public class HotSpotHologram extends HotSpotPlayer
{
    /** O ile moze byc odchylony od osi Z hotSpota kierunek wchodzacego w niego aktora, 
     *  zeby zadzialaly podpiete do niego hologramy [deg]
     */
    public float fReactionAngle = 75.f;//#HOTSPOTHOLOGRAM
        
    /** Lista hologramow podpietych do hotSpota (ustawiane w edytorze)
     */
    public ObjectRefList cAttachedHolograms = null;//#HOTSPOTHOLOGRAM
    
    
    
    /** Jak czesto ma byc sprawdzany kierunek aktora, gdy stoi w hotSpocie
     */
    public float fActorDirUpdateTime = 0.5f;
    
    
    /** Cosinus fReactionAngle liczony w OnCreate
     */
    float fReactionCos = 1.f;
    
    /** Referencja do aktora, ktory wszedl w hotSpot
     */
    ChromeActor cActor = null;
    

    
    
    void OnCreate()
    {
        super.OnCreate();

        fReactionCos = (float)Math.cos(fReactionAngle * Math.PI / 180);
        
        // Zrob walidacje danych
        if (cAttachedHolograms == null || cAttachedHolograms.GetObjectsCount() == 0)
            CrashLog("ERROR: HotSpotHologram (" + GetName() + "): cAttachedHolograms list contains no objects!!!");
        else
            for (int i=0; i<cAttachedHolograms.GetObjectsCount(); i++)
            {
                if (!(cAttachedHolograms.GetObject(i) instanceof AIHologram))
                    CrashLog("ERROR: HotSpotHologram (" + GetName() + 
                             "): cAttachedHolograms list contains object of class not derived from AIHologram class! (" +
                             ((GameObject)cAttachedHolograms.GetObject(i)).GetName() + "\n");
            }
    }
    
    
    boolean IsActorLookingInRightDir()
    {
        Vector vDir = GetForwardVector(); 
        vDir.fY = 0;
        vDir.Normalize();
        Vector vActorDir = cActor.GetForwardVector();
        vActorDir.fY = 0;
        vActorDir.Normalize();
        return vDir.Dot(vActorDir) > fReactionCos;

    }
    
    
    
    void HotSpotEntered(ChromeActor cActor)
    {
        this.cActor = cActor;
        //CrashLog("DBG: HotSpotEntered!!!!!\n");
        if (IsActorLookingInRightDir())
            ActivateHolograms();
        else
            CallMethodEvery("UpdateTrackingDir", fActorDirUpdateTime);    
    }
    

    void HotSpotLeft(ChromeActor cActor)
    {
        this.cActor = null;
        DisableCallMethod("UpdateTrackingDir");
        DeactivateHolograms();
    }
    
    
    void UpdateTrackingDir()
    {
        if (IsActorLookingInRightDir())
        {
            ActivateHolograms();
            DisableCallMethod("UpdateTrackingDir");
        }
    }
    
    void ActivateHolograms()
    {
        for (int i=0; i<cAttachedHolograms.GetObjectsCount(); i++)
            ((AIHologram)(cAttachedHolograms.GetObject(i))).ActorEnteredHotSpot(cActor);
    }
    
    void DeactivateHolograms()
    {
        for (int i=0; i<cAttachedHolograms.GetObjectsCount(); i++)
            ((AIHologram)(cAttachedHolograms.GetObject(i))).ActorLeftHotSpot(cActor);
    }
}
