
/** kamera przypieta do MeshObjectu. Sama z siebie sie nie rusza
 */
public class CameraAttachedSlave extends CameraExtended
{
    MeshObject Target = null;
    int nElement = -1;

    //wektor przesuniecia wzgledem meshobjectu
    Vector vShift = null;
    //czy patrzymy na meshObject - wlasciciela?
    boolean bLookAtTarget = true; 
    //czy patrzymy do tylu
    boolean bRevDir = false;

    //zmienne pomocnicze
    protected float fFov = 60.0f;
    protected float fFovTan = (float)java.lang.Math.tan(fFov);


    public void OnCreate()
    {
        //SetClipNear(4);
    }

    public void OnActivate()
    {	
        super.OnActivate();

		SetFOV(fFov);
        SetBaseFOV(fFov);

        // poczatkowe ustawienie widoku
        if ( Target != null )
        {
            OnPostUpdate();
        }
        else
        {
            FromForwardUpPos( Vector.Forward, Vector.Up, new Vector() );
        }

    }

    void OnPostUpdate()
    {
        if (vShift == null)
        {
            //LogD("pos:"+Target.GetElementForwardVector(nElement)+"\n");
            if (bRevDir)
            {
                Vector dir = Target.GetElementForwardVector(nElement);
                dir.Negate();
                FromForwardUpPos( dir,
                                  Vector.Up, Target.GetElementPos(nElement) );
            }
            
            else
                FromForwardUpPos( Target.GetElementForwardVector(nElement),
                                  Vector.Up, Target.GetElementPos(nElement) );
        }
        else
        {
            Vector vDir, vPos;

			vPos = Target.GetElementLocalPos(nElement);
			vPos.Add(vShift);

			vPos = Target.PointLocalToWorld(vPos);

            if (bLookAtTarget)
            {
                vDir = Target.GetElementPos(nElement);
                vDir.Sub(Target.PointLocalToWorld(vShift));
                vDir.Negate();
            }
            else
            {
                vDir = Target.GetElementForwardVector(nElement);
            }
			
			if (bRevDir) vDir.Negate();

            FromForwardUpPos(vDir, Vector.Up, vPos);
        }
    }
    
    public void SetZoom(float fZoom)
    {
        float angle = 360.f / (float)Math.PI * (float)Math.atan(fFovTan/fZoom);
        SetFOV(angle);
    }
    
    /** Obsluga myszy
     */
    void OnInputMouseAxis(int nAxis, int nDelta)
    {

    }    
	
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {
		FileChunk.Log("[CameraAI.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);
		
        if (cFC.GetID() == ESGChunksChrome._CHK_CAMERA_ATTACHED_SLAVE)
        {
			super.SGLoadChunk(cFC);			

			Target = (MeshObject)GameObject.cSG.LoadObjectRef(cFC);
			
			nElement = cFC.LoadInt();
			//wektor przesuniecia wzgledem meshobjectu
			vShift = cFC.LoadVector();
			//czy patrzymy na meshObject - wlasciciela?
			bLookAtTarget = cFC.LoadBool();
			//czy patrzymy do tylu
			bRevDir = cFC.LoadBool();
        }
		
		cFC.delete();
	}
	
	
    /** Metoda zapisujaca dane do Save gracza
     */		
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[CameraAttachedSlave.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_CAMERA_ATTACHED_SLAVE, cFCParent);
		
		super.SGSaveChunk(cFC);

		GameObject.cSG.SaveObjectRef(cFC,Target);
		
		cFC.SaveInt(nElement);
		//wektor przesuniecia wzgledem meshobjectu
		cFC.SaveVector(vShift);
		//czy patrzymy na meshObject - wlasciciela?
		cFC.SaveBool(bLookAtTarget);
		//czy patrzymy do tylu
		cFC.SaveBool(bRevDir);
					
		cFC.delete();
	}	    	    	
}
