
/** Kontroler kamery - wyluskuje kolejne pozycje ze sciezki patrolowej AIPatrolera
 * Zrobiona do teasera, innego zastosowania nie widac.
 */
public class CameraController extends AIPatroler
{

    String sTargetName = "Logan01"; //#TARGET
    String sTargetElemName = "Bip01 Head"; //#TARGET

    CameraMovie m_Camera = null;
    int m_nCurrentNode = 0;

    public void OnCreate()
    {
        m_Camera = (CameraMovie)CreateObject("CameraMovie");
    }

    public void Start(int n)
    {
        m_nCurrentNode = n;

        //uzupelniamy stosik pozycji        
		m_Camera.pPos.ClearParameters();

		//1. pozycja natychmiast:
		m_Camera.NextPosition( aPath.GetPoint(n).vPosition, 
							   0,
							   InterpolatedCameraParameter.INTERP_LINEAR );

        for (int i = n + 1; i < aPath.GetPointsNum(); i++)
        {    
            m_Camera.NextPosition( aPath.GetPoint(i).vPosition, 
                                   ((AIPatrolerPathPoint) aPath.GetPoint(i)).fStopTimeInterval > 0 ?
								   ((AIPatrolerPathPoint) aPath.GetPoint(i)).fStopTimeInterval : 3,
                                   InterpolatedCameraParameter.INTERP_LINEAR );
        }

		m_Camera.pPos.CalculateAbsoluteSpeeds();

        //ustawiamy cel
        MeshObject target = (MeshObject)GetModule().GetObjectByName(sTargetName);
        if (target != null)
        {
            int nTargetElem = -1;
            
            if (sTargetElemName != null)
            {
                nTargetElem = target.GetElementID(sTargetElemName);
            }

			Log("target set to "+target+", elemID="+nTargetElem+sTargetElemName+"\n");

            if (nTargetElem != -1)
			{
				//FIXIT - dlaczego trzeba az 2 razy?
                m_Camera.NextTarget(target, nTargetElem, 0);
                m_Camera.NextTarget(target, nTargetElem, 0);				
			}
            else
			{
				//FIXIT 
				Vector position = target.GetPosition();
				position.Add(new Vector(0, 175, 0));
                m_Camera.NextTarget(position, 0);
                m_Camera.NextTarget(position, 0);				
			}
        }

        LogD("found "+aPath.GetPointsNum()+" nodes\n");

    }

    public void Stop()
    {
    }

}
