public class ChromeGame extends Game
{
    Cheat s_cCheat = null;
    
    final static int    DIFF_VERY_EASY  = 0,
                        DIFF_EASY       = 1,
                        DIFF_NORMAL     = 2,
                        DIFF_HARD       = 3,
						DIFF_VERY_HARD  = 4;
						
	//Intro/Outro
    static MovieModule movieModule = null;
    
    static int m_nDiffLevel = DIFF_NORMAL;
       
    static float m_tHackDiffLevelMult[] = new float[5];
    static float m_tTakeDamageDiffLevelMult[] = new float[5];
        
    // mnozniki czasu detekcji wroga (ten czas to defaultowo 5 sekund) dla roznych poziomow trudnosci
    static float m_aAIDetectionDelayDiffLevelMult[] = new float[5];
    
    // mnozniki celnosci dzialek kontrolowanych przez ai dla roznych poziomow trudnosci
    static float m_aCannonAimingDiffLevelMult[] = new float[5];

    // mnozniki do odleglosci widzenia gracz przez AI gdy gracz uzywa cloaking device (dla roznych poziomow trudnosci)
    static float m_aAICloakingDeviceRecogMult[] = new float[5];
    
    void SetCannonAimMult(float fMult)
    {
        m_aCannonAimingDiffLevelMult[m_nDiffLevel] = fMult;
    }
    
    static void SetDiffLevel(int nDiff)
    {
        m_nDiffLevel = nDiff;
    }
   
    void SetDiff(int nDiff)
    {
        m_nDiffLevel = nDiff;
    }
    
    static float GetTakeDamageDiffLevelMult()
    {
        return m_tTakeDamageDiffLevelMult[m_nDiffLevel];
    }
    
    static float GetHackDiffLevelMult()
    {
        return m_tHackDiffLevelMult[m_nDiffLevel];
    }
    
    static float GetAIDetectionDelayDiffLevelMult()
    {
        return m_aAIDetectionDelayDiffLevelMult[m_nDiffLevel];
    }
    
    static float GetCannonAimingDiffLevelMult()
    {
        return m_aCannonAimingDiffLevelMult[m_nDiffLevel];
    }
    
    static float GetCloakingDeviceDiffLevelMult()
    {
        return m_aAICloakingDeviceRecogMult[m_nDiffLevel];
    }
    
    static int GetDiffLevel()
    {
        return m_nDiffLevel;
    }
    
    int GetDiff()
    {
        return m_nDiffLevel;
    }
    
    int bNoMenu = 0;

    MethodCaller m_cMethodCaller = null;
    
    ChromeMenuModule Menu = null;
    ChromeModule DedicatedModule = null;
    GameInitInfoSingle cGameInfo = null;
    boolean bLoadSaveEnabled = true; // czy jest dostepny load/save z menu
    
    
    public void OnPreInitialize(String[] aParams)
    {
        CrashLog("[VER] Net:"+NetGameVersion.Get()+"\n");
        CrashLog("[VER] SaveGame:"+ChromeModuleSingle._SAVE_VERSION_NUMBER+"\n");
        
        SetGameName("Chrome");
        NetLog.Init();

        // odczyt i interpretacja parametrow wejsciowych gry
        ReadExecuteParams( aParams );
        
        if ( m_bDedicatedServer )
            GoDedicatedServer();

        // Ustawienie Controlsow
        ControlLoadSave.LoadKeySeting("Data\\UserControls.scr");
        ControlLoadSave.SetGameControls();
		
		ChromeGameRunInfo.LoadRunInfo("run.ini");
    }

    public void OnInitialize()
    {
        s_cCheat = (Cheat)CreateObject("Cheat");
        s_cCheat.SetName("");
        
        NetMsg.UpdateStrings();
        
        super.OnInitialize();
        
        MasterClient.SetMasterClientNetworkInterface(GetSelectedNetworkInterface());
        //GameScanner.SetNetworkInterface(GetSelectedNetworkInterface());
        
        ForceRender();
        
        m_cMethodCaller = (MethodCaller)CreateObject("MethodCaller");
        m_cMethodCaller.Activate();
        m_cMethodCaller.TimerStart();
        
        if(bPlayingInputs || bRecordingInputs)
        {
            // wlaczamy wczytywanie tylko jednego levelu
            bNoMenu = 1;
        }

        // ustawienie defaultowych parametrow zasiegu slyszenia
        EChromeAudioMenuUI.bNoDefSound = SetDefaultSoundRanges(4000.0f, 15000.0f);

        //CrashLog("[ChromeGame::OnInitilize] Chrome is now initializing\n");
        //////////////////////////////////////////////
        
        if ( m_bCreateServer || IsDedicatedServer() || m_bJoinServer )
        {
            Menu = (ChromeMenuModule)CreateObject("ChromeMenuModule");
            Menu.Activate();
            SetMaxTimerUpdate( 10000000 );
            if ( m_bCreateServer || IsDedicatedServer() )
                ChromeNetCreatMenu.AutoCreateServer( Menu );
            else
                ChromeNetJoinMenu.ForceJoinServer( Menu, 
                                                   m_sServerAddress, 
                                                   m_sServerPassword );
            return;
        }
		
		//zaladowanie automatyczne levelu
		if( m_iAutoloadLevel != -1)
		{
			bNoMenu = 1;
			CreateMenu();
            return;
		}
        
        /*if (IsDedicatedServer())
        {
            String sLevelName="ModuleNet.map";
            CreateServer( "czesiu", 2116, 16, "czesiu", 0 );
            
            Log("Server laduje level <" + sLevelName + ">\n");
            try 
            {
                CrashLog("Wczytujemy level\n");
                DedicatedModule=(ChromeModule)LoadModule(sLevelName);
            }
            catch(ClassCastException e)
            {
                CrashLog("[ChromeMenuModule.OnCreate] Invalid module class in ");
                CrashLog(sLevelName);
                CrashLog(". Class should have been inherited from ChromeModule!\n");
            }
            
            DedicatedModule.Activate();
        }
        else*/
        {
            if (ChromeGameRunInfo.s_bLoadMenu3dScene)
            {
                movieModule = (MovieModule)CreateObject("MovieModule");
		        movieModule.Activate();
            }
            else
            {
                CreateMenu();
            }
            //CreateMenu
        }
    }

    void CreateMenu()
    {
        // tworzymy menu gry, ktore wlasciwie cala gre uruchomi
        if(bNoMenu==0)
        {
            Menu=(ChromeMenuModule)CreateObject("ChromeMenuModule");
            Menu.Activate();
        }
        else
        {
            Menu = (ChromeMenuModule)CreateObject("ChromeMenuModule");
            Menu.Activate();
			
			LoadLevelAutomatically();
        }
    }
	
	void LoadLevelAutomatically()
	{
		String sLevelScript = null;
            
            if(m_iAutoloadLevel == -1)
				sLevelScript = "LevelsSingle_1.scr";
			else
				sLevelScript = ChromeMenuLevelSelection.s_aScriptLevelsNames[m_iAutoloadLevel];
            
            // ladujemy level
            GameInitInfoSingle game=new GameInitInfoSingle( "Data/"+sLevelScript );
			Menu.NewGame(game);
			Menu.StartGame();
	}
			
	static boolean bFilms = false;
    
    boolean bRecordingInputs = false;
    boolean bPlayingInputs = false;

    // odczyt parametrow wejsciowych gry
    String sInputFile = "demo.rec";
    String sAVIFile = "OUTPUT.avi";
    float fFPS = 25.0f;

    
    boolean m_bCreateServer    = false;
    boolean m_bDedicatedServer = false;

    boolean m_bJoinServer       = false;
    String  m_sServerAddress    = null;
    String  m_sServerPassword   = null;
    
	int		m_iAutoloadLevel = -1;
    
    public void ReadExecuteParams(String[] aParams)
    {
        super.ReadExecuteParams(aParams);

        NetGameInfo.SetAutoPlayer( false );
        
        if ( aParams.length > 0 )
        {
            boolean []aUsedParams = new boolean[aParams.length];
            
            for (int i=0; i<aParams.length; i++)
            {
                if ( aUsedParams[i] )
                    continue;
                //if( aParams[i].compareTo("notrees")==0 )
                //    DisableTrees();
                
                if( aParams[i].startsWith("input=") )
                    sInputFile = aParams[i].substring(aParams[i].indexOf('=')+1);
                
                if( aParams[i].startsWith("avi=") )
                    sAVIFile = aParams[i].substring(aParams[i].indexOf('=')+1);
                
                if( aParams[i].startsWith("fps=") )
                    fFPS = new Float( aParams[i].substring(aParams[i].indexOf('='))+1 ).floatValue();
                                
                if( aParams[i].compareTo("play")==0 )
                    bPlayingInputs = true;
                
                if( aParams[i].compareTo("record")==0 )
                    bRecordingInputs = true;
                
                if( aParams[i].compareTo("logmeshes")==0 )
                    LogLoadingMeshes();
                
                /**
                 * mozliwosc odpalenia automatycznie levelu
                 */
				if ( aParams[ i ].compareTo( "level" ) == 0 )
                {
                    if ( aParams.length > i + 1 )
                        m_iAutoloadLevel = Integer.valueOf( aParams[ i + 1 ] ).intValue();
					
					if(m_iAutoloadLevel<0)
						m_iAutoloadLevel = 0;
					else
						if(m_iAutoloadLevel > 14)
							m_iAutoloadLevel = 14;
                }
				
                /**
                 * parametry sieciowe
                 */
                
                //odpalenie serwera (na tych mapach ktore byly ustawione poprzednio)
                if ( aParams[ i ].equalsIgnoreCase( "server" ) )
                {
                    m_bCreateServer = true;
                }
                
                //odpalenie serwera dedykowanego (jak wyzej)
                if ( aParams[ i ].equalsIgnoreCase( "dedicated" ) )
                {
                    m_bDedicatedServer = true;
                }
                
                //odpalenie clienta z podanym IP
                if ( aParams[ i ].equalsIgnoreCase( "join" ) || 
                     aParams[ i ].equalsIgnoreCase( "client" ) )
                {
                    m_bJoinServer  =  true;
                    String sServer = null;
                    if ( aParams.length > i + 1 )
                    {
                        sServer = aParams[ i + 1 ];
                        aUsedParams[ i + 1 ] = true;
                    }
                    m_sServerAddress = sServer;
                }
                
                //wymuszenie profilu o podanej nazwie
                if ( aParams[ i ].equalsIgnoreCase( "profile" ) )
                {
                    String sProfileName = null;
                    if ( aParams.length > i + 1 )
                    {
                        sProfileName = aParams[ i + 1 ];
                        aUsedParams[ i + 1 ] = true;
                    }
                    if ( sProfileName != null )
                    {
                        if ( ! NetPlayerProfile.TryToSetCurrentProfileName( sProfileName ) )
                        {
                            //jesli nie znalazl, to sprawdzmy czy znajdzie
                            //profil 2-wyrazowy
                            if ( aParams.length > i + 2 )
                            {
                                //jak widac pomiedzy wyrazy wstawiam jedna spacje,
                                //wiac jak ptofil ma wiecej to kicha...
                                sProfileName = sProfileName + " " + aParams[ i + 2 ];
                                if ( NetPlayerProfile.TryToSetCurrentProfileName( sProfileName ) )
                                    aUsedParams[ i + 2 ] = true;
                                //profile wielowyrazowe pozostawiam na pozniej
                            }
                        }
                        
                    }
                }
                
                //wymuszenie nicka o podanej nazwie
                if ( aParams[ i ].equalsIgnoreCase( "nick" ) )
                {
                    String sNick = null;
                    if ( aParams.length > i + 1 )
                    {
                        sNick = aParams[ i + 1 ];
                        aUsedParams[ i + 1 ] = true;
						
						if ( NetGameTools.IsStringValid( sNick ) &&
							 sNick.startsWith( "\"" ) )
						{
							//rozpoczyna sie od cydzyslowia
							
							//usuwamy go
							sNick = sNick.substring( 1, sNick.length() );
							
							int nNick = i + 2;
							//teraz musimy znalezc zamykajacy
							
							do
							{
								if ( aParams.length > nNick )
								{
									aUsedParams[ nNick ] = true;
									sNick = sNick + aParams[ nNick ];
										
									nNick ++;	
								}
								else
									break;
							
							} while ( sNick.indexOf( "\"" ) == -1 );
							
							int nPos = sNick.indexOf( "\"" );
							if ( nPos > -1 )
								sNick = sNick.substring( 0, nPos );
						}
                    }
                                        
                    if ( sNick != null )
                    {
                        NetPlayerProfile.ForceProfileWithNick( sNick );
                    }
                }
                

                //zapamietanie hasla do gry
                if ( aParams[ i ].equalsIgnoreCase( "pass" ) )
                {
                    String sPassword = null;
                    if ( aParams.length > i + 1 )
                    {
                        sPassword = aParams[ i + 1 ];
                        aUsedParams[ i + 1 ] = true;
                    }
                    m_sServerPassword = sPassword;
                }
                
                //wymuszenie profilu o podanej nazwie
                if ( aParams[ i ].equalsIgnoreCase( "profile" ) )
                {
                    String sProfileName = null;
                    if ( aParams.length > i + 1 )
                    {
                        sProfileName = aParams[ i + 1 ];
                        aUsedParams[ i + 1 ] = true;
                    }
                    if ( sProfileName != null )
                    {
                        if ( ! NetPlayerProfile.TryToSetCurrentProfileName( sProfileName ) )
                        {
                            //jesli nie znalazl, to sprawdzmy czy znajdzie
                            //profil 2-wyrazowy
                            if ( aParams.length > i + 2 )
                            {
                                //jak widac pomiedzy wyrazy wstawiam jedna spacje,
                                //wiac jak ptofil ma wiecej to kicha...
                                sProfileName = sProfileName + " " + aParams[ i + 2 ];
                                if ( NetPlayerProfile.TryToSetCurrentProfileName( sProfileName ) )
                                    aUsedParams[ i + 2 ] = true;
                                //profile wielowyrazowe pozostawiam na pozniej
                            }
                        }
                        
                    }
                }

                
                //do testow
                
                //gracz w trybie autoplayera
                if ( aParams[ i ].compareTo( "autoplayer" ) == 0 )
                {
                    NetGameInfo.SetAutoPlayer( true );
                }
                
                //odpalenie botow (zadziala tylko na serwerze)
                if ( aParams[ i ].compareTo( "bots" ) == 0 )
                {
                    int nBots = 1;
                    if ( aParams.length > i + 1 )
                    {
                        nBots = Integer.valueOf( aParams[ i + 1 ] ).intValue();
                        aUsedParams[ i + 1 ] = true;
                    }
                    NetGameInfo.SetBotsCnt( nBots );
                }
            }
        }
        
        if( bPlayingInputs )
        {
            EnableRecordingAVI(sAVIFile, fFPS);
        }
        
        SetupAVIRecording();
    }
    
    public void SetupAVIRecording()
    {
        if( bPlayingInputs )
        {
            EnableInputPlaying(sInputFile, fFPS);
            bFilms = true;
        }
        
        if( bRecordingInputs )
        {
            EnableInputRecording(sInputFile, fFPS);
            bFilms = true;
        }
    }
    
    void EnableLoadSave(boolean bEnable)
    {
        bLoadSaveEnabled = bEnable;
    }
    
    boolean IsLoadSaveEnabled()
    {
        if (Menu != null && 
            Menu.ActiveLevelModule != null && 
            Menu.ActiveLevelModule.GetMainPlayer() != null &&
            Menu.ActiveLevelModule instanceof ChromeModuleSingle)
        {
            
            HUDManager cHUD = ((PlayerHUD)Menu.ActiveLevelModule.GetMainPlayer()).HUD;
            
            
                        
            return bLoadSaveEnabled && 
                   cHUD.m_nActiveHudMenu != HUDManager._HUD_HACK &&
                   ((ChromeModuleSingle)Menu.ActiveLevelModule).bCanShowInGameMenu &&
                   !(((ChromeModule)Menu.ActiveLevelModule).bInFadeState && !((ChromeModuleSingle)Menu.ActiveLevelModule).m_bMissionEnded);//&& ((ChromeModule)Menu.ActiveLevelModule).cMoviePlaying != null);
        }
        else
        {
            return bLoadSaveEnabled;
        }
    }
    
    public void OnTakeScreenShot(String sFile)
    {
        LogR("ScreenShot " + sFile + " Taken\n");
        ScriptWriter cWriter = new ScriptWriter();
        cWriter.Open(sFile + ".txt");
        if (Menu.ActiveLevelModule != null)
        {
            if (Menu.ActiveLevelModule instanceof ChromeModuleSingle)
            {
                ChromeModuleSingle cMod = (ChromeModuleSingle)Menu.ActiveLevelModule;
                cWriter.Write("SingleLevelMap : <" + Menu.cGameInitInfo.cLevels.GetCurrent().sLevelName +">");
                cWriter.Write("Save game : <" + ((ChromeModuleSingle)Menu.ActiveLevelModule).sSaveGameName +">");
                
                //cWriter.Write(" : <" +  +">");
            }
            else
            {
                String sMapName = Menu.cGameInitInfo.cLevels.IsCurrentValid() ?
                                  Menu.cGameInitInfo.cLevels.GetCurrent().sLevelName:
                                  "unknown";
                cWriter.Write("MultiplayerMap : <" + sMapName +">");
                cWriter.Write("Server : " + (Role == ERole._AUTHORITY));
            }
            cWriter.NewLine();
            
            
            Player cPlayer = Menu.ActiveLevelModule.GetMainPlayer();
            if (cPlayer != null)
            {
                cWriter.Write("PLAYER : ");
                cWriter.Write("         pos     " + cPlayer.GetPosition().toString());
                cWriter.Write("     forward     " + cPlayer.GetForwardVector().toString());
                cWriter.Write("          up     " + cPlayer.GetUpVector().toString());
                cWriter.Write("      health     " + cPlayer.fHealth);
                cWriter.Write("       cheat     " + cPlayer.m_bLifeCheat);
                cWriter.Write("      weapon     " + cPlayer.ActiveWeapon);
                
                cWriter.Write("IMPLANTS :   ");
                ImplantSystem cImplants = cPlayer.GetImplantSystem();
                for (int i = 0; i < cImplants._IMPLANTS_NUM; i++)
                {
                    if (cImplants.GetImplant(i) != null)
                    {
                        cWriter.Write("     " + cImplants.GetImplantName(i) + " <active " + cImplants.IsImplantActive(i) + "> <disabled " + cImplants.GetImplant(i).m_bDisabled+">");
                    }
                }
                //cWriter.Write("         
                cWriter.NewLine();
            }
        }
        
        
        cWriter.Close();
                      
    }
}