/** Przyciski, ktore sie fajnie pojawiaja.
 */
class MenuOptionSprite_ extends UIButton
{
    Vector textColor = null;

    int nID = 0;
    
    float fShowTime = 0.2f;
    float fRefreshTime = 0.05f;

    static float fAlpha[] = null;

    void OnCreate()
    {
        if (fAlpha == null)
            fAlpha = new float[13]; //FIXIT: max liczba linii
        super.OnCreate();
    }

    public void SetText(String text, Vector color)
    {
		if (text == null)
			return;
        textColor = new Vector(color);
        m_sText = new String(text);
        m_sLocalizedText = Text.Get(m_sText);
        FadeIn();
    }
    
    public void SetText(String text)
    {
		if (text == null)
			return;
        m_sText = new String(text);
        m_sLocalizedText = Text.Get(m_sText);
        FadeIn();
    }
    
    
    void FadeIn()
    {
        if (fAlpha == null || nID == -1)
            return;
        
        float time = 0;
        for(int i = 0; i < nID - ETerminalUI_.UI_BTN_LINES; i++)
        {
            if (fAlpha[i] < 1) time += (1-fAlpha[i]) * fShowTime;
        }
        fAlpha[nID - ETerminalUI_.UI_BTN_LINES] = 0.0f;
        SetTextAlpha(0);
        
        DisableCallMethod("UpdateAlpha");
        //wyswieltamy sie po wszystkich poprzednich napisach
        CallMethodIn("UpdateAlpha", time);
    }
    

    //funkcja 'pojawiajaca' napis
    void UpdateAlpha()
    {
        if (fAlpha == null || nID == -1)
            return;

        int myID = nID - ETerminalUI_.UI_BTN_LINES;

        if (fAlpha[myID] == 0) 
        {
            //zaczynamy sie pokazywac
            //dzwiek
            PlaySound(ComputerTerminalNew.sSoundShowLine);

            CallMethodEvery("UpdateAlpha", fRefreshTime);
        }

        if (fAlpha[myID] < 1)
        {
            fAlpha[myID] += fRefreshTime/fShowTime;
            if (fAlpha[myID] > 1)
                fAlpha[myID] = 1;
            if (textColor != null)
            {
                SetTextAllColors(textColor.fX, textColor.fY, textColor.fZ);
                SetTextAllAlpha(fAlpha[myID]);
            }
            else
            {
                SetTextAllAlpha(fAlpha[myID]);
            }
            
            super.DisplayText();
        }
        else
        {
            DisableCallMethod("UpdateAlpha");
        }
    }
 
}
