import java.io.*;
public class ControlLoadSave extends GameObject
{
    static String sm_sUserControlsFile    = "Data/UserControls.scr";
    
	static boolean s_bControlsInited = false;
	
    static int  IMPLANTBIND_1_ID = -1, 
                IMPLANTBIND_2_ID = -1,
                IMPLANTBIND_3_ID = -1,
                IMPLANTBIND_4_ID = -1;
    
    /**nazwy kontrolsow na ich podstawi odczytywane sa nazwy zlokalizowane*/
    static String []ControlsName = {"FORWARD",
                                    "BACKWARD",
                                    "STRAFE LEFT",
                                    "STRAFE RIGHT",
                                    "LEAN LEFT",
                                    "LEAN RIGHT",
                                    "JUMP",
                                    "CROUCH",
                                    "CROUCH TOGGLE",
                                    "PRONE",
                                    "PRONE TOGGLE",
                                    "WALK/RUN",
                                    "WALK TOGGLE",
                                    "FIRE",
                                    "AIM/SPECIAL WEAPON",
                                    "AIM TOGGLE",
                                    "RELOAD",
                                    "USE ITEM",
                                    "ACTION",
                                    "ZOOM IN",
                                    "ZOOM OUT",
                                    //"DETECTOR",                                     
                                    "INVENTORY MODE",
                                    "MAP MODE",
                                    "IMPLANTS MODE",
                                    "LOGS MODE",
                                    "SELECT MELEE WEAPON",
                                    "SELECT PISTOL",
                                    "SLECT RIFLE",
                                    "SELECT HEAVY GUN",
                                    "SELECT GRENADE",
                                    "HOLSTER WEAPON",
                                    "NEXT WEAPON",
                                    "PREVIOUS WEAPON",
                                    //"SELECT BEST WEAPON",
                                    "THROW WEAPON",
                                    "NEXT ITEM",
                                    "PREVIOUS ITEM",
                                    //"CONSOLE",
                                    "SAY",
                                    "SAY_TEAM",
                                    "VOICE MENU",
                                    "CHANGE TEAM",
                                    "IMPLANT0", 
                                    "IMPLANT1", 
                                    "IMPLANT2", 
                                    "IMPLANT3", 
                                    "IMPLANT4",
                                    "IMPLANT5", 
                                    "IMPLANT6",
                                    "IMPLANTS_OFF",
                                    "IMPLANTS BIND 1",
                                    "IMPLANTS BIND 2",
                                    "IMPLANTS BIND 3",
                                    "IMPLANTS BIND 4",
                                    "QUICKSAVE",
                                    "QUICKLOAD",
                                    "USE HEALTHEX",
                                    "USE NEURAL HEALTHEX",
                                    "USE BINOCULARS"
                                    /*"IMPLANT7", 
                                    "IMPLANT8", 
                                    "IMPLANT9" */};

	static String []ControlsLocalizedName = new String[ControlsName.length];
    /**czy klawisz zostal zaladowany ze skryptu, jesli nie, to dajemy domyslny*/
    static boolean bLoaded[] = new boolean[ControlsName.length];
    
    
    /**Tablica przypisanych klawiszy*/
    static int []KeyId  = new int[ControlsName.length];
    static int []KeyIdDefaults  = {
        EGameControl.FORWARD,//"FORWARD",
        EGameControl.BACKWARD,//"BACKWARD",
        EGameControl.STRAFE_LEFT,//"STRAFE LEFT",
        EGameControl.STRAFE_RIGHT,//"STRAFE RIGHT",
        EGameControl.LEAN_LEFT,//"LEAN LEFT",
        EGameControl.LEAN_RIGHT,//"LEAN RIGHT",
        EGameControl.JUMP,//"JUMP",
        EGameControl.DUCK,//"CROUCH",
        EGameControl.DUCK_TOGGLE,//"CROUCH TOGGLE"
        EGameControl.CRAWL,//"PRONE",
        EGameControl.CRAWL_TOGGLE,//PRONE TOGGLE"
        EGameControl.WALK,//"WALK/RUN",
        EGameControl.WALK_TOGGLE,//"WALK TOGGLE"
        EGameControl.FIRE,//"FIRE",
        EGameControl.AIM,//"AIM/SPECIAL WEAPON",
        EGameControl.AIM_TOGGLE,//"AIM TOGGLE",
        EGameControl.RELOAD,//"RELOAD",
        EGameControl.USE,//"USE ITEM",
        EGameControl.ACTION,//"ACTION",
        EGameControl.ZOOM_IN,//"ZOOM IN",
        EGameControl.ZOOM_OUT,//"ZOOM OUT",
        //EGameControl.DETECTOR,//"DETECTOR",                                     
        EGameControl.INVENTORY,//"INVENTORY MODE",
        EGameControl.MAP,//"MAP MODE",
        EGameControl.IMPLANTS, //"IMPLANTS MODE",
        EGameControl.LOGS, //"LOGS MODE",
        EGameControl.WEAPON_MELEE,//"SELECT MELEE WEAPON",
        EGameControl.WEAPON_PISTOL,//"SELECT PISTOL",
        EGameControl.WEAPON_RIFLE,//"SLECT RIFLE",
        EGameControl.WEAPON_HEAVY,//"SELECT HEAVY GUN",
        EGameControl.WEAPON_GRENADE,//"SELECT GRENADE",
        EGameControl.WEAPON_HANDS,//"HOLSTER WEAPON"
        EGameControl.WEAPON_NEXT,//"NEXT WEAPON",
        EGameControl.WEAPON_PREV,//"PREVIOUS WEAPON",
        //EGameControl.WEAPON_BEST,//"SELECT BEST WEAPON",
        EGameControl.WEAPON_THROW,//"THROW WEAPON",
        EGameControl.ITEM_NEXT,//"NEXT ITEM",
        EGameControl.ITEM_PREV,//"PREVIOUS ITEM",
        //EGameControl.CONSOLE,//"CONSOLE",
        EGameControl.SAY,//"SAY",
        EGameControl.SAY_TEAM,//"SAY_TEAM",
        EGameControl.VOICE_MENU,//"VOICE MENU",
        EGameControl.NET_CHANGE_TEAM,//"CHANGE TEAM",
        EGameControl.IMPLANT0,//"IMPLANT0", 
        EGameControl.IMPLANT1,//"IMPLANT1",  
        EGameControl.IMPLANT2,//"IMPLANT2", 
        EGameControl.IMPLANT3,//"IMPLANT3", 
        EGameControl.IMPLANT4,//"IMPLANT4", 
        EGameControl.IMPLANT5,//"IMPLANT5", 
        EGameControl.IMPLANT6,//"IMPLANT6",
        EGameControl.IMPLANTS_OFF,
        EGameControl.IMPLANTBIND_1,//"IMPLANTS BIND 1",
        EGameControl.IMPLANTBIND_2,//"IMPLANTS BIND 2",
        EGameControl.IMPLANTBIND_3,//"IMPLANTS BIND 3",
        EGameControl.IMPLANTBIND_4,//"IMPLANTS BIND 4",
        EGameControl.QUICKSAVE,
        EGameControl.QUICKLOAD,
        EGameControl.USE_ITEM_HEALTHEX,
        EGameControl.USE_ITEM_NEURAL_HEALTHEX,
        EGameControl.USE_ITEM_BINOCULARS,
        /*GameControl.IMPLANT7,//"IMPLANT7", 
        EGameControl.IMPLANT8,//"IMPLANT8", 
        EGameControl.IMPLANT9,//"IMPLANT9"*/
    };

    /**Czy ma byc invert mouse*/
    static boolean Invert_Mouse = false;
    
    //--------------------------------------------------------------------------
    /** Czulosc myszki ustawiana w menu*/
    static int Mouse_Sensitiviti = 0;
    
    /** Maksymalna czulosc ustawiana w menu */
    static int Mouse_Sensitiviti_Max = 10;
    
    static float fMouseSensMin = 0.001f;
    static float fMouseSensMax = 0.010f;
    
    /** Czulosc myszy bezposrednio czytana w graczu wyliczana na podstawie
     * Mouse_Sensitiviti, fMouseSensMin i fMouseSensMax
     */
    static float fMouseSensitivity = 0.001f;
    //MK: IMHO to jest totalna zjebka, to powinno byc w 
    //EGameControl i ustawiane w metodzie SetGameControls()
    //--------------------------------------------------------------------------
    

	static void InitControls()
	{
		s_bControlsInited = true;
		for (int index = 0; index < ControlsName.length ; index++)
		{
			ControlsLocalizedName[index] = new String(Text.Get("&"+ ControlsName[index] +"&"));
		}
	}
	
    static void SetMouseSens(int nSens)
    {
        Mouse_Sensitiviti = nSens;
        fMouseSensitivity = fMouseSensMin + (fMouseSensMax - fMouseSensMin)/Mouse_Sensitiviti_Max * Mouse_Sensitiviti;
    }
	
    static String sm_sLastLoadedFile = null;
	
    static void LoadKeySeting(String sFile)
    {
        if(!s_bControlsInited)
			InitControls();
		
		if(sFile == sm_sLastLoadedFile)
			return;
		else
			sm_sLastLoadedFile = sFile;
		
		ParseKeyword Root=ParseFile(sFile);
        
        if(Root==null)
        {
            LoadDefaultKeySettings();
        }
        else
        {
            EGameControl.m_cImplantsBindingF1.Clear();
            EGameControl.m_cImplantsBindingF2.Clear();
            EGameControl.m_cImplantsBindingF3.Clear();
            EGameControl.m_cImplantsBindingF4.Clear();
            ParseKeyword Key, SubKey;
            
            for(Key=Root; Key!=null; Key=Key.GetNext())
            {
				if (Key.Equals("ActionKey"))
                {
                    int index;
                    for (index = 0; index < ControlsName.length ; index++)
                    {
                        if ( ControlsName[index].equals( "" + Key.GetSParam(0) + "" )) 
                            break;
                    }
                    if ( index == ControlsName.length )
                    {
                        LogD("Nie ma takiej akcji: "+Key.GetSParam(0)+"\n"); 
                        continue;
                    }
                    
                    int nKey = Key.GetIParam(1);
                    //przedtem byly inne identyfikatory, ta zmiana pozwala ladowac stare kontrolsy
                    //(klawisze myszy)
                    if (nKey == 0xEE)
                        nKey = 0xF000;
                    if (nKey == 0xEF)
                        nKey = 0xF001;
                    if (nKey == 0xF0)
                        nKey = 0xF002;
                    KeyId[index] = nKey;
                    
                    bLoaded[index] = true;
                    LogLine("Action "+ Key.GetSParam(0) + " klawisz " + Key.GetIParam(1));
                }
				else if (Key.Equals("Version"))
                {
                    //TODO dorobic wersjonowanie
                }
                else if(Key.Equals("InvertMouse")) Invert_Mouse = Key.GetIParam(0) != 0;
                else if(Key.Equals("MouseSensitvity")) SetMouseSens( Key.GetIParam(0) );
                
				else if (Key.Equals("ImplantsBindingF1"))
                    EGameControl.m_cImplantsBindingF1.Load(Key);
                else if (Key.Equals("ImplantsBindingF2"))
                    EGameControl.m_cImplantsBindingF2.Load(Key);
                else if (Key.Equals("ImplantsBindingF3"))
                    EGameControl.m_cImplantsBindingF3.Load(Key);
                else if (Key.Equals("ImplantsBindingF4"))
                    EGameControl.m_cImplantsBindingF4.Load(Key);
            }
            
            for (int nKey = 0; nKey < ControlsName.length; nKey++)
            {
                //nie zaladowane, trzeba ustalic domyslne
                if (!bLoaded[nKey])
                {
                    KeyId[nKey] = KeyIdDefaults[nKey];
                    LogR("Setting not loaded key "+ ControlsName[nKey] + " to " + KeyIdDefaults[nKey]);
                }
            }
            
            Root.delete();
        }
    }
    
    static void LoadDefaultKeySettings()
    {
		if(!s_bControlsInited)
			InitControls();
		
        String sScript = "data/DefaultControls";
        switch (ELocale.GetLocale())
        {
        case ELocale._CZECH:
            sScript += "_cz.scr";
            break;
        case ELocale._GERMAN:
            sScript += "_de.scr";
            break;
        case ELocale._FRENCH:
            sScript += "_fr.scr";
            break;
        default:
            for (int nKey = 0; nKey < ControlsName.length; nKey++)
            {
                KeyId[nKey] = KeyIdDefaults[nKey];
            }
            return;   
        }
        
        LoadKeySettings(sScript);
        
    }
    
    static void SaveControls(String sFile)
    {
        java.io.File cFile  = new java.io.File( sFile );
        if ( cFile.exists() && !cFile.canWrite() )
            cFile.delete(); 
        
        try
        {
            BufferedWriter Buff = new BufferedWriter(new FileWriter(sFile));
            String sBuffor = "!ActionKey(s,i,i)";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "!ImplantsBindingF1(i,i,i,i,i,i,i,i)";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "!ImplantsBindingF2(i,i,i,i,i,i,i,i)";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "!ImplantsBindingF3(i,i,i,i,i,i,i,i)";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "!ImplantsBindingF4(i,i,i,i,i,i,i,i)";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            
            sBuffor = "!InvertMouse(i)";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "!MouseSensitvity(i)";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            for ( int index = 0; index < ControlsName.length ; index++)
            {
                sBuffor = "ActionKey(\"" + ControlsName[index] + "\"," + KeyId[index] + ",0)" +
                          "//" + GetKeyName(KeyId[index]);
                Buff.write(sBuffor, 0, sBuffor.length());
                Buff.newLine();
            }

            sBuffor = "ImplantsBindingF1(" + EGameControl.m_cImplantsBindingF1.toString() + ")";
            Buff.write(sBuffor);
            Buff.newLine();

            sBuffor = "ImplantsBindingF2(" + EGameControl.m_cImplantsBindingF2.toString() + ")";
            Buff.write(sBuffor);
            Buff.newLine();

            sBuffor = "ImplantsBindingF3(" + EGameControl.m_cImplantsBindingF3.toString() + ")";
            Buff.write(sBuffor);
            Buff.newLine();
            
            sBuffor = "ImplantsBindingF4(" + EGameControl.m_cImplantsBindingF4.toString() + ")";
            Buff.write(sBuffor);
            Buff.newLine();
            
            sBuffor = "InvertMouse(" + (Invert_Mouse ? 1 : 0) + ")";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "MouseSensitvity(" + Mouse_Sensitiviti + ")";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            Buff.close();
        }
        catch (IOException e)
        { 
            Log("ERROR defining sequences" + e.getMessage()); 
        }
        
        LogD("Controls saved\n");
    }
    
    static void SetGameControls()
    {
        int n = 0;
        EGameControl.FORWARD = KeyId[n++];
        EGameControl.BACKWARD = KeyId[n++];
        EGameControl.STRAFE_LEFT = KeyId[n++];
        EGameControl.STRAFE_RIGHT = KeyId[n++];
        EGameControl.LEAN_LEFT = KeyId[n++];
        EGameControl.LEAN_RIGHT = KeyId[n++];
        EGameControl.JUMP = KeyId[n++];
        EGameControl.DUCK = KeyId[n++];
        EGameControl.DUCK_TOGGLE = KeyId[n++];
        EGameControl.CRAWL = KeyId[n++];
        EGameControl.CRAWL_TOGGLE = KeyId[n++];
        EGameControl.WALK = KeyId[n++];
        EGameControl.WALK_TOGGLE = KeyId[n++];
        EGameControl.FIRE = KeyId[n++];
        EGameControl.AIM  = KeyId[n++];
        EGameControl.AIM_TOGGLE  = KeyId[n++];
        EGameControl.RELOAD = KeyId[n++];
        EGameControl.USE = KeyId[n++];
        EGameControl.ACTION = KeyId[n++];
        EGameControl.ZOOM_IN = KeyId[n++];
        EGameControl.ZOOM_OUT = KeyId[n++];
        //EGameControl.DETECTOR = KeyId[n++];
        EGameControl.INVENTORY = KeyId[n++];
        EGameControl.MAP = KeyId[n++];
        EGameControl.IMPLANTS = KeyId[n++];
        EGameControl.LOGS   = KeyId[n++];
        EGameControl.WEAPON_MELEE = KeyId[n++];
        EGameControl.WEAPON_PISTOL = KeyId[n++];
        EGameControl.WEAPON_RIFLE = KeyId[n++];
        EGameControl.WEAPON_HEAVY = KeyId[n++];
        EGameControl.WEAPON_GRENADE = KeyId[n++];
        EGameControl.WEAPON_HANDS = KeyId[n++];
        EGameControl.WEAPON_NEXT = KeyId[n++];
        EGameControl.WEAPON_PREV = KeyId[n++];
        //EGameControl.WEAPON_BEST = KeyId[n++];
        EGameControl.WEAPON_THROW  = KeyId[n++];
        EGameControl.ITEM_NEXT = KeyId[n++];
        EGameControl.ITEM_PREV = KeyId[n++];
        //EGameControl.CONSOLE = KeyId[n++];
        EGameControl.SAY = KeyId[n++];
        EGameControl.SAY_TEAM = KeyId[n++];
        EGameControl.VOICE_MENU = KeyId[n++];
        EGameControl.NET_CHANGE_TEAM = KeyId[n++];
        //implanty
        EGameControl.IMPLANT0 = KeyId[n++];
        EGameControl.IMPLANT1 = KeyId[n++];
        EGameControl.IMPLANT2 = KeyId[n++];
        EGameControl.IMPLANT3 = KeyId[n++];
        EGameControl.IMPLANT4 = KeyId[n++];        
        EGameControl.IMPLANT5 = KeyId[n++];
        EGameControl.IMPLANT6 = KeyId[n++];
        EGameControl.IMPLANTS_OFF = KeyId[n++];
        IMPLANTBIND_1_ID = n;
        EGameControl.IMPLANTBIND_1 = KeyId[n++];//"IMPLANTS BIND 1",
        IMPLANTBIND_2_ID = n;
        EGameControl.IMPLANTBIND_2 = KeyId[n++];//"IMPLANTS BIND 2",
        IMPLANTBIND_3_ID = n;
        EGameControl.IMPLANTBIND_3 = KeyId[n++];//"IMPLANTS BIND 3",
        IMPLANTBIND_4_ID = n;
        EGameControl.IMPLANTBIND_4 = KeyId[n++];//"IMPLANTS BIND 4",
        EGameControl.QUICKSAVE = KeyId[n++];
        EGameControl.QUICKLOAD = KeyId[n++];
        EGameControl.USE_ITEM_HEALTHEX = KeyId[n++];
        EGameControl.USE_ITEM_NEURAL_HEALTHEX = KeyId[n++];
        EGameControl.USE_ITEM_BINOCULARS = KeyId[n++];
        /*EGameControl.IMPLANT7 = KeyId[40];
        EGameControl.IMPLANT8 = KeyId[41];
        EGameControl.IMPLANT9 = KeyId[42];        
        */
    }

    private static String KeyName[] =
    {
        "",
        "&ESCAPE&",//#define DIK_ESCAPE          0x01
        "",//#define DIK_1               0x02
        "",//#define DIK_2               0x03
        "",//#define DIK_3               0x04
        "",//#define DIK_4               0x05
        "",//#define DIK_5               0x06
        "",//#define DIK_6               0x07
        "",//#define DIK_7               0x08
        "",//#define DIK_8               0x09
        "",//#define DIK_9               0x0A
        "",//#define DIK_0               0x0B
        "",//#define DIK_MINUS           0x0C    /* - on main keyboard */
        "",//#define DIK_EQUALS          0x0D
        "&BACKSPACE&",     //#define DIK_BACK            0x0E    /* backspace */
        "&TAB&",     //#define DIK_TAB             0x0F
        "",     //#define DIK_Q               0x10
        "",     //#define DIK_W               0x11
        "",     //#define DIK_E               0x12
        "",     //#define DIK_R               0x13
        "",     //#define DIK_T               0x14
        "",     //#define DIK_Y               0x15
        "",     //#define DIK_U               0x16
        "",     //#define DIK_I               0x17
        "",     //#define DIK_O               0x18
        "",     //#define DIK_P               0x19
        "",     //#define DIK_LBRACKET        0x1A
        "",     //#define DIK_RBRACKET        0x1B
        "&ENTER&",     //#define DIK_RETURN          0x1C    /* Enter on main keyboard */
        "&LCTRL&",     //#define DIK_LCONTROL        0x1D
        "",     //#define DIK_A               0x1E
        "",     //#define DIK_S               0x1F
        "",     //#define DIK_D               0x20
        "",     //#define DIK_F               0x21
        "",     //#define DIK_G               0x22
        "",     //#define DIK_H               0x23
        "",     //#define DIK_J               0x24
        "",     //#define DIK_K               0x25
        "",     //#define DIK_L               0x26
        "",     //#define DIK_SEMICOLON       0x27
        "",     //#define DIK_APOSTROPHE      0x28
        "&GRAVE&",     //#define DIK_GRAVE           0x29    /* accent grave */
        "&LSHIFT&",     //#define DIK_LSHIFT          0x2A
        "",     //#define DIK_BACKSLASH       0x2B
        "",     //#define DIK_Z               0x2C
        "",     //#define DIK_X               0x2D
        "",     //#define DIK_C               0x2E
        "",     //#define DIK_V               0x2F
        "",     //#define DIK_B               0x30
        "",     //#define DIK_N               0x31
        "",     //#define DIK_M               0x32
        "",     //#define DIK_COMMA           0x33
        "",     //#define DIK_PERIOD          0x34    /* . on main keyboard */
        "",     //#define DIK_SLASH           0x35    /* / on main keyboard */
        "&RSHIFT&",     //#define DIK_RSHIFT          0x36
        "* &NUMPAD&",     //#define DIK_MULTIPLY        0x37    /* * on numeric keypad */
        "&LALT&",     //#define DIK_LMENU           0x38    /* left Alt */
        "&SPACE&",      //#define DIK_SPACE           0x39
        "&CAPS LOCK&", //#define DIK_CAPITAL         0x3A
        "F1",// #define DIK_F1              0x3B
        "F2",//#define DIK_F2              0x3C
        "F3",//#define DIK_F3              0x3D
        "F4",//#define DIK_F4              0x3E
        "F5",//#define DIK_F5              0x3F
        "F6",//#define DIK_F6              0x40
        "F7",//#define DIK_F7              0x41
        "F8",//#define DIK_F8              0x42
        "F9",//#define DIK_F9              0x43
        "F10",//#define DIK_F10             0x44
        "&NUMLOCK&",//#define DIK_NUMLOCK         0x45
        "&SCROLL LOCK&",//#define DIK_SCROLL          0x46    /* Scroll Lock */
        "7 &NUMPAD&",//#define DIK_NUMPAD7         0x47
        "8 &NUMPAD&",//#define DIK_NUMPAD8         0x48
        "9 &NUMPAD&",//#define DIK_NUMPAD9         0x49
        "- &NUMPAD&",//#define DIK_SUBTRACT        0x4A    /* - on numeric keypad */
        "4 &NUMPAD&",//#define DIK_NUMPAD4         0x4B
        "5 &NUMPAD&",//#define DIK_NUMPAD5         0x4C
        "6 &NUMPAD&",//#define DIK_NUMPAD6         0x4D
        "+ &NUMPAD&",//#define DIK_ADD             0x4E    /* + on numeric keypad */
        "1 &NUMPAD&",//#define DIK_NUMPAD1         0x4F
        "2 &NUMPAD&",//#define DIK_NUMPAD2         0x50
        "3 &NUMPAD&",//#define DIK_NUMPAD3         0x51
        "0 &NUMPAD&",//#define DIK_NUMPAD0         0x52
        ". &NUMPAD&",//#define DIK_DECIMAL         0x53    /* . on numeric keypad */
        // dziura na 3
        "",
        "",
        "",
        "F11",//#define DIK_F11             0x57
        "F12",//#define DIK_F12             0x58
        // dziura na 68
        //"",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",

        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",

        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",

        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",

        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",

        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",

        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",


        "&ENTER& &NUMPAD&", //#define DIK_NUMPADENTER     0x9C    /* Enter on numeric keypad */
        "&RCTRL&", //#define DIK_RCONTROL        0x9D

        // dziura na 22
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",

        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",

        "",
        "",

        ", &NUMPAD&",//#define DIK_NUMPADCOMMA     0xB3    /* , on numeric keypad (NEC PC98) */
        "/ &NUMPAD&", //#define DIK_DIVIDE          0xB5    /* / on numeric keypad */
        "",
        "", // sys req
        "&RALT&", //#define DIK_RMENU           0xB8    /* right Alt */
        "",
        "",

        // dziura na 15
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",

        "",
        "",

        "&HOME&", //#define DIK_HOME            0xC7    /* Home on arrow keypad */
        "&UP&", //#define DIK_UP              0xC8    /* UpArrow on arrow keypad */
        "&PG UP&", //#define DIK_PRIOR           0xC9    /* PgUp on arrow keypad */
        "",
        "&LEFT&", //#define DIK_LEFT            0xCB    /* LeftArrow on arrow keypad */
        "",
        "&RIGHT&", //#define DIK_RIGHT           0xCD    /* RightArrow on arrow keypad */
        "",
        "&END&", //#define DIK_END             0xCF    /* End on arrow keypad */

        "&DOWN&", //#define DIK_DOWN            0xD0    /* DownArrow on arrow keypad */
        "&PG DOWN&", //#define DIK_NEXT            0xD1    /* PgDn on arrow keypad */
        "&INSERT&", //#define DIK_INSERT          0xD2    /* Insert on arrow keypad */
        "&DELETE&", //#define DIK_DELETE          0xD3    /* Delete on arrow keypad */
        "",//0xD4
        "",//0xD5
        "",//0xD6
        "",//0xD7
        "",//0xD8
        "",//0xD9
        "",//0xDA
        "",//0xDB
        "",//0xDC
        "",//0xDD
        "",//0xDE
        "",//0xDF
        "",//0xE0
        "",//0xE1
        "",//0xE2
        "",//0xE3
        "",//0xE4
        "",//0xE5
        "",//0xE6
        "",//0xE7
        "",//0xE8
        "",//0xE9
        "",//0xEA
        "",//0xEB
        "",//0xEC
        "",//0xED
        "&MOUSE BUTTON& 1",//0xEE
        "&MOUSE BUTTON& 2",//0xEF
        "&MOUSE BUTTON& 3",//0xF0
        "&MOUSE WHEEL UP&",//0xF1
        "&MOUSE WHEEL DN&",//0xF2
    };

    static String GetKeyName(int nKey)
    {
        if (nKey == 0xF000)
            nKey = 0xEE;
        if (nKey == 0xF001)
            nKey = 0xEF;
        if (nKey == 0xF002)
            nKey = 0xF0;
        
        if(KeyName[nKey].equals(""))
        {
            char nKeyAscii = GameObject.GetKeyAscii(nKey);
        
            if(nKeyAscii != 0)
            {
                String sKeyName = String.valueOf(nKeyAscii);
                sKeyName = GameObject.TextToUpperCase(sKeyName);
                return sKeyName;
            }
            else
            {
                int nLocale = ELocale.GetLocale();
                switch (nKey)
                {
                case EKey._LBRACKET:
                    if (nLocale == ELocale._FRENCH)
                        return "&GUILLEMET&";
                    if (nLocale == ELocale._SPANISH)
                        return "&TILDE1&";
                    break;
                case EKey._APOSTROPHE:
                    if (nLocale == ELocale._SPANISH)
                        return "&TILDE2&";
                    break;
                case EKey._EQUALS:
                    if (nLocale == ELocale._GERMAN)
                        return "&APOSTROPH&";
                    break;
                    
                }
            }
        }

        return Text.Get(KeyName[nKey]);
    }

    /**
     * Wykorzystywane w sieci
     */
    
    /**
     * Zaladowanie (bezwarunkowe) kontrolsow z pliku
     */
    static void LoadKeySettings(String sFile)
    {
        //ustawiamy sobie na null poprzedni plik zebym 
        //mial pewnosc ze ta dziadoska poniznsza metoda
        //zaladuje mi co chce
        sm_sLastLoadedFile = null;
        //no i ladujemy
        LoadKeySeting( sFile );
    }
    
    /**
     * Zaladowanie kontrolsow z pliku i zastosowanie ich
     */
    static void LoadSettingsAndApply(String sFile)
    {
        LoadKeySettings( sFile );
        SetGameControls();
    }
}
