/** Zawiera mapowanie klawiszy */
public class EGameControl
{
    final static int IMPLANTS_NUM = 8;
    
    static ImplantsBinding  m_cImplantsBindingF1 = new ImplantsBinding(),
                            m_cImplantsBindingF2 = new ImplantsBinding(),
                            m_cImplantsBindingF3 = new ImplantsBinding(),
                            m_cImplantsBindingF4 = new ImplantsBinding();
    
    //motion
    static int FORWARD         =EKey._W;
    static int BACKWARD        =EKey._S;
    static int STRAFE_LEFT     =EKey._A;
    static int STRAFE_RIGHT    =EKey._D;
    static int JUMP            =EKey._SPACE;        //net event
    static int CRAWL           =EKey._LCONTROL;
    static int CRAWL_TOGGLE    =0;
    static int DUCK            =EKey._LSHIFT;
    static int DUCK_TOGGLE     =0;
    static int WALK            =EKey._CAPITAL;
    static int WALK_TOGGLE     =0;
    static int LEAN_LEFT       = 0;//EKey._Z;
    static int LEAN_RIGHT      = 0;//EKey._X;
                                      

    //weapon
    static int FIRE            =EKey._MOUSE_BUTTON1;        //LMB
    static int AIM             =EKey._MOUSE_BUTTON2;         //RMB
    static int AIM_TOGGLE      =0;
    static int RELOAD          =EKey._R;           //net event
    static int WEAPON_MELEE    =EKey._1;           //net event
    static int WEAPON_PISTOL   =EKey._2;           //net event
    static int WEAPON_RIFLE    =EKey._3;           //net event
    static int WEAPON_HEAVY    =EKey._4;           //net event
    static int WEAPON_GRENADE  =EKey._5;           //net event
    static int WEAPON_HANDS    =EKey._0;           //net event
    static int WEAPON_NEXT     =EKey._RBRACKET;    //net event
    static int WEAPON_PREV     =EKey._LBRACKET;    //net event
    static int WEAPON_THROW    =EKey._BACK;           //net event
    
    //inventory
    static int USE             =EKey._E;            //net event
    static int ACTION          =EKey._F;            //net event
    
    static int ZOOM_IN         =EKey._EQUALS;          //net event
    static int ZOOM_OUT        =EKey._MINUS;     //net event
    static int DETECTOR        =EKey._G;
    static int INVENTORY       =EKey._I;
    static int MAP             =EKey._M;
    static int ITEM_NEXT       =EKey._PERIOD;
    static int ITEM_PREV       =EKey._COMMA;
    static int IMPLANTS        =EKey._J;
    static int LOGS			   =EKey._L;

    //implants
    static int IMPLANT0        =EKey._NUMPAD1;
    static int IMPLANT1        =EKey._NUMPAD2;
    static int IMPLANT2        =EKey._NUMPAD3;
    static int IMPLANT3        =EKey._NUMPAD4;
    static int IMPLANT4        =EKey._NUMPAD5;
    static int IMPLANT5        =EKey._NUMPAD6;
    static int IMPLANT6        =EKey._NUMPAD7;
    /*static int IMPLANT7        =EKey._NONE;
    static int IMPLANT8        =EKey._NONE;
    static int IMPLANT9        =EKey._NONE;*/
    static int IMPLANTS_OFF    =EKey._NUMPAD0;
    //others
    //static int CONSOLE         =EKey._GRAVE;//
    static int SAY             =EKey._C;            //net event
    static int SAY_TEAM        =EKey._X;            //net event
    static int VOICE_MENU      =EKey._V;
    static int NET_CHANGE_TEAM =EKey._T;
    
    static int QUICKSAVE        = EKey._F5;
    static int QUICKLOAD        = EKey._F8;
    
    static int IMPLANTBIND_1   = EKey._F1;
    static int IMPLANTBIND_2   = EKey._F2;
    static int IMPLANTBIND_3   = EKey._F3;
    static int IMPLANTBIND_4   = EKey._F4;
    
    static int USE_ITEM_HEALTHEX = 0;
    static int USE_ITEM_NEURAL_HEALTHEX = 0;
    static int USE_ITEM_BINOCULARS = 0;
    
    static int SHOW_ADMIN_MESSAGES    = EKey._F12;
    
}

class ImplantsBinding
{
	//IMPLANT
    boolean m_bImplantsBinding[] = new boolean[EGameControl.IMPLANTS_NUM];
	
	ImplantsBinding(){}
	
	ImplantsBinding(ImplantsBinding cImplantsBinding)
	{
		for (int i = 0; i < EGameControl.IMPLANTS_NUM; i ++)
			m_bImplantsBinding[i] = cImplantsBinding.m_bImplantsBinding[i];
	}
    
    void BindImplant(int nImplant)
    {
        m_bImplantsBinding[nImplant] = true;
    }
    
    void Clear()
    {
        for (int i = 0; i < m_bImplantsBinding.length; i++)
            m_bImplantsBinding[i] = false;
    }
    
    boolean IsBinded(int nImplant)
    {
        return m_bImplantsBinding[nImplant];
    }
    
    public String toString()
    {
        String sRet = "";
        for (int i = 0; i < m_bImplantsBinding.length - 1; i++)
        {
            if (m_bImplantsBinding[i])
                sRet = sRet + "1, ";
            else 
                sRet = sRet + "0, ";
        }
        
        if (m_bImplantsBinding[m_bImplantsBinding.length - 1])
            sRet = sRet + "1";
        else 
            sRet = sRet + "0";
        
        return sRet;
    }
    
    
    
    void Load(ParseKeyword Key)
    {
        for (int i = 0; i < EGameControl.IMPLANTS_NUM; i ++)
            m_bImplantsBinding[i] = (Key.GetIParam(i) == 1);
    }
}  


