public class FXPlayerNetIndicator extends FX
{
    //czas trwania jednej sekwencji animacji znacznika. (w milisekundach)
    static double _DURATION = 1000.0;
    
    //wysokosc (w centymetrach) na jakiej bedzie widoczny indykator
    //static float  _HEIGHT   = 205.0f;
    static float  _HEIGHT   = 190.0f;
    
    //dodatkowa wysokosc na ktorej bedzie wyswietlany identyfikator spoken
    static float  _SPOKEN_ADD_HEIGHT = 40.0f;
    
    String m_sTextDyn  = "m_sText"; 
    int    m_nFontSize = 24;
    
    float  m_fMinScreenSize          = 0.13f;
    float  m_fMaxScreenSize          = 0.135f;
    float  m_fMinScreenSizeThreshold = 0.01f;
    
    float  m_fMinSpokenScreenSize    = 0.1f;
    
    FXPlayerNetIndicator()
    {
        Sequence("FXPlayerNetIndicatorBlue");
        {
			SeqDuration(1000);
			
			Expl();
            {   
                Texture("IndicatorTEXBlueTransparent");
                Duration(1000);
				TowardsToCamera(1);
				Size();
				{
					v(160,40);
				}
                MinScreenSize( m_fMinScreenSize );
                MaxScreenSize( m_fMaxScreenSize );
                MinScreenSizeTreshold( m_fMinScreenSizeThreshold );
                CullOnMinScreenSizeTreshold(true);
                SymCoords(0);
                
                BlendMode(_BLEND_MIX);
				Position();
				{
					v(0,0,0);
					
				}
				Rotation();
				{
					v(0,0,0);
					
				}
				
                Alpha();
				{
					v(0.7f);
				
				}
                
                TextDyn( m_sTextDyn );
                //TextFont( "MSS8", "Microsoft Sans Serif", m_nFontSize );
                TextFont( ChromeFonts.FONT_VERDANA_22, "Verdana", 22 );
                TextBlendMode(_BLEND_ADD);

            }
        }
        
        
        
        Sequence("FXPlayerNetIndicatorRed");
        {
			SeqDuration(1000);
			
			Expl();
            {   
                Texture("IndicatorTEXRedTransparent");
                Duration(1000);
				TowardsToCamera(1);
				Size();
				{
					v(160,40);
				}
                MinScreenSize( m_fMinScreenSize );
                MaxScreenSize( m_fMaxScreenSize );
                MinScreenSizeTreshold( m_fMinScreenSizeThreshold );
                CullOnMinScreenSizeTreshold(true);
                SymCoords(0);

                BlendMode(_BLEND_MIX);
				Position();
				{
					v(0,0,0);
					
				}
				Rotation();
				{
					v(0,0,0);
					
				}
				
				
				
				Alpha();
				{
					v(1);
				
				}
            }
            
            TextDyn( m_sTextDyn );
            //TextFont( "MSS8", "Microsoft Sans Serif", m_nFontSize );
            TextFont( ChromeFonts.FONT_VERDANA_22, "Verdana", 22 );
            TextBlendMode(_BLEND_ADD);
        }
        
        //bardzo wazne jest, aby indykator voica mial 
        //taka nazwe ( zwykly indykator + koncowka "spoken" )
        Sequence("FXPlayerNetIndicatorBlueSpoken");
        {
			SeqDuration( 1000 * HUDMapTeam._SPEACH_ICON_TIME );
			
			Expl();
            {   
                Texture("IndicatorTEXBlue");
                Duration( 1000 * HUDMapTeam._SPEACH_ICON_TIME );
				TowardsToCamera(1);
				Size();
				{
					//v(160,40);
                    v(240,60);
				}
                MinScreenSize( m_fMinSpokenScreenSize );
                
                BlendMode(_BLEND_MIX);
				Position();
				{
					v(0,0,0);
					
				}
				Rotation();
				{
					v(0,0,0);
					
				}
				
				Alpha();
				{
					v(1);
				
				}
            }
        }
        
        Sequence("FXPlayerNetIndicatorRedSpoken");
        {
			SeqDuration( 1000 * HUDMapTeam._SPEACH_ICON_TIME );
			
			Expl();
            {   
                Texture("IndicatorTEXRed");
                Duration( 1000 * HUDMapTeam._SPEACH_ICON_TIME );
				TowardsToCamera(1);
				Size();
				{
					//v(160,40);
                    v(240,60);
					
				}
                MinScreenSize( m_fMinSpokenScreenSize );

                BlendMode(_BLEND_MIX);
				Position();
				{
					v(0,0,0);
					
				}
				Rotation();
				{
					v(0,0,0);
					
				}
				
				
				
				Alpha();
				{
					v(1);
				
				}
            }
        }
    }
}


