import java.io.*;
import java.lang.Character;
import java.lang.System;

/** Klasa animowanego aktora dla rezyserowanych scenek
 */
public class AnimActor extends ChromeActor
{
	//////////////
    // atrybuty //
    //////////////

    /** Czestotliwosc odtwarzania diafonow */
    float fSamplesPerSec = 16000; // not SG
    
    /** Plik sekwencji animacji dla obiektu
     */
    //public String sAnimSeqFile = "Data/Meshes/Logan/logan.scr";//#AnimActor
    
    /** sciezka aktualnie odgrywanego wava
     */
    String sWaveName = null; // SG
    
    /** Identyfikator aktualnie/ostatnio odgrywanego wave'a (0 = brak) */
    int nWaveID = 0;             
    
    /** Czas rozpoczecia odgrywania wave'a w sekundach */
    float fStartTime = 0; // not SG
	
	/** Wykorzystywana przy zapisie/odczycie do wyliczania ile pozostao do odegrania i
	 *  do wyliczenia fStartTime w nowym czasie
	 */
	float fTimeDifference = 0; // SG
    
    /** Czas trwania wave'a w sekundach */
    float fWaveDuration = 0; // not SG
    
    /** Opoznienie odpalenia wave'a w stosunku do ust w sekundach */
    float fStartDelay = 0.04f; // not SG

    /** Aktualnie odpalony tekst subtitle'a */
    String sSubtitleText = null; // SG
    
    /** Czasy morfingow
     */
    float fMorphTime     = 0.0f; // not SG
    float fLipsMorphTime = 0.2f; // not SG
    
    AnimHash   animHash   = null; // not SG
    DiafonHash diafonHash = null; // not SG
    java.util.Vector vDiafons = null; // not SG

    Sprite cSubtitle = null; // not SG
    Sprite cSubtitleText = null; // not SG
    int nSubtitleTex = 0;
    int nSubtitlesLeftMargin = 25; // not SG
    int nSubtitlesDownMargin = 10; // not SG
    
    int nLipsElement = 0; // not SG
    String sLipsElementName = "LIPS"; // not SG
	
    /* Flaga umozliwiajaca inicjacje animacji itp. dopiero przy pierwszym
	 * uzyciu featursow
	 */
    boolean bInitiated = false;	// not SG
    
    /** Flaga do zablokowania napisow (np w klasach potomnych)
     */
    protected boolean bSubtitlesAvailable = true; // not SG
    
    /** Flaga do zablokowania odwarzania wave'a (np w klasach potomnych)
     */
    protected boolean bPlayWave = true;	// not SG	
    
    //////////////
    /// metody ///
    //////////////
        
    void OnCreate()
    {
        super.OnCreate();

        //SetLighting(false);
        
        //ActivateOnModule();
        //InitTalkingHead();
        bInitiated = false;
        
        // blokujemy ruszanie ustami az do filmu
        nLipsElement = GetElementID( sLipsElementName );
        DectivateLips();
        
        /*
        if (sAnimSeqFile == null || 
            sAnimSeqFile.length() == 0)
        {
            LogD("WARNING: sAnimSeqFile undefined...\n");
        }
        else
            InitAnimSeqFile(sAnimSeqFile);
        */
    }
    
    GameObject cCreator = null;
    
    void OnCreate(GameObject creator)
    {
        cCreator = creator;
    }
    
    void OnDestroy()
    {
        if(cSubtitleText !=null)
        {
            RemoveSprite(cSubtitleText);
            cSubtitleText.delete();
            cSubtitleText = null;
        }
        
        if(cSubtitle!=null)
        {
            if (nSubtitleTex != 0)
                cSubtitle.ReleaseTexture(nSubtitleTex);
            
            RemoveSprite(cSubtitle);
            cSubtitle.delete();
            cSubtitle = null;
        }
        super.OnDestroy();
    }
    
    void InitTalkingHead()
    {
        animHash   = new AnimHash();
        diafonHash = new DiafonHash();
        
        SetAnimBlock( sLipsElementName , true);
        
        //bylo 0, dodalem membera fMorphTime i przypisalem mu wartosc 0
        //SetAnimMorphTime(0);
        SetAnimMorphTime( fMorphTime );
        SetAnimMorphTime( sLipsElementName , fLipsMorphTime );
        
        // tworzymy sprite'a piszacego text
        if (bSubtitlesAvailable)
        {
            cSubtitle = (Sprite)CreateObject("Sprite");
		    cSubtitle.SetNoTexture();
		    cSubtitle.ProcessMouse(false);
            cSubtitle.SetTextColor( 1.0f, 1.0f, 1.0f, 1.0f );
		    cSubtitle.SetSize(new Vector(1024.0f, 768.0f,0));
		    cSubtitle.SetPos(new Vector(10.0f, 455.0f, 0));
            GetModule().AddSprite(cSubtitle);
            
            nSubtitleTex = cSubtitle.AddTexture("er_t_black.png");
            cSubtitle.SetTexture(nSubtitleTex, new Rect(0,0,1,1));
            cSubtitle.SetAlpha(0.66f);
            
            cSubtitle.MoveTop();
		    cSubtitle.Hide();
            
            cSubtitleText = (Sprite)CreateObject("Sprite");
		    cSubtitleText.SetNoTexture();
		    cSubtitleText.ProcessMouse(false);
            cSubtitleText.SetTextColor( 1.0f, 1.0f, 1.0f, 1.0f );
		    cSubtitleText.SetSize(new Vector(1024.0f, 768.0f,0));
		    cSubtitleText.SetPos(new Vector(10.0f, 455.0f, 0));
            cSubtitle.AddChild(cSubtitleText);
            
		    cSubtitleText.MoveTop();
		    cSubtitleText.Show();
        }
                
        bInitiated = true;
    }
	
	boolean bSpeakSG = false;
    
    public void Speak(String sWave)
    {
        if (bDead)
            return;
        
        if (GetModule() instanceof ChromeModuleSingle)
        {
            if(((ChromeModuleSingle)GetModule()).m_bMissionEnded)
                return;
        }
        
		if (bSpeakSG)
		{
			bSpeakSG = false;
			SpeakInternal(sWave, fStartTime, fTimeDifference);
			//!Elvis : nie powinno by "StopSpeak" zamiast "StopText" ?
			CallMethodIn("StopText", fWaveDuration-fTimeDifference);
		}
		else
		{
			//!Elvis : nie powinno by "StopSpeak" zamiast "StopText" ?
			SpeakInternal(sWave, GetTime(), 0.0f);
			CallMethodIn("StopText", fWaveDuration);
		}
    }
    
    static public String CheckFile(String sWave, String sExt)
    {
        if (sWave == null)
            return null;
        String sFileName = null;
        int nLastPointPos = sWave.lastIndexOf('.');
        if(nLastPointPos!=-1) sFileName = sWave.substring(0, nLastPointPos) + sExt;
        
        // sprawdzamy czy plik na dysku
        
        return sFileName;
        
    }
    
    /** Odegranie wave'a, oraz odpalenie animacji ust */
    public void SpeakInternal(String sWave, float fNow, float fDelay)
    {
        if (!bInitiated)
            InitTalkingHead();
        
        if (sWave == null)
            return;
        
        StopSpeak();

        // wlaczamy animacje lipsow
        ActivateLips();

        // wyciagamy nazwe pliku i sciezke
		String sDiafonFile = CheckFile(sWave, ".phn");
        
        try {
            ParseDiafons(sDiafonFile);
        } 
		catch (IOException ex) {
            LogR("[AnimActor.Speak] Object <"+GetUniqueID()+","+GetName()+"> error while parsing diaphones file <"+sDiafonFile+"> sWave=<"+sWave+">.\n");
        }
/*
        if (bSubtitlesAvailable)
        {
            String sSubtitlesFile = CheckFile(sWave, ".txt");
            String sSubtitles = "";
            try {
                sSubtitles = new String(ReadSubtitles(sSubtitlesFile));
            } catch (IOException ex) {
                CrashLog("[AnimActor.Speak] Object <"+GetUniqueID()+","+GetName()+"> error while parsing text file <"+sSubtitlesFile+">.\n");
            }
            ShowSubtitle( sSubtitles );
        }
*/
        sWaveName = new String(sWave);
		
        //TODO odegranie wave'a od miejsca fTimeDifference
        if( bPlayWave )
        {
            nWaveID = PlayWave(sWave);
            fWaveDuration = (nWaveID > 0) ? GetWaveDuration(nWaveID) : GetWaveDuration(sWaveName);
        }
        else
        {
            nWaveID = 0;
            //FIXIT fWaveDuration = 0.0f;
            // szybki hack, zeby sie dlugosc trwania z wave'a brala
            fWaveDuration = GetWaveDuration(sWaveName);
        }
        
        nExternalWave = -1;
        
        fStartTime = fNow;
    }

    public void StopSpeak()
    {
        if (!bInitiated)
            return;

        if (nWaveID > 0)
            StopWave(nWaveID);
        
        if (nExternalWave > 0)
            StopWave(nExternalWave);
        
        StopText();
        
        nWaveID = 0;
        fWaveDuration = 0;
        fStartTime = 0;
    }
    
    int iLastDiafon = -1; // SG
	
	boolean bUpdateFaceSG = false;
    
    int nExternalWave = 0;
    void SetExternalPlayingWave(int nWave)
    {
        // ustawiamy zewnwetrznie uruchomionego wave'a
        nExternalWave = nWave;
    }
    
    boolean bLogPlaying = false;
    
    protected void UpdateFace()
    {
		// przeliczenie czasu po zaadowaniu save'a gry
		if (bUpdateFaceSG && (fStartTime != 0))
		{
			fStartTime = GetTime()-fTimeDifference;
			bUpdateFaceSG = false;
		}
		
        float fDelta = GetTime() - fStartTime;
        
        if(nExternalWave > -1)
        {
            float fRealDelta = fDelta;
            
            if (!Game.cSingleton.IsAviRecording())
            {
                // obliczamy pozycje wave'a
                long nLen = GetPlayingWaveLen(nExternalWave);
                long nPos = GetPlayingWavePos(nExternalWave);
            
                fDelta = (fWaveDuration * (float)nPos) / (float)nLen;
            }
            
            if(bLogPlaying) LogR("fRealDelta="+fRealDelta+" fDelta="+fDelta+" fWaveDuration="+fWaveDuration+"\n");
            //LogR("nLen="+nLen+" nPos="+nPos+"\n");
        }
           
        if(fWaveDuration > fDelta)
        {
            Diafon cDiafon = null;
            long currSample =(long)(fDelta * fSamplesPerSec + fStartDelay);
            
            int i = 0;
            while( i < vDiafons.size() )
            {
                cDiafon = (Diafon)vDiafons.elementAt(i);
                if( (cDiafon.nBegin<currSample) && (cDiafon.nEnd>currSample) ) break;
                
                ++i;
            }
            
            if( (cDiafon != null) && (i!=iLastDiafon))
            {
                String sAnim = (String)animHash.get(new Byte(cDiafon.eDiafon));
            
                if(bLogPlaying) LogR("fDelta="+fDelta+" sAnim="+sAnim+"\n");
                PlayAnim( sLipsElementName , sAnim, 1 );
            
                iLastDiafon = i;
            }
        }
        else
            nExternalWave = -1;
    }
        
    public void OnFrame()
    {
        UpdateFace();
    }
    
    // metoda wolana z klasy Director.java
    public void Play(String sElem, String sAnim, int nRepeat, float fTime)
    {
        SetAnimMorphTime( fTime );
        SetAnimMorphTime( sLipsElementName, fLipsMorphTime);
        
        PlayAnim(sElem, sAnim, nRepeat);
    }
    
    
    // metoda wolana z klasy Director.java
    public void StopAnim()
    {
        // TODO: zatrzymanie aktywnej animacji
    }
	
	float fSpeakTextStartTime = 0; // not SG
	float fSpeakTextDuration = 0; // SG
    
    /** Napisy
     */
    public void SpeakText(String sText, float fTime)
    {
        if (bDead)
            return;
        if (bSubtitlesAvailable)
        {
            ShowSubtitle( sText );
			fSpeakTextStartTime = GetTime();
			fSpeakTextDuration = fTime;
            CallMethodIn( "StopText", fTime );
        }
    }
    
    boolean m_bSubtitlesFromBottom = true;
    
    protected void ShowSubtitle(String sText)
    {
        if (!bInitiated)
            InitTalkingHead();
        
        if (bSubtitlesAvailable==false)
            return;
    
        sSubtitleText = sText;
        
        cSubtitleText.SetFont(ChromeFonts.FONT_SUBTITLES);
        cSubtitleText.SetTextPosFlags(ESpriteText.MULTILINE);
        
        int nSizeX = GetScreenWidth() - 2*nSubtitlesLeftMargin;
        cSubtitleText.SetSize(new Vector(nSizeX,GetScreenHeight(),0));
        
        cSubtitleText.DisplayText(sText);
        int nSizeY = (int)cSubtitleText.GetTextExtent(sText).fY;
        cSubtitleText.SetSize(new Vector(nSizeX, nSizeY, 0));
        cSubtitle.SetSize(new Vector(GetScreenWidth(), nSizeY + nSubtitlesDownMargin, 0));
        int nPosY = GetScreenHeight() - nSizeY - nSubtitlesDownMargin;
                
        cSubtitle.SetPos(new Vector(0,nPosY,0));
        cSubtitleText.SetPos(new Vector(nSubtitlesLeftMargin,nPosY + nSubtitlesDownMargin/2,0));//new Vector(nSubtitlesLeftMargin, GetScreenWidth() - nSizeY - nSubtitlesDownMargin, 0.0f));
        cSubtitle.MoveTop();
        cSubtitle.Show();
                
    }
    
    void StopText()
    {
        if (bSubtitlesAvailable && (cSubtitle!=null))
            cSubtitle.Hide();
		
		fSpeakTextStartTime = 0;
		fSpeakTextDuration = 0;
        
        sSubtitleText = null;
        
        // blokujemy ruszanie ustami poza filmem
        DectivateLips();
    }
    
    
    /** Metody odczytujace pliki
     */
    public void ParseDiafons(String sDiafons) throws IOException
    {
        LogD("(" + sDiafons + ")\n");

        vDiafons = new java.util.Vector();
        
        File inputFile = new File(sDiafons);
        FileReader inputStream = new FileReader(inputFile);
            
        StreamTokenizer sTokenizer = new StreamTokenizer(inputStream);

        sTokenizer.wordChars('#','#');
        sTokenizer.wordChars('-','-');

        int nBegin = 0;
        int nEnd = 0;
        int nToken = 0;
        String sDiafon = "";
        Diafon diafon = null;
            
        while ( (nToken = sTokenizer.nextToken()) != StreamTokenizer.TT_EOF)
        {
            nBegin = (int)sTokenizer.nval;
            sTokenizer.nextToken();
            nEnd = (int)sTokenizer.nval;
            sTokenizer.nextToken();
            sDiafon = sTokenizer.sval;
                
            diafon = new Diafon();
            diafon.nBegin = nBegin;
            diafon.nEnd = nEnd;
                
            Byte byteDiafon = (Byte)(diafonHash.get(sDiafon));
            if (byteDiafon != null)
                diafon.eDiafon = byteDiafon.byteValue();
           
            vDiafons.addElement(diafon);
        }
        inputStream.close();
    }
    
    
    public String ReadSubtitles(String sSubtitlesFile) throws IOException
    {
        LogD("(" + sSubtitlesFile + ")\n");

        BufferedReader Buff = new BufferedReader(new FileReader(sSubtitlesFile));

        StringBuffer sSubtitles = new StringBuffer("");
        String sLine = new String("");
        
        while(sLine != null)
        {
            sLine = Buff.readLine();

            if(sLine != null)
                sSubtitles.append(sLine);
        }

        Buff.close();
        
        return sSubtitles.toString();
    }
    
    
    /**
     * Metody aktywujace i deaktywujace usta
     */
    
    void ActivateLips()
    {
        if (nLipsElement > -1)
        {
            SetElementAnimType( nLipsElement, EAnimType._SEQUENCE, true );
            LogD(" OK\n");
        }
        else
            LogD(" element not found!\n");
    }
    
    void DectivateLips()
    {
        if (nLipsElement >-1 )
        {
            SetElementAnimType( nLipsElement, EAnimType._OFF, true );
            LogD(" OK\n");
        }
        else
            LogD(" element not found!\n");
    }
 
    public void Die()
    {
        super.Die();
        Dialog cCurDialog = Dialog.cPlayingDialog;
        if (cCurDialog != null)
        {
            if (cCurDialog.IsActorInDialog(this))
                cCurDialog.Stop();
        }
    }
    
 	//*********************************************************
	//					SaveGame
    //*********************************************************
    
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[AnimActor.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_ANIM_ACTOR)
        {
			super.SGLoadChunk(cFC);
			
			StopSpeak();
			
			// Aktualnie odpalony tekst subtitle'a
            if (cFC.LoadBool())
			{
				fSpeakTextDuration = cFC.LoadFloat();
				if (fSpeakTextDuration < 0) fSpeakTextDuration = 0;
				// odpalamy gadanie
                SpeakText(cFC.LoadString(),fSpeakTextDuration);
			}
            else
            {
                StopText();
            }
			
            if (cFC.LoadBool())
            {
				// sciezka aktualnie odgrywanego wava
                String sLoadWaveName = cFC.LoadString();
				
				// czas rozpoczecia odgrywania wava w sekundach
                fStartTime = cFC.LoadFloat();
				// ile czasu trwao juz odgrywanie
				fTimeDifference = cFC.LoadFloat();
				
				iLastDiafon = cFC.LoadInt();
				
				bSpeakSG = true;
				bUpdateFaceSG = true;
                
				Speak( sLoadWaveName );			
            }
        }
		
		cFC.delete();
    }
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[AnimActor.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_ANIM_ACTOR, cFCParent);
		
		super.SGSaveChunk(cFC);	

		// Aktualnie odpalony tekst subtitle'a
        cFC.SaveBool( sSubtitleText != null );
		
        if ((sSubtitleText != null) && (fSpeakTextDuration != 0))
		{
			cFC.SaveFloat(fSpeakTextDuration-(GetTime()-fSpeakTextStartTime));
            cFC.SaveString(sSubtitleText);
		}

        cFC.SaveBool( nWaveID != 0 );
		
        if (nWaveID != 0)
        {
			// sciezka aktualnie odgrywanego wava
            cFC.SaveString( sWaveName );
			// czas rozpoczecia odgrywania wava w sekundach
            cFC.SaveFloat( fStartTime );
			// ile czasu trwao juz odgrywanie
            cFC.SaveFloat( GetTime()-fStartTime );
			
			cFC.SaveInt(iLastDiafon);
        }
        
        cFC.delete();
    }
    
    public void SGUpdate()
    {
		FileChunk.Log("[AnimActor.SGUpdate]\n");
		super.SGUpdate();
    }
    
    
    long l_nWavePos = -1;
    public void OnAudioPreReinitialize()
    {
        if (nWaveID != 0 && IsPlayingWave(nWaveID))
        {
            l_nWavePos = GetPlayingWavePos(nWaveID);
            
        }
    }
    
    public void OnAudioReinitialize()
    {
        
        if (l_nWavePos != -1)
        {
            nWaveID = PlayWaveFromPos(sWaveName, l_nWavePos);
        }
        
        l_nWavePos = -1;
    }
    

}