/** Klasa przelacznika do otwierania bramy typu Gate_ExternalControl
 */
public class GateController extends TriggerObject
{
    /** Tip wyswietlany na starcie
     */
    public String sTipNormal = "&Open Gate&";//#GateController
    
    /** Tip wyswietlany po przelaczeniu, jesli mozna jeszcze uzyc kontrolera
     */
    public String sTipAlternate = "&Close Gate&";//#GateController
    
    /** Polaczona z kontrolerem brama
     */
    public String sControlledGateName = null;//#GateController
    
    /** Nazwa klasy karty, ktora jest potrzebna, zeby uzyc tego kontrolera
     *  (jesli null albo "" to nie trzeba karty)
     */
    public String sRequiredCardName = null;//#GateController

    
    /** dzwiek, ktory ma byc odegrany gdy uzyjemy zamka elektronicznego */
    public String sLockSystemAcceptSound = "Data/Sounds/doors/LockSystemAccept";//#GateController
    
    
    /** dzwiek, ktory ma byc odegrany gdy nie mozna otworzyc drzwi */
    public String sLockSystemRejectSound = "Data/Sounds/doors/LockSystemReject";//#GateController
    
    
    /** Znacznik, ze brama moze byc tez zamykana tym kontrolerem
     */
    public boolean bMultipleUse = false;//#GateController
    
    
    /** Znacznik, ze kontroler jest zablokowany
     */
    public boolean bIsLocked = false;//#GateController
    
    /** Znacznik, ze brama, ktora sterujemy jest aktualnie otwarta
     */
    boolean bIsOpen = false;
    
    
    /** Obiekt sterowanej bramy
     */
    Gate_ExternalControl cGate = null;
    
    
    GateController()
    {
        super();
        //TODO: reszta inicjalizacji
    }
    
    public void OnCreate()
    {
        super.OnCreate();
        CallMethodIn("Initialization", 0);
        
        //FIXIT SetSkinElement("CH_P_Ekran02.png", 1);
    }
    
    public void Initialization()
    {
        if (sControlledGateName != null &&
            sControlledGateName.length() > 0)
        {
            cGate = (Gate_ExternalControl)GetObjectByName(sControlledGateName);
            if (cGate == null)
            {
                CrashLog("[GateController.Initailization] ERROR: Can't find object \"" + sControlledGateName + 
                         "\" for controller: \"" + GetName() + "\"\n");
            }
        }
    }

    
    void Execute( Actor executor )
    {
        super.Execute(executor);
        
        boolean bAccessGranted = true;
        
        if (bIsLocked)
        {
            bAccessGranted = false;
            PlaySound(sLockSystemRejectSound);
        }
        else if (sRequiredCardName != null &&
            sRequiredCardName.length() > 0)
        {
            if (executor instanceof Pawn)
            {
                Pawn cPawn = (Pawn)executor;
                if (cPawn.cInventory.GetByName(sRequiredCardName) == null)
                {
                    bAccessGranted = false;
                    PlaySound(sLockSystemRejectSound);
                    cPawn.TextMessage("&KEYCARD_NEEDED_1&"+" "+sRequiredCardName+" "+"&KEYCARD_NEEDED_2&");
                }
            }
        }
                
        if (bAccessGranted)
        {
            PlaySound(sLockSystemAcceptSound);
            if (!bIsOpen)
            {
                cGate.Open();
                bIsOpen = true;
            }
            else 
            {
                cGate.Close();
                bIsOpen = false;
            }
        }
    }
    
    public boolean IsActive(ControlObject Activator)
    {
        return bMultipleUse || !bIsOpen;
    }
    
    public String GetTip()
    {
        return (!bIsOpen) ? sTipNormal : sTipAlternate;
    }

    
}
