/** klasa reprezentujaca kompas lornetki i sniperki
 */
public class HUDAdditionalCompass extends HUDComponent
{
    /** pozycja tekstu statycznego na  ramce kompasu w pikselach */
	int _STATIC_TEXT_POS_X = 10;
    /** pozycja tekstu opisujacego obiekt na ramce kompasu w pikselach */
	int _OBJECT_TEXT_POS_X = 323;
    /** pozycja tekstu na ramce kompasu w pikselach */
	int _TEXT_POS_Y = 5;
	
	/** nazwa i sciezka do tekstury paska kompasu */
	String sCompassTex = "CH_T_kompasL.png";
	 
	/** nazwa i sciezka do tekstury ramki kompasu */
	String sCompassFrameTex = "CH_kompasL.png";
	
	/** nazwa i sciezka do tekstury destination point */
	String sCompassDestTex = "compas_dest.png";
   
	/** sprite kompasu */
	Sprite cHUDCompassSpr = null;
	int nHUDCompassSprTex = 0;
	
	/** sprite ramki kompasu */
	Sprite cHUDCompassFrameSpr = null;
	int nHUDCompassFrameSprTex = 0;
	
	/** sprite punktu docelowego */
	Sprite cHUDCompassDest = null;
	int nHUDCompassDestTex = 0;
    
	/** rozmiary ramki kompasu */
	int nFrameSizeX = 512;
	int nFrameSizeY = 64;
	
	/** rozmiary okienka kompasu */
	int nWindowSizeX = 121;
	int nWindowSizeY = 35;
	/** pozycja okienka kompasu wzgledem ramki kompasu (rodzica) */
	int nWindowPosX = 196;
	int nWindowPosY = 14;
	
	/** rozmiary tekstury punktu docelowego */
	int nDestSizeX = 1;
	int nDestSizeY = 33;
	/** odleglosc od brzegu kompasu do najbardziej wychylonej kreski punktu docelowego */
	int nMaxDist = -1;
	
	/** ostatnie polozenie strzalki na kompasie */
	float m_fLastCompassDestPos	= 0f;
	
	/** jeden stopien to na teksturze */
	float fOneDegreeNorm = 0.002778f;
	
	/** pozycja N znormalizowana */
	float fNPos = 0.33203125f;
	/** 60 pixeli to znormalizowane */
	float f60Pix = 0.234375f;
	/** jeden stopien to pixeli */
	float fOneDegreeToPix = 0;
	
	/** wektor polnocy */
	Vector NVect = null;
	/** wektory kierunku gracza */
	Vector PosVect = null;
	Vector RightPosVect = null;
	/** wektor punktu docelowego */
	Vector DestPosition = null;
	Vector DestVect = null;
	
	/** pozycje relatywne - poniewaz ten kompas ma sluzyc zarowno przy lornetce,
	 * jak i przy snajperce, kazda z nich moze sobie ustawic wlasne polozenie kompasu
	 */
	int m_iRelX = 0;
	int m_iRelY = 0;
	 
    /** odleglosc od celu */
    double fDistance = 0.0;

	/** wielkosc okna tekstu na ramce kompasu */
	int m_iTextSizeX = 100;
	int m_iTextSizeY = 100;
	
	/** sprite'y z tekstami wypisujacymi sie na lornetce */
	Sprite m_StaticTextInfo = null;
	Sprite m_ObjectTextInfo = null;
	
	public void OnCreate()
	{
		super.OnCreate();
		
        InitVectors();
        
        if (m_bDisableInNetGame)
            return;

        // tworze sprite'a ramki kompasu
		cHUDCompassFrameSpr = (Sprite) CreateObject("Sprite");
        nHUDCompassFrameSprTex = cHUDCompassFrameSpr.AddTexture(sCompassFrameTex);
        cHUDCompassFrameSpr.SetTexture(nHUDCompassFrameSprTex, new Rect(0f, 0f, 1f, 1f));
        cHUDCompassFrameSpr.SetSize(new Vector(nFrameSizeX, nFrameSizeY, 0));
        cHUDCompassFrameSpr.ProcessMouse(false);
		AddSprite(cHUDCompassFrameSpr);
        
        cHUDCompassFrameSpr.SetSpriteMaterial("data/materials/sprites/sprite_blend_add_walpha.mat");
        
		// tworze spritea kompasu
        cHUDCompassSpr = (Sprite) CreateObject("Sprite");
        nHUDCompassSprTex = cHUDCompassSpr.AddTexture(sCompassTex, false, true);
        #if !ENGINE_GL
            cHUDCompassSpr.SetSpriteMaterial("sprite_blend_add_wrap.mat");
        #else
            cHUDCompassSpr.SetBlendingMode(EBlendingModes.S_BLEND_ADD);
        #endif
        cHUDCompassSpr.SetTexture(nHUDCompassSprTex, new Rect(0f, 0f, 1f, 1f));
        cHUDCompassSpr.SetSize(new Vector(nWindowSizeX, nWindowSizeY, 0));
		cHUDCompassFrameSpr.AddChild(cHUDCompassSpr);
        cHUDCompassSpr.ProcessMouse(false);
        
		
		// tworze sprite'a punktu docelowego
		cHUDCompassDest = (Sprite) CreateObject("Sprite");
        nHUDCompassDestTex = cHUDCompassDest.AddTexture(sCompassDestTex);
        cHUDCompassDest.SetTexture(nHUDCompassDestTex, new Rect(0f, 0f, 0.5f, 0.8f));
        cHUDCompassDest.SetSize(new Vector(nDestSizeX, nDestSizeY, 0));
		cHUDCompassFrameSpr.AddChild(cHUDCompassDest);
        cHUDCompassDest.ProcessMouse(false);
        #if !ENGINE_GL
            cHUDCompassDest.SetSpriteMaterial("sprite_blend_add_walpha.mat");
        #else
            cHUDCompassDest.SetBlendingMode(EBlendingModes.S_BLEND_ADD);
        #endif

		// tekst statyczny
		m_StaticTextInfo = (Sprite) CreateObject("Sprite");
		m_StaticTextInfo.SetNoTexture();
		m_StaticTextInfo.ProcessMouse(false);
        #if !ENGINE_GL
            m_StaticTextInfo.SetSpriteMaterial("sprite_blend_add_walpha.mat");
        #else
            m_StaticTextInfo.SetBlendingMode(EBlendingModes.S_BLEND_ADD);
        #endif
		m_StaticTextInfo.SetSize(new Vector(m_iTextSizeX, m_iTextSizeY, 0));
		m_StaticTextInfo.SetTextPosFlags(ESpriteText.MULTILINE);
		m_StaticTextInfo.SetTextColor(186f / 255f, 201f / 255f, 234f / 255f, 0.8f);
		m_StaticTextInfo.SetFont(ChromeFonts.FONT_HUD);
		cHUDCompassFrameSpr.AddChild(m_StaticTextInfo);
		m_StaticTextInfo.MoveTop();

		// tekst z opisem obiektu
		m_ObjectTextInfo = (Sprite) CreateObject("Sprite");
		m_ObjectTextInfo.SetNoTexture();
		m_ObjectTextInfo.ProcessMouse(false);
        #if !ENGINE_GL
            m_ObjectTextInfo.SetSpriteMaterial("sprite_blend_add_walpha.mat");
        #else
            m_ObjectTextInfo.SetBlendingMode(EBlendingModes.S_BLEND_ADD);
        #endif
		m_ObjectTextInfo.SetSize(new Vector(m_iTextSizeX, m_iTextSizeY, 0));
		m_ObjectTextInfo.SetTextPosFlags(ESpriteText.MULTILINE);
		m_ObjectTextInfo.SetTextColor(186f / 255f, 201f / 255f, 234f / 255f, 0.8f);
		m_ObjectTextInfo.SetFont(ChromeFonts.FONT_HUD);
		cHUDCompassFrameSpr.AddChild(m_ObjectTextInfo);
		m_ObjectTextInfo.MoveTop();
        
		PositionHUDComponent(m_iRelX, m_iRelY);
		
		SetCompasPos(0.0f);
		
		fOneDegreeNorm = 1.0f / 360.0f;
		fOneDegreeToPix = 360.0f / 256.0f;
		
		
		RegisterMouseAxisRequest();
		
		HideAll();
	}
	
    void InitVectors()
    {
        // inicjalizuje wektory
		NVect = new Vector(0f, 0f, 1f);
		NVect.Normalize();
		PosVect = new Vector(0f, 0f, 1f);
		RightPosVect = new Vector(0f, 0f, 0f);
		DestPosition = new Vector(35000f, 0f, 35000f);
		DestVect = new Vector(0f, 0f, 0f);
    }
    
	public void OnDestroy()
	{
		super.OnDestroy();	
		
        if (m_bDisableInNetGame)
            return;
        
		if (nHUDCompassSprTex != 0)
	        cHUDCompassSpr.ReleaseTexture(nHUDCompassSprTex);
        RemoveSprite(cHUDCompassSpr);
        cHUDCompassSpr.delete();
        cHUDCompassSpr = null;	
		
		if (nHUDCompassDestTex != 0)
			cHUDCompassDest.ReleaseTexture(nHUDCompassDestTex);
		RemoveSprite(cHUDCompassDest);
		cHUDCompassDest.delete();
		cHUDCompassDest = null;
		
		RemoveSprite(m_StaticTextInfo);
		m_StaticTextInfo.delete();
		m_StaticTextInfo = null;
		
		RemoveSprite(m_ObjectTextInfo);
		m_ObjectTextInfo.delete();
		m_ObjectTextInfo = null;
		
        if (nHUDCompassFrameSprTex != 0)
			cHUDCompassFrameSpr.ReleaseTexture(nHUDCompassFrameSprTex);
        RemoveSprite(cHUDCompassFrameSpr);
        cHUDCompassFrameSpr.delete();
        cHUDCompassFrameSpr = null;	
        
		DisableCallMethod("ComputeDestTexPos");
		
        //CrashLog("[HUDAdditionalCompass.OnDestroy]: Destroing DONE. \n");
	}
	
	/** metoda aktywujaca kompas
	 */
	public void Activate()
	{
        if (m_bDisableInNetGame)
            return;
        
		if (bActiveFlag)
			return;
		if (!cHUDManager.m_bActivateAllowed)
			return;
		
		super.Activate();

        DestPosition = cHUDManager.GetHUDCompass().GetDestPosition();
        
		CallMethodEvery("ComputeDestTexPos", 0.05f);
		
		Draw();
		
		PositionHUDComponent(m_iRelX, m_iRelY);
	}
	/** metoda deaktywujaca kompas
	  */
	public void Deactivate()
	{
        if (m_bDisableInNetGame)
            return;
        
		if (!bActiveFlag)
			return;
		
		super.Deactivate();
		
		DisableCallMethod("ComputeDestTexPos");
		
		HideAll();
		
		PositionHUDComponent(m_iRelX, m_iRelY);
	 }
	
	/** metoda wyswietlajaca konsole z tekstami
	  */
	 public void DrawDo() 
	 {
         if (m_bDisableInNetGame)
            return;
         
		cHUDCompassSpr.Show();
		cHUDCompassFrameSpr.Show();
		cHUDCompassDest.Show();
		m_StaticTextInfo.Show();
		m_ObjectTextInfo.Show();
		
		cHUDCompassDest.MoveTop();
	 }
	 
	 public void HideAll()
	 {
         if (m_bDisableInNetGame)
            return;
		cHUDCompassSpr.Hide();
		cHUDCompassFrameSpr.Hide();
		cHUDCompassDest.Hide();
		m_StaticTextInfo.Hide();
		m_ObjectTextInfo.Hide();
	 }
	 
	/** metoda ustawia polozenie kompasa w zaleznosci od podanych
	 *  stopni (0-360)
	 */
	public void SetCompasPos(float degree)
	{
        if (m_bDisableInNetGame)
            return;
		float start_pos = fNPos+fOneDegreeNorm*degree - f60Pix;
		float end_pos = fNPos+fOneDegreeNorm*degree + f60Pix;
	
		cHUDCompassSpr.SetTextureCoords(new  Rect(start_pos,0.0f,end_pos ,1.0f));			
	}
	
	void OnInputMouseAxis(int nAxis, int nDelta)
	{
        if (m_bDisableInNetGame)
            return;
		double kat = 0.0;
		
        if(cPlayer==null)
        {
            Log("[HUDCompass.OnInputMosueAxis]: Player == null !\n");
            PosVect = new Vector(Vector.Up);
		    RightPosVect = new Vector(Vector.Right);
        }
        else
        {
            PosVect = cPlayer.GetForwardVector();
		    RightPosVect = cPlayer.GetRightVector();
        }
        
		float cos_alfa = PosVect.Dot(NVect);
		float cos_beta = RightPosVect.Dot(NVect);
		double kat_alfa = java.lang.Math.acos((double)cos_alfa);
		double kat_degree = (kat_alfa*180.0)/java.lang.Math.PI;
		if (cos_beta>=0)
			kat = kat_degree;
		else
			kat = 180.0f+(180.0f-kat_degree);
		SetCompasPos((float) kat);
		ComputeDestTexPos();
	}
	
	/** meotoda na podstawie kata miedzy wektorem kierunku gracza
	 *  a wektorem punktu docelowego wyswietla w odpowiednim miejscu
	 *  kreske nawigacyjna
	 */
	public void SetDestTexPos(float degr)
	{
        if (m_bDisableInNetGame)
            return;
        
		if (!bActiveFlag)
			return;
		
	    float positionX = 0.0f;
		
        if ( (degr >= 0) && (degr < 180) ) 
			positionX = nMaxDist + 60 - degr * fOneDegreeToPix;
		else
			positionX = nMaxDist + 60 + (360 - degr) * fOneDegreeToPix;
        
		if (positionX < nMaxDist)
			ShowArrowOnLeft();
        else 
        if (positionX > nMaxDist + nWindowSizeX)
			ShowArrowOnRight();
        else
		{
			cHUDCompassDest.SetRelativePos(new Vector(nWindowPosX + positionX,
													  nWindowPosY, 0));
			m_fLastCompassDestPos = positionX;
		}
	}
	
	/** wyliczenie aktualnej pozycji kreski nawigacyjnej
	 */
	public void ComputeDestTexPos()
	{
        if (m_bDisableInNetGame)
            return;
        
		if (DestPosition != null)
		{
			double kat = 0.0;
			
			//wyliczam wektor do punktu destination
            Vector player_pos=null;
            if(cPlayer==null)
            {
                Log("[HUDCompass.ComputeDestTexPos]: Player = null !\n");
                player_pos=new Vector(0,0,0);
                PosVect = new Vector(Vector.Up);
			    RightPosVect = new Vector(Vector.Right);
            }
            else
            {
                player_pos= cPlayer.GetPosition();
                PosVect = cPlayer.GetForwardVector();
			    RightPosVect = cPlayer.GetRightVector();
            }
            
			DestVect.fX = DestPosition.fX - player_pos.fX;
			DestVect.fY = 0.0f;
			DestVect.fZ = DestPosition.fZ - player_pos.fZ;
			DestVect.Normalize();
		
			// mam juz wektor kierunku destionation point
		
			float cos_alfa = PosVect.Dot(DestVect);
			float cos_beta = RightPosVect.Dot(DestVect);
			double kat_alfa = java.lang.Math.acos((double)cos_alfa);
			double kat_degree = (kat_alfa*180.0)/java.lang.Math.PI;
			if (cos_beta>=0)
				kat = kat_degree;
			else
				kat = 180.0f+(180.0f-kat_degree);
			SetDestTexPos((float)kat);	
		}
	}
	
	/** metoda wyswietla strzalke kierunku z prawej strony kompasu
	 */
	void ShowArrowOnRight()
	{
        if (m_bDisableInNetGame)
            return;
        
	   	cHUDCompassDest.SetRelativePos(new Vector(nWindowPosX + nMaxDist + nWindowSizeX,
												  nWindowPosY, 0));
		m_fLastCompassDestPos = nMaxDist + nWindowSizeX;
	}
	
	/** metoda wyswietla strzalke kierunku z lewej strony kompasu
	 */
    void ShowArrowOnLeft()
    {
        if (m_bDisableInNetGame)
            return;
        
    	cHUDCompassDest.SetRelativePos(new Vector(nWindowPosX + nMaxDist,
												  nWindowPosY, 0));
		m_fLastCompassDestPos = nMaxDist;
    }
	
	public void PositionHUDComponent(int relX, int relY)
	{
        if (m_bDisableInNetGame)
            return;
        
		super.PositionHUDComponent(relX, relY);
		
		// ustawiam parametry ramki kompasu
		nHUDCompPosX = (GetScreenWidth() - nFrameSizeX) / 2;
		nHUDCompPosY = GetScreenHeight() - nFrameSizeY;
        cHUDCompassFrameSpr.SetPos(new Vector(relX + nHUDCompPosX,
											  relY + nHUDCompPosY,
											  0));
		
		// ustawiam parametry sprite'a paska kompasu
        cHUDCompassSpr.SetRelativePos(new Vector(nWindowPosX,
												 nWindowPosY,
												 0));
		
		// ustawiam parametry sprite'a kreski docelowaj
        cHUDCompassDest.SetRelativePos(new Vector(nWindowPosX + m_fLastCompassDestPos,
												  nWindowPosY,
												  0));
		m_StaticTextInfo.SetRelativePos( new Vector(_STATIC_TEXT_POS_X, _TEXT_POS_Y, 0f) );
		m_ObjectTextInfo.SetRelativePos( new Vector( _OBJECT_TEXT_POS_X, _TEXT_POS_Y, 0f) );
	}
	
	void SetRelativePosition(int relX, int relY)
	{
		m_iRelX = relX;
		m_iRelY = relY;
	}
    
    public void SGUpdate()
    {
        super.SGUpdate();
        ForceDeactivate();
    }
}
