public class HUDBinocularsExtended extends HUDBinoculars
{
	/** co jaki czas maja byc update'owane cyferki */
	static float _UPDATE_DIGITS_TIME = 0.1f;
	
	/** szybkosc szukania celu (przesuwania punktu biezacego w kierunku docelowego */
	static float _POINT_MOVE_SPEED = 1f;
	
	/** szybkosc obrotu w stopniach na 1x zooma */
	static float _ROTATION_SPEED = 35f;

	/** maks rotation focusa */
	static float _MIN_FOCUS_ROTATION = 5f;
	static float _MAX_FOCUS_ROTATION = 30f;
	/** speed rotation focusa */
	static float _MIN_FOCUS_ROTATION_SPEED = 20f;
	static float _MAX_FOCUS_ROTATION_SPEED = 80f;

	/** czas przerwy w obracaniu focusa */
	static float _MIN_STOP_FOCUS_ROTATION_TIME = 2f;
	static float _MAX_STOP_FOCUS_ROTATION_TIME = 4f;

	/** czas przerwy pomiedzy zakloceniami */
	static float _MIN_TIME_BTW_DISORTIONS = 0.1f;
	static float _MAX_TIME_BTW_DISORTIONS = 3f;
	/** czas zaklocenia typu "pojedynczy pasek" */
	static float _DISORTION_TIME = 0.05f;
	/** czas trwania jednej ramki zaklocenia "caly ekran" */
	static float _FRAME_DISORTION_TIME = 0.05f;
	
	static int _MAX_DISORTIONS = 9;

    String m_sDisortionSound = "Data/Sounds/BinocularsDistortion.wav";
    String m_sFocusSound = "Data/Sounds/BinocularsFocus.wav";

    // id dzwieku zaklocen
    //int m_nDisortionSound = 0;
    
	/** nazwa tekstury z analogowymi zakloceniami - czteroklatkowy szum */
	String m_Disorder1TexName = "CH_zaklocenia.png";
	/** nazwa tekstury z zakloceniami 2*/
	String m_Disorder2TexName = "CH_zaklocenia2.png";
	/** tekstury zaklocen */
	int m_DisorderTextures[] = null;
	/** sprite'y zaklocen */
	Sprite m_DisorderSprites[] = null;
	int m_iDisorderTexHeight = 32;
	/** czy wyliczyc nastepny czas pojawienia sie zaklocenia */
	boolean m_bUpdateDisortion = true;
	/** kiedy ma byc nastepne pokazanie disortion */
	float m_fNextDisortionTime = 0;
	/** czy jest wyswietlane disortion */
	boolean m_bShowingDisortion	= false;
	/** numer nastepnego zaklocenia */
	int m_iNextDistortionNum = 0;
	/** czas pokazania zaklocenia */
	float m_fDisortionTime = 0;
	/** numer klatki szumu */
	int m_iCurrFrame = 0;
	int m_iFrameTextures[] = new int[4];
	
	/** obszar aktywny lornetki */
	String m_ActiveFieldTexName = "CH_fokus.png";
    Sprite m_ActiveField = null;
    int m_iActiveFieldTex = 0;
	Vector m_vActiveFieldSize = new Vector(256f, 256f, 0);

	/** obszar aktywny lornetki po zalockowaniu na obiekcie */
	String m_FocusFieldTexName = "CH_fokus2.png";
    Sprite m_FocusField = null;
    int m_iFocusFieldTex = 0;
	Vector m_vFocusFieldSize = new Vector(256f, 256f, 0);

	Vector m_vCurrWatchPoint = new Vector();
	float m_fCurrTime = 0;
	float m_fLastUpdateTime = 0;
	
	boolean m_bIsObjectTracked = false;
	
	float m_fCurrMaxFocusRotation = _MAX_FOCUS_ROTATION;
	float m_fFocusRotation = 0f;
	float m_fFocusRotationSpeed = 10f;
	int m_iFocusRotationDir = 1;
	float m_fStopRotationLen = 0f;
	boolean m_bStopRotation = false;
	float m_fStopRotationTime = 0f;

	HUDAdditionalCompass m_Compass = null;
	
	Digits m_DigitsLeft = null;
	Digits m_DigitsRight = null;
	
	float m_fLastDigitsUpdateTime = 0;
	
    public void OnCreate()
    {
        super.OnCreate();

        if (m_bDisableInNetGame)
            return;
		// dodatkowy widok		
		m_ActiveField = (Sprite) CreateObject("Sprite");
		m_iActiveFieldTex = m_ActiveField.AddTexture(m_ActiveFieldTexName, true, false);
        m_ActiveField.SetTexture(m_iActiveFieldTex, new Rect(0f, 0f, 1f, 1f));
		m_ActiveField.ProcessMouse(false);
        #if !ENGINE_GL
            m_ActiveField.SetSpriteMaterial("sprite_blend_add.mat");
        #else
            m_ActiveField.SetBlendingMode(EBlendingModes.S_BLEND_ADD);
        #endif
        m_ActiveField.SetSize(m_vActiveFieldSize);
		AddSprite(m_ActiveField);
		
		// dodatkowy widok - focus
		m_FocusField = (Sprite) CreateObject("Sprite");
		m_iFocusFieldTex = m_FocusField.AddTexture(m_FocusFieldTexName, true, false);
        m_FocusField.SetTexture(m_iFocusFieldTex, new Rect(0f, 0f, 1f, 1f));
		m_FocusField.ProcessMouse(false);
        #if !ENGINE_GL
            m_FocusField.SetSpriteMaterial("sprite_blend_add.mat");
        #else
            m_FocusField.SetBlendingMode(EBlendingModes.S_BLEND_ADD);
        #endif
        m_FocusField.SetSize(m_vFocusFieldSize);
		AddSprite(m_FocusField);

		InitDisortions();
		
		m_DigitsLeft = new Digits(GetModule(), 4, 15, 0.1f);
		m_DigitsRight = new Digits(GetModule(), 10, 15, 0.8f);
		
		PositionHUDComponent(0, 0);
        
        //GameObject.CrashLog("-2-2-2-2----------\n");
	}

    Binoculars GetBinoculars()
    {
        return (Binoculars)m_Binoculars;
    }
    
	void SetCompass(HUDAdditionalCompass compass)
	{
		m_Compass = compass;
	}
	
	public void InitWatchPoint()
	{
		m_vCurrWatchPoint.Set( ((float) GetScreenWidth()) / 2f,
							   ((float) GetScreenHeight()) / 2f,
							   0);
	}
	
	void InitDisortions()
	{
		m_DisorderTextures = new int[_MAX_DISORTIONS];
		m_DisorderSprites = new Sprite[_MAX_DISORTIONS];

		// inicjalizacja zaklocen pojedynczych paskow
		for (int i = 0; i < 8; i++)
		{
			m_DisorderSprites[i] = (Sprite) CreateObject("Sprite");
			m_DisorderTextures[i] = m_DisorderSprites[i].AddTexture(m_Disorder2TexName);
			m_DisorderSprites[i].SetTexture(m_DisorderTextures[i],
											new Rect(0f,
													 i * m_iDisorderTexHeight * EHudInvParams._P256,
													 1f,
													 (i + 1) * m_iDisorderTexHeight * EHudInvParams._P256));
			m_DisorderSprites[i].ProcessMouse(false);
			m_DisorderSprites[i].SetPos(new Vector());
			AddSprite(m_DisorderSprites[i]);
	        m_DisorderSprites[i].SetBlendingMode(EBlendingModes.S_BLEND_MIX);
			m_DisorderSprites[i].Hide();
		}
		
		// inicjalizacja zaklocenia sniezenia calego ekranu
		m_DisorderSprites[8] = (Sprite) CreateObject("Sprite");
		m_DisorderTextures[8] = m_DisorderSprites[8].AddTexture(m_Disorder1TexName);
		m_DisorderSprites[8].SetTexture(m_DisorderTextures[8], new Rect(0f, 0f, 1f, 1f));
		m_DisorderSprites[8].ProcessMouse(false);
		m_DisorderSprites[8].SetPos(new Vector());
		AddSprite(m_DisorderSprites[8]);
        m_DisorderSprites[8].SetBlendingMode(EBlendingModes.S_BLEND_MIX);
		m_DisorderSprites[8].Hide();
		
		InitDisortionsSizes();
	}
	
	void InitDisortionsSizes()
	{
		for (int i = 0; i < 8; i++)
	        m_DisorderSprites[i].SetSize(new Vector(GetScreenWidth(), m_iDisorderTexHeight, 0f));
	    m_DisorderSprites[8].SetSize(new Vector(GetScreenWidth(), GetScreenHeight(), 0f));
	}
	
	public void SetStaticText(String text)
	{
		if (m_Compass == null || m_Compass.m_StaticTextInfo == null)
			return;
        //if (text == null)
            
            //nie wyswietlamy temperatury i wilgotnosci bo za duzo jebania 
            //z budynkami (trzeba by tam zmieniac)
        text = "";
		m_Compass.m_StaticTextInfo.DisplayText(text);
        
	}
	
	public void SetObjectText(String text)
	{
		if (m_Compass == null || m_Compass.m_StaticTextInfo == null)
			return;
		m_Compass.m_ObjectTextInfo.DisplayText(text);
	}
	
    
    public void SetBinoculars(Binoculars binoculars)
    {
        //z klasy bazowej
        m_Binoculars = binoculars;
        
        if ( m_Binoculars != null && cPlayer != null )
        {
            m_Binoculars.Owner = cPlayer;
        }
        
        if ( m_Binoculars != null && m_Binoculars.Owner instanceof PlayerNetBase )
        {
            m_bDisableInNetGame = ! m_Binoculars.Owner.bNetIsOwner;
        }
        
        //CrashLog("SetBinocularsExt "+binoculars+"\n");
        if ( m_Binoculars.Owner instanceof PlayerNetBase )
        {
            m_bDisableInNetGame = ! m_Binoculars.Owner.bNetIsOwner;
            //CrashLog("m_bDisableInNetGame "+m_bDisableInNetGame+"\n");
        }
    }

    public void OnDestroy()
    {
		super.OnDestroy();

        if (m_ActiveField != null)
        {
            if (m_iActiveFieldTex != 0)
                m_ActiveField.ReleaseTexture(m_iActiveFieldTex);
            RemoveSprite(m_ActiveField);
            m_ActiveField.delete();
            m_ActiveField = null;
        }
        
        if (m_DisorderSprites != null)
        {
            for (int i = 0; i < m_DisorderSprites.length; i++)
            {
                if (m_DisorderTextures[i] != 0)
                    m_DisorderSprites[i].ReleaseTexture(m_DisorderTextures[i]);
                RemoveSprite(m_DisorderSprites[i]);
                m_DisorderSprites[i].delete();
                m_DisorderSprites[i] = null;
            }
        }
        if (m_FocusField != null)
        {
            if (m_iFocusFieldTex != 0)
                m_FocusField.ReleaseTexture(m_iFocusFieldTex);
            RemoveSprite(m_FocusField);
            m_FocusField.delete();
            m_FocusField = null;
        }
        if (m_DigitsLeft != null)
        {
            m_DigitsLeft.Destroy();
        }
        if (m_DigitsRight != null)
        {
            m_DigitsRight.Destroy();
        }
        //CrashLog("[HUDBinocularsExtended.OnDestroy]: Destroing DONE. \n");
    }

	public void Activate()
	{
		if (bActiveFlag)
			return;
		if (cHUDManager.m_bIsUserHUDActive)
			return;
		if (!cHUDManager.CanActivate(HUDManager._HUD_BINOCULARS))
			return;
		
        cHUDManager.DeactivateCurMenu();
        
		super.Activate();
		
		Draw();
	}

	public void ActivateByHUD()
    {
		if (bActiveFlag)
			return;
		if (cHUDManager.m_bIsUserHUDActive)
			return;
		if (!cHUDManager.m_bActivateAllowed)
			return;
		
		super.ActivateByHUD();
		
		Draw();
	}
	
    public void Draw()
    {
        super.Draw();
        cHUDManager.HintsMoveTop();
    }
    
    public void Deactivate()
    {
		if (!bActiveFlag)
			return;
		
        super.Deactivate();

		RestoreElements();
        
        if(nFocusSound!=0)
        {
            cPlayer.DetachSound(nFocusSound);
            nFocusSound = 0;
        }
        /*if(m_nDisortionSound!=0)
        {
            cPlayer.DetachSound(m_nDisortionSound);
            m_nDisortionSound = 0;
        }*/
    }

	public void DeactivateByHUD()
	{
		if (!bActiveFlag)
			return;
		
        super.DeactivateByHUD();

		RestoreElements();
        
        if(nFocusSound!=0)
        {
            cPlayer.DetachSound(nFocusSound);
            nFocusSound = 0;
        }
        
        /*if(m_nDisortionSound!=0)
        {
            cPlayer.DetachSound(m_nDisortionSound);
            m_nDisortionSound = 0;
        }*/
	}
	
	public void DrawDo()
	{
		super.DrawDo();
        
		m_ActiveField.Show();
		
		if (m_Compass == null)
		{
			m_Compass = cHUDManager.GetHUDAddCompass();
			CrashLog("[HUDBinocularsExtended] ERROR! Compass was not created !");
			Thread.dumpStack();			
		}
		
		if (m_Compass != null)
		{
			m_Compass.SetRelativePosition(0, (int) (-0.131f * GetScreenHeight()));
			m_Compass.Activate();
		}
		else
		{
			CrashLog("[HUDBinocularsExtended] ERROR! Compass was not created !");
			Thread.dumpStack();
		}
		
		if (m_DigitsLeft != null)
		{
			m_DigitsLeft.ShowAll();
			m_DigitsRight.ShowAll();
		}
		else
		{
			CrashLog("[HUDBinocularsExtended] ERROR! Digits not created !");
			Thread.dumpStack();			
		}

		m_bUpdateDisortion = true;
	}

	public void RestoreElements()
	{
        m_ActiveField.Hide();
		m_FocusField.Hide();		
		
		m_DigitsLeft.HideAll();
		m_DigitsRight.HideAll();
		
		m_DisorderSprites[m_iNextDistortionNum].Hide();
		
        if (m_Compass != null)
		    m_Compass.Deactivate();
	}
	
    int nFocusSound = 0;
    
    String  m_sTargetDistance = Text.Get("&BINOCULARS_TARGET_DIST&"),
            m_sDistanceUnit = Text.Get("&BINOCULARS_DIST_UNIT&"),
            m_sTargetSize = Text.Get("&BINOCULARS_TARGET_SIZE&");
    /** update'owanie HUDa wolane przez Binoculars
     */
    public void UpdateHUD()
    {
        if (GetBinoculars() != null && !m_bDisableInNetGame && bActiveFlag)
        {
			m_fCurrTime = GetTime();
			
			UpdateDisortion();
			
			UpdateDigits();
			
            java.util.Vector aSecObjs = GetBinoculars().GetIdentifiedObjects();
			
            Camera camera = cPlayer.Camera;

			if (GetBinoculars().IsFirstObjectInFocus() && (aSecObjs.size() > 0) )
			{
                if(nFocusSound==0) 
                    nFocusSound=cPlayer.AttachSound(m_sFocusSound);
                
				// obiekt miesci sie w strefie dokladnej aktywacji
				PositionActive((ChromeActor) aSecObjs.elementAt(0));
				
				Vector vTemp = GetBinoculars().GetTrackedObject().GetPosition();
				vTemp.Sub(cPlayer.GetPosition());
				float fDist = (int) vTemp.Len();
				fDist *= 0.01f;
				
				Vector vAnotherTemp = new Vector();
				GetBinoculars().GetTrackedObject().GetMeshExtentsInWorld(vTemp, vAnotherTemp);
				float fSize = (int) java.lang.Math.abs(vTemp.fY - vAnotherTemp.fY);
				fSize *= 0.01f;
				
				SetObjectText(m_sTargetDistance + "\n" +
							  GetStringFromFloat(fDist, 2) + " " +
							  m_sDistanceUnit + "\n" +
							  m_sTargetSize + "\n" +
							  GetStringFromFloat(fSize, 2) + " " + m_sDistanceUnit);
			}
			else
			{
                if(nFocusSound!=0)
                {
                    cPlayer.DetachSound(nFocusSound);
                    nFocusSound = 0;
                }
                
				PositionActive(null);
				SetObjectText("");
			}
		
			m_fLastUpdateTime = m_fCurrTime;
        }
    }

	void UpdateDisortion()
	{
		// sprawdzamy, czy nalezy wyliczyc, kiedy ma byc nowe zaklocenie
		if (m_bUpdateDisortion)
		{
			m_fNextDisortionTime = m_fCurrTime + GameObject.RandomFloat(_MIN_TIME_BTW_DISORTIONS,
																		_MAX_TIME_BTW_DISORTIONS);
			m_iNextDistortionNum = GameObject.RandomInt(9);
			m_bUpdateDisortion = false;
			m_DisorderSprites[m_iNextDistortionNum].SetAlpha(GameObject.RandomFloat(0.1f, 0.5f));
			if (m_iNextDistortionNum != 8)
			{
				m_DisorderSprites[m_iNextDistortionNum].SetPos(new Vector(0f,
																		  GetScreenHeight() * GameObject.RandomFloat(1f),
																		  0f));
			}
			else
			{
				// jezeli ma byc zaklocenie sniezenia calego ekranu, ustalamy pierwsza klatke tekstury
				m_iCurrFrame = 0;
				SetDisortionAnimTexture(m_iCurrFrame);
                
                //if(m_nDisortionSound!=0) cPlayer.DetachSound(m_nDisortionSound);
                cPlayer.AttachOneShotSound(m_sDisortionSound);
			}
		}
		else
		{
			if (m_iNextDistortionNum != 8)
			{
				if (m_fCurrTime > m_fNextDisortionTime)
				{
					if (m_bShowingDisortion)
					{
						if (m_fDisortionTime + _DISORTION_TIME > m_fCurrTime)
							return;
						// wylaczamy zaklocenie
						m_DisorderSprites[m_iNextDistortionNum].Hide();
						m_bShowingDisortion = false;
						m_bUpdateDisortion = true;
                        
                        //if(m_nDisortionSound!=0) cPlayer.DetachSound(m_nDisortionSound);
					}
					else
					{
						// wlaczamy zaklocenie
						m_bShowingDisortion = true;
						m_DisorderSprites[m_iNextDistortionNum].Show();
						m_fDisortionTime = m_fCurrTime;
                        
                        //if(m_nDisortionSound!=0) cPlayer.DetachSound(m_nDisortionSound);
                        //m_nDisortionSound = cPlayer.AttachSound(m_sDisortionSound);
                        cPlayer.AttachOneShotSound(m_sDisortionSound);
					}
				}
			}
			else
			{
				// sterujemy odtwarzaniem klatek
				if (m_bShowingDisortion)
				{
					if (m_fDisortionTime + _FRAME_DISORTION_TIME > m_fCurrTime)
						return;
					m_fDisortionTime = m_fCurrTime;
					if (m_iCurrFrame == 3)
					{
						m_DisorderSprites[m_iNextDistortionNum].Hide();
						m_bShowingDisortion = false;
						m_bUpdateDisortion = true;
						return;
					}
					
					// zwiekszamy numer klatki
					m_iCurrFrame++;
					SetDisortionAnimTexture(m_iCurrFrame);
				}
				else
				{
					// wlanczamy sniezenie
					m_bShowingDisortion = true;
					m_DisorderSprites[m_iNextDistortionNum].Show();
                    
                    //if(m_nDisortionSound!=0) cPlayer.DetachSound(m_nDisortionSound);
				}
			}
		}
	}
	
	void SetDisortionAnimTexture(int iTexture)
	{
		m_DisorderSprites[8].SetTexture(m_DisorderTextures[8],
										new Rect(0f,
												 iTexture * 128f * EHudInvParams._P512,
												 1f,
												 (iTexture + 1) * 128f * EHudInvParams._P512));
		m_DisorderSprites[8].SetAlpha(0.1f);
	}
	
	static String GetStringFromFloat(float fValue, int iDigitsAfterDot)
	{
		int iBeforeDot = (int) fValue;
		
		if (iDigitsAfterDot == 0)
			return ("" + iBeforeDot);
		
		float fAfterDot = fValue - iBeforeDot;
		fAfterDot *= (float) java.lang.Math.pow(10, iDigitsAfterDot);
		
		return ("" + iBeforeDot + "." + ((int) fAfterDot));
	}
	
	public void PositionActive(ChromeActor actor)
	{
		float fScreenWidth = GetScreenWidth();
		float fScreenHeight = GetScreenHeight();
		
		if (actor == null)
		{
			m_bIsObjectTracked = false;
			// nie ma na co namierzac
			Vector vTemp = new Vector( ((float) GetScreenWidth()) / 2f,
									   ((float) GetScreenHeight()) / 2f,
									   0);
			vTemp.Sub(m_vCurrWatchPoint);
			float fDistanceToDest = vTemp.Len();
			vTemp.Normalize();
			float fCoef = m_fCurrTime - m_fLastUpdateTime;
			vTemp.fX *= fScreenWidth * fCoef * _POINT_MOVE_SPEED;
			vTemp.fY *= fScreenHeight * fCoef * _POINT_MOVE_SPEED;
			if (vTemp.Len() > fDistanceToDest)
			{
				vTemp.Normalize();
				vTemp.Mul(fDistanceToDest);
			}				
			m_vCurrWatchPoint.Add(vTemp); // mamy nastepny punkt do obserwacji
			m_FocusField.Hide();
		}
		else
		{
			m_bIsObjectTracked = true;
			Vector vMin = PointToScreen(cPlayer.Camera, Binoculars.GetMeshPoint(actor)); // mamy punkt, ktory chcemy namierzac
			
			vMin.Sub(m_vCurrWatchPoint);
			float fDistanceToDest = vMin.Len();
			vMin.Normalize();
			float fCoef = m_fCurrTime - m_fLastUpdateTime;
			vMin.fX *= fScreenWidth * fCoef * _POINT_MOVE_SPEED;
			vMin.fY *= fScreenHeight * fCoef * _POINT_MOVE_SPEED;
			if (vMin.Len() > fDistanceToDest)
			{
				vMin.Normalize();
				vMin.Mul(fDistanceToDest);
			}
			m_vCurrWatchPoint.Add(vMin); // mamy nastepny punkt do obserwacji
			m_FocusField.Show();
		}
		
		Vector vPos = new Vector( m_vCurrWatchPoint.fX - m_vActiveFieldSize.fX / 2f,
								  m_vCurrWatchPoint.fY - m_vActiveFieldSize.fY / 2f,
								  0f);
		m_ActiveField.SetPos(vPos);
		if (m_bIsObjectTracked);
			m_FocusField.SetPos(vPos);
			
		// ustawiamy kolka w zaleznosci od zooma
		float fZoomRotation = ( m_Binoculars.cZoomer.GetZoom() -
							    m_Binoculars.fMinZoom) * _ROTATION_SPEED;
		m_ActiveField.SetRotation(fZoomRotation);
			
		if (m_bIsObjectTracked)
			SetFocusRotation(fZoomRotation);
	}
	
	void SetFocusRotation(float fBaseRotation)
	{
		if (m_bStopRotation)
		{
			StartRotatingFocus();
			return;
		}
									 
		m_fFocusRotation += m_iFocusRotationDir * (m_fCurrTime - m_fLastUpdateTime) *
							m_fFocusRotationSpeed;
		
		if (m_iFocusRotationDir < 0)
		{
			if (m_fFocusRotation < -m_fCurrMaxFocusRotation)
			{
				m_fFocusRotation = -m_fCurrMaxFocusRotation;
				ReverseTurn();
		
				StopRotatingFocus();
			}
		}
		else
		if (m_iFocusRotationDir > 0)
		{
			if (m_fFocusRotation > m_fCurrMaxFocusRotation)
			{
				m_fFocusRotation = m_fCurrMaxFocusRotation;
				ReverseTurn();
				
				StopRotatingFocus();
			}
		}
		m_FocusField.SetRotation(m_fFocusRotation);
	}
	
	void ReverseTurn()
	{
		m_fCurrMaxFocusRotation = GameObject.RandomFloat(_MIN_FOCUS_ROTATION,
														 _MAX_FOCUS_ROTATION);
		m_fFocusRotationSpeed = GameObject.RandomFloat(_MIN_FOCUS_ROTATION_SPEED,
													   _MAX_FOCUS_ROTATION_SPEED);
		m_iFocusRotationDir *= -1;
	}
	
	void StopRotatingFocus()
	{
		if (!m_bStopRotation)
		{
			if (GameObject.RandomFloat(1f) < 0.3f)
			{
				m_bStopRotation = true;
				m_fStopRotationLen = GameObject.RandomFloat(_MIN_STOP_FOCUS_ROTATION_TIME,
															_MAX_STOP_FOCUS_ROTATION_TIME);
				m_fStopRotationTime = m_fCurrTime;
			}
		}
	}
	
	void StartRotatingFocus()
	{
		if (!m_bStopRotation)
			return;
		if (m_fStopRotationTime + m_fStopRotationLen < m_fCurrTime)
			m_bStopRotation = false;
	}
	
	public void PositionHUDComponent(int relX, int relY)
	{
		super.PositionHUDComponent(relX, relY);
		
		m_ActiveField.SetPos( new Vector( (GetScreenWidth() - m_vActiveFieldSize.fX) / 2f,
										  (GetScreenHeight() - m_vActiveFieldSize.fY) / 2f - 25f,
										  0f) );
		m_FocusField.SetPos( new Vector( (GetScreenWidth() - m_vActiveFieldSize.fX) / 2f,
										 (GetScreenHeight() - m_vActiveFieldSize.fY) / 2f - 25f,
										 0f) );
		// inicjujemy dane do zaznaczenia w aktywnego obiektu
		InitWatchPoint();
		
		InitDisortionsSizes();
	}
	
	void UpdateDigits()
	{
		if (m_fLastDigitsUpdateTime + _UPDATE_DIGITS_TIME < m_fCurrTime)
		{
			m_DigitsLeft.UpdateText();
			m_DigitsRight.UpdateText();
			
			m_fLastDigitsUpdateTime = m_fCurrTime;
		}
	}
    
    public void SGUpdate()
    {
        super.SGUpdate();
        m_fCurrTime = GetTime();
		m_fLastUpdateTime = 0;
        m_fNextDisortionTime = 0;
        
        if(nFocusSound!=0)
        {
            cPlayer.DetachSound(nFocusSound);
            nFocusSound = 0;
        }
        
        ForceDeactivate();
    }
    
        
    public void OnAudioReinitialize()
    {
        
        if(nFocusSound != 0) 
            nFocusSound = cPlayer.AttachSound(m_sFocusSound);

    }
    
}

/** klasa odpowiedzialna za rzedy cyferek w lornetce
 */
class Digits
{
	Sprite m_Background1 = null;
	Sprite m_Background2 = null;
	Sprite m_ActiveDigits = null;
	
	Module m_Module = null;
	
	int m_iActiveRows;
	/** od ktorego wiersza (zaczynajac liczyc od 1) zaczyna sie pole aktywne */
	int m_iActiveRowsPos;
	
	int m_iScreenHeight = 0;
	Vector m_vLineExtents = null;
	
	/** polozenie w X w ekranach */
	float m_fScreenPos = 0;

	String m_Sample = "0000000000";
	
	String m_Randoms[] = null;
	
	Digits(Module module, int iActiveRows, int iActiveRowsPos, float fScreenPos)
	{
		m_Module = module;
		m_iActiveRows = iActiveRows;
		m_iActiveRowsPos = iActiveRowsPos; 
		m_fScreenPos = fScreenPos;
		
		m_Background1 = (Sprite) m_Module.CreateObject("Sprite");
		m_Background1.SetNoTexture();
		m_Background1.ProcessMouse(false);
		m_Background1.SetTextPosFlags(ESpriteText.MULTILINE);
		m_Background1.SetTextColor(186f / 255f, 201f / 255f, 234f / 255f, 0.15f);
		m_Background1.SetFont(ChromeFonts.FONT_HUD);
		m_Module.AddSprite(m_Background1);
		//REM bym MK
        //m_Background1.Show();
		
		m_Background2 = (Sprite) m_Module.CreateObject("Sprite");
		m_Background2.SetNoTexture();
		m_Background2.ProcessMouse(false);
		m_Background2.SetTextPosFlags(ESpriteText.MULTILINE);
		m_Background2.SetTextColor(186f / 255f, 201f / 255f, 234f / 255f, 0.15f);
		m_Background2.SetFont(ChromeFonts.FONT_HUD);
		m_Module.AddSprite(m_Background2);
        //REM bym MK
		//m_Background2.Show();
		
		m_ActiveDigits = (Sprite) m_Module.CreateObject("Sprite");
		m_ActiveDigits.SetNoTexture();
		m_ActiveDigits.ProcessMouse(false);
		m_ActiveDigits.SetTextPosFlags(ESpriteText.MULTILINE);
		m_ActiveDigits.SetTextColor(186f / 255f, 201f / 255f, 234f / 255f, 0.5f);
		m_ActiveDigits.SetFont(ChromeFonts.FONT_HUD);
		m_Module.AddSprite(m_ActiveDigits);
        //REM bym MK
		//m_ActiveDigits.Show();
		
		GenerateRandoms();
		
		UpdateSizePos();
	}
	
	void GenerateRandoms()
	{
		m_Randoms = new String[10];
		int iRowLength = m_Sample.length();
		String s = null;
		
		for (int i = 0; i < m_Randoms.length; i++)
		{
			s = "";
			while (s.length() <= iRowLength)
				s += Integer.toBinaryString(GameObject.RandomInt(Integer.MAX_VALUE));
			m_Randoms[i] = new String(s.substring(1, iRowLength + 1));
			m_Randoms[i] += "\n";
		}
	}
	
	void UpdateSizePos()
	{
		m_iScreenHeight = m_Module.GetScreenHeight();
        m_Background1.DisplayText(m_Sample);
		m_vLineExtents = m_Background1.GetTextExtent(m_Sample);
		
		m_Background1.SetSize(new Vector((int) m_vLineExtents.fX,
										 m_vLineExtents.fY * (m_iActiveRowsPos - 1),
										 0f));
		m_Background1.SetPos(new Vector(m_fScreenPos * m_Module.GetScreenWidth(), 0f, 0f));
		
		String text = "";
		for (int i = 0; i < m_iActiveRowsPos - 1; i++)
			text += m_Sample + "\n";
		m_Background1.DisplayText(text);
		
		m_ActiveDigits.SetSize(new Vector((int) m_vLineExtents.fX,
										  m_vLineExtents.fY * m_iActiveRows,
										  0f));
		m_ActiveDigits.SetPos(new Vector(m_fScreenPos * m_Module.GetScreenWidth(),
										 m_vLineExtents.fY * (m_iActiveRowsPos - 1),
										 0f));
		text = "";
		for (int i = 0; i < m_iActiveRows; i++)
			text += "1111111111\n";
		m_ActiveDigits.DisplayText(text);
		
		int iRowsLeft = (int) (m_iScreenHeight / m_vLineExtents.fY) + 1 -
						(m_iActiveRowsPos - 1 + m_iActiveRows);
		m_Background2.SetSize(new Vector((int) m_vLineExtents.fX, m_iScreenHeight -
										 (m_vLineExtents.fY * iRowsLeft),
										 0f));
		m_Background2.SetPos(new Vector(m_fScreenPos * m_Module.GetScreenWidth(),
										 m_vLineExtents.fY * (m_iActiveRowsPos - 1 + m_iActiveRows),
										 0f));
		
		text = "";
		for (int i = 0; i < iRowsLeft; i++)
			text += m_Sample + "\n";
        
		m_Background2.DisplayText(text);
	}
	
	void UpdateText()
	{
		String s = "";
		
		for (int i = 0; i < m_iActiveRows; i++)
			s += m_Randoms[GameObject.RandomInt(m_Randoms.length)];
		m_ActiveDigits.DisplayText(s);
	}
	
	void ShowAll()
	{
		m_Background1.Show();
		m_Background2.Show();
		m_ActiveDigits.Show();
	}
	
	void HideAll()
	{
		m_Background1.Hide();
		m_Background2.Hide();
		m_ActiveDigits.Hide();
	}
	
	void Destroy()
	{
		m_Module.RemoveSprite(m_Background1);
		m_Background1.delete();
		m_Background1 = null;
		m_Module.RemoveSprite(m_Background2);
		m_Background2.delete();
		m_Background2 = null;
		m_Module.RemoveSprite(m_ActiveDigits);
		m_ActiveDigits.delete();
		m_ActiveDigits = null;
	}

    
    
}


/*
String( "LEVEL_DESCRIPTION_00_W", "Temperature 23 C \nHumidity 50%")
String( "LEVEL_DESCRIPTION_01_W", "Temperature 25 C \nHumidity 60%")
String( "LEVEL_DESCRIPTION_02_W", "Temperature 25 C \nHumidity 60%")
String( "LEVEL_DESCRIPTION_03_W", "Temperature 25 C \nHumidity 60%")
String( "LEVEL_DESCRIPTION_04_W", "Temperature 25 C \nHumidity 60%")
String( "LEVEL_DESCRIPTION_06_W", "Temperature 25 C \nHumidity 60%")
String( "LEVEL_DESCRIPTION_07_W", "Temperature 25 C \nHumidity 60%")
String( "LEVEL_DESCRIPTION_08_W", "Temperature 25 C \nHumidity 60%")
String( "LEVEL_DESCRIPTION_10_W", "Temperature 25 C \nHumidity 60%")
String( "LEVEL_DESCRIPTION_10a_W", "Temperature 25 C \nHumidity 60%")
String( "LEVEL_DESCRIPTION_11_W", "Temperature 25 C \nHumidity 60%")
String( "LEVEL_DESCRIPTION_12_W", "Temperature 25 C \nHumidity 60%")
String( "LEVEL_DESCRIPTION_13a_W", "Temperature 25 C \nHumidity 60%")
String( "LEVEL_DESCRIPTION_13b_W", "Temperature 25 C \nHumidity 60%")
String( "LEVEL_DESCRIPTION_13c_W", "Temperature 25 C \nHumidity 60%")
*/