/** element HUD'a - parametry gracza (health itp.)
 */
public class HUDCompPlayer extends HUDComponent
{
    /////////////////////////////
    // USTAWIENIA DLA PIRAMIDKI
    /** liczba elementow w piramidzie */
    private final static int    _NUMBER_OF_ELEMENTS = 5;
    /** identyfikator elementu */
    private final static String _ELEM_ID            = "ID_PYR_";
    //
    /////////////////////////////

    
    /** wartosc ktora nalezy dodac przy wyliczaniu indeksu wskaznikow */
    final static int    _INDC_BASE          = 2;
    /** identyfikatory wskaznikow */
    final static int    _INDC_HEALTH        = 0,
                        _INDC_OVERLOAD      = 1,
                        _INDC_AMMO          = 2,
                        _INDC_LAST          = 3;
    /** identyfikatory */
    final static int    _INDC_MIN           = 0,
                        _INDC_MAX           = 1;
    /** okreslenie minimalnego i maksymalnego wychylenia wskaznikow */
    final static int    _HEALTH_ROT_MIN     = 90,
                        _HEALTH_ROT_MAX     = 0,
                        _OVERLOAD_ROT_MIN   = -90,
                        _OVERLOAD_ROT_MAX   = 0,
                        _AMMO_ROT_MIN       = -90,
                        _AMMO_ROT_MAX       = 0;
    /** identyfikator obracajacego sie kolka */
    final static int    _CIRCLE_0           = 0;
    
    /** liczba miejsc na ktorych ma byc wyswietlana ilosc amunicji */
    final static int    _AMMO_COUNTER_CHR   = 4;
    
    /** licznik amunicji */
    private UIStatic m_cAmmoCounter = null;
    private UIWindow    cBeltAmmo = null,
                        cBeltHealth = null,
                        cBeltOverload = null;
    
    /** ziarno zdrowia :-) */
    private float m_fHealthGrain            = -1f;
    /** ziarno overloadu */
    private float m_fOverloadGrain          = -1f;
    /** ziarno amunicji */
    private float m_fAmmoGrain              = -1f;
    /** tablica przechowujaca wskazniki poziomu */
    private int m_tIndicatorsRot[][];
    /** maksymalna liczba bronii */
    private int m_nMaxWeapon = -1;
    /** aktualnie wybrana bron */
    private int m_nCurrWeapon = -1;
    /** aktualnie obracany item */
    private int m_nCurrRotatedItem = -1;
    /** kat obrotu kolka przy zmianie broni */
    private float m_fChangeItemCircleAngle = -1f;
    /** maksymalna liczba itemow */
    private int m_nMaxItem = -1;
    /** aktualnie wybrana bron */
    private int m_nCurrItem = -1;
    
    static float _HEALTH_WARNING_THRESHOLD = 0.3f;
    static float _AMMO_WARNING_THRESHOLD = 0.2f;

    static String _HEALTH_WARNING_SOUND = "data/sounds/player/Health_warning.wav";
    static String _OVERLOAD_WARNING_SOUND = "data/sounds/player/Overload_warning.wav";
    static String _AMMO_WARNING_SOUND = null;
    
    int m_nOverloadWarningSound = 0;
    int m_nHealthWarningSound = 0;
    int m_nAmmoWarningSound = 0;
    
    boolean m_bOverloadBlinking = false;
    float m_fOverloadBlinkingPeriod = 0.4f;
    
    boolean m_bHealthBlinking = false;
    float m_fHealthBlinkingPeriod = 0.3f;
    
    boolean m_bAmmoBlinking = false;
    float m_fAmmoBlinkingPeriod = 0.25f;
    
    /** obiekt klasy obslugujacej wyswietlanie ramek wokol aktywnego triggera */
    ActiveTriggerFrames cActiveTriggerFrames = null;
    
    /** wartosci potrzebne do okreslania wielkosci paskow energii i Overload */
    int nMaxOverload  = 100;
    
    /**Uzywany przedmiot*/
    /** Dzwiek odpalany przy pokazywaniu invObjecta */
    String sShowInvObjSound = "Data/Sounds/menu/showline.wav";
    
    /** liczba miejsc, ktore zajmuje aktualny obiekt */
    int m_iCurrInvObjectCellX = 0;	
    int m_iCurrInvObjectCellY = 0;	
    
    /** sprite-napis z nazwa przedmiotu 
    UIStatic cNameSprTxt = null;*/
    
    UIStatic cBatteryUsageSprTxt = null;
    
    /* sciezka do i nazwa tekstury przedmiotu uzywanego */
    String sInvObjTexName = null;
    
    /* sprite z tekstura przedmiotu do uzywania */
    UIStatic cInvObjSpr = null;
    int nInvObjSprTex = 0;
    
    /**Referencja do inventory gracza*/
    Inventory cInventory = null;
    
    /**Aktualnie uzywany przedmiot*/
    InvObject cActualInvObject = null;
    
    
        
    public void OnInit()
    {
        super.OnInit();
        m_cAmmoCounter = (UIStatic)GetElem("ID_AMMO_COUNTER");
        cBeltOverload = GetElem("ID_PYR_" + String.valueOf(_INDC_BASE + _INDC_OVERLOAD));
        cBeltHealth = GetElem("ID_PYR_" + String.valueOf(_INDC_BASE + _INDC_HEALTH));
        cBeltAmmo = GetElem("ID_PYR_" + String.valueOf(_INDC_BASE + _INDC_AMMO));
        cInvObjSpr = (UIStatic)GetElem("ID_INV_OBJECT");
        cBatteryUsageSprTxt = (UIStatic)GetElem("ID_INV_OBJECT_BATTERY_ON");
        cBatteryUsageSprTxt.SetFont(ChromeFonts.FONT_HUD);
        cInvObjSpr.SetFont(ChromeFonts.FONT_HUD);
        
        Init();
    }
    
    /** inicjalizacja wskaznikow */
    void Init()
    {
        LoadElements( _NUMBER_OF_ELEMENTS, _ELEM_ID );

        m_tIndicatorsRot = new int[ _INDC_LAST ][ 2 ];
        
        for( int i = 0; i < _INDC_LAST; i++ )
        {
            switch( i )
            {
                case _INDC_HEALTH:
                    m_tIndicatorsRot[ _INDC_HEALTH ][ _INDC_MIN ] = _HEALTH_ROT_MIN;
                    m_tIndicatorsRot[ _INDC_HEALTH ][ _INDC_MAX ] = _HEALTH_ROT_MAX;
                    
                break;
                case _INDC_OVERLOAD:
                    m_tIndicatorsRot[ _INDC_OVERLOAD ][ _INDC_MIN ] = _OVERLOAD_ROT_MIN;
                    m_tIndicatorsRot[ _INDC_OVERLOAD ][ _INDC_MAX ] = _OVERLOAD_ROT_MAX;
                break;
                case _INDC_AMMO:
                    m_tIndicatorsRot[ _INDC_AMMO ][ _INDC_MIN ] = _AMMO_ROT_MIN;
                    m_tIndicatorsRot[ _INDC_AMMO ][ _INDC_MAX ] = _AMMO_ROT_MAX;
                break;
            }
        }
        //TODO: pobieranie wartosci (rozdzielczosci) dla poszczegolnych wskaznikow
        SetHealthIndicatorGrain();
        SetOverloadIndicatorGrain();
        
        //TODO: pobieranie informacji o aktualnie uzywanej broni
        m_nMaxWeapon = 5;
        m_nCurrWeapon = 0;
        //ponizsza metoda jest tymczasowa
        SetAmmoIndicatorGrain();
        SetWeapon( m_nCurrWeapon );
        
        //TODO: pobieranie informacji o akutalnie uzywanym itemie
        m_nMaxItem = 5;
        m_nCurrItem = 2;
        m_nCurrRotatedItem = m_nCurrItem;
        
        SetItem( m_nCurrItem );
        
        //ustalenie kata obrotu kola przy zmianie broni
        m_fChangeItemCircleAngle = _FULL_ANGLE / (float)m_nMaxItem;
        //RotateElement( _CIRCLE_0, m_nCurrRotatedItem * m_fChangeItemCircleAngle );
    }
    /** zmiana ziarna */
    private void SetHealthIndicatorGrain()
    {
        //TODO: pobieranie od playera - jezeli takie samo to spadaj
        m_fHealthGrain = 100f;
    }
    private void SetOverloadIndicatorGrain()
    {
        //TODO: pobieranie od playera - jezeli takie samo to spadaj
        m_fOverloadGrain = 100f;
    }
    private void SetAmmoIndicatorGrain()
    {
        //TODO: pobieranie od playera - jezeli takie samo to spadaj
        m_fAmmoGrain = 800f;
    }
    private void SetAmmoIndicatorGrain( float fVal )
    {
        m_fAmmoGrain = fVal;
    }
    /** ustawianie wskaznika zycia */
    void SetHealth(float fVal)
    {
        SetHealthIndicatorGrain();
        SetIndicatorVal( _INDC_HEALTH, fVal, m_fHealthGrain, true );
    }
    /** ustawianie wskaznika overload'u */
    void SetOverload(float fVal)
    {
        SetOverloadIndicatorGrain();
        SetIndicatorVal( _INDC_OVERLOAD, fVal, m_fOverloadGrain, true );
    }
    /** wyswietlanie liczby amunicji */
    private void SetAmmoCounter( float fVal )
    {
        if (m_cAmmoCounter == null)
            return;
        
        if( fVal < 0 )
        {
            m_cAmmoCounter.SetText("");
            return;
        }
                    
        String sCounterText = new String();
        int nMaxCounter = -1;
        
        if( Math.pow( 10, _AMMO_COUNTER_CHR ) < m_fAmmoGrain )
        {
            int fTemp = (int)m_fAmmoGrain;
            nMaxCounter = 0;
            while( fTemp > 0 )
            {
                fTemp /= 10;
                nMaxCounter++;
            }
        }
        else
        {
            nMaxCounter = _AMMO_COUNTER_CHR;
        }
        
        for( int i = 0; i < nMaxCounter; i++ )
        {
            if( Math.pow( 10, i ) > fVal )
            {
                sCounterText += "0";
            }
        }
        
        if( fVal != 0 )
            sCounterText += "" + (int)fVal;
        
        m_cAmmoCounter.SetText( sCounterText );
    }
    
    /** ustawianie wskaznika amunicji */
    private void SetAmmo(float fCurrentClip, float fTotal)
    {
        if (m_cAmmoCounter == null)
            return;
        
        if( fCurrentClip > m_fAmmoGrain )
        {
            SetAmmoIndicatorGrain( fCurrentClip );
        }
        
        SetIndicatorVal( _INDC_AMMO, fCurrentClip, m_fAmmoGrain, true );
        SetAmmoCounter( fTotal );
    }
    /** zmiana broni */
    void SetWeapon( int nVal )
    {
        if( nVal >= m_nMaxWeapon )
        {
            m_nCurrWeapon = 0;
        }
        else if( nVal < 0 )
        {
            m_nCurrWeapon = m_nMaxWeapon - 1;
        }
        
        //TODO: obsluga zmiany broni
        SetAmmo( 222f, 1000f );
    }
    /** kolejna bron */
    void OnNextWeapon()
    {
        m_nCurrWeapon++;
        SetWeapon( m_nCurrWeapon );
    }
    /** poprzednia bron */
    void OnPreviousWeapon()
    {
        m_nCurrWeapon--;
        SetWeapon( m_nCurrWeapon );
    }
    /** zmiana broni */
    void SetItem( int nVal )
    {
        if( nVal >= m_nMaxItem )
        {
            m_nCurrItem = 0;
        }
        else if( nVal < 0 )
        {
            m_nCurrItem = m_nMaxItem - 1;
        }
        
        //TODO: obsluga zmiany itema
        //SetElementText( _CIRCLE_0, ">> "+m_nCurrItem+ " <<" );
    }
    
    void OnNextItem()
    {
        m_nCurrItem++;
        SetItem( m_nCurrItem );
        if( m_nCurrRotatedItem == m_nMaxItem || m_nCurrRotatedItem == -m_nMaxItem)
            m_nCurrRotatedItem = m_nCurrItem - 1;
        m_nCurrRotatedItem++;
        RotateElement( _CIRCLE_0, m_nCurrRotatedItem * m_fChangeItemCircleAngle );
    }
    
    /** poprzednia bron */
    void OnPreviousItem()
    {
        m_nCurrItem--;
        SetItem( m_nCurrItem );
        if( m_nCurrRotatedItem == -m_nMaxItem || m_nCurrRotatedItem == m_nMaxItem)
        {
            m_nCurrRotatedItem = 0;
        }
        m_nCurrRotatedItem--;
        RotateElement( _CIRCLE_0, m_nCurrRotatedItem * m_fChangeItemCircleAngle );
    }

    
    /** zmiana wychylenia wskaznika */
    private void SetIndicatorVal( int nIndex, float fVal, float fIndicatorGrain, boolean bMask )
    {
        if( fVal < 0 )
            return;
        
        float fDiff = -1;
        boolean bMaskDir = false;
        
        fDiff = Math.abs( m_tIndicatorsRot[ nIndex ][ _INDC_MIN ] - m_tIndicatorsRot[ nIndex][ _INDC_MAX ] );
        
        fVal = ( fDiff * fVal ) / fIndicatorGrain;
        switch( nIndex )
        {
            case _INDC_HEALTH:
                fVal = m_tIndicatorsRot[ _INDC_HEALTH ][ _INDC_MIN ] - fVal;
                bMaskDir = true;
            break;
            case _INDC_OVERLOAD:
                fVal = fVal + m_tIndicatorsRot[ _INDC_OVERLOAD ][ _INDC_MIN ];
                bMaskDir = false;
            break;
            case _INDC_AMMO:
                fVal = fVal + m_tIndicatorsRot[ _INDC_AMMO ][ _INDC_MIN ];
                bMaskDir = false;
            break;
        }

        RotateElement( _INDC_BASE + nIndex, fVal, bMask, bMaskDir );
    }

    public void OnCreate()
    {
        super.OnCreate();
        
        if (cHUDManager.m_bDisableInNetGame)
            return;
        
        Load(GetModule(), "data/hud/HUDPlayer.scr", true);
        
        // tworzenie obiektu obslugujacego wyswietlanie ramek wokol aktywnego triggera
        cActiveTriggerFrames = (ActiveTriggerFrames) CreateObject("ActiveTriggerFrames");
    }
    
    void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
        if (bKeyState)
        {
            Vector vPos = new Vector(((UIWindow)this).GetLogicPos());
            Tools.MovePointByKeys(vPos, nKeyCode, 0);
            ((UIWindow)this).SetLogicPos(vPos);
            
        }
        Tools.ShowInfoTop(GetLogicPos() + " " + " fDelta " + Tools.g_fDelta, GetModule());
    }
    
    /** ustawianie referencji do playera (potrzebne do ustalenia max poziomu zdrowia)
     */
    public void SetParams(PlayerHUD player,HUDManager manager)
    {
        if (player == null)
            CrashLog("[HUDCompPlayer:SetPlayer] NULL Player!");
        
        super.SetParams(player,manager);
        
        player.GetImplantSystem().SetHUDToUpdate(this);
    }
    
    public void OnDestroy()
    {
        super.OnDestroy();
        
        if (cActiveTriggerFrames != null)
            cActiveTriggerFrames.delete();
        cActiveTriggerFrames = null;
        
        //CrashLog("[HUDCompPlayer.OnDestroy]: Destroing DONE. \n");
    }


    /** metoda aktywujaca HUD'a
     */
    public void Activate()
    {
        if (bActiveFlag)
            return;
        if (!cHUDManager.m_bActivateAllowed)
            return;
        
        super.Activate();
        
        if (HUDManager._DETECTOR_IS_AVAILABLE && 
            HUDManager._DETECTOR_ALWAYS_ON)
            ((HUDManager)cHUDManager).GetHUDObjDetector().Activate();
        
        Draw();
        
        //w sieci tego nie ma bo tam gracz moze byc w dziwnych stanach
        if (((ChromeModule)GetModule()).GetMainPlayer() != null &&
            GetModule() instanceof ChromeModuleSingle)
        {
            PlayerHUD cPlayer = (PlayerHUD)((ChromeModule)GetModule()).GetMainPlayer();
            cPlayer.RefreshHealth();
            cPlayer.RefreshAmmoLeft();
            if (cPlayer.GetImplantSystem() != null)
                cPlayer.GetImplantSystem().UpdateHud();
        }
    }

    void RefreshAmmoLeft()
    {
        
    }

    public void ActivateSlow()
    {
        if (bActiveFlag)
            return;
        if (!cHUDManager.m_bActivateAllowed)
            return;
        
        super.Activate();
        
        Draw();
        
        MoveComponent(new Vector(0, 61, 0),
                      new Vector(0, 0, 0),
                      1.25f);
    }
    
    public void ComponentMoved()
    {
        if (!bActiveFlag)
        {
            HideAll();
        }
        else
        {
            if (HUDManager._DETECTOR_IS_AVAILABLE && HUDManager._DETECTOR_ALWAYS_ON)
                ((HUDManager)cHUDManager).GetHUDObjDetector().ActivateSlow();
            
        }
            
    }
    
    /** metoda deaktywujaca  HUD'a
     */
    public void Deactivate()
    {
        if (!bActiveFlag)
            return;
        
        super.Deactivate();
        
        HideAll();
        
        cPlayer.bDisableTriggerDetection = true;
        cPlayer.SetActiveTrigger(null);
        
    }

    void DeactivateForMovie()
    {
        Deactivate();
        ClearWarnings();
    }
    
    void ClearWarnings()
    {   
        if (m_nHealthWarningSound != 0)
        {
            cPlayer.DetachSound(m_nHealthWarningSound);
            m_nHealthWarningSound = 0;
            m_bHealthBlinking = false;
            DisableCallMethod("BlinkHealth");
            cBeltHealth.Show();
        }
        
        if (m_nOverloadWarningSound != 0)
        {
            m_bOverloadBlinking = false;
            DisableCallMethod("BlinkOverload");
            cPlayer.DetachSound(m_nOverloadWarningSound);
            m_nOverloadWarningSound = 0;
            cBeltOverload.Show();
        }
    }
    
    
    public void DeactivateSlow()
    {
        if (!bActiveFlag)
            return;
        
        super.Deactivate();
        
        cPlayer.bDisableTriggerDetection = true;
        cPlayer.SetActiveTrigger(null);
        
        MoveComponent(new Vector(0, 0, 0),
                      new Vector(0, 61, 0),
                      0.75f);
    }
    
    public void HideAll()
    {
        Hide();
    }
    
    /** metoda rysujaca HUD'a na ekranie
     */
    public void DrawDo()
    {
        if (bActiveFlag) 
        {
            Show();            
            cPlayer.bDisableTriggerDetection = false;
        }
    }
    
    void BlinkOverload()
    {
        if (cBeltOverload.IsActuallyVisible())
            cBeltOverload.Hide();
        else
            cBeltOverload.Show();
    }
    
    void BlinkHealth()
    {
        if (cBeltHealth.IsActuallyVisible())
            cBeltHealth.Hide();
        else
            cBeltHealth.Show();
    }
    
    void BlinkAmmo()
    {
        if (cBeltAmmo.IsActuallyVisible())
            cBeltAmmo.Hide();
        else
            cBeltAmmo.Show();
    }
    /** metoda ustawiajaca wartosc TextHealth
     */
    public void SetTextHealth(float health)
    {
        float fHealth = health * 100.0f / cPlayer.fMaxHealth;
        if(fHealth > 100.0f) 
            fHealth = 100.0f;
        if (fHealth < 1 && fHealth > 0)
            fHealth = 1;

        if ( GetStatus() == _STATUS_OWNER )
        {
            SetHealth(fHealth);
            SetHealthBelt((int)health);
        }
    }
    
    public void SetStringTextHealth(String text)
    {
        //cHealthSpriteText.DisplayText(text);
    }
    
    /** metoda ustawiajaca wartosc Overload
     */
    public void SetTextOverload (float overload)
    {
        if (m_bDisableInNetGame)
            return;
        float overload_pom = overload;
        if (overload_pom > (float) nMaxOverload)
            overload_pom = (float) nMaxOverload;
        SetOverload(overload_pom);
        //SetStringTextOverload(Text.Get("&HUD_OVERLOAD&") + overload_pom + "%");
    }
    
    public void SetStringTextOverload(String text)
    {
        /*if ( cOverloadSpriteText == null )
        {
            //CrashLog(this+" SetStringTextOverload cOverloadSpriteText == null!\n");
            return;
        }
        
        cOverloadSpriteText.DisplayText(text);*/
    }
    
    public void SetWeapon(Weapon weapon)
    {
        if (weapon != null)
        {
            SetAmmoIndicatorGrain(weapon.nCapacity);
            SetTextAmmoLeft(weapon);
        }
        else
        {
            SetTextAmmoLeft(weapon);
        }
    }

    public void SetStringWeaponType(String text)
    {
        //cWeaponSpriteText.DisplayText(text);
    }
    
    public void SetTextAmmoLeft(Weapon weapon)
    {
        if ( GetStatus() != _STATUS_OWNER )
            return;
        
        if (weapon != null)
        {
            int nAmmo = cPlayer.GetTotalAmmoCount(weapon);
            SetAmmo(weapon.nAmmo, nAmmo);
            if (weapon.nCapacity > 0 &&
                (float)weapon.nAmmo/(float)weapon.nCapacity <= _AMMO_WARNING_THRESHOLD && 
                !m_bAmmoBlinking)
            {
                m_bAmmoBlinking = true;
                if (m_nAmmoWarningSound == 0 && _AMMO_WARNING_SOUND != null)
                    m_nAmmoWarningSound = cPlayer.AttachSound(_AMMO_WARNING_SOUND);
                CallMethodEvery("BlinkAmmo", m_fAmmoBlinkingPeriod);
            }
            else
            {
                if ((float)weapon.nAmmo/(float)weapon.nCapacity > _AMMO_WARNING_THRESHOLD && 
                    m_bAmmoBlinking)
                {
                    m_bAmmoBlinking = false;
                    DisableCallMethod("BlinkAmmo");
                    cBeltAmmo.Show();
                    if (m_nAmmoWarningSound != 0)
                    {
                        cPlayer.DetachSound(m_nAmmoWarningSound);
                        m_nAmmoWarningSound = 0;
                    }
                }
                
            }
        }
    }
    
    public void UpdateActiveTrigger()
    {
        if (m_bDisableInNetGame)
            return;
        if (cPlayer.ActiveTrigger != null)
            cActiveTriggerFrames.DisplayTriggerFrames(cPlayer.ActiveTrigger, cPlayer.Camera);
        else
            cActiveTriggerFrames.HideTriggerFrames();
    }
    
    /** metoda wyswietla pasek energii na podstawie podanego zdrowia
     */
    private void SetHealthBelt(int health)
    {
        if (cPlayer.bDead)
            return;
        
        if ( GetStatus() != _STATUS_OWNER )
            return;
        // player must exist
        int nMaxHealth = (int)cPlayer.fMaxHealth;

        float health_level = (float)health / (float) nMaxHealth; 
        
        if (health_level > 1.0f) 
            health_level = 1.0f;
        
        if (health_level <= 0)
        {
            if (m_nHealthWarningSound != 0)
            {
                cPlayer.DetachSound(m_nHealthWarningSound);
                m_nHealthWarningSound = 0;
            }
            return;
        }
        
        if (health_level <= _HEALTH_WARNING_THRESHOLD && !m_bHealthBlinking)
        {
            m_bHealthBlinking = true;
            if (m_nHealthWarningSound == 0)
                m_nHealthWarningSound = cPlayer.AttachSound(_HEALTH_WARNING_SOUND);
            CallMethodEvery("BlinkHealth", m_fHealthBlinkingPeriod);
        }
        else
        {
            if (health_level > _HEALTH_WARNING_THRESHOLD && m_bHealthBlinking)
            {
                m_bHealthBlinking = false;
                DisableCallMethod("BlinkHealth");
                cBeltHealth.Show();
                if (m_nHealthWarningSound != 0)
                {
                    cPlayer.DetachSound(m_nHealthWarningSound);
                    m_nHealthWarningSound = 0;
                }
            }
            
        }
    }
    
    /** metoda wyswietla pasek energii na podstawie podanego zdrowia
     */
    public void SetOverloadBelt(int overload)
    {
        if (cPlayer.bDead)
            return;
        
        if ( GetStatus() != _STATUS_OWNER )
            return;
            
        if (overload > nMaxOverload)
            overload = nMaxOverload; // obciecie do wyswietlania
        float overload_level = (float) overload / (float) nMaxOverload; 
        
        if (overload >= ImplantSystem._OVERLOAD_WARNING_THRESHOLD && !m_bOverloadBlinking)
        {
            m_bOverloadBlinking = true;
            if (m_nOverloadWarningSound == 0)
                m_nOverloadWarningSound = cPlayer.AttachSound(_OVERLOAD_WARNING_SOUND);
            CallMethodEvery("BlinkOverload", m_fOverloadBlinkingPeriod);
        }
        else
        {
            if (cPlayer != null &&
                cPlayer.GetImplantSystem().GetActiveImplantsCount() == 0)
            {
                //implanty sa wylaczone, wiec dzwiek niepotrzebny
                if (m_nOverloadWarningSound != 0)
                {
                    cPlayer.DetachSound(m_nOverloadWarningSound);
                    m_nOverloadWarningSound = 0;
                } 
            }
            
            if (overload < ImplantSystem._OVERLOAD_WARNING_THRESHOLD && m_bOverloadBlinking)
            {
                m_bOverloadBlinking = false;
                DisableCallMethod("BlinkOverload");
                if (m_nOverloadWarningSound != 0)
                {
                    cPlayer.DetachSound(m_nOverloadWarningSound);
                    m_nOverloadWarningSound = 0;
                }
                cBeltOverload.Show();
            }
            
        }
        
    }

    /** metoda wyswietlajaca rodzaj amunicji
     */
    public void SetAmmoTypeText(byte ammo_type)
    {
        String ammo = null;
        
        switch (ammo_type) 
        {
        case EAmmoType._Unlimited:
            ammo = new String("");
            break; 
            
        case EAmmoType._9mmShort: 
            ammo = new String("9mm Short");
            break; 

        case EAmmoType._12mmShort:
            ammo = new String("12mm Short");
            break; 
            
        case EAmmoType._HEX:
            ammo = new String("HEXs");
            break; 
            
        case EAmmoType._Shotgun: 
            ammo = new String("Shotgun");
            break;
            
        case EAmmoType._14mmLong: 
            ammo = new String("14mm Long");
            break;
            
        case EAmmoType._8mmLong: 
            ammo = new String("8mm Long");
            break;
            
        case EAmmoType._Grenades: 
            ammo = new String("Grenades");
            break;
            
        case EAmmoType._Energy: 
            ammo = new String("Energy");
            break;
         
        case EAmmoType._Rocket:
            ammo = new String("Rockets");
            break;                              
        }
        
        //cAmmoTypeSprText.DisplayText(ammo);
    }
    
    public void PositionHUDComponent(int relX, int relY)
    {
        super.PositionHUDComponent(relX, relY);
        CalcActualInvObjSizeAndPos();
    }
    
    /***************************************************************************
     * *************************Uzywany przedmiot
     */
    
    /** metoda ustawiajaca nazwe przedmiotu do wyswietlenia
     
    public void SetNameTxt(String name)
    {
        cNameSprTxt.SetFont(ChromeFonts.FONT_HUD);
        cNameSprTxt.DisplayText(new String(name));
        cNameSprTxt.Show();
    }*/
    
    /** ustawia aktualne inventory gracza
	 */
	public void SetPlayerInv(Inventory inv)
	{
        if (inv == null)
			LogD(": ERROR inv == NULL \n");
		
		cInventory = inv;
		cInventory.ComputeInvObjPositions();
	}
    
    /** metoda wyswietla ikonke aktualnie ustawionego przedmiotu do uzywania
     */
    public void SetActualInvObj(InvObject obj)
    {
        if ( GetStatus() != _STATUS_OWNER )
            return;
        
        LogD(obj + "\n");
        if (nInvObjSprTex != 0)
        {
            cInvObjSpr.ReleaseTexture(cInvObjSpr.m_cNormalTexture);
            nInvObjSprTex = 0;
        }
        
        
        UITexture cNewTex = new UITexture(obj.sTexFileName, obj.nTexSizeX, obj.nTexSizeY,
                                          obj.nOnTexPosX, obj.nOnTexPosY,
                                          (obj.nOnTexPosX + obj.nCellsWidth * (float) EHudInvParams.GetCellTexWidth()),
                                          (obj.nOnTexPosY + obj.nCellsHeight * (float) EHudInvParams.GetCellTexHeight() )
                                          );
        
        ((UIWindow)cInvObjSpr).LoadTexture(cNewTex);
        nInvObjSprTex = cNewTex.m_nId;
        ((UIWindow)cInvObjSpr).ReleaseTexture(((UIWindow)cInvObjSpr).m_cNormalTexture);
        ((UIWindow)cInvObjSpr).SetTexture(cNewTex);
        ((UIWindow)cInvObjSpr).m_cNormalTexture = cNewTex;
        cInvObjSpr.ProcessMouse(false);
        
        //SetNameTxt(obj.GetInvName());
        
        m_iCurrInvObjectCellX = obj.nCellsWidth;
        m_iCurrInvObjectCellY = obj.nCellsHeight;
        CalcActualInvObjSizeAndPos();
        
        cInvObjSpr.Show();    
    }        
    
    void CalcActualInvObjSizeAndPos()
    {
        if (m_bDisableInNetGame)
            return;
        
        if (nInvObjSprTex == 0)
            return;
        
        float sizeX_pom = (float) m_iCurrInvObjectCellX * (float) EHudInvParams.GetCellWidth();
        float sizeY_pom = (float) m_iCurrInvObjectCellY * (float) EHudInvParams.GetCellHeight();                       
        
        
        cInvObjSpr.SetSize(new Vector(sizeX_pom, sizeY_pom, 0));
        cInvObjSpr.UpdateLogicSizeAndPos(cInvObjSpr.GetSize(), cInvObjSpr.GetPos());
        cInvObjSpr.OnSizeAndPos();
        cBatteryUsageSprTxt.UpdateLogicSizeAndPos(cInvObjSpr.GetSize(), cInvObjSpr.GetPos());
        cBatteryUsageSprTxt.OnSizeAndPos();
    }
    
    public void ShowUsableInvObj(InvObject InvObj)
    {
        ShowUsableInvObj(InvObj, -1);
    }
    /** metoda wyswietla w oknie uzywanych przedmiotow podany przedmiot
     */
    public void ShowUsableInvObj(InvObject InvObj, int nDirection)
    {
        if (m_bDisableInNetGame)
            return;
        
        if (cActualInvObject == InvObj && InvObj != null)
            return;
        
        cActualInvObject = InvObj;
        
        if (InvObj != null)
        {
            SetActualInvObj(InvObj);
            PlaySound(sShowInvObjSound);
        }
        else 
        {
            if (nInvObjSprTex != 0)
            {
                cInvObjSpr.ReleaseTexture(cInvObjSpr.m_cNormalTexture);
                cInvObjSpr.SetNoTexture();
                nInvObjSprTex = 0;
            }
            //cInvObjSpr.SetNoTexture();
            //cInvObjSpr.Hide();  
            //SetNameTxt("NONE");  
        }
        UpdateActualObjCounter();
        if (InvObj instanceof BatteryChargedInvObject)
        {
            DisableCallMethod("UpdateActualObjUsage");
            CallMethodEvery("UpdateActualObjUsage", 0.1f);
            cBatteryUsageSprTxt.SetNormalTexture(((BatteryChargedInvObject)InvObj).cTextureOn);
            UpdateActualObjUsage();
        }
        else
        {
            cBatteryUsageSprTxt.DisplayText("");
            DisableCallMethod("UpdateActualObjUsage");
            cBatteryUsageSprTxt.SetAlpha(0);
        }

        if (InvObj != null)
        {
            //obracamy kolkami
            if (nDirection == -1)
                ;//nie obracamy
            else
                if (nDirection == EGameControl.ITEM_NEXT)
                    OnNextItem();
                else
                    if (nDirection == EGameControl.ITEM_PREV)
                        OnPreviousItem();
        }
            
        
    }
    
    void UpdateActualObjCounter()
    {
        if (m_bDisableInNetGame)
            return;
        
        int nCount = 0;
        //ile jest takich obiektow, jesli wiecej niz 1, to wyswietlamy liczbe
        if (cActualInvObject == null)
            nCount = 0;
        else
            nCount = cInventory.GetObjCount(cActualInvObject.nInvIndex);
        
        if (cActualInvObject instanceof BatteryChargedInvObject)
            nCount = 1;
        
        //cInvObjSpr
        
        if (nCount > 1)
            cInvObjSpr.DisplayText(String.valueOf(nCount));
        else
            cInvObjSpr.DisplayText("");
        
        Vector vSize = cInvObjSpr.GetSize();
        cInvObjSpr.SetTextPos((vSize.fX/4) * 3, ((vSize.fY/5) * 3));

    }
    
    /**Updejt obiektu, ktory w trakcie uzycia zuzywa baterie (trzeba to pokazac).
     */
    void UpdateActualObjUsage()
    {
        if (m_bDisableInNetGame)
            return;
        
        if (cActualInvObject instanceof BatteryChargedInvObject)
        {
            BatteryChargedInvObject cObj = (BatteryChargedInvObject)cActualInvObject;
        
            if (cObj.IsInUse())
                cBatteryUsageSprTxt.SetAlpha(1f);
            else
                cBatteryUsageSprTxt.SetAlpha(0f);
            cBatteryUsageSprTxt.SetText((int)cObj.m_fPower + "%");
        }
        else
        {
            cBatteryUsageSprTxt.SetAlpha(0f);
            cBatteryUsageSprTxt.SetText("");
        }
    }   
    
    public void OnAudioReinitialize()
    {
        
        if(m_nAmmoWarningSound != 0) 
            m_nAmmoWarningSound = cPlayer.AttachSound(_AMMO_WARNING_SOUND);
        if (m_nHealthWarningSound != 0)
            m_nHealthWarningSound = cPlayer.AttachSound(_HEALTH_WARNING_SOUND);
        if (m_nOverloadWarningSound != 0)
            m_nOverloadWarningSound = cPlayer.AttachSound(_OVERLOAD_WARNING_SOUND);

    }
    
 }