public class HUDObjectsDetector extends HUDComponent
{
    final static int    _MODE_AI    = 0x0001, 
                        _MODE_MOVE  = 0x0002;

    float _MAX_VERTICAL_DISTANCE = 800f;
    
    public String m_sScanSound = "Data/Sounds/ObjectsDetectorScan.wav";
    
    /**Ziarnistosc sprawdzania obiektow w centymetrach - kolejne sprawdzenie bedzie przeprowadzone
     * jesli linia skanujaca przesunie sie co najmniej o ta wartosc (w terenie nie na wyswietlaczu :)) */
    float m_fGranularity = 10;
    
    boolean m_bFolded = false;
    
    boolean m_bFullyActive = false;
    
    int m_nMode = _MODE_AI;//_MODE_MOVE;
    
    final Vector _DOT_SIZE = new Vector(10, 10, 0);
    
    /** wielkosc pola detektora w pikselach */
	float _FIELD_SIZE_X = 332f;
	float _FIELD_SIZE_Y = 184f;
	float _FIELD_SIZE_Y_SMALL = 5;
	/** odleglosc pola detektora w pikselach od dolnej krawedzi ekranu */
	int _POS_Y = -1;//(int)_FIELD_SIZE_Y;//TODO do stalej
    int _POS_Y_SMALL = -1;//(int)_FIELD_SIZE_Y_SMALL + 62;
	
	/** sprite detektora */
	Sprite m_cBkg = null;
    
    /**Linia skanujaca */
	Sprite m_cScanLine = null;
    
	/** nazwa tekstury kropek */
	String m_DotTexName = "CH_P_Skaner.png";
	/** numerek tekstury kropki */
	int m_iDotTexNos[] = null;
	/** sprite'y kropek */
	Sprite m_DotSprites[] = null;
	
    UITexture   m_cBkgTexture       = null,
                m_cBkgTextureSmall  = null,
                m_cScanLineTex      = null, 
                m_cDotAiTex         = null;    
    
    java.util.Vector m_vDotsAi = new java.util.Vector();
    
    /** czy przywrocic hud np. po otwarciu okna implant room */
	boolean m_bRestoreComponent = false;

    // identyfikator klasy Pawn
    int nPawnClass = 0;
    
	public void OnCreate()
	{
		super.OnCreate();
		
        _DOT_SIZE.fX *= GetResCoefX();
        _DOT_SIZE.fY *= GetResCoefY();
        
        vScanLineSize.fX *= GetResCoefX();
        vScanLineSize.fY *= GetResCoefY();
        
        _FIELD_SIZE_X *= GetResCoefX();
	    _FIELD_SIZE_Y *= GetResCoefY();
	    _FIELD_SIZE_Y_SMALL *= GetResCoefX();
        
        _POS_Y = (int)_FIELD_SIZE_Y;//TODO do stalej
        _POS_Y_SMALL = (int)_FIELD_SIZE_Y_SMALL + (int)(62f * GetResCoefY());
        
        
		bSG = false;
        
        nPawnClass = GetClassID("Pawn");
        
        //UITexture(String sFileName, float fWidth, float fHeight, float fLeft, float fTop,float fRight, float fBottom)
		m_cBkgTexture = new UITexture("CH_P_Skaner.png", 512, 256, 
                                      1, 
                                      70, 
                                      333, 
                                      254);
        
        m_cBkgTextureSmall = new UITexture("CH_P_Skaner.png", 512, 256, 
                                      1, 
                                      70 + (_FIELD_SIZE_Y - _FIELD_SIZE_Y_SMALL) , 
                                      333, 
                                      254);
		// tekstura detektora
		m_cBkg = (Sprite) CreateObject("Sprite");
        m_cBkgTexture.m_nId = m_cBkgTextureSmall.m_nId = m_cBkg.AddTexture(m_cBkgTexture.m_sFileName);
        m_cBkg.SetTexture(m_cBkgTextureSmall.m_nId, m_cBkgTextureSmall.GetLogicRect());
        
        m_cBkg.SetSize(new Vector(_FIELD_SIZE_X * GetResCoefX(), _FIELD_SIZE_Y_SMALL, 0f));
        m_cBkg.ProcessMouse(false);
		AddSprite(m_cBkg);

        
        m_cScanLineTex = new UITexture("CH_P_Skaner.png", 512, 256, 337, 148, 511, 240);
        m_cScanLine = (Sprite) CreateObject("Sprite");
        m_cScanLineTex.m_nId = m_cScanLine.AddTexture(m_cScanLineTex.m_sFileName);
        m_cScanLine.SetTexture(m_cBkgTexture.m_nId, m_cScanLineTex.GetLogicRect());
        m_cScanLine.ProcessMouse(false);
		m_cBkg.AddChild(m_cScanLine);
        m_cScanLine.Show();
        m_cScanLine.SetRelativePos(new Vector());
        
        m_cDotAiTex = new UITexture("CH_P_Skaner.png", 512, 256, 336, 245, 346, 255);//"er_t_red.png", 2, 2, 0, 0, 2, 2);//
        //teksture dodajemy tylko raz, potem zostanie tylko raz usunieta
        m_cDotAiTex.m_nId = m_cBkg.AddTexture(m_cDotAiTex.m_sFileName);
        
    	// ustawiamy ten komponent
		//PositionHUDComponent(0, (int)(_FIELD_SIZE_Y - _FIELD_SIZE_Y_SMALL));
        
        Fold();
        
        //kropa wygasnie do nastepnego odswiezenia
        _DOT_FADE_TIME = fOkres * 0.9f;
        ActivateOnModule();
        
        /*if (HUDManager._DETECTOR_IS_AVAILABLE && HUDManager._DETECTOR_ALWAYS_ON)
            CallMethodIn("ActivateSlow", 0);*/
	}
	
    float GetResCoefX()
    {
        return GetScreenWidth()/800f;
    }
    
    float GetResCoefY()
    {
        return GetScreenHeight()/600f;
    }
    
    Sprite CreateDot(int nType)
    {
        UITexture cTex = null;
        switch (nType)
        {
            case _MODE_MOVE:
                cTex = m_cDotAiTex;
                break;
                
            case _MODE_AI:
                cTex = m_cDotAiTex;
                break;
        }
        
        ObjectsDetectorDotSprite cDot = (ObjectsDetectorDotSprite)CreateObject("ObjectsDetectorDotSprite");
        
        cDot.m_fFadeTime = _DOT_FADE_TIME; 
                          
        cDot.SetTexture(cTex.m_nId, cTex.GetLogicRect());
        m_cBkg.AddChild(cDot);
        cDot.SetSize(_DOT_SIZE);
        
        return cDot;
    }
    
	public void OnDestroy()
	{
		super.OnDestroy();	

        //ta tekstura byla dodana tylko raz, potem tylko ustawiana dla kolejnych sprite'ow
        m_cBkg.ReleaseTexture(m_cDotAiTex.m_nId);
        
		for (int i = 0; i < m_vDotsAi.size(); i++)
		{
			Sprite cDot = (Sprite)m_vDotsAi.elementAt(i);
			RemoveSprite(cDot);
			cDot.delete();
		}
		m_vDotsAi.clear();
        
        if (m_cScanLineTex.m_nId != 0)
            m_cScanLine.ReleaseTexture(m_cScanLineTex.m_nId);
        RemoveSprite(m_cScanLine);
        m_cScanLine.delete();
        m_cScanLine = null;
        
        if (m_cBkgTexture.m_nId != 0)
	        m_cBkg.ReleaseTexture(m_cBkgTexture.m_nId);
        RemoveSprite(m_cBkg);
        m_cBkg.delete();
        m_cBkg = null;
    }   
	
	/** metoda aktywujaca detektor
	 */
	public void Activate()
	{
		if (bActiveFlag)
			return;
		if (cHUDManager.m_bIsUserHUDActive)
			return;
		if (!cHUDManager.m_bActivateAllowed)
			return;
        
		m_bFullyActive = true;
        UnFold();
		super.Activate();

		Draw();
	}
	
    public void ActivateSlow()
	{
        if (bActiveFlag)
			return;
		if (cHUDManager.m_bIsUserHUDActive)
			return;
		if (!cHUDManager.m_bActivateAllowed)
			return;
		
        super.Activate();   

        Draw();

        m_cScanLine.Hide();
        Fold();
        
        MoveComponent(new Vector(0,_FIELD_SIZE_Y_SMALL, 0),//_POS_Y, 0),
					  new Vector(0, 0,  0),
					  0.5f);
	}
    
    public void DeactivateSlow()
	{
		if (!bActiveFlag)
			return;
		
        super.Deactivate();   
        
        m_bFullyActive = false;
        //zwijamy do malego paska
        Fold();
		MoveComponent(new Vector(0, 0,  0),
					  new Vector(0,  _FIELD_SIZE_Y_SMALL, 0),
					  0.5f);
	}
    
	/** metoda deaktywujaca detektor
	 */
	public void Deactivate()
	{
		if (!bActiveFlag)
			return;
        Fold();
		m_bFullyActive = false;
		super.Deactivate();
		
		HideAll();
	}
	
	/** metoda wyswietlajaca detektor i wszystkie punkty
	 */
	public void DrawDo() 
	{
		m_cBkg.Show();
	}
	 
	/** metoda chowajaca detektor i wszystkie punkty
	 */
	public void HideAll()
	{
		m_cBkg.Hide();
	}
	
	public void PositionHUDComponent(int relX, int relY)
	{
        LogD("pos " + relX + ", " + relY);
		super.PositionHUDComponent(relX, relY);
		
        if (m_bFolded)
		    m_cBkg.SetPos( new Vector(relX + GetScreenWidth()/2f - m_cBkg.GetSize().fX/2, 
                                  relY + GetScreenHeight() - _POS_Y_SMALL, 0f) );
        else
            m_cBkg.SetPos( new Vector(relX + GetScreenWidth()/2f - m_cBkg.GetSize().fX/2, 
                                  relY + GetScreenHeight() - _POS_Y, 0f) );
	}
    
    
    /**Czas przejscia jednej linii skanujacej*/
    float fOkres = 1;
    Vector vScanLineSize = new Vector(324, 168, 0f);
    
    /**Zasieg skanera*/
    float m_fScanRange = 6000;//70 metrow
    
    float fStartTime = 0;
    
    float fLastScanRange = 0;
    
    /**Wyliczana w oncreate na podstawie okresu*/
    float _DOT_FADE_TIME = 0.0f;
    
    /**Przesuniecie linii skanujacej w pionie i poziomie wynikajace z roznych rozmiarow bitmap*/
    float _MARGINY = 6, _MARGINX = 5;

    Vector m_vTempScanLinePos = new Vector(),
           m_vTempScanLineSize = new Vector(), 
           m_vTempBkgSize = null;
    
    void OnPostUpdate()
    {
        if (Precache.bPrecaching)
            return;
        
        if (!m_bFullyActive)
            return;
        
        if (!bActiveFlag)
			return;
        
        if (fStartTime == 0)
            fStartTime = GetTime();
        float fTimeNow = GetTime();
        float fTime = fTimeNow - fStartTime;
        
        //chcemy, zeby tylko pierwsza cwiartka (wznoszaca od 0 do 1) sinusa byla brana pod uwage
        //troche magiczne, ale dziala
        if (fTime/(fOkres * 2) >= 0.5f)
        {
            fTime = 0;
            fStartTime = GetTime();
        }
        
        float fFrac = (float)(((fTime/(fOkres*2))) * (float)java.lang.Math.PI);

        float fSin = (float)Math.abs((float)java.lang.Math.sin(fFrac));   
        
        float fRange = m_fScanRange * fSin;
        
        if (fRange - fLastScanRange < m_fGranularity && fRange - fLastScanRange > 0)
            return;
        
        /* gdy przebieg zaczyna skanowac od nowa to odpalamy dzwiek
        if(fRange - fLastScanRange < 0)
            cPlayer.AttachOneShotSound(m_sScanSound);*/
        
        m_vTempScanLineSize.Set(vScanLineSize);
        m_vTempScanLineSize.Mul(fSin);
        m_cScanLine.SetSize(m_vTempScanLineSize);
        
        m_vTempScanLinePos.Set(0,0,0);
        if (m_vTempBkgSize == null)
            m_vTempBkgSize = m_cBkg.GetSize();
        m_vTempScanLinePos.fX = (m_vTempBkgSize.fX - m_vTempScanLineSize.fX)/2 + 1;
        m_vTempScanLinePos.fY = m_vTempBkgSize.fY - m_vTempScanLineSize.fY - _MARGINY;
        m_vTempScanLinePos.fZ = 0;
        m_cScanLine.SetRelativePos(m_vTempScanLinePos);
        
        
        
        if ((m_nMode & _MODE_AI) == _MODE_AI)
        {
            ControlObject tab[] = ((GameObject)this).GetObjectsInRadiusFromClass(
                                                        cPlayer.GetPosition(), 
                                                        m_fScanRange, 
                                                        nPawnClass);
            if (tab != null && tab.length > 0)
            {
                while (tab.length > m_vDotsAi.size())
                {
                    m_vDotsAi.insertElementAt(CreateDot(_MODE_AI),0);
                }
                for (int i = 0; i < tab.length; i++)
                {
                    float fObjDist = cPlayer.GetDistanceTo((ControlObject)tab[i]);
                    if (fObjDist > fLastScanRange && fObjDist <= fRange &&
                        (float)Math.abs(cPlayer.GetPositionVectorVolatile().fY - ((ControlObject)tab[i]).GetPositionVectorVolatile().fY) < _MAX_VERTICAL_DISTANCE &&
                        ((Pawn)tab[i]).CanBeShowOnMoveDetector() )
                    {
                        Vector vLocalPos = cPlayer.PointWorldToLocal(((ControlObject)tab[i]).GetPosition());
                        if (vLocalPos.fZ < 0)
                            continue;
                        SetDotPosition((Sprite)m_vDotsAi.elementAt(0), vLocalPos);
                        ShowDot(m_vDotsAi, 0);
                        cPlayer.AttachOneShotSound(m_sScanSound);
                    }
                }
            }
        }
        
        if ((m_nMode & _MODE_MOVE) == _MODE_MOVE)
        {
            ControlObject tab[] = ((GameObject)this).GetObjectsInRadiusFromClass(
                                                        cPlayer.GetPosition(), 
                                                        m_fScanRange, 
                                                        "ChromeActor");
            if (tab != null && tab.length > 0)
            {
                while (tab.length > m_vDotsAi.size())
                {
                    m_vDotsAi.insertElementAt(CreateDot(_MODE_MOVE),0);
                }
                for (int i = 0; i < tab.length; i++)
                {
                    float fObjDist = cPlayer.GetDistanceTo((ControlObject)tab[i]);
                    if (fObjDist > fLastScanRange && fObjDist <= fRange && ((ControlObject)tab[i]).GetSpeedValue() > 1f)
                    {
                        Vector vLocalPos = cPlayer.PointWorldToLocal(((ControlObject)tab[i]).GetPositionVectorVolatile());
                        if (vLocalPos.fZ < 0)
                            continue;
                        SetDotPosition((Sprite)m_vDotsAi.elementAt(0), vLocalPos);
                        ShowDot(m_vDotsAi, 0);
                        cPlayer.AttachOneShotSound(m_sScanSound);
                    }
                }
            }
        }
        
        fLastScanRange = fRange;
    }
    
    void ShowDot(java.util.Vector vDots, int nIdx)
    {
        if (nIdx < 0 || nIdx >= vDots.size())
        {
            Tools.CrashLogError("HUDObjectsDetector.ShowDot idx out of range");
            return;
        }
        
        Sprite cDot = (Sprite)vDots.elementAt(nIdx);
        cDot.Show();
        //przenosimy sprite'a na     koniec kolejki, tak zeby zdazyl wygasnac zanim chcielibysmy go 
        //zapalic znowu, do wyswietlenia brane sa elementy z poczatku
        vDots.removeElementAt(nIdx);
        vDots.addElement(cDot);
    }
    
    void SetDotPosition(Sprite cDot, Vector vLocalPos)
    {
        if (vLocalPos.fX != 0)
            vLocalPos.fX = vScanLineSize.fX/2f - vScanLineSize.fX/(2 * m_fScanRange/vLocalPos.fX) -_DOT_SIZE.fX/2 + _MARGINX;
        else
            vLocalPos.fX = vScanLineSize.fX/2f -_DOT_SIZE.fX/2 + _MARGINX;
        
        if (vLocalPos.fZ != 0)
            vLocalPos.fY = vScanLineSize.fY - vScanLineSize.fY/(m_fScanRange/vLocalPos.fZ) + _DOT_SIZE.fY/2 + _MARGINY;
        else
            vLocalPos.fY = vScanLineSize.fY + _DOT_SIZE.fY/2 + _MARGINY;
        
        vLocalPos.fZ = 0;
        cDot.SetRelativePos(vLocalPos);
        cDot.Show();
        //LogD("Real pos " + vRealPos + " dot pos " + vLocalPos );
    }

    float fBlinkTime = 0.25f;
    public void ComponentMoved()
    {
        DisableCallMethod("Blink");
        super.ComponentMoved();
        if (bActiveFlag)
        {
            CallMethodIn("Blink", RandomFloat(fBlinkTime));
            CallMethodIn("StopBlink", 1f + RandomFloat(0.5f));
        }
        else
        {
            m_cBkg.Hide();
        }
    }
    
    void Blink()
    {
        if (m_bFolded)
        {
            UnFold();
        }
        else
        {
            Fold();
        }
        CallMethodIn("Blink", RandomFloat(fBlinkTime));
    }
    
    void StopBlink()
    {
        if (m_bFolded)
        {
            UnFold();
        }
        DisableCallMethod("Blink");
        m_bFullyActive = true;
        m_cScanLine.Show();
    }
    
    void UnFold()
    {
        m_bFolded = false;
        m_cBkg.SetTexture(m_cBkgTexture.m_nId, m_cBkgTexture.GetLogicRect());
        m_cBkg.SetSize(new Vector(_FIELD_SIZE_X, _FIELD_SIZE_Y, 0));
        PositionHUDComponent(0,0);
    }
    
    void Fold()
    {
        m_bFolded = true;
        m_cBkg.SetTexture(m_cBkgTextureSmall.m_nId, m_cBkgTextureSmall.GetLogicRect());
        m_cBkg.SetSize(new Vector(_FIELD_SIZE_X, _FIELD_SIZE_Y_SMALL, 0));
        PositionHUDComponent(0, 0);
    }
    /*void OnInputKey(int nKey, boolean b, char c)
    {
        if (b)
        {
            Tools.MovePointByKeys(vScanLineSize, nKey, 0);
        }
        CrashLog("vScanLineSize " + vScanLineSize + " delta " + Tools.g_fDelta);
        
    }*/
	
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[HUDObjectsDetector.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_HUD_OBJECTS_DETECTOR)
        {	
			super.SGLoadChunk(cFC);
			
			m_bFolded = cFC.LoadBool();
			m_bFullyActive = cFC.LoadBool();
			fStartTime = cFC.LoadFloat();
			fLastScanRange = cFC.LoadFloat();	
            
            for (int i = 0; i < m_vDotsAi.size(); i++)
            {
                Sprite cDot = (Sprite)m_vDotsAi.elementAt(i);
                RemoveSprite(cDot);
                cDot.delete();
            }		
            m_vDotsAi.clear();
        }
		
		cFC.delete();
    }
	    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[HUDObjectsDetector.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_HUD_OBJECTS_DETECTOR, cFCParent);
		
		super.SGSaveChunk(cFC);
		
		cFC.SaveBool(m_bFolded);
		cFC.SaveBool(m_bFullyActive);
		cFC.SaveFloat(fStartTime);
		cFC.SaveFloat(fLastScanRange);			
		
        cFC.delete();
    }	    	    
	
	public void SGUpdate()
	{
        fStartTime = 0;
		fLastScanRange = 0;
					
		FileChunk.Log("[HUDObjectsDetector.SGUpdate]\n");
		super.SGUpdate();		
	}		
}
