public class HUDSniper extends HUDComponent
{
    static int m_nWeaponId = 0; 
                            
    float _UPDATE_TIME = 0.1f; 
	/** obrot w stopniach przy zmianie zooma, wyliczana na podstawie maksymalnego zooma */
	static float _ZOOM_ROTATION_STEP = 0f;

	/** maks rotation focusa */
	static float _MIN_FOCUS_ROTATION = 5f;
	static float _MAX_FOCUS_ROTATION = 30f;
	/** speed rotation focusa */
	static float _MIN_FOCUS_ROTATION_SPEED = 20f;
	static float _MAX_FOCUS_ROTATION_SPEED = 80f;

	/** czas przerwy w obracaniu focusa */
	static float _MIN_STOP_FOCUS_ROTATION_TIME = 2f;
	static float _MAX_STOP_FOCUS_ROTATION_TIME = 4f;

	/** czas przerwy pomiedzy zakloceniami */
	static float _MIN_TIME_BTW_DISORTIONS = 0.1f;
	static float _MAX_TIME_BTW_DISORTIONS = 3f;
	/** czas zaklocenia typu "pojedynczy pasek" */
	static float _DISORTION_TIME = 0.05f;
	/** czas trwania jednej ramki zaklocenia "caly ekran" */
	static float _FRAME_DISORTION_TIME = 0.05f;
	
	static int _MAX_DISORTIONS = 9;
	
    String m_sDisortionSound = "Data/Sounds/BinocularsDistortion.wav";
    String m_sFocusSound = "Data/Sounds/BinocularsFocus.wav";
    
    // id dzwieku zaklocen
    //int m_nDisortionSound = 0;
    int nFocusSound = 0;
    
    Weapon m_cWeaponSniper = null;
    
	/** nazwa tekstury z analogowymi zakloceniami - czteroklatkowy szum */
	String m_Disorder1TexName = "CH_zaklocenia.png";
	/** nazwa tekstury z zakloceniami 2*/
	String m_Disorder2TexName = "CH_zaklocenia2.png";
	/** tekstury zaklocen */
	int m_DisorderTextures[] = null;
	/** sprite'y zaklocen */
	Sprite m_DisorderSprites[] = null;
	int m_iDisorderTexHeight = 32;
	/** czy wyliczyc nastepny czas pojawienia sie zaklocenia */
	boolean m_bUpdateDisortion = true;
	/** kiedy ma byc nastepne pokazanie disortion */
	float m_fNextDisortionTime = 0;
	/** czy jest wyswietlane disortion */
	boolean m_bShowingDisortion	= false;
	/** numer nastepnego zaklocenia */
	int m_iNextDistortionNum = 0;
	/** czas pokazania zaklocenia */
	float m_fDisortionTime = 0;
	/** numer klatki szumu */
	int m_iCurrFrame = 0;
	int m_iFrameTextures[] = new int[4];
	
    final String m_sSniperTextureName = "CH_P_Sniper_base.png";
    /**Drugi typ snajperki*/
    final String m_sSniperHeavyTextureName = "CH_P_Sniper_base2.png";
    
    /** glowny sprite snajperki */
    String m_sBkgTextureName = "";
    float m_fBkgTexSize = 512;
    Sprite m_cBkg = null;
    int m_iBkgTex = 0;
    
    Sprite m_cLeftMargin = null;
    Sprite m_cRightMargin = null;

    int m_nLeftTex = 0;
    int m_nRightTex = 0;
    
	/** obszar aktywny snajperki */
	String m_sActiveFieldTexName = "CH_P_Sniper_Zoom.png";
    Sprite m_cActiveField = null;
    int m_iActiveFieldTex = 0;
	Vector m_vActiveFieldSize = new Vector(256f, 256f, 0);

    /** obszar aktywny snajperki */
	String m_sActiveFieldRotTexName = "CH_P_Sniper_rotate.png";
    Sprite m_cActiveFieldRot = null;
    int m_iActiveFieldRotTex = 0;
	Vector m_vActiveFieldRotSize = new Vector(256f, 256f, 0);
    
	/** obszar aktywny snajperki po zalockowaniu na obiekcie */
	String m_sFocusFieldTexName = "CH_P_Sniper_FocusOn.png";
    Sprite m_cFocusField = null;
    int m_iFocusFieldTex = 0;
	Vector m_vFocusFieldSize = new Vector(128, 128, 0);

	Vector m_vCurrWatchPoint = new Vector();
	float m_fCurrTime = 0;
	float m_fLastUpdateTime = 0;
	
	//boolean m_bIsObjectTracked = false;
	
	float m_fCurrMaxFocusRotation = _MAX_FOCUS_ROTATION;
	float m_fFocusRotation = 0f;
	float m_fFocusRotationSpeed = 10f;
	int m_iFocusRotationDir = 1;
	float m_fStopRotationLen = 0f;
	boolean m_bStopRotation = false;
	float m_fStopRotationTime = 0f;

	HUDAdditionalCompassSniper m_Compass = null;
	
	
    public void OnCreate()
    {
        super.OnCreate();

        if (m_bDisableInNetGame)
            return;
        
        float fBoxSize = GetScreenHeight();
        
        float fMarginSize = (GetScreenWidth() - fBoxSize) / 2.f;
        
        float fScale = fBoxSize/m_fBkgTexSize;
        // glowny sprite
		m_cBkg = (Sprite) CreateObject("Sprite");
		m_cBkg.ProcessMouse(false);
        m_cBkg.SetSize(new Vector(fBoxSize, fBoxSize, 0));
		m_cBkg.SetPos(new Vector(fMarginSize, 0, 0));
		m_cBkg.MoveTop();
		AddSprite(m_cBkg);
        m_cBkg.SetBlendingMode(EBlendingModes.S_BSRC_ONE | EBlendingModes.S_BDST_ONE_MINUS_SRC_ALPHA);//EBlendingModes.S_BLEND_MIX);
        
        
        // lewy
		m_cLeftMargin = (Sprite)CreateObject("Sprite");
		m_nLeftTex = m_cLeftMargin.AddTexture("er_t_black.png", true, false);
        m_cLeftMargin.SetTexture(m_nLeftTex, new Rect(0.01f,0.01f,0.02f,0.02f));
		m_cLeftMargin.ProcessMouse(false);
        m_cLeftMargin.SetSize(new Vector(fMarginSize, fBoxSize, 0));
		m_cLeftMargin.SetPos(new Vector(0, 0, 0));
		m_cBkg.AddChild(m_cLeftMargin);
        m_cLeftMargin.Show();
        
        // prawy
		m_cRightMargin = (Sprite)CreateObject("Sprite");
		m_nRightTex = m_cRightMargin.AddTexture("er_t_black.png", true, false);
        m_cRightMargin.SetTexture(m_nRightTex, new Rect(0.01f,0.01f,0.02f,0.02f));
		m_cRightMargin.ProcessMouse(false);
        m_cRightMargin.SetSize(new Vector(fMarginSize, fBoxSize, 0));
		m_cRightMargin.SetPos(new Vector(fBoxSize + fMarginSize, 0, 0));
		m_cBkg.AddChild(m_cRightMargin);
        m_cRightMargin.Show();
        
		// dodatkowy widok, obracajacy sie przy zoomowaniu
		m_cActiveField = (Sprite) CreateObject("Sprite");
		m_iActiveFieldTex = m_cActiveField.AddTexture(m_sActiveFieldTexName, true, false);
        m_cActiveField.SetTexture(m_iActiveFieldTex, new Rect(0f, 0f, 1f, 1f));
		m_cActiveField.ProcessMouse(false);
        
        m_cActiveField.SetSpriteMaterial("sprite_blend_add_walpha.mat");
        m_cActiveField.SetSize(m_vActiveFieldSize.Mul2(fScale));
        
		m_cBkg.AddChild(m_cActiveField);
        m_cActiveField.Show();
		
        //obracajacy sie jinx
        m_cActiveFieldRot = (Sprite) CreateObject("Sprite");
		m_iActiveFieldRotTex = m_cActiveFieldRot.AddTexture(m_sActiveFieldRotTexName, true, false);
        m_cActiveFieldRot.SetTexture(m_iActiveFieldRotTex, new Rect(0f, 0f, 1f, 1f));
		m_cActiveFieldRot.ProcessMouse(false);
        m_cActiveFieldRot.SetSpriteMaterial("sprite_blend_add_walpha.mat");
        m_cActiveFieldRot.SetSize(m_vActiveFieldRotSize.Mul2(fScale));
		m_cBkg.AddChild(m_cActiveFieldRot);
        m_cActiveFieldRot.Show();
        
		// dodatkowy widok - focus, aktywny gdy celujemy w chromeactora
		m_cFocusField = (Sprite) CreateObject("Sprite");
		m_iFocusFieldTex = m_cFocusField.AddTexture(m_sFocusFieldTexName, true, false);
        m_cFocusField.SetTexture(m_iFocusFieldTex, new Rect(0f, 0f, 1f, 1f));
		m_cFocusField.ProcessMouse(false);
        //m_cFocusField.SetSpriteMaterial("sprite_blend_add_walpha.mat");
        m_cFocusField.SetSize(m_vFocusFieldSize.Mul2(fScale));
		m_cBkg.AddChild(m_cFocusField);

		InitDisortions();
		
		ActivateOnModule();
		PositionHUDComponent(0, 0);
        RegisterKeyRequest();
        
	}

	void SetCompass(HUDAdditionalCompassSniper compass)
	{
		m_Compass = compass;
	}
	
	public void InitWatchPoint()
	{
		m_vCurrWatchPoint.Set( ((float) GetScreenWidth()) / 2f,
							   ((float) GetScreenHeight()) / 2f,
							   0);
	}
	
	void InitDisortions()
	{
		m_DisorderTextures = new int[_MAX_DISORTIONS];
		m_DisorderSprites = new Sprite[_MAX_DISORTIONS];

		// inicjalizacja zaklocen pojedynczych paskow
		for (int i = 0; i < 8; i++)
		{
			m_DisorderSprites[i] = (Sprite) CreateObject("Sprite");
			m_DisorderTextures[i] = m_DisorderSprites[i].AddTexture(m_Disorder2TexName);
			m_DisorderSprites[i].SetTexture(m_DisorderTextures[i],
											new Rect(0f,
													 i * m_iDisorderTexHeight * EHudInvParams._P256,
													 1f,
													 (i + 1) * m_iDisorderTexHeight * EHudInvParams._P256));
			m_DisorderSprites[i].ProcessMouse(false);
			m_DisorderSprites[i].SetPos(new Vector());
			AddSprite(m_DisorderSprites[i]);
	        m_DisorderSprites[i].SetBlendingMode(EBlendingModes.S_BLEND_MIX);
			m_DisorderSprites[i].Hide();
		}
		
		// inicjalizacja zaklocenia sniezenia calego ekranu
		m_DisorderSprites[8] = (Sprite) CreateObject("Sprite");
		m_DisorderTextures[8] = m_DisorderSprites[8].AddTexture(m_Disorder1TexName);
		m_DisorderSprites[8].SetTexture(m_DisorderTextures[8], new Rect(0f, 0f, 1f, 1f));
		m_DisorderSprites[8].ProcessMouse(false);
		m_DisorderSprites[8].SetPos(new Vector());
		AddSprite(m_DisorderSprites[8]);
        m_DisorderSprites[8].SetBlendingMode(EBlendingModes.S_BLEND_MIX);
		m_DisorderSprites[8].Hide();
		
		InitDisortionsSizes();
	}
	
	void InitDisortionsSizes()
	{
		for (int i = 0; i < 8; i++)
	        m_DisorderSprites[i].SetSize(new Vector(GetScreenWidth(), m_iDisorderTexHeight, 0f));
	    m_DisorderSprites[8].SetSize(new Vector(GetScreenWidth(), GetScreenHeight(), 0f));
	}
	
	public void SetStaticText(String text)
	{
		if (m_Compass == null  || m_Compass.m_StaticTextInfo == null)
			return;
		m_Compass.m_StaticTextInfo.DisplayText(text);
	}
	
	public void SetObjectText(String text)
	{
		if (m_Compass == null || m_Compass.m_ObjectTextInfo == null)
			return;
		m_Compass.m_ObjectTextInfo.DisplayText(text);
	}
	
    public void SetWeapon(Weapon cWeapon)
    {
        m_cWeaponSniper = cWeapon;
        
        m_nWeaponId = cWeapon.nInvIndex;
        
        //TODO sprawdzic
        //do potrzeb sieci
        if ( m_cWeaponSniper != null && cPlayer != null )
        {
            m_cWeaponSniper.Owner = cPlayer;
        }
        
        //CrashLog("SetWeapon "+cWeapon+"\n");
        if ( m_cWeaponSniper.Owner instanceof PlayerNetBase )
        {
            m_bDisableInNetGame = ! m_cWeaponSniper.Owner.bNetIsOwner;
            //CrashLog("m_bDisableInNetGame "+m_bDisableInNetGame+"\n");
        }
        
        String sOldTexture = m_sBkgTextureName;
        switch(m_nWeaponId)
        {
            case InvObject._W_RIFLE_SNIPER:
                _ZOOM_ROTATION_STEP = 90 / (cWeapon.cZoomer.GetMaxZoom() - cWeapon.cZoomer.GetBaseZoom());
                m_sBkgTextureName = m_sSniperTextureName;
                break;
            case InvObject._W_RIFLE_SNIPER_HEAVY:
                _ZOOM_ROTATION_STEP = 180 / (cWeapon.cZoomer.GetMaxZoom() - cWeapon.cZoomer.GetBaseZoom());
                m_sBkgTextureName = m_sSniperHeavyTextureName;
                break;
        }
        
        if ((m_iBkgTex != 0) && (m_sBkgTextureName != sOldTexture))
        {
            //teksture podmieniamy tylko przy zmianie snajperki na inna
            m_cBkg.ReleaseTexture(m_iBkgTex);
            m_iBkgTex = 0;
        }
        
        if (m_iBkgTex == 0)
        {
            if (m_cBkg != null)
            {
                m_iBkgTex = m_cBkg.AddTexture(m_sBkgTextureName);
                m_cBkg.SetTexture(m_iBkgTex, new Rect(0,0,1,1));
            }
        }
    }

    public void OnDestroy()
    {
		super.OnDestroy();

        if (m_cActiveField != null)
        {
            if (m_iActiveFieldTex != 0)
                m_cActiveField.ReleaseTexture(m_iActiveFieldTex);
            RemoveSprite(m_cActiveField);
            m_cActiveField.delete();
            m_cActiveField = null;
        }
        if (m_cActiveFieldRot != null)
        {
            if (m_iActiveFieldRotTex != 0)
                m_cActiveFieldRot.ReleaseTexture(m_iActiveFieldRotTex);
            RemoveSprite(m_cActiveFieldRot);
            m_cActiveFieldRot.delete();
            m_cActiveFieldRot = null;
        }
        
        if (m_DisorderSprites != null)    
            for (int i = 0; i < m_DisorderSprites.length; i++)
            {
                if (m_DisorderTextures[i] != 0)
                    m_DisorderSprites[i].ReleaseTexture(m_DisorderTextures[i]);
                RemoveSprite(m_DisorderSprites[i]);
                m_DisorderSprites[i].delete();
                m_DisorderSprites[i] = null;
            }

        if (m_cFocusField != null)
        {
            if (m_iFocusFieldTex != 0)
                m_cFocusField.ReleaseTexture(m_iFocusFieldTex);
            RemoveSprite(m_cFocusField);
            m_cFocusField.delete();
            m_cFocusField = null;
        }
        if (m_cLeftMargin != null)
        {
            m_cLeftMargin.ReleaseTexture(m_nLeftTex);
            RemoveSprite(m_cLeftMargin);
            m_cLeftMargin.delete();
            m_cLeftMargin = null;
        }
        if (m_cRightMargin != null)
        {
            m_cRightMargin.ReleaseTexture(m_nRightTex);
            RemoveSprite(m_cRightMargin);
            m_cRightMargin.delete();
            m_cRightMargin = null;
        }
        
        if (m_cBkg != null)
        {
            if (m_iBkgTex != 0)
                m_cBkg.ReleaseTexture(m_iBkgTex);
            RemoveSprite(m_cBkg);
            m_cBkg.delete();
            m_cBkg = null;
        }
    }

    public void ActivateForMovie()
	{
        if (bActiveFlag)
			return;
        
        if (cHUDManager.GetHUDNiunia() != null)
            ((HUDCompNiunia)cHUDManager.GetHUDNiunia()).CallMethodIn("MoveTop", 0);
        
		super.Activate();
		
		Draw();
    }
    
	public void Activate()
	{
		if (bActiveFlag)
			return;
		if (cHUDManager.m_bIsUserHUDActive)
			return;
		if (!cHUDManager.CanActivate(HUDManager._HUD_SNIPER))
			return;
	
        //printStackTrace("");
        
        if (cHUDManager.GetHUDNiunia() != null)
            ((HUDCompNiunia)cHUDManager.GetHUDNiunia()).CallMethodIn("MoveTop", 0);
        
		super.Activate();
		
		Draw();
	}

	/*public void ActivateByHUD()
    {
		if (bActiveFlag)
			return;
		if (cHUDManager.m_bIsUserHUDActive)
			return;
		if (!cHUDManager.m_bActivateAllowed)
			return;
		
		super.ActivateByHUD();
		
		Draw();
	}*/
	
    public void Draw()
    {
        super.Draw();
        cHUDManager.HintsMoveTop();
    }
    
    public void Deactivate()
    {
		if (!bActiveFlag)
			return;
		
        super.Deactivate();

        //Thread.dumpStack();
        
		RestoreElements();
        
        if(nFocusSound != 0)
        {   
            cPlayer.DetachSound(nFocusSound);
            nFocusSound = 0;
        }
        /*if(m_nDisortionSound!=0)
        {
            cPlayer.DetachSound(m_nDisortionSound);
            m_nDisortionSound = 0;
        }*/
    }

	/*public void DeactivateByHUD()
	{
		if (!bActiveFlag)
			return;
		
        super.DeactivateByHUD();

		RestoreElements();
	}*/
	
	public void DrawDo()
	{
		super.DrawDo();
        
        if (m_cBkg != null)
        {
            m_cBkg.Show();
		
            if(m_Compass != null)
            {
		        m_Compass.SetRelativePosition(2, (int) (-0.139f * GetScreenHeight()));
		        m_Compass.Activate();
            }
        }        
		m_bUpdateDisortion = true;
	}

    /*Vector vTemp = new Vector(5f, 0.5f, 0);
    public void OnInputKey(int nKey, boolean b, char c)
    {
        if (b && bActiveFlag)
            Tools.MovePointByKeys(vTemp, nKey, 0);
        m_Compass.Deactivate();
        m_Compass.nWindowPosX = (int)vTemp.fX;
        //m_Compass.SetRelativePosition((int)vTemp.fX, (int) (vTemp.fY * GetScreenHeight()));
        //m_Compass.m_ObjectTextInfo.SetPos(new Vector(vTemp.fX * 800f, vTemp.fY * 600f, 0));
        m_Compass.Activate();
        Tools.ShowInfoTop("pos " + vTemp + " delta " + Tools.g_fDelta, GetModule());
    }*/
    
	public void RestoreElements()
	{
        if (m_cBkg != null && 
            m_cFocusField != null &&
            m_DisorderSprites != null)
        {
		    m_cFocusField.Hide();		
		    m_cBkg.Hide();

            m_DisorderSprites[m_iNextDistortionNum].Hide();
		
		    if(m_Compass != null) m_Compass.Deactivate();
        }
	}
	
    
    public void OnFrame()
    {
        if (bActiveFlag)
        {
            UpdateHUD();
            UpdateZoomRotation();
        }
    }
    
    /** update'owanie HUDa wolane przez Weapon
     */
    public void UpdateHUD()
    {
        if (m_cWeaponSniper != null && !m_bDisableInNetGame)
        {
			m_fCurrTime = GetTime();
            if (m_fCurrTime - m_fLastUpdateTime < _UPDATE_TIME)
                return;
            ControlObject cTarget = m_cWeaponSniper.GetObjectInSight();
            //m_cWeaponSniper.GetOwnerFireOrigin(), m_cWeaponSniper.GetOwnerFireDir());
            if ( (cTarget instanceof NewAI        || 
                 cTarget instanceof PlayerNetBase) &&
                 !((ChromeActor)cTarget).bDead)
            {
                Pawn cPawn = (Pawn) cTarget;
                if (!cPawn.bDead)
                {
                    if (nFocusSound == 0) 
                        nFocusSound = cPlayer.AttachSound( m_sFocusSound );
                
                    String sText = null;
                    PositionActive((ChromeActor)cTarget);    
				    float fDist = cTarget.GetDistanceTo(cPlayer);
				    fDist *= 0.01f;
				
                    SetObjectText( GetStringFromFloat(fDist, 2) );
                }
            }
            else
            {
                if (nFocusSound != 0)
                {
                    cPlayer.DetachSound( nFocusSound );
                    nFocusSound = 0;
                }
                
                SetObjectText("");
                PositionActive(null);
            }
            
			UpdateDisortion();
			
			m_fLastUpdateTime = m_fCurrTime;
        }
    }

	void UpdateDisortion()
	{
		// sprawdzamy, czy nalezy wyliczyc, kiedy ma byc nowe zaklocenie
		if (m_bUpdateDisortion)
		{
			m_fNextDisortionTime = m_fCurrTime + GameObject.RandomFloat(_MIN_TIME_BTW_DISORTIONS,
																		_MAX_TIME_BTW_DISORTIONS);
			m_iNextDistortionNum = GameObject.RandomInt(9);
			m_bUpdateDisortion = false;
			m_DisorderSprites[m_iNextDistortionNum].SetAlpha(GameObject.RandomFloat(0.1f, 0.5f));
			if (m_iNextDistortionNum != 8)
			{
				m_DisorderSprites[m_iNextDistortionNum].SetPos(new Vector(0f,
																		  GetScreenHeight() * GameObject.RandomFloat(1f),
																		  0f));
			}
			else
			{
				// jezeli ma byc zaklocenie sniezenia calego ekranu, ustalamy pierwsza klatke tekstury
				m_iCurrFrame = 0;
				SetDisortionAnimTexture(m_iCurrFrame);
                
                //if(m_nDisortionSound!=0) 
                  //  cPlayer.DetachSound(m_nDisortionSound);
                //m_nDisortionSound = cPlayer.AttachSound(m_sDisortionSound);
                cPlayer.AttachOneShotSound(m_sDisortionSound);
			}
		}
		else
		{
			if (m_iNextDistortionNum != 8)
			{
				if (m_fCurrTime > m_fNextDisortionTime)
				{
					if (m_bShowingDisortion)
					{
						if (m_fDisortionTime + _DISORTION_TIME > m_fCurrTime)
							return;
						// wylaczamy zaklocenie
						m_DisorderSprites[m_iNextDistortionNum].Hide();
						m_bShowingDisortion = false;
						m_bUpdateDisortion = true;
                        
                        //if(m_nDisortionSound != 0) 
                          //  cPlayer.DetachSound(m_nDisortionSound);
					}
					else
					{
						// wlaczamy zaklocenie
						m_bShowingDisortion = true;
						m_DisorderSprites[m_iNextDistortionNum].Show();
						m_fDisortionTime = m_fCurrTime;
                        
                        //if(m_nDisortionSound != 0) 
                            //cPlayer.DetachSound(m_nDisortionSound);
                        //m_nDisortionSound = cPlayer.AttachSound(m_sDisortionSound);
                        cPlayer.AttachOneShotSound(m_sDisortionSound);
					}
				}
			}
			else
			{
				// sterujemy odtwarzaniem klatek
				if (m_bShowingDisortion)
				{
					if (m_fDisortionTime + _FRAME_DISORTION_TIME > m_fCurrTime)
						return;
					m_fDisortionTime = m_fCurrTime;
					if (m_iCurrFrame == 3)
					{
						m_DisorderSprites[m_iNextDistortionNum].Hide();
						m_bShowingDisortion = false;
						m_bUpdateDisortion = true;
						return;
					}
					
					// zwiekszamy numer klatki
					m_iCurrFrame++;
					SetDisortionAnimTexture(m_iCurrFrame);
				}
				else
				{
					// wlanczamy sniezenie
					m_bShowingDisortion = true;
					m_DisorderSprites[m_iNextDistortionNum].Show();
                    
                    //if(m_nDisortionSound!=0) 
                      //  cPlayer.DetachSound(m_nDisortionSound);
				}
			}
		}
	}
	
	void SetDisortionAnimTexture(int iTexture)
	{
		m_DisorderSprites[8].SetTexture(m_DisorderTextures[8],
										new Rect(0f,
												 iTexture * 128f * EHudInvParams._P512,
												 1f,
												 (iTexture + 1) * 128f * EHudInvParams._P512));
		m_DisorderSprites[8].SetAlpha(0.1f);
	}
	
	static String GetStringFromFloat(float fValue, int iDigitsAfterDot)
	{
		int iBeforeDot = (int) fValue;
		
		if (iDigitsAfterDot == 0)
			return ("" + iBeforeDot);
		
		float fAfterDot = fValue - iBeforeDot;
		fAfterDot *= (float) java.lang.Math.pow(10, iDigitsAfterDot);
		
		return ("" + iBeforeDot + "." + ((int) fAfterDot));
	}
	
	public void PositionActive(ChromeActor actor)
	{
        if (actor == null)
		{
			m_cFocusField.Hide();
		}
		else
		{
			m_cFocusField.Show();
		}
		
        float fInitialZoom = 0;
		// ustawiamy kolka w zaleznosci od zooma
		float fZoomRotation = ( m_cWeaponSniper.cZoomer.GetZoom() -
							    m_cWeaponSniper.cZoomer.GetBaseZoom()) * _ZOOM_ROTATION_STEP;
        /*CrashLog("Zoom " + m_cWeaponSniper.cZoomer.GetZoom() +
                 " i zoom " + m_cWeaponSniper.cZoomer.fInitialZoom + 
                 " ZoomRotation " + fZoomRotation);*/
		//m_cActiveField.SetRotation(fZoomRotation);
        SetZoomRotation(fZoomRotation);
        SetFocusRotation();
	}
	
	void SetFocusRotation()
	{
		if (m_bStopRotation)
		{
			StartRotatingFocus();
			return;
		}
									 
		m_fFocusRotation += m_iFocusRotationDir * (m_fCurrTime - m_fLastUpdateTime) *
							m_fFocusRotationSpeed;
		
		if (m_iFocusRotationDir < 0)
		{
			if (m_fFocusRotation < -m_fCurrMaxFocusRotation)
			{
				m_fFocusRotation = -m_fCurrMaxFocusRotation;
				ReverseTurn();
		
				StopRotatingFocus();
			}
		}
		else
		if (m_iFocusRotationDir > 0)
		{
			if (m_fFocusRotation > m_fCurrMaxFocusRotation)
			{
				m_fFocusRotation = m_fCurrMaxFocusRotation;
				ReverseTurn();
				
				StopRotatingFocus();
			}
		}
		m_cActiveFieldRot.SetRotation(m_fFocusRotation);
	}
	
	void ReverseTurn()
	{
		m_fCurrMaxFocusRotation = GameObject.RandomFloat(_MIN_FOCUS_ROTATION,
														 _MAX_FOCUS_ROTATION);
		m_fFocusRotationSpeed = GameObject.RandomFloat(_MIN_FOCUS_ROTATION_SPEED,
													   _MAX_FOCUS_ROTATION_SPEED);
		m_iFocusRotationDir *= -1;
	}
	
	void StopRotatingFocus()
	{
		if (!m_bStopRotation)
		{
			if (GameObject.RandomFloat(1f) < 0.3f)
			{
				m_bStopRotation = true;
				m_fStopRotationLen = GameObject.RandomFloat(_MIN_STOP_FOCUS_ROTATION_TIME,
															_MAX_STOP_FOCUS_ROTATION_TIME);
				m_fStopRotationTime = m_fCurrTime;
			}
		}
	}
	
	void StartRotatingFocus()
	{
		if (!m_bStopRotation)
			return;
		if (m_fStopRotationTime + m_fStopRotationLen < m_fCurrTime)
			m_bStopRotation = false;
	}
	
	public void PositionHUDComponent(int relX, int relY)
	{
		super.PositionHUDComponent(relX, relY);
		
		m_cActiveField.SetPos( new Vector( (GetScreenWidth() - m_cActiveField.GetSize().fX) / 2f,
										  (GetScreenHeight() - m_cActiveField.GetSize().fY) / 2f,
										  0f) );
        
        m_cActiveFieldRot.SetPos( new Vector( (GetScreenWidth() - m_cActiveField.GetSize().fX) / 2f,
										  (GetScreenHeight() - m_cActiveField.GetSize().fY) / 2f,
										  0f) );
            
		m_cFocusField.SetPos( new Vector( (GetScreenWidth() - m_cFocusField.GetSize().fX) / 2f,
										 (GetScreenHeight() - m_cFocusField.GetSize().fY) / 2f,
										 0f) );
		
		InitDisortionsSizes();
	}
	
    float m_fZoomRotation = 0;
    float m_fDestZoomRotation = 0;
    float m_fLastZoomRUpdateTime = 0;
    float m_fZoomRotationSpeed = 270;
    void SetZoomRotation(float fRotation)
    {
        m_fDestZoomRotation = fRotation;
    }
    
    void UpdateZoomRotation()
    {
        float fTime = GetTime();
        
        float fTimeDelta = fTime - m_fLastZoomRUpdateTime;
        if (m_fZoomRotation > m_fDestZoomRotation)
        {
            m_fZoomRotation -= m_fZoomRotationSpeed * fTimeDelta;
            
            if (m_fZoomRotation < m_fDestZoomRotation)
                m_fZoomRotation = m_fDestZoomRotation;
        }
        else
        {
            if (m_fZoomRotation < m_fDestZoomRotation)
            {
                m_fZoomRotation += m_fZoomRotationSpeed * fTimeDelta;
                
                if (m_fZoomRotation > m_fDestZoomRotation)
                    m_fZoomRotation = m_fDestZoomRotation;
            }
        }
        m_cActiveField.SetRotation(m_fZoomRotation);
        m_fLastZoomRUpdateTime = fTime;
    }

    public void SGUpdate()
    {
        //nie chcemy przywracac snajperki
        bActiveFlagSG = false;
        super.SGUpdate();
        m_fCurrTime = GetTime();
        m_fLastZoomRUpdateTime = m_fCurrTime;
        m_fLastUpdateTime = m_fCurrTime;
    }

    
    public void OnAudioReinitialize()
    {
        
        if(nFocusSound != 0) 
            nFocusSound = cPlayer.AttachSound(m_sFocusSound);

    }
    
}


