/** klasa reprezentujaca definiowalny timer na hudzie
 */
public class HUDTimer extends HUDComponent
{
	static String _BUTTON_CLICK = "Data/Sounds/Menu/Bong.wav";
	
    UIStatic m_TimerTimeText = null;
    
	int m_SecondsTable[] = {15, 30, 60, 180, 300, 600};
	int m_iCurrSetting = 0;
	
	Explosive m_Explosive = null;

    public void OnInit()
    {
        super.OnInit();
        m_TimerTimeText = (UIStatic)GetElem("ID_TIME");
    }
    
    public void OnCreate()
    {
        super.OnCreate();   
        
        Load(GetModule(), "data/hud/HUDTimer.scr", false);
        // inicjalizcja kursora
		cCursor = (Cursor) CreateObject("Cursor");
		cCursor.SetCursorTex(cModule, sCursorTex);
		cCursor.Hide();
        
		PositionHUDComponent(0, 0);
    }
	
    public void OnDestroy()
    {
		super.OnDestroy();
				
        //Log("[HUDTimer.OnDestroy]: Destroing DONE. \n");
    }
      
	public void SetExplosive(Explosive explosive)
	{
		m_iCurrSetting = 0;
		SetTimeText(m_SecondsTable[m_iCurrSetting]);
		m_Explosive = explosive;
	}

	public float GetCurrTimer()
	{
		return m_SecondsTable[m_iCurrSetting];
	}
	
	public void SetTimer(int iTableNo)
	{
		m_iCurrSetting = iTableNo;
		if (m_iCurrSetting < 0)
			m_iCurrSetting = 0;
		if (m_iCurrSetting >= m_SecondsTable.length)
			m_iCurrSetting = m_SecondsTable.length - 1;
		
		SetTimeText(m_SecondsTable[m_iCurrSetting]);
	}
	
	public void SetTimeText(int iSeconds)
	{
		LogLine("iSeconds:" + iSeconds);
		int iMinutes = iSeconds / 60;
		int iSecondsLeft = iSeconds - iMinutes * 60;
		String text = "";
		if (iMinutes < 10)
			text += "0";
		text += iMinutes + ":";
		if (iSecondsLeft < 10)
			text += "0";
		text += iSecondsLeft;
		m_TimerTimeText.SetText(text);
	}
	
    public void Activate()
    {
		if (bActiveFlag)
			return;
		if (cHUDManager.m_bIsUserHUDActive)
			return;
		if (!cHUDManager.CanActivate(HUDManager._HUD_TIMER))
			return;
		
        super.Activate();   

        SetFocus(false);
        
		cHUDManager.m_bIsUserHUDActive = true;
		
        cHUDManager.HudMenuActivated(HUDManager._HUD_TIMER);
        
		Draw();
    }
	
    public void Deactivate()
    {
		if (!bActiveFlag)
			return;
		
        super.Deactivate();   
		
		HideAll();
		
        
		cHUDManager.m_bIsUserHUDActive = false;
		
		cHUDManager.HudMenuDeactivated(HUDManager._HUD_TIMER);
    }
	
	public void HideAll()
	{
		Hide();
		cCursor.Hide();
	}
	
    public void DrawDo()
    {
	    if (bActiveFlag)
        {
            Show();
            cCursor.Show();
			cCursor.MoveTop();
        }
    }
	
    void OnUICommand(UIWindow cSender, int nCommand)
	{
		super.OnUICommand(cSender,nCommand);
		
		if(nCommand == EUIConst.CM_CLICK || nCommand == EUIConst.CM_DBCLICK)
        {
            if (cSender.m_sId.equals("ID_SET"))
            {
		    	Deactivate();
		    	m_Explosive.SetTimer(GetCurrTimer());
		    	PlaySound(_BUTTON_CLICK);
		    }
		
		    if (cSender.m_sId.equals("ID_MINUS"))
		    {
		    	SetTimer(m_iCurrSetting - 1);
		    	PlaySound(_BUTTON_CLICK);
		    }
		
		    if (cSender.m_sId.equals("ID_PLUS"))
		    {
		    	SetTimer(m_iCurrSetting + 1);
		    	PlaySound(_BUTTON_CLICK);
		    }
		
		    if (cSender.m_sId.equals("ID_CANCEL"))
		    {
		    	Deactivate();
		    	m_Explosive.Disarm();
		    	PlaySound(_BUTTON_CLICK);
		    }
        }
	}
    
	public void PositionHUDComponent(int relX, int relY)
	{
		super.PositionHUDComponent(relX, relY);
	}
}

