public class ImplantDescriptionWindow extends UIStatic
{
	static int _CHARS_PER_SECOND = 120;
	static float _CALL_TIME = 0.01f;
	static int _SIZE_X = 150; 
	static int _SIZE_Y = 100; 
	static String m_ShowSound = "Data/Sounds/menu/showline.wav";
	
	String m_DescriptionText = null;
	String m_DisplayText = null;
	int m_iTextIndex = 0;
	float m_fLastFrameTime = 0f;
	
	void DisplayDescriptionText(String text)
	{
		m_fLastFrameTime = GetTime();
		m_iTextIndex = 0;
		m_DisplayText = new String("");
		m_DescriptionText = new String(text);
		CallMethodEvery("DisplayMore", _CALL_TIME);
		Show();
	}
	
	public void DisplayMore()
	{
		if (m_DescriptionText != null)
		{
			float fCurrTime = GetTime();
			int iCharsToAdd = (int) ((fCurrTime - m_fLastFrameTime) * (float) _CHARS_PER_SECOND);

			if (iCharsToAdd == 0)
				return;
			
			m_fLastFrameTime = fCurrTime;
			
			if (m_iTextIndex + iCharsToAdd > m_DescriptionText.length())
			{
				DisableCallMethod("DisplayMore");
				iCharsToAdd = m_DescriptionText.length() - m_iTextIndex;
			}
			
			m_DisplayText += m_DescriptionText.substring(m_iTextIndex, m_iTextIndex + iCharsToAdd);
			SetText(m_DisplayText);
			m_iTextIndex += iCharsToAdd;
			
			PlaySound(m_ShowSound);
			
		}
	}
	
	void HideWindow()
	{
		DisableCallMethod("DisplayMore");
		SetText("");
		m_DisplayText = null;
		Hide();
	}
}
