/** klasa reprezentujaca implant
 */
public class Implant
{
    //TODO trzeba to ustawiac!!!
    boolean bNetIsOwner = true;
    
    /** nazwa implantu */
    String m_sName = "Implant";
    
    /** opis dzialania implantu */
    String m_sInfo = "";
    
    int m_nHint = -1;

    boolean m_bShowHint = false;
    
    /**Dzwiek podlaczany w menu przy ogladaniu implanta*/
    String m_sMenuSound = null;
    
    /**Mesh d3 w menu implantow*/
    String m_sMeshName = null;
    
    /**Pozycja mesha w menu implantow*/
    Vector m_vMeshPos = null;
    
    /**Parametry kamery w menu implantow
     * m_fDistFromPoint
	 * m_fDestCamAngleH
	 * m_fDestCamAngleV z ImplantModule*/
    Vector m_vCamParams = null;

    /** Gracz do ktorego przypiety jest implant */
    Player m_Player = null;
    
    /** flaga mowiaca czy jest aktywny */
    boolean m_bActiveFlag = false;
    
    /** flaga mowiaca czy implant jest DISABLED */
    boolean m_bDisabled = true;
    
    /** o ile procent / sek wzrasta przeladowanie systemu nerwowego */
    float m_fOverload = 0.0f;

    float m_fMaxWorkingTime = 0.0f;
    
	/** postep asymilacji */
	float m_fCurrAssimilation = 0.0f;
	
	/** szybkosc asymilacji */
	float m_fAssimilationSpeed = 0.0f;
    
    /**Czy system implantow dziala*/
    boolean m_bImplantSystemWorking = true;
	
    java.util.Vector m_vAssimilationThresholds = new java.util.Vector();
    
    /**Tekstury ikon, ikona normalna jest ladowana ze skryptu, disabled i aktywna sa
     * generowane na jej podstawie (na teksturze sa na okreslonych pozycjach)*/
    UITexture   m_cIconNormal   = null,
                m_cIconDisabled = null,
                m_cIconActive   = null;
    static float    _ICON_WIDTH = -1;
    
    boolean bPlayerCanActivate = true;
    
    ChromeModule cModule = null;
    
    public void OnCreate()
    {
    }
	
    public void OnDestroy()
    {
    }
    
    /**Inicjacja implantu, musi byc juz ustalona asymilacja i w efekcie aktualny prog,
     * nalezy ja pokryc we wszystkich implantach i ustalic im jak maja sie zmieniac pod
     * wplywem asymilacji*/
    void ReinitImplantParams()
    {
        int nThreshold = GetCurAssimilationThreshold();
        float fThresholdAssim = GetAssimilationThreshold(nThreshold);
        ImplantSystem cImplantSystem = m_Player.GetImplantSystem();
        
        m_fOverload = 100f / (fThresholdAssim * m_fMaxWorkingTime);// + cImplantSystem.m_fNaturalOverloadReduction/100f; 
    }
    
    
    /** aktywacja implantu */
    public boolean Activate()
    {
		if (m_bDisabled || !m_bImplantSystemWorking || !bNetIsOwner || m_bActiveFlag)
			return false;
        m_bActiveFlag = (m_Player != null);
        
        if (m_Player instanceof PlayerNet &&
            m_Player.bDead) 
        {
            //Tools.CrashLogError("Trying to activate an implant " + this + " for a dead player ");
            //Thread.dumpStack();
            return false;
        }
        
		return m_bActiveFlag;
    }
	
    /** deaktywacja implantu */
    public void Deactivate()
    {
        //TODO: zapewnic jednokrotne wylaczanie
        if (m_bImplantSystemWorking &&  bNetIsOwner)
        {
            m_bActiveFlag = false;   
        }
    }
	
	public float Update(float fTime)
	{
		if (!m_bActiveFlag)
			return 0;
		return fTime * m_fOverload;
	}
	
	public void SetAssimilation(float fValue)
	{
		m_fCurrAssimilation = fValue;
		if (m_fCurrAssimilation < 0)
			m_fCurrAssimilation = 0;
		if (m_fCurrAssimilation > 1)
			m_fCurrAssimilation = 1;
        //czy wyskoczylismy ponad prog dzialania?
		if (GetCurAssimilationThreshold() > 0)
		{
			m_bDisabled = false;
			m_bActiveFlag = false;
		}
        ReinitImplantParams();
	}
	
	public boolean IsActive()
	{
		return m_bActiveFlag;
	}

	public boolean IsDisabled()
	{
		return m_bDisabled;
	}
            
    void SetPlayer( Player player )
    {
        m_Player = player;
    }
    
    void Load(ParseKeyword Root)
    {
        ParseKeyword Key, SubKey, SubSubKey;
        String sImplantName = Root.GetSParam(1);
        m_sName = Text.Get("&" + sImplantName + "&");
        m_sInfo = Text.Get("&" + Root.GetSParam(2) + "&");
        //CrashLog("Loading " + this + " " + m_Name);
        for (SubKey = Root.GetChild(); SubKey != null; SubKey = SubKey.GetNext())
		{
            if (SubKey.Equals("TimeToOverload"))
                m_fMaxWorkingTime = SubKey.GetFParam(0);
                
            if (SubKey.Equals("MeshName"))
                m_sMeshName = SubKey.GetSParam(0);
                
            if (SubKey.Equals("MeshPos"))
                m_vMeshPos = new Vector(SubKey.GetFParam(0), SubKey.GetFParam(1), SubKey.GetFParam(2));
                    
            if (SubKey.Equals("CameraParams"))
                m_vCamParams = new Vector(SubKey.GetFParam(0), SubKey.GetFParam(1), SubKey.GetFParam(2));
                
            if (SubKey.Equals("MenuSound"))
                m_sMenuSound = SubKey.GetSParam(0);
            
            if (SubKey.Equals("Assimilation"))
            {
                for (SubSubKey = SubKey.GetChild(); SubSubKey != null; SubSubKey = SubSubKey.GetNext())
                {
                    if (SubSubKey.Equals("Threshold"))
                        m_vAssimilationThresholds.addElement(new Float(SubSubKey.GetFParam(0)));
                }
            }
            if (SubKey.Equals("IconNormal"))
            {
                m_cIconNormal = new UITexture(SubKey.GetSParam(0), //nazwa tekstury
                                              SubKey.GetIParam(1), SubKey.GetIParam(2), //rozmiar tekstury
                                              SubKey.GetIParam(3), SubKey.GetIParam(4),//lewy gorny
                                              SubKey.GetIParam(5), SubKey.GetIParam(6));//prawy dolny rog
                _ICON_WIDTH = m_cIconNormal.m_rRect.fRight - m_cIconNormal.m_rRect.fLeft;
                                                                                     
            }
                    
        }
    }
    
    /**Zwraca aktualny prog asymilacji*/
    int GetCurAssimilationThreshold()
    {
        for (int i = 0; i < m_vAssimilationThresholds.size(); i++)
        {
            if (m_fCurrAssimilation < ((Float)m_vAssimilationThresholds.elementAt(i)).floatValue())
                return i;
        }
        return GetAssimilationThresholdsCount();
    }
    
    /**Zwraca wartosc asymilacji dla danego progu (konkretnie gdzie zaczyna sie dany poziom
     * asymilacji)*/
    float GetAssimilationThreshold(int nThreshold)
    {
        if (nThreshold > 0)
            return ((Float)m_vAssimilationThresholds.elementAt(nThreshold - 1)).floatValue();
        else
            return ((Float)m_vAssimilationThresholds.elementAt(0)).floatValue();
    }   
    
    /**Zwraca ilosc progow asymilacji*/
    int GetAssimilationThresholdsCount()
    {
        return m_vAssimilationThresholds.size();
    }
    
    void Masta()
    {
        SetAssimilation(1);
        m_fOverload = 0;
    }
    
    UITexture GetIconNormal()
    {
        return m_cIconNormal;
    }
    
    UITexture GetIconDisabled()
    {
        if (m_cIconDisabled == null)
        {
            m_cIconDisabled = new UITexture(m_cIconNormal.m_sFileName, 
                                            m_cIconNormal.m_fWidth,
                                            m_cIconNormal.m_fHeight,
                                            m_cIconNormal.m_rRect.fLeft + 2*_ICON_WIDTH,
                                            m_cIconNormal.m_rRect.fTop,
                                            m_cIconNormal.m_rRect.fRight + 2*_ICON_WIDTH,
                                            m_cIconNormal.m_rRect.fBottom);
        }
        return m_cIconDisabled;
    }
    
    UITexture GetIconActive()
    {
        if (m_cIconActive == null)
        {
            m_cIconActive = new UITexture(m_cIconNormal.m_sFileName, 
                                            m_cIconNormal.m_fWidth,
                                            m_cIconNormal.m_fHeight,
                                            m_cIconNormal.m_rRect.fLeft + _ICON_WIDTH,
                                            m_cIconNormal.m_rRect.fTop,
                                            m_cIconNormal.m_rRect.fRight + _ICON_WIDTH,
                                            m_cIconNormal.m_rRect.fBottom);
        }
        return m_cIconActive;
    }
    
    public void SGUpdate()
	{
        //super.SGUpdate();
    }
}
