/** klasa reprezentujaca posiadane przez gracza lub AI przedmioty
 */
public class Inventory extends GameObject
	
{

/////////////////////////////
// atrybuty
////////////////////////////
    
    /** rozne rodzaje grida
	 
    final static int _LEG_L_GRID  =  0;
    final static int _LEG_R_GRID  =  1;
    final static int _BELT_L_GRID =  2;
    final static int _BELT_R_GRID =  3;
	final static int _ARM_GRID    =  4; 
	final static int _BELT_M_GRID =  5;
    final static int _MAIN_GRID   =  6;
    final static int _ARMORY_GRID =  8;*/
    final static int    _SLOT_01 = 0,
                        _SLOT_02 = 1,
                        _SLOT_03 = 2,
	                    _SLOT_04 = 3,
	                    _SLOT_05 = 4,
	                    _SLOT_06 = 5,
	                    _SLOT_07 = 6,           
                        _SLOT_MISSION = 7;
    final static int    _AI_GRID     =  8;
	/** wektor przedmiotow znajdujacych sie w inventory
	 */
	java.util.Vector aInvObjects = new java.util.Vector(10); // SG
    
    /**posiadacz inventory
     */
    Pawn Owner = null; // SG
    
    /** tablica gridow plecaka gracza
	 */
	InvGrid aInvGrids[]	= null; // SG
    
    /** aktualna rzecz trzymana przez gracza w rekach
     */
    boolean bGridInited = false;
	
    /** numer indeksu aktualnie ustawionego przedmiotu do uzywania
     */
    int nActualUsableObjIdx = -1; // SG
    
    /** referencja do aktualnie ustwionego przedmiotu do uzycia 
     */
    InvObject cActualUsableInvObj = null;

	/** flaga mowiaca czy to inventory jest aktywne (pokazane)
	 */
	boolean bActive = false; // SG
    
    /** Metoda updejtuje wszystkie informacje w calym inventory zwiazane ze zmiana 
     * wlasciciela inventory
     */
    void Acquire(Module mod, Pawn owner)
    {
        LogD("\n");

        // updejtujemy
        Owner = owner;
        
        if(mod == null) return;
        
        // wlaczamy obiektowi modul gracza
        mod.AcquireObjectModule(this);
        
        if(aInvObjects != null)
        {
            LogD("aInvObjects.length"+ aInvObjects.size() +"\n");
            for(int i=0; i<aInvObjects.size(); i++)
            {
                InvObject cObject = (InvObject)aInvObjects.elementAt(i);
                //if (!cObject.bMissionCritical)
                    cObject.Acquire(mod, owner);
                /*else
                    RemoveObject(cObject);*/
            }
        }
        
        // ustawienie tego spowoduje, ze przy nastepny pokazaniu
        // inventory w graczu przeinicjalizuja sie pozycje gridow
        bGridInited = false;
/*
        if(cInvHands != null)
            cInvHands.Acquire(mod, owner);
        
        // wkladam rzecz nowemu wlascicielowi zgodnie ze stanem cInvHands
        PutInvObjInHands(cInvHands);
*/        
    }
    
    void Unacquire()
    {
        if(aInvObjects != null)
            for(int i=0; i<aInvObjects.size(); i++)
            {
                ((InvObject)aInvObjects.elementAt(i)).Unacquire();
            }
    }
    
//-------------------------------------------------------------------	
	 public void OnCreate()
	 {
         // TO NIE ZAPISUJE SIE W SAVE'A SAMO Z SIEBIE!
		 bSG = false;
	 }

//-------------------------------------------------------------------
	/** metoda inicjalizujaca wywolywana po konstruktorze
	 */
	public void Initialize()
	{
	}
    
    public void InitInvGrid(UIWindow cInvWindow)
    {
        for (int i=0; i<aInvGrids.length; i++)
        {
            aInvGrids[i].InitializeGrid(i, cInvWindow);
        }
        bGridInited = true;
    }
    
    
    //-------------------------------------------------------------------
    /** metoda zwracajace liczbe obiektow w inventory
     */
    public int GetInvObjSize()
    {
        return aInvObjects.size();
    }
    
    //-------------------------------------------------------------------
    /** 
	 */
	public InvGrid GetInvGrid(int nGrid)
	{
        if ((nGrid < aInvGrids.length) &&
            (nGrid >= 0)
           )
            return aInvGrids[nGrid];
        else
            return null;
	}
    
    
//-------------------------------------------------------------------
    /** dodawanie przedmiotu do inventory
	 * @return true jesli dodanie powidlo, false jesli nie ma juz miejsca
	 */
	public boolean AddInvObject(InvObject InvObj)
	{
        return InternalAddInvObject(InvObj, EInventoryAddMode._DEFAULT );
    }


//-------------------------------------------------------------------
    /** dodawanie przedmiotu do inventory
	 * @return true jesli dodanie powidlo, false jesli nie ma juz miejsca
	 */
	public boolean AddInvObjectNearest(InvObject InvObj)
	{
        return InternalAddInvObject(InvObj, EInventoryAddMode._NEAREST_CELL );
    }
    
    /** dodawanie przedmiotu do inventory
	 * @return true jesli dodanie powiodlo, false jesli nie ma juz miejsca
	 */
	public boolean AddInvObjectInPlace(InvObject InvObj)
	{
        return InternalAddInvObject(InvObj, EInventoryAddMode._GIVEN_PLACE );
    }

//-------------------------------------------------------------------
    /** dodawanie przedmiotu do inventory. funkcja prywatna klasy.
	 * @return true jesli dodanie powidlo, false jesli nie ma juz miejsca
	 */
    private boolean InternalAddInvObject(InvObject InvObj, int nMode)
	{
        //amunicje dodajemy inaczej
        if (InvObj.nInvType == EInvObjType._AMMO)
        {
            if (AddAmmo((Ammo)InvObj) == null)
            {
                //amunicja zmiescila sie w istniejacym pudelku
                //AddAmmo usunelo obiekt InvObj
                Owner.CountAmmo();
                return true;
            }
            else
            {
                //trzeba dodac pudelko
                //wiec dalszy kod to zalatwi
            }
                
        }
        
		if (IsFreeSpaceInInv(InvObj) || InvObj.bMissionCritical || InvObj.bHidden || InvObj.bHiddenButUsable)
		{
            int i = 0;
            for (i = 0; i < aInvObjects.size(); i++)
            {
                InvObject cObj = (InvObject)aInvObjects.elementAt(i);
                if (cObj == InvObj)
                {
                    //Tools.CrashLogWarning(this + " is already in inventory");
                    return true;
                }
                //najpierw elementy o nizszym typie, gdy ten sam typ to liczy sie nInvIndex
                if ((cObj.nInvType == InvObj.nInvType) &&
                    (InvObj.nInvIndex <= cObj.nInvIndex) &&
                    aInvObjects.indexOf(InvObj) == -1)
                {
                    aInvObjects.insertElementAt(InvObj, i); 
                    break;
                }
            }
            //jesli w petli sie nie dodalo
    		if (i == aInvObjects.size()&&
                aInvObjects.indexOf(InvObj) == -1)
            {
                aInvObjects.addElement( (InvObject)InvObj );
            }

            Vector cellGrid = null;

            if (!InvObj.bMissionCritical && !InvObj.bHidden && !InvObj.bHiddenButUsable)
            {
                // szukam miejsca
                switch (nMode)
                {
                case EInventoryAddMode._NEAREST_CELL:
                    cellGrid = FindNearestCellGrid( InvObj.cInvObjSprite.cActualSpritePos, InvObj);
                    break;
                    
                case EInventoryAddMode._GIVEN_PLACE:
                    cellGrid = InvObj.GetCurrentPlace();
                    break;
                        
                case EInventoryAddMode._DEFAULT:
                default:
                    cellGrid = FindCellGrid(InvObj);
                    break;
                }
            }
            else
            {
                if (InvObj.bMissionCritical)
                    cellGrid = FindCellGridMission(InvObj);
                else
                    if (InvObj.bHidden || InvObj.bHiddenButUsable)
                        cellGrid = null;
            }

            InvObj.Owner = Owner;
            
            // nadaje przynaleznosc do tego inventory
            InvObj.SetInventory(this);
            
            // ustawiam obiekt
            if (cellGrid != null)
            {
                InvObj.SetInvObjCellsGrid((byte)cellGrid.fX,
									  (byte)cellGrid.fY,
									  (byte)cellGrid.fZ);
        
                // zaznaczam zajete miejsce
			    aInvGrids[(int)cellGrid.fZ].SetTakenCells((byte)cellGrid.fY, 
													  InvObj.nCellsHeight,
													  (byte)cellGrid.fX,
													  InvObj.nCellsWidth); 
            }
            else
            {
                InvObj.SetInvObjCellsGrid((byte)-1,(byte) -1, (byte)-1);
            }
            // FIXIT updejtujemy amunicje
            Owner.CountAmmo();
            
            if(bActive)
            {
                InvObj.cInvObjSprite.ProcessMouse(true);
                InvObj.Draw();
                
            }
            UpdateActualObjCounter();
			return true;
		}
		else
		{
            LogLine("IsFreeSpaceInInv(InvObj) failed\n");
            UpdateActualObjCounter();
			return false;
		}
    }    
    
//-------------------------------------------------------------------
    /** deaktywacja przedmiotu w inventory 
     */
    public boolean RemoveDrugFromInventory(InvObject iObj)
    {
        for (int i=0; i<aInvObjects.size(); i++)
        {
            InvObject InvObj = (InvObject)aInvObjects.elementAt(i);
            
            if (InvObj == iObj)
            {
                aInvObjects.removeElementAt(i); 
                iObj.OnRemoveFromInventory();
                //-- trzeba obsluzyc sytuacje gdy wyrzucamy aktualnie ustawiony do wyrzucenia przedmiot
                if ((cActualUsableInvObj!= null) && (iObj == cActualUsableInvObj))
                {
                    InvObject cPrevActual = cActualUsableInvObj;
                    SetNextUsableInvObj(true);
                    if (cPrevActual == GetActualUsableInvObj())
                        cActualUsableInvObj = null;
                    
                    try
                    {
                        PlayerHUD player = (PlayerHUD)Owner;
                        if ((player.HUD!=null) && (player.HUD.aHUDComponent[player.HUD._PLAYER_DATA]!=null))
                        {
                            HUDCompPlayer hudInvUse = (HUDCompPlayer)player.HUD.aHUDComponent[player.HUD._PLAYER_DATA];  
                            hudInvUse.ShowUsableInvObj(cActualUsableInvObj, EGameControl.ITEM_NEXT);
                        }
                        
                    }
                    catch (Exception ex)
                    {
                        Log("[Inventory.RemoveInvObj]: Usuwanie przedmiotu z inventory nie nalezacego do PlayerHUDa \n" );
                    }
                    
                }
                //-------------------------------------------------------------------------------------
                InvObj.Hide();
                InvObj.cInvObjSprite.ProcessMouse(false);
                
                InvGrid cGrid = GetInvGrid(InvObj.nGrid);
                if(cGrid != null)
                {
                    cGrid.SetFreeCells(InvObj.nCellY,
                                       InvObj.nCellsHeight,
                                       InvObj.nCellX,
                                       InvObj.nCellsWidth);
                }
                else
                {
                    LogR("WARNING RemoveDrugFromInventory: obiekt " + InvObj + " nie ma grida!!!");
                }
                
                // ten obiekt nie nalezy juz do tego inventory
                //InvObj.SetInventory(null);
                
                //
                //InvObj.Owner = null;
                
                
                UpdateActualObjCounter();
                return true;
            } //if 
        } //for
        UpdateActualObjCounter();
        return false;
    }
    
    
//-------------------------------------------------------------------    
	/** usuwanie przedmiotu z inventory // UWAGA drugi (np DrugHealthex sa usuwane 
	 * metoda RemoveDrugFromInventory(...
	 */
	public boolean RemoveInvObject(InvObject iObj)
	{
        
        
		for (int i=0; i<aInvObjects.size(); i++)
		{
            InvObject InvObj = (InvObject)aInvObjects.elementAt(i);
            
            if (InvObj == iObj)
            {
                aInvObjects.removeElementAt(i);
                iObj.OnRemoveFromInventory();
                
                //-- trzeba obsluzyc sytuacje gdy wyrzucamy aktualnie ustawiony do wyrzucenia przedmiot
                if ((cActualUsableInvObj!= null) && (iObj == cActualUsableInvObj))
                {
                    InvObject cPrevActual = cActualUsableInvObj;
                    SetNextUsableInvObj(true);
                    if (cPrevActual == GetActualUsableInvObj())
                        cActualUsableInvObj = null;
                    
                    if(Owner instanceof PlayerHUD)
                    {
                        PlayerHUD player = (PlayerHUD)Owner;
                        if ((player.HUD!=null) && (player.HUD.aHUDComponent[player.HUD._PLAYER_DATA]!=null))
                        {
                            HUDCompPlayer hudInvUse = player.HUD.GetHUDPlayer();
                            hudInvUse.ShowUsableInvObj(cActualUsableInvObj, EGameControl.ITEM_NEXT);
                        }
                    }
                    else
                    {
                        Log("[Inventory.RemoveInvObj]: Usuwanie przedmiotu z inventory nie nalezacego do PlayerHUDa \n" );
                    }
                }
                //-------------------------------------------------------------------------------------
                InvObj.Hide();
                if ( InvObj.cInvObjSprite != null )
                    InvObj.cInvObjSprite.ProcessMouse(false);
                else
                    LogD(" ERROR: InvObj.cInvObjSprite == null \n");
                
                InvGrid cGrid = GetInvGrid(InvObj.nGrid);
                if(cGrid != null)
                {
                    cGrid.SetFreeCells(InvObj.nCellY,
                                       InvObj.nCellsHeight,
                                       InvObj.nCellX,
                                       InvObj.nCellsWidth);
                }
                else
                {
                    //LogR("WARNING RemoveInvObject: obiekt " + InvObj + " nie ma grida!!!");   
                }
                
                Pawn OldOwner = InvObj.Owner;
                
                // ten obiekt nie nalezy juz do tego inventory
                InvObj.SetInventory(null);
                
                if (InvObj.Owner instanceof Player)
                {
                    InvObj.RegisterInInteractionMap();
                    InvObj.Owner.RegisterInInteractionMap();
                    InvObj.SetInteraction(InvObj.Owner, false);
                    InvObj.CallMethodIn("UnregisterInInteractionMap", 5);
                }
                
                //
                InvObj.Owner = null;
                
                // update amunicji
                if (InvObj.nInvType == EInvObjType._AMMO)
                {
                    if (OldOwner != null)
                        OldOwner.CountAmmo();
                }
                
                // to jest straszne gowno, ale inaczej tego sie nie da zrobic
                Module mod = GetModule();
                if (mod instanceof ChromeModule)
                    ((ChromeModule) mod).OnPlayerInvObjectRemoved(InvObj);
                UpdateActualObjCounter();
                return true;
            } //if 
        } //for
        UpdateActualObjCounter();
        return false;
    }
//-------------------------------------------------------------------
    /** Zwraca iIndex obiektu z Inventory
     */
    public int GetIndex(InvObject invObject)
    {
        return aInvObjects.indexOf(invObject);
    }

//-------------------------------------------------------------------    
    /** Zwraca obiekt z inventory na podstawie indeksu iIndex obiektu
     */
    public InvObject GetInvObject(int iIndex)
    {
        return (InvObject)aInvObjects.elementAt(iIndex);
    }

//-------------------------------------------------------------------    
	/**Pobiera pierwszy inv object o podanymn invIndex
	 */
	public InvObject GetSpecificInvObject(int nInvIndex)
	{
        for (int i=0; i<aInvObjects.size(); i++)
            if (((InvObject)aInvObjects.elementAt(i)).nInvIndex == nInvIndex)
				return (InvObject)aInvObjects.elementAt(i);
		return null;
	}

//-------------------------------------------------------------------
    /** metoda zwraca przedmioty podanego typu w postaci Wektora
     */
	public java.util.Vector GetInvObjects(int nType)
    {
        java.util.Vector objects = new java.util.Vector();
        
        for (int i=0; i<aInvObjects.size(); i++)
            if (((InvObject)aInvObjects.elementAt(i)).nInvType == nType)
                objects.addElement((Object)aInvObjects.elementAt(i));

        return objects;
    }

//-------------------------------------------------------------------
// iterator 
//-------------------------------------------------------------------    
    
    int nIteratorType = EInvObjType._NONE;
    int nIteratorIndex = 0 ;
    int nIteratorBackIndex = 0;
    
    public void ResetIterator()
    {
        nIteratorType = EInvObjType._NONE;
        nIteratorIndex = 0 ;
        nIteratorBackIndex = 0;
    }

	
//-------------------------------------------------------------------
    /** metoda sprawdza czy obiekt o podanej nazwie istnieje w inventory
     * i zwraca go
     */
    public InvObject GetByName(String name)
    {
     for (int i=0;i<aInvObjects.size(); i++)   
     {
        InvObject InvObj = (InvObject)aInvObjects.elementAt(i);
        if ((InvObj.sName).compareTo(name) == 0) return InvObj;
     }
     return null;
        
    }
//---------------------------------------------------------------------
    
    public InvObject GetFirstInvObject(int nType)
    {
        //Log("[Inventory.GetFirstInvObject] Searching\n");
        int i;        
        nIteratorType = nType;
        
        for (i=0; i<aInvObjects.size(); i++)
        {
            InvObject InvObj = (InvObject)aInvObjects.elementAt(i);

            if (InvObj.nInvType == nIteratorType)
            {
                //Log("[Inventory.GetFirstInvObject] got object:"+ InvObj.sName +"\n");
                nIteratorIndex = i+1;
                return InvObj;
            }
        }
        
        nIteratorIndex = i;
        return null;
    }

    public InvObject GetLastInvObject(int nType)
    {
        //Log("[Inventory.GetFirstInvObject] Searching\n");
        int i;        
        nIteratorType = nType;
        
        for (i = aInvObjects.size() - 1; i >= 0; i--)
        {
            InvObject InvObj = (InvObject)aInvObjects.elementAt(i);

            if (InvObj.nInvType == nIteratorType)
            {
                //Log("[Inventory.GetFirstInvObject] got object:"+ InvObj.sName +"\n");
                nIteratorBackIndex = i-1;
                return InvObj;
            }
        }
        
        nIteratorBackIndex = aInvObjects.size() - 1;
        return null;
    }
    
    public InvObject GetNextInvObject()
    {
        //Log("[Inventory.GetNextInvObject] Searching\n");
        int i;
        
        for (i = nIteratorIndex; i<aInvObjects.size(); i++)
        {
            InvObject InvObj = (InvObject)aInvObjects.elementAt(i);
            //gun moze byc, bo WeaponHands jest ukryte, a zakladamy ze 
            //broni zawsze mozna uzywac
            if (InvObj.bHidden && !(nIteratorType == EInvObjType._GUN) ||
                InvObj.cInventory != this)
                continue;
            
            if (InvObj.nInvType == nIteratorType)
            {
                //Log("[Inventory.GetNextInvObject] got object:"+ InvObj.sName +"\n");
                nIteratorIndex = i+1;
                nIteratorBackIndex = i;
                return InvObj;
            }
        }

        nIteratorIndex = i;
        nIteratorBackIndex = nIteratorIndex;
        return null;
    }

    public InvObject GetPrevInvObject()
    {
        //Log("[Inventory.GetNextInvObject] Searching\n");
        int i;
        
        if (nIteratorBackIndex >= aInvObjects.size())
            nIteratorBackIndex = aInvObjects.size() - 1;
        for (i = nIteratorBackIndex; i >= 0; i--)
        {
            InvObject InvObj = (InvObject)aInvObjects.elementAt(i);
            //gun moze byc, bo WeaponHands jest ukryte, a zakladamy ze 
            //broni zawsze mozna uzywac
            if (InvObj.bHidden && !(nIteratorType == EInvObjType._GUN)||
                InvObj.cInventory != this)
                continue;
            
            if (InvObj.nInvType == nIteratorType)
            {
                //Log("[Inventory.GetNextInvObject] got object:"+ InvObj.sName +"\n");
                nIteratorBackIndex = i-1;
                nIteratorIndex = i;
                return InvObj;
            }
        }

        nIteratorBackIndex = aInvObjects.size() - 1;
        nIteratorIndex = nIteratorBackIndex;
        return null;
    }
//-------------------------------------------------------------------    
//-------------------------------------------------------------------
    /** metoda rysuje wszystkie Przedmioty w Inventory
	 */
	public void ShowAllInvObjects(Sprite cParentInvGrid)
	{
	    bActive = true;
        
        UpdateTakenCells();
        
        for (int i=0; i<aInvObjects.size();  i++)
        {
            if (((InvObject)aInvObjects.elementAt(i)).cInventory == this)
            {
                //jesli beda dziecmi grida to nie beda zawsze na wierzchu
                cParentInvGrid.AddChild(((InvObject)aInvObjects.elementAt(i)).cInvObjSprite);
			    ((InvObject)aInvObjects.elementAt(i)).Draw();
            }
            else
            {
                CrashLog("ERROR " + ((InvObject)aInvObjects.elementAt(i)) + " is in " + this + " but his cInventory is " + ((InvObject)aInvObjects.elementAt(i)).cInventory);
            }
        }
    }

//-------------------------------------------------------------------	    
	public void HideAllInvObjects()
    {
	    bActive = false;
        
        for (int i=0; i<aInvObjects.size();  i++)
			((InvObject)aInvObjects.elementAt(i)).Hide();
	}

//-------------------------------------------------------------------	
 	/** destruktor
 	 */
    public void OnDestroy()
    {
    }
    
    /** metoda oblicza i wyswietla invobjecty znajdujace sie w gridach przesuwajac je
     *  (gridy) chwilowo o wektor (relX, relY)
     */		
    public void ComputeInvObjPositions(int relX, int relY)
    {
		for (int i = 0; i < aInvGrids.length; i++)
		{
			aInvGrids[i].nGridPosX += relX;
			aInvGrids[i].nGridPosY += relY;
		}
		ComputeInvObjPositions();
		for (int i = 0; i < aInvGrids.length; i++)
		{
			aInvGrids[i].nGridPosX -= relX;
			aInvGrids[i].nGridPosY -= relY;
		}
	}
	
    /** metoda wylicza ad hoc pozycje przedmiotow z inventory w gridach
     *  pozwala na reczne sterowanie rozlozeniem przedmiotow w inventory
     */		
    public void ComputeInvObjPositions()
    {
        //Log("[InventoryPlayer.ComputeInvObjPositions]\n");
        int i_InvObj = 0;

        for (i_InvObj = 0; i_InvObj<aInvObjects.size(); i_InvObj++)
        {
            InvObject InvObj = (InvObject)aInvObjects.elementAt(i_InvObj);

            if (InvObj.bHidden || InvObj.bHiddenButUsable ||
                InvObj.cInventory != this)
                continue;
            
            if (InvObj.cInventory == null)
            {
                //Log("[InventoryPlayer.ComputeInvObjPositions] -- Znalazlem NULL'a \n");
                Vector freeCell = FindCellGrid(InvObj);
                    
                //ustawiam odpowiednie polozenia przedmiotow w inventory
                InvObj.SetInvObjCellsGrid((byte)freeCell.fX,
                                          (byte)freeCell.fY,
                                          (byte)freeCell.fZ);
                    
                CrashLog("freeCell="+freeCell.fX+" "+freeCell.fY+"\n");
                
                // update tablic wolnych miejsc w gridach
                aInvGrids[(int)freeCell.fZ].SetTakenCells((byte)freeCell.fY,
                                                          InvObj.nCellsHeight,
                                                          (byte)freeCell.fX,
                                                          InvObj.nCellsWidth);	
                    
            } //if (przedmioty, ktore nie maja jeszcze przyporzadkowanej celi)
            else
            {
                // przedmiot jest w celi, ale trzeba mu zupdejtowac pozycje
                InvObj.SetInvObjCellsGrid(InvObj.nCellX,
                                          InvObj.nCellY,
                                          InvObj.nGrid);
                
            }
        }//for jade po wszystkich przedmiotach w inventory
        
        //Log("[InventoryPlayer.ComputeInvObjPositions] OK\n");
    }
//-------------------------------------------------------------
    
	/** metoda sprawdza czy sprite przedmiotu znajduje sie w calosci
	 *  poza inventory
	 */
	public boolean IsOutOfInventory(InvObject InvObj)
	{
		// nie jest pokazane
		if (!bActive)
			return true;
		
        // brak obiektu
        if(InvObj == null) 
            return true;
        
        boolean ret = true;
		for (int i=0; i<aInvGrids.length; i++ )
		{
			ret = aInvGrids[i].IsOutOfGrid(InvObj);
			if (ret == false) return false;
		}
		
		return true;
	}
    
//------------------------------------------------------------------    
	 /** metoda zwraca Vector z wspolrzednymi najblizszego grida
	  *	 wartosc zwracana Vector(cellX, cellY, GridNr)
	  */
	 public Vector FindNearestCellGrid(Vector pos, InvObject obj)
	 {
		int nGrid = 0;
		Vector Vect_pom = new Vector(0,0,0);
		Vector retVect = new Vector(0,0,0);

        float max_dist = 10000.0f; // maksymalna odleglosc poszukiwan
		float min_dist = max_dist; // aktualnie znaleziona minimalna odleglosc
		
		for (nGrid = 0; nGrid < aInvGrids.length; nGrid++)
		{
            if (nGrid == _SLOT_MISSION && !obj.bMissionCritical)
                continue;
			Vect_pom = aInvGrids[nGrid].FindNearestCell(pos, obj, max_dist);
			if ((Vect_pom.fZ < min_dist) && (Vect_pom.fX != -1))
			{
				retVect.fX = Vect_pom.fX;
				retVect.fY = Vect_pom.fY;
				retVect.fZ = nGrid;
				min_dist = Vect_pom.fZ;
			}//znalazlem blizszy grid
		}//dla kolejnych gridow szukam najmniejszego 
		
		return retVect;
	 }
//------------------------------------------------------------------
	/** metoda sprawdza czy jest wolne miejsce w inventory dla podanego przedmiotu
	 */
	public boolean IsFreeSpaceInInv(InvObject obj)
	{
        boolean bIsSpace = false;

        //jade po wszystkich gridach
        if (aInvGrids != null)
        {
            for (int i=0; i<aInvGrids.length; i++)
            {
                if (i == _SLOT_MISSION)
                    continue;
                
                bIsSpace = aInvGrids[i].IsSpaceForInvObj(obj);
                if (bIsSpace) 
                    return true;
            }
            //nie znaleziono miejsca
            return false;
                
        }
        else
            return false;
    }
    
//------------------------------------------------------------
    
    /** metoda zwraca pierwsze wolne miejsce w Gridach w postaci
     *	Vector(CellX, CellY, numerGrida) 
     */
    public Vector FindCellGrid(InvObject obj)	
    {
        int nGridIdx = 0;
        Vector retVect = new Vector(-1,0,0);
        
        for (nGridIdx = 0; nGridIdx < aInvGrids.length; nGridIdx++)
        {
            //nie szukamy w gridzie misji
            if (nGridIdx == Inventory._SLOT_MISSION)
                continue;
            retVect = aInvGrids[nGridIdx].FindFreeCell(obj.nCellsWidth, obj.nCellsHeight);
            // sprawdzam czy juz znalazl wolne miejsce
            if (retVect.fX != -1)
            {
                retVect.fZ = nGridIdx;
                return retVect;
            }
        }//sprawdzam po kolei miejsca w gridach
        
        return retVect;
    }    
    
    /**
     * Zwraca informacje, ktory obiekt blokuje obiektowi
     * podanemu jako parametr dostep do inwentory (do gridow
     * ktore sobie obiekt "wymarzyl")
     * Zwraca pierwszy znaleziony taki obiekt
     */
    InvObject GetGridConflictedObject(InvObject cMyObject)
    {
        Vector vMyPlace = cMyObject.GetCurrentPlace();
                
        int nMyGrid    = (int)vMyPlace.fZ;
        int nMyPosX    = (int)vMyPlace.fX;
        int nMyPosY    = (int)vMyPlace.fY;
        int nMyPosXEnd = nMyPosX + cMyObject.nCellsWidth - 1;
        int nMyPosYEnd = nMyPosY + cMyObject.nCellsHeight - 1;
        
        for (int i=0; i<aInvObjects.size(); i++)
        {
            InvObject cInvObj = (InvObject)aInvObjects.elementAt(i);
            if ( cInvObj == null )
                continue;
            
            //sprawdzam, czy sa w tym samym gridzie
            Vector vPlace = cInvObj.GetCurrentPlace();
            int nGrid    = (int)vPlace.fZ;
            if ( nGrid != nMyGrid )
                continue;
            int nPosX    = (int)vPlace.fX;
            int nPosY    = (int)vPlace.fY;
            int nPosXEnd = nPosX + cInvObj.nCellsWidth - 1;
            int nPosYEnd = nPosY + cInvObj.nCellsHeight - 1;
            
            boolean bX = (nPosX    >= nMyPosX)&&(nPosX    <= nMyPosXEnd)||
                         (nPosXEnd >= nMyPosX)&&(nPosXEnd <= nMyPosXEnd);
            boolean bY = (nPosY    >= nMyPosY)&&(nPosY    <= nMyPosYEnd)||
                         (nPosYEnd >= nMyPosX)&&(nPosYEnd <= nMyPosYEnd);
            
            if ( bX && bY )
                return cInvObj;
        }
        return null;
    }

        
    /** metoda zwraca pierwsze wolne miejsce w gridzie misji
     *	Vector(CellX, CellY, numerGrida) 
     */
    public Vector FindCellGridMission(InvObject obj)	
    {
        int nGridIdx = Inventory._SLOT_MISSION;
        Vector retVect = aInvGrids[nGridIdx].FindFreeCell(obj.nCellsWidth, obj.nCellsHeight);
        retVect.fZ = nGridIdx;
        return retVect;
    }    
    
//--------------------------------------------------------------------
    /** metoda zwraca pierwszy przedmiot do uzycia 
     */
    public InvObject GetFirstUsableObj()
    {
        nActualUsableObjIdx = -1;
        
        // Log("[Inventory.GetFirstUsableObj] Searching...\n");
        for (int i=0; i<aInvObjects.size(); i++)
        {
            InvObject InvObj = (InvObject)aInvObjects.elementAt(i);
            if (InvObj.bHidden)
                continue;
            
            if ( (InvObj.nInvType != EInvObjType._AMMO) &&
                 (InvObj.nInvType != EInvObjType._GUN)  &&
                 (InvObj.nInvType != EInvObjType._NONE))
            {
                // Log("[Inventory.GetFirstInvObject] got object:"+ InvObj.sName +"\n");
                nIteratorIndex = i+1;
                nActualUsableObjIdx = i;
                return InvObj;
            }
        }
        
        return null;
    }
//--------------------------------------------------------------------
    /** metoda zwraca nastepny przedmiot do uzycia
     */
    public InvObject GetNextUsableObj()
    {
        if (aInvObjects.size() > 0)
        {
            int j = aInvObjects.size();
            int i = nActualUsableObjIdx+1;
            for (; j > 0; i++,j--)
            {
                i = i % aInvObjects.size();
                InvObject InvObj = (InvObject)aInvObjects.elementAt(i);
                if (InvObj.bHidden)
                    continue;
                
                if ((InvObj.nInvType != EInvObjType._AMMO)  &&
                    (InvObj.nInvType != EInvObjType._GUN)   &&
                    (InvObj.nInvType != EInvObjType._NONE))
                {
                    nActualUsableObjIdx = i;
                    return InvObj;
                }//if      
            }//for
            
            return null; 
        }//if
        
        return null;
    }

//-------------------------------------------------------------------------    
    /** metoda zwraca nastepny przedmiot do uzycia
     */
    public InvObject GetPrevUsableObj()
    {
        if (aInvObjects.size() > 0)
        {
            int j = aInvObjects.size();
            int i = nActualUsableObjIdx-1;
            for (; j > 0; i--,j--)
            {
                if(i < 0) i = aInvObjects.size()-1;
                InvObject InvObj = (InvObject)aInvObjects.elementAt(i);
                if (InvObj.bHidden)
                    continue;
                
                if ((InvObj.nInvType != EInvObjType._AMMO)  &&
                    (InvObj.nInvType != EInvObjType._GUN)   &&
                    (InvObj.nInvType != EInvObjType._NONE))
                {
                    nActualUsableObjIdx = i;
                    return InvObj;
                }//if      
            }//for
            
            return null; 
        }//if
        
        return null;
    }

	public boolean IsUsableObj(InvObject invObj)
	{
        if ((invObj.nInvType != EInvObjType._AMMO)  &&
            (invObj.nInvType != EInvObjType._GUN)   &&
            (invObj.nInvType != EInvObjType._NONE))
			return true;
		else
			return false;
	}
//------------------------------------------------------------
    /** metoda sprawdza czy podany InvObject nalezy do tego inventory
     */
    public boolean BecomeToThisInventory(InvObject cInvObj)
    {
        if (cInvObj.cInventory == this)
        {
            for (int i = 0; i < aInvObjects.size(); i++)
                if (((InvObject)aInvObjects.elementAt(i)) == cInvObj)
                    return true;
            
            Tools.CrashLogWarning("InvObject ma referencje na inventory w ktorym go juz nie ma");
        }
        return false;
    }
    
//---------------------------------------------------------------------------------
    
    public void UpdateTakenCells()
    {
        for (int i = 0; i < aInvGrids.length; i++)
        {
            InvGrid cGrid = aInvGrids[i];
            if (cGrid != null)
            {
                cGrid.ClearGrid();
            }
        }
        
        for (int i = 0; i < aInvObjects.size(); i++)
        {
            InvObject cObj = (InvObject)aInvObjects.elementAt(i);
            if (cObj.cInventory == this)
            {
                if (cObj.nCellY != -1 && cObj.nCellX != -1)
                    aInvGrids[cObj.nGrid].SetTakenCells(cObj.nCellY, cObj.nCellsHeight, cObj.nCellX, cObj.nCellsWidth);
            }
            else
            {
                Tools.CrashLogWarning(cObj + " jest w " + this + " a mysli ze jest w " + cObj.cInventory);
            }
        }
                
    }
    
//---------------------------------------------------------------------------------
    /** metoda czycsi cale inventory - wyrzuca (nie kasuje!) wszystkie obiekty
     */
    public void Clear()
    {
        /*
        // przepisujemy zalockowane przedmioty
        java.util.Vector aOldInvObjects = new java.util.Vector(10);
        
        for(int i=0; i<aInvObjects.size(); i++)
        {
            InvObject obj = ((InvObject)aInvObjects.elementAt(i));
            if( obj.bLocked )
            {
                aOldInvObjects.addElement(obj);
            }
        }
        */
        // czyscimy inventory
        while (aInvObjects.size() > 0)
        {
            RemoveInvObject(((InvObject)aInvObjects.elementAt(0)));
        }
        
        for (int i=0; i<aInvGrids.length; i++)
        {
            aInvGrids[i].ClearGrid();   
        }
      
        nActualUsableObjIdx = -1;
        
        ResetIterator();
        /*
        // dodajemy zalockowane przedmioty
        for(int i=0; i<aOldInvObjects.size(); i++)
        {
            AddInvObjectInPlace( ((InvObject)aOldInvObjects.elementAt(i)) );
        }
        */
    }
//---------------------------------------------------------------------------------    
    /** metoda wypisuje wszystkie przedmioty z inventory
     */
    public void PrintInventory()
    {
        if (aInvObjects == null) Log("Inventory is EMPTY \n");
        else
        {
            if (aInvObjects.size() == 0) Log("Inventory is EMPTY \n");
            for (int i=0; i<aInvObjects.size(); i++)   
            {
                String pom = ((InvObject)aInvObjects.elementAt(i)).GetInvName();
                Log("Invetory obj nr. "+i+" = "+pom+"\n");
            }//for    
        }//else
    }
    
//---------------------------------------------------------------------------------    
	/** metoda pomocnicza do wyswietlania wartosci cel we wszystkich gridach
	 */
    public void PrintGridCells()
	{
		/*
		for (int i=0; i<aInvGrids.length; i++)
		{
			Log("GRID NR = "+i+"\n");
			aInvGrids[i].PrintFreeCells();
			
		}
        */
	}
//----------------------------------------------------------------------------------
    /** uzycie przedmiotu usable
     */
    public void UseInvObject()
    {
        if (cActualUsableInvObj!= null)
        {
            try
            {
                Player player = (Player)Owner;
                player.UseInvObject(cActualUsableInvObj);   
            }
            catch (ClassCastException ex)
            {
                
                CrashLog("[Inventory.UseInvObject]: InvObject can be used only by PLAYER \n");
            }
        }
    }
    
    public void UseSpecificInvObject(int nInvIndex)
    {
        InvObject cObj = GetSpecificInvObject(nInvIndex);
        if (cObj != null)
        {
            Player player = (Player)Owner;
            player.UseInvObject(cObj); 
        }
    }
    
//----------------------------------------------------------------------------------
    /** metoda znajduje i ustawia referencje do pierwszego z przedmiotow w inventory, ktory mozna uzyc
     */
    public void SetFirstUsableInvObj()
    {
        //nActualUsableObjIdx = -1;
        cActualUsableInvObj = null;
        
        Log("[Inventory.SetFirstUsableObj] Searching...\n");
        for (int i=0; i<aInvObjects.size(); i++)
        {
            InvObject InvObj = (InvObject)aInvObjects.elementAt(i);
            
            if (InvObj.bHidden || InvObj.cInventory != this)
                continue;
            
            if ( (InvObj.nInvType != EInvObjType._AMMO) &&
                 (InvObj.nInvType != EInvObjType._GUN)  &&
                 (InvObj.nInvType != EInvObjType._NONE))
            {
                cActualUsableInvObj = InvObj;
                Log("[Inventory.GetFirstInvObject] got object:"+ InvObj.GetInvName() +"\n");
                return;
                //nIteratorIndex = i+1;
                //nActualUsableObjIdx = i;
                
            }
        }
        
    }
//----------------------------------------------------------------------------------
    /** metoda znajduje i ustawia referencje do nastepnego z przedmiotow w inventory, ktory mozna uzyc
     * @param bCanRepeat jesli true, to kolejnym przedmiotem moze byc taki sam jak poprzedni
     * jesli false to kolejny rodzaj przedmiotu lub zaden (true jest ustawiane przy wyrzucaniu)
     */
    public void SetNextUsableInvObj(boolean bCanRepeat)
    {
        nActualUsableObjIdx = 0;
        
        if (cActualUsableInvObj == null) SetFirstUsableInvObj();
        else
        {
            nActualUsableObjIdx = aInvObjects.indexOf((InvObject)cActualUsableInvObj);
            
            if (nActualUsableObjIdx == aInvObjects.size()-1)
            {
                //koniec listy
                for (int i=0; i<aInvObjects.size(); i++)        
                {
                   InvObject InvObj = (InvObject)aInvObjects.elementAt(i);
                   
                   if (InvObj.bHidden || InvObj.cInventory != this)
                        continue;
                   
                   if ( (InvObj.nInvType != EInvObjType._AMMO) &&
                        (InvObj.nInvType != EInvObjType._GUN)  &&
                        (InvObj.nInvType != EInvObjType._NONE) &&
                        (((InvObj.nInvIndex != cActualUsableInvObj.nInvIndex) && !bCanRepeat)|| 
                         (InvObj.nInvIndex == cActualUsableInvObj.nInvIndex) && (bCanRepeat || InvObj instanceof BatteryChargedInvObject))
                       )
                  {
                        cActualUsableInvObj = InvObj;
                        Log("[Inventory.GetNextInvObject] got object:"+ InvObj.GetInvName() +"\n");
                        return;
              
                  }//if   
                    
                }//for
                
            }
            else
            {
                //gdzies w srodku listy, najpierw idziemy do przodu, 
                for (int i = nActualUsableObjIdx+1; i<aInvObjects.size(); i++)
                {
                   InvObject InvObj = (InvObject)aInvObjects.elementAt(i);
                    if (InvObj.bHidden || InvObj.cInventory != this)
                        continue;
                    
                    if ( (InvObj.nInvType != EInvObjType._AMMO) &&
                        (InvObj.nInvType != EInvObjType._GUN)  &&
                        (InvObj.nInvType != EInvObjType._NONE)&&
                        (((InvObj.nInvIndex != cActualUsableInvObj.nInvIndex) && !bCanRepeat)|| 
                         (InvObj.nInvIndex == cActualUsableInvObj.nInvIndex) && (bCanRepeat || InvObj instanceof BatteryChargedInvObject))
                       )
                    {
                        cActualUsableInvObj = InvObj;
                        Log("[Inventory.GetNextInvObject] got object:"+ InvObj.GetInvName() +"\n");
                        return;
              
                    }//if   
                }//for
            
                //potem od poczatku do danego miejsca
                for (int i = 0; i<=nActualUsableObjIdx; i++)
                {
                    InvObject InvObj = (InvObject)aInvObjects.elementAt(i);
                    if (InvObj.bHidden || InvObj.cInventory != this)
                        continue;
                    
                    if ( (InvObj.nInvType != EInvObjType._AMMO) &&
                        (InvObj.nInvType != EInvObjType._GUN)  &&
                        (InvObj.nInvType != EInvObjType._NONE) &&
                         (((InvObj.nInvIndex != cActualUsableInvObj.nInvIndex) && !bCanRepeat)|| 
                         (InvObj.nInvIndex == cActualUsableInvObj.nInvIndex) && (bCanRepeat || InvObj instanceof BatteryChargedInvObject)))
                    {
                        cActualUsableInvObj = InvObj;
                        Log("[Inventory.GetNextInvObject] got object:"+ InvObj.GetInvName() +"\n");
                        return;
                
                    }//if   
                }//for
             }//else
            
             
            
        }//else    
        
        //obiekt moze sie nie znalezc, jesli szukamy bez powtorzen a wlasnie wyrzucilismy
        //ostatni obiekt danej klasy, wtedy ustawiamy pierwszy z brzegu
        SetFirstUsableInvObj();
       
    }
	
	public boolean SetUsableObject(InvObject invObj)
	{
        if (invObj == null)
			return false;
		if (!IsUsableObj(invObj))
			return false;
		if (aInvObjects.indexOf(invObj) == -1)
			return false;
        cActualUsableInvObj = invObj;
		return true;
	}
//----------------------------------------------------------------------------------
    /** metoda znajduje i ustawia referencje do poprzedniego z przedmiotow w inventory, ktory mozna uzyc
     */
    public void SetPrevUsableInvObj(boolean bCanRepeat)
    {
        nActualUsableObjIdx = 0;
        
        if (cActualUsableInvObj == null) SetFirstUsableInvObj();
        else
        {
            nActualUsableObjIdx = aInvObjects.indexOf((InvObject)cActualUsableInvObj);
            
            if (nActualUsableObjIdx == 0)
            {
                for (int i=aInvObjects.size()-1; i>=0; i--)        
                {
                  
                  InvObject InvObj = (InvObject)aInvObjects.elementAt(i);  
                  if (InvObj.bHidden || InvObj.cInventory != this)
                      continue;
                  
                  if ( (InvObj.nInvType != EInvObjType._AMMO) &&
                       (InvObj.nInvType != EInvObjType._GUN)  &&
                       (InvObj.nInvType != EInvObjType._NONE) &&
                       (((InvObj.nInvIndex != cActualUsableInvObj.nInvIndex) && !bCanRepeat)|| 
                       (InvObj.nInvIndex == cActualUsableInvObj.nInvIndex) && (bCanRepeat || InvObj instanceof BatteryChargedInvObject)))
                  {
                        cActualUsableInvObj = InvObj;
                        Log("[Inventory.GetPrevInvObject] got object:"+ InvObj.GetInvName() +"\n");
                        return;
              
                  }//if   
                    
                }//for
                
            }
            else
            {
            
                for (int i = nActualUsableObjIdx-1; i>=0; i--)
                {
                    InvObject InvObj = (InvObject)aInvObjects.elementAt(i);
                    if (InvObj.bHidden || InvObj.cInventory != this)
                        continue;
                    
                    if ( (InvObj.nInvType != EInvObjType._AMMO) &&
                        (InvObj.nInvType != EInvObjType._GUN)  &&
                        (InvObj.nInvType != EInvObjType._NONE)&&
                         (((InvObj.nInvIndex != cActualUsableInvObj.nInvIndex) && !bCanRepeat)|| 
                         (InvObj.nInvIndex == cActualUsableInvObj.nInvIndex) && (bCanRepeat || InvObj instanceof BatteryChargedInvObject)))
                    {
                        cActualUsableInvObj = InvObj;
                        Log("[Inventory.GetNextInvObject] got object:"+ InvObj.GetInvName() +"\n");
                        return;
              
                    }//if   
                }//for
            
                for (int i = aInvObjects.size()-1; i>=nActualUsableObjIdx; i--)
                {
                    InvObject InvObj = (InvObject)aInvObjects.elementAt(i);
                    if (InvObj.bHidden || InvObj.cInventory != this)
                        continue;
                    
                    if ( (InvObj.nInvType != EInvObjType._AMMO) &&
                        (InvObj.nInvType != EInvObjType._GUN)  &&
                        (InvObj.nInvType != EInvObjType._NONE) &&
                         (((InvObj.nInvIndex != cActualUsableInvObj.nInvIndex) && !bCanRepeat)|| 
                         (InvObj.nInvIndex == cActualUsableInvObj.nInvIndex) && (bCanRepeat || InvObj instanceof BatteryChargedInvObject)))
                    {
                        cActualUsableInvObj = InvObj;
                        Log("[Inventory.GetNextInvObject] got object:"+ InvObj.GetInvName() +"\n");
                        return;
                
                    }//if   
                }//for
             }//else
            
        }//else        
        
        //obiekt moze sie nie znalezc, jesli szukamy bez powtorzen a wlasnie wyrzucilismy
        //ostatni obiekt danej klasy, wtedy ustawiamy pierwszy z brzegu
        SetFirstUsableInvObj();
    }
//----------------------------------------------------------------------------------    
    /** metoda zwraca aktualnie ustawiony do uzycia InvObject
     */
    public InvObject GetActualUsableInvObj()
    {
        return cActualUsableInvObj;   
    }
    
    /**Zwraca liczbe obiektow o podanym indeksie (identyfikatorze - zmienna nInvIndex w InvObject.java)*/
    int GetObjCount(int nInvIndex)
    {
        int nCount = 0;
        for (int i = 0; i < aInvObjects.size(); i ++)
        {
            InvObject InvObj = (InvObject)aInvObjects.elementAt(i);
            if (InvObj.nInvIndex == nInvIndex)
                nCount ++;
        }
        return nCount;
    }
    
    void UpdateActualObjCounter()
    {
        if (Owner instanceof PlayerHUD)
        {
            PlayerHUD player = (PlayerHUD)Owner;
            if ((player.HUD!=null) && (player.HUD.aHUDComponent[player.HUD._PLAYER_DATA]!=null))
            {
                HUDCompPlayer hudInvUse = (HUDCompPlayer)player.HUD.aHUDComponent[player.HUD._PLAYER_DATA];  
                hudInvUse.UpdateActualObjCounter();
            }
        }
    }
    
    /**Dodaje amunicje do pudelek, jesli cos zostanie w cAmmo, to zostaje zwrocone*/
    Ammo AddAmmo(Ammo cAmmo)
    {
        java.util.Vector ammoVec = GetInvObjects( EInvObjType._AMMO );
        
        
        Ammo ammo = null;
        for (int i=0; i<ammoVec.size(); i++)
        {
            ammo = (Ammo)(ammoVec.elementAt(i));
            
            //mamy pudelko z wlasciwa amunicja
            if (ammo.eAmmoType == cAmmo.eAmmoType)
            {
                //wolne miejsce w pudelku
                int nSpace = ammo.nCapacity - ammo.nCount;
                if (nSpace > 0)
                {
                    if (nSpace >= cAmmo.nCount)
                    {
                        //zmiesci sie wszystko
                        ammo.nCount += cAmmo.nCount;
                        cAmmo.nCount = 0;
                        cAmmo.DetachFromParent();
                        //nie trzeba usuwac z ewentualnego inventory, invobject sam to zrobi w ondestroyu
                        cAmmo.delete();
                        Owner.CountAmmo();
                        return null;
                    }
                    else
                    {
                        ammo.nCount += nSpace;
                        cAmmo.nCount -= nSpace;
                    }
                }
            }
        }
        Owner.CountAmmo();
        
        return cAmmo;
    }

    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[Inventory.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_INVENTORY)
        {	
			super.SGLoadChunk(cFC);
			
            // ta flaga ma byc wyzerowana, zeby przy pokazywaniu sie pozycje ustawily
            bGridInited = false;
			
            // flaga mowiaca czy to inventory jest aktywne (pokazane)
			bActive = cFC.LoadBool();
            
			// wektor przedmiotow znajdujacych sie w inventory
			aInvObjects = cFC.LoadObjectsVectorRef();
			
            int nGrids = cFC.LoadInt();
            if(aInvGrids.length != nGrids)
            {
                CrashLog("Different inventory grids num read="+nGrids+" aInvGrids.length="+aInvGrids.length+"\n");
            }
                
			// tablica gridow plecaka gracza
			for (int i=0; i < nGrids; i++)
				aInvGrids[i].SGLoadChunk(cFC);			
			
			// numer indeksu aktualnie ustawionego przedmiotu do uzywania
			nActualUsableObjIdx = cFC.LoadInt();
			
            
            if (cFC.LoadBool())
                cActualUsableInvObj = (InvObject)cFC.LoadObjectRef();
            else
                cActualUsableInvObj = null;
            /*// referencja do aktualnie ustwionego przedmiotu do uzycia 
            if(nActualUsableObjIdx > -1)
			    cActualUsableInvObj = (InvObject)aInvObjects.elementAt(nActualUsableObjIdx);
            else
                cActualUsableInvObj = null;*/

        }
		
		cFC.delete();
    }
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[Inventory.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_INVENTORY, cFCParent);
		
		super.SGSaveChunk(cFC);		
		
        // flaga mowiaca czy to inventory jest aktywne (pokazane)
        // to chyba jakas pomylka, ze to tu jest!
		cFC.SaveBool(bActive);

		// wektor przedmiotow znajdujacych sie w inventory
		cFC.SaveObjectsVectorRef(aInvObjects);
		
        cFC.SaveInt(aInvGrids.length);
        
		// tablica gridow plecaka gracza
		for (int i=0; i < aInvGrids.length; i++)
			aInvGrids[i].SGSaveChunk(cFC);
				
		// numer indeksu aktualnie ustawionego przedmiotu do uzywania
		cFC.SaveInt(nActualUsableObjIdx);

        cFC.SaveBool(cActualUsableInvObj != null);
        if (cActualUsableInvObj != null)
        {
            cFC.SaveObjectRef(cActualUsableInvObj);
        }
        
        cFC.delete();
    }	    	
    
    public void SGUpdate()
    {
        super.SGUpdate();
        if (Owner instanceof Player)
        {
            HUDCompPlayer hudInvUse = (HUDCompPlayer)((PlayerHUD)Owner).HUD.GetHUDPlayer();  
            hudInvUse.ShowUsableInvObj(cActualUsableInvObj);
        }
    }
    
    public void OwnerDied()
    {
        
    }

}
