/** klasa lornetki
 */
public class Binoculars extends InvObjectInst
{
	ZoomerSniperSmooth cZoomer = null;

	float fMinZoom = 2.f;
	float fMaxZoom = 10.f;
	   
	HUDComponent cBinocularsHUD = null;
   
	public String sExplosionWave = "Data/Sounds/Ai/sgshot"; // #EXPLOSIVES

    InvObject thisInvObject = this;
    
    /** Zasieg dzialania 'rozpoznania' lornetki */
    public float _IDENTIFICATION_RANGE = 25000f;

    /** czas pomiedzy strzelaniem trace'ami */
    public float _BTW_TRACE_TIME = 0.3f;
	
    /** kat bazowy w stopniach dla lornetki (i zoom), dla niego i odleglosci jest potem
     * wyliczany wlasciwy kat, w obrebie ktorego musi sie znalezc obiekt, by byc
     * uwzgledniany jako glowny (najbardziej aktywny). Wzor na obliczanie kata ma postac:
     * Beta[rad] = atan( tan(BaseAlpha) / Zoom )
     */
    public float _BASE_IDENTIFICATION_ANGLE = 15f;
    public float _BASE_IDENTIFICATION_TAN = 0f;
	
    /** Minimalny czas update'owania 'rozpoznanych' obiektow */
    public float fIdentificationUpdateTime = 0.5f;

    /** O ile wektor do obiektu musi byc odchylony od osi patrzenia lornetki,
     *  zeby lornetka mogla go sledzic [deg]
     */
    public float fTrackedIdentificationAngle = 10f;

	public ChromeActor m_TrackedObject = null;
	
    /** Vector z obiektami, ktore maja byc zaznaczone w lornetce */
    java.util.Vector aIdentifiedObjects = new java.util.Vector();

    /** Vector ze strukturami (Obiekt+Dot(kierunek do obiektu, kierunek kamery)) - 
     * jezeli jest w nim za malo elementow by pomiescic dane wszystkich obiektow,
     * dynamicznie sa one dodawane */
    java.util.Vector aObjectsInfos = new java.util.Vector();

	/** liczba obiektow z aObjectsInfos, ktore ida do przetwarzania */
	int m_iNofValidObjectInfos = 0;
	
    float fLastIdentificationUpdateTime = 0;

	boolean m_bIsFristObjectSpecial = false;

	float m_fLastCheckTraceTime = 0;
	
	boolean m_bSetOutOfGrid = true;
    
	Binoculars()
    {
        super();
		
        MeshName = "Data/Meshes/Equipment/Lornetka.3DA";
        nInvIndex = InvObject._E_BINOCULARS;
        nInvType = EInvObjType._EQUIP;
        sTexFileName = "CH_I_Weapons2.png";
      	nCellsWidth = 2;
	    nCellsHeight = 2;
        
        // wspolrzedne polozenia na teksturze
        nOnTexPosX = 200.0f;
        nOnTexPosY = 180.0f;
        
        // rozmiary tekstury
        nTexSizeX = 256.0f;
        nTexSizeY = 256.0f;
        
        //lornetki nie mozna uzywac jak przycelowujemy
        m_bCanUseWhileAiming = false;
        
        sName = "&E_N_BINOCULARS&";
		_BASE_IDENTIFICATION_TAN = (float) Math.tan(_BASE_IDENTIFICATION_ANGLE /
											 	    180f *
													Math.PI);
    }

    public void OnCreate()
    {
        super.OnCreate();
        RegisterMouseButtonRequest();
    }
    
    void InitializeZoomer()
    {
        if (cZoomer == null)
        {
            cZoomer = (ZoomerSniperSmooth) CreateObject("ZoomerSniperSmooth");
        }
        cZoomer.cOwner = this;
        cZoomer.fInitialZoom = fMinZoom;
        cZoomer.fZoomMax = fMaxZoom;
        cZoomer.Reset();

    }    
    
    void InitializeHUD()
    {
		
    }

    void Explode()
    {
        PlayWave(sExplosionWave);
    }

    
    public class BeingUsed extends State
    {
        boolean bExitAfterNextKey = true;

        public void OnEnter()
        {
            m_bUsing = true;
            
            InitializeZoomer();
			
            bExitAfterNextKey = false;
            DisableCallMethod("SetExitFlag");
            CallMethodIn("SetExitFlag",0.0f);
        }
        
        public void OnFrame()
		{
            if ( Owner != null && Owner.bNetIsOwner && cBinocularsHUD.bActiveFlag)
                ((HUDBinocularsExtended) cBinocularsHUD).UpdateHUD();
		}
		
        public void SetExitFlag()
        {
			bExitAfterNextKey = true;
        }

        public void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
        {
            // wcisniecie USE
            if (bKeyState && 
                (nKeyCode == EGameControl.USE || nKeyCode == EGameControl.USE_ITEM_BINOCULARS) )
            {
                if (bExitAfterNextKey)
                {
                    // w grze sieciowej trzeba to zrobic po ludzku
                    if ( Owner instanceof PlayerNet )
                        ((PlayerNet)Owner).EndUseInvObject( thisInvObject );
                    else
                    {
                        if (cBinocularsHUD != null )
					        cBinocularsHUD.Deactivate();
                    }
                }
            }        
            
            OnInputKeyTest( nKeyCode, bKeyState, nKeyAscii );
        }		
        
        public void OnInputMouseButton(int nButton, int nState)
        {
            //uzyty tu jest OnInputKey, zeby nie powielac obslugi klawiatury (myszka tez
            //moze byc podpieta pod rozne akcje)
            CallOnInputKey(Player.ConvertMouseButtonToKey(nButton), nState, '0');
        }
        
        
		
    }
    
    boolean m_bUsing = false;
    
    void OnRemoveFromInventory()
    {
        super.OnRemoveFromInventory();
        
        if (m_bUsing)
            EndUse();
        
        if (Owner instanceof PlayerHUD)
        {
            if (cBinocularsHUD != null)
            {   
                if(((HUDBinocularsExtended)cBinocularsHUD).m_Binoculars == this)
                    ((HUDBinocularsExtended)cBinocularsHUD).m_Binoculars = null;
            }
        }
    }
    
    
    public void EndUse()
    {
        if ( cBinocularsHUD != null )
            cBinocularsHUD.Deactivate();
    }
    
    public class Idle extends State
    {
        public void OnEnter()
        {
//            LogD("OnEnter()\n");
            m_bUsing = false;
            if (nInvState != EInvObjState._ONGROUND) 
                DeactivateOnModuleAlways();
        }		
    }
    
    public void InGameMovieEnd()
    {
        EndUse();
        SetState("Idle");
        if (Owner != null && 
            Owner instanceof Player && 
            ((Player)Owner).cBinoculars != null)
            ((Player)Owner).RestoreViewAfterBinoculars();
    }
    
    void OnInputKeyTest(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
    }
	
 	//*********************************************************
	//					SaveGame
	//*********************************************************
	
	boolean m_bUsingSG = false;
				
	public void SGLoadChunk(FileChunk cParentFC)
	{
		FileChunk.Log("[Binoculars.SGLoadChunk]\n");
			
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
		if (cFC.GetID() == ESGChunksChrome._CHK_BINOCULARS)
		{
			super.SGLoadChunk(cFC);
			
			m_bUsingSG = cFC.LoadBool();
		}
			
		cFC.delete();
	}
	
	public void SGSaveChunk(FileChunk cParentFC)
	{
		FileChunk.Log("[Binoculars.SGSaveChunk]\n");
			
		FileChunk cFC = NewChunk(ESGChunksChrome._CHK_BINOCULARS, cParentFC);
			
		super.SGSaveChunk(cFC);
		
		cFC.SaveBool(m_bUsing);
			
		cFC.delete();
	}
		
	public void SGUpdate()
	{
		FileChunk.Log("[Binoculars.SGUpdate]\n");
			
		super.SGUpdate();			      
		
		//if (m_bUsing && !m_bUsingSG)
		{
			FileChunk.Log("[Binoculars.SGUpdate] END USE !\n");
			EndUse();
            if ( cBinocularsHUD != null )
                cBinocularsHUD.ForceDeactivate();
		}
		
		//if (!m_bUsing && m_bUsingSG)
		{
			FileChunk.Log("[Binoculars.SGUpdate] USE !\n");
		//	Use();
		}		
        SetState("Idle");
	}			
	
        
       
    public void Use()
    {
        if (((ChromeModule)GetModule()).bInFadeState && 
             ((ChromeModule)GetModule()).cMoviePlaying != null)
            return;
        
        super.Use();

        if (Owner != null && Owner instanceof PlayerHUD)
        {
            PlayerHUD player = (PlayerHUD) Owner;
            if (player.IsImplantActive(ImplantSystem._IMPLANT_TERMOVISION_SYSTEM))
                return;
            player.UseBinoculars(this);
        }
        
		/*if (cBinocularsHUD == null)// || !cBinocularsHUD.bActiveFlag)
			return; // w klasie nadrzednej nie udalo sie aktywowac huda*/
		
        if (Owner != null && Owner.bNetIsOwner)
        {
            ClearData();
		
		    if (m_bSetOutOfGrid)
		    {
		    	ActivateOnModuleGridIndependent();
		    	//m_bSetOutOfGrid = false;
		    }
        }
    }
	
    void ClearData()
    {
        fLastIdentificationUpdateTime = m_fLastCheckTraceTime = GetTime(); // zeby sie informacje pokazaly z opoznieniem
        aIdentifiedObjects.removeAllElements();
		m_iNofValidObjectInfos = 0;
    }
    
    /** Zwraca obiekt sledzony aktualnie przez lornetke
     */
    public ChromeActor GetTrackedObject() 
    {
		return m_TrackedObject;
    }
    
    /** Zwraca liste obiektow 'zwawych'
     */
    public java.util.Vector GetIdentifiedObjects()
    {
        float fCurrentTime = GetTime();
		
		// szukamy obiektow do podswietlenia
        if (fCurrentTime - fLastIdentificationUpdateTime > fIdentificationUpdateTime)
        {
            fLastIdentificationUpdateTime = fCurrentTime;
            if ( (cBinocularsHUD != null) && (cBinocularsHUD.cPlayer != null) )
            {
                Player cPlaya = cBinocularsHUD.cPlayer;
                if ( cPlaya.Camera == null )
                    return aIdentifiedObjects;
                    
                ControlObject aObjs[] = cPlaya.GetObjectsInRadiusFromClass(_IDENTIFICATION_RANGE,
																		   "ChromeActor");
                aIdentifiedObjects.removeAllElements();
				m_iNofValidObjectInfos = 0;
                
                float fAngleCos = (float) Math.cos(Math.atan(_BASE_IDENTIFICATION_TAN / cZoomer.GetZoom()));
                Vector vMainDir = cPlaya.Camera.GetForwardVector();
                vMainDir.Normalize();
                if (aObjs != null)
                {
					// znajdujemy wszystkie obiekty, ktore wchodza nam do stozka
                    for (int i = 0; i < aObjs.length; i++)
                    {
                        ChromeActor cChromeActor = (ChromeActor) aObjs[i];
                        if (cChromeActor.bIsActiveTarget)
                        {
                            Vector vObjDir = cPlaya.GetPosition();
                            vObjDir.Sub(cChromeActor.GetPosition());
                            vObjDir.Normalize();
                            float fDot = vObjDir.Dot(vMainDir);
							
                            if (fDot > fAngleCos) // jest w stozku
							{
								TargetObject target = null;
								if (m_iNofValidObjectInfos >= aObjectsInfos.size())
								{
									// vector sie przepelnil, dodajemy jeszcze jeden element
									target = new TargetObject();
									aObjectsInfos.addElement(target);
								}
								else
									target = (TargetObject) aObjectsInfos.elementAt(m_iNofValidObjectInfos);
								target.SetValues(cChromeActor, fDot);
								m_iNofValidObjectInfos++;
							}
                        }                                       
                    }
					
					// sortujemy obiekty
                    Object aObjInfoArray[] = new Object[m_iNofValidObjectInfos];
					for (int i = 0; i < m_iNofValidObjectInfos; i++)
						aObjInfoArray[i] = aObjectsInfos.elementAt(i);
                    java.util.Arrays.sort(aObjInfoArray);
					
                    // kopiujemy do tablicy wynikowej
                    for (int i = 0; i < m_iNofValidObjectInfos; i++)
					{
						TargetObject sorted = (TargetObject) aObjInfoArray[i];
						
						aObjectsInfos.setElementAt(sorted, i);
                        aIdentifiedObjects.addElement(sorted.cObject);
					}
                }
            }
            else
                CrashLog("[Binoculars.GetIdentifiedObjects] cBinocularsHUD or it's cPlayer is null!");
        }
		
        return aIdentifiedObjects;      
    }
	
	public boolean IsFirstObjectInFocus()
	{
        float fCurrentTime = GetTime();
		if (fCurrentTime - m_fLastCheckTraceTime > _BTW_TRACE_TIME)
		{
			m_TrackedObject = null;
			
			if ( (aObjectsInfos.size() == 0) ||
				 (m_iNofValidObjectInfos == 0) )
			{
				m_bIsFristObjectSpecial = false;
				return m_bIsFristObjectSpecial;
			}
		
			TargetObject target = (TargetObject) aObjectsInfos.elementAt(0);
			// czy miesci sie w obiektywie
			float fAngleCos = (float) Math.cos(Math.PI / 180.f * fTrackedIdentificationAngle);
			if (target.fDot <= fAngleCos)
			{
				m_bIsFristObjectSpecial = false;
				return m_bIsFristObjectSpecial;
			}
		
			// czy obiekt jest widoczny
            Vector vStart = Owner.GetPosition();
            Vector vEnd = target.cObject.GetPointToLookAt(0);
            
            if (vStart == null || vEnd == null)
            {
                // na wypadek, gdyby obiekty nagle byly zdezaktywowane
				m_bIsFristObjectSpecial = false;
				return m_bIsFristObjectSpecial;
            }
            vStart.fY += 183f;
    
            if (NewAI.AITrace(Owner, vStart, vEnd, NewAI._AITRACE_IGNORE_GLASS, new ControlObject[]{target.cObject}) != null)
			{
				m_bIsFristObjectSpecial = false;
				return m_bIsFristObjectSpecial;
			}

			m_TrackedObject = target.cObject;
			m_bIsFristObjectSpecial = true;
			
			m_fLastCheckTraceTime = fCurrentTime;
		}
		
		return m_bIsFristObjectSpecial;
	}
    
    static Vector GetMeshPoint(ChromeActor actor)
	{
        return actor.GetPointToLookAt(0);
	}
    
    void Acquire(Module mod, Pawn owner)
    {
        super.Acquire(mod, owner);

        cBinocularsHUD = null;
        
        if (cZoomer != null)
        {
            cZoomer.delete();
            cZoomer = null;
        }
        
        aIdentifiedObjects.removeAllElements();
        aObjectsInfos.removeAllElements();
        m_TrackedObject = null;
        m_bIsFristObjectSpecial = false;
        ClearData();
    }
    
    void ChangeInvState( Pawn owner, int newState )
    {
        super.ChangeInvState(owner, newState);
        SetFlag(EFlags._NOT_STATIC);
    }
}

/** Klasa - struktura zawierajaca dane obiektu do podswietlenia
 */
//#IGNORE_EXT_IMPL
class TargetObject implements Comparable
{
    ChromeActor cObject = null;
    float fDot = 0;
 
	TargetObject()
	{
	}
	
	void SetValues(ChromeActor cObject, float fDot)
	{
        this.cObject = cObject;
        this.fDot = fDot;
	}
	
    TargetObject(ChromeActor cObject, float fDot)
    {
        this.cObject = cObject;
        this.fDot = fDot;
    }
    
    /** Porownanie do sortowania po malejacych fDot'ach
     */
    public int compareTo(Object cObj)
    {
        float fDiff = ((TargetObject)cObj).fDot - fDot;
        return (fDiff > 0) ? 1 : (fDiff < 0) ? -1 : 0;
    }
}
