public class CloakingDevice extends BatteryChargedInvObject
{
    
    CloakingDevice()
    {
        super();
		
        MeshName = "Data/Meshes/Equipment/CloakingDevice.3da";
        nInvIndex = InvObject._E_CLOAKING_DEVICE;
        nInvType = EInvObjType._EQUIP;
        sName = "&E_N_CLOAKING_DEVICE&";
        sTexFileName = "CH_I_Weapons2.png";
      	nCellsWidth = 2;
	    nCellsHeight = 2;
        
        // wspolrzedne polozenia na teksturze
        nOnTexPosX = 120.0f;
        nOnTexPosY = 180.0f;
        
        // rozmiary tekstury
        nTexSizeX = 256.0f;
        nTexSizeY = 256.0f;
        
        m_fPower = 100f;
        
        float fWorkingTime = 60;
        /**Tempo zuzycia baterii (w % na sekunde)*/
        m_fPowerUsage = m_fPower/fWorkingTime;
        
        cTextureOn = new UITexture("CH_I_Weapons2.png", 256,256, 80, 180, 120, 220);
    }
    
    public void OnCreate()
    {
        super.OnCreate();
        SetCollFlags(GetCollFlags() | ECollFlags.OBJCOL_FLAG_ALIGNTOGROUND);
    }
    
    public void Use()
    {
        boolean bWasInUse = m_bInUse;
        super.Use();
        if (Owner != null && (bWasInUse != m_bInUse))
        {
            Owner.SetCloaking(m_bInUse);
        }
    }
    
    public void StopUsing()
    {
        super.StopUsing();
        if (Owner != null)
        {
            if (Owner instanceof Player)
			{
                ((Player)Owner).SetCloaking(false);
			}
        }
    }

    
    /*public void DeactivateOnModule()
    {
        printStackTrace("");
        super.DeactivateOnModule();
    }*/
    
}
