/** bomba wysadzajaca specjalne obiekty na levelach
 */
public class ExplosiveSpecial extends Explosive
{
	ExplosiveSpecialPlace m_PlantPlace = null;
	
    public void OnCreate()
    {
        super.OnCreate();
		
		cDamageType = new EnumDamageType(EnumDamageType._BLAST_SPECIAL);
	}
	
    public void Use()
    {
        // sprawdzam, czy tu mozna zaplantowac bombe
        Vector vStart = ((ChromeModuleSingle) GetModule()).MainPlayer.Camera.GetPosition();
        m_vEnd = ((ChromeModuleSingle)GetModule()).MainPlayer.Camera.GetForwardVector();
        m_vEnd.Mul(-fDistance);
        m_vEnd.Add(vStart);
        
		m_Collision = null;
		
		Collision coll = TraceTerrain(vStart, m_vEnd);
		if (coll != null)
			m_Collision = coll;

		coll = TraceTrees(vStart, m_vEnd);
		if (coll != null)
			m_Collision = coll;
		
		coll = TraceObjectsExclude(vStart, m_vEnd, Owner);
		if (coll != null)
			m_Collision = coll;
		
		if (m_Collision != null)
		{
			if (m_Collision.Obstacle instanceof ExplosiveSpecialPlace)
			{
				m_PlantPlace = (ExplosiveSpecialPlace) m_Collision.Obstacle;
				RetrieveTimeToExplode();
				return;
			}
		}
		Owner.TextMessage("&BOMB_CANNOT_PLANTED_POSITION&");                                                    
    }
	
	/** ustawienie bomby na obiekcie i czekanie na ustawienie timera */
    void PlantBomb()
    {
		if (m_PlantPlace != null)
		{
			FromUpForwardPos(m_PlantPlace.GetUpVector(),
							 m_PlantPlace.GetForwardVector(),
							 m_PlantPlace.GetPosition());
			ActivateOnModule();
			EnableRendering(true);
            m_PlantPlace.BombPlanted();
            ControlObject parent = m_PlantPlace.GetParent();
			if (bAttachToTarget && parent != null)
			    parent.AttachChildAndKeepWorldPos(this);
		}
		else
			super.PlantBomb();
    }
	
	public void Plant()
	{
		super.Plant();

		if (m_PlantPlace != null)
		{
            m_PlantPlace.DetachFromParentAndKeepWorldPos();
			m_PlantPlace.EnableRendering(false);
            m_PlantPlace.DeactivateOnModuleAlways();
			// nie mozna kasowac!!! bo save sie zwali
            //m_PlantPlace.delete();
			m_PlantPlace = null;
		}
	}
	
    void Acquire(Module mod, Pawn owner)
    {
        super.Acquire(mod, owner);
		m_PlantPlace = null;
    }		
}
