/** odtwarzacz mp3
 */

public class PortablePlayer extends InvObjectInst
{
    /** aktualny stan otwarzacza - playing lub nie playing
     */
    boolean bPlaying = false;
    
        
    public String sExplosionWave = "Data/Sounds/Ai/sgshot";//#PortablePlayer
	
    /** muzyczka jaka ma odgrywac po wlaczeniu w inv gracza
     */
    public String sMusicWave = "Data/Sounds/Equipment/mp3_loop1";//#PortablePlayer
    
    /** muzyczka jaka jest odgrywana poza inventory gracza
     */
    public String sMusicWaveOut = "Data/Sounds/Equipment/mp3_loop1_out";//#PortablePlayer
    
    /** identyfikator podpietego dzwieku do playera
     */
    int nSoundId = -1;
    
    public void OnCreate()
    {
        super.OnCreate();
        //losuje sie jeden z czterech wav'ow 1,2,3,4
        sMusicWave = "Data/Sounds/Equipment/mp3_loop" + RandomInt(1,5);
    }
    
    void Explode()
    {
        PlayWave(sExplosionWave);
    }
    
    public void Use()
    {
        if (bPlaying) 
            StopPlaying();
        else 
            Play();
    }
    
//--------------------------------------------------------------------------------    
    /** wlaczenie playera
     */
    public void Play()
    {
        if (!bPlaying)
        {
			if (Owner != null)
				nSoundId = Owner.AttachSound(sMusicWave, 100.0f, 300.0f);
            else
                nSoundId = AttachSound(sMusicWave, 100.0f, 300.0f);								

            SetSoundVolume(nSoundId, Music.fMusicVolume);
            bPlaying = true;
        }
    }
    
//--------------------------------------------------------------------------------
    /** wylaczenie playera
     */
    public void StopPlaying()
    {
        if (Owner != null)
            Owner.DetachSound(nSoundId); 
        else
            DetachSound(nSoundId);
        nSoundId = -1;
        bPlaying = false;
    }
    
    public void UpdateMusicVolume()
    {
        if (bPlaying)
        {
            if (nSoundId != -1)
                SetSoundVolume(nSoundId, Music.fMusicVolume);
        }
    }
//--------------------------------------------------------------------------------
    /** metoda wolana jest za kazdym razem, gdy przedmiot zostaje usuniety (wyrzucony) z inventory
     */
    public void OnRemoveFromInventory()
    {
        if (bPlaying)
        {
            Owner.DetachSound(nSoundId); 
            nSoundId = AttachSound(sMusicWave, 100.0f, 1000.0f);
        }
    } 
//--------------------------------------------------------------------------------
    /** metoda wolana jest za kazdym razem, gdy przedmiot zostanie podniesiony z ziemi i dodany do inventory
     */
    public void AddedToInventory()
    {
        if (bPlaying)
        {
            this.DetachSound(nSoundId); 
            nSoundId = -1;
            nSoundId = Owner.AttachSound(sMusicWave, 100.0f, 300.0f);
        }
            
    
    } 
    
    public void Unacquire()
    {
        StopPlaying();
        _bPlayingBeforeMovie = false;
    }
    
    boolean _bPlayingBeforeMovie = false;
    void InGameMovieStart()
    {
        _bPlayingBeforeMovie = bPlaying;
        StopPlaying();
    }
    
    void InGameMovieEnd()
    {
        if (_bPlayingBeforeMovie)
            Play();
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[PortablePlayer.SGLoadChunk]\n");
		
        FileChunk cFC = GameObject.LoadChunk(cParentFC);   
        
        if (cFC.GetID() == ESGChunksChrome._CHK_EXPLOSIVE)
        {	
			super.SGLoadChunk(cFC);
			
			StopPlaying();			
            
			if (cFC.LoadBool())				
				CallMethodIn("Play",0.1f);						
        }
		
		cFC.delete();
    }
    
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[PortablePlayer.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_EXPLOSIVE, cFCParent);
		
		super.SGSaveChunk(cFC);

        cFC.SaveBool( nSoundId > 0 );        
		    
        cFC.delete();
    }	    	
	

	/*
    public void SGUpdate()
    {
        super.SGUpdate();
        StopPlaying();
    }
	*/
    
    public void OnAudioReinitialize()
    {
        
        if (bPlaying)
        {
			if (Owner != null)
				CrashLog("[DUPA-OnAudioReinitialize] = Name = <"+Owner.GetName()+"> Class = <"+Owner.getClass().getName()+">");			
            if (Owner != null)
                nSoundId = Owner.AttachSound(sMusicWave, 100.0f, 300.0f);
            else
                nSoundId = AttachSound(sMusicWave, 100.0f, 300.0f);
                
            SetSoundVolume(nSoundId, Music.fMusicVolume);
        }
        

    }
    
//--------------------------------------------------------------------------------
    
}
