public class CannonControllerAPCNet extends CannonController
{
    String sSoundExplodeName   = "Data/Sounds/Explosion/RocketExplosionFF";
    float  fBlastRadius                 = 500.0f;
    float  fMaxExplCameraShake          = 200;
    float  fPlayerNetAimDevMultiplier   = 1.0f;

    
    ControlObject m_cDummyBullet = null;

    static int m_nActorClassId = 0;
    
    public void OnCreate()
    {
        if (m_nActorClassId == 0) 
            m_nActorClassId = GetClassID( "Actor" );
        
        super.OnCreate();
        
        m_cDummyBullet = (ControlObject)CreateObject("ControlObject");
            
        sSoundShoot = "data/sounds/weapon/EnergyFire";
        sFXCombName = "FXGrzebienAPCNet";
        sFXHitName  = "FXBlowAPCNet";
        
        fDamageMult                = 1.0f;
        fBlastRadius               = 1000.0f;
        fPlayerNetAimDevMultiplier = 0.5f;//1.0f
    }
    
    public void OnDestroy()
    {
        super.OnDestroy();
        
        if ( m_cDummyBullet != null )
        {
            m_cDummyBullet.delete();
            m_cDummyBullet = null;
        }
    }
    

    Vector m_vTarget = new Vector();
    
    public Vector GetFireDir()
    {
        Vector vDir = null;

        m_vTarget.Set( m_fAimX, m_fAimY, m_fAimZ );
                
        if (m_vTarget != null)
        {
            vDir = m_vTarget; 
            vDir.Sub( GetFireOrigin() );
            vDir.Normalize();
        }
        else
        {
            vDir = m_OwnerMesh.GetElementForwardVector( m_nElementV );
        }

        float fTempAimMult;
        if ( m_CannonUser instanceof Player)
            fTempAimMult = fPlayerNetAimDevMultiplier * ((Player)m_CannonUser).fCurrentAccuracy;
        else
            fTempAimMult = fAimMultiplier * ChromeGame.GetCannonAimingDiffLevelMult();
        
        Vector vDev = new Vector( ((RandomFloat(1.0f) - 0.5f) * fTempAimMult/100.f),
                                  ((RandomFloat(1.0f) - 0.5f) * fTempAimMult/100.f), 
                                  ((RandomFloat(1.0f) - 0.5f) * fTempAimMult/100.f) );
        vDir.Add( vDev );
        vDir.Normalize();

        return vDir;
    }
    
    
    void Hit(float fDistance, ControlObject cObstacle, int nObstacleElement, Vector vHitPoint, Vector vDir, Vector vNormal, int nMaterial, int nMaterialFlags, boolean bWaterHit)
    {
        Vector vPos = vHitPoint;
        ExecuteFX( sFXHitName, vPos );
        ExecuteParticleSystem( sFXHitName, vPos, Vector.Up );
        if ( sSoundExplodeName != null )
            PlaySound( sSoundExplodeName, vPos );
        
        Actor cExcludeObj = (cObstacle instanceof Actor)?
                              (Actor)cObstacle : null;
        MakeBlastDamageAndCameraShake( fDamage * fDamageMult, 
                                       fPhysicsSimDamage, 
                                       vPos, fBlastRadius, 
                                       false, cExcludeObj );
        PassengersCameraShake();
        
        
        super.Hit( fDistance, cObstacle, nObstacleElement, 
                   vHitPoint, vDir,      vNormal, 
                   nMaterial, nMaterialFlags, 
                   bWaterHit );
    }
    
    public void MakeBlastDamageAndCameraShake(float fInBlastDamage, 
                                              float fPhSimDamage, 
                                              Vector vPos, float fBlastRange, 
                                              boolean bExcludeActor, Actor cExcludeObj)
    {
        //LogR("HIT "+((cExcludeObj!=null)?cExcludeObj.GetNetInfo():"none")+" Damage "+fDamage); 
        
        m_cDummyBullet.SetPosition( vPos );
        ControlObject[] aObjects = m_cDummyBullet.GetObjectsInRadiusFromClass(
                                                  fBlastRange, 
                                                  m_nActorClassId );
        Actor  cActor = null;
        Vector vSpeed = null;
        for(int i=0; i<aObjects.length; i++)
        {
            float fBlastDamage = fInBlastDamage;
                
            cActor = (Actor)aObjects[i]; 
            
            
            
            if ( cActor instanceof Player )
            {
                Player cPlayer = (Player)cActor;
                ShakeCameraPlayer( cPlayer );
                
                if ( (cPlayer.cSeatInfo != null)&&
                     (cPlayer.cSeatInfo.GetOccupiedObject() instanceof Vehicle) )
                {
                    fBlastDamage *= 
                        ((Vehicle)cPlayer.cSeatInfo.GetOccupiedObject()).GetOccupantsBlastDamageMul();
                }
            }
            
            if ( Role < ERole._AUTHORITY )
                continue;
            
            if ( cExcludeObj == cActor )
                continue;
            
            // sprawdzamy czy sobie nie odejmowac energii
            if ( bExcludeActor && ( cActor == this ) ) 
                continue;
                
            // umarlaki nie maja co miec zabieranego damagu
            if (cActor.bDead) 
                continue;
                
            float fRange = vPos.Distance(cActor.GetPosition());
            if (fRange < fBlastRange)
            {
                float fDamage = (fBlastRange - fRange) / fBlastRange;
                float fPhDamage = fDamage;
                fDamage *= fBlastDamage;
                fPhDamage *= fPhSimDamage;
                // liczymy kierunek predkosci
                vSpeed = cActor.GetPosition();
                vSpeed.Sub(vPos);
                vSpeed.Normalize();
                vSpeed.Mul(100000.0f);
                    
                // w odleglosci 30% zasiegu dzialania bulleta i tak zabiera energie
                if (fRange > fBlastRange*0.3f)
                {
                    // liczymy trace'a czy czasem cos nie zaslania obiektu
                    Vector vActorMin = new Vector();
                    Vector vActorMax = new Vector();
                    cActor.GetMeshExtents(vActorMin, vActorMax);
                    
                    vActorMin.fX = 0; vActorMin.fZ = 0;
                    
                    // inaczej sprawdzamy czy nie schowal sie ktos za przeszkoda
                    int nSamples = 4;
                    float fStep = (vActorMax.fY - vActorMin.fY) / ((float)nSamples);
                    float fDamageStep = fDamage/((float)nSamples);
                    float fPhDamageStep = fPhDamage/((float)nSamples);
                    for(int j=0; j<nSamples; ++j)
                    {
                        if(!CheckTrace(cActor, new Vector(), vActorMin))
                        {
                            // nie ma trafienia, wiec odbieramy mniej energii
                            fDamage -= fDamageStep;
                            fPhDamage -= fPhDamageStep;
                        }
                        vActorMin.fY += fStep;
                    }
                }
            
                //LogR("BLAST "+cActor.GetNetInfo()+" Damage "+fDamage); 
                cActor.TakeDamage( fDamage, fPhDamage, Owner, 
                                  Vector.Up, vSpeed, 
                                  EBones._SPINE , EnumDamageType._BULLET );
            }
            
        }
    }
    
    void PassengersCameraShake()
    {
        if (! (m_CannonUser instanceof Player))
            return;
        
        Player cPlayer = (Player)m_CannonUser; 
        SeatInfo cSeat = cPlayer.cSeatInfo;
        if ( cSeat == null )
            return;
        
        TriggerObject cOccupiedObject = cSeat.GetOccupiedObject();
        if ( ! (cOccupiedObject instanceof Vehicle) )
            return;
        
        Vehicle cVehicle = (Vehicle)cOccupiedObject;
        Pawn[] aPawns    = cVehicle.GetAllOccupants();
        if ( aPawns == null )
            return;
        
        for ( int i=0; i<aPawns.length; ++i )
        {
            if ( aPawns[ i ] instanceof Player )
            {
                ShakeCameraPlayer( (Player)aPawns[ i ] );
            }
        }
    }
    
    private void ShakeCameraPlayer(Player cPlayer)
    {
        if (cPlayer != null && cPlayer.Camera != null)
        {
            float dist2 = GetDistance2To( cPlayer );
            float fShakeVal = fMaxExplCameraShake *
                              (1 - Tools.InterpLinear(0, fBlastRadius * fBlastRadius, dist2));
            if (fShakeVal > 1)
                cPlayer.Camera.ShakeImpulse( fShakeVal, fShakeVal, fShakeVal, CameraPlayer._SHAKE_EXPLOSION );
        }
    }
    
}
