public interface ICannonController extends ISaveGame
{
    void InitController(ICannonMesh cOwnerMesh);

    boolean StartManualControl(Pawn cUser, 
                               float fOverGunHeight, float fOverGunBack,
                               float fOverGunHeightAim, float fOverGunBackAim,
							   float fOverGunFOV, float fOverGunAimFOV,
                               boolean bUseGyro);
    void StopManualControl();
    
    void StartAutonomicHuntingByUser(ChromeActor cUser);
    void StartAutonomicHuntingByConflictSide(int nConflictSide);
    void StopAutonomicHunting();
    
    void SetTargetFindingAngle(float fFindingAngle);
    float GetTargetFindingAngle();

    void SetMaxHorizAngle(float fMaxHorizAngle);
    float GetMaxHorizAngle();

    void SetMinVertAngle(float fMinVertAngle);
    float GetMinVertAngle();

    void SetMaxVertAngle(float fMaxVertAngle);
    float GetMaxVertAngle();
    
    void SetHorizAngSpeed(float fSpeed);
    void SetVertAngSpeed(float fSpeed);
    
    void SetFireParams(int nShots, float fRateOfFire, float fLongDelay, float fRange, float fDamage);
    void SetAmmo(int nAmmoCount);
    void SetInitialFireDelay(float fDelay);

    void SetParticleSystem(String sParticleSystem);
    
    ICannonMesh GetOwnerMesh();
    ChromeActor GetTarget();
    boolean HasClearShot();

    Vector GetFireDir();
    Vector GetFireOrigin();
    Vector GetCannonDir();
    Vector GetCannonOrigin();
    void AimAtPoint(Vector vPoint);
	
	float GetBaseAccuracy();
	float GetAimAccChange();
	void SetAimMultiplier(float fMul); // <0, 1>, 1 == najcelniej
	
	void SetFXHitName(String sFXHitName);
	void SetBeamProbability(float fProbability);
	void SetBeamFX(String sBeamName);
    void SetCombFX(String sCombName);
	
	void ActivateInAutoMode(boolean bActivate);
	boolean IsActiveInAutoMode();
    
    void StartFire(byte nMode);
    void SuperStartFire(byte nMode);
    void StopFire();
    
    void SetAccuracy(float fBase, float fAim);
    
    void Die();
    
    // a to jest popierdolone
    void SetFXSizeX(float fSize);
    void SetMinBeamDistance(float fDistance);
    
    void SetShotSound(String sSoundName);
    void SetShotSoundRange(float fMin, float fMax);
    
    Vector GetCannonToParentPositionDiff();
}
