public class StationaryCannonNet extends StationaryCannon
{
    StationaryCannonNet()
    {
        super();
        
        m_cCannonControllerClass = StationaryCannonControllerNet.class;

        //Cannons in net game are not destroyable
        m_bDestroyable = false;
        
        //SP params:
        /*
        nRoundShots = 12;
        fRateOfFire = 600f;
        fLongDelay = 3f;
        fFireRange = 5000f;
        fFireDamage = 100f;

        m_fBaseAccuracy = 3.5f;
        m_fAimAccuracy  = 2.0f;
    
        m_fMaxHAngle = 45f;
        m_fMinVAngle = -30f;
        m_fMaxVAngle = 30f;
        */
        
        //full revolution
        m_fMaxHAngle = 360f;
        
        m_fBaseAccuracy = 2.5f;
        m_fAimAccuracy  = 1.0f;//1.15f;// aim accuracy as WeaponRifle
        //damage and rate of fire as JeepNet
        fFireRange  = 20000f;
        fFireDamage = 105.0f;//75f;
        fRateOfFire = 550f; // don't set more than 600 cause efficiency
                
        nRoundShots = 60;
        fLongDelay  = 4.0f;
    }
    
    void OverHeat()
    {
        m_fOverHeatTime = GetTime();
        //CallMethodEvery("UpdateOverHeatSounds", 0.01f);
    }
    
    void StillOverHeat()
    {
        m_bFiring = false;
    }
    
    String  m_sOverHeatSoundName = "Data/Sounds/Weapon/EnergyCharge";
    int     m_iOverHeatSoundId = 0;
    float   m_fMinOverHeatFreq = 0.7f;
    float   m_fMaxOverHeatFreq = 2f;
    
    float   m_fOverHeatTime = 0f;
    
    public void UpdateOverHeatSounds()
    {
        float fTime = GetTime() - m_fOverHeatTime;

        if (fTime > fLongDelay)
        {
            DetachOverHeatSound();
            DisableCallMethod("UpdateChargeSounds");    
            return;
        }
        
        if (m_iOverHeatSoundId == 0)
            AttachOverHeatSound();
            
        if (m_iOverHeatSoundId != 0)
        {
            // zmieniamy czestotliwosc
            float fFreq =  m_fMinOverHeatFreq +
                          (m_fMaxOverHeatFreq - m_fMinOverHeatFreq) * fTime / fLongDelay;
            SetSoundFreq( m_iOverHeatSoundId, fFreq );
        }
    }
    
    private void AttachOverHeatSound()
    {
        if ((m_sOverHeatSoundName != null) && (m_iOverHeatSoundId == 0) )
             m_iOverHeatSoundId = AttachSound(m_sOverHeatSoundName, 1000f, 5000f);
    }
    
    private void DetachOverHeatSound()
    {
        if (m_iOverHeatSoundId != 0)
        {
            DetachSound(m_iOverHeatSoundId);            
            m_iOverHeatSoundId = 0;
        }
    }
    
    
}
