public class StationaryRocketCannonControllerNet extends RocketCannonController
{
    StationaryRocketCannonControllerNet()
    {
        super();
        sRocketClassName = "RocketStationaryCannonNet";
    }

    
    //ignore CreateRocket() called from RocketCannonController
    //we will call CreateNetRocket() if we want it
    void CreateRocket()
    {
    }

    void CreateNetRocket()
    {
        if ( Role == ERole._AUTHORITY )
        {
            cBullet = (Rocket) CreateObject(sRocketClassName);    
            if (cBullet != null)
            {
                cBullet.Init( this, (ChromeActor)m_OwnerMesh );
            }
        }
    }
    
    //first rocket will be create ASAP
    public void OnCreate()
    {
        CreateNetRocket();
        
        super.OnCreate();
    }
    
    //next rockets we create after every shot
    void Fire(Vector vBarrelPos, Vector vDir)
    {
        super.Fire( vBarrelPos, vDir );
        
        CreateNetRocket();
    }
    
    //when player start/stop using cannon
    //cannon (and rocket) should know about it
    void SetPlayerManual(Player player)
    {
        super.SetPlayerManual( player );
        ChangeNetOwner( player );
        if ( cBullet != null )
            cBullet.ChangeNetOwner( player );
    }
    
    //rocket should be initialized AFTER controller
    public void InitController(ICannonMesh cOwnerMesh)
    {
        super.InitController( cOwnerMesh );
        
        if ( cBullet != null )
        {
            cBullet.Init( this, (ChromeActor)cOwnerMesh );
        }
    }
}
