public class RocketCannon extends StationaryCannon
{
    RocketCannon()
    {
        super();
        
        fFireDamage = 1500f;
        fRateOfFire = 30f;
        fFireRange = 10000f;
        
        m_fBaseAccuracy = 2.0f;
        m_fAimAccuracy  = 1.5f;
        
        m_cMeshName = "data/meshes/ai/ckmb.3da";
        m_cAnimSeqFile = null;
        m_sWreckMeshName = "data/meshes/ai/ckmbwreck.3da";
        
        m_cCannonControllerClass = RocketCannonController.class;
    }
        
    void InitCannonController(ICannonController cNewCannon)
    {
        //MK: dlaczego tu nie ma super ? przeciez
        //tam sie te same parametry inicjalizuja!
        
        // inicjalizujemy guna
        m_Cannon = cNewCannon;
        m_Cannon.InitController(this);
        
		m_Cannon.SetHorizAngSpeed(500f);
		m_Cannon.SetVertAngSpeed(500f);
        m_Cannon.SetFireParams( nRoundShots, fRateOfFire, fLongDelay, 
							    fFireRange, fFireDamage );
		
		// ustalenie rozrzutu broni
        m_Cannon.SetAccuracy(m_fBaseAccuracy,m_fAimAccuracy);
            
		// ustalenie katow dla stationary cannon
		m_Cannon.SetTargetFindingAngle(m_fMaxHAngle);
		m_Cannon.SetMaxHorizAngle(m_fMaxHAngle);
		m_Cannon.SetMinVertAngle(m_fMinVAngle);
		m_Cannon.SetMaxVertAngle(m_fMaxVAngle);

        m_Cannon.SetInitialFireDelay(m_fShootVisibleDelay);
    }
    
    public void FireStarted(byte nMode)
    {
        m_Cannon.SuperStartFire(nMode);
    }
}
