public class RocketCannonController extends CannonController
{
    /** Lista rakiet jaie zostaly wystrzelone i nie skasowane */
    java.util.Vector vRocketList = new java.util.Vector();
    
    /** Rodzaj wystrzeliwanej rakiety */
    String sRocketClassName = "Rocket";

    /** rakieta, ktora strzelamy */
    //MK: a po jasna ciasna to jest tu jak juz jest bullet w WeaponBullet!
    //public Rocket cBullet = null;
    
    RocketCannonController()
    {
        eBulletType = EAmmoType._HEX;    
        fShakeImpulseForce = 2000;
    }
    
    public void OnCreate()
    {
        super.OnCreate();

    	sFXCombName = "FXRocketCombSmoke";
        sSoundShoot = "Data/Sounds/Weapon/H02_Fire";
    }
    
    void CreateRocket()
    {
        if ( Role == ERole._AUTHORITY )
        {
            Rocket cRocket = (Rocket) CreateObject(sRocketClassName);    
            if (cRocket != null)
            {
                cRocket.fDamage = 0;
                cRocket.fBlastDamage = ((StationaryCannon) m_OwnerMesh).fFireDamage;
                cRocket.fRange = ((StationaryCannon) m_OwnerMesh).fFireRange;
                cRocket.Init(this, (ChromeActor)m_OwnerMesh);
                
                cBullet = cRocket;
            }
            else
                LogD("ERROR:Rocket not created\n");
        }
    }
    
    
    
    void SetShakeImpulse()
    {
        
        vShakeImpulse.Set( fShakeImpulseForce/100f * RandomFloat(-1,2), 
                           RandomFloat(1f) > 0.5f ? fShakeImpulseForce : -fShakeImpulseForce, 
                           RandomFloat(1f) > 0.5f ? fShakeImpulseForce : -fShakeImpulseForce);
    }
    
    void Fire(Vector vBarrelPos, Vector vDir)
    {
        CreateRocket();
        
        fLastShotT = GetTime();
        
        if (cBullet != null)
        {
            vRocketList.addElement( cBullet );
            cBullet.ActionStart( this, 0f, vBarrelPos, vDir );
        }
        else
            CrashLog("[RocketCannonController.Fire] no bullet\n");

        // dodajemy efekty zwiazane z wystrzalem
        //wczesniej nalezy ustawic odowiednie pola FXa
        
        if (sFXCombName != null)
            ExecuteFX(sFXCombName, GetFireOrigin());

        m_OwnerMesh.PlaySound(sSoundShoot, fMinShootSound, fMaxShootSound);
        m_OwnerMesh.MakeNoise(fNoiseShot, Pawn._NOISE_WEAPON_FIRING);
        
        if (m_CannonUser instanceof Player)
        {
            CameraPlayer cCamera = ((Player)m_CannonUser).Camera;
            
            
            SetShakeImpulse();
            
            if ( cCamera != null )
                cCamera.ShakeImpulse(vShakeImpulse, CameraPlayer._SHAKE_CANNON_2 , false);
            
        }
        
        CreateRocket();
    }
    /*
    void RemoveBullet()
    {
        //cRocket.delete();
        //cRocket = null;
        for( int index = 0; index < vRocketList.size() ; index++ )
        {
            if(((Rocket)vRocketList.elementAt(index)).bExploded)
            {
                Rocket cTemp = (Rocket)vRocketList.elementAt(index);
                vRocketList.removeElementAt(index);
                cTemp.delete();
                cTemp = null;
                break;
            }
        }
    }*/
}
