public class WeaponHeavyElectro extends Weapon
{
    boolean _bShowHitMeshes = false;
    
    
    WeaponHeavyElectro()
    {
        super();

        MeshName="Data/Meshes/Equipment/TPPplasma.3DA";
        m_nFireMode = _FIREMODE_SINGLE;        
        //Weapon
        nType = EWeaponType._HEAVY;

        //InvObject properites
        nInvIndex = InvObject._W_HEAVY_ELECTRO;
        sName = "&W_N_ELECTRO&";
        
        sTexFileName = "Data/Textures/CH_I_Weapons1.png";
        
        //wspolrzedne polozenia na teksturze
        nOnTexPosX = 0.0f;
        nOnTexPosY = 100.0f;
        
        //rozmiary tekstury
        nTexSizeX = 256.0f;
        nTexSizeY = 256.0f;

		// Ilosc kratek zajmowanych w plecaku
	    nCellsHeight = 3;
	    nCellsWidth = 9;
		
        fRecoilShiftChange = 0.03f;
        vRecoilShift = new Vector(0.0f, 0.7f, 0f);
        
		m_bShowFXBeam = false;
        fBaseAcc = 0.9f;
        
        eBulletType = EAmmoType._Energy;
        
        fDamage             = 250.0f;
        fPhysicsSimDamage   = 50;
        fRange              = 3000.0f;
        fBulletSpeed        = 100000.0f;
	    fRateOfFire         = 20.0f;
	    eBulletType         = EAmmoType._Energy;
		nCapacity		    = 10;
		
		fNoiseShot = 1000.0f;
		fNoiseHit  = 300.0f;
		
        /**Nazwa dzieku odpalanego przy wystrzale */
        sSoundShoot = "Data/Sounds/Weapon/EnergyFire";
        sSoundReload = "Data/Sounds/Weapon/H03_Reload";

        fMinShootSound = 1000.f;
        fMaxShootSound = 9000.f;
        
		/**Nazwa FX odpalanego przy wystrzale (grzebien)*/
		sFXCombName = "FXGrzebienHeavyElectro";
        
        /** Klasa mesha pokazywanego w FPP */
        sFPPHandsClass = "FPPHandsPlasma";
		fShootLightScale = 1000;
        vShootLightColor = new Vector(0.5f,0.5f,1f);
    }
    
    //String sSoundCharged = "";
    
    public String sBeamName = "FXBeamElectro";

    
    /*public void FireStopped()
    {
        super.FireStopped();

        DisableCallMethod("UpdateChargeSounds");
        DisableCallMethod("DelayStartFire");
        DetachChargeSound();
        ReplaceOriginalMaterial(nChargeMaterial, aPreloadedChargeMaterials[0] );
    }*/
    
    String m_ChargeSoundName = "Data/Sounds/Weapon/EnergyCharge";
    int m_iChargeSoundId = 0;
    float m_fMinChargeFreq = 0.7f;
    float m_fMaxChargeFreq = 2f;
    float m_fStartTime = 0f;
    
    
    void AttachChargeSound()
    {
        if ((m_ChargeSoundName != null) && (m_iChargeSoundId == 0) )
        {
            if (Owner != null)
            {
                m_iChargeSoundId = Owner.AttachSound(m_ChargeSoundName, 1000f, 5000f);
                //LogR("ATTACHING SOUND " + m_iChargeSoundId);
            }
        }
    }
    
    void DetachChargeSound()
    {
        if (m_iChargeSoundId != 0)
        {
            if (Owner != null)
                Owner.DetachSound(m_iChargeSoundId);            
            //LogR("DETACHING SOUND " + m_iChargeSoundId);
            m_iChargeSoundId = 0;
        }
    }
    
    FPPHandsPlasma m_cFppMesh = null;
    
    public void UpdateChargeSounds()
    {
        if (nAmmo <= 0)
        {
            if (m_cFppMesh != null)
                m_cFppMesh.SetChargeMaterial(0);
            return;
        }
        
        float fTime = GetTime() - fLastShotT;
        if (fLastShotT == 0f)
        {
            fLastShotT = fTime - fDelay;
            return;
        }
        if (fTime > fDelay)
            fTime = fDelay;
        
        if (m_iChargeSoundId == 0)
            AttachChargeSound();
            
        if (m_iChargeSoundId != 0)
        {
            // zmieniamy czestotliwosc
            float fFreq = m_fMinChargeFreq +
                          (m_fMaxChargeFreq - m_fMinChargeFreq) * fTime / fDelay;
            if (Owner != null)
                Owner.SetSoundFreq(m_iChargeSoundId, fFreq);
            else
                SetSoundFreq(m_iChargeSoundId, fFreq);
        }

        if (m_cFppMesh == null)
        {
            DetachChargeSound();
            return;
        }
        
        int nMat = (int)((float)(m_cFppMesh.nChargeMaterialsCount - 1) * (fTime/fDelay));

        if (nMat == m_cFppMesh.nChargeMaterialsCount - 1)
        {
            if (GetState() != STATE_READY)
                nMat--;
            else
            {
                DetachChargeSound();
                DisableCallMethod("UpdateChargeSounds");
                //Owner.AttachOneShotSound(sSoundCharged, fMinShootSound, fMaxShootSound);
            }
        }

        m_cFppMesh.SetChargeMaterial(nMat);
            
    }
    
    public void OnRemoveFromInventory()
    {
        DetachChargeSound();
        super.OnRemoveFromInventory();
    }
    
    void Reload(int nCount)
    {
        if (nAmmo == 0 && nCount > 0)
            fLastShotT = GetTime();
        
        super.Reload(nCount);
    }
    
    void ChangeInvState( Pawn owner, int newState )
    {
        switch (newState)
        {
        case EInvObjState._ONGROUND :
            DetachChargeSound();
            CallOnFrameEnd("OnGround");
            break;

        case EInvObjState._HANDS :
            DetachChargeSound();
            CallOnFrameEnd("Hands");
            break;

        case EInvObjState._INVENTORY:
            DetachChargeSound();
            CallOnFrameEnd("Inventory");
            break;
        }

        super.ChangeInvState(owner, newState);
    }
    
    void OnGround()
    {
        DisableCallMethod("UpdateChargeSounds");
        m_cFppMesh = null;
    }        
    
    void Hands()
    {
        m_cFppMesh = null;
        if (Owner instanceof Player)
        {
            if ( ((Player)Owner).HandsAnims != null )
            {
                FPPHands cHands = (FPPHands)((Player)Owner).HandsAnims.cMesh;
                if (cHands instanceof FPPHandsPlasma)
                    m_cFppMesh = (FPPHandsPlasma)cHands;
            }
            
        }
        CallMethodEvery("UpdateChargeSounds", 0.01f);
    }
    
    void Inventory()
    {
        DisableCallMethod("UpdateChargeSounds");
        m_cFppMesh = null;
    }
    
    java.util.Vector vMeshes = new java.util.Vector();
    
    void Fire(Vector vBarrel, Vector vDir)
    {
        for (int i = 0; i < vMeshes.size(); i++)
        {
            ((ControlObject)vMeshes.elementAt(i)).CallMethodIn("delete",0);
        }
        
        vMeshes.removeAllElements();
        
        super.Fire(vBarrel, vDir);

        Vector vBarrelDummyPos = null;
        if (Owner instanceof Player)
        {
            vBarrelDummyPos = ((Player)Owner).GetWeaponBarrelPos();
        }
        else
        {
            vBarrelDummyPos = PointLocalToWorld(vBarrelElementPos);
        }
        //ustawienia fx beama 
        ExecuteFX(// cOwner, sElementBarrelExit,
                  sBeamName,//
                  vBarrelDummyPos, vDir
                  );
        
        Vector vStart = new Vector(vBarrel), vTempEnd = new Vector();
        Vector vEnd = new Vector();
        ControlObject cExclude = Owner;
        Collision stColl = null;
        Collision stCollTerrain = null;
        float fBeamLength = fRange;
        while (true)
        {
            // wyliczamy, pobieramy, ustalamy kierunek w ktory strzelamy
            vEnd.Set(vDir);
            vEnd.Mul(fBeamLength);
            vEnd.Add(vStart);
            
            /*stColl = TraceTerrain(vStart, vEnd);
            if(stCollTerrain != null)
            {
                // trafienie w ziemie
                fDist = stCollTerrain.fDistance;
            }

            Collision stCollTrees=TraceTrees(vBarrelPos, vEnd);
            if(stCollTrees!=null)
            {
                // trafienie w drzewo
                if (stCollTrees.fDistance < fDist)
                    fDist = stCollTrees.fDistance;
            }*/
 
            vTempEnd.Set(vEnd);
            
            Collision stCollObjects = TraceObjectsExclude(vStart, vTempEnd, cExclude);
            
            if(stCollObjects!=null)
            {
                if (_bShowHitMeshes)
                {
                    ControlObject cMesh = Tools.AddHelperMesh(this, Tools._HM_MESH_CUBE);
                    vMeshes.addElement(cMesh);
                    cMesh.SetPosition(vTempEnd);
                }
                
                //zaczynamy od miejsca trafienia
                vStart.Set(vTempEnd);
                
                //zapamietujemy ostatnio trafiony controlObject
                cExclude = stCollObjects.Obstacle;
                
                if (stCollObjects.Obstacle != Owner)
                {
                    Hit(stCollObjects.fDistance, 
                        stCollObjects.Obstacle, 
                        stCollObjects.ObstacleElement, 
                        vTempEnd, 
                        vDir, 
                        stCollObjects.vNormal, 
                        stCollObjects.nMaterial);
                }
            }
            else 
                break;
        }
        
        Owner.AttachOneShotSound(sSoundShoot, fMinShootSound, fMaxShootSound);
        Owner.ExecuteFXBarrel(sFXCombName);
        CallMethodEvery("UpdateChargeSounds", 0.01f);
    }

    
    void Hit(float fDistance, ControlObject cObstacle, int nObstacleElement, Vector vHitPoint, Vector vDir, Vector vNormal, int nMaterial)
    {
        // kiedy jest jakis cel to odbieramy energie
        Vector vSpeed = new Vector(vDir);//bo cObstacle.TakeDamage() normalizuje wektor 
        if(cObstacle != null)
        {
            int iBoneId = ((MeshObject)cObstacle).GetBoneIDFromMeshElem(nObstacleElement);
            cObstacle.TakeDamage(fDamage * fDamageMult, fPhysicsSimDamage, Owner, vHitPoint, vSpeed, iBoneId, EnumDamageType._BULLET);
        }
        
        int nMaterialToUse = EMaterialType._GROUND;
        if(nMaterial>-1) nMaterialToUse=nMaterial;
        
        //CrashLog("Hit on material <"+nMaterialToUse+">\n");
        
        // odpalamy efekt trafienia
        /*FxAndSoundManager(Owner,
                          nMaterialToUse,
                          vHitPoint, vNormal, vSpeed,
                          cObstacle, nObstacleElement,
                          eBulletType, sFXHitName );*/
    }
	
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza     
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[WeaponHeavyElectro.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_WEAPON)
        {	
			super.SGLoadChunk(cFC);
			
        }
		
		cFC.delete();
    }
    
    /** Metoda zapisujaca dane do Save gracza
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[WeaponHeavyElectro.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_WEAPON, cFCParent);
		
		super.SGSaveChunk(cFC);
        
        // kasujemy
        cFC.delete();
    }	   
	*/
	
	public void SGUpdate()
	{
		FileChunk.Log("[WeaponHeavyElectro.SGUpdate]\n");
		super.SGUpdate();
		
		if (m_iChargeSoundId != 0)
		{
            if (Owner != null)
			    Owner.DetachSound(m_iChargeSoundId);
            else
                DetachSound(m_iChargeSoundId);
			m_iChargeSoundId = 0;
		}		
	}
    
    public void OnAudioReinitialize()
    {
        if (m_iChargeSoundId != 0)
        {
            m_iChargeSoundId = 0;
            AttachChargeSound();
            UpdateChargeSounds();
        }
    }
	
}
