public class WeaponRifleSniper extends WeaponBulletSniper
{
    /** Wartosci zooma dla kolejnych przyblizen 
     */
    public float aSniperZoomFactors[] = { 6.f, 9.f, 15.f };
    
    WeaponRifleSniper()
    {
        super();

        m_nFireMode = _FIREMODE_SINGLE;
        //MeshObject
        MeshName="Data/Meshes/Equipment/TPPsniper.3DA";
        
        //Weapon
        nType = EWeaponType._RIFLE;

        //InvObject properites
        nInvIndex = InvObject._W_RIFLE_SNIPER;
        sName = "&W_N_SNIPER&";
        //sInfo = "Ammo : 8mmLong \nDamage : High \nRoF : 45 SemiAuto";
        sTexFileName = "Data/Textures/CH_I_Weapons3.png";
        
        //wspolrzedne polozenia na teksturze
        nOnTexPosX = 0.0f;
        nOnTexPosY = 60.0f;
        
        //rozmiary tekstury
        nTexSizeX = 256.0f;
        nTexSizeY = 256.0f;

		// Ilosc kratek zajmowanych w plecaku
	    nCellsHeight = 3;
	    nCellsWidth = 9;
		
	    //WeaponPistol properties
	    fBaseAcc  = 7.0f;
        fRecoilAccChange = 3.5f;
		fAccuracyChangeSpeed = 8.0f;
		fAimAcc = 0f;

        fRecoilShiftChange= 0.06f;
        //TODO jesli trzeba to zmodyfikowac
        //vRecoilShift = new Vector(0, 0.5f, 0);

        fDamage             = 90.0f;
        fPhysicsSimDamage   = 200f;
        fRange              = 75000.0f;
        fBulletSpeed        = 90000.0f;
	    fRateOfFire         = 60.0f;
	    eBulletType         = EAmmoType._14mmLong;
		nCapacity		    = 12;
		bMountable          = true;

		fNoiseShot = 9000.0f; // zmienione z 5000.0f; a pozniej z 70000...
		fNoiseHit  = 1500.0f;

        /** Klasa mesha pokazywanego w FPP */
        sFPPHandsClass = "FPPHandsSniper";
        
        /**Nazwa dzieku odpalanego przy wystrzale */
        sSoundShoot = "Data/Sounds/Weapon/R05_Fire";  
        sSoundReload = "Data/Sounds/Weapon/R05_Reload";
        sSoundEmpty = "Data/Sounds/Weapon/R05_Click";
        
        fMinShootSound = 200.f;
        fMaxShootSound = 20000.f;

		/**Nazwa FX odpalanego przy wystrzale (grzebien)*/
		sFXCombName = "FXGrzebienRifleSniper";
		
        ////////////////////////////////////////////////////////////////////////////
        //                         PARAMETRY DLA AI                               //
        ////////////////////////////////////////////////////////////////////////////
        nAIFireModes = _FIREMODE_SINGLE;
        fAIAimingDeviation = 0.07f;
        //fAIBurstAimingDeviation = 0.5f;
        //fAISingleFireDelay = 0.5f;
        //fAIRandomSingleFireDelay = 2.f;
        //fAIBurstFireDelay = 0.5f;
        //fAIRandomBurstFireDelay = .1f;
        nAIMinSingleFireBullets = 1;
        nAIMaxSingleFireBullets = 1;
        //fAIBurstTime = 0.5f;
        //fAIRandomBurstTime = .5f;
        //fAIMaxBurstDistance = 2000;
        nAIReadinessToAim = 99;
        nAIReadinessToStopAiming = 0;
        fAIEffectiveRange = 25000.f;
        //fAIHidingPosTime = 1.1f;
        //fAIRandomHidingPosTime = 0.5f;
        //fAIFiringPosTime = 1.1f;
        //fAIRandomFiringPosTime = 0.5f;
        fAIMinDesiredHitRatio = 5.f;
        fAIMaxDesiredHitRatio = 85.f;

        fShootLightScale = 500;
        ////////////////////////////////////////////////////////////////////////////
    }
    
    void InitializeZoomer()  
    {
        // Lunetka snajperska - zoom skokowy
        ZoomerSniperStep cZoomerSniper = (ZoomerSniperStep)CreateObject("ZoomerSniperStep");
        cZoomerSniper.cOwner = this;
        cZoomerSniper.aZoomFactors = aSniperZoomFactors;
        cZoomer = cZoomerSniper;
        cZoomer.Reset();
    }
    
    public void OnRemoveFromInventory()
    {
        if (Owner != null && Owner instanceof PlayerHUD)
        {
            if (((PlayerHUD)Owner).HUD != null)
            {
                HUDSniper cHud = ((PlayerHUD)Owner).HUD.GetHUDSniper();
                if (cHud != null && cHud.bActiveFlag)
                {
                    ((Player)Owner).RestoreViewAfterAiming();
                    //((Player)Owner).SetState("FreehandState");
                }
            }
        }
            
        super.OnRemoveFromInventory();
    }
   
    /**
     * Sniperkom zawsze wysylamy ilosc amunicji
     * kanalem pewnym
     */
    void SetSendClientAmmoMode()
    {
        bSendClientAmmoReliable = true;
    }

    /**
     * Snajperka zawsze strzal przesyla kanalem pewnym
     */
    void MessageNewServerFire()
    {
        MessageNew( MSG_SERVER_FIRE );
    }
}
