public class WeaponRifleSniperHeavy extends WeaponBullet
{
    // Parametry zoomowania plynnego
    /** Poczatkowe powiekszenie
     */
    public float fZoomMin = 6.0f;
    
    /** Maksymalne powiekszenie
     */
    public float fZoomMax = 32.f;
    
    /**Mnoznik przyrostu zooma*/
    public float fZoomMul = 2f;
    
    /** Tablica progow czasowych [s]
     *  (po danym czasie pobierane jest odpowiadajaca mu 
     *   predkosc z aZoomSpeedValue)
     */
    public float aZoomTimeThreshold[] = { .5f, 1.f, 2.f };
    
    /** Tablica prredkosci dla progow czasowych z aZoomTimeThreshold
     *  w [1/s]
     */
    public float aZoomSpeedValue[] = { 1f, 2.f, 10.f };

    
    WeaponRifleSniperHeavy()
    {
        super();

        m_nFireMode = _FIREMODE_SINGLE;
        //MeshObject
        MeshName="Data/Meshes/Equipment/TPPsniper2.3DA";
        
        //Weapon
        nType = EWeaponType._RIFLE;

        //InvObject properites
        nInvIndex = InvObject._W_RIFLE_SNIPER_HEAVY;
        sName = "&W_N_SNIPER_HEAVY&";

        sTexFileName = "Data/Textures/CH_I_Weapons2.png";
        
        //wspolrzedne polozenia na teksturze
        nOnTexPosX = 0.0f;
        nOnTexPosY = 40.0f;
        
        //rozmiary tekstury
        nTexSizeX = 256.0f;
        nTexSizeY = 256.0f;

		// Ilosc kratek zajmowanych w plecaku
	    nCellsHeight = 3;
	    nCellsWidth = 10;
		
	    //WeaponPistol properties
	    fBaseAcc  = 7.0f;
        fRecoilAccChange = 4.0f;
		fAccuracyChangeSpeed = 8.0f;
		fAimAcc = 0f;
        
        fRecoilShiftChange= 0.08f;
        //TODO jesli trzeba to zmodyfikowac
        //vRecoilShift = new Vector(0, 0.5f, 0);
        
        fDamage             = 220.0f; // bylo 60
        fPhysicsSimDamage   = fDamage;
        fRange              = 90000.0f;
        fBulletSpeed        = 100000.0f;
	    fRateOfFire         = 45.0f;
	    eBulletType         = EAmmoType._14mmLong;
		nCapacity		    = 8;
		bMountable          = true;

		fNoiseShot = 9000.0f; // zmienione z 6000.0f;7000.0f...
		fNoiseHit  = 1700.0f;

        /** Klasa mesha pokazywanego w FPP */
        sFPPHandsClass = "FPPHandsSniper2";
        
        /**Nazwa dzieku odpalanego przy wystrzale */
        sSoundShoot = "Data/Sounds/Weapon/R06_Fire";
        sSoundReload = "Data/Sounds/Weapon/R06_Reload";
        sSoundEmpty = "Data/Sounds/Weapon/R06_Click";
        
        fMinShootSound = 200.f;
        fMaxShootSound = 20000.f;

		/**Nazwa FX odpalanego przy wystrzale (grzebien)*/
		sFXCombName = "FXGrzebienRifleSniperHeavy";
		
        ////////////////////////////////////////////////////////////////////////////
        //                         PARAMETRY DLA AI                               //
        ////////////////////////////////////////////////////////////////////////////
        nAIFireModes = _FIREMODE_SINGLE;
        //fAIAimingDeviation = 0.1f;
        //fAIBurstAimingDeviation = 0.5f;
        //fAISingleFireDelay = 0.5f;
        //fAIRandomSingleFireDelay = 2.f;
        //fAIBurstFireDelay = 0.5f;
        //fAIRandomBurstFireDelay = .1f;
        nAIMaxSingleFireBullets = 1;
        //fAIBurstTime = 0.5f;
        //fAIRandomBurstTime = .5f;
        //fAIMaxBurstDistance = 2000;
        nAIReadinessToAim = 99;
        nAIReadinessToStopAiming = 0;
        fAIEffectiveRange = 25000.f;
        //fAIHidingPosTime = 1.1f;
        //fAIRandomHidingPosTime = 0.5f;
        //fAIFiringPosTime = 1.1f;
        //fAIRandomFiringPosTime = 0.5f;
        ////////////////////////////////////////////////////////////////////////////
        fShootLightScale = 600;
    }
    

    void InitializeZoomer()
    {
        // Lunetka snajperska - zoom plynny
        ZoomerSniperSmooth cZoomerSniper = (ZoomerSniperSmooth)CreateObject("ZoomerSniperSmooth");
        cZoomerSniper.cOwner = this;
        cZoomerSniper.aZoomSpeedTime = aZoomTimeThreshold;
        cZoomerSniper.aZoomSpeedValue = aZoomSpeedValue;
        cZoomerSniper.fZoomMax = fZoomMax;
        cZoomerSniper.fInitialZoom = fZoomMin;
        cZoomerSniper.cOwner = this;
        cZoomerSniper.fZoomMul = fZoomMul;
        cZoomer = cZoomerSniper;
        cZoomer.Reset();
        
    }

    public void OnRemoveFromInventory()
    {
        if (Owner != null && Owner instanceof PlayerHUD)
        {
            if (((PlayerHUD)Owner).HUD != null)
            {
                HUDSniper cHud = ((PlayerHUD)Owner).HUD.GetHUDSniper();
                if (cHud != null && cHud.bActiveFlag)
                {
                    ((Player)Owner).RestoreViewAfterAiming();
                    //((Player)Owner).SetState("FreehandState");
                }
            }
        }
            
        super.OnRemoveFromInventory();
    }
    
    /**
     * Sniperkom zawsze wysylamy ilosc amunicji
     * kanalem pewnym
     */
    void SetSendClientAmmoMode()
    {
        bSendClientAmmoReliable = true;
    }
    
   /**
     * Snajperka zawsze strzal przesyla kanalem pewnym
     */
    void MessageNewServerFire()
    {
        MessageNew( MSG_SERVER_FIRE );
    }

    
    
}
