
/** Bron srutowa
 */
public class WeaponShotgun extends WeaponBullet
{
    /** Kat rozprysku srutu*/
    public float fShotSpray = .0536f; //2.5deg

    LaserPointer _tTestLasersAdd[] = null;
    
    /**Ilosc srutu*/
    int nShots = 7;
    
    /** Tan kata rozprysku */
    protected double fShotSprayTan = java.lang.Math.tan(fShotSpray);

    /**Odleglosc od celu przy ktorej zaczyna obowiazywac wiekszy power*/
    public float fStrongDistance = 500f;
    
    public float fStrongDistanceDamageMul = 1.5f;
    
    WeaponShotgun()
    {
        //przeladowanie po kazdym strzale - 
        // dodatkowa animacja dla fire
        bPumpAction     = true;
		m_bShowFXBeam = false;
		
		fNoiseShot = 7000.0f; // zmienione z 4500.0f;
    }

    public void OnCreate()
    {
        super.OnCreate();
    }
    
    void CreateTestBeamLaser()
    {
        super.CreateTestBeamLaser();
        
        _tTestLasersAdd = new LaserPointer[nShots];
        for (int i = 0; i < nShots; i++)
        {
            _tTestLasersAdd[i] = Tools.CreateLaserPointer(GetModule(), LaserPointer._BEAM_BLUE, 1, fRange, true);
        }
    }
    
    void UpdateTestBeamParams()
    {
        super.UpdateTestBeamParams();
        for (int i = 0; i < nShots; i++)
        {
            _tTestLasersAdd[i].SetRange(fRange);
            _tTestLasersAdd[i].m_bSingleBeam = _bTestBeamSingle;
        }
    }
    
    /** Strzelanie pociskami
     */
    void Fire(Vector vBarrel, Vector vDir)
    {
        super.Fire(vBarrel, vDir);

        //strzelamy odlamkami
        Vector vDirDev;
        float fDist;
        
        if (_bShowTestBeam)
        {
            if (_cTestLaser == null || _tTestLasersAdd == null || nShots != _tTestLasersAdd.length)
                CreateTestBeamLaser();
        }
            
        for (int i = 0; i < nShots; i++)
        {
            //if (Owner instanceof Player)
            {
                //w playerze obliczy sie losowy rozrzut dla kazdego strzalu
            //    vDirDev = ((Player)Owner).GetFireDir();
            }
            //else
            {
                //TODO chyba trzeba to poprawic, chyba ze ai nie uzywa shotguna, to co 
                //ponizej jest wersja wczesniejsza
                vDirDev = new Vector(vDir);
                
                float fDevX = (float)fShotSprayTan*RandomFloat(1);
                if (RandomFloat(1) <= 0.5f)
                    fDevX *= -1;
                
                float fDevY = (float)fShotSprayTan*RandomFloat(1);
                if (RandomFloat(1) <= 0.5f)
                    fDevY *= -1;
                
                float fDevZ = (float)fShotSprayTan*RandomFloat(1);
                if (RandomFloat(1) <= 0.5f)
                    fDevZ *= -1;
                
                vDirDev.Add( new Vector( fDevX,
                                         fDevY,
                                         fDevZ));
            }
            
            
            if (_bShowTestBeam)
            {
                _tTestLasersAdd[i].PointFromTowards(vBarrel, vDirDev);
            }
            fDist = FireBullet(vBarrel, vDirDev);
        }


        // dodajemy efekty zwiazane z wystrzalem
        //OwnerExecuteFXBarrel(sFXCombName);

        /* //odgrywanie losowych dzwiekow, dla Tomka
        int iPostfix = RandomInt(5);
        PlaySound(sSoundShoot+String.valueOf(iPostfix));
        */
        //PlaySound(sSoundShoot);

        //Owner.MakeNoise(fNoiseShot, Pawn._NOISE_WEAPON_FIRING);
    }

    
    String GetInfoString()
    {
        return  Text.Get("&W_D_AMMO&") + EAmmoType.GetAmmoName(eBulletType) + "\n" +
                Text.Get("&W_D_CAPACITY&") + String.valueOf(nCapacity) + "\n" +
                Text.Get("&W_D_DAMAGE&") + String.valueOf((int)fDamage * nShots) + "\n" +
                Text.Get("&W_D_RANGE&") + String.valueOf((int)(fRange/100)) + "m";
    }
}
