/** Bron dodatkowa uzywana przez Walkera_w (rakietnica)
 *  (Umozliwia uzywanie kilku gunow na raz)
 */
public class WeaponWalker_w_Rocket extends WeaponHEX
{
	static float _TIME_BTW_HEAVY_WEAPON_USE = 10f;
	static float _RND_TIME_BTW_HEAVY_WEAPON_USE = 10f;
	
    WeaponWalker_w_Rocket()
    {
        super();
        //MeshObject
        MeshName="Data/Meshes/Equipment/minigun01.3DA";
        sRocketClassName = "RocketFF";
        
        //Weapon
        nType = EWeaponType._HEAVY;

        //InvObject properites
        nInvIndex = 15;
        sName = "Walker W-type internal rocket launcher";
        //sInfo = "Ammo:Rocket Damage:90 RoF:45 Accuracy:No Recoil:High Range:300 AmmoCapacity:8";
        sInfo = "Ammo : Rocket \nDamage : 90 \nRoF : 45";
        sTexFileName = "Data/Textures/CH_I_Weapons3.png";
        
        //wspolrzedne polozenia na teksturze
        nOnTexPosX = 0.0f;
        nOnTexPosY = 180.0f;
        
        //rozmiary tekstury
        nTexSizeX = 256.0f;
        nTexSizeY = 256.0f;

		// Ilosc kratek zajmowanych w plecaku
	    nCellsHeight = 3;
	    nCellsWidth = 10;
		
        fBaseAcc = 0.f;

        fDamage             = 90.0f;
        fPhysicsSimDamage   = fDamage;
        fRange              = 30000.0f;
        fBulletSpeed        = 3000.0f;
	    fRateOfFire         = 240.0f;
	    eBulletType         = EAmmoType._HEX;
		nCapacity		    = 1000000000;

		fNoiseShot = 10000.0f;
		fNoiseHit  = 3000.0f;

        nAIFireModes = _FIREMODE_BURST;
    
        fAIBurstTime = 0.5f;
        fAIRandomBurstTime = 1f;

        nAIReadinessToAim = 0;
        
        fAINearTargetDistance = 200.f;
        fAIMaxAimingChanceDistance = 800.f;
        fAIFarTargetDistance = 3000.f;
    
        fAIEffectiveRange = fAIMaxBurstDistance = 6000.f;
		
        /**Nazwa dzieku odpalanego przy wystrzale */
        sSoundShoot = "Data/Sounds/Weapon/RocketStartFF";
        
		/**Nazwa FX odpalanego przy wystrzale (grzebien)*/
		sFXCombName = null;//"FXGrzebienWalker";
		
        /** Klasa mesha pokazywanego w FPP */
        sFPPHandsClass = "FPPHandsRocket";
        bHidden = true;
    }
    
    int METHOD_StartFire = 0;
    
    public void OnCreate()
    {
        METHOD_StartFire = RegisterCallMethod("StartFire");
        super.OnCreate();
    }
    
    void Fire(Vector vBarrel, Vector vDir)
    {
        super.Fire(vBarrel, vDir);
		
        if (cBullet instanceof RocketFF && Owner instanceof NewAIWalkerHeavy)
		{
			RocketFF rocket = (RocketFF) cBullet;
	        rocket.fStartSpeed = 0f;
			rocket.fMaxSpeed   = fBulletSpeed;

            rocket.SetTarget(((NewAIWalkerHeavy) Owner).GetController().GetActiveEnemy());
		}
    }    
    ///////////////////////////////////////////////////////////
    // Metody pokryte - dodaja do wywolan metod z Ownera this 
    // (potrzebne przy identyfikacji)
    //
    
    /** Pobranie z wlasciciela pozycji, z ktorej strzelamy
     */
    Vector GetOwnerFireOrigin()
    {
        if ( m_cWalker != null )
            return GetPosition();
        return Owner.GetFireOrigin();        
    }
    
    /** Pobranie z wlasciciela kierunku, w ktory strzelamy
     */
    Vector GetOwnerFireDir()
    {
        if ( m_cWalker != null )
            return GetWalkerFireDir();
        return Owner.GetFireDir();
    }

    /** Wyslanie message'a do Ownera
     */
    void SendWeaponMessage(int nState)
    {
        if ( Owner instanceof NewAIWalkerHeavy ) 
            ((NewAIWalkerHeavy) Owner).MessageWeapon(nState);
    }
    
    void OwnerExecuteFXBarrel(String sFXCombName)
    {
        if ( Owner instanceof NewAIWalkerHeavy ) 
            ((NewAIWalkerHeavy) Owner).ExecuteFXBarrel(sFXCombName);
        else if ( m_cWalker != null )
            WalkerExecuteFXBarrel( sFXCombName );
    }
    
    void StartFire()
    {
        float fDelay   = this.fDelay;
        //jesli od poprzedniego strzalu uplynal juz odpowiedni czas to strzelaj
        if ( fLastShotT == 0.0f || fLastShotT + this.fDelay <= GetTime() )
            StartFire( MODE_SINGLE );
        else
            fDelay -= (GetTime() - fLastShotT);
        //zaprogramujmy nastepny strzal (o ile nie przyjdzie StopFire)
        DisableCallMethod( METHOD_StartFire );
        CallMethodIn( METHOD_StartFire, fDelay );
    }
    
    public void StopFire()
    {
        DisableCallMethod( METHOD_StartFire );
        super.StopFire();
    }
    
    void SetWalkerMode( Walker cWalker )
    {
        super.SetWalkerMode( cWalker );
        fDelay = 5f;
    }
    
    void ChangeInvState(Pawn owner, int newState)
    {
        super.ChangeInvState(owner, newState);
        SetFlag(EFlags._NOT_STATIC);
    }
}
