/** orzel latajacy kodowaniec
 */

public class Eagle extends Destroyable
{
 //- atrybuty zwiazane z lataniem *****************************
    
    // wysokosc na jakiej lata orzel wzgledem pozycji Y gracza
    public float fHeight = 8000.0f;//#EAGLE
    
    // skala orla - ile razy jest mniejszy od wyjsciowych rozmiarw mesha
    public float fScale = 0.7f;
      
    // promien okregu
    public float fRadius = 5000.0f;//#EAGLE
    
    //predkosc 
    public float fFlyingSpeed = 0.2f;//#EAGLE
    
    //kierunek zmiany wspolerzednej X
    float fPrevDegree = 0.0f;
    float fActualDegree = 0.0f;
    
    //aktualny X i Y
    float fActualX = 0.0f;
    
    
    //pozycja orla
    Vector vEaglePos = null;
    Vector vCenterPos = null;
    
 //- *****************************       
    
    Vector vHitPos = null;
    
    /** pozycja docelowa
     */
    Vector vDestPos = null;
    
    /** predkosc spadania ora (cm/s)
     */
    float fFallingSpeed = 6000.0f;
    
    /** predkosc obracania sie (stopnie/s)
     */
    float fRotateSpeed = 40.0f;
    
    /** zmienne pomocnicze 
     */
    float fPrevTime = 0.0f;
    float fActualTime = 0.0f;
    
    /** nazwa animacji latania
     */
    String sAnimName = "fly";
    
    Eagle()
    {
        MeshName = "data/meshes/animals/orzel.3da";
        
        fHealth = 10.0f;
        fBlastRange = 100.0f;
        fBlastDamage = 1.0f;
        fDelayTime = 0.0f;
        
        sBlowFX = "FXWoodAmmo";
        sBlowSound = "Data/Sounds/desert_birds/Canyonbird_hit.wav";
    }

    public void OnCreate()
    {
        super.OnCreate();
        
        ClearFlag(EFlags._BLOCK_MOVE);
        ClearFlag(EFlags._NO_ANIMATION);
        vCenterPos = GetPosition();
        vEaglePos = new Vector(vCenterPos.fX, vCenterPos.fY, vCenterPos.fZ+fRadius);
        SetPosition(vEaglePos);
        //ShowCoarseBox(true);
        
        SetState("Flying");
        
    }
    
/*	public void OnTakeDamage(float fDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nDamageType)
	{
		super.OnTakeDamage(fDamage, Assassin, vHitLocation, vSpeed, nDamageType);
	}
*/	
 	// poprawione OnTakeDamage //////////////////////////////////////////////////////////////
    public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
		super.OnTakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
	}
      
     /** Odpalamy efekt wybuchu. Do pokrycia w klasach pochodnych, gdy
     * ma byc niestandardowy efekt wybuchu.
     */
    public void SpawnFX()
    {
        if( sBlowFX != null)
        {
            ExecuteFX(sBlowFX, GetPosition(), Vector.Up);
            ExecuteFXTrace(sBlowFX, GetPosition(), Vector.Up);
            ExecuteParticleSystem(sBlowFX, GetPosition(), Vector.Up);
        }

        if( sBlowSound != null)
            PlaySound(sBlowSound);
    }
    
     void DelayedBlow()
    {
        // efekt wybuchu
        SpawnFX();
    }
    
    
    public void Die()
    {
        bDead = true;
        
        CallMethodIn("DelayedBlow", RandomFloat(fDelayTime));
        SetState("FallingDown");
    }
  
//---------------------------------------------------------------------------    
    
    
 public class Flying extends State
    {
         float fDelay = 0.0f;
         float fMove = 0.0f; 
         float fDegree = 0.0f;
         float fX = 0.0f;
         float fZ = 0.0f;
         Vector vNewPos = null;
         Vector vPlayerPos = null;
         PlayerSingle cPlayer = null; 
     
        public void OnEnter()
        {
            
            fActualTime = GetTime();
            SetScale( new Vector(fScale, fScale, fScale));
         }
        
        public void OnFrame()
        {
        
                        
            fDelay = 0.0f;
            fMove = 0.0f;
       
            fPrevTime = fActualTime;
            fActualTime = GetTime();
    
            //ile czasu uplynelo
            fDelay = fActualTime-fPrevTime;
            
            fActualX+= fDelay*fFlyingSpeed;
            
            if (fActualX >2*java.lang.Math.PI) fActualX-=2*java.lang.Math.PI;
            
            fX = vCenterPos.fX + (float)java.lang.Math.sin(fActualX)*fRadius;
            fZ = vCenterPos.fZ + (float)java.lang.Math.cos(fActualX)*fRadius;
            SetPosition(new Vector(fX, vCenterPos.fY, fZ));
            
            SetDir(new Vector((float)java.lang.Math.cos(fActualX), 0.0f, -1.0f*(float)java.lang.Math.sin(fActualX)));
            
            if (cPlayer == null)
            {
                //cPlayer = ((ChromeModuleSingle)GetModule()).MainPlayer;
            }
            else
            {
             vPlayerPos = cPlayer.GetPosition();
             //update pozycji ora
             SetPosition(new Vector(GetPosition().fX, vPlayerPos.fY+fHeight, GetPosition().fZ));
            }
        }   
            
        
    }    
//---------------------------------------------------------------------------     
  public class FallingDown extends State
    {
            float fDelay = 0.0f;
            float fMove = 0.0f; 
            float fDegree = 0.0f;
      
      public void OnEnter()
        {
            vHitPos = GetPosition();
            vDestPos = new Vector(vHitPos.fX, vHitPos.fY, vHitPos.fZ);
            vDestPos.fY = TerrainHeight(vDestPos.fX, vDestPos.fZ);
            fActualTime = GetTime();
            
        }
        
        public void OnFrame()
        {
          
            fDelay = 0.0f;
            fMove = 0.0f;
       
    
            fPrevTime = fActualTime;
            fActualTime = GetTime();
    
            //ile czasu uplynelo
            fDelay = fActualTime-fPrevTime;
            //o ile sie powinien przesunac
            fMove = fDelay*fFallingSpeed;
    
            SetPosition(new Vector(GetPosition().fX, GetPosition().fY - fMove, GetPosition().fZ ));
            if (GetPosition().fY <= vDestPos.fY)
            {
             SetPosition(vDestPos);   
             SetState("OnGround");
            }
            
            
            //symulacja obracania sie
            fDegree = fDelay*fRotateSpeed;
            RotateLocal( new Vector(0,1,0), -fDegree);
            RotateLocal( new Vector(0,0,1), -fDegree);
        
        }
    }
//---------------------------------------------------------------------------      
 public class OnGround extends State
    {
        public void OnEnter()
        {
            
            DeactivateOnModuleAlways();
            CallMethodIn("delete", 0.0f);
            
            
        }
    }    
//---------------------------------------------------------------------------     
}
