
public class Eagle2 extends Destroyable
{
    Vector vHitPos = null;
    
    /** pozycja docelowa
     */
    Vector vDestPos = null;
    
    /** predkosc spadania ora (cm/s)
     */
    float fFallingSpeed = 6000.0f;
    
    /** predkosc obracania sie (stopnie/s)
     */
    float fRotateSpeed = 40.0f;
    
    /** zmienne pomocnicze 
     */
    float fPrevTime = 0.0f;
    float fActualTime = 0.0f;
    
    /** nazwa animacji latania
     */
    String sAnimName = "fly";
    
    Eagle2()
    {
        MeshName = "data/meshes/animals/orzel2.3da";
        
        fHealth = 10.0f;
        fBlastRange = 100.0f;
        fBlastDamage = 1.0f;
        fDelayTime = 0.0f;
        
        sBlowFX = "FXWoodAmmo";
        sBlowSound = "Data/Sounds/desert_birds/Canyonbird_hit.wav";
    }

    public void OnCreate()
    {
        super.OnCreate();
        //ShowCoarseBox(true);
        
        //ClearFlag(EFlags._COLLISION);
        ClearFlag(EFlags._BLOCK_MOVE);
        
        ClearFlag(EFlags._NO_ANIMATION);
        
        InitAnimSeq(sAnimName, 0, 750);
        PlayAnim(sAnimName, 0);
    }
    
/*	public void OnTakeDamage(float fDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nDamageType)
	{
		super.OnTakeDamage(fDamage, Assassin, vHitLocation, vSpeed, nDamageType);
	}
*/
	// poprawione OnTakeDamage //////////////////////////////////////////////////////////////
    public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
		super.OnTakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
	}
	
     /** Odpalamy efekt wybuchu. Do pokrycia w klasach pochodnych, gdy
     * ma byc niestandardowy efekt wybuchu.
     */
    public void SpawnFX()
    {
        if( sBlowFX != null)
        {
            ExecuteFX(sBlowFX, GetPosition(), Vector.Up);
            ExecuteFXTrace(sBlowFX, GetPosition(), Vector.Up);
            ExecuteParticleSystem(sBlowFX, GetPosition(), Vector.Up);
        }

        if( sBlowSound != null)
            PlaySound(sBlowSound);
    }
    
     void DelayedBlow()
    {
        // efekt wybuchu
        SpawnFX();
        
        // chowamy po wybuchu beczke
     //   DeactivateOnModule();
        //CallMethodIn("delete", 0.0f);
    }
    
    
    public void Die()
    {
        bDead = true;
        
        // odpalamy odbieranie energii obiektom w promieniu
        //if( (fBlastRange > 0.0f) || (fBlastDamage > 0.0f) ) Blast();
        
        CallMethodIn("DelayedBlow", RandomFloat(fDelayTime));
        SetState("FallingDown");
    }
  
//---------------------------------------------------------------------------    
  public class FallingDown extends State
    {
            float fDelay = 0.0f;
            float fMove = 0.0f; 
            float fDegree = 0.0f;
      
      public void OnEnter()
        {
            StopAnim("");
            vHitPos = GetPosition();
            vDestPos = new Vector(vHitPos.fX, vHitPos.fY, vHitPos.fZ);
            vDestPos.fY = TerrainHeight(vDestPos.fX, vDestPos.fZ);
            fActualTime = GetTime();
            
        }
        
        public void OnFrame()
        {
          
            fDelay = 0.0f;
            fMove = 0.0f;
       
    
            fPrevTime = fActualTime;
            fActualTime = GetTime();
    
            //ile czasu uplynelo
            fDelay = fActualTime-fPrevTime;
            //o ile sie powinien przesunac
            fMove = fDelay*fFallingSpeed;
    
            //RotateLocal( new Vector(1,0,0), (float)(fSinMaxDegree*fDegree));
            
            SetPosition(new Vector(GetPosition().fX, GetPosition().fY - fMove, GetPosition().fZ ));
            if (GetPosition().fY <= vDestPos.fY)
            {
             SetPosition(vDestPos);   
             SetState("OnGround");
            }
            
            
            //symulacja obracania sie
            fDegree = fDelay*fRotateSpeed;
            //RotateLocal( new Vector(1,0,0), fDegree);
            RotateLocal( new Vector(0,1,0), -fDegree);
            RotateLocal( new Vector(0,0,1), -fDegree);
        
        }
    }
  
 public class OnGround extends State
    {
        public void OnEnter()
        {
            
            DeactivateOnModuleAlways();
            CallMethodIn("delete", 0.0f);
            
            
        }
    }    
}
