public class FlyingTransporterSmallFake extends MeshObject implements iact_StartStop
{
    public String sFXEngine = "FXFlyingEngine";//#FX;
    public String sFXEngineSmall = "FXFlyingEngineSmaller10Times";//#FX;
    public String sFXEngineDyn = "FXFlyingEngineSmallerSyf";//#FX;

    float fFXScale = 1.f;
    
    // maly efekt do filmow - HACK
    public String sFXEngineNormal = null;
    
    public float fUpdateFXTime = 0.1f;//#FX;

    public boolean bAutoStart = false;//#FX;
    
    String[] aEngineElementsNames = { "Engine01", "Engine02", "Engine03", "Engine04", "Engine" };
    int[] aEngineElements = null;
    
    String sTakeOffSound = "Data/Sounds/Vehicles/shuttle start short.wav";//FX;
    String sFlySound = "Data/Sounds/Vehicles/shuttle.wav";//#FX;
    
    public float fFlySoundMin = 3300f;//#FlyingTransporterSmallFake;
    public float fFlySoundMax = 12000f;//#FlyingTransporterSmallFake;
    
    public float fVolume = 0.7f;//#FlyingTransporterSmallFake;
    
    int nSoundID = 0;
    
    public boolean bGridIndependent = false;//#FlyingTransporterSmallFake;
    public float fMeshVisibilityRangeMin = 25000;//#FlyingTransporterSmallFake;
    public float fMeshVisibilityRangeMax = 50000;//#FlyingTransporterSmallFake;

    /** fx'y glow */
    String [] m_aGlowDummies = new String[] { "Glow01", "Glow02", "Glow03", "Glow04", "Glow05", "Glow06"};
    int [] m_aGlowDummiesIDs = null;
    int [] m_aGlowFXsIDs = null;
    int METHOD_UpdateGlowFXs = 0;
    public float _GLOW_FX_UPDATE_TIME = 60f;
    public String _GLOW_FX_NAME = "FXHueyGlow";

    // do fxow
    public float fVal_7 = 70.f;
    public float fVal_35 = 350.f;
    public float fVal_2 = -20.f;
    public float fVal_30 = 300.f;
    public float fVal_15 = 150.f;
    public float fVal_5 = -50.f;
    public float fVal_18 = -180.f;
    public float fZero = 0.f;
    
    float base_fVal_7 = 70.f;
    float base_fVal_35 = 350.f;
    float base_fVal_2 = -20.f;
    float base_fVal_30 = 300.f;
    float base_fVal_15 = 150.f;
    float base_fVal_5 = -50.f;
    float base_fVal_18 = -180.f;
    float base_fZero = 0.f;
    
    public void OnCreate()
    {
        SetGlows();
        
		bSG = true;
        aEngineElements = new int[aEngineElementsNames.length];
        for (int i = 0; i < aEngineElements.length; ++i)
            aEngineElements[i] = GetElementID(aEngineElementsNames[i]);
        SetMeshVisibilityRange(fMeshVisibilityRangeMin, fMeshVisibilityRangeMax);
        SetBlobMapSize(800f);
        SetFlag(EFlags._CAST_SHADOWS);

        if(bAutoStart) Start();
    }
    
    void BurnEngines()
    {
        for (int i = 0; i < aEngineElements.length; i++)
        {
            if (aEngineElements[i] != -1)
                ExecuteFX(this, aEngineElements[i], sFXEngine, Vector.Zero);
        }
    }
    
    boolean bBurning = false;
    
    public void FXSmall()
    {
        sFXEngineNormal = new String(sFXEngine);
        sFXEngine = sFXEngineSmall;
        bDyn = false;
        StopDyn();
    }
    
    public void FXNormal()
    {
        sFXEngine = sFXEngineNormal;
        bDyn = false;
        StopDyn();
    }
    
    boolean bDyn = false;
    public void FXDyn()
    {
        sFXEngineNormal = new String(sFXEngine);
        sFXEngine = sFXEngineDyn;
        CallMethodEvery("UpdateDyn", 0.05f);
    }
    
    void StopDyn()
    {
        DisableCallMethod("UpdateDyn");
    }
    
    public void UpdateDyn()
    {
        Vector vScale = GetScale();
        float fScale = vScale.fY;
        // to jest hack, bo efekty nie nadazaja za zmiana skali
        fScale *= 0.7f;
        fVal_7 = fScale * base_fVal_7;
        fVal_35 = fScale *  base_fVal_35;
        fVal_2 = fScale *  base_fVal_2;
        fVal_30 = fScale *  base_fVal_30;
        fVal_15 = fScale *  base_fVal_15;
        fVal_5 = fScale *  base_fVal_5;
        fVal_18 = fScale *  base_fVal_18;
    }
    
    public void StartTakeOff()
    {
        if (sTakeOffSound != null)
        {
            nSoundID = AttachSound(sTakeOffSound, fFlySoundMin, fFlySoundMax);
            SetSoundVolume(nSoundID, fVolume);
            DisableCallMethod("SpawnSound");
            CallMethodIn("SpawnSound", GetWaveDuration(sTakeOffSound));
        }
        
        Start();
    }

    void SpawnSound()
    {
        DeleteSound();
        
        if (sFlySound != null)
        {
            nSoundID = AttachSound(sFlySound, fFlySoundMin, fFlySoundMax);
            SetSoundVolume(nSoundID, fVolume);
        }
    }
    
    void DeleteSound()
    {
        if (nSoundID != 0)
            DetachSound(nSoundID);
        nSoundID = 0;
    }
    
    public void Start()
    {
        DisableCallMethod("BurnEngines");
        CallMethodEvery("BurnEngines", fUpdateFXTime);
        
        bBurning = true;
        
        if (nSoundID == 0)
        {
            DisableCallMethod("SpawnSound");
            SpawnSound();
        }
        
        TurnGlowsOn();
    }
    
    public void StartSound()
    {
        if (nSoundID == 0)
        {
            DisableCallMethod("SpawnSound");
            SpawnSound();
        }
    }
    
    public void StartFX()
    {
        DisableCallMethod("BurnEngines");
        CallMethodEvery("BurnEngines", fUpdateFXTime);
        
        bBurning = true;
    }
    
    public void Stop()
    {
        DisableCallMethod("BurnEngines");
        DisableCallMethod("SpawnSound");
        StopDyn();
        
        DeleteSound();
        
        bBurning = false;
        
        TurnGlowsOff();
    }
    
    public void ToggleStartStop()
    {
        if(bBurning)
            Stop();
        else
            Start();
    }
    
    public void Appear(ControlObject cObj)
    {
        int nRoot = GetElementID("");
        SetFrame(0.f, nRoot);
        if (bGridIndependent)
            bDisappearGridIndependent = true;// fake w fake'u - zeby sie aktywowal grid independent
        super.Appear(cObj);
    }

    public void Disappear(ControlObject cDestinationObj)
    {
        super.Disappear(cDestinationObj);
        
        Stop();
        DeleteAttachedFXes();
    }
    
    void SetGlows()
    {
        m_aGlowDummiesIDs = new int[m_aGlowDummies.length];
        for (int i = 0; i < m_aGlowDummies.length; i++)
            m_aGlowDummiesIDs[i] = GetElementID(m_aGlowDummies[i]);
        
        m_aGlowFXsIDs = new int[m_aGlowDummiesIDs.length];
        for (int i = 0; i < m_aGlowFXsIDs.length; i++)
            m_aGlowFXsIDs[i] = -1;
        if (METHOD_UpdateGlowFXs != 0)
            DisableCallMethod(METHOD_UpdateGlowFXs);
        METHOD_UpdateGlowFXs = RegisterCallMethod("UpdateGlowFXs");
    }
    
    void TurnGlowsOn()
    {
        CallMethodEvery(METHOD_UpdateGlowFXs, _GLOW_FX_UPDATE_TIME);
        UpdateGlowFXs();
    }
    
    void TurnGlowsOff()
    {
        DisableCallMethod(METHOD_UpdateGlowFXs);
        for (int i = 0; i < m_aGlowDummiesIDs.length; i++)
        {
            if (m_aGlowDummiesIDs[i] == -1)
                continue;
            if (m_aGlowFXsIDs[i] >= 0)
            {
                DeleteFXSequence(m_aGlowFXsIDs[i]);
                m_aGlowFXsIDs[i] = -1;
            }
        }
    }
    
    void UpdateGlowFXs()
    {
        if (m_aGlowDummiesIDs == null)
            return;
        
        for (int i = 0; i < m_aGlowDummiesIDs.length; i++)
        {
            if (m_aGlowDummiesIDs[i] == -1)
                continue;
            if (m_aGlowFXsIDs[i] >= 0)
                DeleteFXSequence(m_aGlowFXsIDs[i]);
            m_aGlowFXsIDs[i] = ExecuteFX(this, m_aGlowDummiesIDs[i], _GLOW_FX_NAME, new Vector());
        }
    }
    
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
	int nSGSoundID = -1;
	boolean bBurningSG = false;
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[FlyingTransporterSmallFake.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_WEAPON)
        {	
			super.SGLoadChunk(cFC);
			
			sFXEngineNormal = cFC.LoadString();
			fFlySoundMin = cFC.LoadFloat();
			fFlySoundMax = cFC.LoadFloat();
			fVolume = cFC.LoadFloat();
			nSGSoundID = cFC.LoadInt();	
			bBurningSG = cFC.LoadBool();			
			
			LoadMeshElements(cFC);
        }
		
		cFC.delete();
    }	
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[FlyingTransporterSmallFake.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_WEAPON, cFCParent);
		
		super.SGSaveChunk(cFC);

		cFC.SaveString(sFXEngineNormal);
		cFC.SaveFloat(fFlySoundMin);
		cFC.SaveFloat(fFlySoundMax);
		cFC.SaveFloat(fVolume);
		cFC.SaveInt(nSoundID);	            
		cFC.SaveBool(bBurning);	
		
		SaveMeshElements(cFC);

        cFC.delete();
    }	   
	
	public void SGUpdate()
	{
		FileChunk.Log("[FlyingTransporterSmallFalke.SGUpdate]\n");
		super.SGUpdate();
		
		DeleteSound();

        SetGlows();
		
        if (bBurning)
			Stop();
		if (bBurningSG)		
			Start();
		else
			Stop();
	}   	
    
    public void OnAudioReinitialize()
    {
        if (nSoundID != 0)
        {
            nSoundID = 0;
            SpawnSound();
        }
    }

}
