public class Level00 extends ChromeModuleSingle
{
    /** Akcja odpalana po zakonczeniu tutoriala */
    public Action[] cAfterTutorialAction;//#\TUTORIAL;Actions run when tutorial is finished
	
    /** skrzynia z ekwipunkiem */
    public TriggerObject cChest = null;//#\TUTORIAL;
    public InvObjectInst[] aObjectsInChest = null;//#\TUTORIAL;

	boolean m_bChestOpened = false;
	
	int m_nObjectsInChest = 7;

	/** aktywna czesc tutoriala - wlaczenie inventory */
	boolean m_bTurnInventoryOn = false;
	/** aktywna czesc tutoriala - wylaczenie inventory */
	boolean m_bTurnInventoryOff = false;
	/** czy teraz zebrac obiekt wyrzucony z inventory */
	boolean m_bInvObjectTaken = false;
	/** aktywna czesc tutoriala - wybranie CAFS'a */
	boolean m_bCheckCafs = false;
	/** aktywna czesc tutoriala - sprawdzenie celowania */
	boolean m_bCheckAiming = false;
	/** aktywna czesc tutoriala - wlaczenie lornetki */
	boolean m_bBinocularsOn = false;
	/** aktywna czesc tutoriala - wylaczenie lornetki */
	boolean m_bBinocularsOff = false;
	/** aktywna czesc tutoriala - zoomowanie */
	boolean m_bZoom = false;
	/** wlaczenie mapy */
	boolean m_bMapOn = false;
	/** wylaczenie mapy */
	boolean m_bMapOff = false;
	/** klik na mapie */
	boolean m_bMapClick = false;
	/** ostatnia pozycja na mapie do sprawdzenia, czy gracz kliknal */
	Vector m_vLastDestPosOnMap = null;
	
	/** InvObject wyrzucony z inventory */
	InvObject m_Obj = null;
	/** czy w tym momencie mamy sledzic wyrzucony z inventory obiekt */
	boolean m_bDropInvObject = false;
	
    String m_TutorialObjects[] = { "TPPrifle01", "m_rifle01", "Lornetka01",
                                   "m_pistolet01", "TPPpistol_b01", "drag_health01"};
    
    void OnCreate()
    {
        m_bImplantsAvailable = false;
        super.OnCreate();
		
		RegisterKeyRequest();
		RegisterMouseButtonRequest();
		RegisterMouseAxisRequest();
		
        if(cChest == null)
        {
		    GameObject obj = GetObjectByName("SkrzyniaOtwierana02");
			obj.bSG = true;
		    try
		    {
		    	cChest = (TriggerObject) obj;
		    	cChest.bActiveTrigger = false;
		    }
		    catch (Exception e)
		    {
		    	CrashLog("Na levelu 00 nie ma skrzyni!!!\n");
		    }
        }
        
        if(aObjectsInChest != null)
        {
            m_nObjectsInChest = aObjectsInChest.length;
        }
        
        MeshObject cHueyPilot = (MeshObject)GetObjectByName("LSoldier46");
        if (cHueyPilot != null)
        {
            cHueyPilot.ClearFlag(EFlags._BLOCK_TRACE);
        }
        else
        {
            LogR("ZJEBAZJEBAZJEBA");
        }
    }
	
    public void EnableImplants()
    {
        m_bImplantsAvailable = true;
        GetMainPlayer().GetImplantSystem().OnInstantActionEnableImplants();
    }
    
	public void OnPostCreate()
	{
		super.OnPostCreate();
		
		LoadSoundTemplates("Data/Levels/Level00/sounds.ini");
		
		Training();
	}
	
	/** dialog przed tutorialem */
	public void Training()
	{
		StartHints();
	}
    
    boolean bFirstTutorial = true;
    
	public void StartHints()
	{
// jednak pytanie o tutorial ma byc zawsze        
          // sprawdzamy czy tutorial juz kiedys byl
//        java.io.File cTutFile = new java.io.File("Data/Levels/Level00/Check.tut");
//        bFirstTutorial = !cTutFile.exists();
        bFirstTutorial = true;

		/*
        if(Game.cSingleton instanceof ChromeGame)
        {
            ChromeGame game = (ChromeGame)Game.cSingleton;
            game.EnableLoadSave(false);
        }
		*/
        
        cHintManager.Start(bFirstTutorial);
		// od tej pory mozna otworzyc skrzynie
		cChest.bActiveTrigger = true;
        
        if (bJustLoaded)
        {
            bJustLoaded = false;
            
            SetStateAfterTutorial();
        
            cHintManager.delete();
            cHintManager = null;
        
            InitAfterTutorialHints();
        
            bTutorialEnded = true;
        
            if(Game.cSingleton instanceof ChromeGame)
            {
                ChromeGame game = (ChromeGame)Game.cSingleton;
                game.EnableLoadSave(true);
            }
        }
	}
	
    void InitHints()
    {
        cHintManager = (HintManager) CreateObject("HintManager");
        
		cHintManager._TIME_START_DELAY = 0.1f;
		cHintManager._MIN_DISPLAY_PAUSE = 0f;
		for (int i = 1; i <= 16; i++)
	        cHintManager.AddHint( new HintTutorial(i) );
    }
	
    public void TriggerExecuted(TriggerObject cTrigger, Actor cExecutor)
    {
        super.TriggerExecuted(cTrigger, cExecutor);
		
		if (cTrigger.GetName() == null)
		{
			CrashLog("cTrigger.GetName() == null dla " + cTrigger + " !!!\n");
			return;
		}
		
        LogR("cTrigger=" + cTrigger.GetName() + " aObjectsInChest=" + cTrigger + "\n");
        
        if (cTrigger == cChest)
        {
			m_bChestOpened = true;
			MessageToHints(HintManager._MSG_TUTORIAL_STEP1_ENDED);
        }
		
		if (m_nObjectsInChest > 0)
		{
            // sprawdzamy liste obiektow
            boolean bObjectFromChest = false;
            
            if (aObjectsInChest == null)
            {
                for (int i = 0; i < m_TutorialObjects.length; i++)
                {
                    if (cTrigger.GetName().toLowerCase().equals(m_TutorialObjects[i].toLowerCase()))
                    {
                        bObjectFromChest = true;
                        break;
                    }
                }
            }
            else
            {
                for (int i = 0; i < aObjectsInChest.length; ++i)
                {
                    if (cTrigger == aObjectsInChest[i])
                    {
                        bObjectFromChest = true;
                        break;
                    }
                }
            }

            LogR("bObjectFromChest=" + bObjectFromChest + " m_nObjectsInChest=" + m_nObjectsInChest + "\n");
            if (bObjectFromChest)
			{
				m_nObjectsInChest--;
				if (m_nObjectsInChest == 0)
                    ObjectsCollected();
			}
		}
		
		if ( (m_Obj != null) && (cTrigger.GetName().equals(m_Obj.GetName())) )
		{
			if (m_bTurnInventoryOff)
				m_bInvObjectTaken = true;
			else
				m_bInvObjectTaken = false;
			
			m_Obj = null;
			MessageToHints(HintManager._MSG_TUTORIAL_STEP7_ENDED);
			m_bCheckCafs = true;
		}
    }
    
    void ObjectsCollected()
    {
        LogR("m_nObjectsInChest=" + m_nObjectsInChest + "\n");
                    
		MessageToHints(HintManager._MSG_TUTORIAL_STEP2_ENDED);
                    
        if (bFirstTutorial)
		    CallMethodIn("TurnInventoryOn", HintTutorial._TIME_TO_INFO_TEXT + 1f);
        else
            EndTutorial();
    }
    
    void MoveTutorItemsToPlayerInventory()
    {
        for (int i = 0; i < m_TutorialObjects.length; i++)
        {
            InvObject obj = (InvObject) GetObjectByName(m_TutorialObjects[i]);
            if (obj.cInventory == null)
                obj.Execute(MainPlayer);
        }
    }
	
	public void TurnInventoryOn()
	{
		m_bTurnInventoryOn = true;
	}

    public void InventoryTurnedOff()
    {
        if (m_bTurnInventoryOff)
        {
            m_bTurnInventoryOff = false;
            MessageToHints(HintManager._MSG_TUTORIAL_STEP6_ENDED);
            
            if (m_bInvObjectTaken)
            {
                m_Obj = null;
                MessageToHints(HintManager._MSG_TUTORIAL_STEP7_ENDED);
                m_bCheckCafs = true;
            }
        }
    }
    
    boolean bFastTutorial = false;
    
    public void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
		if ((bKeyState) && (/*(nKeyCode==EKey._F5) ||*/ (nKeyCode==EKey._F6)) && bFastTutorial)
			return;
			
		super.OnInputKey(nKeyCode, bKeyState, nKeyAscii);
		
        if (bKeyState)
		{
            if( (nKeyCode==EKey._F1) && bFastTutorial &&
              !Game.cSingleton.IsScreenShotMode())
            {
                // na szybko konczymy tutorial
                EndTutorial();
            }
            
            if ( !((PlayerLevel00) MainPlayer).bInputsAllowed)
                return;
                
            if ( (nKeyCode == EGameControl.INVENTORY) && (m_bTurnInventoryOn) )
			{
				m_bTurnInventoryOn = false;
				MessageToHints(HintManager._MSG_TUTORIAL_STEP4_ENDED);
				m_bDropInvObject = true;
			}
			
			/*if ( (nKeyCode == EGameControl.INVENTORY) && (m_bTurnInventoryOff) )
			{
				m_bTurnInventoryOff = false;
				MessageToHints(HintManager._MSG_TUTORIAL_STEP6_ENDED);
				
				if (m_bInvObjectTaken)
				{
					m_Obj = null;
					MessageToHints(HintManager._MSG_TUTORIAL_STEP7_ENDED);
					m_bCheckCafs = true;
				}
			}*/
			
			if ( ((nKeyCode == EGameControl.WEAPON_RIFLE) ||
				  (nKeyCode == EGameControl.WEAPON_PISTOL))
				 && (m_bCheckCafs) )
			{
				m_bCheckCafs = false;
                MessageToHints(HintManager._MSG_TUTORIAL_STEP8_ENDED);
				m_bCheckAiming = true;
			}
			
			if ( ((nKeyCode == EGameControl.USE) || (nKeyCode == EGameControl.USE_ITEM_BINOCULARS)) &&
                 m_bBinocularsOn )
			{
				if ( (MainPlayer.cInventory.cActualUsableInvObj != null) &&
					 (MainPlayer.cInventory.cActualUsableInvObj instanceof Binoculars) )
				{
					m_bBinocularsOn = false;
					MessageToHints(HintManager._MSG_TUTORIAL_STEP10_ENDED);
					m_bZoom = true;
				}
			}
			
			if ( ((nKeyCode == EGameControl.USE) || (nKeyCode == EGameControl.USE_ITEM_BINOCULARS)) &&
                 m_bBinocularsOff )
			{
					m_bBinocularsOff = false;
					MessageToHints(HintManager._MSG_TUTORIAL_STEP12_ENDED);
					m_bMapOn = true;
			}
			
			if ( (nKeyCode == EGameControl.MAP) && (m_bMapOn) )
			{
				m_bMapOn = false;
				MessageToHints(HintManager._MSG_TUTORIAL_STEP13_ENDED);
				m_vLastDestPosOnMap = new Vector( ((PlayerHUD) MainPlayer).HUD.GetHUDCompass().GetDestPosition() );
				m_bMapClick = true;
			}
			
			if ( (nKeyCode == EGameControl.MAP) && (m_bMapOff) )
			{
				m_bMapOff = false;
				MessageToHints(HintManager._MSG_TUTORIAL_STEP15_ENDED);
				
				EndTutorial();
			}
            
            if ( ((nKeyCode == EGameControl.ZOOM_IN) || (nKeyCode == EGameControl.ZOOM_OUT))
                 && (m_bZoom) )
			{
                m_bZoom = false;
				MessageToHints(HintManager._MSG_TUTORIAL_STEP11_ENDED);
				m_bBinocularsOff = true;
            }
            
            if ( (nKeyCode == EGameControl.AIM) && (m_bCheckAiming) )
            {
				m_bCheckAiming = false;
				MessageToHints(HintManager._MSG_TUTORIAL_STEP9_ENDED);
				m_bBinocularsOn = true;
			}
		}
	}
	
	public void OnInputMouseButton(int nButton, int nState)
    {
		if (nState > 0)
		{
            // sprawdzenia klikniecie na mapie
            if(m_bMapClick)
            {
			    if(nButton == EMouse._BUTTON_1)
			    	CallMethodIn("CheckLMBClick", 0f);
            }
            else
                OnInputKey(Player.ConvertMouseButtonToKey(nButton), nState>1 ? true : false, ' ');
		}
	}
	
	public void CheckLMBClick()
	{
		if (m_vLastDestPosOnMap.Distance(((PlayerHUD) MainPlayer).HUD.GetHUDCompass().GetDestPosition()) > 100f)
		{
			m_bMapClick = false;
			MessageToHints(HintManager._MSG_TUTORIAL_STEP14_ENDED);
			m_bMapOff = true;	
		}
	}
	
    void OnInputMouseAxis(int nAxis, int nDelta)
    {
		if (m_bZoom)
		{
			if (nAxis == EMouse._AXIS_Z)
			{
				m_bZoom = false;
				MessageToHints(HintManager._MSG_TUTORIAL_STEP11_ENDED);
				m_bBinocularsOff = true;
			}
		}
	}
	
	public void OnPlayerInvObjectRemoved(InvObject invObj)
	{
		if ( (cHintManager != null) && (m_bDropInvObject) )
		{
			m_Obj = invObj;
			m_bDropInvObject = false;
			MessageToHints(HintManager._MSG_TUTORIAL_STEP5_ENDED);
			m_bTurnInventoryOff = true;
		}
	}
	
	void DeleteBarriers()
	{
		GameObject []objTab = GetObjectsFromClass("Barrier_Level00");
		if (objTab.length == 0)
		{
			CrashLog("Nie ma bariery do hintow dla gracza na levelu 00\n");
			return;
		}
		for (int i = 0; i < objTab.length; i++)
		{
			objTab[i].delete();
			objTab[i] = null;
		}
	}
    
    boolean bTutorialEnded = false;
        
    void EndTutorial()
    {
        if(bTutorialEnded) return;
        
        java.io.File cTutFile = new java.io.File("Data/Levels/Level00/Check.tut");
        try {
            cTutFile.createNewFile();
        } catch (Exception e) {}

        SetStateAfterTutorial();
        
        InvokeActionChain(cAfterTutorialAction);
        
        cHintManager.delete();
        cHintManager = null;
        
        InitAfterTutorialHints();
        
        bTutorialEnded = true;
        
        if(Game.cSingleton instanceof ChromeGame)
        {
            ChromeGame game = (ChromeGame)Game.cSingleton;
            game.EnableLoadSave(true);
        }
    }
    
    void InitAfterTutorialHints()
    {
        CrashLog("InitAfterTutorialHints\n");
        
        cHintManager = (HintManager)CreateObject("HintManager");
        cHintManager._TIME_START_DELAY = 5.0f;
		cHintManager._MIN_DISPLAY_PAUSE = 5.0f;
        
		/*
        if (m_vLoadedHints != null && m_vLoadedHints.size() > 0)
        {
            AddLoadedHints();
        }
        else
		*/
        {
            cHintManager.AddHint( new HintJeepAvailable() );
            cHintManager.AddHint( new HintReloadNeeded() );
            cHintManager.AddHint( new HintHealthexNeeded() );
            cHintManager.AddHint( new HintSearchBody() );        
        }
        cHintManager.Start(false);
        ActivateHints();
    }

    void InitLoadedHints()
    {
        //w tej klasie robi sie inaczej niz w ChromeModuleSingle
        if (cHintManager != null)
        {
            cHintManager.ClearTime();
        }
    }
    
    void SetStateAfterTutorial()
    {
      	m_bChestOpened = false;
	    m_bTurnInventoryOn = false;
	    m_bTurnInventoryOff = false;
	    m_bInvObjectTaken = false;
	    m_bCheckCafs = false;
	    m_bCheckAiming = false;
	    m_bBinocularsOn = false;
	    m_bBinocularsOff = false;
	    m_bZoom = false;
	    m_bMapOn = false;
	    m_bMapOff = false;
	    m_bMapClick = false;
	    m_bDropInvObject = false;
    }
    
    void SetStateBeforeTutorial()
    {
        bJustLoaded = false;
        bTutorialEnded = false;

        m_nObjectsInChest = m_TutorialObjects.length;
      	m_bChestOpened = false;
	    m_bTurnInventoryOn = false;
	    m_bTurnInventoryOff = false;
	    m_bInvObjectTaken = false;
	    m_bCheckCafs = false;
	    m_bCheckAiming = false;
	    m_bBinocularsOn = false;
	    m_bBinocularsOff = false;
	    m_bZoom = false;
	    m_bMapOn = false;
	    m_bMapOff = false;
	    m_bMapClick = false;
	    m_bDropInvObject = false;
	    m_Obj = null;
	    m_bDropInvObject = false;
    }
    
    public void TurnOnSpace()
    {
        // wylaczamy sky i terrain
        ViewRenderTerrain(iMovieViewID, false);
        ViewRenderSky(iMovieViewID, false);
        ViewRenderWater(iMovieViewID, false);
    }
    
    public void TurnOffSpace()
    {
        // wlaczamy sky i terrain
        ViewRenderTerrain(iMovieViewID, true);
        ViewRenderSky(iMovieViewID, true);
        ViewRenderWater(iMovieViewID, true);
    }
    
    public void TurnOnWater()
    {
        //??? nie wiem co ta metoda robila wczesniej
    }
 
    boolean bJustLoaded = false;
        
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[Level00.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_CHROMEMODULE_PROLOG)
        {	
			super.SGLoadChunk(cFC);
            
            // bJustLoaded = true;
			
			bFastTutorial = cFC.LoadBool();
			bFirstTutorial = cFC.LoadBool();
			bTutorialEnded = cFC.LoadBool();
			m_bChestOpened = cFC.LoadBool();
		
			m_nObjectsInChest = cFC.LoadInt();
		
			m_bTurnInventoryOn = cFC.LoadBool();
			m_bTurnInventoryOff = cFC.LoadBool();
		
			m_bInvObjectTaken = cFC.LoadBool();
			m_bCheckCafs = cFC.LoadBool();
			m_bCheckAiming = cFC.LoadBool();
			m_bBinocularsOn = cFC.LoadBool();
			m_bBinocularsOff = cFC.LoadBool();
			m_bZoom = cFC.LoadBool();
			m_bMapOn = cFC.LoadBool();
			m_bMapOff = cFC.LoadBool();
			m_bMapClick = cFC.LoadBool();
		
			m_vLastDestPosOnMap = cFC.LoadVector();
		
			m_Obj = (InvObject)cFC.LoadObjectRef();
				
			m_bDropInvObject = cFC.LoadBool();							
        }
		
		cFC.delete();
    }
    
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[Level00.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_CHROMEMODULE_PROLOG, cFCParent);
		
		super.SGSaveChunk(cFC);
		
		cFC.SaveBool(bFastTutorial);
		cFC.SaveBool(bFirstTutorial);
		cFC.SaveBool(bTutorialEnded);
		cFC.SaveBool(m_bChestOpened);
		
		cFC.SaveInt(m_nObjectsInChest);
		
		cFC.SaveBool(m_bTurnInventoryOn);
		cFC.SaveBool(m_bTurnInventoryOff);
		
		cFC.SaveBool(m_bInvObjectTaken);
		cFC.SaveBool(m_bCheckCafs);
		cFC.SaveBool(m_bCheckAiming);
		cFC.SaveBool(m_bBinocularsOn);
		cFC.SaveBool(m_bBinocularsOff);
		cFC.SaveBool(m_bZoom);
		cFC.SaveBool(m_bMapOn);
		cFC.SaveBool(m_bMapOff);
		cFC.SaveBool(m_bMapClick);
		
		cFC.SaveVector(m_vLastDestPosOnMap);
		
		cFC.SaveObjectRef(m_Obj);
			
		cFC.SaveBool(m_bDropInvObject);		

        cFC.delete();
    }	
    
    public void SGUpdate()
    {
        super.SGUpdate();
        /*
        if (sSaveGameName.toLowerCase().indexOf(SGController._SG_RESTARTSAVELOAD_FILE.toLowerCase()) != -1)
        {
            if (cHintManager != null)
            {
                cHintManager.delete();
                cHintManager = null;
            }
            SetStateBeforeTutorial();
            InitHints();
            ActivateHints();
            Training();
        }
        else
        {
            if (cHintManager != null)
            {
                cHintManager.delete();
                cHintManager = null;
            }
            InitAfterTutorialHints();
            
            bTutorialEnded = true;
        
            if(Game.cSingleton instanceof ChromeGame)
            {
                ChromeGame game = (ChromeGame)Game.cSingleton;
                game.EnableLoadSave(true);
            }
        }
		*/
    }
}