/** Przykladowy level.
 */
public class LevelTemplate extends ChromeModuleSingle
{

    //////////////////////////////////////////////////////////////////////////
    // identyfikatory objectives
    
    final static int OBJECTIVE_GROUP_X  = 1;
    final static int OBJECTIVE_X1       = 1;
    final static int OBJECTIVE_X2       = 2;

    final static int OBJECTIVE_GROUP_Y  = 2;
    final static int OBJECTIVE_Y1       = 1;

    final static int OBJECTIVE_Z        = 3;

    
    //////////////////////////////////////////////////////////////////////////
    // inicjacja

    void OnCreate()
    {
        super.OnCreate();    
        
        // sprawdzenie, czy wszystkie potrzebne do dzialania levelu obiekty sa ustawione
        MeshObject object;

        if (GetObjectByName("Object01") == null)
        {
            CrashLog("[Level.OnCreate]: ERROR: "+"Object01"+" NOT FOUND\n");
         }

        if (GetObjectByName("Object02") == null)
        {
            CrashLog("[Level.OnCreate]: ERROR: "+"Object02"+" NOT FOUND\n");
        }

        //definicja scenariuszy
        sLevelName = "Template";
        
        // scenariusze gadek
        aChatScenario = new String[][] { {"C Scene00_Chat00", "L Scene00_Chat01"} };

        // teksty do filmow        
        sMovieScenario = new String[][] { {"Film00/Movie00_Chat00", "Film00/Movie00_Chat01"} };
        
        //rejestracja klawiszy
        RegisterKeyRequest();        
    }

    void Init()
    {
        // wlaczamy odpowiednio objectivy
		m_ObjectivesManager.EnableObjective(OBJECTIVE_GROUP_X);
		m_ObjectivesManager.EnableObjective(OBJECTIVE_GROUP_Y);
		m_ObjectivesManager.EnableObjective(OBJECTIVE_Z);
        
        //inne rzeczy, np. ukrycie niewidoczych na poczatku przedmiotow
    }

    //////////////////////////////////////////////////////////////////////////
    // obsluga hotspotow

    boolean bStart = false, bEnd = false;

    void OnEnterHotSpot(Actor Adventurer, HotSpot Point)
    {
        LogLine("Aktor <"+ Adventurer.getClass().getName() +"> wszedl w punkt "+ "\""+Point.GetName()+"\"");

        PlayerSingle player;

        try
        {
            player = (PlayerSingle)Adventurer;
        } catch( ClassCastException e) {
            return;
        }
        
        if (Point.GetName().compareTo("hotStart") == 0)
        {
            if (!bStart) CallMethodIn("Start", 1);

        } else if (Point.GetName().compareTo("hotEnd") == 0)
        {
            if (!bEnd) CallMethodIn("TheEnd", 1);

        } else if (Point.GetName().compareTo("hotMovie") == 0)
        {
            Movie00_Take00();
        } else if  (Point.GetName().compareTo("hotChat") == 0)
        {
            PlayScene(0);
        }

    }

    void OnLeaveHotSpot(Actor Adventurer, HotSpot Point)
    {
        Log("Aktor <"+ Adventurer.getClass().getName() +"> wyszedl z punktu "+ "\""+Point.GetName()+"\"");
    }

    public void GateOpened(String sGateName)
    {
        if (sGateName.compareTo("Gate00") == 0)
        {
			m_ObjectivesManager.SetAccomplished(OBJECTIVE_GROUP_X, OBJECTIVE_X1);
			m_ObjectivesManager.SetAccomplished(OBJECTIVE_GROUP_Y, OBJECTIVE_Y1);
        }
    }

    ///////////////////////////////////////////////////////////////////////////
    void Start()
    {
        bStart = true;
    }
    
    void TheEnd()
    {
        bEnd = true;
        MissionSuccess("");        
    }

    ///////////////////////////////////////////////////////////////////////////
    // Movie00
    
    void Movie00_Take00()
    {
        //InGameMovieStart();

        //ustawienie i aktywacja kamery
        //ActivateCamera(cMovieCamera);
        
        float fTime = MovieSpeak(MainPlayer, sMovieScenario[0][0]);
        CallMethodIn("Movie00_Take01", fTime);
    }

    void Movie00_Take01()
    {
        //float fTime = MovieSpeak(Dexon, sMovieScenario[0][1]);
        //CallMethodIn("Movie00_Stop", fTime);
    }

    void Movie00_Stop()
    {
        //InGameMovieEnd();
    }

}
