import java.util.*;

/** Trigger, zawierajacy ekran z animowana tekstura. Klasa bazowa dla komputerow
 *  security i innych...
 */
public class AnimatedScreen extends Destroyable
{
    /** Numer materialu zawierajacego teksture do animowania
     */
    public int nScreenMaterial = 1;//#AnimatedScreen
    
    /** Lista tekstur, ktore moga pojawic sie na ekranie. Jest to String  
     *  ze sciezkami do materialow oddzielonymi srednikami (przecinkami)
     */
    public String sMaterialsList = "";//#AnimatedScreen
    //"Ekran1GreenOff.mat;Ekran1GreenOn.mat;Ekran1RedOff.mat;Ekran1RedOn.mat;Ekran1YellowOff.mat;Ekran1YellowOn.mat";
    
    /** Indeks tekstury ekranu, ktora ma sie pojawic na poczatku
     */
    public int nStartupScreenIdx = 0;//#AnimatedScreen
    

    String sOriginalMaterial = "Ekran1.mat";//#AnimatedScreen;Material to be replaced.
    int nOriginalMaterialID = -1;
    
    /*--------------------------------------------------------------------------*/
    AnimatedScreen()
    {
        fHealth = 10000;
    }

    /** Tablica z nazwami materialow (sparsowany sMaterialsList)
     */
    java.util.Vector aMaterials = new java.util.Vector();
    
    
    public void OnCreate()
    {
        super.OnCreate();
        nOriginalMaterialID = MaterialGetID(sOriginalMaterial);
        InitializeMaterials();
        
        bActiveTrigger = false;
    }
    

    void InitializeMaterials()
    {
        aMaterials.removeAllElements();
        StringTokenizer cMaterialsTokenizer = new StringTokenizer(sMaterialsList, ",;", false);
        while (cMaterialsTokenizer.hasMoreTokens())
        {
            String sMaterial = cMaterialsTokenizer.nextToken();
            sMaterial = sMaterial.trim();
            aMaterials.addElement(sMaterial);
        }
        //SetScreen(nStartupScreenIdx);
    }
	
	public int nCurrentMaterial = -1;
    
    /** Procedura powoduje ustawienie tekstury ekranu na jedna z listy tekstur 
     *  @param nTextureIdx numer tekstury 'do wyswietlenia' (jesli numer jest
     *         poza zakresem, ustawiona zostanie tekstura DOMYSLNA DLA MESHA
     */
    public void SetScreen(int nMaterialIdx)
    {
		nCurrentMaterial = nMaterialIdx;
			
        if (nMaterialIdx < 0 ||
            nMaterialIdx >= aMaterials.size())
        {
            //LoadMesh();
        }
        else
        {
            ReplaceOriginalMaterial(nOriginalMaterialID, (String)aMaterials.elementAt(nMaterialIdx));
        }
            // TODO : call MeshObject::ReplaceMaterial(..) instead
			//          see also GameObject::MaterialLoad(..)
            //SetSkinElement((String)aMaterials.elementAt(nTextureIdx), nScreenMaterial);
    }
	
    //*********************************************************
	//					SaveGame
    //*********************************************************	
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[AnimatedScreen.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_ANIMATED_SCREEN)
        {	
			super.SGLoadChunk(cFC);
			
        }
		
		cFC.delete();
    }
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[AnimatedScreen.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_ANIMATED_SCREEN, cFCParent);
		
		super.SGSaveChunk(cFC);
							
        cFC.delete();
    }	    						
	
	public void SGUpdate()
	{
		FileChunk.Log("[AnimatedScreen.SGUpdate]\n");
		super.SGUpdate();
		
		SetScreen(nCurrentMaterial);
	}
}
