/** Obiekt zarzadza kolejnoscia odpalania leveli po uruchomieniu gry.
 * Taki obiekt jest tworzony dla kazdego typu gry.
 */
//import java.util.Vector;


public class LevelsManager
{
    // aktualnie wybrany do grania Level, nazwe mozna pobrac metoda GetCurrent
    public int nCurrent = 0;
    
    // wektor wybranych Leveli
    private java.util.Vector aLevelsList = null;

    static java.util.Vector m_vDiffModifiersVeryEasy = new java.util.Vector();
    static java.util.Vector m_vDiffModifiersEasy = new java.util.Vector();
    static java.util.Vector m_vDiffModifiersNormal = new java.util.Vector();
    static java.util.Vector m_vDiffModifiersHard = new java.util.Vector();
    static java.util.Vector m_vDiffModifiersVeryHard = new java.util.Vector();
    
    static java.util.Vector GetDiffModifiers(int nDiff)
    {
        switch(nDiff)
        {
        case ChromeGame.DIFF_VERY_EASY:
            return m_vDiffModifiersVeryEasy;
        case ChromeGame.DIFF_EASY:
            return m_vDiffModifiersEasy;
        case ChromeGame.DIFF_NORMAL:
            return m_vDiffModifiersNormal;
        case ChromeGame.DIFF_HARD:
            return m_vDiffModifiersHard;
        case ChromeGame.DIFF_VERY_HARD:
            return m_vDiffModifiersVeryHard;
        }
        return null;
    }
    
    // nazwa pliku trzymana w celu przechowywania informacji o ustawieniu
    String sConfigFileName = null;
	
	public int GetLevelPos(String sLavelName)
	{
		for (int i=0; i < aLevelsList.size(); i++)
			if (sLavelName.compareTo(((LevelContent)aLevelsList.elementAt(i)).sLevelName) == 0)
				return i;
		return -1;
	}
    
    void Init(String sFileName)
    {
        m_vDiffModifiersVeryEasy.removeAllElements();
        m_vDiffModifiersEasy.removeAllElements();
        m_vDiffModifiersNormal.removeAllElements();
        m_vDiffModifiersHard.removeAllElements();
        m_vDiffModifiersVeryHard.removeAllElements();
        Init(sFileName, false);
    }
    
    /** Inicjalizacja na podstawie danych zawartych w pliku
     */
    void Init(String sFileName, boolean bAdd)
    {
        // tworzymy pusty wektor leveli
        if (!bAdd)
            aLevelsList = new java.util.Vector(0);
        
        // odczytanie z pliku listy leveli
        sConfigFileName = new String(sFileName);
        ParseKeyword Root = GameObject.ParseFile(sConfigFileName);
        
        if(Root == null)
        {
            GameObject.CrashLog("No file "+ sConfigFileName +"!\n");
        }
        else
        {
            ParseKeyword Key, SubKey;
            for (Key = Root; Key != null; Key = Key.GetNext())
            {
                if (Key.Equals("VeryEasy"))
                {
                    LoadDiffSettings(Key, m_vDiffModifiersVeryEasy, ChromeGame.DIFF_VERY_EASY);
                }
                if (Key.Equals("Easy"))
                {
                    LoadDiffSettings(Key, m_vDiffModifiersEasy, ChromeGame.DIFF_EASY);
                }
                if (Key.Equals("Normal"))
                {
                    LoadDiffSettings(Key, m_vDiffModifiersNormal, ChromeGame.DIFF_NORMAL);
                }
                if (Key.Equals("Hard"))
                {
                    LoadDiffSettings(Key, m_vDiffModifiersHard, ChromeGame.DIFF_HARD);
                }
                if (Key.Equals("VeryHard"))
                {
                    LoadDiffSettings(Key, m_vDiffModifiersVeryHard, ChromeGame.DIFF_VERY_HARD);
                }
                
                if (Key.Equals("LevelMap"))
                {
                    if (ChromeGameRunInfo.s_bSkipCutscenes)
                    {
                        String sLevelName = Key.GetSParam(0).toLowerCase();
						
						if (sLevelName.indexOf("film") != -1
							&& sLevelName.indexOf("f13-01") == -1)
                            continue;
                    }
                    
                    LevelContent cLevel = new LevelContent();
                    cLevel.sLevelName = new String(Key.GetSParam(0));
                    cLevel.nLevelType = LevelContent._MAP;
                    aLevelsList.addElement(cLevel);

                    for (SubKey = Key.GetChild(); SubKey != null; SubKey = SubKey.GetNext())
                    {
                        PerformLevelMapCommand( SubKey, cLevel );
                    }
                }
                
				if (Key.Equals("TalkHead"))
                {
				    LevelContent cLevel=new LevelContent();
                    cLevel.nLevelType = LevelContent._MOVIES_TH;
                    aLevelsList.addElement(cLevel);
                    for(SubKey=Key.GetChild(); SubKey!=null; SubKey=SubKey.GetNext())
                    {
                        if(SubKey.Equals("ScenMap"))
                        {
                            cLevel.sLevelName = new String(SubKey.GetSParam(0));
                        }
                        
                        if(SubKey.Equals("ScenScript"))
                        {
                            cLevel.sMoviesScr = new String(SubKey.GetSParam(0));
                        }
                        
                        if(SubKey.Equals("FadingTime"))
                        {
                            cLevel.fFadingTime = SubKey.GetFParam(0);
                        }
                        
                        if(SubKey.Equals("PrepareToMissionMode"))
                        {
                            cLevel.bPrepareToMission = true;
                            InventoryRoomCommand(SubKey.GetChild(),cLevel);
                        }
                    }
				}
				
                if(Key.Equals("Scenery"))
                {
				    LevelContent cLevel=new LevelContent();
                    cLevel.nLevelType = LevelContent._MOVIES_S;
                    aLevelsList.addElement(cLevel);
                    for(SubKey=Key.GetChild(); SubKey!=null; SubKey=SubKey.GetNext())
                    {
                        if(SubKey.Equals("Camera"))
                        {
                            cLevel.sCameraName = new String(SubKey.GetSParam(0));
                            cLevel.fFOV = SubKey.GetFParam(1);
                        }
                        if(SubKey.Equals("Path3DA"))
                        {
                            cLevel.sPhat3DA = new String(SubKey.GetSParam(0));
                            cLevel.nLastAnimFrame = SubKey.GetIParam(1);
                        }
                        if(SubKey.Equals("PathWAV"))
                        {
                            cLevel.sPhatWAV = new String(SubKey.GetSParam(0));
                        }
                        if(SubKey.Equals("TrackingMeshElement"))
                        {
                            cLevel.sTrackingMeshElementName = new String(SubKey.GetSParam(0));
                        }
                        
                        if(SubKey.Equals("FadingTime"))
                        {
                            cLevel.fFadingTime = SubKey.GetFParam(0);
                        }
                        
                        if(SubKey.Equals("PrepareToMissionMode"))
                        {
                            cLevel.bPrepareToMission = true;
                            InventoryRoomCommand(SubKey.GetChild(),cLevel);
                        }
                    }
				}
                
                if (Key.Equals("LevelModule"))
                {
                    LevelContent cLevel = new LevelContent();
                    cLevel.sLevelName = new String(Key.GetSParam(0));
                    cLevel.nLevelType = LevelContent._MODULE;
                    aLevelsList.addElement(cLevel);
                    
                    for(SubKey = Key.GetChild(); SubKey != null; SubKey = SubKey.GetNext())
                    {
                        //if(SubKey.Equals("PlaySceneryTracking"))
                        {
                            // 
                        }
                    }
                }
            }
            
            Root.delete();
        }
    }
   
    void AddLevels(String sName)
    {
        Init(sName, true);
    }
    
    void PerformLevelMapCommand( ParseKeyword SubKey,
                                 LevelContent cLevel )
    {
        PerformLevelMapCommand( SubKey, cLevel,false );
    }
        
    void PerformLevelMapCommand( ParseKeyword SubKey,
                                 LevelContent cLevel,
                                 boolean      bNetwork )
    {
        if(SubKey.Equals("MapTexture"))
        {
            cLevel.SetLevelMapTexture( new String(SubKey.GetSParam(0)) );
            GameObject.Log("Level <"+cLevel.sLevelName+"> map <"+cLevel.sLevelMapTexture + ">\n");
        }
        if (SubKey.Equals("Description"))
        {
            cLevel.sDescriptionLevel = new String(SubKey.GetSParam(0)); 
        }
        if (SubKey.Equals("Briefing"))
        {
            cLevel.sBriefing = new String(SubKey.GetSParam(0)); 
        }
        if (SubKey.Equals("DescriptionBackground"))
        {
            cLevel.SetDescriptionLevelBackground( new String(SubKey.GetSParam(0)) );    
        }
        if (SubKey.Equals("WeatherDescription"))
        {
            cLevel.sWeather = new String(SubKey.GetSParam(0)); 
        }
        if (SubKey.Equals("SaveName"))
        {
            cLevel.sSaveName = new String(SubKey.GetSParam(0));
        }
        if (SubKey.Equals("DisableDetector"))
        {
            cLevel.bDisableDetector = true;
        }
        
		// obsluga objectives
		if (SubKey.Equals("AObjective"))
		{
			ObjectiveDescription obj =
				new ObjectiveDescription(SubKey.GetIParam(0),
										 0,
										 false,
										 SubKey.GetSParam(1));
            GameObject.LogD(" "+SubKey.GetIParam(0)+" "+SubKey.GetSParam(1)+"\n");
			cLevel.m_Objectives.addElement(obj);
		}
		if (SubKey.Equals("DefLocation"))
		{
			LocationDescription loc =
				new LocationDescription(SubKey.GetIParam(0),
										0,
										SubKey.GetSParam(1),
										new Vector(SubKey.GetFParam(2),
												   SubKey.GetFParam(3),
												   SubKey.GetFParam(4)));
			cLevel.m_Locations.addElement(loc);
		}
		if (SubKey.Equals("DefLocationTrack"))
		{
			LocationDescription loc =
				new LocationDescription(SubKey.GetIParam(0),
									    0,
									    SubKey.GetSParam(1),
									    SubKey.GetSParam(2));
			cLevel.m_Locations.addElement(loc);
		}
						
		if (SubKey.Equals("AddToolTip"))
		{
			LocationDescription loc = LocationDescription.FindLocation(SubKey.GetIParam(0),
																	   SubKey.GetIParam(1),
																	   cLevel.m_Locations);
			if (loc != null)
				loc.SetToolTip(SubKey.GetSParam(2));
		}
						
		if (SubKey.Equals("AObjectiveGroup"))
		{
			int iGroupNo = SubKey.GetIParam(0);
			ObjectiveDescription obj =
				new ObjectiveDescription(iGroupNo,
										 0,
										 true,
										 SubKey.GetSParam(1));
			cLevel.m_Objectives.addElement(obj);
							
            for (ParseKeyword SubKey2 = SubKey.GetChild(); SubKey2 != null; SubKey2 = SubKey2.GetNext())
			{
				if (SubKey2.Equals("AObjective"))
				{
					obj = new ObjectiveDescription(iGroupNo,
												   SubKey2.GetIParam(0),
												   false,
												   SubKey2.GetSParam(1));
					cLevel.m_Objectives.addElement(obj);
				}
				if (SubKey2.Equals("DefLocation"))
				{
					LocationDescription loc =
						new LocationDescription(iGroupNo,
											    SubKey2.GetIParam(0),
												SubKey2.GetSParam(1),
												new Vector(SubKey2.GetFParam(2),
														   SubKey2.GetFParam(3),
														   SubKey2.GetFParam(4)));
					cLevel.m_Locations.addElement(loc);
				}
				if (SubKey2.Equals("DefLocationTrack"))
				{
					LocationDescription loc =
						new LocationDescription(iGroupNo,
											    SubKey2.GetIParam(0),
												SubKey2.GetSParam(1),
												SubKey2.GetSParam(2));
					cLevel.m_Locations.addElement(loc);
				}
				if (SubKey2.Equals("AddToolTip"))
				{
					LocationDescription loc = LocationDescription.FindLocation(SubKey.GetIParam(0),
																			   SubKey.GetIParam(1),
																			   cLevel.m_Locations);
					if (loc != null)
						loc.SetToolTip(SubKey.GetSParam(2));
				}
			}
		}
		
        /**
         * Uwaga!
         * Wszystko co ponizej nie bedzie obslugiwane w sieci!!!
         */
        if ( bNetwork )
            return;
        
        if(SubKey.Equals("DefaultWeapon"))
        {
            cLevel.aDefaultWeapons.addElement(new String(SubKey.GetSParam(0)));
        }
        
		// obsluga implantow
		if (SubKey.Equals("ImplantAssimilation"))
		{
			//GameObject.LogR("ImplantAssimilation\n");
			ImplantModifier aModifier =
				new ImplantModifier(new String(SubKey.GetSParam(0)),
									SubKey.GetFParam(1));
		    cLevel.aImplantModifiers.addElement(aModifier);
		}
        if (SubKey.Equals("NewImplantAssimilation"))
		{
			//GameObject.LogR("ImplantAssimilation\n");
			ImplantModifier aModifier =
				new ImplantModifier(new String(SubKey.GetSParam(0)),
									SubKey.GetFParam(1), true);
		    cLevel.aImplantModifiers.addElement(aModifier);
		}
        if (SubKey.Equals("HackMovesMult"))
        {
            cLevel.m_fHackMovesMult = SubKey.GetFParam(0);
        }
        if (SubKey.Equals("HackElemsRange"))
        {
            cLevel.m_nHackElemsMin = SubKey.GetIParam(0);
            cLevel.m_nHackElemsMax = SubKey.GetIParam(1);
        }
        if (SubKey.Equals("HackCombo"))
        {
            cLevel.m_nHackCombo = SubKey.GetIParam(0);
        }
            
        if (SubKey.Equals("ImplantsChanged"))
		{
            cLevel.bImplantsChanged = true;
        }
        
        if (SubKey.Equals("LeaveInventory"))
		{
            cLevel.bLeaveInventory = true;
        }
        
        if(SubKey.Equals("PrepareToMissionMode"))
        {
            cLevel.bPrepareToMission = true;
            InventoryRoomCommand(SubKey.GetChild(),cLevel);
        }
        
        if(SubKey.Equals("StartLevelWithWeapon"))
        {
            cLevel.sStartWithWeapon = new String(SubKey.GetSParam(0));
        }
        
        if(SubKey.Equals("StartItem"))
        {
            cLevel.aStartItems.addElement(new String(SubKey.GetSParam(0)));
        }
        
        if(SubKey.Equals("ActionPath"))
        {
            cLevel.aActionPaths.addElement(new String(SubKey.GetSParam(0)));
        }
        
        if(SubKey.Equals("TexturesPath"))
        {
            cLevel.aLevelTexturesPaths.addElement(new String(SubKey.GetSParam(0)));
        }
    }
    
    void LoadDiffSettings(ParseKeyword Key, java.util.Vector vList, int nDiff)
    {
        vList.removeAllElements();
        NewAI.ResetModifiers();
        ParseKeyword SubKey = null;
        for (SubKey = Key.GetChild(); SubKey != null; SubKey = SubKey.GetNext())
        {
            if(SubKey.Equals("AccuracyMult"))
            {
                vList.addElement(new AIModAccuracyMult(SubKey.GetFParam(0)));
            }
            if(SubKey.Equals("FiringTimeMult"))
            {
                vList.addElement(new AIModAccuracyMult(SubKey.GetFParam(0)));
            }
            if(SubKey.Equals("FireDelayMult"))
            {
                vList.addElement(new AIModFireDelayMult(SubKey.GetFParam(0)));
            }
            if(SubKey.Equals("SingleHealtexProbability"))
            {
                vList.addElement(new AIModSingleHealtexProbability(SubKey.GetIParam(0)));
            }
            if(SubKey.Equals("MaxHealtexesNumber"))
            {
                vList.addElement(new AIModMaxHealtexesNumber(SubKey.GetIParam(0)));
            }
            if(SubKey.Equals("SingleGrenadeProbability"))
            {
                vList.addElement(new AIModSingleGrenadeProbability(SubKey.GetIParam(0)));
            }
            if(SubKey.Equals("MaxGrenadesNumber"))
            {
                vList.addElement(new AIModMaxGrenadesNumber(SubKey.GetIParam(0)));
            }
            if(SubKey.Equals("MinHitRatioMult"))
            {
                vList.addElement(new AIModMinHitRatioMult(SubKey.GetFParam(0)));
            }
            if(SubKey.Equals("MaxHitRatioMult"))
            {
                vList.addElement(new AIModMaxHitRatioMult(SubKey.GetFParam(0)));
            }
            if(SubKey.Equals("MinSpareAmmoClips"))
            {
                vList.addElement(new AIModMinSpareAmmoClips(SubKey.GetFParam(0)));
            }
            if(SubKey.Equals("MaxSpareAmmoClips"))
            {
                vList.addElement(new AIModMaxSpareAmmoClips(SubKey.GetFParam(0)));
            }
            if(SubKey.Equals("SpareAmmoProbability"))
            {
                vList.addElement(new AIModSpareAmmoProbability(SubKey.GetIParam(0)));
            }
            if (SubKey.Equals("HackMovesMult"))
            {
                ChromeGame.m_tHackDiffLevelMult[nDiff] = SubKey.GetFParam(0);
            }
            
            if (SubKey.Equals("TakeDamageMult"))
            {
                ChromeGame.m_tTakeDamageDiffLevelMult[nDiff] = SubKey.GetFParam(0);
            }
            
            if (SubKey.Equals("AIDetectionDelayMult"))
            {
                ChromeGame.m_aAIDetectionDelayDiffLevelMult[nDiff] = SubKey.GetFParam(0);
            }
            
            if (SubKey.Equals("CannonAimingMult"))
            {
                ChromeGame.m_aCannonAimingDiffLevelMult[nDiff] = SubKey.GetFParam(0);
            }
            
            if (SubKey.Equals("CloakingDeviceRecognitionMult"))
            {
                ChromeGame.m_aAICloakingDeviceRecogMult[nDiff] = SubKey.GetFParam(0);
            }
        }
    }
    
    void InitNet(String sFileName)
    {
        // tworzymy pusty wektor leveli
        aLevelsList = new java.util.Vector(0);
        
        // odczytanie z pliku listy leveli
        sConfigFileName = new String(sFileName);
        ParseKeyword Root = GameObject.ParseFile(sConfigFileName);
        
        if(Root == null)
        {
            GameObject.CrashLog("No file "+ sConfigFileName +"!\n");
        }
        else
        {
            ParseKeyword Key, SubKey;
            int nGameCnt = 0;
            for (Key = Root; Key != null; Key = Key.GetNext())
            {
                if (Key.Equals("LevelMapNet"))
                {
                    String sName      = Key.GetSParam( 0 );
                    int    nGameType  = Key.GetIParam( 1 );
                    
                    //TODO: sprawdzic, czy mapa jest dostepna w wersji demo:
                    
                    if ( sName     != null && 
                         nGameType >= 0    && 
                         nGameType < ENetGameType.TYPES_COUNT )
                    {
                        LevelContent cLevel = new NetLevelContent( sName, nGameType );
                        aLevelsList.addElement( cLevel );
                    }
                    else
                    {
                        if ( sName != null )
                            GameObject.CrashLog("Bledny typ gry "+nGameType+
                                                " dla "+sName+"\n");
                        else
                            GameObject.CrashLog("Zla nazwa gry "+nGameCnt+"\n");
                    }
                    nGameCnt++;
                }
            }
            Root.delete();
        }
    
        if ( aLevelsList != null )
            for ( int i=0; i<aLevelsList.size(); i++ )
            {
                if ( ! (aLevelsList.elementAt(i) instanceof LevelContent) )
                    continue;
                
                LevelContent cLevelContent = (LevelContent)aLevelsList.elementAt(i);
        
                //HACK: na pale wpiszmy jeden noz (lub raczki) do default
                AddInbornWeaponToDefaultWeapons( cLevelContent );
                
                //parsujemy parametry ze skryptu
                //Uwaga: nie sa juz parsowane GameSettings!
                ParseNetLevelScript( cLevelContent );
                
                //HACK: na pale wpiszmy noz lub raczki
                AddInbornWeaponToInventoryRoom( cLevelContent );
            }
    }
    
    static String NET_LEVEL_SCRIPT_FILE_NAME = "Level.scr";
    
    void ParseNetLevelScript( LevelContent cLevel )
    {
        String sLevelMap = new String( cLevel.sLevelName );
        
        //GameObject.CrashLog("Pracujemy nad "+ sLevelMap +"\n");
            
        int nLast = sLevelMap.lastIndexOf("/");
        String sLevelPath      =  new String( sLevelMap.substring( 0, nLast ) );
        String sScriptFullName = sLevelPath + "/" + 
                                 ENetGameType.GetScriptFileName( cLevel.GetNetGameType() );    
            
        //GameObject.CrashLog("Parsujemy "+sScriptFullName+"\n");
            
        ParseKeyword Root = GameObject.ParseFile( sScriptFullName );
        if (Root == null)
        {
            GameObject.CrashLog("No file "+ sScriptFullName +"!\n");
        }
        else
        {
            for (ParseKeyword Key = Root; Key != null; Key = Key.GetNext())
            {
                if (Key.Equals("InventoryRoom"))
                {
                    NetInventoryRoomCommand( Key.GetChild(),cLevel );
                }
                
                if (Key.Equals("ImplantsRoom"))
                {
                    NetImplantsRoomCommand( Key.GetChild(),cLevel );
                }
                
                PerformLevelMapCommand( Key, cLevel, true );
            }
            Root.delete();
        }
    }
    
    
    void AddInbornWeaponToDefaultWeapons(LevelContent cLevelContent)
    {
        cLevelContent.aDefaultWeapons.addElement( PlayerNet.GetInbornWeaponClass().getName() );
        //GameObject.CrashLog("AddInbornWeaponToDefault "+PlayerNet.GetInbornWeaponClass().getName()+"\n");
    }
    
    void AddInbornWeaponToInventoryRoom(LevelContent cLevelContent)
    {
        //w Inventory musi znajdowac sie jeden i dokladnie jeden noz...
        InventoryRoomModifier aModifier =
					new InventoryRoomModifier(EInventoryRoomModifiers._SET,
											   EInvObjType._GUN,
											   PlayerNet.GetInbornWeaponClass().getName(),
											   1 );
        cLevelContent.aInventoryRoomModifiers.addElement(aModifier);
        //GameObject.CrashLog("AddInbornWeaponToInventory "+PlayerNet.GetInbornWeaponClass().getName()+"\n");
    }
        
    void InventoryRoomCommand(ParseKeyword SubKey,LevelContent cLevelContent)
    {
        for(; SubKey!=null; SubKey=SubKey.GetNext())
        {
			
            if(SubKey.Equals("DisableInvObject"))
            {
				InventoryRoomModifier aModifier =
					new InventoryRoomModifier(EInventoryRoomModifiers._DISABLE,
											   EInvObjType._NONE,
											   new String(SubKey.GetSParam(0)));
                cLevelContent.aInventoryRoomModifiers.addElement(aModifier);
            }
            if(SubKey.Equals("AddInvWeapon"))
            {
				InventoryRoomModifier aModifier =
					new InventoryRoomModifier(EInventoryRoomModifiers._ADD,
											   EInvObjType._GUN,
											   new String(SubKey.GetSParam(0)),
											   SubKey.GetIParam(1));
                cLevelContent.aInventoryRoomModifiers.addElement(aModifier);
            }
            if(SubKey.Equals("DelInvWeapon"))
            {
				InventoryRoomModifier aModifier =
					new InventoryRoomModifier(EInventoryRoomModifiers._DEL,
											   EInvObjType._GUN,
											   new String(SubKey.GetSParam(0)),
											   SubKey.GetIParam(1));
                cLevelContent.aInventoryRoomModifiers.addElement(aModifier);
            }
            if(SubKey.Equals("SetInvWeaponNum"))
            {
				InventoryRoomModifier aModifier =
					new InventoryRoomModifier(EInventoryRoomModifiers._SET,
											   EInvObjType._GUN,
											   new String(SubKey.GetSParam(0)),
											   SubKey.GetIParam(1));
                cLevelContent.aInventoryRoomModifiers.addElement(aModifier);
            }
            if(SubKey.Equals("AddInvAmmo"))
            {
				InventoryRoomModifier aModifier =
					new InventoryRoomModifier(EInventoryRoomModifiers._ADD,
											   EInvObjType._AMMO,
											   new String(SubKey.GetSParam(0)),
											   SubKey.GetIParam(1));
                cLevelContent.aInventoryRoomModifiers.addElement(aModifier);
            }
            if(SubKey.Equals("DelInvAmmo"))
            {
				InventoryRoomModifier aModifier =
					new InventoryRoomModifier(EInventoryRoomModifiers._DEL,
											   EInvObjType._AMMO,
											   new String(SubKey.GetSParam(0)),
											   SubKey.GetIParam(1));
                cLevelContent.aInventoryRoomModifiers.addElement(aModifier);
            }
            if(SubKey.Equals("SetInvAmmoNum"))
            {
				InventoryRoomModifier aModifier =
					new InventoryRoomModifier(EInventoryRoomModifiers._SET,
											   EInvObjType._AMMO,
											   new String(SubKey.GetSParam(0)),
											   SubKey.GetIParam(1));
                cLevelContent.aInventoryRoomModifiers.addElement(aModifier);
            }
            if(SubKey.Equals("AddInvEquip"))
            {
				InventoryRoomModifier aModifier =
					new InventoryRoomModifier(EInventoryRoomModifiers._ADD,
											   EInvObjType._EQUIP,
											   new String(SubKey.GetSParam(0)),
											   SubKey.GetIParam(1));
                cLevelContent.aInventoryRoomModifiers.addElement(aModifier);
            }
            if(SubKey.Equals("DelInvEquip"))
            {
				InventoryRoomModifier aModifier =
					new InventoryRoomModifier(EInventoryRoomModifiers._DEL,
											   EInvObjType._EQUIP,
											   new String(SubKey.GetSParam(0)),
											   SubKey.GetIParam(1));
                cLevelContent.aInventoryRoomModifiers.addElement(aModifier);
            }
            if(SubKey.Equals("SetInvEquipNum"))
            {
				InventoryRoomModifier aModifier =
					new InventoryRoomModifier(EInventoryRoomModifiers._SET,
											   EInvObjType._EQUIP,
											   new String(SubKey.GetSParam(0)),
											   SubKey.GetIParam(1));
                cLevelContent.aInventoryRoomModifiers.addElement(aModifier);
            }
            if(SubKey.Equals("DefaultWeapon"))
            {
                cLevelContent.aDefaultWeapons.addElement(new String(SubKey.GetSParam(0)));
            }
        }
    }
    
    void Destroy()
    {
        // zapisanie do pliku konfiguracyjnego ustawienia leveli
        
        // skasowanie listy leveli
        aLevelsList.removeAllElements();
        aLevelsList = null;
    }
    
    /** Pobranie aktualnego levelu
     */
    LevelContent GetCurrent()
    {
        if ((aLevelsList.size() > 0) &&
            (nCurrent <  aLevelsList.size())&&
            (nCurrent >= 0))
            return (LevelContent)aLevelsList.elementAt(nCurrent);
        else
            return null;
    }

    String GetNextLevelBriefing()
    {
        int nLevel = nCurrent;
        while (nLevel < aLevelsList.size())
        {
            if (GetLevel(nLevel).sBriefing != null)
                return GetLevel(nLevel).sBriefing;
            nLevel++;
        }
        return "";
    }
    
    String GetNextLevelBackground()
    {
        int nLevel = nCurrent;
        while (nLevel < aLevelsList.size())
        {
            if (GetLevel(nLevel).sDescriptionLevelBackground != null)
                return GetLevel(nLevel).sDescriptionLevelBackground;
            nLevel++;
        }
        return "";
    }
    
    String GetNextMissionFileName()
    {
        int nLevel = nCurrent + 1;
        while (nLevel < aLevelsList.size())
        {
            if (GetLevel(nLevel).sLevelName != null)
            {
                String sLevelName = GetLevel(nLevel).sLevelName.toLowerCase();
                if (sLevelName.indexOf("film") == -1)   
                    return GetLevel(nLevel).sLevelName;
            }
            nLevel++;
        }
        return "";
    }
    
    int GetLevelsCnt() { return aLevelsList.size(); }
    
    /** Pobranie dowolonego levelu
     */
    LevelContent GetLevel(int nLevel)
    {
        if ((aLevelsList.size() > 0) &&
            (nLevel < aLevelsList.size())&&
            (nLevel >= 0))
            return (LevelContent)aLevelsList.elementAt(nLevel);
        else
            return null;    
    }
    
    /** Pobranie numeru porzadkowego aktualnego levelu
     */
    int GetCurrentLevelPos()
    {
        return nCurrent;
    }
    
    
    /**Tworzenie tablicy z listy i usowanie podanych w drugiej liscie elementow
     */
    String [] MakeArray(java.util.Vector cListWeapon, java.util.Vector cListDelete)
    {
        for( int i = 0 ; i < cListDelete.size() ; i++ )
        {
            if(!cListWeapon.removeElement(cListDelete.elementAt(i)))
            {
                GameObject.LogLine("Nie ma takiego elementu do usuniecia");
            }
        }
        
        String []tab = new String[cListWeapon.size()];
        for( int i = 0 ; i < cListWeapon.size() ; i++ )
        {
            tab[i] = new String((String)cListWeapon.elementAt(i));    
        }
        return tab;
    }
    
    /**
     */
    LevelContent SetSingleLevel(String sName)
    {
        aLevelsList.removeAllElements();
        Restart();
        
        if (sName != null)
        {
            LevelContent cLevel = new LevelContent();
            cLevel.sLevelName   = new String( sName );
            aLevelsList.addElement( cLevel );
            return cLevel;
        }
        
        return null;
    }
    
    void SetSingleNetLevel(String sName,int nGameType)
    {
        aLevelsList.removeAllElements();
        Restart();
        
        if (sName != null)
        {
            LevelContent cLevel = new NetLevelContent( sName, nGameType );
            aLevelsList.addElement( cLevel );
            ParseNetLevelScript( cLevel );
        }
    }
    
    /** Przelaczenie na nastepny po aktualnym levelu
     */
    void NextLevel()
    {
        nCurrent++;
        m_bCurrentValid = true;
    }
    
    /** Restart. Powoduje przeskoczenie na pierwszy element na liscie leveli.
     */
    void Restart()
    {
        nCurrent = 0;
        m_bCurrentValid = true;
    }
    
    void NetInventoryRoomCommand(ParseKeyword SubKey,LevelContent cLevelContent)
    {
        if ( cLevelContent.IsReceivedFromServer() )
            return;
        InventoryRoomCommand( SubKey,cLevelContent );
    }
    
    void NetImplantsRoomCommand(ParseKeyword SubKey,LevelContent cLevelContent)
    {
        if ( cLevelContent.IsReceivedFromServer() )
            return;
        
        for(; SubKey!=null; SubKey=SubKey.GetNext())
        {
            if (SubKey.Equals("ImplantAssimilation"))
		    {
			    ImplantModifier cModifier =
				    new ImplantModifier(new String(SubKey.GetSParam(0)),
									    SubKey.GetFParam(1));
		        cLevelContent.aImplantModifiers.addElement( cModifier );
		    }
        }
    }

    private 
    boolean m_bCurrentValid = true;

    /**
     * Checks if nCurrent indicates valid LevelContent
     */
    boolean IsCurrentValid()
    {
        return ((m_bCurrentValid) &&
                (aLevelsList.size() > 0) &&
                (nCurrent < aLevelsList.size()) &&
                (nCurrent >= 0) &&
                (aLevelsList.elementAt(nCurrent) != null));
    }
    

    
    /** wymuszenie nastepnego levelu
     */
    boolean ForceNetLevel(int nLevel)
    {
        nCurrent = nLevel-1;
        
        m_bCurrentValid = false;
        return true;
    }
    
    /** wymuszenie nastepnego levelu
     */
    boolean ForceNetLevel(int nLevel,LevelContent cNewLevel)
    {
        aLevelsList.insertElementAt( cNewLevel, nLevel+1 );
        ParseNetLevelScript( cNewLevel );
        
        return true;
    }
    
    boolean RemoveNetLevel(int nLevel)
    {
        if ( nCurrent != nLevel )
        {
            if ( nCurrent > nLevel )
                nCurrent --;
            aLevelsList.removeElementAt( nLevel );
            return true;
        }
        return false;
    }

}
