public class ChromMenuCustomLevels extends ChromeMenuWindow
{
    int m_iNumberOfActiveButtons = 0;
    final static String sm_sCustomMapDir = "data/LevelsCustom";
	
	final static String sm_sCustomMap = "CustomMap";
	
    int m_iActiveButton = -1;
    
    final static int _MAX_NR_OF_BUTTONS = 16;
    
	java.util.ArrayList vCustomMapScripts = new java.util.ArrayList();
	
    UIMenu m_cUIButtonsMenu = null;
    
    UIMenuButton m_cMenuButtons[] = new UIMenuButton[_MAX_NR_OF_BUTTONS];
	UIMenuButton m_cButtonNext = null;
	UIMenuButton m_cButtonPrev = null;
    
    String m_cBitmapsFile[] = new String[_MAX_NR_OF_BUTTONS];
    String m_cLevelSriptFile[] = new String[_MAX_NR_OF_BUTTONS];
   
	//index pierwszego wyswietlonego levelu
	int m_iFirstLevelID = 0;
	
	{
	nMovieIn = 24;
    nMovieLoop = 25;
	nMovieOut = 26;
	} 
	
    void Init(MenuBackground cBack)
    {
    	MenuModule=(ChromeMenuModule)GetModule();
      
        m_cUIButtonsMenu = (UIMenu)GetElem("ID_MENU_LEVELS");
		m_cButtonNext = (UIMenuButton)GetElem("ID_NEXT");
		m_cButtonPrev = (UIMenuButton)GetElem("ID_PREVIOUS");
        
        for(int i = 0; i < _MAX_NR_OF_BUTTONS; i++)
        {
            int iButtonID = i+1;
            m_cMenuButtons[i] = (UIMenuButton)m_cUIButtonsMenu.GetElem("ID_" + iButtonID);
            
            //na poczatek chowamy wszystkie przyciski
            m_cMenuButtons[i].Hide();
			m_cMenuButtons[i].SetDisabled(true);
        }
        GetElem("ID_SCREENSHOT").Hide();
        FindAvailableMaps();
		ShowLevelsFrom(m_iFirstLevelID);
    }

    boolean CheckFile(String  sFile)
    {
       java.io.File file = new java.io.File(sFile);
       return file.exists();    
    }
     
	/**Znajduje mapy w domyslnym katalogu i dodaje zapamietane mapy do MapListy*/
    void FindAvailableMaps()
    {
		vCustomMapScripts.clear();
		java.io.File MapDirec = new java.io.File( sm_sCustomMapDir );
        if (!MapDirec.exists())
        {
            MapDirec.mkdir();
            return;
        }
        String []aMapName = MapDirec.list();
        
        if (aMapName == null )  
            return;
		
		//uzupelniam lista dostepnych map
		for ( int i = 0 ; i < aMapName.length ; i++ )
		{
			String sDir        = sm_sCustomMapDir + "/" + aMapName[ i ];
			java.io.File   cDirToCheck = new java.io.File( sDir );
			if ( cDirToCheck.isDirectory() )
			{
				//sprawdzamy mape z katalogu sDir
				//String sMapFile = sm_sCustomMapDir + "/"+ aMapName[i] + "/"+ aMapName[i] + ".map";
				String sMapScript = sm_sCustomMapDir + "/"+ aMapName[i] + "/"+ aMapName[i] + ".scr";
				if (/*CheckFile(sMapFile) &&*/ CheckFile(sMapScript))
				{
					vCustomMapScripts.add(new String(aMapName[i]));
				}
			}
		}
    }

	void ShowLevelsFrom(int iIndex)
	{
		if(iIndex < 0)
			iIndex = 0;
		
		m_cButtonNext.SetDisabled(iIndex + _MAX_NR_OF_BUTTONS >= vCustomMapScripts.size());
		m_cButtonPrev.SetDisabled(iIndex == 0);
		
		m_iFirstLevelID = iIndex;
		m_iNumberOfActiveButtons = 0;
		m_iActiveButton = -1;
		
		for (int i = 0; i < _MAX_NR_OF_BUTTONS; i++)
		{
			m_cMenuButtons[i].Hide();
		}
		
		for (int i = iIndex; i < iIndex + _MAX_NR_OF_BUTTONS; i++)
		{
			if( i >= vCustomMapScripts.size())
				break;
			
			String sLevelDir = (String)vCustomMapScripts.get(i);
			
			String sMapScript = sm_sCustomMapDir + "/"+ sLevelDir + "/"+ sLevelDir + ".scr";
				
			ActivateNewButton(sLevelDir, sMapScript);
		}
		FitMenuSize();
	}
	
    void ActivateNewButton(String sText, String sLevelScriptFile)
    {
        if( m_iNumberOfActiveButtons == _MAX_NR_OF_BUTTONS)
            return;
        
		sText = TextToUpperCase(Text.Get(sText));
        int iButtonID = m_iNumberOfActiveButtons;
        
        
        m_cLevelSriptFile[iButtonID] = new String(sLevelScriptFile);
        
        if (MenuModule.cGameInitInfo == null)
            MenuModule.cGameInitInfo = new GameInitInfoSingle();
        
        MenuModule.cGameInitInfo.cLevels.Init(sLevelScriptFile);
        MenuModule.cGameInitInfo.cLevels.Restart();
        String sBitmapToShow = MenuModule.cGameInitInfo.cLevels.GetNextLevelBackground();
        m_cBitmapsFile[iButtonID] = new String(sBitmapToShow);
        
		m_cMenuButtons[iButtonID].SetDisabled(false);
        m_cMenuButtons[iButtonID].DisplayTextFitSizeWithMargin(sText, new Vector(2.0f, 1.0f, 0.0f));
        m_cMenuButtons[iButtonID].Show();
        
        m_iNumberOfActiveButtons++;
        
        //Aktywacja pierwszego dodanego buttonu
        if (m_iActiveButton == -1)
        {
            OnSetButton(iButtonID);
            m_cMenuButtons[iButtonID].SetCheck(true);
			m_cMenuButtons[iButtonID].SetFocus(true);
        }
    }
    
    //dostosowanie rozmiaru okna do ilosci aktywowanych buttonow
    void FitMenuSize()
    {
        Vector vMenuSize = m_cUIButtonsMenu.GetSize();
        Vector vButtonSize = m_cMenuButtons[0].GetSize();
        
        m_cUIButtonsMenu.SetSize(new Vector(vMenuSize.fX, (2+m_iNumberOfActiveButtons)*vButtonSize.fY, vMenuSize.fZ));
        m_cUIButtonsMenu.OnSizeAndPos();
        m_cUIButtonsMenu.OnSizeAndPos();
    }
    
    void ShowBitmap( String sTex )
    {
        LogR("ShowBitmap " + sTex + "\n");
        if (sTex != null)
        {
            GetElem("ID_SCREENSHOT").Show();
            UITexture cTexture = new UITexture(sTex, 512, 256, 0,0,512,256);
            GetElem("ID_SCREENSHOT").SetNormalTexture(cTexture);
            
        }
        else
        {
            GetElem("ID_SCREENSHOT").Hide();
        }
    }
    
    void OnSetButton(int nID)
    {
        for(int i = 0; i < _MAX_NR_OF_BUTTONS; i++)
        {
            if( nID != i)
                m_cMenuButtons[i].SetCheck(false);
            else
                m_cMenuButtons[i].SetCheck(true);
        }
                
                
        m_iActiveButton = nID;
        
        ShowBitmap( m_cBitmapsFile[nID] );
    }
    
    void LoadLevel()
	{
		GameInitInfoSingle game=new GameInitInfoSingle( m_cLevelSriptFile[m_iActiveButton] );
		
		MenuModule.NewGame(game);
        MenuModule.StartGame();
		
        LogR("LoadLevel " + m_cLevelSriptFile[m_iActiveButton] + "\n");
    }
     
    void Discard()
    {
		if(!CanDiscard())
			return;
		MenuModule.SetMenu(MenuModule.sMenuBackName);
    }
    
    void OnUICommand(UIWindow cSender, int nCommand)
	{
		super.OnUICommand(cSender,nCommand);
        
        if(nCommand == EUIConst.CM_CLICK || nCommand == EUIConst.CM_DBCLICK)
        {
            if(cSender.m_sId.equals("ID_BACK"))
			{
			    Discard();
                return;
			}else
			if(cSender.m_sId.equals("ID_OK"))
			{
                //LoadLevel();
				java.util.Vector vParams = new java.util.Vector();
				vParams.addElement(new String(m_cLevelSriptFile[m_iActiveButton]));
				vParams.addElement(new String(sm_sCustomMap));
				MenuModule.SetMenu("ChromeNewGameMenu", vParams);
				return;
			}else
			if(cSender.m_sId.equals("ID_NEXT"))
			{
				ShowLevelsFrom((m_iFirstLevelID + _MAX_NR_OF_BUTTONS));
                return;
			}else
			if(cSender.m_sId.equals("ID_PREVIOUS"))
			{
                ShowLevelsFrom((m_iFirstLevelID - _MAX_NR_OF_BUTTONS));
                return;
			}
				
        
		    int nID = GetButtonId(cSender.m_sId);
            if( nID > 0 && nID <= _MAX_NR_OF_BUTTONS) 
			{
				OnSetButton( nID-1 ); //indeksowane od zera
			}
        }
    }
	

 }

