public class ChromeAudioMenu extends ChromeMenuWindow 
{
    UIComboBox ComboBox_API = null; 
    UISlider Button_VolumeFX =null;
    UISlider Button_VolumeM =null;
    UIComboBox ComboBox_Quality = null;
    UIButton Button_Eax = null;
	
    int aiAPI[] = { ESoundAPI.NO_SOUND, ESoundAPI.DSOUND3D, ESoundAPI.AUREAL3D };
    
	void Init(MenuBackground cBack)
    {
        MenuModule=(ChromeMenuModule)GetModule();
        
		ComboBox_API = (UIComboBox)GetElem("ID_COMBOBOX_SOUND_MODE");
		ComboBox_API.AddItem("&NOSOUND&",null);
        ComboBox_API.AddItem("&DSOUND3D&",null);
        //ComboBox_API.AddItem("&AUREAL3D&",null);
        
		Button_VolumeFX =(UISlider)GetElem("ID_SLIDER_SFX");
        Button_VolumeFX.SetRange(0, 10);
		
		Button_VolumeM =(UISlider)GetElem("ID_SLIDER_MUSIC");
        Button_VolumeM.SetRange(0, 10);
		
		ComboBox_Quality = (UIComboBox)GetElem("ID_COMBOBOX_SOUND_Q");
		ComboBox_Quality.AddItem("&low&",null);
        ComboBox_Quality.AddItem("&medium&",null);
        ComboBox_Quality.AddItem("&high&",null);
        
		Button_Eax = (UIButton)GetElem("ID_EAX_CHECK");
    /*
		if (MenuModule.bInGameMenuAct)
		{
            UIStatic cStatic = (UIStatic)GetElem("ID_EAX_CHECK_TEXT");
			cStatic.SetAlphaForAll(0.6f);
			cStatic.SetTextAlpha(0.6f);
			Button_Eax.SetActive(false);
			Button_Eax.SetAlpha(0.6f);
		}
    */        
        SetButton();
    }
    
    void OnUICommand(UIWindow cSender, int nCommand)
	{
		super.OnUICommand(cSender,nCommand);
		
		if (nCommand == EUIConst.CM_SLIDER_CHANGEPOS)
		{
            UpdateVolumes();
			return;
		}
		     
		if(nCommand == EUIConst.CM_CLICK || nCommand == EUIConst.CM_DBCLICK)
        {
            if(cSender.m_sId.equals("ID_OK"))
			{
				boolean bSoundReinited = SetSetings();
                SaveSetings();
                if (bSoundReinited && CanReturnToGame())
                    ReturnToGame();
                else
                    MenuModule.SetMenu("ChromeOptionsMenu");
			}else
			if(cSender.m_sId.equals("ID_CANCEL"))
			{
				Discard();
			}else
			if(cSender.m_sId.equals("ID_DEFAULT"))
			{
                OnDefaultButton();
			}
				
        }
    }
    
    void OnDefaultButton()
    {
        ComboBox_API.SetSelection(1);
		if (!MenuModule.bInGameMenuAct)
			Button_Eax.SetCheck( false );
        Button_VolumeFX.SetSliderPos( 10 );
        Button_VolumeM.SetSliderPos( 7);
        ComboBox_Quality.SetSelection(2);
        UpdateVolumes();
    }
    
    void SetButton()
    {
        ComboBox_API.SetSelection( API2APIMode(GetAudioAPI()) );
        Button_Eax.SetCheck( IsAudioUsingEAX() );
        Button_VolumeFX.SetSliderPos( GetAudioFXVolume() );
        Button_VolumeM.SetSliderPos( GetAudioCDVolume() );
        
        int iMixFreq = GetAudioMixFrequency();
        int iChannels = GetAudioChannels();
        
        if (iMixFreq >= 44100 && iChannels > 8)
            ComboBox_Quality.SetSelection(2);
        else
        if (iMixFreq == 22050)
            ComboBox_Quality.SetSelection(1);
        else
            ComboBox_Quality.SetSelection(0);
    }
    
    void SaveSetings()
    {
        SaveAudioSettings("");
    }
    
    boolean SetSetings()
    {
		ChangeQuality();
        SetAudioAPI( aiAPI[ComboBox_API.GetSelection()] );
        AudioUseEAX( Button_Eax.GetCheck() );

        boolean bAudioReinitialized = ApplyAudioSettings();
        UpdateVolumes();
        
        return bAudioReinitialized;
    }
    
    void ReturnToGame()
    {
        MenuModule.SetState("DuringGame");
        UnregisterKeyRequest();
        MenuModule.ActiveLevelModule.CallMethodIn("ReturnFromMenu", 0.01f);
    }
    
    boolean CanReturnToGame()
    {
        return (MenuModule.bMenuNetInGame || 
                (MenuModule.bInGameMenuAct && 
                 !(((ChromeModuleSingle)MenuModule.ActiveLevelModule).m_bMissionEnded)));
    }
    
	void UpdateVolumes()
    {
		ChangeVolume_FX();
		ChangeVolume_Music();
        MenuModule.UpdateMenuMusicVolume();
	}
	
    void ChangeVolume_FX()
    {
        SetAudioFXVolume( (int)Button_VolumeFX.GetSliderPos() );
        //teraz SetAudioFXVolume ustawia tylko glosnosc dzwiekow odpalanych przez playsound
        //zeby streaming audio tez sie zmienilo trzeba zawolac:
        SetAudioWaveVolume( (int)Button_VolumeFX.GetSliderPos() );
    }
    
    void ChangeVolume_Music()
    {
        SetAudioCDVolume( (int)Button_VolumeM.GetSliderPos() );
    }
    
    void Discard()
    {
		if(!CanDiscard())
			return;
		
		if (ComboBox_API.m_bExpanded)
		{
			ComboBox_API.Collapse();
			return;
		}
		if (ComboBox_Quality.m_bExpanded)
		{
			ComboBox_Quality.Collapse();
			return;
		}
        MenuModule.SetMenu("ChromeOptionsMenu");
        //Log("[ChromeMenuWindow.Discard] called\n");
    }
    
    int API2APIMode(int iAPI)
    {
        for (int i = 0; i < aiAPI.length; ++i)
        {
            if (aiAPI[i] == iAPI)
                return i;
        }
        
        return 0;
    }
 
    void ChangeQuality()
    {
        switch (ComboBox_Quality.GetSelection())
        {
            // jesli zmieniasz parametry dla quality to zmien tez
            // wykrywanie jakosci w SetButton!!!
        case 0:
			SetAudioMixFrequency(11025);
            SetAudioChannels(8);
            break;
            
        case 1:
            SetAudioMixFrequency(22050);
            SetAudioChannels(8);
            break;
            
        case 2:
            SetAudioMixFrequency(44100);
            SetAudioChannels(16);
            break;
        }
    }
}
