
public class ChromeMenuBackground extends UserInterface
{
    UIWindow    m_cBlackness = null,
                m_cChrome = null,
                m_cRingOut = null,
                m_cRingIn = null,
                m_cBackFade = null,
                m_cRingSmall = null;
	
	UIStatic m_cGameVersion = null;
    
	public void OnCreate()
	{
		super.OnCreate();
		Load(GetModule(), "Data/Menu/ChromeMenuBackground.scr", true);
		HideFrame();
	}
	
    public void OnInit()
    {
        super.OnInit();
        m_cBlackness    = GetElem("ID_BLACKNESS");
        m_cChrome       = GetElem("ID_CHROME");
        m_cRingOut      = GetElem("ID_RING_OUT");
        m_cRingIn       = GetElem("ID_RING_IN"); 
        m_cRingSmall    = GetElem("ID_RING_SMALL");
        m_cBackFade     = GetElem("ID_BACKGROUND_LEFT");
		m_cGameVersion  = ((UIStatic)GetElem("ID_GAME_VERSION"));
		if(ChromeModuleSingle._bPrologDemo)
            m_cGameVersion.SetText(NetGameVersion.GetShortName()+" demo");
        else
        {
            if(ChromeModule._bMultiplayerDemo)
                m_cGameVersion.SetText(NetGameVersion.GetShortName()+" DEMO");
            else
                m_cGameVersion.SetText(NetGameVersion.GetShortName());
        }
    }
    
    public void FullView(boolean bFull)
    {
        float fAlpha = bFull? 1:0.2f;
        /*m_cChrome.SetVisible(bFull);
        m_cRingOut.SetVisible(bFull);
        m_cRingIn.SetVisible(bFull);*/
        m_cChrome.SetAlpha(fAlpha);
        m_cRingOut.SetAlpha(fAlpha);
        m_cRingIn.SetAlpha(fAlpha);
        m_cRingSmall.SetAlpha(fAlpha);
        
        if(bFull)
            m_cBackFade.Hide();
        else
            m_cBackFade.Show();
    }
    
	public void ShowFrame()
	{
		GetElem("ID_FRAME").Show();
	}
	
	public void ShowGameVersion()
	{
		m_cGameVersion.Show();
	}
	
	public void HideFrame()
	{
		GetElem("ID_FRAME").Hide();
	}
    
    public void HideCaption()
    {
        ((UIStatic)GetElem("ID_CAPTION")).Hide();
    }
	
	public void SetCaption(String sCaption)
	{
		((UIStatic)GetElem("ID_CAPTION")).SetText(sCaption);
	}
    
    public void Show()
    {
        super.Show();
        if (m_cBlackness != null)
        {
            if (((ChromeMenuModule)GetModule()).m_c3DSceneModule != null)
                m_cBlackness.SetVisible(false);
            else
                m_cBlackness.SetVisible(true);
        }
		if(m_cGameVersion != null)
			m_cGameVersion.Hide();
    }

}
