public class EChromeAudioMenuUI extends EUI
{
    final static float P256 = 1.0f/256.0f;
    final static float P1024 = 1.0f/1024.0f;
    
    final static int ID_LABEL_API     = 200; 
    final static int ID_LABEL_VF      = 201;
    final static int ID_LABEL_VM      = 202;
    final static int ID_LABEL_QUALITY = 203;
    final static int ID_LABEL_EAX     = 204;
    
    final static int ID_BUTTON_API     = 210; 
    final static int ID_BUTTON_VF      = 211;
    final static int ID_BUTTON_VM      = 212;
    final static int ID_BUTTON_QUALITY = 213;
    final static int ID_BUTTON_EAX     = 214;
    
    final static int ID_BTN_DEFAULT       = 402;
    final static int ID_BTN_OK            = 403;
    final static int ID_BTN_BACK          = 404;
    
    static boolean bNoDefSound = false;
    
    //---------------------------------------------------------
    static UIElement Label_API = new UIElement(
        ID_LABEL_API,0,
        new Vector(128,100,0),
        new Vector(256,32,0),
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&API&"
        );
    
    static UIElement Label_VolumeFX = new UIElement(
        ID_LABEL_VF,0,
        new Vector(128,134,0),
        new Vector(256,32,0),
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&VOLUME FX&"
        );
    
    static UIElement Label_VolumeM = new UIElement(
        ID_LABEL_VM,0,
        new Vector(128,168,0),
        new Vector(256,32,0),
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&VOLUME M&"
        );
    
    static UIElement Label_Quality = new UIElement(
        ID_LABEL_QUALITY,0,
        new Vector(128,202,0),
        new Vector(256,32,0),
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&SOUND QUALITY&"
        );
    
    static UIElement Label_Eax = new UIElement(
        ID_LABEL_EAX,0,
        new Vector(128,235,0),
        new Vector(256,32,0),
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&EAX EXTENSION&"
        );
    
    static UIElement Button_Default = new UIElement(
        ID_BTN_DEFAULT,0,
        new Vector(186+14,430,0),
        new Vector(128,32,0),
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&DEFAULT&"
        );
    
    static UIElement Button_Ok = new UIElement(
        ID_BTN_OK,0,
        new Vector(324+14,430,0),
        new Vector(128,32,0),
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&OK&"
        );
    
    static UIElement Button_Back = new UIElement(
        ID_BTN_BACK,0,
        new Vector(48+14,430,0),
        new Vector(128,32,0),
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala,  
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&CANCEL&"
        );
    
    static UIElement ComboBox_API = new UIElement(
        ID_BUTTON_API,0,
        new Vector(384,100,0),
        new Vector(128,32,0),
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala,  
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        ""
        );
    
    static UIElement Button_VolumeFX = new UIElement(
        ID_BUTTON_VF,0,
        new Vector(384,134,0),
        new Vector(64,32,0),
        MenuTextures.sRamka64, 
        MenuTextures.sRamka64, 
        MenuTextures.sRamka64, 
        MenuTextures.sRamka64,  
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        ""
        );
    
    static UIElement Button_VolumeM = new UIElement(
        ID_BUTTON_VM,0,
        new Vector(384,168,0),
        new Vector(64,32,0),
        MenuTextures.sRamka64, 
        MenuTextures.sRamka64, 
        MenuTextures.sRamka64, 
        MenuTextures.sRamka64,  
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        ""
        );
    
    static UIElement ComboBox_Quality = new UIElement(
        ID_BUTTON_QUALITY,0,
        new Vector(384,202,0),
        new Vector(128,32,0),
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala,
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        ""
        );
    
    static UIElement Button_Eax = new UIElement(
        ID_BUTTON_EAX,0,
        new Vector(384,236,0),
        new Vector(32,32,0),
        MenuTextures.sCheckbox, 
        MenuTextures.sCheckbox2, 
        "", 
        "", 
        EButtonFlags.BTN_TYPE_CHECKBUTTON,
        ""
        );
}
