public class EChromeConrolsUI extends EUI 
{
    final static float P256 = 1.0f/256.0f;
    final static float P1024 = 1.0f/1024.0f;
    
    final static int ID_LISTBOX_BCONTROLS = 401; 
    final static int ID_LISTBOX_ECONTROLS = 400; 
    
    final static int ID_BTN_DEFAULT       = 402;
    final static int ID_BTN_OK            = 403;
    final static int ID_BTN_BACK          = 404;
    
    final static int ID_BTN_KEY           = 450;
    final static int ID_BTN_MOUSE         = 451;
    
    /**Zakladka myszki i joystica*/
    
    final static int ID_BTN_MOUSE_SEN     = 460;
    final static int ID_BTN_JOYX_SEN      = 461;
    final static int ID_BTN_JOYY_SEN      = 462;
    final static int ID_BTN_INVERT        = 463;
    
    final static int ID_LABEL_MOUSE_SEN     = 464;
    final static int ID_LABEL_JOYX_SEN      = 465;
    final static int ID_LABEL_JOYY_SEN      = 466;
    final static int ID_LABEL_INVERT        = 467;
    
//-------------------------------------------------------------------------
    static UIElement ListBox_EControls = new UIElement(
        ID_LISTBOX_ECONTROLS,0,
        new Vector(48+14,90,0),
        new Vector(544,320,0),
        "", 
        "", 
        "", 
        "", 
        EButtonFlags.BTN_TYPE_LISTBOX,
        ""
        );
    
    static UIElement Button_Default = new UIElement(
        ID_BTN_DEFAULT,0,
        new Vector(186+14,430,0),
        new Vector(128,32,0),
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&DEFAULT&"
        );
    
    static UIElement Button_Ok = new UIElement(
        ID_BTN_OK,0,
        new Vector(324+14,430,0),
        new Vector(128,32,0),
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&OK&"
        );
    
    static UIElement Button_Back = new UIElement(
        ID_BTN_BACK,0,
        new Vector(48+14,430,0),
        new Vector(128,32,0),
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala,  
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&CANCEL&"
        );
    
    static UIElement Button_Key = new UIElement(
        ID_BTN_KEY,0,
        new Vector(48+12,10,0),
        new Vector(256,32,0),
        MenuTextures.sRamka, 
        MenuTextures.sRamka2, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka2, 
        EButtonFlags.BTN_TYPE_LISTBOX_ITEM,
        "&KEYS&"
        );
    
    static UIElement Button_Mouse = new UIElement(
        ID_BTN_MOUSE,0,
        new Vector(48+256+14,10,0),
        new Vector(256,32,0),
        MenuTextures.sRamka, 
        MenuTextures.sRamka2, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka2, 
        EButtonFlags.BTN_TYPE_LISTBOX_ITEM,
        "&MOUSE&"
        );
    
    static UIElement Label_Action = new UIElement(
        0,0,
        new Vector(48+14,58,0),
        new Vector(256,32,0),
        MenuTextures.sRamkaNaglowek, 
        MenuTextures.sRamkaNaglowek, 
        MenuTextures.sRamkaNaglowek, 
        MenuTextures.sRamkaNaglowek,  
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&ACTION&"
        );
    
    static UIElement Label_Key = new UIElement(
        0,0,
        new Vector(48+14+256,58,0),
        new Vector(256,32,0),
        MenuTextures.sRamkaNaglowek, 
        MenuTextures.sRamkaNaglowek, 
        MenuTextures.sRamkaNaglowek, 
        MenuTextures.sRamkaNaglowek, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&KEY&"
        );
    
    static UIElement Label_MouseS = new UIElement(
        ID_LABEL_MOUSE_SEN,0,
        new Vector(0,30,0),
        new Vector(256,32,0),
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&MOUSE SENSITIVITY&"
        );
    
    static UIElement Label_Invert = new UIElement(
        ID_LABEL_INVERT,0,
        new Vector(0,70,0),
        new Vector(256,32,0),
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&INVERT MOUSE&"
        );
    
    static UIElement Label_JoyXS = new UIElement(
        ID_LABEL_JOYX_SEN,0,
        new Vector(0,110,0),
        new Vector(256,32,0),
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&JOYSTIC SENSITIVITY X&"
        );
    
    static UIElement Label_JoyYS = new UIElement(
        ID_LABEL_JOYX_SEN,0,
        new Vector(0,150,0),
        new Vector(256,32,0),
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&JOYSTIC SENSITIVITY Y&"
        );
    
    static UIElement ButtonLR_Mouse_S = new UIElement(
        ID_BTN_MOUSE_SEN,0,
        new Vector(256,30,0),
        new Vector(64,32,0),
        MenuTextures.sRamka64, 
        MenuTextures.sRamka264, 
        MenuTextures.sRamka64, 
        MenuTextures.sRamka264, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        ""
        );
    
    static UIElement Button_Invert = new UIElement(
        ID_BTN_INVERT,0,
        new Vector(256,70,0),
        new Vector(32,32,0),
        MenuTextures.sCheckbox, 
        MenuTextures.sCheckbox2, 
        "", 
        "", 
        EButtonFlags.BTN_TYPE_CHECKBUTTON,
        ""
        );
    
    static UIElement ButtonLR_JoyX_S = new UIElement(
        ID_BTN_JOYX_SEN,0,
        new Vector(256,110,0),
        new Vector(64,32,0),
        MenuTextures.sRamka64, 
        MenuTextures.sRamka264, 
        MenuTextures.sRamka64, 
        MenuTextures.sRamka264, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        ""
        );
    
    static UIElement ButtonLR_JoyY_S = new UIElement(
        ID_BTN_JOYY_SEN,0,
        new Vector(256,150,0),
        new Vector(64,32,0),
        MenuTextures.sRamka64, 
        MenuTextures.sRamka264, 
        MenuTextures.sRamka64, 
        MenuTextures.sRamka264, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        ""
        );
}
