public class UIEditWithControls extends UIEdit
{
    private static int m_iForbidenKeysIndex[] = new int[]
                        {
                            1,//esc
                        };
   
    public void OnInit()
    {
        super.OnInit();
		RegisterMouseButtonRequest();
        RegisterMouseAxisRequest();
        m_bMouseBtnOutAsEnter = false;
	}
	
    boolean IsKeyForbiden(int iKey)
    {
        for (int i = 0; i < m_iForbidenKeysIndex.length; i++)
        {
            if (m_iForbidenKeysIndex[i] == iKey)
                return true;
        }
        return false;
    }
    
    void SetCheck(boolean bCheck)
	{
     	if(!m_bActive)
			return;	
        
        String sOldText = m_sEditText;
        
        if(bCheck && !m_bChecked)
            SetText("");
        
        super.SetCheck(bCheck);
        m_sOldText = sOldText;
    }
        
    public void OnInputMouseButton(int nButton, int nState)
	{
        if(!m_bActive || !m_bChecked)
			return;	
		
		if( ( (UIWindow) this).IsCursorInUIWindow())
        {
            int nKey = 0;
            
            switch(nButton)
            {
            case EMouse._BUTTON_1:
                {
                    LogLine("Wcisnieto przycisk myszki Button1");
                    nKey = EKey._MOUSE_BUTTON1;
                    break;
                }
            case EMouse._BUTTON_2:
                {
                    LogLine("Wcisnieto przycisk myszki Button2");
                    nKey = EKey._MOUSE_BUTTON2;
                    break;
                }
            case EMouse._BUTTON_3:
                {
                    LogLine("Wcisnieto przycisk myszki Button3");
                    nKey = EKey._MOUSE_BUTTON3;
                    break;
                }
            }
            
            ProcessKey(nKey);
            
            //jesli jest rowny to i tak zostanie zawolane on enter
            if (nButton != EMouse._BUTTON_1)
                OnKeyEnter();
            else
                if (nState == 0)
                    CallOnFrameEnd("OnKeyEnter");//, 0);   
        }
        else
        {
            OnKeyEscape();
        }
    }
   
   
    void OnKeyEnter()
	{
	    super.OnKeyEnter();
	}
    
    void OnInputMouseAxis(int nAxis, int nDelta)
    {
        if(!m_bActive || !m_bChecked)
			return;
        
        int nKey = -1;
        if (nAxis == EMouse._AXIS_Z)
        {
            if (nDelta > 0)   
                nKey = EKey._MOUSE_WHEEL_DN;
            else
                if (nDelta < 0)
                    nKey = EKey._MOUSE_WHEEL_UP;
        }
        
        if (nKey != -1)
        {
            ProcessKey(nKey);
            OnKeyEnter();
        }
    }

    
    void ProcessKey(int nKey)
    {
        if(IsKeyForbiden(nKey))
            return;
        
        int select = ((UIListBox)m_wndParent.m_wndParent.m_wndParent).GetSelection();
        if ( select == -1 ) return;
        
        //sprawdzamy czy gdzies juz nie wystepuje ten przycisk
        for (int index = 0 ; index < ControlLoadSave.KeyId.length ; index++ )
        {
            if ( ControlLoadSave.KeyId[index] == nKey && select != index)
            {
                ControlLoadSave.KeyId[index] = 0;
                MenuButtonDouble btn = (MenuButtonDouble)((UIListBox)m_wndParent.m_wndParent.m_wndParent).vItems.elementAt(index);
                btn.SetEditText(ControlLoadSave.KeyId[index]);
            }
        }
        
        ControlLoadSave.KeyId[select] = nKey;
        
        DisplayText(nKey);
        
    }
    
	void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
        super.OnInputKey(nKeyCode, bKeyState, nKeyAscii);
		
		if(!m_bActive || !m_bChecked)
			return;	
		
		if (!bKeyState)
        {
			if (!IsKeyForbiden(nKeyCode))
                OnKeyEnter();
            else
                OnKeyEscape();
        }
	}
    
	void OnKeyPressed(int nKey, char nAsci)
	{
        if(!m_bActive || !m_bChecked)
			return;			
		
		LogLine("nKey: " + nKey + " nAsci: "+ nAsci);
        //sText = Text.Get(KeyName[nKey]);
        //sText = sText.toLowerCase();
        
        if(!IsKeyForbiden(nKey))
            DisplayText(nKey);
	}
	
	void OnKeyReleased(int nKey, char nAsci)
	{
		if(!m_bActive || !m_bChecked)
			return;	
        
        if(IsKeyForbiden(nKey))
            return;
		
		int select = ((UIListBox)m_wndParent.m_wndParent.m_wndParent).GetSelection();
        if ( select == -1 ) return;
    
		//sprawdzamy czy gdzies juz nie wystepuje ten przycisk
        for (int index = 0 ; index < ControlLoadSave.KeyId.length ; index++ )
        {
            if ( ControlLoadSave.KeyId[index] == nKey && select != index)
            {
                ControlLoadSave.KeyId[index] = 0;
				MenuButtonDouble btn = (MenuButtonDouble)((UIListBox)m_wndParent.m_wndParent.m_wndParent).vItems.elementAt(index);
				btn.SetEditText(ControlLoadSave.KeyId[index]);
            }
        }
		
    	 ControlLoadSave.KeyId[select] = nKey;
		 
		 super.OnKeyReleased(nKey,nAsci);
   }
	
    void DisplayText(int nKey)
    {
        //SetText(" " + Text.Get(ControlLoadSave.KeyName[nKey]));
        SetText(" " + Text.Get(ControlLoadSave.GetKeyName(nKey)));
    }
    
    public void OnDestroy()
    {
        super.OnDestroy();
    }
}

