public class CreditsEntryWindow extends UIControlObject
{
    java.util.Vector m_vNameWindows = new java.util.Vector();
    java.util.Vector m_vNames = new java.util.Vector();
    
    Vector vMargin = new Vector (0, 10, 0);
    
    float m_fBlendTime = 1;
    
    float m_fLineSpacing = 5;
    
    float m_fDestAlpha = 0;
    
    static int nId = 0;
    public void OnCreate()
    {
        ActivateOnModule();
        super.OnCreate();
        nId ++;
        LogR("CreditsEntryWindow.OnCreate " + nId);
    }
    
    public void OnDestroy()
    {
        super.OnDestroy();
        nId --;
        LogR("CreditsEntryWindow.OnDestroy " + nId);
        
    }
    
    public void SetText(String sText)
    {
        super.SetText(sText);
        Vector vTextSize = GetTextExtent(sText);
        SetRealSize(new Vector(GetSize().fX, vTextSize.fY, 0));
    }
    
    public void Show()
    {
        m_fDestAlpha = 1f;
        SetTextAlphaForAll(0);
        super.Show();
    }
    
    public void Hide()
    {
        m_fDestAlpha = 0;
    }
    
    float fLastFrameTime = 0;
    
    public void OnFrame()
    {
        if (fLastFrameTime == 0)
            fLastFrameTime = GetTime();
        
        float fTimeDelta = GetTime() - fLastFrameTime;
        super.OnFrame();
        
        if (m_fDestAlpha > ((UIStatic)this).m_fCurTextAlpha)
        {
            m_fCurTextAlpha += fTimeDelta * (1f/m_fBlendTime);
            if (m_fDestAlpha < m_fCurTextAlpha)
                m_fCurTextAlpha = m_fDestAlpha;
        }
        else
            if (m_fDestAlpha < m_fCurTextAlpha)
            {
                m_fCurTextAlpha -= fTimeDelta * m_fBlendTime;
                if (m_fDestAlpha > m_fCurTextAlpha)
                    m_fCurTextAlpha = m_fDestAlpha;
            }   
        
        SetTextAlphaForAll(m_fCurTextAlpha);
        
        if (m_fCurTextAlpha == 0 && m_fDestAlpha == 0)
            Hide();
        
        fLastFrameTime = GetTime();
    }
    
    void AddName(Credits.CreditName cName)
    {
        UIStatic cWnd = null;
        m_vNames.addElement(cName);
        if (m_vNames.size() < m_vNameWindows.size())
        {
            cWnd = (UIStatic)m_vNameWindows.elementAt(m_vNames.size() - 1);
        }
        else
        {
            UIStatic cPattern = (UIStatic)GetPattern(EUIConst.sSTATIC);
        
            cWnd = (UIStatic)CreateObject("UIStatic");    
            cWnd.m_sId = "_NAME_" + String.valueOf(m_vNames.size() - 1);
            if(cPattern!=null)
                cWnd.Copy(cWnd, cPattern);            
            cWnd.OnSizeAndPos();
            AddElement(cWnd);
            m_vNameWindows.addElement(cWnd);
        }
        cWnd.SetVisible(true);
        cWnd.SetText(cName.m_sName);
        cWnd.SetFont(cName.m_sFontName);
        cWnd.SetFontScale(cName.m_fFontScale);
        cWnd.SetTextPosFlags(cName.m_nFontFlags);
        
        float fPosY = GetPos().fY + GetSize().fY + cName.m_fLineSpacing;
        for (int i = 0; i < m_vNames.size() - 1; i++)
        {
            fPosY += ((UIWindow)m_vNameWindows.elementAt(i)).GetSize().fY + ((Credits.CreditName)m_vNames.elementAt(i)).m_fLineSpacing;
        }
            
        cWnd.UpdateLogicSizeAndPos(GetSize(),
                                   new Vector(GetPos().fX,  fPosY, 0));
        cWnd.OnSizeAndPos();
        
        cWnd.DisplayText();
    }
    
    void Clear()
    {
        m_vNames.removeAllElements();
        for (int i = 0; i < m_vNameWindows.size(); i++)
        {
            ((UIWindow)m_vNameWindows.elementAt(i)).Hide();
        }
    }
}
