public class MenuYesNoDialog extends ChromeMenuWindow
{
    int m_nID = -1;
    
    String  m_sTitle = null,
            m_sQuestion = null,
            m_sBtnLeftText = null,
            m_sBtnRightText = null,
            m_sBtnCenterText = null;
    
    ChromeMenuWindow m_cWndOwner = null;
    
    UIButton m_cBtnLeft = null,
             m_cBtnRight = null,
             m_cBtnCenter = null;
    
    UIStatic m_cQuestion = null,
             m_cTitle = null;
    
    GameObject m_cCallbackObj = null;
    String  m_sCallbackMethod1 = null,
            m_sCallbackMethod2 = null;
    
    final static String _ID_YES     = "ID_YES",
                        _ID_NO      = "ID_NO",
                        _ID_OK      = "ID_OK",
                        _ID_CANCEL  = "ID_CANCEL";
    
    public void OnInit()
    {
        super.OnInit();
        m_cBtnLeft = (UIButton)GetElem("ID_LEFT");
        m_cBtnRight = (UIButton)GetElem("ID_RIGHT");
        m_cBtnCenter = (UIButton)GetElem("ID_CENTER");
        
        m_cTitle = (UIStatic)GetElem("ID_FRAME");
        m_cQuestion = (UIStatic)GetElem("ID_QUESTION");
        Hide();
        //UIStatic m_cBackground = (UIStatic)GetElem("ID_TITLE");
        //m_cBackground.SetAlpha(0.4f);
    }
    
    void SetOwner(ChromeMenuWindow cNewOwner)
    {
        m_cWndOwner = cNewOwner;
    }
    
    ChromeMenuWindow GetOwner()
    {
        return m_cWndOwner;
    }
    
    void Init(int nID, String sTitle, String sQuestion)
    {
        m_nID = nID;
        m_sTitle = sTitle;
        m_sQuestion = sQuestion;
        ApplyTexts();
    }
    
    
    void InitYesNo(int nID, String sTitle, String sQuestion, String sYesBtn, String sNoBtn)
    {
        m_cBtnLeft.m_sId = new String(_ID_YES);
        m_cBtnRight.m_sId = new String(_ID_NO);
        m_cBtnLeft.m_bCanFocus = true;
        m_cBtnLeft.Show();
        m_cBtnRight.m_bCanFocus = true;
        m_cBtnRight.Show();
        
        m_cBtnCenter.Hide();
        m_cBtnCenter.m_bCanFocus = false;
        
        if (sYesBtn != null)
            m_sBtnLeftText = sYesBtn;
        else
            m_sBtnLeftText = Text.Get("&BtnYes&");
        
        if (sNoBtn != null)
            m_sBtnRightText = sNoBtn;
        else
            m_sBtnRightText = Text.Get("&BtnNo&");
        
        Init(nID, sTitle, sQuestion);
        
    }
    
    void InitOkCancel(int nID, String sTitle, String sQuestion, String sOkBtn, String sCancelBtn)
    {
        m_cBtnLeft.m_sId = new String(_ID_OK);
        m_cBtnRight.m_sId = new String(_ID_CANCEL);
        m_cBtnLeft.m_bCanFocus = true;
        m_cBtnLeft.Show();
        m_cBtnRight.m_bCanFocus = true;
        m_cBtnRight.Show();
        
        m_cBtnCenter.Hide();
        m_cBtnCenter.m_bCanFocus = false;
        
        if (sOkBtn != null)
            m_sBtnLeftText = sOkBtn;
        else
            m_sBtnLeftText = Text.Get("&OK&");
        
        if (sCancelBtn != null)
            m_sBtnRightText = sCancelBtn;
        else
            m_sBtnRightText = Text.Get("&CANCEL&");
        
        Init(nID, sTitle, sQuestion);
    }
    
    void InitOk(int nID, String sTitle, String sQuestion, String sOkBtn)
    {
        m_cBtnCenter.m_sId = new String(_ID_OK);
        m_cBtnLeft.Hide();
        m_cBtnLeft.m_bCanFocus = false;
        m_cBtnRight.Hide();
        m_cBtnRight.m_bCanFocus = false;
        
        m_cBtnCenter.m_bCanFocus = true;
        m_cBtnCenter.Show();
        
        if (sOkBtn != null)
            m_sBtnCenterText  = sOkBtn;
        else
            m_sBtnCenterText = Text.Get("&OK&");
        
        Init(nID, sTitle, sQuestion);
    }
    
    void InitCancel(int nID, String sTitle, String sQuestion, String sCancelBtn)
    {
        m_cBtnCenter.m_sId = new String(_ID_CANCEL);
        m_cBtnLeft.Hide();
        m_cBtnLeft.m_bCanFocus = false;
        m_cBtnRight.Hide();
        m_cBtnRight.m_bCanFocus = false;

        m_cBtnCenter.m_bCanFocus = true;
        m_cBtnCenter.Show();
        
        
        if (sCancelBtn != null)
            m_sBtnCenterText = sCancelBtn;
        else
            m_sBtnCenterText = Text.Get("&CANCEL&");
        
        Init(nID, sTitle, sQuestion);
    }
    
    void SetCallback(GameObject cObject, String sMethod1, String sMethod2)
    {
        m_cCallbackObj = cObject;
        if (sMethod1 != null)
            m_sCallbackMethod1 = new String(sMethod1);
        else
            m_sCallbackMethod1 = null;
        
        if (sMethod2 != null)
            m_sCallbackMethod2 = new String(sMethod2);
        else
            m_sCallbackMethod2 = null;
    }
    
    void SetQuestionText(String sText)
    {
        m_cQuestion.SetText(sText);
    }
    
    void ApplyTexts()
    {
        m_cQuestion.SetText(m_sQuestion);

        if(m_sBtnLeftText != null)
        {
            m_cBtnLeft.SetText(m_sBtnLeftText);   
        }
        
        if(m_sBtnRightText != null)
        {
            m_cBtnRight.SetText(m_sBtnRightText);  
        }

        if (m_sBtnCenterText != null)
        {
            m_cBtnCenter.SetText(m_sBtnCenterText);  
        }
        
        m_cTitle.SetText(m_sTitle);
    }
    
    void OnUICommand(UIWindow cSender, int nCommand)
	{
		super.OnUICommand(cSender,nCommand);		
		if(nCommand == EUIConst.CM_CLICK)
        {
            if (cSender.m_sId.equals(_ID_YES))
            {
                if (m_cWndOwner != null)
                {
                    m_cWndOwner.OnYesFromDlg(m_nID);
                }
                else
                {
                    if (m_cCallbackObj != null)
                        m_cCallbackObj.CallOnFrameEnd(m_sCallbackMethod1);
                }
            } 
            
            if (cSender.m_sId.equals(_ID_NO))
            {
                if (m_cWndOwner != null)
                {
                    m_cWndOwner.OnNoFromDlg(m_nID);
                }
                else
                {
                    if (m_cCallbackObj != null)
                        m_cCallbackObj.CallOnFrameEnd(m_sCallbackMethod2);
                }
            }
            
            if (cSender.m_sId.equals(_ID_OK))
            {
                if (m_cWndOwner != null)
                {
                    m_cWndOwner.OnOKFromDlg(m_nID);
                }
                else
                {
                    if (m_cCallbackObj != null)
                        m_cCallbackObj.CallOnFrameEnd(m_sCallbackMethod1);
                }
            }

            if (cSender.m_sId.equals(_ID_CANCEL))
            {
                if (m_cWndOwner != null)
                {
                    m_cWndOwner.OnCancelFromDlg(m_nID);
                }
                else
                {
                    if (m_cCallbackObj != null)
                        m_cCallbackObj.CallOnFrameEnd(m_sCallbackMethod2);
                }
            }
        }
	}
    
    public void Show()
    {
		MoveTop();        
		super.Show();
        
        if(m_cBtnLeft != null)
        {
            if(m_cBtnLeft.IsActuallyVisible())
                m_cBtnLeft.SetFocus(true);
            else
                if(m_cBtnCenter.IsActuallyVisible())
                    m_cBtnCenter.SetFocus(true);
        }
        MenuModule.cCursor.Show();
        MenuModule.cCursor.MoveTop();
    }
	
	public void Hide()
	{
		super.Hide();
	}
}
