public class MeshAnimatedObject extends MeshObject
{
    private java.util.Vector m_aAnimsToPlay  = new java.util.Vector();
    
    int m_iLastRandomAnim = -1;
    
    int m_iStandardAnimID = 0;
    
    int m_iTotalFreqPoints = 0;

    float m_fMinTime = 4f;
    float m_fMaxTime = 8f;
    
    void ClearAnimsList()
    {
        m_aAnimsToPlay.clear();
        m_iTotalFreqPoints = 0;
    }
    
    void AddAnimToPlay(String sAnimName, int iAppearFrequency)
    {
        int iAnimIndex = GetAnimID( "",sAnimName);
        MeshAnimToPlay cMeshAnimToPlay = new MeshAnimToPlay(sAnimName, iAppearFrequency, iAnimIndex);
        m_aAnimsToPlay.addElement( cMeshAnimToPlay );
        m_iTotalFreqPoints += iAppearFrequency;
    }
    
    public void OnCreate()
    {
        super.OnCreate();
        ClearFlag( EFlags._NO_ANIMATION_REFRESH );
    }
    
    void StartPlayingAnims(String sStandardAnim)
    {
        m_iStandardAnimID =  GetAnimID( "",sStandardAnim);
        DrawAnim();
    }
    
    //Losuje metoda ruletki jedna z animacji i ja odgrywa
    void PlayRandomAnim()
    {
        if (m_aAnimsToPlay.size() > 0)
		{
    		int iFreqPointsToActivate = RandomInt(m_iTotalFreqPoints);
            
            MeshAnimToPlay cMeshAnimToPlay = null;
            for (int i = 0; i < m_aAnimsToPlay.size(); i++)
            {
                 cMeshAnimToPlay = (MeshAnimToPlay)m_aAnimsToPlay.elementAt(i);	
                 iFreqPointsToActivate -= cMeshAnimToPlay.m_iAnimApperFrequency;
                 if (iFreqPointsToActivate <= 0)
                     break;
            }
		    m_iLastRandomAnim = PlayAnim(cMeshAnimToPlay.m_iAnimID, 1);
		}	
    }
    
    void OnAnimEnd(int nID)
    {
        if (nID == m_iLastRandomAnim)
        {
            m_iLastRandomAnim = -1;
            DrawAnim();
        }
    }
    
    void DrawAnim()
    {
		DisableCallMethod("PlayRandomAnim");
        CallMethodIn("PlayRandomAnim", m_fMinTime + RandomInt((int)(m_fMaxTime - m_fMinTime)));
        //SetAnimMorphTime(m_fAnimMorphTime);
        PlayAnim(m_iStandardAnimID, -1);
    }

    class MeshAnimToPlay
    {
        MeshAnimToPlay(String cAnim, int iAnimApperFrequency, int iAnimID)
        {
            m_cAnim = cAnim;
            m_iAnimID = iAnimID;
            m_iAnimApperFrequency = iAnimApperFrequency;
        }
        
        //nazwa animacji
        String m_cAnim = null;
        
        //ID animacji
        int m_iAnimID = 0;
        
        //od 1 do 10
        int m_iAnimApperFrequency = 5;
    }
}
