public class ButtonLeftRight extends Button 
{
    final static int ID_BTN_LEFT   = 80;
    final static int ID_BTN_RIGHT  = 81;
    
    int iValue = 0;
    int iMaxValue = 100;
    int iMinValue = 0;
    
    Button Button_Left = null;
    Button Button_Right = null;
    Button Button_Value = null;
    
    void Init(UIElement data, Module module)
    {
        super.Init( new UIElement(),module);
        ProcessMouse(true);
        ProcessKb(true);
        Button_Value = (Button) this.CreateObject("Button");
        AddChild(Button_Value);
        AddChildWnd(Button_Value, wndRoot);
        Button_Value.Init(data,module);
        Button_Value.Enable(false);
        SetRelativePos(data.vPos);
        
        SetScrollButton();
        Vector vBV_Size  = new Vector(Button_Value.GetSize());
        Vector vBLR_Size = new Vector(Button_Left.GetSize());
        SetSize(new Vector(vBV_Size.fX + vBLR_Size.fX*2.0f, vBLR_Size.fY , 0.0f));
        Button_Left.SetRelativePos(new Vector(0.0f,0.0f,0.0f));
        Button_Value.SetRelativePos(new Vector(vBLR_Size.fX , 0.0f , 0.0f));
        Button_Right.SetRelativePos(new Vector(vBLR_Size.fX + vBV_Size.fX , 0.0f , 0.0f));
        Button_Value.Enable(false);
        ShowValue();
    }
    
    void SetScrollButton()
    {
        Button_Left = (Button) this.CreateObject("Button");
        AddChild(Button_Left);
        AddChildWnd(Button_Left, wndRoot);
        Button_Left.Init(new UIElement(ID_BTN_LEFT,0,
                                    new Vector(0,0,0),
                                    new Vector(32,32,0),
                                    MenuTextures.sGuzikLewo,
                                    MenuTextures.sGuzik2Lewo,
                                    MenuTextures.sGuzikLewo,
                                    MenuTextures.sGuzik2Lewo,
                                    EButtonFlags.BTN_TYPE_PRESSBUTTON,
                                    ""),
                      module);
                
        Button_Right = (Button) this.CreateObject("Button");
        AddChild(Button_Right);
        AddChildWnd(Button_Right, wndRoot);
        Button_Right.Init(new UIElement(ID_BTN_RIGHT,0,
                                    new Vector(0,0,0),
                                    new Vector(32,32,0),
                                    MenuTextures.sGuzikPrawo,
                                    MenuTextures.sGuzik2Prawo,
                                    MenuTextures.sGuzikPrawo,
                                    MenuTextures.sGuzik2Prawo,
                                    EButtonFlags.BTN_TYPE_PRESSBUTTON,
                                    ""),
                      module);    
    }
    
    void OnButton(Button btnSender)
    {
        switch(btnSender.nID)
        {
            case ID_BTN_LEFT:
            {
                OnLeft();
                CallOnButton(Button_Value);
                break;
            }
            case ID_BTN_RIGHT:
            {           
                OnRight();
                CallOnButton(Button_Value);
                break;
            }
            default:
            {
                if (wndParent != null )
                {
                    wndParent.CallOnButton(btnSender);
                    return;
                }
            }
        }
    }
    
    void OnLeft()
    {
        if ( iValue == iMinValue ) return;
        iValue--;
        ShowValue();
    }
    
    void OnRight()
    {
        if ( iValue == iMaxValue ) return;
        iValue++;
        ShowValue();
    }
    
    void ShowValue()
    {
        Button_Value.SetTextPosFlags(ESpriteText.VERT_MIDDLE | ESpriteText.HORIZ_MIDDLE);
        Button_Value.DisplayText(String.valueOf(iValue));
    }
    
    void SetValue( int i )
    {
        iValue = i;
        ShowValue();
    }
    
    int GetValue()
    {
        return iValue;
    }
}
