public class AIAlarmed extends AIAttacker implements IAlarmID
{
    public Alarm cAlarm = null;//#\AIALARMED;Alarm connected with this AI
    
	public int m_iAlarmID = AlarmsManager._DEFAULT_ALARM_ID;//#AI_ALARMED

    public void OnPostCreate()
    {
        if (cAlarm != null)
            cAlarm.AddAlarmObject(this);
    }
    
    public void SetAlarmID(int iAlarmID)
    {
        m_iAlarmID = iAlarmID;
    }
    
    public int GetAlarmID()
    {
        return m_iAlarmID;
    }
    
	public void Run()
	{
		if (aPath != null)
			aPath.nFlags |= AIPatrolerPath._PATROLPATH_ONCE;
		nReadinessToSearch = 0;
		SetPositionWorld(aPath.GetPoint(0).vPosition);
		DeactivateAlarmed();
	}
	
	void ActivateAlarmed()
	{
		if (bDead)
			return;
		Vector vDistDir = ((ChromeModuleSingle) GetModule()).MainPlayer.GetPosition();
		vDistDir.Sub(GetPosition());
		vDistDir.fY = 0;
		if ( vDistDir.Len() < 1000f )
			return;
		
		ActivateAI(true, AIBase._FREEZE_ADVENTURE);
		nReadinessToSearch = 100;
		SetState("Patrol");
	}

	void DeactivateAlarmed()
	{
		ActivateAI(false, AIBase._FREEZE_ADVENTURE);
	}
	
    public class Patrol extends AIAttacker.Patrol
    {
		public void OnReact()
		{
		}
		
/*		public void OnTakeDamage(float fDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nDamageType)
		{
			if (bDead)
				return;
			if (Assassin instanceof Player)
				SuperOnTakeDamage(fDamage, Assassin, vHitLocation, vSpeed, nDamageType);
		}
*/		
		// poprawione OnTakeDamage //////////////////////////////////////////////////////////////
		public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
		{
			if (bDead)
				return;
			if (Assassin instanceof Player)
				SuperOnTakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
		}		
		
		public void OnHearNoise(Actor Noisy, float fNoiseLevel, int nNoiseType)
		{
		}
    }
	
    void PatrolPointReached()
    {
		if (bDead)
			return;
	
		super.PatrolPointReached();
		
		if (nCurrentNode == aPath.GetPointsNum() - 1)
		{
            nAttackCause = _ATTACK_CAUSE_SIGHT;
            nTargetPointIdx = 0;
			bCriticalActionInProgress = false;
			Attack( ((ChromeModuleSingle) GetModule()).MainPlayer );
		}
    }
	
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
	boolean bIsRotatingSG = false;
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {
		FileChunk.Log("[AIAlarmed.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);
        
        if (cFC.GetID() == ESGChunksChrome._CHK_AI_ALARMED)
        {
			super.SGLoadChunk(cFC);

			m_iAlarmID = cFC.LoadInt();
        }
		cFC.delete();
	}
	
    /** Metoda zapisujaca dane do Save gracza
     */		
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[AIAlarmed.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_AI_ALARMED, cFCParent);
		
		super.SGSaveChunk(cFC);

		cFC.SaveInt(m_iAlarmID);			
		
		cFC.delete();
	}				
	
	public void SGUpdate()
	{
		FileChunk.Log("[AIAlarmed.SGUpdate]\n");
		
		super.SGUpdate();
	
	}	
}
