public class Alarm extends GameObject implements iact_EnableDisable
{
    int m_iAlarmID = AlarmsManager.GetNextAutoAlarmID();
    
    /** Akcje wykonywane po uruchomieniu alarmow */
    public Action[] aActions = null;//#\ALARM;Actions performed when alarm activated
	
    /** czas, po jakim alarm sie wylaczy */
    public float fDuration = 60f;//#\ALARM;Alarm duration in seconds
    
    /** Metoda wolana po przyjsciu zdarzenia act_Enable */
    public void Enable()
    {
        AlarmsManager.m_AlarmsManager.EnableAlarm(true, m_iAlarmID, fDuration);
		InvokeActionChain(aActions);
    }
    
    /** Metoda wolana po przyjsciu zdarzenia act_Disable */
    public void Disable()
    {
        AlarmsManager.m_AlarmsManager.EnableAlarm(false, m_iAlarmID, 0);
    }
    
    public boolean IsEnabled()
    {
        return AlarmsManager.m_AlarmsManager.IsAlarmEnabled(m_iAlarmID);
    }
    
    /** dodanie alarm objecta do tego alarmu (inicjacja)
     */
    public void AddAlarmObject(IAlarmID object)
    {
        object.SetAlarmID(m_iAlarmID);
    }
    
    
    public void OnDestroy()
    {
    }
}
