public class Music extends GameObject implements iact_StartStop
{
    static Music cPlayingMusic = null;
    
    /** glosnosc muzyki w grze */
    static float fMusicVolume = 1.f;
    
    /** Muzyka do odegrania */
    public FileName sMusic = null;//#MUSIC;
    
    // ilosc odtworzen muzyki, -1 w nieskonczonosc
    public int nLoops = 1;//#MUSIC;
    
    // 0 - czas brany z wave'a i loopow, -1 - gdy bLooped true loopowanie w nieskonczonosc
    public float fDuration = 0.0f;//#MUSIC;
    
    // czas trwania wyfejdowania muzyki, gdy wlacza sie inna podczas niej
    public float fFadeOutTime = 3.0f;//#MUSIC;

    // rzeczywisty czas odtwarzania
    float fRealDuration = 0.f;
    
    // ilosc loopow jeszcze do wykonania
    int nRealLoops = 0;
    
    int nMusic = 0;
    
    // muzyka do wystartowania po zrobieniu Fade'a
    Music cNewMusic = null;
	
	Music()
	{
		bSG = true;
	}
    
    public void Start()
    {
        String sMusicFile = (sMusic!=null) ? Text.Get(sMusic.toString()) : "";
        
        // sprawdzamy czy juz czasem nie gramy lub sie nie fejduje do nas
        if(cPlayingMusic != null)
        {
            if(cPlayingMusic == this ||
               cPlayingMusic.cNewMusic == this )
            {
                CrashLog("[Music.Play] <"+sMusicFile+"> already playing this music\n");
                return;
            }
        }
        
        // zatrzymujemy aktualnie grana muzyke
        if(cPlayingMusic != null)
        {
            String sMusicFilePlaying = (cPlayingMusic.sMusic!=null) ? Text.Get(cPlayingMusic.sMusic.toString()) : "";
            CrashLog("[Music.Play] <"+sMusicFile+"> some <"+sMusicFilePlaying+"> music already playing - stopping\n");
            cPlayingMusic.Stop(this);
            return;
            //cPlayingMusic.ForceStop();
        }
        
        if(sMusic != null)
        {
            // sprawdzamy czy sami nie gramy
            if(nMusic != 0 && IsPlayingWave(nMusic)) StopWave(nMusic);
            
            nMusic = PlayWave(sMusicFile);
            if(nMusic == 0)
                CrashLog("[Music.Play] No music <"+sMusicFile+">\n");
            else
                LogR("[Music.Play] Music <"+sMusicFile+"> fMusicVolume="+fMusicVolume+"\n");

            SetWaveVolume(nMusic, fMusicVolume);
            
            cPlayingMusic = this;
            
            if(fDuration == 0.0f && nLoops > 0)
                fRealDuration = nLoops * GetWaveDuration(nMusic);
            else
                fRealDuration = fDuration;

            nRealLoops = nLoops;
            
            // juz raz odpalilismy muzyke
            if(nRealLoops > 0) nRealLoops--;
            
            //CrashLog("[Music.Start] fRealDuration="+fRealDuration+"\n");
            
            if(fRealDuration > 0.0f)
            {
                // wlaczamy zatrzymania za jakis czas
                CallMethodIn("Stop", fRealDuration);
            }
            
            bFadeOut = false;
        }
    }
    
    void ZeroPlayingMusic()
    {
        cPlayingMusic = null;
    }
    
    public void Stop()
    {
        String sMusicFile = (sMusic!=null) ? Text.Get(sMusic.toString()) : "";
        LogR("[Music.Stop] Music <"+sMusicFile+">\n");
        
        // wlaczamy wyfejdowania wave'a
        if(fFadeOutTime == 0.0f)
            ForceStop();
        else
        {
            bFadeOut = true;
            fVolume = GetWaveVolume(nMusic);
            fStartTime = GetTime();
        }
    }

    public void Stop(Music newMusic)
    {
        cNewMusic = newMusic;
        Stop();
    }
    
    // wymusza natychmiastowe zatrzymanie
    public void ForceStop()
    {
        bFadeOut = false;
        
        String sMusicFile = (sMusic!=null) ? Text.Get(sMusic.toString()) : "";
        LogR("[Music.ForceStop] Music <"+sMusicFile+">\n");
       
        if(nMusic != 0)
        {
            if( IsPlayingWave(nMusic) ) StopWave(nMusic);
            nMusic = 0;
            
            ZeroPlayingMusic();
        }

        // wlaczamy muzyke nastepna
        if(cNewMusic != null)
        {
            cNewMusic.Start();
            cNewMusic = null;
        }
    }
    
    public void ToggleStartStop()
    {
        if(nMusic != 0)
        {
            if( IsPlayingWave(nMusic) ) Stop();
        }
        else
            Start();
    }
    
    public void OnDestroy()
    {
        cNewMusic = null;
        ForceStop();
    }
    
    public void Fade(float fFade)
    {
        SetWaveVolume(nMusic, fFade);
    }
    
    boolean bFadeOut = false;
    float fVolume = 1.f;
    float fStartTime = 0.0f;
    
    public void OnFrame()
    {
        if(nMusic != 0)
        {
            // mamy loopa do odtworzenia
            if(nRealLoops != 0)
            {
                if(!IsPlayingWave(nMusic))
                {
                    nMusic = PlayWave(Text.Get(sMusic.toString()));
                    SetWaveVolume(nMusic, fMusicVolume);
                    if(nRealLoops > 0) nRealLoops --;
                }
            }

            if(bFadeOut && (nMusic != 0))
            {
                float fInterval = GetTime() - fStartTime;
                float fCurrVolume = fVolume * fInterval / fFadeOutTime;
                if(fInterval > fFadeOutTime)
                {
                    // koniec fejdowania
                    Fade(0.0f);
                    bFadeOut = false;
                    
                    ForceStop();
                }
                else
                    Fade(fVolume - fCurrVolume);
            }
        }
    }
	
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
	boolean bPlay = false;
	    
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[Music.SGLoadChunk]\n");
		
		DisableCallMethod("Stop");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_PAWN)
        {
			if (nMusic != 0) 
			{
			    //if (IsPlayingWave(nMusic))
                StopWave(nMusic);
			    nMusic = 0;
			}
			
			if (cPlayingMusic != null)
			{
				if (cPlayingMusic.nMusic != 0)
				{
					//if (IsPlayingWave(cPlayingMusic.nMusic))
                    StopWave(cPlayingMusic.nMusic);
					cPlayingMusic.nMusic = 0;					
					cPlayingMusic = null;
				}
			}
			
			super.SGLoadChunk(cFC);
			
			// rzeczywisty czas odtwarzania
			fRealDuration = cFC.LoadFloat();
			// ilosc loopow jeszcze do wykonania
			nRealLoops = cFC.LoadInt();
			
			bFadeOut = cFC.LoadBool();
			fVolume = cFC.LoadFloat();
			fStartTime = cFC.LoadFloat();		
			
			fMusicVolume = cFC.LoadFloat();			
			bPlay = cFC.LoadBool();				
			cNewMusic = (Music)cFC.LoadObjectRef();			
        }
		
		cFC.delete();
	}
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[Music.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_PAWN, cFCParent);
		
		super.SGSaveChunk(cFC);
	
		// rzeczywisty czas odtwarzania
		cFC.SaveFloat(fRealDuration);
		// ilosc loopow jeszcze do wykonania
		cFC.SaveInt(nRealLoops);

		cFC.SaveBool(bFadeOut);
		cFC.SaveFloat(fVolume);
		cFC.SaveFloat(fStartTime);		
		
		cFC.SaveFloat(fMusicVolume);
		
		cFC.SaveBool(nMusic != 0);
		cFC.SaveObjectRef(cNewMusic);
					
		cFC.delete(); 
	}				
	
	public void SGUpdate()
	{
		FileChunk.Log("[Music.SGUpdate]\n");
		
		super.SGUpdate();
        
		if (bPlay)
		{
            nMusic = PlayWave(Text.Get(sMusic.toString()));
            SetWaveVolume(nMusic, fMusicVolume);
		}
	}	

    static void UpdateVolume()
    {
        int nCDVolume = GameObject.GetAudioCDVolume();
        fMusicVolume = nCDVolume/10.f;
        
        // zmieniamy gloscnosc muzyki
        if( cPlayingMusic != null )
        {
            if( cPlayingMusic.nMusic != 0)
            {
                SetWaveVolume(cPlayingMusic.nMusic, fMusicVolume);
            }
        }
        
        GameObject[] tab = GetObjectsFromClass("PortablePlayer");
        if (tab != null && tab.length > 0)
        {
            for (int i = 0; i < tab.length; i++)
            {
                ((PortablePlayer)tab[i]).UpdateMusicVolume();       
            }
        }
    }
    
    long l_nWavePos = -1;
    public void OnAudioPreReinitialize()
    {
        if (cPlayingMusic == this && 
            cPlayingMusic.nMusic != 0 && 
            IsPlayingWave(cPlayingMusic.nMusic))
        {
            l_nWavePos = GetPlayingWavePos(cPlayingMusic.nMusic);
        }
    }
    
    public void OnAudioReinitialize()
    {
        //CrashLog("Music <"+GetName()+"> l_nWavePos="+l_nWavePos+" cPlayingMusic=<"+cPlayingMusic.GetName()+">\n");
        if (cPlayingMusic == this)
        {
            String sMusicFile = Text.Get(cPlayingMusic.sMusic.toString());
            if (l_nWavePos != -1)
                nMusic = PlayWaveFromPos(sMusicFile, l_nWavePos);
            else
                nMusic = PlayWave(sMusicFile);
            
            SetWaveVolume(nMusic, fMusicVolume);
        }
        
        l_nWavePos = -1;
    }
}