public class ChatClientInfoList extends ObjectsList
{
    void Add( ChatClientInfo cClientInfo )
    {
        if ( cClientInfo instanceof ChatClientInfo )
        {
            String sNick = cClientInfo.GetNick();
            int i = 0;
            for ( ; i < GetSize(); ++ i )
            {
                ChatClientInfo cClientToCompare = GetClientInfoAt( i );
                String         sNickToCompare   = cClientToCompare.GetNick();
                
                if ( sNick.compareTo( sNickToCompare ) < 0 )
                    break;
            }
            
            InsertAt( (Object) cClientInfo, i );
        }
    }
    
    ChatClientInfo GetClientInfoAt( int nIndex )
    {
        Object cObj = GetObjectAt( nIndex );
        return (cObj instanceof ChatClientInfo)?
               (ChatClientInfo)cObj : null;
    }
    
    ChatClientInfo FindClientInfoById( int nId )
    {
        for ( int i=0; i<GetSize(); ++i )
        {
            ChatClientInfo cClientInfo = GetClientInfoAt( i );
            if ( ( cClientInfo != null ) && ( cClientInfo.GetId() == nId ) )
                return cClientInfo;
        }
        
        return null;
    }
}
