public class AuthorizationServersMngr
{
    final static String sm_sServersScriptFile   = "Data/AuthorizationServers.scr";
    final static float  sm_fDefaultTimeOut      = 15.0f;
    
    
    private 
    float       m_fTimeOut  = sm_fDefaultTimeOut;
        
    private
    StringsList m_cServers  = new StringsList();
    
    AuthorizationServersMngr()
    {
        this( sm_sServersScriptFile );
    }
    
    AuthorizationServersMngr(String sFile)
    {
        //parsujemy plik
        ParseKeyword cRoot = GameObject.ParseFile( sFile );
        if ( cRoot != null )
        {
            for ( ParseKeyword cKey = cRoot; cKey != null; cKey = cKey.GetNext() )
            {
                if (cKey.Equals("TimeOut"))
                    m_fTimeOut = cKey.GetIParam(0);
                
                if (cKey.Equals("AuthorizationServer"))
                    m_cServers.Add( cKey.GetSParam(0) );    
            }
            cRoot.delete();
        }
        else
        {
            NetLog.Error("Read or parse error in file " + sFile);
        }
    }

    float GetTimeOut()
    { 
        return m_fTimeOut; 
    }
    
    String[] GetServers()
    {
        String []aList = null;
        int nCnt = m_cServers.GetSize();
        if ( nCnt > 0 )
        {
            aList = new String[ nCnt ];
            for ( int i=0; i<nCnt; ++i )
                aList[ i ] = m_cServers.GetStringAt( i );    
        }
        return aList;
    }

}
