public class WishListAnswersContainer
{
    java.util.ArrayList vAnswers = new java.util.ArrayList();
    
    //czas okreslajacy kiedy odpowiedz moze byc usunieta z listy; jesli <0,
    //to nie ma sprawdzania; sprawdzanie jest wykonywane w momencie dodawania nowej odpowiedzi
    float fAnswerTimeOut = -1.0f;
    Module cModule = null;
    
    public WishListAnswersContainer(float fAnswerTimeOut, Module cModule)
    {
        this.fAnswerTimeOut = fAnswerTimeOut;
        this.cModule = cModule;
    }
    
    public void Add(WishListAnswer answer)
    {
        if (fAnswerTimeOut >= 0.0f)
        {
            ReleaseTimedOutAnswers();
        }
        
        if (answer != null)
        {
            vAnswers.add(answer);
        }
    }
    
    public void ReleaseTimedOutAnswers()
    {
        float fCurrentTime = cModule.GetAbsoluteTime();
        
        int iCount = vAnswers.size();
        
        for (int i = 0; i < iCount; ++i)
        {
            WishListAnswer answer = (WishListAnswer)vAnswers.get(i);
            
            if (fCurrentTime - answer.GetCreateTime() > fAnswerTimeOut)
            {
                vAnswers.remove(i);
                iCount--;
                i--;
                answer = null;
            }
        }
    }
    /** sprawdza poprawnosc odpowiedzi. Niezaleznie od tego czy odpowiedz byla poprawna, 
     * czy nie, jesli na liscie byla odpowiedz o takim samym QueryNum to jest ona usuwana.
     * Odpowiedz, ktora nie ma na liscie swojego odpowiednika (okreslane na podstawie QueryNum)
     * jest uznawana za niepoprawna.
     */
    /*public boolean Check(WishListAnswer answer)
    {
        if (answer != null)
        {
            int iCount = vAnswers.size();
            int i = 0;
            WishListAnswer cListAnswer = null;
            
            while (i < iCount &&
                   cListAnswer == null)
            {
                WishListAnswer cAnswer = (WishListAnswer)vAnswers.get(i);
                if (cAnswer.GetQueryNum() == answer.GetQueryNum())
                {
                    cListAnswer = cAnswer;
                    vAnswers.remove(i);
                }
            }

            if (cListAnswer != null)
            {
                return cListAnswer.Compare(answer);
            }
        }
        
        return false;
    }
    */
    public boolean Check(int iQueryNum, int iCRC)
    {
        int iCount = vAnswers.size();
        int i = 0;
        WishListAnswer cListAnswer = null;

        while (i < iCount &&
               cListAnswer == null)
        {
            WishListAnswer cAnswer = (WishListAnswer)vAnswers.get(i);
            if (cAnswer.GetQueryNum() == iQueryNum)
            {
                cListAnswer = cAnswer;
                vAnswers.remove(i);
            }
            
            ++i;
        }

        if (cListAnswer != null)
        {
            return cListAnswer.Compare(iQueryNum, iCRC);
        }
        
        return false;    
    }
}
