public class CommandAdminLogin extends ConsoleCommandParams
{
    CommandAdminLogin()
    {
        super();
        m_nMinParams       = 
        m_nMaxParams       = 2;
    }
    
    final static int _PARAM_USER_NAME = 0;
    final static int _PARAM_PASSWORD  = 1;
    
    void Perform()
    {
        String sUserName = GetSParam( _PARAM_USER_NAME );
        String sPassword = GetSParam( _PARAM_PASSWORD );
        int    nHostId   = GetHost();
        
        if ( nHostId != 0 )
        {
            int nErrorId = 
                m_cGameInfo.GetAdminsManager().AdminLogin( sUserName, 
                                                           sPassword,
                                                           nHostId );
            if ( nErrorId != EConsoleCommandError._NONE )
                SetErrorId( nErrorId );
        }
        else
            SetErrorId( EConsoleCommandError._YOU_ARE_ALREADY_LOGGED_IN );
    }
    
    void ShowErrors()
    {
        String sError = GetTextCommandNotAccepted();
        switch ( GetErrorId() )
        {
        case EConsoleCommandError._YOU_ARE_ALREADY_LOGGED_IN:            
            sError = sError + " " + Text.Get("&ConsoleCommandYouAreAlreadyLoggedIn&");
            break;
            
        case EConsoleCommandError._INCORRECT_LOGINNAME_OR_PASSWORD:            
            sError = sError + " " + Text.Get("&ConsoleCommandIncorrectLoginNameOrPassword&");
            break;            
            
        default:
            sError = null;
            super.ShowErrors();
        }
        if ( sError != null )
            WriteResults( sError );
    }
    
    void ShowResults()
    {
        String sResults = GetTextCommandAccepted() +
                          " " + 
                          Text.Get("&ConsoleCommandYouHaveLoggedInAsAdmin&");
        WriteResults( sResults );
        //"ConsoleCommandPlayerHasLoggedInAsAdmin"
    }
}
