public class CommandForceNick extends ConsoleCommandParams
{
    CommandForceNick()
    {
        super();
        m_nRequiredAdminRights  = EAdminRights._STANDARD;
        m_nMinParams            = 
        m_nMaxParams            = 2;
    }
    
    final static int _PARAM_OLD_NICK_OR_PID = 0;
    final static int _PARAM_NEW_NICK        = 1;
    
    void Clean()
    {
        super.Clean();
        m_sOldNickOrPID         = null;
        m_sOldNick              = null;
        m_sNewNick              = null;
    }
    
    String m_sOldNickOrPID  = null;
    String m_sOldNick       = null;
    String m_sNewNick       = null;
    
    void InitPerform()
    {
        super.InitPerform();
        
        if ( ErrorOccured() )
            return;
        
        m_sOldNickOrPID = GetSParam( _PARAM_OLD_NICK_OR_PID );
        m_sNewNick      = GetSParam( _PARAM_NEW_NICK );
        
        m_cPlayerInfo = m_cPlayerInfoList.GetPlayerByNickOrPID( m_sOldNickOrPID );
        if ( m_cPlayerInfo == null )
        {
            SetErrorId( EConsoleCommandError._PLAYER_NOT_FOUND );
            return;
        }
                
        m_sOldNick = m_cPlayerInfo.GetNick();
            
        if ( m_sNewNick.equals( m_sOldNick ) )
        {
            SetErrorId( EConsoleCommandError._NICKS_EQUALS );
            return;
        }
    }
        
    void PostPerform()
    {
        //teraz przechodzimy przez weryfikacje
        m_sNewNick = m_cPlayerInfoList.VerifyPlayerNick( m_sNewNick );
        
        m_cPlayerInfo.SetName( m_sNewNick );
        m_cGameInfo.EventPlayerChangedNickForced( m_cPlayerInfo, m_sOldNick );
    }
}
