public class CommandForceTeam extends ConsoleCommandParams
{
    CommandForceTeam()
    {
        super();
        m_nRequiredAdminRights  = EAdminRights._STANDARD;
        m_nMinParams            = 1;
        m_nMaxParams            = 2;
    }
    
    final static int _PARAM_OLD_NICK_OR_PID = 0;
    final static int _PARAM_NEW_TEAM        = 1;
    
    void Clean()
    {
        super.Clean();
        m_sOldNickOrPID     = null;
        m_sNewTeam          = null;
        m_nNewTeamId        = NetTeamInfo.NONE;
    }
    
    String m_sOldNickOrPID  = null;
    String m_sNewTeam       = null;
    int    m_nNewTeamId     = NetTeamInfo.NONE;

    void InitPerform()
    {
        super.InitPerform();
        
        if ( ErrorOccured() )
            return;
        
        if ( ! (m_cGameInfo instanceof NetGameInfoTeam) )
        {
            SetErrorId( EConsoleCommandError._CURRENT_MAP_IS_NOT_A_TEAM_GAMEPLAY );
            return;
        }
        
        m_sOldNickOrPID = GetSParam( _PARAM_OLD_NICK_OR_PID );
        m_sNewTeam      = CheckSParam( _PARAM_NEW_TEAM ) ?
                          GetSParam( _PARAM_NEW_TEAM ) : null;
        
        m_cPlayerInfo = m_cPlayerInfoList.GetPlayerByNickOrPID( m_sOldNickOrPID );
        if ( m_cPlayerInfo == null )
        {
            SetErrorId( EConsoleCommandError._PLAYER_NOT_FOUND );
            return;
        }

        m_nNewTeamId = NetTeamInfo.NONE;
        if ( m_sNewTeam != null )
        {
            if ( m_sNewTeam.equalsIgnoreCase("RED") )
                m_nNewTeamId = NetTeamInfo.RED;
            else if ( m_sNewTeam.equalsIgnoreCase("BLUE") )
                m_nNewTeamId = NetTeamInfo.BLUE;
        }
        
        if ( (m_nNewTeamId != NetTeamInfo.NONE) &&
             (m_nNewTeamId == m_cPlayerInfo.GetTeamId()) )
        {
            SetErrorId( EConsoleCommandError._TEAMS_EQUALS );
            return;
        }
    }
        
    void PostPerform()
    {
        ((NetGameInfoTeam)m_cGameInfo).EventAdminForcePlayerChangeTeam( 
                                        m_cPlayerInfo, m_nNewTeamId );
    }
}
