public class CommandAdminList extends ConsoleCommand
{        
    LoggedUsersList          m_cLoggedAdminList = null;
    
    void Clean()
    {
        super.Clean();
        m_cLoggedAdminList = null;
    }

    void InitPerform()
    {
        super.InitPerform();
        
        m_cLoggedAdminList = m_cGameInfo.GetAdminsManager().GetLoggedAdmins();
        if ( m_cLoggedAdminList == null )
        {
            //TODO: brak zalogowanych adminow
            NetLog.Warning( GetNetInfo()+" m_cLoggedAdminList == null");
            SetErrorId();
        }
    }

    void Perform()
    {
        int nAdminsCnt = m_cLoggedAdminList.GetSize();
        m_aResultsContainer = new NetDataContainer();
        m_aResultsContainer.PackInt( nAdminsCnt );
        for ( int i=0; i<nAdminsCnt; ++i )
        {
            LoggedUserInfo cUserInfo   = m_cLoggedAdminList.GetUserAt( i );
            NetPlayerInfo  cPlayerInfo = m_cPlayerInfoList.GetPlayerByHostId( cUserInfo.GetHostId() );
            
            m_aResultsContainer.PackString( cPlayerInfo.GetNick() );
            m_aResultsContainer.PackInt( GetPlayerId( cPlayerInfo ) );
        }
    }
    
    void ShowResults()
    {
        if ( m_aResultsContainer == null )
        {
            NetLog.Warning( GetNetInfo()+ " m_aResultsContainer == null"); 
            //TODO: sprawdzic tekst
            WriteResults( Text.Get("&ConsoleCommandNoLoggedAdminsInGame&") );
            return;
        }
        
        int nAdminsCnt = m_aResultsContainer.UnPackInt();
        if ( nAdminsCnt <= 0 )
        {
            //TODO: sprawdzic tekst
            WriteResults( Text.Get("&ConsoleCommandNoLoggedAdminsInGame&") );
            return;
        }
        
        WriteResults( NetGameTools.MixString(
                        Text.Get("&ConsoleCommandThereAreLoggedAdminsInGame&"),
                        Integer.toString( nAdminsCnt )) 
                    );
        for ( int i=0; i<nAdminsCnt; ++i )
        {
            String sText = m_aResultsContainer.UnPackString()+
                           " "+GetPlayerIdName()+": "+
                           m_aResultsContainer.UnPackInt();
            WriteResults( sText );
        }
    }
}
