/**
 * Komenda powodujaca zabicie gracza ktory ja wywolal.
 */
public class CommandKillMe extends ConsoleCommand
{
    void InitPerform()
    {
        super.InitPerform();
        
        if ( ErrorOccured() )
            return;
        
        if ( m_cGameInfo.IsGameOver() )
        {
            SetErrorId( EConsoleCommandError._GAME_OVER );
            return;
        }

        if ( m_cPlayerInfo == null )
        {
            SetErrorId( EConsoleCommandError._PLAYER_NOT_FOUND );
            return;
        }
            
        if ( ! m_cPlayerInfo.IsAlive() )
        {
            SetErrorId( EConsoleCommandError._PLAYER_IS_DEAD );
            return;
        }
    }
    void Perform()
    {
    }
    
    void PostPerform()
    {
        m_cPlayerInfo.ServerForceKillMe();
    }
        
    void ShowErrors()
    {
        String sError = GetTextCommandNotAccepted();
        switch ( GetErrorId() )
        {
        
        default:
            sError = null;
            super.ShowErrors();
        }
        if ( sError != null )
            WriteResults( sError );
    }
}
