/**
 * Wyslanie chata do podanego nicka
 */
public class CommandMsgNick extends ConsoleCommandParams
{
    CommandMsgNick()
    {
        super();
        m_nMinParams                 = 
        m_nMaxParams                 = 2;
        m_bResultsExpected           = false;
        m_bShouldExecuteOnlyOnServer = false;
    }
    
    final static int _PARAM_NICK_OR_PID = 0;
    final static int _PARAM_MSG         = 1;
    
    void Perform()
    {
        String sNickOrPID = GetSParam( _PARAM_NICK_OR_PID );
        if ( ! NetGameTools.IsStringValid( sNickOrPID ) )
        {
            SetErrorId( EConsoleCommandError._WRONG_PARAMS_CNT );
            return;
        }
        
        m_cPlayerInfo = m_cGameInfo.GetPlayerInfoList().GetPlayerByNickOrPID( sNickOrPID );
        if ( m_cPlayerInfo == null )
        {
            SetErrorId( EConsoleCommandError._PLAYER_NOT_FOUND );
            return;
        }
        
        m_cGameInfo.LocalEventTypedText( 
                                        GetParamsToEnd( _PARAM_MSG ),
                                        NetMsg._MODE_NICK,
                                        m_cPlayerInfo.GetClientOwnerId()                 
                                       );
    }
}
