/**
 * Wyswietlenie listy wszystkich graczy
 */
public class CommandPlayerList extends ConsoleCommand
{
    CommandPlayerList()
    {
        super();
        m_bShouldExecuteOnlyOnServer = false;
    }
            
    void Perform()
    {
        int nPlayersCnt = m_cPlayerInfoList.GetSize();
        m_aResultsContainer = new NetDataContainer();
        m_aResultsContainer.PackInt( nPlayersCnt );
        for ( int i=0; i<nPlayersCnt; ++i )
        {
            NetPlayerInfo cPlayerInfo = m_cGameInfo.GetPlayerInfoList().GetPlayerByIndex( i );
            
            m_aResultsContainer.PackString( cPlayerInfo.GetNick() );
            m_aResultsContainer.PackInt( GetPlayerId( cPlayerInfo ) );
        }
    }
    
    void ShowResults()
    {
        if ( m_aResultsContainer == null )
        {
            NetLog.Warning( GetNetInfo()+ " m_aResultsContainer == null"); 
            WriteResults( Text.Get("&ConsoleCommandNoPlayersInGame&") );
            return;
        }
        
        int nPlayersCnt = m_aResultsContainer.UnPackInt();
        if ( nPlayersCnt <= 0 )
        {
            WriteResults( Text.Get("&ConsoleCommandNoPlayersInGame&") );
            return;
        }
        
        WriteResults( NetGameTools.MixString(
                        Text.Get("&ConsoleCommandThereArePlayersInGame&"),
                        Integer.toString( nPlayersCnt )) 
                    );
        for ( int i=0; i<nPlayersCnt; ++i )
        {
            String sText = m_aResultsContainer.UnPackString()+
                           " "+GetPlayerIdName()+": "+
                           m_aResultsContainer.UnPackInt();
            WriteResults( sText );
        }
    }
}

