/** Klasa przechowujaca liste tekstow
 * Kazdy nowy element dopisuje sie na poczatku listy ( index 0 )
 * jesli przy dodawaniu tekstu okaze sie ze juz taki jest
 * na liscie to tez "stary" wpis zostaje usuniety
 */
public class ConsoleMessageHistory
{
    final static int _HISTORY_SIZE = 20;
    
    private String[] m_sTexts = new String[ _HISTORY_SIZE ];
    private int m_nCurrent = -1;
    
    void Reset()
    {
        m_nCurrent = -1;
    }
    
    void Add( String sText )
    {
        String sCurrent = sText;
        String sNext    = null;
        for ( int i=0; i<m_sTexts.length; i++ )
        {
            //pobieramy tekst do przesuniecia dalej
            sNext = m_sTexts[ i ];
            //w jego miejsce wstawiamy aktualny
            m_sTexts[ i ] = sCurrent;
            //jesli ten zastapiony tekst byl pusty, albo taki sam 
            //jak wstawiamy to konczymy zabawe...
            if ( sNext == null || sNext.compareTo( sText ) == 0 )
                break;
            //teraz nowym tekstem do wstawienia na pozycji m_sHistory[ i+1 ]
            //jest ten co byl w m_sHistory[ i ]
            sCurrent = sNext;
        }
        
        Reset();
    }
    
    String Get(int i)
    {
        if ( i >= 0 && i < m_sTexts.length )
            return m_sTexts[ i ];
        return null;
    }
    
    String GetPrevious()
    { 
        String sText = Get( m_nCurrent + 1 );
        if ( sText != null )
            m_nCurrent++;
        return sText;
    }
    String GetNext()
    { 
        String sText = Get( m_nCurrent - 1 );
        if ( sText != null )
            m_nCurrent--;
        return sText;
    }
}
