public class NetGameSettings extends NetGameSettingsBase
{
    /**domyslne parametry, mozna tym zmiennym przypisac konkretne wartosci 
     * w konstruktorach poszczegolnych klas dziedziczacych NetGameSettings
     **/
    //warunki zakonczenia:
    //wygrana (jesli sie osiagnie, to wygrana)
    //maksymalny czas gry, jesli < 0 , to brak limitu
    int   _TIME_LIMIT_IN_MINUTES        = 20;
    //fragi do ilu gramy, jesli < 0, tzn ze nie istotne
    int   _FRAGS_LIMIT                  = -1;
    //punkty "do ilu" gramy, jesli < 0, tzn ze nie istotne
    int   _POINTS_LIMIT                 = -1;
    //przegrana (jesli sie osiagnie, to dyskwalifikacja)
    //limit respawnow w grze dla kazdego gracza, jesli < 0 to brak limitow
    int   _RESPAWN_CNT_LIMIT            = -1;
    //minimalny czas pomiedzy smiercia a nastepnym respawnem, < 0 brak limitu
    float _MIN_RESPAWN_TIME_IN_SECONDS  = -1.0f;
    //limit respawnow w grze dla kazdego pojazdu, jesli < 0 to brak limitow
    int   _VEHICLE_RESPAWN_CNT_LIMIT            = -1;
    // czas pomiedzy smiercia a nastepnym respawnem pojazdu
    float _VEHICLE_MIN_RESPAWN_TIME_IN_SECONDS  = 30.0f;
    // po jakim czasie nieuzywany pojazd automatycznie wraca do bazy
    float _VEHICLE_AUTO_RETURN_TIME_IN_SECONDS  = 90.0f;
    //czy maja byc dostepne pojazdy (tu MUSI  byc false i ustawiane to bedzie
    //w skryptach na true tam gdzie sa pojazdy, po to, zeby w MenuNetGameSettings
    //nie pojawialy sie domyslnie powyzesz kontrolki dotyczace pojazdw
    boolean _AVAILABLE_VEHICLES = false;    
    //czy pozycja wrogich graczy ma byc pokazywana na mapie
    boolean _ENEMIES_VISIBLE_ON_HUD_MAP = false;
    //czy pozycja pojazdow ma byc pokazywana na mapie
    boolean _VEHICLES_VISIBLE_ON_HUD_MAP = true;
    //czy ma byc dostepne inwentory menu?
    boolean _AVAILABLE_INVENTORY_ROOM = true;
    //czy nicki wrogich gracz ma sie pokazac na celowniku
    boolean _IDENTIFY_ENEMY_PLAYERS   = false;
    //pozostale:
    //minimalna liczba graczy (druzyn) jaka mus byc zeby gra nie zostala przerwana    
    int   _MIN_ACTIVE_PLAYERS_IN_GAME   = 2;
    
    
    NetGameSettings()
    {
    }
    
   
    //zmienne obslugujace parametry gry podczas jej trwania
    //wygrana (jesli sie osiagnie, to wygrana)
    //maksymalny czas gry, jesli < 0 , to brak limitu
    private float m_fGameTimeLimit          = -1.0f;
    //fragi "do ilu" gramy, jesli < 0, tzn ze nie istotne
    private int   m_nFragsLimit             = -1;
    //punkty "do ilu" gramy, jesli < 0, tzn ze nie istotne
    private int   m_nPointsLimit            = -1;
    //przegrana (jesli sie osiagnie, to dyskwalifikacja)
    //limit respawnow w grze dla kazdego gracza, jesli < 0 to brak limitow
    private int   m_nRespawnCntLimit        = -1;
    //minimalny czas pomiedzy smiercia a nastepnym respawnem
    private float m_fMinRespawnTime         = -1.0f;
    //limit respawnow w grze dla kazdego pojazdu, jesli < 0 to brak limitow
    private int   m_nVehicleRespawnCntLimit = -1;
    //minimalny czas pomiedzy smiercia a nastepnym respawnem
    private float m_fVehicleMinRespawnTime  = 120.0f;
    //czas po ktorym nieuzywany pojazd powroci do bazy, jesli < 0 to auto returna
    private float m_fVehicleAutoReturnTime  = -1.0f;
    //czy pozycja wrogich graczy ma byc pokazywana na mapie
    private boolean m_bEnemiesVisibleOnHudMap = false;
    //czy pozycja pojazdow ma byc pokazywana na mapie
    private boolean m_bVehiclesVisibleOnHudMap = true;
    //czy ma byc dostepne inwentory room
    private boolean m_bAvailableInventoryRoom = false;
    //czy nicki wrogich graczy maja byc widoczna na celowniku
    private boolean m_bIdentifyEnemyPlayers   = false;
    //pozostale:
    //minimalna liczba graczy (druzyn) jaka mus byc zeby gra nie zostala przerwana
    private int   m_nMinNumberActivePlayersInGame = 2;
    //czy maja byc dostepne pojazdy, to nie bedzie sejwowane i edytowane!
    private boolean m_bAvailableVehicles = false;
    
    
    
    float GetGameTimeLimit()         { return m_fGameTimeLimit;          }
    int   GetGameTimeLimitInMinutes(){ return (int)(m_fGameTimeLimit/60);}
    float GetMinRespawnTime()        { return m_fMinRespawnTime;         }
    int   GetRespawnCntLimit()       { return m_nRespawnCntLimit;        }
    int   GetVehicleRespawnCntLimit(){ return m_nVehicleRespawnCntLimit; }
    float GetVehicleMinRespawnTime() { return m_fVehicleMinRespawnTime;  }
    float GetVehicleAutoReturnTime() { return m_fVehicleAutoReturnTime;  }
    int   GetFragsLimit()            { return m_nFragsLimit;             }
    int   GetPointsLimit()           { return m_nPointsLimit;            }
    int   GetMinNumberActivePlayersInGame(){ return m_nMinNumberActivePlayersInGame; }
    boolean GetEnemiesVisibleOnHudMap(){ return m_bEnemiesVisibleOnHudMap; }
    boolean GetVehiclesVisibleOnHudMap(){ return m_bVehiclesVisibleOnHudMap; }
    boolean GetAvailableInventoryRoom(){ return m_bAvailableInventoryRoom; }
    boolean GetAvailableVehicles()   { return m_bAvailableVehicles; }
    boolean GetIdentifyEnemyPlayers() { return m_bIdentifyEnemyPlayers; }
    
    void SetGameTimeLimitInMinutes(int nMinutes)     { m_fGameTimeLimit = nMinutes*60.0f;}
    void SetMinRespawnTimeInSeconds(float fSeconds)  { m_fMinRespawnTime = fSeconds; }
    void SetRespawnCntLimit(int nCnt)                { m_nRespawnCntLimit = nCnt; }
    void SetVehicleRespawnCntLimit(int nCnt)                { m_nVehicleRespawnCntLimit = nCnt; }
    void SetVehicleMinRespawnTimeInSeconds(float fSeconds)  { m_fVehicleMinRespawnTime = fSeconds; }
    void SetVehicleAutoReturnTime(float fSeconds)    { m_fVehicleAutoReturnTime = fSeconds; }
    void SetFragsLimit(int nFrags)                   { m_nFragsLimit = nFrags; }
    void SetPointsLimit(int nPoints)                 { m_nPointsLimit = nPoints; }
    void SetMinNumberActivePlayersInGame(int nMin)   { m_nMinNumberActivePlayersInGame = nMin; }
    void SetEnemiesVisibleOnHudMap(boolean bVisible){ m_bEnemiesVisibleOnHudMap = bVisible; }
    void SetVehiclesVisibleOnHudMap(boolean bVisible){ m_bVehiclesVisibleOnHudMap = bVisible; }
    void SetAvailableInventoryRoom(boolean bAvailable){ m_bAvailableInventoryRoom = bAvailable; }
    void SetAvailableVehicles(boolean bAvailable){ m_bAvailableVehicles = bAvailable; }
    void SetIdentifyEnemyPlayers(boolean bIdentify){ m_bIdentifyEnemyPlayers = bIdentify; }
    
    //zmienna ktora okresla czy w danej grze zlicza sie 
    //punkty (domyslnie) czy fragi
    boolean m_bScorePoints = true;
    boolean ScorePoints(){ return m_bScorePoints; }
        
    void Init()
    {
        SetGameTimeLimitInMinutes( _TIME_LIMIT_IN_MINUTES );
        SetFragsLimit( _FRAGS_LIMIT );
        SetPointsLimit( _POINTS_LIMIT );
        SetMinRespawnTimeInSeconds( _MIN_RESPAWN_TIME_IN_SECONDS );
        SetRespawnCntLimit( _RESPAWN_CNT_LIMIT );
        SetVehicleRespawnCntLimit( _VEHICLE_RESPAWN_CNT_LIMIT );
        SetVehicleMinRespawnTimeInSeconds( _VEHICLE_MIN_RESPAWN_TIME_IN_SECONDS );
        SetVehicleAutoReturnTime( _VEHICLE_AUTO_RETURN_TIME_IN_SECONDS );
        SetMinNumberActivePlayersInGame( _MIN_ACTIVE_PLAYERS_IN_GAME );
        SetEnemiesVisibleOnHudMap( _ENEMIES_VISIBLE_ON_HUD_MAP );
        SetVehiclesVisibleOnHudMap( _VEHICLES_VISIBLE_ON_HUD_MAP );
        SetAvailableInventoryRoom( _AVAILABLE_INVENTORY_ROOM );
        SetAvailableVehicles( _AVAILABLE_VEHICLES );
        SetIdentifyEnemyPlayers( _IDENTIFY_ENEMY_PLAYERS );
    }
        
    boolean ApplyModifier(ModifierNetGameSettings cModifier)
    {
        boolean bOk = true;
        
        switch ( cModifier.GetId() )
        {
        case EModifiersNetGameSettings._MAX_GAME_TIME:
            SetGameTimeLimitInMinutes( cModifier.GetIntParam() );
            break;
        case EModifiersNetGameSettings._MAX_POINTS:
            SetPointsLimit( cModifier.GetIntParam() );
            break;
        case EModifiersNetGameSettings._RESPAWN_CNT_LIMIT:
            SetRespawnCntLimit( cModifier.GetIntParam() );
            break;
        case EModifiersNetGameSettings._MIN_RESPAWN_TIME:
            SetMinRespawnTimeInSeconds( cModifier.GetFloatParam() );
            break;
        case EModifiersNetGameSettings._VEHICLE_RESPAWN_CNT_LIMIT:
            SetVehicleRespawnCntLimit( cModifier.GetIntParam() );
            break;
        case EModifiersNetGameSettings._VEHICLE_MIN_RESPAWN_TIME:
            SetVehicleMinRespawnTimeInSeconds( cModifier.GetFloatParam() );
            break;
        case EModifiersNetGameSettings._VEHICLE_AUTO_RETURN_TIME:
            SetVehicleAutoReturnTime( cModifier.GetFloatParam() );
            break;            
        case EModifiersNetGameSettings._ENEMIES_VISIBLE_ON_HUD_MAP:
            SetEnemiesVisibleOnHudMap( cModifier.GetBooleanParam() );
            break;
        case EModifiersNetGameSettings._VEHICLES_VISIBLE_ON_HUD_MAP:
            SetVehiclesVisibleOnHudMap( cModifier.GetBooleanParam() );
            break;            
        case EModifiersNetGameSettings._AVAILABLE_INVENTORY_ROOM:
            SetAvailableInventoryRoom( cModifier.GetBooleanParam() );
            break;            
        case EModifiersNetGameSettings._AVAILABLE_VEHICLES:
            SetAvailableVehicles( cModifier.GetBooleanParam() );
            break;            
        case EModifiersNetGameSettings._IDENTIFY_ENEMY_PLAYERS:
            SetIdentifyEnemyPlayers( cModifier.GetBooleanParam() );
            break;
        default:
            bOk = false;
            GameObject.LogD(" Modyfikator "+cModifier.GetId()+
                            " nie zostal obsluzony\n");
        }
        return bOk;
    }
    
        
    void SaveSettings()
    {
        m_cScriptWriter.Write("GameTime("+GetGameTimeLimitInMinutes()+")");
        if (m_bScorePoints)
            m_cScriptWriter.Write("MaxPoints("+m_nPointsLimit+")");
        else
            m_cScriptWriter.Write("MaxFrags("+GetFragsLimit()+")");
        m_cScriptWriter.Write("RespawnCntLimit("+m_nRespawnCntLimit+")");
        m_cScriptWriter.Write("MinRespawnTime("+m_fMinRespawnTime+")");
        m_cScriptWriter.Write("VehicleRespawnCntLimit("+m_nVehicleRespawnCntLimit+")");
        m_cScriptWriter.Write("VehicleRespawnTime("+m_fVehicleMinRespawnTime+")");
        m_cScriptWriter.Write("VehicleAutoReturnTime("+m_fVehicleAutoReturnTime+")");
        m_cScriptWriter.Write("EnemiesVisibleOnHudMap("+Bool2String(m_bEnemiesVisibleOnHudMap)+")");
        m_cScriptWriter.Write("VehiclesVisibleOnHudMap("+Bool2String(m_bVehiclesVisibleOnHudMap)+")");
        m_cScriptWriter.Write("AvailableInventoryRoom("+Bool2String(m_bAvailableInventoryRoom)+")");
        m_cScriptWriter.Write("IdentifyEnemyPlayers("+Bool2String(m_bIdentifyEnemyPlayers)+")");
        
        //celowo pomijam:
        //m_cScriptWriter.Write("AvailableVehicles("+Bool2String(m_bAvailableVehicles)+")");
    
        //TODO
        //minimalna liczba graczy (druzyn) jaka mus byc zeby gra nie zostala przerwana
        //private int   m_nMinNumberActivePlayersInGame = 2;
    }
    
    
    void CopyDataFromContainer()
    {
        SetLevelName( m_cContainer.UnPackString() );
        SetGameTimeLimitInMinutes( m_cContainer.UnPackInt() );
        if (m_bScorePoints)
            SetPointsLimit( m_cContainer.UnPackInt() );
        else
            SetFragsLimit( m_cContainer.UnPackInt() );
        SetRespawnCntLimit( m_cContainer.UnPackInt() );
        SetMinRespawnTimeInSeconds ( m_cContainer.UnPackFloat() );
        SetAvailableVehicles( m_cContainer.UnPackBoolean() );
        SetVehicleRespawnCntLimit( m_cContainer.UnPackInt() );
        SetVehicleMinRespawnTimeInSeconds ( m_cContainer.UnPackFloat() );
        SetVehicleAutoReturnTime( m_cContainer.UnPackFloat() );
        SetEnemiesVisibleOnHudMap( m_cContainer.UnPackBoolean() );
        SetVehiclesVisibleOnHudMap( m_cContainer.UnPackBoolean() );
        SetAvailableInventoryRoom( m_cContainer.UnPackBoolean() );
        SetIdentifyEnemyPlayers( m_cContainer.UnPackBoolean() );
    }

    void CopyDataToContainer()
    {
        m_cContainer.PackString( GetLevelName() ) ;
        m_cContainer.PackInt( GetGameTimeLimitInMinutes() );
        if (m_bScorePoints)
            m_cContainer.PackInt( GetPointsLimit() );
        else
            m_cContainer.PackInt( GetFragsLimit() );
        m_cContainer.PackInt( GetRespawnCntLimit() );
        m_cContainer.PackFloat( GetMinRespawnTime() );
        m_cContainer.PackBoolean( GetAvailableVehicles() );
        m_cContainer.PackInt( GetVehicleRespawnCntLimit() );
        m_cContainer.PackFloat( GetVehicleMinRespawnTime() );
        m_cContainer.PackFloat( GetVehicleAutoReturnTime()  );
        m_cContainer.PackBoolean( GetEnemiesVisibleOnHudMap() );
        m_cContainer.PackBoolean( GetVehiclesVisibleOnHudMap() );
        m_cContainer.PackBoolean( GetAvailableInventoryRoom() );
        m_cContainer.PackBoolean( GetIdentifyEnemyPlayers() );
    }
    
    void ASEQuery_OnWantRules( ModuleNetBaseQuery cLevel )
    {
        //time limit / round time limit
        int nValue = GetGameTimeLimitInMinutes();
        String sRule = this instanceof NetGameSettingsRound ?
                        "Round Time Limit" : "Time Limit";
        cLevel.ASEQuery_AddRule( sRule, 
                                 (nValue > 0) ? Integer.toString( nValue ): "unlimited" );
        //points/frags limit
        nValue = m_bScorePoints ? GetPointsLimit() : GetFragsLimit();
        cLevel.ASEQuery_AddRule( m_bScorePoints ? "Points Limit" : "Frags Limit",
                                (nValue > 0) ? Integer.toString( nValue )+" min.": "unlimited" );        
        
        nValue = GetRespawnCntLimit();
        cLevel.ASEQuery_AddRule( "Respawns Limit",
                                 (nValue > 0) ? Integer.toString( nValue ): "unlimited" );        
        
        nValue = (int)GetMinRespawnTime();
        cLevel.ASEQuery_AddRule( "Respawn Delay",
                                (nValue > 0) ? Integer.toString( nValue )+" sec.": "no" );        
        
        cLevel.ASEQuery_AddRule( "Enemies Visible On Map",
                                 NetGameTools.Bool2YesNo(GetEnemiesVisibleOnHudMap()) );        
                
        cLevel.ASEQuery_AddRule( "Available Inventory Room",
                                 NetGameTools.Bool2YesNo(GetAvailableInventoryRoom()) );        
        
        cLevel.ASEQuery_AddRule( "Identify Enemy Players",
                                 NetGameTools.Bool2YesNo(GetIdentifyEnemyPlayers()) );        
        
        cLevel.ASEQuery_AddRule( "Available Vehicles",
                                 NetGameTools.Bool2YesNo(GetAvailableVehicles()) );        
        
        if ( GetAvailableVehicles() )
        {
            nValue = GetVehicleRespawnCntLimit();
            cLevel.ASEQuery_AddRule( "Vehicle Respaws Limit",
                                    (nValue > 0) ? Integer.toString( nValue ): "unlimited" );        
        
            nValue = (int)GetVehicleMinRespawnTime();
            cLevel.ASEQuery_AddRule( "Vehicle Respawn Delay",
                                    (nValue > 0) ? Integer.toString( nValue )+" sec.": "no" );        
            
            nValue = (int)GetVehicleAutoReturnTime();
            cLevel.ASEQuery_AddRule( "Vehicle Auto Return Time",
                                    (nValue > 0) ? Integer.toString( nValue )+" sec.": "off" );        
            
            cLevel.ASEQuery_AddRule( "Vehicles Visible On Map",
                                     NetGameTools.Bool2YesNo(GetVehiclesVisibleOnHudMap()) );        
        }
        
    }
}
