public class NetGameSettingsSMD extends NetGameSettingsIndividual
{
    //co ile zliczamy punkty
    float   _SCORE_UPDATE_TIME                  = 5.0f;
    //czy gracz po smierci nadal moze kontrolowac baze?
    boolean _ALLOW_CONTROL_BY_DEAD_PLAYER       = true;
    //czy stan bazy ma byc pokazywany na mapie
    boolean _BASES_VISIBLE_ON_HUD_MAP           = true;
    
    NetGameSettingsSMD()
    {
        super();
        
        _POINTS_LIMIT                  = 100;
        _TIME_LIMIT_IN_MINUTES         = 30;
        _MIN_RESPAWN_TIME_IN_SECONDS   = 10.0f;
    }
        
    //co jaki czas zliczamy punkty
    private float   m_fScoreUpdateTime = 5.0f; 
    //czy po smierci gracza-ownera dalej zliczmy punkty?
    private boolean m_bAllowDominateByDeadPlayer = false; 
    //czy stan bazy ma byc pokazywana na mapie
    private boolean    m_bBasesVisibleOnHudMap = true;
    
    float   GetScoreUpdateTime(){ return m_fScoreUpdateTime; }
    boolean GetAllowDominateByDeadPlayer(){ return m_bAllowDominateByDeadPlayer; }
    boolean GetBasesVisibleOnHudMap(){ return m_bBasesVisibleOnHudMap;}
    void    SetScoreUpdateTime(float fTime){ m_fScoreUpdateTime = fTime; }    
    void    SetAllowDominateByDeadPlayer(boolean bVal) { m_bAllowDominateByDeadPlayer = bVal; }
    void    SetBasesVisibleOnHudMap(boolean bVal){ m_bBasesVisibleOnHudMap = bVal;}
    
    void Init()
    {
        super.Init();

        SetScoreUpdateTime( _SCORE_UPDATE_TIME );
        SetAllowDominateByDeadPlayer( _ALLOW_CONTROL_BY_DEAD_PLAYER );
        SetBasesVisibleOnHudMap( _BASES_VISIBLE_ON_HUD_MAP );
    }
    
    boolean ApplyModifier(ModifierNetGameSettings cModifier)
    {
        boolean bOk = true;
        
        switch ( cModifier.GetId() )
        {
        case EModifiersNetGameSettings._DOMINATION_SCORE_UPDATE_TIME:
            SetScoreUpdateTime( (float)cModifier.GetIntParam() );
            break;
        case EModifiersNetGameSettings._ALLOW_DOMINATE_BY_DEAD_PLAYER:
            SetAllowDominateByDeadPlayer( cModifier.GetBooleanParam() );
            break;
        case EModifiersNetGameSettings._BASES_VISIBLE_ON_HUD_MAP:
            SetBasesVisibleOnHudMap( cModifier.GetBooleanParam() );
            break;
            
        default:
            bOk = super.ApplyModifier( cModifier );
        }
        
        return bOk;
    }
    
    void SaveSettings()
    {
        super.SaveSettings();
        
        m_cScriptWriter.Write("ScoreUpdateTime("+((int)(GetScoreUpdateTime()))+")");
        m_cScriptWriter.Write("AllowDominateByDeadPlayer("+Bool2String(GetAllowDominateByDeadPlayer())+")");
        m_cScriptWriter.Write("BasesVisibleOnHudMap("+Bool2String(GetBasesVisibleOnHudMap())+")");
    }

    void CopyDataFromContainer()
    {
        super.CopyDataFromContainer();
        
        SetScoreUpdateTime( (float)m_cContainer.UnPackInt() );
        SetAllowDominateByDeadPlayer( m_cContainer.UnPackBoolean() );
        SetBasesVisibleOnHudMap( m_cContainer.UnPackBoolean() );
    }

    void CopyDataToContainer()
    {
        super.CopyDataToContainer();
        
        m_cContainer.PackInt( (int)GetScoreUpdateTime() );
        m_cContainer.PackBoolean( GetAllowDominateByDeadPlayer() );
        m_cContainer.PackBoolean( GetBasesVisibleOnHudMap() );
    }
    
    NetGameRule GetGameRule()
    {
        if ( GetPointsLimit() >-1 && GetGameTimeLimit() > -1 )
        {
            return new NetGameRule( NetGameRule._MSG_PointsAndTime,
                                    GetPointsLimit(),
                                    GetGameTimeLimitInMinutes() );              
        }
        else if ( GetPointsLimit() > -1 )
        {
            return new NetGameRule( NetGameRule._MSG_PointsOnly,
                                    GetPointsLimit() );              
        } 
        else if ( GetGameTimeLimit() > -1 )
        {
            return new NetGameRule( NetGameRule._MSG_TimeOnly,
                                    GetGameTimeLimitInMinutes() );              
        }
        else return null;
    }
}
