public class NetGameVersion
{
    private 
#if MPDEMO2004
    final  static int sm_nCurrentGameVersion = ENetGameVersion._VER_1_02_01;
#else    
    final  static int sm_nCurrentGameVersion = ENetGameVersion._VER_1_02_00;
#endif
    
    static int    Get()            { return sm_nCurrentGameVersion; }
    static String GetShortName()   { return GetShortName( sm_nCurrentGameVersion ); }
    static String GetShortName(int nVal){ return ENetGameVersion.GetShortName( nVal ); }
    static String GetFullName()    { return GetFullName( sm_nCurrentGameVersion ); }
    static String GetFullName(int nVal){ return ENetGameVersion.GetFullName( nVal ); }
    static String GetNumberName()    { return GetNumberName( sm_nCurrentGameVersion ); }
    static String GetNumberName(int nVal){ return ENetGameVersion.GetNumber( nVal ); }
    static String GetNetNumberName()    { return GetNetNumberName( sm_nCurrentGameVersion ); }
    static String GetNetNumberName(int nVal){ return ENetGameVersion.GetNetNumber( nVal ); }
    
    /**
     * Czy wersje sa ze soba kompatybilne?
     */
    static boolean IsVersionCompatible( int nVer1, int nVer2 )
    {
        //jesli sa takie same to tak
        if ( nVer1 == nVer2 )
            return true;
        //jesli naleza do tych nowych co juz 
        //supportuja kompatybilnosc to sprawdzmy
        if ( nVer1 >= ENetGameVersion._FIRST_ALLOW_BACKWARD_COMPATIBILITY_VER )
        {
            //jezeli sa takie same z dokladnoscia do 
            //2 ostatnich pozycji dziesietnych to tak
            if ( (nVer1/100) == (nVer2/100) )
                return true;
        }
        //w kazdym innym przypadku nie.
        return false;
    }
    
    static boolean IsDemo()
    {
        return (Get() == ENetGameVersion._VER_1_02_01);
    }
          
    static boolean IsFullVersion()
    {
        return (!IsDemo());
    }

}
