/** Zawiera niezbedne informacje o mapie (sciezka, wybrany tryb)
 * niezbedne do uruchomienia jej w grze sieciowej...
 * Klasa wykorzystywana w menu
 */
public class NetMapInfo
{
    //nazwa mapy
    private String          m_sMapFile              = "";
    //tryby dostepne dla danej mapy
    private boolean[]       m_aAvailableGameTypes   = new boolean[ ENetGameType.TYPES_COUNT ];
    //wybrany tryb dla danej mapy
    private int             m_nGameType             = ENetGameType.DEFAULT;
        
    NetMapInfo(String sMapFile)
    {
        m_sMapFile = sMapFile;
        
        for (int i = 0; i < m_aAvailableGameTypes.length; i++)
        {
            String       sFileName     = GetScriptFullFileName( i );
            java.io.File cFile         = new java.io.File( sFileName );
                                
            m_aAvailableGameTypes[ i ] = cFile.exists();
        }
    }
    
    boolean SetGameType(int nGameType)
    {
        if (IsGameTypeAvailable(nGameType))
        {
            m_nGameType = nGameType;
            return true;
        }
        return false;
    }

    int    GetGameType()       {     return m_nGameType;    }
    
    String GetFileName()       {     return m_sMapFile;     }
    
    String GetLevelName()
    { 
        int    nSlashPos  = m_sMapFile.lastIndexOf("/");
        int    nExtPos    = m_sMapFile.lastIndexOf(".map");
        return new String( m_sMapFile.substring( nSlashPos+1,nExtPos ) );
    }
    
    String GetLevelPathName()
    {
        int    nSlashPos = m_sMapFile.lastIndexOf("/");
        return new String( m_sMapFile.substring( 0, nSlashPos ) );
    }
    
     
    
    private String GetScriptFullFileName()
    {
        return GetScriptFullFileName( m_nGameType );
    }
    private String GetScriptFullFileName(int nGameType)
    {
        String sLevelPath      = GetLevelPathName();
        String sScriptFileName = ENetGameType.GetScriptFileName( nGameType );
        return sLevelPath + "/" + sScriptFileName;
    }
    
    private boolean IsGameTypeAvailable(int nGameType)
    {
        if ( nGameType < 0 || nGameType >= ENetGameType.TYPES_COUNT )
             return false;
        return m_aAvailableGameTypes[ nGameType ];
    }
        
}
