/** Sprite ktory bedzie reprezentowal jakis obiekt bedacy
 * w jakims zwiazku z graczem (albo jego druzyna)
 */
public class NetHudMapSprite extends Sprite
{
    UIRotorTextNet.RotorTextElementNet m_cCompassElement = null;
    final Vector m_vWorldObjectPos = new Vector();
    boolean m_bRotateOnCompassAndMap = true;
    
    void SetWorldPos(Vector vPos)
    {
        m_vWorldObjectPos.Set(vPos);
    }
    
    Vector GetWorldPosRef()
    {
        return m_vWorldObjectPos;
    }
    
    String m_sTextureName = "CH_P_ikonki.png";
    int m_nTextureSizeX = 256;
    int m_nTextureSizeY = 128;
    
    int m_nTexture = 0;
    
    int m_nTexturePosX = 0;
    int m_nTexturePosY = 0;
    
    int m_nIconSizeX = 17;
    int m_nIconSizeY = 11;
    
    int m_nSizeX = 17;
    int GetCurrentSizeX(){ return m_nSizeX;}
    int m_nSizeY = 11;
    int GetCurrentSizeY(){ return m_nSizeY;}
    
    
    final static int _MODE_UNKNOWN      =  -1;
    final static int _MODE_FREE         =  0;
    final static int _MODE_OWNER        =  1;
    final static int _MODE_ENEMY        =  2;
    final static int _MODE_BLUE         =  3;
    final static int _MODE_RED          =  4;
    final static int _MODE_SPEAKING     =  5;
    final static int _MODE_VEHICLE      =  6;
    final static int _MODE_CNT          =  7;
    
        
    int m_nMode = _MODE_UNKNOWN;
    
    Vector[] m_aModePos = new Vector[_MODE_CNT];
        
    public boolean m_bIsVisibleOutOfBorderCompass = true;
    
    NetHudMapSprite()
    {
        m_aModePos[ _MODE_FREE      ] = new Vector(160,96,0);
        m_aModePos[ _MODE_OWNER     ] = new Vector(128,96,0);
        m_aModePos[ _MODE_ENEMY     ] = new Vector(64,96,0);
        m_aModePos[ _MODE_BLUE      ] = new Vector(96,96,0);
        m_aModePos[ _MODE_RED       ] = new Vector(64,96,0);
        m_aModePos[ _MODE_SPEAKING  ] = new Vector(160,112,0);
    }
    
    void OnCreate()
    {
        m_nSizeX = (int)((float)m_nSizeX * (GetScreenWidth()/ 800f));
        m_nSizeY = (int)((float)m_nSizeY * (GetScreenHeight()/ 600f));
        
		ProcessMouse(false);
        
        m_nTexture = AddTexture( m_sTextureName );
        SetSize(new Vector(m_nSizeX, m_nSizeY, 0));
        UpdateSprite();
        
    }
    
    void OnDestroy()
    {
        if ( m_nTexture != 0 )
            ReleaseTexture( m_nTexture );
    }
    
    void SetMode(int nMode)
    {
        if ( m_nMode == nMode )
            return;
        
        
        
        switch ( nMode )
        {
        case _MODE_FREE:
        case _MODE_OWNER:
        case _MODE_ENEMY:
        case _MODE_BLUE:
        case _MODE_RED:
        case _MODE_SPEAKING:
        case _MODE_VEHICLE:
            m_nMode        = nMode;
            m_nTexturePosX = (int)m_aModePos[ m_nMode ].fX;
            m_nTexturePosY = (int)m_aModePos[ m_nMode ].fY;
            break;
            
        case _MODE_UNKNOWN:
        default:
            m_nMode        = _MODE_UNKNOWN;
            m_nTexturePosX = 0;
            m_nTexturePosY = 0;
        }
        
        UpdateSprite();
    }

    
    boolean CanBeVisible()
    {
        return (m_nMode!=_MODE_UNKNOWN);
    }
    
    void UpdateSprite()
    {
        SetTexture( m_nTexture, 
            new Rect( (float) m_nTexturePosX/m_nTextureSizeX, 
                      (float) m_nTexturePosY/m_nTextureSizeY, 
                      (float)(m_nTexturePosX+m_nIconSizeX)/m_nTextureSizeX, 
                      (float)(m_nTexturePosY+m_nIconSizeY)/m_nTextureSizeY));

        if (m_cCompassElement != null)
            m_cCompassElement.UpdateTexture(this);
    }
    
    public void Hide()
    {
        super.Hide();
        if (m_cCompassElement != null)
            m_cCompassElement.Hide();
    }
    
    public void Show()
    {
        super.Show();
        if (m_cCompassElement != null)
            m_cCompassElement.Show();
    }

    public void SetRotation(float fRotation)
    {
        if (m_bRotateOnCompassAndMap)
            super.SetRotation(fRotation);
    }
        
}
