public class HUDNetAdminMessage extends HUDNetIncomingMessage
{
    {
        nMaxTexts = 4;
        m_sIncomingTextClass = "IncomingAdminText";
    }
    
    public void OnCreate()
    {
        super.OnCreate();
        
        cBkg.SetAlpha(1);
    }
    
    Vector GetInitialPos()
    {

        float fScreenW = GetScreenWidth();
        float fScreenH = GetScreenHeight();

        return new Vector(
                        (fScreenW    - GetInitialSize().fX)/2f, 
                        (fScreenH/2f - GetInitialSize().fY)/2f, 
                        0
                        );
    }
    
    void SetText( String sTxt )
    {
        super.SetText(sTxt, new Vector(1,1,1));
    }
    
    void CheckTextsTime()
    {
        if ( m_byStatus != HUDNetManager._STATUS_STARTED )
            return;
    
        float   fTimeNow = GetTime();
        boolean bHide    = false;
        
        for ( int i=nMaxTexts-1; i>=0; i--)
        {
            if ( m_aTexts[i].ShouldExpire( fTimeNow ) )
            {
                m_aTexts[i].Expire();
                bHide = true;
            }
        }
        if ( bHide )
        {
            InitText();
            Refresh();
            if ( ((IncomingAdminText)m_aTexts[0]).bExpiredAdmin && !GetKeyState(EGameControl.SHOW_ADMIN_MESSAGES))
                Deactivate();
        }
    }
    
}

class IncomingAdminText extends IncomingText
{
    boolean bExpiredAdmin = false;
    //message admina maja sie nie kasowac, jedynie okno ma sie ukrywac
    void Expire(){bExpiredAdmin = true;}
    
    void SetTextAndTime( String sTxt, float fT, Vector vCol, boolean bExp )
    {
        super.SetTextAndTime( sTxt, fT, vCol, bExp );
        bExpiredAdmin = bExp;
    }
    
}