public class HUDNetConnectionStatus extends HUDComponentNet
{
    
    UIWindow m_cIcon = null;
    
    String m_sScriptName = "data/hudnet/HUDNetConnectionStatus.scr";
    float m_fFlashPeriod = 0.35f;
    
    public void OnCreate()
    {
        super.OnCreate();
  
        Load(GetModule(), m_sScriptName, false);
        
    }
    
    public void SetConnectionStatus(byte nStatus)
    {
        switch(nStatus)
        {
        case ConnectionStatusManager._STATUS_OK:
            HideIcon();
            break;
        case ConnectionStatusManager._STATUS_WARNING:
            FlashIcon();
            break;
        case ConnectionStatusManager._STATUS_ERROR:
            ShowIcon();
            break;
        case ConnectionStatusManager._STATUS_CRITICAL_ERROR:
            //moze jakis dzwiek?
            ShowIcon();
            break;
        }
    }
    
    public void OnInit()
    {
        super.OnInit();
        m_cIcon = GetElem("ID_CONNECTION_PROBLEM_ICON");
        //CrashLog("ICON " + m_cIcon);
                 
    }
    
        
    void HideIcon()
    {
        m_cIcon.Hide();
        DisableCallMethod("FlashIcon");
    }
    
    void FlashIcon()
    {
        if (m_cIcon.IsVisible())
            m_cIcon.Hide();
        else
            m_cIcon.Show();
                
        CallMethodIn("FlashIcon", m_fFlashPeriod);
    }
    
    void ShowIcon()
    {
        m_cIcon.Show();
        DisableCallMethod("FlashIcon");
    }
    
    public void Deactivate()
    {
        super.Deactivate();
        HideIcon();
    }
    
    public void Activate()
    {
        super.Activate();
        Show();
        HideIcon();
    }
    
}
