
public class HUDNetIncomingMessage extends HUDComponentNet
{
    IncomingText m_aTexts[] = null;
    Sprite cBkg = null;
    
    //ilosc lini z tekstem
    int nMaxTexts = 6;
    int nBkgTex = 0;
    
    int METHOD_MoveTop = 0;
    
    String m_sIncomingTextClass = "IncomingText";
    
    public void OnCreate()
    {
        METHOD_MoveTop = RegisterCallMethod("MoveTop");
            
        nHUDCompWidth  = _HUD_NET_MAIN_WIDTH;
	    nHUDCompHeight = _HUD_NET_MAIN_HEIGHT;
        nHUDCompPosX   = GetScreenWidth()/2 - nHUDCompWidth/2;
	    nHUDCompPosY   = GetScreenHeight()/2 - nHUDCompHeight/2;
        nHUDCompPosY   =_HUD_NET_MAIN_POS_Y;
        
        int nDeltaY    = GetScreenHeight() - 480;
                        
        m_aTexts = new IncomingText[ nMaxTexts ];
        Vector vPos = GetInitialPos();
        Vector vSize = GetInitialSize();
        
        cBkg = (Sprite)CreateObject("Sprite");
        AddSprite(cBkg);
        nBkgTex = cBkg.AddTexture("data/hud/ch_p_hud.png");
        cBkg.SetFrameTexture(nBkgTex, new Rect(297f/1024f,465f/512f,307f/1024f,475f/512f),3,3);
        cBkg.SetName("INCOMING_BKG");
        cBkg.SetAlpha(0.33f);
                             //new Rect(297f/1024f,423f/512f,307f/1024f,433f/512f),3,3);
        cBkg.SetPos(vPos);
        cBkg.SetSize(vSize);
        cBkg.MoveTop();
        
        for ( int i = m_aTexts.length - 1; i >= 0; i-- )
        {
            m_aTexts[i] = (IncomingText)CreateObject(m_sIncomingTextClass);
            m_aTexts[i].DisplayText(" ");
            vSize.fY = m_aTexts[i].GetTextExtent().fY;
            m_aTexts[i].SetSize( vSize);
            m_aTexts[i].DisplayText("");
            m_aTexts[i].SetPos(new Vector(vPos));
            m_aTexts[i].SetTextPosFlags(ESpriteText.HORIZ_LEFT);
            vPos.fY += vSize.fY;
            AddSprite( m_aTexts[i] );        
        }
        
        cBkg.SetSize(new Vector(vSize.fX/* + 10*/, (vPos.fY - cBkg.GetPos().fY) + 3, 0));
        cBkg.SetPos(new Vector(cBkg.GetPos().fX - 5, cBkg.GetPos().fY, 0));
        InitText();
    }
    
    Vector GetInitialPos()
    {
        HUDNetMain cStats = (HUDNetMain)m_cHudNetManager.m_aHUDComponentNet[HUDNetManager._STATISTICS];
        return cStats.m_cMessagesWnd.GetPos();
    }
    
    Vector GetInitialSize()
    {
        HUDNetMain cStats = (HUDNetMain)m_cHudNetManager.m_aHUDComponentNet[HUDNetManager._STATISTICS];
        return cStats.m_cMessagesWnd.GetSize();
    }
    
    float fOutgoingMsgSizeMinus = 120.0f;
    
    Vector GetOutgoingMsgPos()
    {
        //return new Vector(cBkg.GetPos().fX + 5, cBkg.GetPos().fY + cBkg.GetSize().fY + 10, 0);
        //return new Vector(cBkg.GetPos().fX + 5, cBkg.GetPos().fY + cBkg.GetSize().fY + 3, 0);
        return new Vector(cBkg.GetPos().fX + 5 + (fOutgoingMsgSizeMinus/2), 
                          cBkg.GetPos().fY + cBkg.GetSize().fY + 3, 
                          0);
    }
    
    float GetOutgoingMsgSizeX()
    {
        return m_aTexts[0].GetSize().fX - fOutgoingMsgSizeMinus;    
    }
    
    Vector GetSystemMsgPos()
    {
        return new Vector(cBkg.GetPos().fX + 5, cBkg.GetPos().fY - m_aTexts[0].GetSize().fY - 5, 0);
    }
    
    float GetSystemMsgSizeX()
    {
        return m_aTexts[0].GetSize().fX;    
    }
    
    public void OnDestroy()
    {
        if ( m_aTexts != null )
        {
            for ( int i=0; i<m_aTexts.length; i++ )
            {
                RemoveSprite( m_aTexts[i] );
                m_aTexts[i].delete();
                m_aTexts[i] = null;
            }
            m_aTexts = null;	 
        }
        if (cBkg != null)
        {
            cBkg.ReleaseTexture(nBkgTex);
            RemoveSprite(cBkg);
            cBkg.delete();
            cBkg = null;
        }
    }
        
    /**
     * Metoda aktywujaca huda pokryta,
     * aby mozna bylo zagwarantowac ze hud
     * bedzie sie "wyciagal" na wierzch
     * Rozwiazanie tymczasowe
     * TODO: zrobic to jakos inaczej
     */    
    public void Activate()
    {
        if (!HUDNetManager.s_bCanActivateIncommingMsg)
            return;
        super.Activate();
        DisableCallMethod( METHOD_MoveTop );
        CallMethodEvery( METHOD_MoveTop, 1.0f );
    }
    
    public void Deactivate()
    {
        super.Deactivate();   
        DisableCallMethod( METHOD_MoveTop );
    }
    
    /** metoda wyswietlajaca tekst
     */
    public void Draw()
    {
        Show();
        MoveTop();
        cBkg.Show();
        for ( int i=0; i<nMaxTexts; i++ )
        {
            m_aTexts[i].Show();
        }
    }
    
    public void MoveTop()
    {
        super.MoveTop();
        cBkg.MoveTop();
        for ( int i=0; i<nMaxTexts; i++ )
        {
            m_aTexts[i].MoveTop();
        }
    }
    
    /** metoda deaktywujaca HUD'a z NetStatsami
     */
    public void HideAll()
    {
        Hide();
        cBkg.Hide();
        for ( int i=0; i<nMaxTexts; i++ )
            m_aTexts[i].Hide();
        
    }
         
    boolean InitText()
    {
        for ( int i=0; i<nMaxTexts; i++ )
            m_aTexts[i].InitText();
        return true;
    }
        
    void SetText( String sTxt, Vector vColor )
    {
        MoveTop();
        Sprite cTest = m_aTexts[ 0 ];
        cTest.SetTextPosFlags(ESpriteText.MULTILINE);
        String sTab[] = cTest.GetTextLines( sTxt );
		for (int i = 0; i < sTab.length; i++)
		{
            for ( int j=nMaxTexts-1; j>0; j--)
                m_aTexts[ j ].SetTextAndTime( m_aTexts[ j-1 ] );
            m_aTexts[ 0 ].SetTextAndTime( sTab[i], GetTime(), vColor );
		}
    }
    
    void ShowHistory()
    {
        for ( int i=0; i<m_aTexts.length; i++ )
            if ( m_aTexts[i] != null )
            {
                 m_aTexts[i].RefreshTime( GetTime() );
                 if ( m_aTexts[i].IsExpired() )
                 {
                    m_aTexts[i].Restore();
                    return;
                 }
            }
    }
    
    void SetStatus(byte byStatus)
    {
        super.SetStatus( byStatus );
        
        if ( byStatus == HUDNetManager._STATUS_STARTED )
        {
            for ( int i=0; i<m_aTexts.length; i++ )
                if ( m_aTexts[i] != null )
                     m_aTexts[i].RefreshTime( GetTime() );
        }
    }
        
    
    void CheckTextsTime()
    {
        if ( m_byStatus != HUDNetManager._STATUS_STARTED )
            return;
    
        float   fTimeNow = GetTime();
        boolean bHide    = false;
        
        for ( int i=nMaxTexts-1; i>=0; i--)
        {
            if ( m_aTexts[i].ShouldExpire( fTimeNow ) )
            {
                m_aTexts[i].Expire();
                bHide = true;
            }
        }
        if ( bHide )
        {
            InitText();
            Refresh();
            if ( m_aTexts[0].IsExpired() )
                Deactivate();
        }
    }
}



class IncomingText extends NetHudTextSprite
{
    static float _DISPLAY_TIME = 10.0f;
        
    // czas wyswietlenia tekstu
    float fTime      = 0.0f;
    
    private boolean bExpired = false;
    boolean IsExpired() { return bExpired; }
    void    Expire()    { bExpired = true; }
    void    Restore()   { bExpired = false;}
    
    void OnCreate()
    {
        super.OnCreate();
        SetFont(ChromeFonts.FONT_HINT);
    }
      
    
    
    void SetTextAndTime( IncomingText cSource )
    {
        SetTextAndTime( cSource.sText, 
                        cSource.fTime, 
                        cSource.vColor,
                        cSource.bExpired );
    }
    
    
    void SetTextAndTime( String sTxt, float fT, Vector vCol, boolean bExp )
    {
        sText    = sTxt;
        fTime    = fT;
        vColor   = vCol;
        bExpired = bExp;
    }
    void SetTextAndTime( String sTxt, float fT, Vector vCol )
    {
        SetTextAndTime( sTxt, fT, vCol, false );
    }
    
    void RefreshTime(float fT)
    {
        if ( sText != null )
            fTime   = fT;
    }

    boolean ShouldExpire( float fTimeNow )
    {
        return (sText != null && fTime < (fTimeNow-_DISPLAY_TIME));
    }
    
    
    
    void InitText()
    {
        if ( bExpired )
            DisplayText("");        
        else
            super.InitText();
    }
}
    
