public class HUDNetSystemMessage extends HUDComponentNet
{
    /**
     * 
     */
    String sText     = null;
    
    // Sprite z tekstem
    Sprite cSprText = null;
    
    Sprite cBkg = null;
    int nBkgTex = 0;
    
    HUDNetIncomingMessage m_cHudIncomingMsg = null;
    
    public void OnCreate()
    {
        Vector vPos = m_cHudIncomingMsg.GetSystemMsgPos();
        Vector vSize = new Vector(m_cHudIncomingMsg.GetSystemMsgSizeX(), 0, 0);
        
        cBkg = (Sprite)CreateObject("Sprite");
        AddSprite(cBkg);
        nBkgTex = cBkg.AddTexture("er_t_black.png");
        cBkg.SetTexture(nBkgTex, Rect.WHOLE_TEX);
        cBkg.SetName("SYSTEM_BKG");
        cBkg.SetAlpha(0.4f);
        
        super.OnCreate();
        cSprText = (Sprite)CreateObject("Sprite");
        cSprText.SetFont(ChromeFonts.FONT_HUD_BIGGER);
        cSprText.SetTextPosFlags(ESpriteText.CENTER);
        cSprText.SetNoTexture();
		cSprText.ProcessMouse(false);
        cSprText.DisplayText(" ");
        cSprText.SetSize(new Vector(vSize.fX, cSprText.GetTextExtent().fY,0));
        cSprText.DisplayText("");
        cSprText.SetPos(vPos);
        AddSprite(cSprText);        
        
        cBkg.SetSize(new Vector(vSize.fX + 10, cSprText.GetSize().fY + 3 , 0));
        cBkg.SetPos(new Vector(vPos.fX - 5, vPos.fY, 0));
        
        cBkg.MoveTop();        
        InitText();
    }
    
        
//-------------------------------------------------------------------------------
    public void OnDestroy()
    {
        if ( cSprText != null )
        {
            RemoveSprite( cSprText );
            cSprText.delete();
            cSprText = null;	 
        }
        
        if (cBkg != null)
        {
            cBkg.ReleaseTexture(nBkgTex);
            RemoveSprite(cBkg);
            cBkg.delete();
            cBkg = null;
        }
    }

    /** metoda wyswietlajaca tekst
     */
    public void Draw()
    {
        cBkg.MoveTop();
        cBkg.Show();
        cSprText.MoveTop();
        cSprText.Show();
        
    }
    
    public void Hide()
    {
        cBkg.Hide();
        cSprText.MoveTop();
        cSprText.Hide();
    }
    
    public void MoveTop()
    {
        super.MoveTop();
        cBkg.MoveTop();
        cSprText.MoveTop();
    }
    
//------------------------------------------------------------------    
         
    boolean InitText()
    {
        if ( sText == null )
            sText = "";
            
        cSprText.DisplayText( sText );   
        
        return true;
    }
        
    void SetText( String sTxt )
    {
        sText = sTxt;
    }
    
    String GetText()
    {
        return sText;
    }
    
}
