public class HUDNetStatisticsDM extends HUDNetStatistics
{
    final static String _COL_TEXTS[] = {"&NetHudStatsCH_Nick&",
                                        "&NetHudStatsCH_Frags&",
                                        "&NetHudStatsCH_Deaths&",
                                        "&NetHudStatsCH_Ping&"};
    final static int    _COL_WIDTH[] = { 50,    50 ,    50,      50   };
    final static int    _COL_POS  [] = { 50,    170,    260,     400  };
    
    {
        m_sScriptName = "data/hudnet/HUDNetStatisticsDM.scr";
    }
    
    void InitializeStatistics()
    {
        super.InitializeStatistics();
        
        SetTitle("&NetGameNameDM&");
    }
    
    void UpdateStatistics()
    {
        if ( m_cNetGameInfo == null)
            return;
         
        NetPlayerInfoList cPlayerInfoList = m_cNetGameInfo.GetPlayerInfoList();
        
        if ( cPlayerInfoList == null )
            return;
        
        cPlayerInfoList.Sort();

        java.util.Vector vPlayers = new java.util.Vector();
        
        for (int i = 0; i < cPlayerInfoList.GetSize(); i++)
        {
            NetPlayerInfo cPlayerInfo = cPlayerInfoList.GetPlayerByIndex( i );
            if (cPlayerInfo != null)
                vPlayers.addElement(cPlayerInfo);
        } 
        
        UpdateTeam(0, null, vPlayers);
    }
    
    void InitColumns()
    {
        m_tColumns = new UIStatic[5];
        m_tColumns[0] = (UIStatic)GetElem("ID_COLUMN_PLACE");
        m_tColumns[1] = (UIStatic)GetElem("ID_COLUMN_NICK");
        m_tColumns[2] = (UIStatic)GetElem("ID_COLUMN_FRAGS");
        m_tColumns[3] = (UIStatic)GetElem("ID_COLUMN_DEATHS");
        m_tColumns[4] = (UIStatic)GetElem("ID_COLUMN_PING");
    }
    
    void SetRow(int nPlace, UIControlObject cRow, float fAlpha, NetPlayerInfo cPlayer)
    {
        cRow.Show();
        if (cPlayer != null)
        {
            Vector vColor = HUDNetManager.GetColorForPlayerInfo( cPlayer );
            SetRow(cRow, vColor, fAlpha, 1,
                   String.valueOf(nPlace), 
                   cPlayer, 
                   String.valueOf(cPlayer.GetFrags()), 
                   String.valueOf(cPlayer.GetDeaths()),
                   String.valueOf(cPlayer.GetLatencyAndLoss()));
        }
        else
        {
            Vector vColor = new Vector(1,1,1);
            SetRow(cRow, vColor, fAlpha, 1, "...", "...", "...", "...", "...");
        }
    }
    
    void SetRow(UIControlObject cRow, Vector vColor, float fAlpha, float fFontScale, String sPlace, NetPlayerInfo cPlayer, String sFrags, String sDeaths, String sPing)
    {
        SetElemText((UIStatic)cRow.GetElem("_PLACE"), sPlace, vColor, fAlpha, fFontScale);
        UIStatic cNick = (UIStatic)cRow.GetElem("_NICK");        
        SetElemText(cNick, cPlayer.GetNickClamped(cNick), vColor, fAlpha, fFontScale);
        SetElemText((UIStatic)cRow.GetElem("_FRAGS"), sFrags, vColor, fAlpha, fFontScale);
        SetElemText((UIStatic)cRow.GetElem("_DEATHS"), sDeaths, vColor, fAlpha, fFontScale);
        SetElemText((UIStatic)cRow.GetElem("_PING"), sPing, vColor, fAlpha, fFontScale);
    }
    
     void SetRow(UIControlObject cRow, Vector vColor, float fAlpha, float fFontScale, String sPlace, String sNick, String sFrags, String sDeaths, String sPing)
    {
        SetElemText((UIStatic)cRow.GetElem("_PLACE"), sPlace, vColor, fAlpha, fFontScale);
        SetElemText((UIStatic)cRow.GetElem("_NICK"), sNick, vColor, fAlpha, fFontScale);
        SetElemText((UIStatic)cRow.GetElem("_FRAGS"), sFrags, vColor, fAlpha, fFontScale);
        SetElemText((UIStatic)cRow.GetElem("_DEATHS"), sDeaths, vColor, fAlpha, fFontScale);
        SetElemText((UIStatic)cRow.GetElem("_PING"), sPing, vColor, fAlpha, fFontScale);
    }
}
