public class HUDMapTeam extends HUDMapNet
{
    static float _SPEACH_ICON_TIME = 1.5f;
        
    void ComputePlayersPos()
    {
        ComputePlayerPos();
        ComputePlayersPosTeam();
    }
    
    void ComputePlayersPosTeam()
    {
        int nPlayerSpriteIndex = 0;
        
        //TODO: czy trzeba wyciagac z modulu gameinfo?
        NetGameInfo cGameInfo = cModule instanceof ModuleNet ?
                                ((ModuleNet)cModule).GetGameInfo() :
                                null;
        
        NetGameSettingsTeam cGameSettings = cGameInfo instanceof NetGameInfoTeam ?
                                            ((NetGameInfoTeam)cGameInfo).GetGameSettingsTeam() :
                                            null;
        
        if ( cGameSettings              == null  ||
             cGameSettings.IsValid()    == false )
        {
            HideRemainingPlayers( nPlayerSpriteIndex );
            return;
        }
        
        boolean bFriendsVisible = cGameSettings.GetFriendsVisibleOnHudMap();
        boolean bEnemiesVisible = cGameSettings.GetEnemiesVisibleOnHudMap();

        if ( !bFriendsVisible && !bEnemiesVisible )
        {
            HideRemainingPlayers( nPlayerSpriteIndex );
            DisableCallMethod( METHOD_ComputePlayersPos );
            return;
        }
        
        
        NetPlayerInfoList cPlayersList = cGameInfo.GetPlayerInfoList();
        if ( cPlayersList == null )
        {
            HideRemainingPlayers( nPlayerSpriteIndex );
            return;
        }
        
        boolean bRedVisible  = true;
        boolean bBlueVisible = true;
        
        NetPlayerInfo cMyPlayerInfo = cPlayersList.GetMyPlayer();
        if ( cMyPlayerInfo != null )
        {
            switch ( cMyPlayerInfo.GetTeamId() )
            {
            case NetTeamInfo.BLUE:
                bBlueVisible = bFriendsVisible;
                bRedVisible  = bEnemiesVisible;
                break;
                
            case NetTeamInfo.RED:                   
                bRedVisible  = bFriendsVisible;
                bBlueVisible = bEnemiesVisible;
                break;
            
            default:
                //przed podlaczeniem do druzyny widzimy wszystkich
                //TODO: tak ma byc?
            }
        }
        else
        {
            //na serwerze dedykowanym widzimy wszystkich
            //TODO: tak ma byc?
        }
            
        
        
                
        for ( int i=0; i<cPlayersList.GetSize() && nPlayerSpriteIndex < m_aPlayers.length; i++ )
        {
            NetPlayerInfo cPlayerInfo = cPlayersList.GetPlayerByIndex( i );
            
            //swojego omijamy
            if ( cPlayerInfo == null || cPlayerInfo == cMyPlayerInfo )
                continue;
            
            PlayerNet cPlayer = cPlayerInfo.GetPlayer();
            if ( cPlayer             == null ||
                 cPlayer.IsSpawned() == false )
                continue;
            
            HudNetMapSpritePlayer cPlayerSprite = m_aPlayers[ nPlayerSpriteIndex ];
            switch ( cPlayerInfo.GetTeamId() )
            {
            case NetTeamInfo.BLUE:
                if ( ! bBlueVisible )
                    continue;

                if (cPlayer.m_bJustSpoken ||
                    (cPlayerSprite.m_nMode == HudNetMapSpritePlayer._MODE_SPEAKING && 
                     GetTime() < cPlayer.m_fJustSpokenTime + _SPEACH_ICON_TIME))
                {
                    cPlayer.m_bJustSpoken = false;
                    cPlayerSprite.SetMode( HudNetMapSpritePlayer._MODE_SPEAKING );
                }
                else
                    cPlayerSprite.SetMode( HudNetMapSpritePlayer._MODE_BLUE );
                
                break;
                
            case NetTeamInfo.RED:                   
                if ( ! bRedVisible )
                    continue;
                if (cPlayer.m_bJustSpoken ||
                    (cPlayerSprite.m_nMode == HudNetMapSpritePlayer._MODE_SPEAKING && 
                     GetTime() < cPlayer.m_fJustSpokenTime + _SPEACH_ICON_TIME))
                {
                    cPlayer.m_bJustSpoken = false;
                    cPlayerSprite.SetMode( HudNetMapSpritePlayer._MODE_SPEAKING );
                }
                else
                    cPlayerSprite.SetMode( HudNetMapSpritePlayer._MODE_RED );
                break;
            
            default:
                continue;
            }
            
            ComputeSpritePos( cPlayerSprite, cPlayer.GetPosition() );
            ComputeSpriteRotation( cPlayerSprite, 
                                   cPlayer.GetForwardVector(), 
                                   cPlayer.GetRightVector() );
            
            if (m_bPlayerPosVisible)
                cPlayerSprite.Show();
            else
                cPlayerSprite.Hide();
            
            nPlayerSpriteIndex++;
        }
        
        
        HideRemainingPlayers( nPlayerSpriteIndex );
    }
    
    boolean CanShowVehicle(Vehicle cVehicle, NetGameSettings cGameSettings)
    {
        return CanShowVehicleTeam( cVehicle, cGameSettings );
    }
    
    boolean CanShowVehicleTeam(Vehicle cVehicle, NetGameSettings cGameSettings)
    {
        Pawn []tOccupants = cVehicle.GetAllOccupants();
        
        boolean bFriendsVisible = ((NetGameSettingsTeam)cGameSettings).GetFriendsVisibleOnHudMap();
        boolean bEnemiesVisible = cGameSettings.GetEnemiesVisibleOnHudMap();
        
        //czy sa pasazerowie
        if (tOccupants != null && tOccupants.length > 0)
        {
            boolean bEnemyIn = false;//czy w pojezdzie sa wrogowie
            for (int i = 0; i < tOccupants.length; i++)
            {
                NetPlayerInfo cInfo = ((PlayerNet)tOccupants[i]).GetPlayerInfo();
                if (cInfo.GetTeamId() == ((PlayerNet)cPlayer).GetPlayerInfo().GetTeamId())
                {
                    if (bFriendsVisible)
                        return true;//ktos z twojego teamu
                }
                else
                {
                    bEnemyIn = true;
                }
            }
            //sa wrodzy pasazerowie
            return bEnemiesVisible && bEnemyIn;
        }
        return true;
    }
}
