import java.util.*;

/** UWAGA obiekt modulu nie jest obiektem replikowanym !!!!!!!!!!!!!!!!!!!!!!
 * Oznacza to, ze nie mozna dodawac mu replikacji zmiennych, wysylac i odbierac z
 * niego messagey. Zadanie to zostalo przeniesione na klase NetGameInfo poprzez
 * obiekt cGameInfo.
 */
public class ModuleNet extends ModuleNetBaseQuery
{
    /** TODO: tylko do testow, przyspieszenie gry
     */
    static float sm_m_fTimerSpeedUp = 1.0f;
    
    public boolean m_bIsActive = false;
    
    static final String sm_sMapDir = "Data/LevelsNet/";    
    
    PrecacheNet m_cPrecache = null;
        
    /** CLIENT i jego zabawki
     */
    
    // czas timeout proby polaczenia
    final static int MAX_TIME_OUT = 120;
    final static int WAIT_TIME    = 5;
    // licznik sekund do konca proby polaczenia
    static int nTimeOutCounter    = MAX_TIME_OUT;
    
    // czy bedzie nastepny level ?
    final static int LEVEL_UNDEF    =-1;
    final static int LEVEL_NEXT     = 0;
    final static int LEVEL_END      = 1;
    final static int LEVEL_DEF      = 2;
    // aktualny stan 
    int nNextLevelState = LEVEL_UNDEF;

    static ModuleNet sm_cCurrentLevel = null;

    private static boolean sm_bGameIsGoing = false;
    
    static boolean IsGameGoing(){ return sm_bGameIsGoing; }
    static void    GameIsGoing(boolean bVal){ sm_bGameIsGoing = bVal; }
        
    NetProfiler m_cNetProfiler = null;
        
    /**
     * Czy w danej chwili level ma wylaczone renderowanie
     * (np gdy gra jest w systemie menu)
     */
    private boolean m_bRenderingDisabled = true;

    
    ///////////////////////////////////////////////////////////////////////////
    /** Obiekty, na ktorych ma byc robiona interpolacja pozycji do renderingu
     */
    LinkedList m_CorrectOnRenderList = new LinkedList();    
    
    int METHOD_ServerLoadNextLevel = 0;
    
    public void OnCreate()
    {   
        METHOD_ServerLoadNextLevel = RegisterCallMethod( "ServerLoadNextLevel" );
        
        
        super.OnCreate();
        
        sm_bGameIsGoing  = true;
        sm_cCurrentLevel = this;
               
        
        InvObject.CleanGlobalChangeInvStateCounter();
        Weapon.CleanGlobalChangeAmmoCounter();
        Ammo.CleanGlobalChangeCountCounter();
        PlayerNetBase.CleanGlobalChangeSkinCounter();
        PlayerNetBaseDriver.CleanGlobalDriverCounter();
        DeadBody.CleanGlobalDeadBodyCounter();
        DestroyableNet.CleanGlobalDestroyableStateCounter();
        Vehicle.CleanGlobalVehicleStateCounter();
        DestroyableNet.CleanGlobalDestroyableStateCounter();
        NetGameInfoASSAULT.CleanGlobalRoundCounter();
        NetGameSettingsBase.CleanGlobalCounter();
        NetPlayerInfo.CleanGlobalChangeNickCounter();
            
        m_cNetProfiler = (NetProfiler)CreateObject("NetProfiler");
        
        // zasieg widocznosci obiektow
        //SetObjectsVisibilityRange( 15000.0f, 25000.0f );
        
        TimerSetForceFromGameTimer( true );
        SetPhUpdateGranularity( PlayerNet.sm_fPhysicsGranularity );
        
        // rejestracja Messager'a
        RegisterMessager();
        
        //TODO: moze jakos inaczej "ladniej" zalatwic ta sprawe?
        HUDManager._DETECTOR_IS_AVAILABLE = false;
                
        // wrzucamy ekran PRECACHING
        //MK: przeniesione do OnPostCreate()
        
        // by Czesiu
        IsLeaning2_();
    }
    
    public void OnPostCreate()
    {
        //GameObject.SendClientAliveSignal();
        
        // wrzucamy ekran PRECACHING
        m_cPrecache = ((PrecacheNet)CreateObject("PrecacheNet"));
        ForceRender();
        
        super.OnPostCreate();
        
        InitObjectives();
        
        InitNetwork();
        
        //TODO: czy to na pewno i na serwerze i kliencie?
        SetSimulateAllObjects( true );
        // wylaczamy renderowanie na serwerze dedykowanym
        if ( AmIDedicatedServer() )
            SetRenderSpritesOnly( true );
        else
            EnableGameRendering( true );
    }
    
    void InitObjectives()
    {
        super.InitObjectives();
        
        //ObjectiveManager tu startuje tylko na serwerze,
        //na kliencie dopiero po odebraniu danych z serwera
        if (Role == ERole._AUTHORITY)
            m_ObjectivesManager.StartOnServer();
    }
   

    void InitNetwork()
    {
        super.InitNetwork();
        
        // na koncu pochwalmy sie za pomoca broadkasta ze jestesmy serwerem
        if (Role == ERole._AUTHORITY)
        {
            if (bTestBroadcast)
            {
                //LogR(" TestBroadcast\n");
                for ( int i=0; i<10; i++ )
                    FreeMsgSendIAmServer(EFreeMsg._I_AM_SERVER_2);
            }    
            //CallMethodEvery( "FreeMsgSendIAmServer", 5.0f );
            //CallMethodEvery( "FreeMsgSendFindServer", 5.0f );
        }
    }

    /** Kasujemy wszystko co bylo w obiekcie
     */
    public void OnDestroy()
    {
        if (m_cPrecache != null)
        {
            m_cPrecache.delete();
            m_cPrecache = null;
        }
        sm_bGameIsGoing = false;
        
        // wylaczamy odbieranie wiadomosci
        //CrashLog("[ModuleNet::OnDestroy] UnregisterMessager()\n");
        UnregisterMessager();      
        
        if ( m_cNetProfiler != null )
        {
            m_cNetProfiler.delete();
            m_cNetProfiler = null;
        }
        
        if ( m_cGameInfo != null )
            m_cGameInfo.ShutdownGame();
        
        if (Role < ERole._AUTHORITY)
        {
            // odlaczamy sie od gry, bo jestesmy klientem
            DisconnectFromServer();
        }
        else
        {
            // w pierwszej kolejnosci usypiamy server
            ShutdownServer();
            //DisableCallMethod("->MasterServerHeartBeat" );
        }
    
        if (m_CorrectOnRenderList != null)
        {
            m_CorrectOnRenderList.clear();
            m_CorrectOnRenderList = null;
        }
        //usuwamy wszystkie zaladowane materialy
        //TODO: pousuwac tylko te materialy ktore zostaly zaladowane na levelu
        //MaterialFreeAll();
            
        super.OnDestroy();
    }

    /** Called when command from dedicated server console is entered,
     */
    public void OnNetConsoleCommand(String sCommand)
    {
        if ( GetGameInfo() != null )
            GetGameInfo().LocalEventTypedCommand( sCommand );
    }
    
    
    //////////////////////////////////////////////////////////////////

    void OnActivate()
    {
        //CrashLog("Activating module\n");
        
        //przywracamy renderowania levelu, jesli zostalo wylaczone
        if ( m_bRenderingDisabled )
        {
            //TODO
        }
        
        RegisterKeyRequest();
        if (GetMainPlayer() != null)
            GetMainPlayer().GameActivatedFromMenu();
    }
    
    void OnDeactivate()
    {
        //CrashLog("Deactivating module\n");
        
        UnregisterKeyRequest();
        if (GetMainPlayer() != null)
            GetMainPlayer().GameDeactivatedToMenu();
    }
        
        
    public void Activate()
    {
        if (GetMainPlayer() != null && 
            ((m_InventoryWindow != null && !m_InventoryWindow.IsVisible()) || m_InventoryWindow == null))
            GetMainPlayer().GameActivatedFromMenu();
                
        if ( AmIDedicatedServer() )
            SetRenderSpritesOnly( true );
        else
            EnableGameRendering( true );
        
        if (!m_bIsActive)
        {
            super.Activate();
            m_bIsActive = true;
        }
        
    }
    
    public void Deactivate()
    {
        if (m_bIsActive)
        {
            super.Deactivate();
            m_bIsActive = false;
        }
    }
            
    void ReturnFromMenu()
    {
        RegisterKeyRequest();
        EnableInputs( true );
    }
    
    /** Obsluga klawiszy niezalezna od wszystkiego
     */
	void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
        if (bKeyState)
        {
            if (nKeyCode==EKey._ESCAPE)
            {
                int nActiveHUDMenu = -1;
                
                if ( GetMainPlayer() != null )
                {
                    nActiveHUDMenu = ((HUDManager)((PlayerHUD)GetMainPlayer()).HUD).m_nActiveHudMenu;
                }
                
                if (nActiveHUDMenu != -1)
                {
                    ((HUDManager)((PlayerHUD)GetMainPlayer()).HUD).DeactivateCurMenu();
                }
                else
                {
                    // koniec gry - wracamy do menu
                    if ( cMenu != null )
                    {
                        cMenu.ActiveLevelReturnValue = ChromeModule._LEVEL_INPROGRESS;
                        
                        //Deactivate();
                        //TODO: tylko wylaczyc renderowania
                        //TODO: wylaczyc dzwieki
                        m_bRenderingDisabled = true;
                        SetRenderSpritesOnly(true);
                                                
                        Player cPlayer = GetMainPlayer();
                        if (cPlayer != null)
                            cPlayer.GameDeactivatedToMenu();
                        UnregisterKeyRequest();
                        EnableInputs( false );
                        
                        cMenu.Activate();
                    }
                    else
                    {
                        ExitGame();
                    }
                }
            }
        }
	}
    
    LevelContent ClientSetNextLevel(String sLevelName, int nGameType)
    {
        //CrashLog(" "+sLevelName+" "+nGameType+"\n");
        m_cNetGameInitInfo.nGameType = nGameType;
        m_cNetGameInitInfo.cLevels.SetSingleNetLevel( sLevelName, nGameType );
        return m_cNetGameInitInfo.cLevels.GetCurrent();
    }
    void ClientLoadNextLevel()
    {
        cMenu.ActiveLevelReturnValue = ChromeModule._LEVEL_CLIENT_FINISHED;
        Deactivate();
        cMenu.Activate();
    }
    
    void ServerLoadNextLevel()
    {
        cMenu.ActiveLevelReturnValue = ChromeModule._LEVEL_SERVER_FINISHED;
        Deactivate();
        cMenu.Activate();
    }

    /**SERVER Wolane na serwerze gdy do gry przylacza sie jakis Host. nHostID zawiera jego identyfikator
     * Wolane rowniez gdy server sam sie przylacza do gry. Kolejnosc nadejscia metod jest nastepujaca:
     * konstruktory Java, LoadLevel, OnCreate, OnHostJoinGame, Init(menu, gameinitinfo)
     */
    void OnHostJoinGame(int nHostID)
    {
        //SERVER HostID == 0 tylko na serverze
        if (nHostID == 0)
        {
            // zaznaczamy modul servera, zeby latwo bylo okreslic na jakim hostie jestesmy
            Role = ERole._AUTHORITY;
        }
        

        LogR("[ModuleNet.OnHostJoinGame] Host <"+ nHostID +"> joined the game!\n");
    }

    /**SERVER Wolane na serwerze gdy:
     * a) od gry odlacza sie jakis host,
     * b) host zostal poproszony o odlaczenie,
     * c) polaczenie sieciowe z hostem zostalo zerwane.
     * nHostID zawiera jego identyfikator
     */
    void OnHostLeftGame(int nHostID)
    {
        //LogR("[ModuleNet.OnHostLeftGame] Host <"+ nHostID +"> left the game!\n");
        
        DeletePlayer( nHostID );
    }    
    
    void OnDisconnectFromServer(int iReason)
    {
        CrashLog("[ModuleNet.OnDisconnectFromServer] DisconnectFromServer iReason="+iReason+"\n");
        
        if ( m_cGameInfo != null )
            m_cGameInfo.EventDisconnectFromServer( iReason );
        else
            CallMethodIn( "ForceQuitGame", 0.0f );
    }
    
    void ForceQuitGame()
    {
        DisableCallMethod("ForceQuitGame");
        
        GetGameInitInfo().cLevels.SetSingleNetLevel((String)null,ENetGameType.DEFAULT);
            
        cMenu.ActiveLevelReturnValue = ChromeModule._LEVEL_CLIENT_FINISHED;
        Deactivate();
        cMenu.Activate();
    }
    

    
    //////////////////////////////////////////
    // Rzeczy uruchamiane tylko na serwerze //
    //////////////////////////////////////////

    /**SERVER Pobiera playera gracza o podanym identyfikatorze
     */
    PlayerNet GetClientPlayer(int nClientID)
    {
        return m_cPlayerManager.FindPlayer( nClientID );
    }
    
    /**SERVER Usuwa gracza o podanym identyfikatorze
     */
    void DeletePlayer(int nClientID)
    {
        //CrashLog( "Find Client for delete nClientID:"+nClientID+"\n");
        PlayerNet cPlayer = GetClientPlayer(nClientID);
        if ( cPlayer != null )
        {
            //LogR( "Player found:"+cPlayer+" id:"+cPlayer.GetNetId()+"\n");
            //LogR(" Deleting...PlayerInfo");
            m_cGameInfo.ServerDeletePlayerInfo( cPlayer );
            //LogR("ok\n Deleting...Player");
            m_cPlayerManager.DeletePlayer( cPlayer );
            //LogR("ok\n");
        }
        else
        {
            CrashLog( "[ModuleNet.DeletePlayer] Player not found - delete canceled!\n");
        }
    }
    
    
    /**SERVER Stworzenie gracza 
     * - dla serwera
     * - dla klienta tuz po otrzymaniu informacji od clienta.
     * Zwraca informacje czy udalo sie stworzyc gracza ECreatePlayerResults
     */
    int CreateNewPlayer( NetPlayerProfile cProfile,
                         int              nClientID,
                         int              nClientGameVersion,
                         String           sPlayerClassName )
    {
        PlayerNet cPlayer = GetClientPlayer(nClientID);
        if ( cPlayer != null )
            return ECreatePlayerResults._CANCELED_CAUSE_ALREADY_CREATED;
        
        if ( ! m_cPlayerManager.CanAddPlayer() )
            return ECreatePlayerResults._CANCELED_CAUSE_TOO_MANY_PLAYERS;
            
        LogR("Create player for client <"+ nClientID	+
                 "> player mesh <"+ cProfile.GetMeshName()		+
		    	 "> player name <"+ cProfile.GetPlayerName()	+
		    	 ">\n");
        
       
        //FIXIT: taki hack na to zeby stworzyc pseudo boty :-)
        if ( cProfile.IsBot() )
            sPlayerClassName = sm_sPlayerNetBotClassName;
        else if ( cProfile.IsAutoPlayer() )
            sPlayerClassName = sm_sPlayerNetAutoClassName;
                
        // tworzymy gracza dla klienta
        PlayerNet cNewPlayer = (PlayerNet)CreateObjectNoInitNet( sPlayerClassName, nClientID );
        if ( cNewPlayer == null )
            return ECreatePlayerResults._CANCELED_CAUSE_NOREASON;
        
        
        cNewPlayer.SetProfile( cProfile );
        cNewPlayer.cGameInitInfo = GetGameInitInfo();
        
        
        NetProfiler.Start("Player InitObject");
        cNewPlayer.InitObject();
        NetProfiler.Delta("Player InitObject");        
                        
        // zapamietujemy nowego gracza w menadzerze graczy
        m_cPlayerManager.AddPlayer( cNewPlayer,nClientID );
        // dodajemy do game info obiekt z informacjami o jego wynikach
        // game info stworzy NetPlayerInfo
        m_cGameInfo.ServerAddPlayerInfo( cNewPlayer, nClientID, nClientGameVersion );
        
        // domyslnie player jest glownym obiektem gracza
        SetClientMainObject( nClientID, cNewPlayer );
        SetClientCamera( nClientID, cNewPlayer.cCurrentCamera );
        return ECreatePlayerResults._CREATED_SUCCESFULL;
    }
    
/*    
    static void StaticMasterClientGotResponse()
    {
        if (sm_cMasterClient != null)
        {
            int iState = sm_cMasterClient.GetAuthState();            
            
            CrashLog("[ModuleNet.StaticMasterClientGotResponse]" + MasterClient.GetAuthState(iState) + "\n");
            
            switch (iState)
            {
            case MasterClient.AuthState_NOT_AUTHORIZED:                
                break;
            case MasterClient.AuthState_OK:                
                break;
            case MasterClient.AuthState_INVALID_KEY:
                break;
            case MasterClient.AuthState_KEY_IN_USE:
                break;
            }
        }
        else
        {
            CrashLog("[ModuleNet.StaticMasterClientGotResponse] no static Master Client!!!\n");
        }
    }
  //*/
    
    //TODO: dlaczego to siedzi tu?
    /** SERVER utworzenie serwera gry sieciowej na podstawie parametrow zapisanych w menu      
     */
    static void CreateServer(ChromeMenuModule MenuModule, NetGameInitInfo cGameInitInfo)
    {
        CrashLog("Creating network server...\n");

        // kasujemy aktualny level gry na wszelki wypadek
        if ( MenuModule.ActiveLevelModule != null ) 
        {
            MenuModule.ActiveLevelModule.delete();
            MenuModule.ActiveLevelModule = null;
        }
        
        // tworzymy serwer
        int iLANServer = 1;
        if (cGameInitInfo.GetServerInfo().IsInternetGame() == true)
        {
            iLANServer = 0;
            MasterClient MClient = MasterClient.GetMasterClient();
            
            //sprawdzamy, czy jest autoryzowany - jesli dostal sie tu "normalna"
            //droga, to juz powinien byc, ale na wszelki wypadek...
            /*if (MClient.IsAuthorized() == false)
            {//a jednak nie jest autoryzowany...
                CrashLog("failed\n[ModuleNet.CreateServer] server not authorized yet - back to ChromeNetCreatMenu\n");
                
                MenuModule.SetMenu("ChromeNetCreatMenu");
                return;
            }*/

            int nGameRemoteAccessPort = 0;
#if REMOTE_ACCESS               
            GameRemoteAccessServer cRAS = GameRemoteAccessServer.GetInstance();
            if ( cRAS == null )
            {
                int nGamePort = cGameInitInfo.GetServerInfo().GetGamePort();
                cRAS = GameRemoteAccessServer.CreateInstance( nGamePort + NetServerInitInfo.sm_nRemoteAccessShift );
            }
            cRAS.Acquire( (IRemoteGame)null );
            nGameRemoteAccessPort = cRAS.GetListenerPort();
            //TODO - potrzebne potwierdzenie!!!
#endif            
            //przekazujemy 0 - tu byl kiedys port komunikacyjny
            MClient.NewGameServer( cGameInitInfo.GetServerInfo().GetGamePort(), 
                                   nGameRemoteAccessPort, 
                                   GameTypes.GAME_CHROME,
                                   ""+NetGameVersion.Get() );
#if REMOTE_ACCESS                
        }
        else
        {
            //DO TESTOW
            /*GameRemoteAccessServer cRAS = GameRemoteAccessServer.GetInstance();
            if ( cRAS != null )
                cRAS.Destroy();
            cRAS = GameRemoteAccessServer.CreateInstance( cGameInitInfo.GetServerInfo().GetGamePort() );
            GameObject.CrashLog(" REMOTE ACCESS on port "+cRAS.GetListenerPort()+"\n");*/
#endif            
        }
            
        
        int nResult = CreateServer( cGameInitInfo.GetServerInfo().GetServerName(),
                                    cGameInitInfo.GetServerInfo().GetGamePort(),
                                    cGameInitInfo.GetServerInfo().GetMaxConnections(),
									cGameInitInfo.GetServerInfo().GetPassword(),
                                    iLANServer);
        if (nResult == 0)
            CrashLog("Error when creating server!\n");
        else
        {
            CrashLog("Server successfully created.\n");

            SetServerState(EServerState.LOADING_MAP, cGameInitInfo.GetCurrentLevelName());
            
            MenuModule.NewGame(cGameInitInfo);
        
            // odpalamy gre
            MenuModule.StartGame();
        }
    }    
    
    /**
     * 
     * System Free Message'y
     * 
     */
            
    public void OnFreeMessage()
    {
        int    nMessageId = FreeMessageGetId();

        if (AmIServer())
        {
            switch (nMessageId)
            {
            case EFreeMsg._FIND_SERVER:
            case EFreeMsg._FIND_SERVER_2:
                FreeMsgRecvFindServer(nMessageId);
                break;
                
            case EFreeMsg._REQUEST_SERVER_PARAMS:
            case EFreeMsg._REQUEST_SERVER_PARAMS_2:
                FreeMsgRecvRequestServerParams(nMessageId);
                break;
                
            case EFreeMsg._REQUEST_SERVER_FULL_INFO:
            case EFreeMsg._REQUEST_SERVER_FULL_INFO_2:
                FreeMsgRecvRequestServerFullInfo(nMessageId);
                break;
                    
            case EFreeMsg._REQUEST_WISH_LIST:
            case EFreeMsg._REQUEST_WISH_LIST_2:
                FreeMsgRecvRequestWishList(nMessageId);
                break;
            
            default:
                //LogR("RECV free msg "+nMessageId+", skipped on server\n");
                FreeMessageEnd();
            }
        }

        if ( AmIClient() )
        {
            switch (nMessageId)
            {
            case EFreeMsg._SERVER_FULL_INFO:
            case EFreeMsg._SERVER_FULL_INFO_2:
                FreeMsgRecvServerFullInfo( FreeMessageGetHost(), nMessageId );
                break;

            default:                
                //LogR("RECV free msg "+nMessageId+", skipped on client\n");
                FreeMessageEnd();
            }
        }
        
        
    }
    
    //iMessageId : EFreeMsg._FIND_SERVER lub EFreeMsg._FIND_SERVER_2
    void FreeMsgRecvFindServer(int iMessageId)
    {
        String sHostName   = FreeMessageGetHost();
        int    nPort       = FreeMessageGetPort();
        int    nServerType = FreeMessageUnPackInt();
        FreeMessageEnd();
        
        //LogR("RECV " + EFreeMsg.GetFlagName(iMessageId) + " from " + sHostName + ":" + nPort + "\n");
        
        int iSendMessageId;
        if (iMessageId == EFreeMsg._FIND_SERVER)
        {
            iSendMessageId = EFreeMsg._I_AM_SERVER;
        }
        else
        {
            iSendMessageId = EFreeMsg._I_AM_SERVER_2;
        }
        
        FreeMsgSendIAmServer( sHostName, nPort, nServerType, iSendMessageId );
    }
    
    //iMessageId : EFreeMsg._I_AM_SERVER lub EFreeMsg._I_AM_SERVER_2
    void FreeMsgSendIAmServer(String sHostName,int nPort, int ServerType, int iMessageId)
    {
        //CrashLog(" SEND " + EFreeMsg.GetFlagName(iMessageId) + " to " + sHostName + ":" + nPort + "\n");
        FreeMessageNew( iMessageId );
        FreeMessagePackInt(ServerType);
        FreeMessageSend( EFreeMsg.TYPE_HOST, sHostName, nPort );
    }
    
    //iMessageId : EFreeMsg._REQUEST_SERVER_PARAMS lub EFreeMsg._REQUEST_SERVER_PARAMS_2
    void FreeMsgRecvRequestServerParams(int iMessageId)
    {
        String sHostName = FreeMessageGetHost();
        int    nPort     = FreeMessageGetPort();
        
        int ServerType = FreeMessageUnPackInt();
        
        //CrashLog(" RECV " + EFreeMsg.GetFlagName(iMessageId) + " from " + sHostName + ":" + nPort + "\n");
        
        float  fSendTime = FreeMessageUnPackFloat();
        FreeMessageEnd();
                               
        if ( m_bNetInitialized )
        {
            int iSendMessageId;
            if (iMessageId == EFreeMsg._REQUEST_SERVER_PARAMS)
            {
                iSendMessageId = EFreeMsg._SERVER_PARAMS;
            }            
            else
            {
                iSendMessageId = EFreeMsg._SERVER_PARAMS_2;
            }
            
            FreeMsgSendServerParams( sHostName, nPort, ServerType, fSendTime, iSendMessageId );
        }
    }
    
    //iMessageId : EFreeMsg._REQUEST_SERVER_FULL_INFO lub EFreeMsg._REQUEST_SERVER_FULL_INFO_2
    void FreeMsgRecvRequestServerFullInfo(int iMessageId)
    {
        String sHostName = FreeMessageGetHost();
        int    nPort     = FreeMessageGetPort();
        
        //CrashLog(" RECV " + EFreeMsg.GetFlagName(iMessageId) + " from " + sHostName + ":" + nPort + "\n");
        
        float  fSendTime = FreeMessageUnPackFloat();
        FreeMessageEnd();
                               
        if ( m_bNetInitialized )
        {
            int iSendMessageId;
            if (iMessageId == EFreeMsg._REQUEST_SERVER_FULL_INFO)
            {
                iSendMessageId = EFreeMsg._SERVER_FULL_INFO;
            }
            else
            {
                iSendMessageId = EFreeMsg._SERVER_FULL_INFO_2;
            }
            
            FreeMsgSendServerFullInfo( sHostName, nPort, fSendTime, iSendMessageId );
        }
    }
    
    WishListAnswersContainer m_cWishListContainer = null;
    
    //iMessageId : EFreeMsg._REQUEST_WISH_LIST lub EFreeMsg._REQUEST_WISH_LIST_2
    void FreeMsgRecvRequestWishList(int iMessageId)
    {
        String sHostName = FreeMessageGetHost();
        int    nPort     = FreeMessageGetPort();
        int    ID        = FreeMessageUnPackInt();
        int    nServerId = FreeMessageUnPackInt();
        FreeMessageEnd();
        
        //CrashLog(" RECV " + EFreeMsg.GetFlagName(iMessageId) + " from " + sHostName + ":" + nPort + "\n");

        if (GetGameInitInfo().GetServerInfo().IsInternetGame())
        {
            MasterClient.GetMasterClient().CheckClientActivity(ID, nServerId,GameTypes.GAME_CHROME, new ActivityCheckWaiter(sHostName, nPort));
            
            if (CheckAuthorizationOn == false)
            {
                CheckAuthorizationOn = true;
                CallMethodEvery("CheckAuthorization", 1.0f);
            }
        }
        else
        {
            SendWishList(sHostName, nPort);
        }
    }
    
    boolean CheckAuthorizationOn = false;
    
    class ActivityCheckWaiter
    {
        public String sHostName;
        public int    nPort;
        ActivityCheckWaiter(String sHostName, int nPort)
        {
            this.sHostName = sHostName;
            this.nPort = nPort;
        }
    }
    
    void CheckAuthorization()
    {
        ActivityCheckWaiter waiter;
        while (null!=(waiter = (ActivityCheckWaiter)MasterClient.GetMasterClient().GetActiveClient()))
        {
            SendWishList(waiter.sHostName,waiter.nPort);
        }
        while (null!=(waiter = (ActivityCheckWaiter)MasterClient.GetMasterClient().GetInactiveClient()))
        {
            //TODO: MAREKP -> jakas akcja ktora trzeba podjac, gdy sie znajdzie takiego nieaktywnego chuja, ktory probuje sie do gry podlaczyc, moze wyslac mu jakis komunikat, zeby spadal, czy cos takiego
        }
        if (MasterClient.GetMasterClient().IsListEmpty() == true)
        {
            CheckAuthorizationOn = false;
            DisableCallMethod("CheckAuthorization");
        }
    }
    
    void SendWishList(String sHostName, int nPort)
    {
        //LogR("[ModuleNet.SendWishList] to " + sHostName + ":" + nPort + "\n");
        
        //jesli nie mamy jeszcze kontenerka na odpowiedzi, to znaczy, ze jest to
        //pierwsze odpytanie, wiec tworzymy ten kontener
        if (m_cWishListContainer == null)
        {
            m_cWishListContainer = new WishListAnswersContainer(180.0f, this);//MP - wydluzylem czas na tej samej zasadzie, 
                                                                              //co czas oczekiwania na odpowiedz z MS
        }
        
        //przygotowujemy liste zyczen
        WishList cWishList = new WishList();
        cWishList.PrepareRandomList(5, (int)GetAbsoluteTime() % 32000, GetGameInitInfo().GetCurrentLevelName());
/*        
        //pytamy o scr'a dla danego typu gry
        int iGameType = GetGameInfo().GetGameType();
        String sScrPath = GetModulePath() + ENetGameType.GetScriptFileName(iGameType);
        LogR("scr crc - "+sScrPath+"\n");
//*/        
        //od razu przygotowujemy odpowiedz
        WishListCounter cWishListCounter = new WishListCounter(null);
        cWishListCounter.FromWishList(cWishList);
//        cWishListCounter.AddQuestion(sScrPath, 0, -1);
        
        WishListAnswer cAnswer = new WishListAnswer(cWishListCounter.Count(), GetAbsoluteTime());
        m_cWishListContainer.Add(cAnswer);
        
        FreeMessageNew( EFreeMsg._WISH_LIST_2 );
        
        //ID pytania
        FreeMessagePackInt(cAnswer.GetQueryNum());
        
        //pytania oparte na ID
        int iCnt = cWishList.GetQuestionCount();
        FreeMessagePackInt(iCnt);
        
        //LogR("count = " + iCnt + "\n");
        
        int iMaxIdx = cWishList.GetQuestionMaxIdx();
        for (int i = 0; i < iMaxIdx; ++i)
        {
            FileCRCCounter cQuestion = cWishList.GetQuestion(i);
            if (cQuestion != null)
            {
                //LogR("added from idx: " + i + "\n");
                
                FreeMessagePackInt(cQuestion.GetFileID());
                FreeMessagePackInt(cQuestion.GetStartPos());
                FreeMessagePackInt(cQuestion.GetEndPos());
            }
            else
            {
                //LogR("null at idx: " + i + "\n");
            }
        }
        
        //jeszcze pytania oparte na stringach        
        FreeMessagePackInt(0);
/*
        //jeszcze pytania oparte na stringach - obecnie tylko 1
        FreeMessagePackInt(1);

        //wrzucamy scr'a
        FreeMessagePackString(sScrPath);
        FreeMessagePackInt(0);
        FreeMessagePackInt(-1);
 //*/       
        //wrzucamy tez modyfikatory zawarte w levelu
        FreeMessagePackLevelContent();
        
        FreeMessageSend( EFreeMsg.TYPE_HOST, sHostName, nPort );
    }
    
    /**
     * LevelContent - czyli ustawienie inwentory room
     * oraz implantow
     */
    //wyslanie z serwera
    void FreeMessagePackLevelContent()
    {
        //pobieramy obiekt z gry
        LevelContent cLevelContent = GetCurrentLevelContent();
        //wrzucamy jego dane do kontenera
        NetDataContainer cLevelContentData = 
            cLevelContent.ToDataContainer( GetGameInfo().GetGameSettings().GetAvailableInventoryRoom() );
        //i kontener pakujemy do message'a
        cLevelContentData.ToFreeMessage( this );
        /*
        //teraz objectivy, ktore w zasadzie tez mozna zaciagnac z 
        //level content, ale znajduja sie tez osobno w objectivemanagerze
        //pobranie obiektu z gry
        ObjectivesManager  cObjectivesManager = m_cModule.GetObjectivesManager();
        //wrzucenie do kontenera
        NetDataContainer   cObjectivesData = cObjectivesManager.ToDataContainer();
        //kontener do message'a
        cObjectivesData.ToMessage( this );*/
    }

    
    //iMessageId : EFreeMsg._SERVER_PARAMS lub EFreeMsg._SERVER_PARAMS_2
    void FreeMsgSendServerParams( String sHostName, int nPort, int ServerType, float fSendTime, int iMessageId )
    {
        //CrashLog(" SEND " + EFreeMsg.GetFlagName(iMessageId) + " to " + sHostName + ":" + nPort + "\n");
        
        FreeMessageNew( iMessageId );
        FreeMessagePackInt(ServerType);
        FreeMessagePackFloat( fSendTime );
        FreeMessagePackString( GetGameInitInfo().GetServerInfo().GetServerName() );
        String sLevelName = GetGameInitInfo().GetCurrentLevelName();
        if (sLevelName != null)
            FreeMessagePackString( sLevelName );
        else
            FreeMessagePackString( "" );
        FreeMessagePackInt( GetGameInitInfo().GetServerInfo().GetMaxPlayers() );
        FreeMessagePackInt( m_cPlayerManager.GetPlayersCnt() );
        FreeMessagePackInt( GetGameInitInfo().nGameType );
        FreeMessagePackInt( NetGameInfo.GetGameVersion() );
        FreeMessagePackBoolean( GetGameInitInfo().GetServerInfo().IsPassword() );
        //TODO - tu ma byc wyliczone CRC aktualnej mapy!!!
        FreeMessagePackInt( 0 );
        FreeMessagePackBoolean( GetGameInitInfo().GetServerInfo().IsInternetGame() );
        //UWAGA - stara wersja wymagala wyslania tu portu komunikacyjnego, wiec
        //musimy cos wyslac, zeby mogla odczytac poprawnie wiadomosc
        FreeMessagePackInt(0);
        FreeMessageSend( EFreeMsg.TYPE_HOST, sHostName, nPort );
    }
    
    //iMessageId : EFreeMsg._SERVER_FULL_INFO lub EFreeMsg._SERVER_FULL_INFO_2
    void FreeMsgSendServerFullInfo( String sHostName, int nPort, float fSendTime, int iMessageId)
    {
        //CrashLog(" SEND " + EFreeMsg.GetFlagName(iMessageId) + " to " + sHostName + ":" + nPort + "\n");
        
        NetServerFullInfo cFullInfo = new NetServerFullInfo( this );
        NetDataContainer  cData     = cFullInfo.ToDataContainer();
        
        FreeMessageNew( iMessageId );
        FreeMessagePackFloat( fSendTime );
        cData.ToFreeMessage( this );
        FreeMessageSend( EFreeMsg.TYPE_HOST, sHostName, nPort );
    }

    NetServerFullInfo m_cReceivedServerFullInfo = null;
    //iMessageId : EFreeMsg._SERVER_FULL_INFO lub EFreeMsg._SERVER_FULL_INFO_2
    void FreeMsgRecvServerFullInfo( String sHostName, int iMessageId )
    {
        NetDataContainer cData = new NetDataContainer();
        
        //CrashLog(" RECV " + EFreeMsg.GetFlagName(iMessageId) + "\n");
        float  fSendTime    = FreeMessageUnPackFloat();
        cData.FromFreeMessage( this );
        FreeMessageEnd();
        
        //poskladajmy odczytane dane do obiektu info
        m_cReceivedServerFullInfo = new NetServerFullInfo( cData );
            
        
    }
    
    // FIXIT, tylko do testow
    //iMessageId: EFreeMsg._I_AM_SERVER lub EFreeMsg._I_AM_SERVER_2
    void FreeMsgSendIAmServer(int iMessageId)
    {
        //CrashLog(" SEND " + EFreeMsg.GetFlagName(iMessageId) + " BROADCAST port:" + GetGameInitInfo().GetServerInfo().GetGamePort() + "\n");
        
        FreeMessageNew( iMessageId );
        FreeMessagePackInt(0);
        FreeMessageSend( EFreeMsg.TYPE_BROADCAST, "", 
                         GetGameInitInfo().GetServerInfo().GetGamePort() );
    }
    
    // FIXIT, tylko do testow
    //iMessageId : EFreeMsg._FIND_SERVER lub EFreeMsg._FIND_SERVER_2
    void FreeMsgSendFindServer(int iMessageId)
    {
        //CrashLog(" SEND " + EFreeMsg.GetFlagName(iMessageId) + "\n");
        
        FreeMessageNew( iMessageId );
        FreeMessageSend( EFreeMsg.TYPE_BROADCAST, "", 
                         GetGameInitInfo().GetServerInfo().GetGamePort() );
    }
    
    
    /**
     * 
     * Koniec systemu Free Message'y
     * 
     */
    

    static PlayerNet GetAssassinPlayerNetFromObject( GameObject cAssassin )
    {
        PlayerNet cPlayerNet = null;
        
        if (cAssassin != null)
        {
            if ( cAssassin instanceof PlayerNet )
                cPlayerNet = (PlayerNet)cAssassin;
            else if ( cAssassin instanceof Vehicle )
            {
                Vehicle cVehicle = (Vehicle) cAssassin;
                Pawn    cDriver  = (Pawn) cVehicle.GetFirstOccupant(EPassengerRole._VEHICLE_DRIVER);
                if ( cDriver instanceof PlayerNet )
                    cPlayerNet = (PlayerNet) cDriver;
            }
            else if ( cAssassin instanceof Bullet)
            {
                Bullet cBullet = (Bullet) cAssassin;
                Pawn   cOwner  = cBullet.Owner;
                if ( cOwner instanceof PlayerNet )
                    cPlayerNet = (PlayerNet) cOwner;
            } 
            else if ( cAssassin instanceof DestroyableNet)
            {
                DestroyableNet cDestroyableNet = (DestroyableNet) cAssassin;
                cPlayerNet = (PlayerNet) cDestroyableNet.GetAssasinPlayer();
            }    
        }
        return cPlayerNet;
    }
    
    
    //////////////////////////////////////////////////////////////////////////////////////////////
    // Dosymulowywanie dla potrzeb renderingu
    //
    public void AddCorrectOnRenderObject(ChromeActor obj)
    {
        if (m_CorrectOnRenderList != null &&
            !m_CorrectOnRenderList.contains(obj))
        {
            m_CorrectOnRenderList.add(obj);
        }
    }

    public void RemoveCorrectOnRenderObject(ChromeActor obj)
    {
        if (m_CorrectOnRenderList != null)
            m_CorrectOnRenderList.remove(obj);
    }

    
    void OnRender()
    {
        if ( AmIDedicatedServer() )
            return;
        
        if ( m_cGameInfo != null && m_cGameInfo.GetPlayerInfoList() != null )
        {
            for (int i=0; i<m_cGameInfo.GetPlayerInfoList().GetSize(); i++)
            {
                NetPlayerInfo cPlayerInfo = m_cGameInfo.GetPlayerInfoList().GetPlayerByIndex( i );
                if ( cPlayerInfo.GetPlayer() == null || cPlayerInfo.GetPlayer().GetNetRelevant() < 0.0f )
                    continue;
                cPlayerInfo.GetPlayer().OnRender();
            }
        }
        
        for ( int i=0; i<m_aVehiclesOnLevel.size(); i++ )
        {
            if (m_aVehiclesOnLevel.elementAt( i ) instanceof Vehicle )
            {                    
                Vehicle cVehicle = (Vehicle)m_aVehiclesOnLevel.elementAt( i );
                cVehicle.OnRender();
            }
        }
        
        if (m_CorrectOnRenderList != null && m_CorrectOnRenderList.size() > 0)
        {
            ListIterator iter = m_CorrectOnRenderList.listIterator(0);
            ChromeActor obj;
            while (iter.hasNext())
                ((ChromeActor)iter.next()).OnRender();
        }
    }
    
    void OnPostRender()
    {
        if ( AmIDedicatedServer() )
            return;
        
        if ( m_cGameInfo != null && m_cGameInfo.GetPlayerInfoList() != null )
        {
            for (int i=0; i<m_cGameInfo.GetPlayerInfoList().GetSize(); i++)
            {
                NetPlayerInfo cPlayerInfo = m_cGameInfo.GetPlayerInfoList().GetPlayerByIndex( i );
                if ( cPlayerInfo.GetPlayer() == null || cPlayerInfo.GetPlayer().GetNetRelevant() < 0.0f )
                    continue;
                cPlayerInfo.GetPlayer().OnPostRender();
            }
        }
        
        for ( int i=0; i<m_aVehiclesOnLevel.size(); i++ )
        {
            if (m_aVehiclesOnLevel.elementAt( i ) instanceof Vehicle )
            {
                Vehicle cVehicle = (Vehicle)m_aVehiclesOnLevel.elementAt( i );
                cVehicle.OnPostRender();
            }
        }

        if (m_CorrectOnRenderList != null && m_CorrectOnRenderList.size() > 0)
        {
            ListIterator iter = m_CorrectOnRenderList.listIterator(0);
            ChromeActor obj;
            while (iter.hasNext())
                ((ChromeActor)iter.next()).OnPostRender();
        }
    }

    void OnReceivedDataOnServer()
    {
        if (m_cGameInfo != null && 
            m_cGameInfo.GetPlayerInfoList() != null)
        {
            for (int i=0; i<m_cGameInfo.GetPlayerInfoList().GetSize(); i++)
            {
                NetPlayerInfo cPlayerInfo = m_cGameInfo.GetPlayerInfoList().GetPlayerByIndex( i );
                if ( cPlayerInfo.GetPlayer() != null )
                    cPlayerInfo.GetPlayer().OnReceivedDataOnServer();
            }
        }
    }
    
    void OnReceivedDataOnClient()
    {
        if (m_cGameInfo != null && 
            m_cGameInfo.GetPlayerInfoList() != null)
        {
            for (int i=0; i<m_cGameInfo.GetPlayerInfoList().GetSize(); i++)
            {
                NetPlayerInfo cPlayerInfo = m_cGameInfo.GetPlayerInfoList().GetPlayerByIndex( i );
                if ( cPlayerInfo.GetPlayer() == null || cPlayerInfo.GetPlayer().GetNetRelevant() < 0.0f )
                    continue;
                cPlayerInfo.GetPlayer().OnReceivedDataOnClient();
            }
        }
    }
    
    void OnPostReplicateDataOnServer()
    {
        if (m_cGameInfo != null && 
            m_cGameInfo.GetPlayerInfoList() != null)
        {
            for (int i=0; i<m_cGameInfo.GetPlayerInfoList().GetSize(); i++)
            {
                NetPlayerInfo cPlayerInfo = m_cGameInfo.GetPlayerInfoList().GetPlayerByIndex( i );
                if ( cPlayerInfo.GetPlayer() != null )
                    cPlayerInfo.GetPlayer().OnPostReplicateDataOnServer();
            }
        }
        
        //Vehicle.StaticOnPostReplicateDataOnServer();
    }
    
    private String sInGameMapName = null;
    String GetInGameMapName(){ return  sInGameMapName; }
    void   SetInGameMapName(String sName){ sInGameMapName = sName;  }
    
    public boolean ValidateCRC(int iQueryNum, int iCRC)
    {
        if (m_cWishListContainer != null)
        {
            return m_cWishListContainer.Check(iQueryNum, iCRC);
        }
        
        return false;
    }
    
    void OnFailedToFinalizeConnection()
    {
        LogR("[ModuleNet.OnFailedToFinalizeConnection]\n");

        CallOnFrameEnd("ClientLeaveLevel");
    }
    
    void ClientLeaveLevel()
    {
        //upewnijmy sie jeszcze, czy jestesmy clientem
        if (cMenu != null && 
            Role < ERole._AUTHORITY)
        {
            cMenu.ActiveLevelReturnValue = ChromeModule._LEVEL_CLIENT_FAILED_TO_ENTER_GAME;
            Deactivate();
            cMenu.Activate();
        }
    }
    
    public void KickNetClient(int iClientID)
    {
        GetGameInfo().EventPlayerToKick(iClientID, EKickReason._INCOMPATIBLE_DATA);
    }
    
    /**
     * Metoda ulatwiajace wlaczanie/wylaczanie logow sieciowych
     * podczas gry, nalezy podac odpowiednie paremetry (patrz klasa NetLog)
     */
    static void SetNetLog(int nType,int nMode){ NetLog.SetMode(nType,nMode);}
}

