public class MenuNetChatWindow extends MenuNetChatWindowBase implements IChatWindow
{
    IChat m_cChat = null;

    boolean m_bConnected = false;
    
    static java.util.Vector m_vChatLines = new java.util.Vector();
    static java.util.Vector m_vUsers = new java.util.Vector();

    Vector vNickColor = new Vector(1,1,1);
    
    static int m_nHistorySize = 100;
    
    UIChatListWindow m_cChatIn = null;
    UIChatListWindow m_cUsers = null;
    ChatInputWindow m_cChatOut = null;

    
	Vector GetChatOutPos()
	{
		return GetElem("ID_CHAT_OUT").GetPos();
	}
	
	Vector GetChatOutSize()
	{
		return GetElem("ID_CHAT_OUT").GetSize();
	}

    void InitChatWindows()
    {
		m_cChatIn = (UIChatListWindow)CreateObject("UIChatListWindow");
		m_cChatIn.Init(GetElem("ID_CHAT_IN"));
		GetElem("ID_CHAT_IN").AddChild(m_cChatIn);
		m_cChatIn.ProcessMouse(true);
		m_cChatIn.SetCursor(MenuModule.cCursor);
		
        m_cChatIn.Init(); // to musi byc zawolane dopiero po ustaleniu pos
		m_cChatIn.Show();
		
		
		m_cUsers = (UIChatListWindow)CreateObject("UIChatListWindow");
		m_cUsers.Init(GetElem("ID_USERS"));
		GetElem("ID_USERS").AddChild(m_cUsers);
		m_cUsers.ProcessMouse(true);
		m_cUsers.SetCursor(MenuModule.cCursor);
		m_cUsers.m_nMaxItems = m_cUsers.nMaxTexts = 1000000000;
		
        m_cUsers.Init(); // to musi byc zawolane dopiero po ustaleniu pos
		m_cUsers.Show();
		
		
		m_cChatOut = (ChatInputWindow)CreateObjectNoInit("ChatInputWindow");
		m_cChatOut.m_cMenuNetChatWindow = this;
		m_cChatOut.InitObject();
		m_cChatOut.m_sId = "CHAT_OUT";
		UIWindow cChatOutDummy = GetElem("ID_CHAT_OUT");
		cChatOutDummy.AddChild(m_cChatOut);
		
    }
    
    public void Show()
    {
        ChatAcquire(this);
        super.Show();
        if (m_cChatOut != null)
            m_cChatOut.Show( 0 );
    }
    
    public void Hide()
    {
        ChatUnacquire();
        super.Hide();
        if (m_cChatOut != null)
            m_cChatOut.Deactivate();
    }
    
    void ChatAcquire( IChatWindow cWindow )
    {
        if (m_cUsers == null)
            return;
        
        if ( GetModule() instanceof ChromeMenuModule )
        {
            UpdateChatWindows(cWindow);
        }
    }
    
    void MasterServerLocalMessage( String sText )
    {
        ChromeMenuModule cModule = (ChromeMenuModule)GetModule();
        Chat cChat = cModule.GetChat();
        if ( cChat == null )
            cChat = cModule.CreateChat();
        if ( cChat != null )
            cChat.LocalInputMsg( sText, NetMsg._COL_INMSG_SERVER );
    }
    
    void ChatConnect()
    {
        ChromeMenuModule cModule = (ChromeMenuModule)GetModule();
        Chat cChat = cModule.GetChat();
        if (cChat != null)
            cChat.Connect();
    }
    
    void UpdateChatWindows(IChatWindow cWindow)
    {
        ChromeMenuModule cModule = (ChromeMenuModule)GetModule();
        Chat cChat = cModule.GetChat();
        if ( cChat == null )
            cChat = cModule.CreateChat();
        if ( cChat != null )
        {
            cChat.Acquire( cWindow );
            ChatState cState = cChat.GetState();
            m_bConnected = cState.m_bConnected;
            m_vUsers.clear();
            if (cState.m_aClients != null)
            {
                for (int i = 0; i < cState.m_aClients.length; i++)
                {
                    m_vUsers.addElement(new ChatMsgInfo(cState.m_aClients[i], vNickColor));
                }
            }
            m_cUsers.Update(m_vUsers);
            
            m_vChatLines.clear();
            if ((cState.m_cMsgHistory != null) && 
                (cState.m_cMsgHistory.GetCurrentIndex() > -1) && //czy sa jakies?
                (cState.m_cMsgHistory.GetList() != null))
            {
                int nLen     = cState.m_cMsgHistory.GetList().length;
                int nCurrent = cState.m_cMsgHistory.GetCurrentIndex();
                int nMsg     = (nCurrent + 1) % nLen;
                for (int i = 0; i < nLen; i++, nMsg = (nMsg + 1) % nLen )
                {
                    ChatMsgInfo cMsgFromHistory = cState.m_cMsgHistory.GetList()[nMsg];
                    if (cMsgFromHistory != null)
                    {
                        String [] sLines = m_cChatIn.CheckTextLines(cMsgFromHistory.GetText());
		                for (int j = 0; j < sLines.length; j++)
			                AddChatLine(sLines[j], cMsgFromHistory.GetColor()); 
                    }
                }
            }
                                  
            m_cChatIn.Update(m_vChatLines);
        }
    }
    
    void ChatUnacquire()
    {
        if ( GetModule() instanceof ChromeMenuModule )
        {
            ChromeMenuModule cModule = (ChromeMenuModule)GetModule();
            Chat cChat = cModule.GetChat();
            if ( cChat != null )
                cChat.Unacquire();
        }
    }
        
    public void Acquire( IChat cChat )
	{
        m_cChat = cChat;
        if (m_cChatOut != null)
		    m_cChatOut.SetChat( cChat );
        m_vChatLines.clear();
	}
        
    synchronized public void OutputMsg( String sText, Vector vColor )
	{
		String [] sLines = m_cChatIn.CheckTextLines(sText);
		for (int i = 0; i < sLines.length; i++)
			AddChatLine(sLines[i], vColor); 
		
		m_cChatIn.Update(m_vChatLines);		
	}
	
	public void AddChatLine(String sText, Vector vColor)
	{
		m_vChatLines.addElement(new ChatMsgInfo(sText, vColor));
		if (m_vChatLines.size() > m_nHistorySize)
			m_vChatLines.removeElementAt(0);
		
	}
    
    
    public void EnableInputs(boolean bEnable)
	{
		
	}
    
    
    void DisableInputChat()
    {
        if ( GetModule() instanceof ChromeMenuModule )
        {
            ChromeMenuModule cModule = (ChromeMenuModule)GetModule();
            Chat cChat = cModule.GetChat();
            if ( ( cChat != null ) && ( cChat.m_cIChatWindow != null ) )
                cChat.m_cIChatWindow.EnableInputs( false );
        }
    }
    
    void EnableInputChat()
    {
        if ( GetModule() instanceof ChromeMenuModule )
        {
            ChromeMenuModule cModule = (ChromeMenuModule)GetModule();
            Chat cChat = cModule.GetChat();
            if ( ( cChat != null ) && ( cChat.m_cIChatWindow != null ) )
                cChat.m_cIChatWindow.EnableInputs( true );
        }
    }
    
    public void SetConnectionStatus( boolean bConnected, String sText )
    {
        m_bConnected = bConnected;
        if (!m_bConnected)
            m_cUsers.Update(null);
    }
    
    synchronized public void UpdateClients( String []sNicks )
    {
        m_vUsers.clear();
        if (sNicks != null)
        {
            for (int i = 0; i < sNicks.length; i++)
            {
                m_vUsers.addElement(new ChatMsgInfo(sNicks[i], vNickColor));
            }
        }   
        m_cUsers.Update(m_vUsers);
    }
    
    
    boolean IsChatConnected()
    {
        return m_bConnected;
    }

    boolean Load(Module mod, String sName, boolean bShow)
    {
        //nie pokazujemy czata po zaladowaniu tylko recznie
        return super.Load(mod, sName, false);   
    } 
}
