public class MenuNetGameSettingsCTF extends MenuNetGameSettingsTeam
{
    NetGameSettingsCTF m_cNetGameSettingsCTF = null;
    void SetGameSettings(NetGameSettings cGameSettings)
    {
        super.SetGameSettings( cGameSettings );
        
        if ( cGameSettings instanceof NetGameSettingsCTF )
            m_cNetGameSettingsCTF = (NetGameSettingsCTF)cGameSettings;
        else
            LogD(" Nieodpowiedni obiekt game settings "+cGameSettings+"\n");
    }
    
    public void OnCreate()
    { 
        super.OnCreate();
        
        m_cPoints.InitControl(this);
        NextElement();
        m_cTime.InitControl(this);
        NewSet();
        
        m_cAvailableInventoryRoom.InitControl(this);
        NewSet();
        
        m_cFlagAutoReturnTime.InitControl(this);
        NewSet();
        
        m_cTeamBalance.InitControl(this);
        NextElement();
        m_cFriendlyFire.InitControl(this);
        NextElement();
        m_cStartWhenBothTeamsHavePlayers.InitControl(this);
        NextElement();
        
        NewColumn();
        
        m_cIdentifyEnemies.InitControl(this);        
        NewSet();
        
        m_cEnemiesVisibleOnHudMap.InitControl(this);
        NextElement();
        m_cFriendsVisibleOnHudMap.InitControl(this);
        NextElement();
        m_cFlagsVisibleOnHudMap.InitControl(this);
        if ( m_cNetGameSettings.GetAvailableVehicles() )
        {
            NextElement();
            m_cVehiclesVisibleOnHudMap.InitControl(this);
        }

        NewSet();
        
        m_cRespawns.InitControl(this);
        NextElement();
        m_cRespawnTime.InitControl(this);
        if ( m_cNetGameSettings.GetAvailableVehicles() )
        {
            NewSet();
        
            m_cVehicleRespawns.InitControl(this);
            NextElement();
            m_cVehicleRespawnTime.InitControl(this);
            NextElement();
            m_cVehicleAutoReturnTime.InitControl(this);
            NextElement();                
        }
    }
    
    void CopyDataFromObjectToMenu()
    {
        super.CopyDataFromObjectToMenu();
                
        if ( m_cFlagsVisibleOnHudMap.Initialized() )        
            m_cFlagsVisibleOnHudMap.SetValue( m_cNetGameSettingsCTF.GetFlagsVisibleOnHudMap() );
        if ( m_cFlagAutoReturnTime.Initialized() )        
            m_cFlagAutoReturnTime.SetValue( (int)m_cNetGameSettingsCTF.GetFlagAutoReturnTime() );
    }
    void CopyDataFromMenuToObject()
    {
        super.CopyDataFromMenuToObject();
        
        if ( m_cFlagsVisibleOnHudMap.Initialized() )        
            m_cNetGameSettingsCTF.SetFlagsVisibleOnHudMap( m_cFlagsVisibleOnHudMap.GetBoolean() );
        if ( m_cFlagAutoReturnTime.Initialized() )        
            m_cNetGameSettingsCTF.SetFlagAutoReturnTime( (float)m_cFlagAutoReturnTime.GetInt() );
    }
}
