public class MenuNetGameSettingsTD extends MenuNetGameSettingsTeam
{
    NetGameSettingsTD m_cNetGameSettingsTD = null;
    void SetGameSettings(NetGameSettings cGameSettings)
    {
        super.SetGameSettings( cGameSettings );
        
        if ( cGameSettings instanceof NetGameSettingsTD )
            m_cNetGameSettingsTD = (NetGameSettingsTD)cGameSettings;
        else
            LogD(" Nieodpowiedni obiekt game settings "+cGameSettings+"\n");
    }
    
    public void OnCreate()
    { 
        super.OnCreate();
        m_cPoints.InitControl(this);
        NextElement();
        m_cTime.InitControl(this);
        NewSet();
        
        m_cDominationScoreUpdateTime.InitControl(this);
        NewSet();
        
        m_cAvailableInventoryRoom.InitControl(this);
        NewSet();
        
        m_cTeamBalance.InitControl(this);
        NextElement();
        m_cFriendlyFire.InitControl(this);
        NextElement();
        m_cStartWhenBothTeamsHavePlayers.InitControl(this);
        NextElement();
        
        NewColumn();
        
        m_cIdentifyEnemies.InitControl(this);        
        NewSet();
        
        m_cEnemiesVisibleOnHudMap.InitControl(this);
        NextElement();
        m_cFriendsVisibleOnHudMap.InitControl(this);
        if ( m_cNetGameSettings.GetAvailableVehicles() )
        {
            NextElement();
            m_cVehiclesVisibleOnHudMap.InitControl(this);
        }
        NextElement();
        m_cBasesVisibleOnHudMap.InitControl(this);
        NewSet();
        
        m_cRespawns.InitControl(this);
        NextElement();
        m_cRespawnTime.InitControl(this);
        if ( m_cNetGameSettings.GetAvailableVehicles() )
        {
            NewSet();
        
            m_cVehicleRespawns.InitControl(this);
            NextElement();
            m_cVehicleRespawnTime.InitControl(this);
            NextElement();
            m_cVehicleAutoReturnTime.InitControl(this);
            NextElement();                
        }
    }
    
    void CopyDataFromObjectToMenu()
    {
        super.CopyDataFromObjectToMenu();
        
        if ( m_cDominationScoreUpdateTime.Initialized() )
            m_cDominationScoreUpdateTime.SetValue( (int)m_cNetGameSettingsTD.GetScoreUpdateTime() );
        if ( m_cBasesVisibleOnHudMap.Initialized() )
            m_cBasesVisibleOnHudMap.SetValue( m_cNetGameSettingsTD.GetBasesVisibleOnHudMap() );
    }
    
    void CopyDataFromMenuToObject()
    {
        super.CopyDataFromMenuToObject();
        
        if ( m_cDominationScoreUpdateTime.Initialized() )
            m_cNetGameSettingsTD.SetScoreUpdateTime( (float)m_cDominationScoreUpdateTime.GetInt() );
        if ( m_cBasesVisibleOnHudMap.Initialized() )
            m_cNetGameSettingsTD.SetBasesVisibleOnHudMap( m_cBasesVisibleOnHudMap.GetBoolean() );
    }
}
