public class MenuNetChatRoom extends MenuNetChatWindow
{
	UIStatic m_cStatus = null;

    ChromeMenuWindow m_cParentChromeWindow = null;
    
    static final float _CONNECT_DELAY = 2f;
    float m_fLastConnectBtnTime = 0;
    
    public void Show()
    {
        super.Show();
        m_fLastConnectBtnTime = 0;
    }
    

	void Init(MenuBackground cBack)
    {
        MenuModule=(ChromeMenuModule)GetModule();
     
		InitChatWindows();
		
		MenuModule.cCursor.CallOnFrameEnd("MoveTop");
		MenuModule.cCursor.CallOnFrameEnd("Show");
    }
	
    void InitChatWindows()
    {
		m_cChatIn = (UIChatListWindow)CreateObject("UIChatListWindow");
		m_cChatIn.Init(GetElem("ID_CHAT_IN"));
		GetElem("ID_CHAT_IN").AddChild(m_cChatIn);
		m_cChatIn.ProcessMouse(true);
		m_cChatIn.SetCursor(MenuModule.cCursor);
		
        m_cChatIn.Init(); // to musi byc zawolane dopiero po ustaleniu pos
		m_cChatIn.Show();
		
		
		m_cUsers = (UIChatListWindow)CreateObject("UIChatListWindow");
		m_cUsers.Init(GetElem("ID_USERS"));
		GetElem("ID_USERS").AddChild(m_cUsers);
		m_cUsers.ProcessMouse(true);
		m_cUsers.SetCursor(MenuModule.cCursor);
		m_cUsers.m_nMaxItems = m_cUsers.nMaxTexts = 1000000000;
		
        m_cUsers.Init(); // to musi byc zawolane dopiero po ustaleniu pos
		m_cUsers.Show();
		
		
		m_cChatOut = (ChatInputWindow)CreateObjectNoInit("ChatInputWindow");
		m_cChatOut.m_cMenuNetChatWindow = this;
		m_cChatOut.InitObject();
		m_cChatOut.m_sId = "CHAT_OUT";
		UIWindow cChatOutDummy = GetElem("ID_CHAT_OUT");
		cChatOutDummy.AddChild(m_cChatOut);
		m_cChatOut.Show( 0 );
		
        m_cStatus = (UIStatic)GetElem("ID_STATUS");
        
        UpdateConnectButton();
    }
    
	Vector GetChatOutPos()
	{
		return GetElem("ID_CHAT_OUT").GetPos();
	}
	
	Vector GetChatOutSize()
	{
		return GetElem("ID_CHAT_OUT").GetSize();
	}
	
	void Discard()
    {
        if(!CanDiscard())
			return;
		if(m_cYesNoDlg != null)
		{
			return;
		}
                
        Hide();
        m_cParentChromeWindow.Show();
    }
	
	void OnUICommand(UIWindow cSender, int nCommand)
    {
        super.OnUICommand(cSender,nCommand);
        
		if(nCommand == EUIConst.CM_CLICK || nCommand == EUIConst.CM_DBCLICK)
		{
			if(cSender.m_sId.equals("ID_EXIT"))
			{	
				Discard();
			}
            
            if (cSender.m_sId.equals("ID_CONNECT_DISCONNECT"))
                OnConnectDisconnect();
		}
	}
    
	void OnConnectDisconnect()
    {
        if (IsChatConnected())
            m_cChat.Disconnect("");
        else
            if (GetTime() - m_fLastConnectBtnTime > _CONNECT_DELAY)
            {
                m_cChat.Connect();
                m_fLastConnectBtnTime = GetTime();
            }
        
        UpdateConnectButton();
    }
   
    synchronized public void SetConnectionStatus( boolean bConnected, String sStatus )
    {
        super.SetConnectionStatus(bConnected, sStatus);
        m_cStatus.SetText( sStatus );
        
        m_bConnected = bConnected;
        UpdateConnectButton();
    }
    
    void UpdateConnectButton()
    {
        if (m_bConnected)
            ((UIButton)GetElem("ID_CONNECT_DISCONNECT")).SetText("&MenuNetChatRoomDisconnect&");
        else
            ((UIButton)GetElem("ID_CONNECT_DISCONNECT")).SetText("&MenuNetChatRoomConnect&");

    }
    
    
    void UpdateChatWindows(IChatWindow cWindow)
    {
        super.UpdateChatWindows(cWindow);
        if (m_cChat == null)
            return;
        ChatState cState = m_cChat.GetState();
        m_bConnected = cState.m_bConnected;
        
        SetConnectionStatus( IsChatConnected(), cState.m_sConnectionState );
    }
    
    public void ChatAcquire( IChatWindow cIChatWindow )
    {
        super.ChatAcquire(cIChatWindow);
        ChatConnect();
    }
    
    
    public void Acquire( IChat cChat )
	{
        super.Acquire(cChat);
        UpdateConnectButton();
    }
    
    
}

