public class MenuNetInGame extends InGameMenu
{
    Button m_cServerInfo = null;

    final static int ID_BTN_SERVERINFO = 313;
    
    int METHOD_TryShowServerFullInfo = 0;
	
	MenuNetServerFullInfo m_cMenuServerInfo = null;
    
    public void OnCreate()
    {
        super.OnCreate();
        METHOD_TryShowServerFullInfo = RegisterCallMethod("TryShowServerFullInfo");
        RegisterMessager();
    }
    
    public void OnDestroy()
    {
        UnregisterMessager();
        super.OnDestroy();

		if(m_cMenuServerInfo != null)
        {
            m_cMenuServerInfo.Remove();
            RemoveSprite(m_cMenuServerInfo);
            m_cMenuServerInfo.delete();
            m_cMenuServerInfo = null;
        }
    }

    void Init(MenuBackground cBack)
    {
        MenuModule = (ChromeMenuModule)GetModule();
        MenuModule.bMenuNetInGame = true;
        super.Init( cBack );
    }
    
    void OnUICommand(UIWindow cSender, int nCommand)
	{
        super.OnUICommand(cSender,nCommand);
        int nID = GetButtonId(cSender.m_sId);
        
        if(nCommand == EUIConst.CM_CLICK || nCommand == EUIConst.CM_DBCLICK)
        {
             switch(nID)
            {
            case ID_BTN_SERVERINFO:
                InitShowServerFullInfo();
                break;
                
            }
        }
    }
    
    boolean m_bWaitForServerFullInfo = false;
    
    void InitShowServerFullInfo()
    {
        ModuleNet cLevel = ModuleNet.sm_cCurrentLevel;
        
        if ( AmIServer() )
        {
            LogD(" Server\n");
            NetServerFullInfo cInfo = new NetServerFullInfo( cLevel );
            ShowServerFullInfo( cInfo );
        }
        else if ( AmIClient() )
        {
            LogD(" Client\n");
            FreeMsgSendRequestServerFullInfo( cLevel.GetGameInitInfo().GetServerInfo().GetServerAddr(),
                                              cLevel.GetGameInitInfo().GetServerInfo().GetGamePort(),
                                              EFreeMsg._REQUEST_SERVER_FULL_INFO_2);
            ModuleNet.nTimeOutCounter = ModuleNet.MAX_TIME_OUT;
            m_bWaitForServerFullInfo = true;                            
            TryShowServerFullInfo();
        }
    }
    
    void TryShowServerFullInfo()
    {
        ModuleNet cLevel = ModuleNet.sm_cCurrentLevel;
        
        if ( cLevel.m_cReceivedServerFullInfo != null )
        {
            m_bWaitForServerFullInfo = false;
            ShowServerFullInfo( cLevel.m_cReceivedServerFullInfo );
            cLevel.m_cReceivedServerFullInfo = null;
            return;
        }
                    
        if ( m_bWaitForServerFullInfo
              &&
             ModuleNet.nTimeOutCounter > 0 )
        {
            LogD(" waiting (" + ModuleNet.nTimeOutCounter + ") ...\n");
            ModuleNet.nTimeOutCounter--;
                
            CallMethodIn( METHOD_TryShowServerFullInfo, 1.0f );
        }
        else
        {
            if ( ModuleNet.nTimeOutCounter == 0 )
                LogD("ShowServerFullInfo time out\n");
            else
                LogD("Canceled\n");
            
            m_bWaitForServerFullInfo = false;
        }
        
    }
    
    void ShowServerFullInfo(NetServerFullInfo cInfo)
    {		
		/*java.util.Vector vParams = new java.util.Vector();
		vParams.add(cInfo);			
		MenuModule.SetMenu("MenuNetServerFullInfo", vParams);*/
	
		if(m_cMenuServerInfo == null)
		{
			m_cMenuServerInfo = (MenuNetServerFullInfo)CreateObjectNoInit( "MenuNetServerFullInfo" );
			m_cMenuServerInfo.InitObject();
			m_cMenuServerInfo.SetServerWindow(this,MenuModule);
		}
		m_cMenuServerInfo.SetServerFullInfo(cInfo);
        Hide();
        m_cMenuServerInfo.MoveTop();
        m_cMenuServerInfo.CallMethodIn( "Show", 0.0f );
    }
    
    //iMessageId : EFreeMsg._REQUEST_SERVER_FULL_INFO lub EFreeMsg._REQUEST_SERVER_FULL_INFO_2
    void FreeMsgSendRequestServerFullInfo( String sHostName, int nPort, int iMessageId )
    {
        LogD(" SEND " + EFreeMsg.GetFlagName(iMessageId) + "\n");
            
        FreeMessageNew( iMessageId );
        FreeMessagePackFloat( GetAbsoluteTime() );
        FreeMessageSend( EFreeMsg.TYPE_HOST, sHostName, nPort );
    }

}
