
/** Sieciowe inventory room
 */
public class MenuNetInventoryRoom extends ChromeInventoryMenu 
{
    private PlayerNet m_cPlayerNet = null;
        
    PlayerNet GetPlayerNet()
    {
        if ( m_cPlayerNet == null && GetModule() instanceof ModuleNet )
             m_cPlayerNet = ((ModuleNet)GetModule()).GetMainPlayerNet();
        return m_cPlayerNet;
    }
    
    void PlayerInit()
    {
        if (cPlayer == null)
        {
            cPlayer = (PlayerFake)CreateObjectLocal("PlayerNetFake");
            cPlayer.SetupInventory( GetPlayerNet(), this );
            SetupPosition(cInvFrame);
        }
        else
        {
            //CleanInventoryRoom();
            cPlayer.SetupInventory( GetPlayerNet(), this );
            SetupPosition(cInvFrame);
            //usuniecie z inwentory room, obiektow ktore _juz_ sa w inwentory
            UpdateInventoryRoom();
        }
    }
    
    void Init(MenuBackground cBack)
    {
        //wyczyszczenie inwentory room
        CleanInventoryRoom();
                
        //inicjalizacja, w tym wypelnienie inwentory room danymi ze skryptow
        super.Init( cBack );

        //usuniecie z inwentory room, obiektow ktore _juz_ sa w inwentory
        UpdateInventoryRoom();
        
        // podmiana znaczenia klawisza
        m_cBtnNextText1.SetText("");
        m_cBtnNextText2.SetText("");
        Button_Next.SetText("&SPAWN&");
    }
    
    public void OnInit()
    {
        super.OnInit();
        Button_Briefing.Hide();
    }
    
    InvObject CreateInvObjectDo(String sClassName)
    {
        if ( sClassName.compareTo( PlayerNet.GetInbornWeaponClass().getName() ) == 0 )
            return null;

        GameObject cObj = CreateObjectLocal( sClassName );
        InvObject  cInv = cObj instanceof InvObject ? (InvObject)cObj : null;
        if ( cInv != null )
        {
            if (cInv instanceof Ammo)
                ((Ammo)cInv).nCount = ((Ammo)cInv).nCapacity;
            
            cInv.m_bLocalObj = true;
        }
        return cInv;
    }
    
    
    void DeleteInvObject(InvObject cObj)
    {
        if ( cObj != null && cObj.m_bLocalObj )
            super.DeleteInvObject( cObj );
        // z tym obiektem nic nie robimy, zostanie skasowany 
        // po wyjsciu z inwentory room (po zaaplayowaniu listy
        // na serwerze, a na kliencie po wyslaniu jej do serwera
    }
    
    
    void ButtonNext()
    {
        LogD(" Wychodzimy z inventory room'u\n");
        
        Hide();
        ((InventoryPlayer) cPlayer.cInventory).Acquire( MenuModule, null );
        
        PlayerNet cPlayerNet = GetPlayerNet();
        cPlayer.StopUseInventory( cPlayerNet );
        cPlayerNet.RestoreAfterInventoryMenu();
        
        /*if (cPlayer != null)
        {
            cPlayer.delete();
            cPlayer = null;
        }*/
    }

    void CleanInventoryRoom()
    {
        if (GetInventoryRoom() != null)
            GetInventoryRoom().Clean();
        else
            CrashLog(this+" CleanInventoryRoom GetInventoryRoom() == null!!\n");
    }
    
    
    void UpdateInventoryRoom()
    {
        //najpierw oproznijmy inwentarz oraz skasujmy niepotrzebne obiekty
        for ( int nInvObj=0; nInvObj<cPlayer.cInventory.GetInvObjSize(); nInvObj++ )
        {
            InvObject cInvObj = cPlayer.cInventory.GetInvObject( nInvObj );
            
            if ( cInvObj == null )
                continue;
            
            //sprawdzmy czy taki jest przewidziany w inwentory room
            InventoryObjectInfo cRoomInfo = GetInventoryRoom().FindObject( cInvObj.nInvType, cInvObj.getClass().getName() );
			if (cRoomInfo == null)
            {
                /*CrashLog("Masz obiekt "+cInvObj.getClass().getName()+
                         " ktorego nie bylo zaplanowanego w inventory room!!!!\n");*/
			    continue; 
            }
            
            cRoomInfo.ChangeAmount( -1 );
        }
    }

    /** W grze sieciowej jest wpisany domyslnie jeden noz (lub raczki),
     * zatem przy tworzeniu default weapon trzeba go ominac
     * bo on nie ma szans wyleciec w metodzie Clean (jest lockaed)
     */
    boolean m_bSkipInbornWeapon = false;
    
    void DefaultWeapon()
    {
        m_bSkipInbornWeapon = true;
        super.DefaultWeapon();
        m_bSkipInbornWeapon = false;
    }
    

    public void OnDestroy()
    {
        //Nie wiem dlaczego Button_Weapon_Desc nie jest kasowane w OnDestroy,
        //nie bede tego dociekal, poprostu wylacze wyswietlanie i tyle...
        ClearDes();
        super.OnDestroy();
    }
    
    InventoryRoom GetInventoryRoom()
    {
        if ( cInventoryRoom == null && GetPlayerNet() != null )
             cInventoryRoom = GetPlayerNet().GetInventoryRoom();
        if ( cInventoryRoom == null )
             CrashLog(this+" cInventoryRoom == null!!!!\n");
        return cInventoryRoom;
    }
}
