/** Ekran do wyboru profila gracza
 */
public class MenuNetPlayerProfile extends ChromeMenuWindow 
{
    {
	nMovieIn = 21;
	nMovieLoop = 22;
	nMovieOut = 23;
	}
    
    static MenuNetPlayerProfile m_cSingleton = null;
    
    UIComboBox m_cProfileComboBox       = null;
    UIEdit     m_cNameEdit              = null;
	UIComboBox m_cMeshComboBox          = null;
    UIStatic[] m_aSkinLabels            = null;
    UIButton[] m_aSkinPreviousButtons   = null;
    UIButton[] m_aSkinNextButtons       = null;
    
    UIButton   m_cControlsButton        = null;
    UIButton   m_cSaveProfileButton     = null;
	UIButton   m_cDeleteProfileButton   = null;
    
    NetPlayerProfile   m_cProfile   = new NetPlayerProfile();
    NetPlayerModelInfo m_cModelInfo = null;
    
    MenuNetSetProfileName cMenuSetProfileName = null;
    
    
    
    boolean m_bDisableMesh = false;
    
    /**
     * Flaga mowiaca o tym, ze aktualnie wybrany
     * jest profil domyslny,
     * w takim przypadku deaktywujemy edycje
     * profilu (nicka, mesha, skinow) 
     */
    boolean m_bChoosenDefaultProfile = false;
    
    
    void Init(MenuBackground cBack)
    {
        MenuModule   = GetModule() instanceof ChromeMenuModule ?
                       (ChromeMenuModule)GetModule() : null ;
        m_cSingleton = this;
		
        //poszczegolne elementy profilu
        //lista dostepnych profili 
		m_cProfileComboBox = (UIComboBox)GetElem("ID_COMBOBOX_PLAYER_NAME");
        //nick gracza wybranego profilu
        m_cNameEdit        = (UIEdit)GetElem("ID_311");
		m_cNameEdit.m_sForbiddenChars = "\\/";
        //lista dostepnych modeli
		m_cMeshComboBox    = (UIComboBox)GetElem("ID_COMBOBOX_MODEL_NAME");
        
        //przycisk do kontrolsow i saveow, zeby mozna
        //bylo je z kodu desable'owac
        m_cControlsButton    = (UIButton)GetElem("ID_301");
        m_cSaveProfileButton = (UIButton)GetElem("ID_345");
		m_cDeleteProfileButton = (UIButton)GetElem("ID_349");
        
        //poszczegolne skiny
        int nSkins = NetPlayerModelInfo.GetSkinsPartialCnt();
        m_aSkinLabels          = new UIStatic[ nSkins ];
        m_aSkinPreviousButtons = new UIButton[ nSkins ];
        m_aSkinNextButtons     = new UIButton[ nSkins ];
        for ( int i = 0; i < nSkins; i++ )
        {
            m_aSkinLabels[i]            = (UIStatic)GetElem("ID_37"+i);
            m_aSkinPreviousButtons[i]   = (UIButton)GetElem("ID_15"+i);
            m_aSkinNextButtons[i]       = (UIButton)GetElem("ID_16"+i);
        }
        
        //odnajdujemy profile na dysku i wpisujemy do combo
        FindProfiles();
        //podobnie z modelami
        FindNetModels();
        
        //tworzymy i ladujemy aktualny profil
        m_cProfile = new NetPlayerProfile();
        m_cProfile.Load();
        //nastepnie wpisujemy go do kontrolek
        LoadProfile();
        //no i odswiezamy stan poszczegolnych kontrolek
        RefreshButtons();
        //tworzymy modul na ktorym bedziemy obserwowali model gracza
        CreateShowMeshModule();
        
        ShowInfo("Init");
        
        
        //tymczasowe schowanie buttonow
        m_cMeshComboBox.Hide();
        ((UIStatic)GetElem("ID_379")).Hide();
    }

    void CreateShowMeshModule()
    {
        if ( m_bDisableMesh )
            return;

		if(MenuModule.m_c3DSceneModule != null)
			MenuModule.m_c3DSceneModule.CreateHoloMesh();
    }
    
    
    public void Hide()
    {
        super.Hide();
    }
    
    void OnUICommand(UIWindow cSender, int nCommand)
	{
		super.OnUICommand(cSender,nCommand);
		if(nCommand == EUIConst.CM_EDIT_ENTER)
		{
			if (cSender.m_sId.equals("ID_311"))
			{
                if ( m_cNameEdit.GetText().length() > 0 )
                {
                    //ktos wpisal nowego nicka
                    String sName = m_cNameEdit.GetText();
                    //wpiszmy go do aktualnego profilu
                    m_cProfile.SetPlayerName( sName );
                    
                    ShowInfo("OnSetPlayerName "+sName);
                }
				return;
			}
		}else
			if(nCommand == EUIConst.CM_CLICK)
			{
				if (cSender.m_sId.equals("ID_BUTTON"))
				{//wybranie jednego z buttonow w ktoryms z comboboxow
					if (cSender.m_cSupervisor.m_cSupervisor.m_cSupervisor.m_sId.equals("ID_COMBOBOX_PLAYER_NAME"))
					{
                        //zmieniono aktualny profile
                        //TODO: obsluzyc fakt jak zmieniono na ten sam
						//SetEditCheckFalse();
						RefreshProfile();
					}else
					if (cSender.m_cSupervisor.m_cSupervisor.m_cSupervisor.m_sId.equals("ID_COMBOBOX_MODEL_NAME"))
					{
                        //TODO - obsluga zmiany mesha
                        String sName = m_cMeshComboBox.GetSelected().GetText();
                        LogLine("Zmieniamy Mesha dla gracza");
                        CreateModelInfoIfNeeded();
						RefreshMesh();
						RefreshButtons();
                        ShowInfo("OnMeshChange "+sName);
					}
					return;
				}
				
				if(cSender.m_sId.equals("ID_COMBO_TRIGGER"))
				{	
					//CallMethodIn("SetEditCheckFalse",0.0f);
					return;
				}
			}else
				if(nCommand == EUIConst.CM_SEL)
				{
					if (cSender.m_sId.equals("ID_BUTTON"))
					{
						return;					
					}
				}
		
		int nID = GetButtonId(cSender.m_sId);
            
		if(nCommand == EUIConst.CM_CLICK || nCommand == EUIConst.CM_DBCLICK)
        {
             switch(nID) 
            {
            case ENetPlayerProfileUI.ID_BTN_NEWPROFILE:
                {
                    //wywolanie okienka do wpisania nazwy nowego profilu
                    CallMethodIn("OnNewProfile", 0);
                    break;
                }
			case ENetPlayerProfileUI.ID_BTN_DELEEPROFILE:
				{
					ShowYesNoDialog(ENetPlayerProfileUI.ID_BTN_DELEEPROFILE, "&DELETE PROFILE&",
									Text.Get("&MenuNetPlayerprofileDeleteQuestion&")+" "+m_cProfileComboBox.GetSelected().GetText()+"?", 
									"&BtnYes&", "&BtnNo&");
					break;
				}
            case ENetPlayerProfileUI.ID_BTN_SAVE:
                {
                    SaveProfile();
                    break;
                }
            case ENetPlayerProfileUI.ID_BTN_CANCEL:
                {
                    if(MenuModule.m_c3DSceneModule != null)
						MenuModule.m_c3DSceneModule.DeleteLaterHoloMesh();
                    MenuModule.SetMenu("ChromeNetMainMenu");
                    break;
                }
            case ENetPlayerProfileUI.ID_BTN_BACK:
                {
                    Discard();
                    break;    
                }
            case ENetPlayerProfileUI.ID_BTN_CONTROLS:
                {
                    SaveProfile();
                    //MenuModule.m_c3DSceneModule.DeleteHoloMesh();
                    MenuModule.SetMenu("MenuNetControls");
                    break;
                }
            case ENetPlayerProfileUI.ID_BTN_PREVIOUS_0:
            case ENetPlayerProfileUI.ID_BTN_PREVIOUS_1:
            case ENetPlayerProfileUI.ID_BTN_PREVIOUS_2:
            case ENetPlayerProfileUI.ID_BTN_PREVIOUS_3:
            case ENetPlayerProfileUI.ID_BTN_PREVIOUS_4:
            case ENetPlayerProfileUI.ID_BTN_PREVIOUS_5:
                {
                    int nElement = nID - ENetPlayerProfileUI.ID_BTN_PREVIOUS_0;
                    ChangeSkin( nElement, -1 );
                    RefreshButtons();
                    break;
                }
            case ENetPlayerProfileUI.ID_BTN_NEXT_0:
            case ENetPlayerProfileUI.ID_BTN_NEXT_1:
            case ENetPlayerProfileUI.ID_BTN_NEXT_2:
            case ENetPlayerProfileUI.ID_BTN_NEXT_3:
            case ENetPlayerProfileUI.ID_BTN_NEXT_4:
            case ENetPlayerProfileUI.ID_BTN_NEXT_5:
                {
                    int nElement = nID - ENetPlayerProfileUI.ID_BTN_NEXT_0;
                    ChangeSkin( nElement, +1 );
                    RefreshButtons();
                    break;
                }
            }
        }
    }
    
    
    void OnNewProfile()
    {
        if(cMenuSetProfileName != null)
        {
            cMenuSetProfileName.Remove();
            RemoveSprite(cMenuSetProfileName);
            cMenuSetProfileName.delete();
        }
        
        cMenuSetProfileName = (MenuNetSetProfileName)CreateObjectNoInit( "MenuNetSetProfileName" );
        cMenuSetProfileName.InitObject();
        Hide();
        cMenuSetProfileName.MoveTop();
        cMenuSetProfileName.CallMethodIn( "Show", 0.0f );
    }
	
	void OnDeleteProfile()
	{
        //najpierw wolamy save, zeby na dysk zapisalo sie info jaki profil
        //jesli aktualnie wybrany
        SaveProfile();
		if ( NetPlayerProfile.DeleteCurrentProfile() )
		{
			int iLastSelected = m_cProfileComboBox.GetSelection();
			//TODO jak juz bedzie dzialalo kasowanie profilu to wywalic go tez z combo
			m_cProfileComboBox.m_cList.RemoveItem(iLastSelected);
			//przy zalozeniu ze default profile nie da sie skasowac, a jest ono pierwsze 
			//ustawiamy selekcje na wczesniejszy element
			m_cProfileComboBox.SetSelection( iLastSelected -1);			
			RefreshProfile();
		}
	}
	
	void RefreshProfile()
	{
		m_cProfile = new NetPlayerProfile();
		//pobranie wyselekcjonowanego profile
		String sProfileName = m_cProfileComboBox.GetSelected().GetText();
		//zaladowanie go do pamieci
		m_cProfile.Load( sProfileName );
		//i przepisanie do kontrolek
		LoadProfile();
		//no i oczywiscie odswiezenie buttonow
		RefreshButtons();
		ShowInfo("OnProfileChange "+sProfileName);
	}
	
	/**
     * Request stworzenia nowego profilu
     */
	void CreateNewPlayerProfile(String sProfileName)
	{
        //najpierw sprawdzmy czy mozna taki profil dodac
        int nVerify = NetPlayerProfile.VerifyProfileName( sProfileName );
        
        if ( nVerify == NetPlayerProfile._NEW_PROFILE_NAME_OK )
        {
            //wszystko ok, zatem jedziemy z koksem
            ShowInfo("PreCreateNewProfile "+sProfileName);
            
            //tworzymy takowy profil
		    m_cProfile = new NetPlayerProfile( sProfileName );
            //dodajemy do combo boxa
            m_cProfileComboBox.AddItem( sProfileName, null );
            
            //ustawiamy jako aktualnie wybrany
            //TODO: to w zasadzie jeze nie potrzebne bo LoadProfile(); to zrobi
            for( int i = 0 ; i < m_cProfileComboBox.m_cList.vItems.size(); i++ )
            {
                if ( sProfileName.equalsIgnoreCase( ((UIMenuButton)m_cProfileComboBox.m_cList.vItems.elementAt(i)).GetText() ))
                {
                    m_cProfileComboBox.SetSelection( i );
                    break;
                }
            }
            
            //teraz zaladowujemy do kontrolek
            LoadProfile();
            //odswiezamy ewentualnie mesha
            RefreshMesh();
            //i kontrolsy
            RefreshButtons();
            //na koniec sejwujemy, zeby juz taki profil istnial na dysku
            SaveProfile();
            
            ShowInfo("PostCreateNewProfile "+sProfileName);
        }
        else
        {
            //nie udalo sie z jakiegos (nVerify) powodu
            //TODO: obsluga bledu, jakies okienko
			if(nVerify==NetPlayerProfile._NEW_PROFILE_NAME_EXIST)
				ShowOKDialog(nVerify, "&Error&", "&Profile already exist&", "&BtnYes&");			
			else if(nVerify==NetPlayerProfile._NEW_PROFILE_NAME_WRONG)
				ShowOKDialog(nVerify, "&Error&", "&Wrong profile name&", "&BtnYes&");	
			else if (nVerify==NetPlayerProfile._NO_PROFILE_DIR)
				ShowOKDialog(nVerify, "&Error&", "&Profile directory not exist&", "&BtnYes&");	
        }
	}
    
	void RefreshMesh(float fDelay)
    {
        DisableCallMethod("RefreshMesh");
        CallMethodIn("RefreshMesh",fDelay);
    }
   
	void RefreshMesh()
    {
        DisableCallMethod("RefreshMesh");

        if(MenuModule.m_c3DSceneModule != null)
			MenuModule.m_c3DSceneModule.SetModel( m_cModelInfo );
    }
    
        
    void RefreshButtons()
    {
        //pobieramy ktore buttony maja byc aktywne
        boolean[] aAvailability = m_cModelInfo != null ?
                                  m_cModelInfo.GetChangeAvailability():
                                  new boolean[m_aSkinLabels.length];
        //pobieramy ktore labele maja byc aktywne
        boolean[] aActivity     = m_cModelInfo != null ?
                                  m_cModelInfo.GetCurrentActivity():
                                  new boolean[m_aSkinLabels.length];
        
        for ( int i = 0; i< aAvailability.length; i++ )
        {
            //buttony sa niektywne jak ModelInfo "nie kaze" lub
            //aktualnie jest wybrany defaultowy profil (ktorego nie mozna edytowac)
            m_aSkinPreviousButtons[i].SetDisabled( !aAvailability[ i ]);// || m_bChoosenDefaultProfile );
            m_aSkinNextButtons[i].SetDisabled( !aAvailability[ i ]);// || m_bChoosenDefaultProfile );
            
            //kolor labela jest nastepujacy
            //bialy gdy dany element jest wybrany i mozna go zmieniac
            //lekko szary gdy element nie jest wybrany (aktywny) ale mozna go zmieniac
            //mocno szary jak element ani nie jest wybrany, ani niz mozna go zmieniac
            //przez fakt ze element jest wybrany (aktywny) rozumiemy
            //ze skin Helmu zostal wybrany taki ze faktycznie jest helm (a nie "nohelmet")
            Vector vColor = aAvailability[ i ] && aActivity [ i ] ? 
                            new Vector (1.0f,1.0f,1.0f):
                            (aAvailability[ i ] ? new Vector (0.75f,0.75f,0.75f) : new Vector (0.5f,0.5f,0.5f));
            m_aSkinLabels[i].SetTextColorV( vColor );
            m_aSkinLabels[i].SetText( m_aSkinLabels[i].GetText() );
        }
        
        //gdy mamy wybrany defaultowy profil to nie mozna zmieniac skinow oraz:
        //edytowac nicka
        //m_cNameEdit.SetDisabled( m_bChoosenDefaultProfile  );
        //zmieniac mesha
        //m_cMeshComboBox.SetDisabled( m_bChoosenDefaultProfile );
        //zmieniac kontrolsow
        //m_cControlsButton.SetDisabled( m_bChoosenDefaultProfile );
        //zapisywac profilu
        //m_cSaveProfileButton.SetDisabled( m_bChoosenDefaultProfile );
		//kasowac profilu
		m_cDeleteProfileButton.SetDisabled( m_bChoosenDefaultProfile );
    }
        
        
    /**wczytujemy profil gracza z obiektu do kontrolek*/
    void LoadProfile()
    {   
        //pobiezmy nazwe biezxacego profilu
        String sPlayerProfile = m_cProfile.GetProfileName();
        //dymyslnego profilu nie bedzie mozna edytowac wiec warto 
        //sobie zapamietac taki fakt
        //MK: zaremowalem bo PZ zyczyl sobie zeby mozna bylo edytowac
        //domyslny profil
        m_bChoosenDefaultProfile = NetPlayerProfile.IsDefaultProfileName( sPlayerProfile ); 
        
        LogD("Player profile: "+sPlayerProfile+"\n");
        
        //odnajdzmy nazwe biezxacego profilu w combo 
        int i;
        for( i = 0; i < m_cProfileComboBox.m_cList.vItems.size(); i++)
        {
            if (sPlayerProfile.equalsIgnoreCase(((UIMenuButton)m_cProfileComboBox.m_cList.vItems.elementAt(i)).GetText())) 
                break;
        }
                    
        LogD("Profile index: " + i + "\n");
        if (i < m_cProfileComboBox.m_cList.vItems.size())
        {
            //profil znaleziony na pozycji i, zaznaczmy ja jako wybrana
            //m_cProfileComboBox.m_cList.SetSelection(i);
			m_cProfileComboBox.SetSelection(i);
        }
        else
        {
            LogR(" Profil "+sPlayerProfile+" nie zostal znaleziony w ComboBoxie\n");
            ShowInfo("LoadProfile");
            //profil nie zostal znaleziony w combo
            //w zasadzie takich przypadkow nie powinno byc, ale jesli juz to
            //dodajemy do combo
            int iIndex = m_cProfileComboBox.AddItem( sPlayerProfile, null );
            m_cProfileComboBox.SetSelection(iIndex);
        }

        //pole edycyjne imienia ustawiamy zgodnie z danymi w obiekcie
        m_cNameEdit.SetText( m_cProfile.GetPlayerName() );
            
        //teraz musimy mesha odszukac w comboboxie podobnie jak profil
        String sMeshName = m_cProfile.GetMeshName();
        LogD("Mesh name: \"" + sMeshName + "\"\n");
        
        for( i = 0 ; i < m_cMeshComboBox.m_cList.vItems.size(); i++ )
        {
            String sMesh = ((UIMenuButton)m_cMeshComboBox.m_cList.vItems.elementAt(i)).GetText();
            
            if (sMeshName.equalsIgnoreCase( sMesh )) 
                break;
        }
                    
        LogD("Mesh index: " + i + "\n");
        //jesli z jakis przyczyn nie znalazl mesha na liscie to ustawiamy mesha o indexie 0
        if ( i >= m_cMeshComboBox.m_cList.vItems.size() )
            i = 0;
        m_cMeshComboBox.SetSelection( i );

        //tworzymy obiekt z informacjami o modelu dla nowego mesha
        m_cModelInfo = new NetPlayerModelInfo( m_cProfile );
        //i odswiezamy mesha na obrazku
        RefreshMesh();
    }
    
    
    void ChangeSkin(int nElement,int nChange)
    {
        if ( nChange > 0 )
            m_cModelInfo.SetNextPartialSkin( nElement );
        else                
            m_cModelInfo.SetPreviousPartialSkin( nElement );
        RefreshMesh( 0.0f );
    }
    
    int m_nElement = 0;
    
    /**Zapisanie ustawien */
    void SaveProfile()
    {
        m_cProfile.SetProfileName( ((UIMenuButton)m_cProfileComboBox.m_cList.vItems.elementAt(m_cProfileComboBox.GetSelection())).GetText() );
        m_cProfile.SetPlayerName( m_cNameEdit.GetText() );
        m_cProfile.SetModel( m_cModelInfo );
        m_cProfile.Save();
        
        //FindProfiles();

        //zaznaczmy nagrany profil w ComboBoxie
        //PlayerProfileComboBox.SetSelection(PlayerProfileComboBox.m_cList.vItems.size() - 1);
    }
    
    /**Pszeszukujemy katalog z profilami i nazwy profili wpisujemy do ComboBox
     */
    void FindProfiles()
    {
        StringsList aList               = NetPlayerProfile.FindProfiles();
        String      sCurrentProfileName = NetPlayerProfile.GetCurrentProfileName();
        int nSelection = 0;
		m_cProfileComboBox.m_cList.Clear();
        for ( int i=0; i<aList.GetSize(); i++ )
        {
            String sProfileName = aList.GetStringAt( i );
            if ( !NetGameTools.IsStringValid( sProfileName ) )
                continue;
            m_cProfileComboBox.AddItem( sProfileName, null );
                
            if ( sProfileName.equalsIgnoreCase( sCurrentProfileName ) )
                nSelection = i ;        
        }
        //wyselekcjonujmy profil ostanio uzywany
		m_cProfileComboBox.SetSelection( nSelection );
    }   
    
    /**Pszeszukuje katalog z modelami i dodaje je do ComboBoxa*/
    void FindNetModels()
    {
        java.util.Vector aList = NetPlayerProfile.FindNetModels();
        
        m_cMeshComboBox.m_cList.Clear();
        for ( int i=0; i<aList.size(); i++ )
        {
            if ( aList.elementAt( i ) instanceof String )
            {
                String sModelName = (String)aList.elementAt( i );
                m_cMeshComboBox.AddItem( sModelName, null );
            }
        }
        m_cMeshComboBox.SetSelection( 0 );
        CreateModelInfoIfNeeded();
    }
    
    void CreateModelInfoIfNeeded()
    {
        String sMeshPathName = NetPlayerProfile.sm_sModelDir + 
                               m_cMeshComboBox.GetSelected().GetText();
        if ( m_cModelInfo != null )
        {
            LogR("Stary :"+sMeshPathName+" nowy:"+m_cModelInfo.GetMeshPathName()+"\n");
            if ( sMeshPathName.compareTo( m_cModelInfo.GetMeshPathName() ) == 0 )
                return;
        }
        m_cModelInfo = new NetPlayerModelInfo( sMeshPathName );
    }

    
    public void OnDestroy()
    {
        if ( cMenuSetProfileName != null )
        {
            RemoveSprite( cMenuSetProfileName );
            cMenuSetProfileName.delete();
            cMenuSetProfileName = null;	 
        }
        super.OnDestroy();
    }
    
    

    void ShowInfo(String sInfo)
    {
        LogR("--------------------------------------\n");
        LogR(" ShowInfo "+sInfo+"\n");
        LogR(" Profile "+
             m_cProfile.GetProfileName()+" "+
             m_cProfile.GetPlayerName()+" "+
             m_cProfile.GetMeshName()+" "+"\n");
        
        
        LogR(" Controls\n");
        String sText = "";
        int i = 0;
        for( ; i < m_cProfileComboBox.m_cList.vItems.size(); i++)
        {
            sText = ((UIMenuButton)m_cProfileComboBox.m_cList.vItems.elementAt(i)).GetText();
            LogR("Profile "+i+" "+sText+"\n");
        }
        LogR("Profile selected "+m_cProfileComboBox.GetSelection()+"\n");
        
        LogR("Name "+m_cNameEdit.GetText()+"\n");
        
        for( i = 0 ; i < m_cMeshComboBox.m_cList.vItems.size(); i++ )
        {
            String sMesh = NetPlayerProfile.sm_sModelDir +
                          ((UIMenuButton)m_cMeshComboBox.m_cList.vItems.elementAt(i)).GetText();
            LogR("Mesh "+i+" "+sMesh+"\n");
        }
        LogR("Mesh selected "+m_cMeshComboBox.GetSelection()+"\n");
        LogR("--------------------------------------\n");
    }
	
	void OnYesFromDlg(int nID)
    {
        super.OnYesFromDlg(nID);
        switch(nID)
        {
			case ENetPlayerProfileUI.ID_BTN_DELEEPROFILE:
				CallMethodIn("OnDeleteProfile",0);            
            break;
        }
    }
    
    void OnNoFromDlg(int nID)
    {
        super.OnNoFromDlg(nID);
        switch(nID)
        {
            case ENetPlayerProfileUI.ID_BTN_DELEEPROFILE:
                break;
        }
    }
	
	void Discard()
    {
		if(!CanDiscard())
			return;
		if (m_cProfileComboBox.m_bExpanded)
		{
			m_cProfileComboBox.Collapse();
			return;
		}
		SaveProfile();
		if(MenuModule.m_c3DSceneModule != null)
			MenuModule.m_c3DSceneModule.DeleteLaterHoloMesh();
		MenuModule.SetMenu("ChromeNetMainMenu");
	}
	
}
