public class GameStatusMsgMngrCTF extends GameStatusMsgManager
{
    GameInfoMsgCTF m_cBlueFlag  = null,
                   m_cRedFlag   = null;
    
    GameInfoMsgDataCTF m_cDataCTF = null;
    
    void OnCreate()
    {
        super.OnCreate();
        
        m_cScoreMsg = new GameScoreMsgTeam();
        
        m_cData     = 
        m_cDataCTF  = new GameInfoMsgDataCTF();
        
        m_cBlueFlag = new GameInfoMsgCTF( GetDataFlagFromId( NetTeamInfo.BLUE ) );
        m_cRedFlag  = new GameInfoMsgCTF( GetDataFlagFromId( NetTeamInfo.RED ) );
        
        AddInfoMsg( m_cBlueFlag );
        AddInfoMsg( m_cRedFlag );
    }
    
    void OnDestroy()
    {
        super.OnDestroy(); 
        
        m_cBlueFlag = null;
        m_cRedFlag  = null;
        m_cDataCTF  = null;
    }

    
    void FlagCaptured( int nFlag, int nPlayerInfoId )
    {
        GameInfoMsgCTF cFlag = GetFlagFromId( nFlag );
        if ( cFlag == null )
            return;
        cFlag.Captured( nPlayerInfoId );
        StatusChanged();
    }
    void FlagDropped( int nFlag )
    {
        GameInfoMsgCTF cFlag = GetFlagFromId( nFlag );
        if ( cFlag == null )
            return;
        cFlag.Dropped();
        StatusChanged();
    }
    
    void FlagReturned( int nFlag )
    {
        GameInfoMsgCTF cFlag = GetFlagFromId( nFlag );
        if ( cFlag == null )
            return;
        cFlag.Returned();
        StatusChanged();
    }
    void FlagDelivered( int nFlag )
    {
        GameInfoMsgCTF cFlag = GetFlagFromId( nFlag );
        if ( cFlag == null )
            return;
        cFlag.Delivered();
        StatusChanged();
    }
    
    GameInfoMsgCTF GetFlagFromId( int nFlag )
    {
        if ( nFlag == NetTeamInfo.BLUE )
            return m_cBlueFlag;
        else if ( nFlag == NetTeamInfo.RED )
            return m_cRedFlag;
        return null;
    }
    
    GameInfoMsgDataCTFFlag GetDataFlagFromId( int nFlag )
    {
        if (( m_cDataCTF != null ) &&
            ( nFlag == NetTeamInfo.BLUE || nFlag == NetTeamInfo.RED) )
            return m_cDataCTF.m_aFlags[ nFlag -1 ];
        return null;
    }

    void StatusChanged()
    {
        if ( m_cData instanceof GameInfoMsgDataCTF )
        {
            int nFlag = NetTeamInfo.BLUE;
            GameInfoMsgDataCTFFlag cData = GetDataFlagFromId( nFlag );
            m_cBlueFlag.Update( cData.m_nStatus, GetPlayerTeamId() != nFlag );
            
            nFlag = NetTeamInfo.RED;
            cData = GetDataFlagFromId( nFlag );
            m_cRedFlag.Update( cData.m_nStatus, GetPlayerTeamId() != nFlag );
        }
        super.StatusChanged();
    }
    
    
    
    void UpdateInfo()
    {
        super.UpdateInfo();
        UpdateInfoFlag();
    }
    
    void UpdateInfoFlag()
    {
        //jezeli nie jestesmu aktywni to nic tu po nas
        if ( ! IsActive() )
            return;
        
        StatusChanged();
    }
}
