/**
 * Komunikaty o stanie gry
 */
public class GameInfoMsg extends GameStatusMsg
{
    GameStatusMsgManager m_cManager = null;
    void SetManager( GameStatusMsgManager cManager) { m_cManager = cManager; }
    
    java.util.Vector m_aTexts = new java.util.Vector();
    void AddText(TextGameInfoMsgCondition cText)
    {
        if ( m_aTexts != null && cText instanceof TextGameInfoMsgCondition )
            m_aTexts.addElement( cText );
    }
    
    void Destroy()
    {
        m_cManager = null;
        m_aTexts.removeAllElements();
    }
    
    TextGameInfoMsgCondition GetText(int i)
    {
        if ( m_aTexts != null && i >= 0 && i < m_aTexts.size() )
            return (TextGameInfoMsgCondition) m_aTexts.get( i );
        return null;
    }
    int GetTextCnt()
    {
        return m_aTexts.size();
    }
    int GetCurrentTextIndex()
    {
        if ( m_cText != null )
            return m_aTexts.indexOf( m_cText );
        return -1;
    }
    TextGameInfoMsgCondition GetLastText()
    {
        if ( GetTextCnt() > 0 )
            return GetText( GetTextCnt() - 1 );
        return null;
    }
    
    //parametry aktualnego tekstu
    TextGameInfoMsg m_cText = null;
    
    String GetText(){ return m_cText!=null ? m_cText.GetText():null; }
    int    GetPriority(){ return m_cText!=null ? m_cText.GetPriority():-1; }
    String GetSound(){ return m_cText!=null ? m_cText.GetSound():null; }
    Vector GetColor(){ return m_cText!=null ? m_cText.GetColor():NetMsg._COLOR_DEFAULT; }
    
    boolean m_bModeId = false;
    
    void Update(float fValue)
    {
        int nNext    = m_bModeId ? -1 : GetCurrentTextIndex();
        //0 po to zeby obslugiwac "cofanie" komunikatow
        for ( int i = 0/*nCurrent + 1*/; i < GetTextCnt(); i++ )
        {
            TextGameInfoMsgCondition cTextCnd = GetText( i );
            
            if ( cTextCnd != null && cTextCnd.CanShow( fValue ) )
                nNext = i;
        }
        Use( nNext );
    }
    
    void Use( int nText )
    {
        if ( GetCurrentTextIndex() != nText )
        {
            m_cText = GetText( nText );
            
            if ( m_cManager != null )
                m_cManager.OnInfoMsgChange( this );
        }
    }

    
    void Used()
    {
        for ( int i = 0; i < GetTextCnt(); i++ )
        {
            TextGameInfoMsgCondition cTextCnd = GetText( i );
            if ( cTextCnd != null )
                 cTextCnd.Used( m_cText );
        }
    }

}


