public class VoiceManager extends VoiceManagerBase
{
    private NetVoice m_cAutoVoiceOnGrenadeThrow = null;
    private NetVoice[] m_aAutoVoicesOnTakeControlPoint = null;
    private NetVoice[] m_aAutoVoicesOnLostControlPoint = null;
    private NetVoice[] m_aAutoVoicesOnTakeMostOfControlPoints = null;
    private NetVoice[] m_aAutoVoicesOnLostMostOfControlPoints = null;
    private NetVoice[] m_aAutoVoicesOnTimeOutLoos = null;
    private NetVoice[] m_aAutoVoicesOnTimeOutWin = null;
    private NetVoice[] m_aAutoVoicesOnTimeOut = null;
    private NetVoice[] m_aAutoVoicesOnGoingToLose = null;
    private NetVoice[] m_aAutoVoicesOnGoingToWin = null;
    private NetVoice[] m_aAutoVoicesOnFriendlyFire = null;
    private NetVoice[] m_aAutoVoicesOnTeamKill = null;
    private NetVoice[] m_aAutoVoicesOnAttackAssaultObjective = null;
    private NetVoice[] m_aAutoVoicesOnTakeFlag = null;
    private NetVoice[] m_aAutoVoicesOnLostFlag = null;

    
   
    VoiceManager()
    {
        super();
        
        //Orders
        Add( new NetVoiceOrder( "&Voice Hold This Position!&", "MP-V02" ) );
        Add( new NetVoiceOrder( "&Voice Regroup!&", "MP-V03" ) );
        Add( new NetVoiceOrder( "&Voice Follow Me!&", "MP-V04" ) );
        Add( new NetVoiceOrder( "&Voice Go Go Go!&", "MP-V05" ) );
        Add( new NetVoiceOrder( "&Voice Fall Back!&", "MP-V06" ) );
        Add( new NetVoiceOrder( "&Voice Stick Together!&", "MP-V07" ) );
        Add( new NetVoiceOrder( "&Voice Attack!&", "MP-V19" ) );
        Add( new NetVoiceOrder( "&Voice Defend Position!&", "MP-V20" ) );
        //Requests
        Add( new NetVoiceRequest( "&Voice Cover Me!&", "MP-V01" ) );
        Add( new NetVoiceRequest( "&Voice Need Backup!&", "MP-V10" ) );
        Add( new NetVoiceRequest( "&Voice Requesting Pickup!&", "MP-V15" ) );
        Add( new NetVoiceRequest( "&Voice Medic!&", "MP-V17" ) );
        Add( new NetVoiceRequest( "&Voice Need Ammo!&", "MP-V21" ) );
        Add( new NetVoiceRequest( "&Voice Get in!&", "MP-V22" ) );
        //Answers
        Add( new NetVoiceAnswer( "&Voice Roger That!&", "MP-V08" ) );
        Add( new NetVoiceAnswer( "&Voice Negative!&", "MP-V12" ) );
        Add( new NetVoiceAnswer( "&Voice Enemy Spotted!&", "MP-V09" ) );
        Add( new NetVoiceAnswer( "&Voice Enemy Vehicle!&", "MP-V23" ) );
        Add( new NetVoiceAnswer( "&Voice Taking Fire!&", "MP-V24" ) );
        Add( new NetVoiceAnswer( "&Voice Clear!&", "MP-V11" ) );
        
        InitAutoVoices();
    }
    
    void InitAutoVoices()
    {
        m_cAutoVoiceOnGrenadeThrow = new NetVoice( "&Voice Fire In The Hole!&", "MP-V16" );
        Add( m_cAutoVoiceOnGrenadeThrow );
        
        m_aAutoVoicesOnTakeControlPoint = new NetVoice[ 5 ];
        m_aAutoVoicesOnTakeControlPoint[ 0 ] = new NetVoice("01a");
        m_aAutoVoicesOnTakeControlPoint[ 1 ] = new NetVoice("01b");
        m_aAutoVoicesOnTakeControlPoint[ 2 ] = new NetVoice("01c");
        m_aAutoVoicesOnTakeControlPoint[ 3 ] = new NetVoice("01d");
        m_aAutoVoicesOnTakeControlPoint[ 4 ] = new NetVoice("01e");
        Add( m_aAutoVoicesOnTakeControlPoint );
        
        m_aAutoVoicesOnLostControlPoint = new NetVoice[ 3 ];
        m_aAutoVoicesOnLostControlPoint[ 0 ] = new NetVoice("02a");
        m_aAutoVoicesOnLostControlPoint[ 1 ] = new NetVoice("02b");
        m_aAutoVoicesOnLostControlPoint[ 2 ] = new NetVoice("02c");
        Add( m_aAutoVoicesOnLostControlPoint );
        
        m_aAutoVoicesOnTakeMostOfControlPoints = new NetVoice[ 4 ];
        m_aAutoVoicesOnTakeMostOfControlPoints[ 0 ] = new NetVoice("03a");
        m_aAutoVoicesOnTakeMostOfControlPoints[ 1 ] = new NetVoice("03b");
        m_aAutoVoicesOnTakeMostOfControlPoints[ 2 ] = new NetVoice("03c");
        m_aAutoVoicesOnTakeMostOfControlPoints[ 3 ] = new NetVoice("03d");
        Add( m_aAutoVoicesOnTakeMostOfControlPoints );
        
        m_aAutoVoicesOnLostMostOfControlPoints = new NetVoice[ 3 ];
        m_aAutoVoicesOnLostMostOfControlPoints[ 0 ] = new NetVoice("04a");
        m_aAutoVoicesOnLostMostOfControlPoints[ 1 ] = new NetVoice("04b");
        m_aAutoVoicesOnLostMostOfControlPoints[ 2 ] = new NetVoice("04c");
        Add( m_aAutoVoicesOnLostMostOfControlPoints );
        
        m_aAutoVoicesOnTimeOutLoos = new NetVoice[ 3 ];
        m_aAutoVoicesOnTimeOutLoos[ 0 ] = new NetVoice("05a");
        m_aAutoVoicesOnTimeOutLoos[ 1 ] = new NetVoice("05b");
        m_aAutoVoicesOnTimeOutLoos[ 2 ] = new NetVoice("05c");
        Add( m_aAutoVoicesOnTimeOutLoos );
        
        m_aAutoVoicesOnTimeOutWin = new NetVoice[ 3 ];
        m_aAutoVoicesOnTimeOutWin[ 0 ] = new NetVoice("06a");
        m_aAutoVoicesOnTimeOutWin[ 1 ] = new NetVoice("06b");
        m_aAutoVoicesOnTimeOutWin[ 2 ] = new NetVoice("06c");
        Add( m_aAutoVoicesOnTimeOutWin );
        
        m_aAutoVoicesOnTimeOut = new NetVoice[ 3 ];
        m_aAutoVoicesOnTimeOut[ 0 ] = new NetVoice("07a");
        m_aAutoVoicesOnTimeOut[ 1 ] = new NetVoice("07b");
        m_aAutoVoicesOnTimeOut[ 2 ] = new NetVoice("07c");
        Add( m_aAutoVoicesOnTimeOut );
        
        m_aAutoVoicesOnGoingToLose = new NetVoice[ 2 ];
        m_aAutoVoicesOnGoingToLose[ 0 ] = new NetVoice("08a");
        m_aAutoVoicesOnGoingToLose[ 1 ] = new NetVoice("08b");
        Add( m_aAutoVoicesOnGoingToLose );
        
        m_aAutoVoicesOnGoingToWin = new NetVoice[ 2 ];
        m_aAutoVoicesOnGoingToWin[ 0 ] = new NetVoice("09a");
        m_aAutoVoicesOnGoingToWin[ 1 ] = new NetVoice("09b");
        Add( m_aAutoVoicesOnGoingToWin );
    
        m_aAutoVoicesOnFriendlyFire = new NetVoice[ 3 ];
        m_aAutoVoicesOnFriendlyFire[ 0 ] = new NetVoice("10a");
        m_aAutoVoicesOnFriendlyFire[ 1 ] = new NetVoice("10b");
        m_aAutoVoicesOnFriendlyFire[ 2 ] = new NetVoice("10c");
        Add( m_aAutoVoicesOnFriendlyFire );
        
        m_aAutoVoicesOnTeamKill = new NetVoice[ 3 ];
        m_aAutoVoicesOnTeamKill[ 0 ] = new NetVoice("11a");
        m_aAutoVoicesOnTeamKill[ 1 ] = new NetVoice("11b");
        m_aAutoVoicesOnTeamKill[ 2 ] = new NetVoice("11c");
        Add( m_aAutoVoicesOnTeamKill );
        
        m_aAutoVoicesOnAttackAssaultObjective = new NetVoice[ 3 ];
        m_aAutoVoicesOnAttackAssaultObjective[ 0 ] = new NetVoice("12a");
        m_aAutoVoicesOnAttackAssaultObjective[ 1 ] = new NetVoice("12b");
        m_aAutoVoicesOnAttackAssaultObjective[ 2 ] = new NetVoice("12c");
        Add( m_aAutoVoicesOnAttackAssaultObjective );
        
        
        m_aAutoVoicesOnLostFlag = new NetVoice[ 2 ];
        m_aAutoVoicesOnLostFlag[ 0 ] = new NetVoice("13a");
        m_aAutoVoicesOnLostFlag[ 1 ] = new NetVoice("13b");
        Add( m_aAutoVoicesOnLostFlag );
        
        m_aAutoVoicesOnTakeFlag = new NetVoice[ 2 ];
        m_aAutoVoicesOnTakeFlag[ 0 ] = new NetVoice("14a");
        m_aAutoVoicesOnTakeFlag[ 1 ] = new NetVoice("14b");
        Add( m_aAutoVoicesOnTakeFlag );
    }
    
    void Add( NetVoice[] aVoices )
    {
        if ( aVoices != null )
            for ( int i = 0; i<aVoices.length; ++i )
            {
                if ( aVoices[ i ] != null )
                    Add( aVoices[ i ] );
            }
    }

    NetVoice GetRandomVoice( NetVoice[] aVoices )
    {
        if (( aVoices != null ) && ( aVoices.length > 0 ))
            return aVoices[ GameObject.RandomInt(aVoices.length) ];
        return null;
    }

    NetVoice GetAutoVoiceOnGrenadeThrow(){ return m_cAutoVoiceOnGrenadeThrow; }
    NetVoice GetAutoVoiceOnTakeControlPoint(){ return GetRandomVoice( m_aAutoVoicesOnTakeControlPoint ); }
    NetVoice GetAutoVoiceOnLostControlPoint(){ return GetRandomVoice( m_aAutoVoicesOnLostControlPoint ); }
    NetVoice GetAutoVoiceOnTakeMostOfControlPoints(){ return GetRandomVoice( m_aAutoVoicesOnTakeMostOfControlPoints ); }
    NetVoice GetAutoVoiceOnLostMostOfControlPoints(){ return GetRandomVoice( m_aAutoVoicesOnLostMostOfControlPoints ); }
    //NetVoice GetAutoVoiceOnTimeOut(){ return GetRandomVoice( m_aAutoVoicesOnTimeOut ); }
    //NetVoice GetAutoVoiceOnGoingToWin(){ return GetRandomVoice( m_aAutoVoicesOnGoingToWin ); }
    //NetVoice GetAutoVoiceOnGoingToLose(){ return GetRandomVoice( m_aAutoVoicesOnGoingToLose ); }
    NetVoice GetAutoVoiceOnFriendlyFire(){ return GetRandomVoice( m_aAutoVoicesOnFriendlyFire ); }
    NetVoice GetAutoVoiceOnTeamKill(){ return GetRandomVoice( m_aAutoVoicesOnTeamKill ); }
    //NetVoice GetAutoVoiceOnAttackAssaultObjective(){ return GetRandomVoice( m_aAutoVoicesOnAttackAssaultObjective ); }
    NetVoice GetAutoVoiceOnTakeFlag(){ return GetRandomVoice( m_aAutoVoicesOnTakeFlag ); }
    NetVoice GetAutoVoiceOnLostFlag(){ return GetRandomVoice( m_aAutoVoicesOnLostFlag ); }
    

}
