public class TestSpawnObject extends MeshObject
{
    TestSpawnObject()
    {
        MeshName = "Data/Interface/Wykrzyknik.3da";
    }
    
    void OnCreate()
    {
        super.OnCreate();
        
        if ( Role == ERole._AUTHORITY )
        {
            ChromeModule cMod     = (ChromeModule) GetModule();
            Vector       vExtents = cMod.GetTerrainSize();
            Player       cPlayer  = cMod.GetMainPlayer();
            Vector       vPos     = new Vector();
            
            if ( cPlayer != null )
            {
                cPlayer.GetPosition( vPos );
                
                float fRange = 10000.0f;
                vPos.fX += RandomFloat( fRange ) - (fRange * 0.5f);
                if ( vPos.fX < 0.0f )
                     vPos.fX = 0.0f;
                else if ( vPos.fX > vExtents.fX )
                          vPos.fX = vExtents.fX;
                vPos.fZ += RandomFloat( fRange ) - (fRange * 0.5f);
                if ( vPos.fZ < 0.0f )
                     vPos.fZ = 0.0f;
                else if ( vPos.fZ > vExtents.fZ )
                          vPos.fZ = vExtents.fZ;
            }
            else
            {
                vPos.fX = RandomFloat( vExtents.fX );
                vPos.fZ = RandomFloat( vExtents.fZ );    
            }
            
            vPos.fY = TerrainHeight( vPos.fX, vPos.fZ ) + 10.0f;
            
            Init( vPos );
        }
    }

    void Init( Vector vPos )
    {
        SetPositionWorld( vPos );
        ActivateOnModule();
    }
    
    public void ReplicationInit()
    {
    }

    public void OnReplicateServer()
    {
         if ( bNetInit )
             MsgSendClientInit();
    }
    
    final static int _MSG_CLIENT_INIT = 0;
    
    public void OnMessage()
    {
        switch ( MessageGetId() )
        {
         case _MSG_CLIENT_INIT:
            LogD(" _MSG_CLIENT_INIT\n");
            MsgRecvClientInit();            
            break;
        
        default:
            MessageCancel();
        }
    }

    
    void MsgSendClientInit()
    {
        MessageNew( _MSG_CLIENT_INIT );
        MessagePackVector( GetPosition() );
        MessageSend();
    }
    
    void MsgRecvClientInit()
    {
        Vector vPos = MessageUnPackVector();
        MessageEnd();
        
        Init( vPos );
    }
    

}
