public class PlayerNetBaseInventory extends PlayerNetBaseMortal
{
    //bron ktora gracz ma ZAWSZE po "urodzeniu" i nie moze sie jej pozbyc
    static Class GetInbornWeaponClass(){ return WeaponKnife.class; }
    
    private
    InventoryRoom m_cInventoryRoom = new InventoryRoom();
    InventoryRoom GetInventoryRoom(){ return m_cInventoryRoom; }
    
    private
    java.util.Vector m_aCustomInventoryObjects = null;
    
    
    int METHOD_CheckInventoryContent     = 0;
    
    static String PROF_RESTARTROUND_TAB = "NetRestartRound";
    int PROFILE_FillInventory            = 0;
    int PROFILE_RemoveInventoryOnDie     = 0;

    public void OnCreate()
    {
        METHOD_CheckInventoryContent     = RegisterCallMethod("CheckInventoryContent");
        
        PROFILE_FillInventory        = ProfileAdd(PROF_RESTARTROUND_TAB, "FillInventory");
        PROFILE_RemoveInventoryOnDie = ProfileAdd(PROF_RESTARTROUND_TAB, "RemoveInventoryOnDie");
        
        super.OnCreate();

        if (bNetIsOwner)
        {
            ((ChromeModule)GetModule()).CreateInvWindow();
            //stworzylo sie inv window ale tez moglo sie inventory przeniesc do fake'a
            //wiec je sobie odbieramy
            cInventory.Acquire(GetModule(), this);
        }
        
        CleanInventoryContent();
    }
    
    public void OnDestroy()
    {
        super.OnDestroy();
        
        DeleteInventory();
        m_cInventoryRoom = null;
        
        if ( m_aCustomInventoryObjects != null )
        {
            m_aCustomInventoryObjects.removeAllElements();
            m_aCustomInventoryObjects = null;
        }
    }
    
    /** Inicjalizacja inventory playera
     */
    void InitInventory()
    {
        cInventory = (InventoryPlayer)CreateObjectNoInit("InventoryPlayer");
        cInventory.Owner = this;
        cInventory.InitObject();
    }
    
    /** Ustawia poczatkowa zawartosc inventory
     */
    void CleanInventory()
    {
        // czyscimy inventory
        cInventory.Clear();
        // czyscimy indeksy broni
        for ( int i=0; i<EWeaponType.count; ++i )
            nWeaponInvIndex[i] = 0;
        // gracz nie trzyma zadnej broni
		// MK: chyba nie wolno robic takich numerow?!?!?!?!?
        //ActiveWeapon = null;
        //PreviousActiveWeapon = null;
    }    
    
    void UseInvObject( InvObject cInvObj )
    {
        if (Role == ERole._AUTHORITY)
        {
            MsgSendClientAction( EPlayerAction.USE, cInvObj.GetNetId() );
            UseInvObjectDo( cInvObj );
        }
        else
        {
            MsgSendServerActionRequest( EPlayerAction.USE, cInvObj.GetNetId() );
        }        
    }    
    
    
    void EndUseInvObject( InvObject cInvObj )
    {
        int nInvObjId = cInvObj != null ? cInvObj.GetNetId() : -1;
        if (Role == ERole._AUTHORITY)
        {
            MsgSendClientAction( EPlayerAction.USE_END, nInvObjId );
            EndUseInvObjectDo( cInvObj );
        }
        else
        {
            MsgSendServerActionRequest( EPlayerAction.USE_END, nInvObjId );
        }        
    }    

    void EndUseInvObjectDo( InvObject cInvObj )
    {
        cInvObj.EndUse();
    }
        
    void RestartInventoryRoom()
    {
        if ( ! cGameInitInfo.cLevels.IsCurrentValid() )
            return;
            
        m_cInventoryRoom.Restart( cGameInitInfo.cLevels.GetCurrent().aInventoryRoomModifiers );
    }
    
    
    
    /**
     * Lokalnie na wlascicielu
     */
    
    /** Wejscie do inventory room
     * Trzeba pochowac wszystkie hudy, oderejestrowac 
     * inputy playerowi u zawolac aktywacje inventory room'u
     */
    void SetInventoryMenu()
    {
        if ( GetModuleNet() != null && 
             GetModuleNet().GetGameInfo() != null &&
             GetModuleNet().GetGameInfo().IsInventoryRoomAvailable() )
        {
            HideHUDNetOnRespawnRequest();
            LockHUDNet( true );
            HUD.HideAll();
            UnregisterKeyRequest();
		    UnregisterMouseAxisRequest();
            UnregisterMouseButtonRequest();
            
            GetModuleNet().SetInventoryMenu();
        }
    }
    
    /** Powrot z inventory room
     * Trzeba przywrcic wszystkie hudy, ponownie zarejestrowac
     * inputy, wyslac serwerowi liste zyczen (z inventory room'u)
     * oraz zawolac respawn
     */
    void RestoreAfterInventoryMenu()
    {
        if ( GetModuleNet() != null )
             GetModuleNet().RestoreAfterInventoryMenu();
            
        LockHUDNet( false );
        HUD.UnhideAll();
        HUD.GetHudCompInvPl().RestoreInventoryGridPositions();
        RegisterKeyRequest();
		RegisterMouseAxisRequest();
        RegisterMouseButtonRequest();
                        
        ActionInvWishList();   
        ActionRespawn();   
    }
    
    
    /** Przegladniecie inventory celem ustalenia jego listy
     * ze szczegolnym uwzglednieniem obiektow ktore doszly w 
     * inwentory room'ie (tymczasowych-lokalnych)
     * Na serwerze lista ta jest od razu apply'owana, klient
     * wysyla ja na serwer z prosba o wyspawnowanie wymarzonych
     * obiektow...
     */
    void ActionInvWishList()
    {
        // lista obiektow wczesniej juz istniejacych ktore nadal maja zostac 
        // w inwentory czyli nie maja byc skasowane
        java.util.Vector aExistingObjects = new java.util.Vector(0,8);
        // lista informacji o obiektach ktore maja zostac stworzone
        java.util.Vector aNewObjects      = new java.util.Vector(0,8);
                
        for (int nIndex=0; nIndex<cInventory.GetInvObjSize(); nIndex++)
        {
            NewInvObjectInfo cInfo = null;
            
            InvObject cInvObj = (InvObject)cInventory.GetInvObject( nIndex );
            if ( cInvObj.m_bLocalObj )
            {
                cInfo = new NewInvObjectInfo( cInvObj.getClass().getName(), 
                                              cInvObj.nInvType,
                                              cInvObj.nGrid, 
                                              cInvObj.nCellX, 
                                              cInvObj.nCellY );
                aNewObjects.addElement( cInfo );
                
                //tymczasowe obiekty po wpisaniu na liste mozna wypisac z inwentory
                cInventory.RemoveInvObject( cInvObj );
                nIndex--;
                //i skasowac                                
                cInvObj.delete();    
                cInvObj = null;
            }
            else
            {
                cInfo = new NewInvObjectInfo( cInvObj.GetNetId(), 
                                              cInvObj.nInvType,
                                              cInvObj.nGrid, 
                                              cInvObj.nCellX, 
                                              cInvObj.nCellY );
                aExistingObjects.addElement( cInfo );
            }
        }
                
        if ( Role == ERole._AUTHORITY )
        {
            // zastosowac zmiany
            ApplyNewInvWishList( aExistingObjects, aNewObjects );
        }
        else
        {
            MsgSendServerInvWishList( aExistingObjects, aNewObjects );
        }
    }
    
    /** CLIENT Wyslanie do serwera listy inwentory jakiego 
     * bysmy sobie zyczyli
     */
    void MsgSendServerInvWishList(java.util.Vector aExistingObjects,java.util.Vector aNewObjects)
    {
        NewInvObjectInfo cInfo = null;
        
        MessageNew( MSG_SERVER_INV_WISH_LIST );
        
        if ( aExistingObjects != null )
        {
            for ( int i=0; i<aExistingObjects.size(); i++ )
            {
                if ( ! (aExistingObjects.elementAt(i) instanceof NewInvObjectInfo ))
                    continue;
                
                cInfo = (NewInvObjectInfo)aExistingObjects.elementAt(i);
                
                MessagePackInt( INV_WISH_LIST_EXISTING );
                MessagePackInt( cInfo.m_nNetId );
                MessagePackInt( cInfo.m_nInvType );
                MessagePackByte( cInfo.m_nGrid );
                MessagePackByte( cInfo.m_nCellX );
                MessagePackByte( cInfo.m_nCellY );
                
                LogD(" Wyslano netid:"+cInfo.m_nNetId+"\n");
            }
        }
        
        if ( aNewObjects != null )
        {
            for ( int i=0; i<aNewObjects.size(); i++ )
            {
                if ( ! (aNewObjects.elementAt(i) instanceof NewInvObjectInfo ))
                    continue;
                
                cInfo = (NewInvObjectInfo)aNewObjects.elementAt(i);
                
                MessagePackInt( INV_WISH_LIST_NEW );
                MessagePackString( cInfo.m_sClassName );
                MessagePackInt( cInfo.m_nInvType );
                MessagePackByte( cInfo.m_nGrid );
                MessagePackByte( cInfo.m_nCellX );
                MessagePackByte( cInfo.m_nCellY );
                
                LogD(" Wyslano: classname"+cInfo.m_sClassName+"\n");    
            }
        }
        MessagePackInt( INV_WISH_LIST_END );
        MessageSend();
    }
    
    final static int INV_WISH_LIST_EXISTING = 0;
    final static int INV_WISH_LIST_NEW      = 1;
    final static int INV_WISH_LIST_END      = 2;
    
    /** SERWER Odebranie od klienta jego wymarzonego inwentory
     */
    void MsgRecvServerInvWishList()
    {
        LogD("\n");
        
        NewInvObjectInfo cInfo = null;
               
        // lista obiektow wczesniej juz istniejacych ktore nadal maja zostac 
        // w inwentory czyli nie maja byc skasowane
        java.util.Vector aExistingObjects = new java.util.Vector(0,8);
        // lista informacji o obiektach ktore maja zostac stworzone
        java.util.Vector aNewObjects      = new java.util.Vector(0,8);
        
        boolean bContinue = true;
        do {
            int nElement = MessageUnPackInt();
            
            switch ( nElement )
            {
            case INV_WISH_LIST_EXISTING:
                cInfo = new NewInvObjectInfo();
                cInfo.m_nNetId   = MessageUnPackInt();
                cInfo.m_nInvType = MessageUnPackInt();
                cInfo.m_nGrid    = MessageUnPackByte();
                cInfo.m_nCellX   = MessageUnPackByte();
                cInfo.m_nCellY   = MessageUnPackByte();
                aExistingObjects.addElement( cInfo );
                break;
                
            case INV_WISH_LIST_NEW:
                cInfo = new NewInvObjectInfo();
                cInfo.m_sClassName = MessageUnPackString();
                cInfo.m_nInvType   = MessageUnPackInt();
                cInfo.m_nGrid      = MessageUnPackByte();
                cInfo.m_nCellX     = MessageUnPackByte();
                cInfo.m_nCellY     = MessageUnPackByte();
                aNewObjects.addElement( cInfo );
                break;
                
            case INV_WISH_LIST_END:
                bContinue = false;
                break;
                
            default:
                bContinue = false;
                CrashLog(" "+GetNetInfo()+" MsgRecvServerInvWishList, unknwown nElement ("+nElement+") received!!!\n");
            }
        } while ( bContinue );
        
        MessageEnd();
        
        ApplyNewInvWishList( aExistingObjects, aNewObjects );
    }
    
    void MsgSendClientNoInvRoom()
    {
        MessageNewUnreliable( MSG_CLIENT_NO_INV_ROOM );
        MessageSend( EMsgSendMode.OWNER );
    }
    
    void MsgRecvClientNoInvRoom()
    {
        MessageEnd();
        
        NotEnoughRoomInInventory();
    }
    
    
    
    /** Metoda robiaca na serwerze porzadek w inwentory,
     * pozostawia w inwentory tylko te obiekty wymienione na liscie aExistingObjects
     * oraz tworzy obiekty z listy aNewObjects
     */
    void ApplyNewInvWishList( java.util.Vector aExistingObjects, java.util.Vector aNewObjects )
    {
        NewInvObjectInfo cInfo = null;
        
        NetObjectsManager cObjMgr = GetModuleNet().GetObjectsManager();
        if ( cObjMgr == null )
        {
            CrashLog(" NetObjectsManager nie istnieje, nie potrafie tworzyc obiektw\n");
            return;
        }
                
        //najpierw oproznijmy inwentarz oraz skasujmy niepotrzebne obiekty
        for ( int nInvObj=0; nInvObj<cInventory.GetInvObjSize(); nInvObj++ )
        {
            InvObject cInvObj = cInventory.GetInvObject( nInvObj );
            
            if ( cInvObj == null )
                continue;
            
            int     nNetId = cInvObj.GetNetId();
            boolean bFound = false;
            if ( aExistingObjects != null )
            {
                for ( int i=0; i<aExistingObjects.size(); i++ )
                {
                    if ( ! (aExistingObjects.elementAt(i) instanceof NewInvObjectInfo ))
                        continue;
                    cInfo = (NewInvObjectInfo)aExistingObjects.elementAt(i);
                    
                    if ( nNetId == cInfo.m_nNetId )
                    {
                        bFound = true;
                        // przy okazji wpiszmy mu nazwe klasy do info
                        //cInfo.m_sClassName = cInvObj.getClass().getName();
                        break;
                    }
                }
            }
        
            //wypisujemy z inwentory, te ktore maja tam zostac to
            //wpiszemy za chwile w nowym miejscu
            cInventory.RemoveInvObject( cInvObj );
            nInvObj--;
            
            // a te ktorych nie ma na liscie to skasujemy
            if ( !bFound )
            {
                cInvObj.ChangeInvState( null, EInvObjState._ONGROUND );
                cObjMgr.DeleteObject( cInvObj );
                cInvObj = null;
            }
        }

        RestartInventoryRoom();
        m_bBinocularsSupportAdded = false;
        
        //dopisujemy istniejace juz obiekty w odpowiednie miejsce
        if ( aExistingObjects != null )
        {
            for ( int i=0; i<aExistingObjects.size(); i++ )
            {
                if ( ! (aExistingObjects.elementAt(i) instanceof NewInvObjectInfo ))
                    continue;
                //pobieramy info obiektu do dodanie do inwentory
                cInfo = (NewInvObjectInfo)aExistingObjects.elementAt(i);
                
                //znajdzmy obiekt po identyfikatorze sieciowym
                InvObject cInvObj = GetInvObjByNetId( cInfo.m_nNetId );
                if ( cInvObj == null )
                    continue;
                
                //wsparcie dla lornetki utworzy sie zawsze z lornetka
                if (cInvObj.getClass().getName().equals(m_cClassBinocularsSupport.getName()))
                {
                    cObjMgr.DeleteObject( cInvObj );
                    continue;
                }
                
                //TODO: sprawdzic czy on na pewno jest w tym inwentarzu
                
                //ok, dodajmy go wiec do inwentory
                TryToAddToInventory( cInvObj, cInfo );
            }
        }
        
        //teraz utworzmy nowe
        if ( aNewObjects != null )
        {
            for ( int i=0; i<aNewObjects.size(); i++ )
            {
                if ( ! (aNewObjects.elementAt(i) instanceof NewInvObjectInfo ))
                    continue;
                //pobieramy info obiektu do dodanie do inwentory
                cInfo = (NewInvObjectInfo)aNewObjects.elementAt(i);
                
                //ok, zatem stworzmy taki obiekt
                InvObject cInvObj = (InvObject)cObjMgr.CreateNewObject( cInfo.m_sClassName, this );
                if ( cInvObj == null )
                    continue;

                //jesli to bron inborn to ukrywamy
                if (cInvObj.getClass().getName().equals(GetInbornWeaponClass().getName()))
                    cInvObj.bHidden = true;
                
                //i sprobujmy dodac go do inwentory
                TryToAddToInventory( cInvObj, cInfo );
            }
        }
        
        ShowInventory("Filled new custom");
        
        //zapamietac inwentory jako nowe domyslne
        RememberInventoryAsCustom();
    }

    
    
    void RememberInventoryAsCustom()
    {
        m_aCustomInventoryObjects = new java.util.Vector(0);
        
        for (int nIndex=0; nIndex<cInventory.GetInvObjSize(); nIndex++)
        {
            InvObject cInvObj = (InvObject)cInventory.GetInvObject( nIndex );
            if ( cInvObj == null )
                continue;
            
            //wsparcie dla lornetki utworzy sie zawsze z lornetka
            if (cInvObj.getClass().getName().equals(m_cClassBinocularsSupport.getName()))
                continue;
            
            
            NewInvObjectInfo cInfo = new NewInvObjectInfo( 
                                          cInvObj.getClass().getName(), 
                                          cInvObj.nInvType,
                                          cInvObj.nGrid, 
                                          cInvObj.nCellX, 
                                          cInvObj.nCellY );
            m_aCustomInventoryObjects.addElement( cInfo );
            //LogR("RememberInventoryAsCustom ");
            //LogR("   "+nIndex+" "+cInvObj.getClass().getName()+"\n");
        }
    }
    
    /**
     * O czym musimy pamietac przy wypelnianiu inwentory
     */
    
    /** Podczas wkladania obiektow do inwentory jednej broni
     * trzeba nadac tryb Inborn, jej klasa jest podana tu
     */
    Class m_cClassToSetInborn       = null;
    
    /**
     * Lornetka jest obiektem, ktory potrzebuje "wsparcia", tzn odpowiedniego 
     * Weapona, ktory bedzie w rece podczas uzywania lornetki
     * Tu mamy klase tego obiektu, trzeba go stworzyc za kazdym razem
     * gdy gracz chce korzystac z lornetki
     */
    Class m_cClassBinocularsSupport = WeaponHandsBinoculars.class;
    
    /**
     * Flaga mowiaca o tym, czy dodano juz do inwentory 
     * obiekt ten wspomagajacy lornetke
     */
    boolean m_bBinocularsSupportAdded = false;
    
    /** Wypelnienie inwentarza domyslnymi obiektami
     */
    void FillInventory()
    {
        if ( Role < ERole._AUTHORITY )
            return;
        
        ProfileBegin( PROFILE_FillInventory );
            
        boolean bShowMsgNoInvRoom      = InvObject.sm_bShowMsgNoInvRoom;
        InvObject.sm_bShowMsgNoInvRoom = false;
        
        m_bBinocularsSupportAdded      = false;
        
        NetObjectsManager cObjMgr = GetModuleNet().GetObjectsManager();
        if ( cObjMgr == null )
        {
            NetLog.Profile(" -FillInventory "+ProfileEnd( PROFILE_FillInventory ));
            CrashLog(" NetObjectsManager nie istnieje, nie potrafie tworzyc obiektw\n");
            return;
        }

        m_cClassToSetInborn = PlayerNet.GetInbornWeaponClass();
        //jesli jest podane przed klienta inwentory to je ladujemy
        //jesli nie to ladujemy domyslne
        if ( ! FillCustomInventory() )
            FillDefaultInventory();
        
        if ( m_cClassToSetInborn != null )
        {
            NetLog.PlayerInventory(
                    " Do inwentory "+GetNetInfo()+
                    " nie zostala dodana zadna bron "+m_cClassToSetInborn.getName()+
                    "\n");
            m_cClassToSetInborn = null;
        }
        
        InvObject.sm_bShowMsgNoInvRoom = bShowMsgNoInvRoom;
        NetLog.Profile(" -FillInventory "+ProfileEnd( PROFILE_FillInventory ));
    }
    
    
    boolean FillCustomInventory()
    {
        if ( m_aCustomInventoryObjects == null )
            return false;
         
        NetObjectsManager cObjMgr = GetModuleNet().GetObjectsManager();
        if ( cObjMgr == null )
        {
            CrashLog(" NetObjectsManager nie istnieje, nie potrafie tworzyc obiektw\n");
            return false;
        }
        
        //TODO:
        //czy tu nie musi byc tego? dodalem, ale jescze sprawdzic...
        RestartInventoryRoom();
        //LogR("FillCustomInventory\n");
        for ( int i=0; i<m_aCustomInventoryObjects.size(); i++ )
        {
            if ( ! (m_aCustomInventoryObjects.elementAt(i) instanceof NewInvObjectInfo ))
                continue;
            //pobieramy info obiektu do dodanie do inwentory
            NewInvObjectInfo cInfo = (NewInvObjectInfo)m_aCustomInventoryObjects.elementAt(i);
                    
            //ok, zagtem stworzmy taki obiekt
            InvObject cInvObj = (InvObject)cObjMgr.CreateNewObject( cInfo.m_sClassName, this );
            if ( cInvObj == null )
                continue;

            if (cInvObj.getClass().getName().equals(GetInbornWeaponClass().getName()))
                cInvObj.bHidden = true;
            
            //i sprobujmy dodac go do inwentory
            boolean bAdded = TryToAddToInventory( cInvObj, cInfo );
                        
            //LogR(" "+i+" "+cInfo.m_sClassName+" "+bAdded+"\n");
        }
        
        ShowInventory("Filled custom");
        return true;
    }
    
    void FillDefaultInventory()
    {
        NetObjectsManager cObjMgr = GetModuleNet().GetObjectsManager();
        if ( cObjMgr == null )
        {
            CrashLog(" NetObjectsManager nie istnieje, nie potrafie tworzyc obiektw\n");
            return;
        }
        
        RestartInventoryRoom();
        
        if ( ! cGameInitInfo.cLevels.IsCurrentValid() )
            return;
        
        java.util.Vector cLevelDef = cGameInitInfo.cLevels.GetCurrent().aDefaultWeapons;
		    		
        for (int i = 0; i < cLevelDef.size(); i++)
        {
            //Log("Default "+i+" : "+(String)cLevelDef.elementAt(i)+"\n");
            InvObject cInvObj = (InvObject)cObjMgr.CreateNewObject( (String)cLevelDef.elementAt(i), this );
            if ( cInvObj == null )
                continue;
            if (cInvObj.getClass().getName().equals(GetInbornWeaponClass().getName()))
                cInvObj.bHidden = true;
            //i sprobujmy dodac go do inwentory
            TryToAddToInventory( cInvObj ); 
        }
        ShowInventory("Filled default");
    }
    
        
    
    /** Metoda probuje dodac do inwentory obiekt,
     * Uwaga, jak operacja sie nie powiedzie, to obiekt
     * jest automatycznie kasowany
     */
    boolean TryToAddToInventory( InvObject        cInvObj,
                                 NewInvObjectInfo cInfo,
                                 boolean          bCheckInventoryRoom )
    {
        //TODO: fixit, tylko do testow
        int         nMyNetId = GetNetId();
        GameObject  cObj1    = cInvObj.GetObjectByNetId( nMyNetId );
        GameObject  cObj2    = GetObjectByNetId( nMyNetId );
        if ( cObj1 != cObj2 )
            CrashLog("ERROR: problem ze znalezieniem obiektu "+GetNetInfo()+
                     " : by InvObj "+cObj1+" != "+cObj2+" \n");
                
        InventoryObjectInfo cRoomInfo = null;
        //sprawdzmy czy taki jest przewidziany w inwentory room
        if ( bCheckInventoryRoom )
            cRoomInfo = m_cInventoryRoom.FindObject( cInvObj.nInvType, cInvObj.getClass().getName() );
        
        if ( ((cRoomInfo != null) && (cRoomInfo.m_iAmount > 0)) || (!bCheckInventoryRoom) )
        {
            cInvObj.bJustTakenToInventory = false;
            
            if ( cInfo != null )
                cInvObj.ActionExecute( this, cInfo.m_nGrid, cInfo.m_nCellX, cInfo.m_nCellY );
            else
                cInvObj.ActionExecute( this );
        
		    if (cInvObj.bJustTakenToInventory)
		    {
                if ( m_cClassToSetInborn != null &&
                     m_cClassToSetInborn == cInvObj.getClass() )
                {
                    ((Weapon)cInvObj).SetInborn();
                    m_cClassToSetInborn = null;
                }
                
                //jesli sie udalo to zaznaczmy ten fakt
                cInvObj.RespawnedInInventory();
                // jesli sie udalo, to zaznaczmy w room'ie ze jednego wzielismy
                if ( cRoomInfo != null )
                    cRoomInfo.ChangeAmount( -1 );
                         
                //jesli to byla lornetka i jeszcze nie mamy w inwentory odpowiednich
                //raczek, to trzeba bedzie je teraz dodatkowo dodac
                if ( (cInvObj instanceof Binoculars) && (!m_bBinocularsSupportAdded) )
                {
                    //TODO: w przyszlosci zmienic, aby te raczki dodawali
                    //sie wszystkim graczom (jesli jest Lornetka zaplanowana)
                    m_bBinocularsSupportAdded = TryToAddToInventoryBinocularsSupport();
                }
                return true;
		    }
            else
            {
                ShowInventory("Nie udalo sie dodac "+cInvObj+" do inwentory");
                /*if ( cInfo != null )
                    cInvObj.ActionExecute( this, cInfo.m_nGrid, cInfo.m_nCellX, cInfo.m_nCellY );
                else
                    cInvObj.ActionExecute( this );*/
            }
        }
        else
            ShowInventory("RoomInfo "+cRoomInfo+" nie wpuscil "+cInvObj+" do inwentory");
        
        
        //TODO: zmienic jesgo stan, zeby nie bylo problemow z 
        //kasowaniem na kliencie
        //jesli nie to kasujemy dziada
        //nie uzywam tu ObjectManagera, bo cos z tym obiektem musi byc nie
        //tak wiec nie chce go wiecej
        cInvObj.delete();
        cInvObj = null;
        return false;
    }
    
    boolean TryToAddToInventory( InvObject cInvObj )
    {
        return TryToAddToInventory( cInvObj, null );
    }
    
    boolean TryToAddToInventory( InvObject        cInvObj,
                                 NewInvObjectInfo cInfo )
    {
        return TryToAddToInventory( cInvObj, cInfo, true );
    }
    
    boolean TryToAddToInventory( InvObject cInvObj, boolean bCheckInventoryRoom )
    {
        return TryToAddToInventory( cInvObj, null, bCheckInventoryRoom );
    }
    
    boolean TryToAddToInventoryBinocularsSupport()
    {
        NetObjectsManager cObjMgr = GetModuleNet().GetObjectsManager();
        if ( cObjMgr == null )
        {
            CrashLog(" NetObjectsManager nie istnieje, nie potrafie tworzyc obiektw\n");
            return false;
        }
        //zawsze powinnismy miec ukryte WeaponHandsBinoculars
        InvObject cBinocularsSupport = (InvObject)cObjMgr.CreateNewObject( m_cClassBinocularsSupport, this );
        if ( cBinocularsSupport != null )
            return TryToAddToInventory( cBinocularsSupport, false );
        return false;
    }
                
    boolean bCheatPos = false;

    void RemoveInventoryOnDie(int nDieMode)
    {
        ProfileBegin( PROFILE_RemoveInventoryOnDie );
        
        // czyscimy raczki playerowi (!)
        UseWeapon( (Weapon)null );
        
        NetObjectsManager cObjMgr = GetModuleNet().GetObjectsManager();
                
        while ( cInventory.GetInvObjSize() > 0 )
        {
            // kolejny obiekt
            InvObject cInvObj = (InvObject)cInventory.aInvObjects.elementAt( 0 );
            
            if ( cInvObj.ThrowAwayOnRemoveFromInventory() )
            {
                //wyrzucamy obiekt na fizyce
                cInvObj.ActionThrowAway();
                //uwaga: w InvObject jest zapewnienie replikacji
                //stanu wyrzucenia obiektu
            }
            else
            {
                // usuwamy obiekt z inwentory
                cInventory.RemoveInvObject( cInvObj );
                // zmieniamy jego stan
                cInvObj.ChangeInvState( null, EInvObjState._ONGROUND );
                
                GetModuleNet().GetPlayerManager().DisablePlayerCollision();
                cInvObj.ClearFlag(EFlags._COLLISION);
                
                // kladziemy obiekt gdzies kolo trupka
                //TODO: dla trybow specjalnych (GameRestart/GameOver) nie
                //rozrzucac obiektow, zeby przyspieszyc
                //cInvObj.SetPositionWorld( GetRandomPosAroundMe() );
                cInvObj.SetPositionOnGroundDrop( GetRandomPosAroundMe(), GetPosition() );
                
                cInvObj.SetFlag(EFlags._COLLISION);
                GetModuleNet().GetPlayerManager().EnablePlayerCollision();

                // wysylamy clientom stan obiektu        
                cInvObj.MsgSendClientState();
            }
            
            //jesli to obiekt inborn to od razu go kasujemy
            if ( cInvObj.IsInborn() )
            {
                cInvObj.DeleteAttachedFXes();
                
                if ( cObjMgr != null )
                    cObjMgr.DeleteObject( cInvObj );
                else
                    cInvObj.delete();
                continue;
            }
            // zaznaczamy obiekt do skasowania, 
            // jesli nikt go nie uzyje przez jakis czas
            boolean bScheduledAnnihilate = cInvObj.ScheduleAnnihilateIfNotUsed();
            //troszke inaczej bedzie jesli to nie byla smierc naturalna,
            //ale GameOver, GameRestart, itp...
            if ( nDieMode != EPlayerAction.DIE_MODE_NORMAL )
            {
                //wtedy te "zwykle" invobiekty trzeba od razu skasowac
                if ( bScheduledAnnihilate )
                {
                    if ( cObjMgr != null )              
                        cObjMgr.DeleteObject( cInvObj );
                    else
                        cInvObj.delete();        
                }
            }
        }
        
        NetLog.Profile(" -RemoveInventoryOnDie "+ProfileEnd( PROFILE_RemoveInventoryOnDie ));
    }
    
    void DeleteInventory()
    {
        // czyscimy raczki playerowi (!)
        UseWeapon( (Weapon)null );
                
        while ( cInventory.GetInvObjSize() > 0 )
        {
            // kolejny obiekt
            InvObject cInvObj = (InvObject)cInventory.aInvObjects.elementAt( 0 );
            
            // usuwamy obiekt z inwentory
            cInventory.RemoveInvObject( cInvObj );
            // zmieniamy jego stan
            cInvObj.ChangeInvState( null, EInvObjState._ONGROUND );
            //kasujemy obiekt
            cInvObj.DeleteAttachedFXes();
            cInvObj.delete();
        }
    }
    
    /**
     * Czy ma dzialac wysylanie stanu wszystkich 
     * obiektow w inwentory do klienta
     */
    boolean bSendClientInvObjStateFromInventory = true;
    
    void SendClientInvObjStateFromInventory(int nHostId)
    {
        if ( ! bSendClientInvObjStateFromInventory )
            return;
        
        if ( Role < ERole._AUTHORITY )
            return;
        
        for (int i=0; i<cInventory.GetInvObjSize();i++ )
        {
            // kolejny obiekt
            InvObject cInvObj = (InvObject)cInventory.aInvObjects.elementAt( i );
            cInvObj.MsgSendClientStateToHost( nHostId );
        }
    }

    /**
     * Lista identyfikatorow sieciowych obiektow ktore zdaniem
     * serwera powinny znalezc sie w inwentory.
     * Na tej podstawie (porownujac z lokalnym inwentory) bedziemy
     * swierdzac czy mamy juz je kompletne i bedziemy pozwalac
     * na spawn i/lub wejscie do inwentory room
     */
    int[] m_aInventoryContentFromServer = null;
    
    /**
     * Flaga mowiaca o tym, czy obecnie w powyzszej
     * liscie mamy aktualne dane (z tego spawnu a 
     * nie z poprzedniego)
     */
    boolean m_bInventoryContentValid = false;
    
    /**
     * Server
     * Wrzucenie informacji o zawartosci inwentory do komunikatu
     */
    void PackInventoryContent()
    {
        if ( Role < ERole._AUTHORITY )
            return;
        
        MessagePackInt( cInventory.GetInvObjSize() );
        for ( int i=0; i<cInventory.GetInvObjSize(); ++i )
        {
            // kolejny obiekt
            InvObject cInvObj = (InvObject)cInventory.aInvObjects.elementAt( i );
            MessagePackInt( cInvObj.GetNetId() );
        }
    }
    
    void UnPackInventoryContent()
    {
        int nSize = MessageUnPackInt();
        m_aInventoryContentFromServer = (nSize > 0)? new int[ nSize ] : null;
        for ( int i=0; i<nSize; ++i )
        {
            m_aInventoryContentFromServer[ i ] = MessageUnPackInt();
        }
    }
    
    void CheckInventoryContent()
    {
        DisableCallMethod( METHOD_CheckInventoryContent );
        
        boolean bChecked = true;
        int nSize = m_aInventoryContentFromServer != null ? m_aInventoryContentFromServer.length : -1;
        if ( m_bInventoryContentValid && nSize == cInventory.GetInvObjSize() )
        {
            for ( int i=0; i<nSize; ++i )
            {
                InvObject cInvObj = (InvObject)cInventory.aInvObjects.elementAt( i );
                int       nId     = cInvObj.GetNetId();
                
                boolean bFound = false;
                for ( int j = 0; j<nSize; ++j )
                {
                    if ( m_aInventoryContentFromServer[ j ] == nId )
                    {
                        bFound = true;
                        break;
                    }
                }
                
                if ( !bFound )
                {
                    bChecked = false;
                    //wysylamy serwerowi prosbe o ponowne info o obiekcie
                    //zastrzegajac ze on u nas nie byl planowany
                    //cInvObj.MsgSendServerStateRequest( true, this, false );
                    NetLog.InvObj("CheckInventoryContent() failed - obiekt "+cInvObj.GetNetInfo()+" nie byl zaplanowany u gracza "+GetNetInfo()+"\n");
                    break;
                }
            }
        }
        else
        {
            if ( m_bInventoryContentValid )
                NetLog.InvObj("CheckInventoryContent() failed - ilosc obiektow sie nie zgadza "+cInventory.GetInvObjSize()+"/"+nSize+"\n");
            else
                NetLog.InvObj("CheckInventoryContent() failed - lista jeszcze nie doszla\n");
            bChecked = false;
        }
                
        if ( bChecked )
        {
            NetLog.InvObj("CheckInventoryContent() OK!\n");
            InventoryContentChecked();
        }
        else
            CallMethodIn( METHOD_CheckInventoryContent, 0.1f );
    }

    /** 
     * Metoda sprawdza dlaczego jeszcze nie mamy inwentory takiego 
     * jakiego oczekujemy i ewentualnie wysyla do serwera prosbe
     * o doslanie stanu niektorych obiektow (te, ktorych nam brakuje,
     * oraz te ktore sa i nas nadmiarowe).
     * Z tego mechanizmu bedziemy musieli korzystac do czasu
     * az na poziomie InvObject beda roztrzygane konflikty 
     * pomiedzy obiektami w Inventory
     **/
    void CheckInventoryContentAlert()
    {
        DisableCallMethod( "CheckInventoryContentAlert" );
        CallMethodIn( "CheckInventoryContentAlert", 1.0f );
        
        if ( !m_bInventoryContentValid )
        {
            NetLog.PlayerInventory(" Lista InventoryContent jeszcze nie przyszla z serwera \n");
            return;
        }
        
        NetLog.PlayerInventory("----------------------------------------------\n");
        int nSize = (m_aInventoryContentFromServer != null) ? m_aInventoryContentFromServer.length : -1;
        NetLog.PlayerInventory(" Lista InventoryContent "+GetNetInfo()+" ma wielkosc "+nSize+"\n");
        for ( int i=0; i<nSize; ++i )
        {
            int        nId     = m_aInventoryContentFromServer[ i ];
            GameObject cObj    = GetObjectByNetId( nId );
            InvObject  cInvObj = (cObj instanceof InvObject)?(InvObject)cObj:null;
            
            NetLog.PlayerInventory("-"+i+" "+((cInvObj != null)?(""+cInvObj.GetNetInfo()):"")+"\n");
            
            if ( ! IsObjectInInventory( cInvObj ) )
            {
                NetLog.PlayerInventory("WARNING: Obiektu "+cInvObj+" nam brakuje!\n");
                if (cInvObj != null)
                {
                    //wysylamy serwerowi prosbe o ponowne info o obiekcie
                    //zastrzegajac ze on u nas nie byl planowany
                    cInvObj.MsgSendServerStateRequest( true, this, true );
                }
            }
        }
        
        NetLog.PlayerInventory("--------------\n");
        NetLog.PlayerInventory("Zawartosc inwentory :"+cInventory.GetInvObjSize()+" obiektow\n");
        
        for ( int i=0; i<cInventory.GetInvObjSize(); ++i )
        {
            InvObject cInvObj = (InvObject)cInventory.aInvObjects.elementAt( i );
            int       nId     = cInvObj.GetNetId();
            
            NetLog.PlayerInventory("-"+i+" "+((cInvObj != null)?(""+cInvObj.GetNetInfo()):"")+"\n");
            
            int j = 0;
            for ( ; j<nSize; ++j )
            {
                if ( m_aInventoryContentFromServer[ j ] == nId )
                    break;
            }
            if ( j >= nSize )
            {
                NetLog.PlayerInventory("ERROR: Obiektu "+cInvObj+" nie powinno tu byc!\n");
                //wysylamy serwerowi prosbe o ponowne info o obiekcie
                //zastrzegajac ze on u nas nie byl planowany
                cInvObj.MsgSendServerStateRequest( true, this, false );
            }
        }
                
        NetLog.PlayerInventory("----------------------------------------------\n");
    }
    
    /**
     * Callback wolany po tym, jak gracz sprawdzl ze ma w inwentory
     * dokladnie to co serwerm mu wlozyl (tzn ze "splynely" juz z serwera
     * wszystkie obiekty.
     * Bedzie to informacja potrzeba dla PlayerNetBaseMortal'a zeby
     * wiedziel ze moze sie juz wyspawnowac
     */
    void InventoryContentChecked()
    {
        DisableCallMethod( "CheckInventoryContentAlert" );
        ShowInventory("FillOnClient");
        super.InventoryContentChecked();
    }

    /** 
     * Zaznaczenie ze lista z zawartoscia inwentory
     * nie jest aktualna
     * Zagwarantuje nam to ze zawolanie w tym momencie
     * metody CheckInventoryContent() zawsze zwroci 
     */
    void CleanInventoryContent()
    {
        m_bInventoryContentValid = false;
        DisableCallMethod("CheckInventoryContentAlert");
    }
    
    /** 
     * Metoda wolana po odczytaniu danych z serwera
     * zaznacza ze dane odczytane do listy zawartosci
     * sa istotne i zagwarantuje nam to ze zawolana 
     * od tej chwili metody CheckInventoryContent()
     * bedzie porownywala liste ze stanem naszego inwentarza 
     */
    void SetInventoryContentValid()
    {
        m_bInventoryContentValid = true;
    }
    
    
    /**
     * Metoda pozycjonujaca guna,
     * Sprawdza czy ActiveWeapon faktycznie znajduje sie w
     * inwentory gracza, tylko w takim przypadku wola super'a
     */
    void PlaceGun()
    {
        if ( IsObjectInInventory( ActiveWeapon ) )
        {
            super.PlaceGun();
            
            //dodatkowa lata na to, zeby nie bylo widac w trybie FPP
            //renderujacej sie broni
            if ( (nRenderMode != REN_FULL) && 
                 (ActiveWeapon!=null) && (ActiveWeapon.IsRenderable()) )
            {
                NetLog.Warning("ActiveWeapon "+ActiveWeapon.GetNetInfo()+
                               " IsRenderable() in nRenderMode "+nRenderMode+
                               " -> force EnableRendering(false) ");
                ActiveWeapon.EnableRendering(false);
            }
        }
    }
    
        
    public void Respawn()
    {
        super.Respawn();
        CleanInventoryContent();
        if ( Role == ERole._AUTHORITY || bNetIsOwner )
            NetLog.PlayerInventory("------ Respawn nr:"+GetRespawnCnt()+" "+GetNetInfo()+" -----------\n");
    }
        
    float _DEVIATION_RANGE = 300.0f;
    float _Y_LEVEL         = 1.0f;
    Vector GetRandomPosAroundMe()
    {
        Vector  vMyPos    = GetPosition();
        Vector  vFoundPos = null;
        boolean bFound    = false;
        int     i = 0;
        do {
            
            vFoundPos = new Vector ( vMyPos );
            bFound    = true;
            
            if ( ++i < 10 )
            {
                // wylosujmy jakies miejsce w okolicy
                vFoundPos.fX += (RandomFloat(1.0f) - 0.5f)*_DEVIATION_RANGE;
                vFoundPos.fZ += (RandomFloat(1.0f) - 0.5f)*_DEVIATION_RANGE;
                // i domyslnie wyznaczmy pozycje tuz nad ziemia
                vFoundPos.fY  = _Y_LEVEL + TerrainHeight( vFoundPos.fX,vFoundPos.fZ );
                
                // strzelmy promieniem czy nie ma jakiejs przeszkody
                Vector vStart = new Vector( vMyPos );
                vStart.fY    += 300.0f;
                Vector vEnd   = new Vector( vFoundPos );
                        
                Collision coll = TraceObjectsExclude( vStart, vEnd, this );
        
                // jesli przeszkoda byla
                if ( coll != null )
                {
                    if ( coll.Obstacle instanceof InvObject ||
                         coll.Obstacle instanceof Bullet ||
                         coll.Obstacle instanceof Vehicle)
                        bFound = false;
                    else
                    {
                        // to jesli to bylo nie wyzej niz metr nad
                        // dotychczasowa pozycja gracza, to ta pozycje
                        // przyjmujemy za wynik, jak wyzej to szukamy dalej
                        if ( vMyPos.fY + 100.0f > vEnd.fY )
                             vFoundPos.fY = vEnd.fY + _Y_LEVEL;
                        else
                            bFound = false;
                    }
                }
            }
            
        } while ( ! bFound  );
                
        
        return vFoundPos;
    }
    
    
    void StopDrugs()
    {
        GameObject aDrugs[] = GetObjectsFromClass("Drug");
        if (aDrugs != null) 
            for (int i = 0; i < aDrugs.length; i++)
            {
                if ( aDrugs[i] instanceof Drug )
                {
                    Drug cDrug = (Drug)aDrugs[i];
                    if (cDrug.Owner == this)
                        cDrug.StopUse();
                }
            }
    }

    /** Zmiana broni
     */
    //bron ktora ma stac sie aktualna
    int     m_nWeaponToUse        = -1;
    
    //liczniki zmian broni - sluzo one po to, aby wykluczyc mozliwosc
    //zmiany broni w innej kolejnosci niz zalozona. kazdy host chcacy
    //zmienic bron w komunikacie wysyla kolejny numerek zmiany, natomiast
    //po stronie odbiorcy komunikat jest obsluzony tylko wtedy, gdy odebrany 
    //numerek jest wiekszy od poprzedniego
    //licznik wychodzacych zmian broni 
    //- na kliencie requesty do serwera
    //- na serwerze wymuszenia do klientow
    int     m_nChangeWeaponOutCnt = 0;
    //licznik przychodzacych zmian broni 
    //- na serwerze requesty od klienta, 
    //- na kliencie wymuszenia z serwera
    int     m_nChangeWeaponInCnt  = 0;

    /** Akcja zmiany broni
     */    
    void ActionChangeWeaponState()
    {
        //Czesiu dorobil wolanie zmiany broni w roznych stanach
        //gracza, zatem to remuje
        /*if ( sCurrentState.compareTo("FreehandState") != 0 )
            return;*/
            
        if (Role == ERole._AUTHORITY)
        {
            // jestesmy serwerem
            if (bNetIsOwner)
            {
                // jezeli jestesmy wlascicielem, to znaczy ze to my wywolalismy
                // ta akcje, trzeba z WeaponToUse policzyc identyfikator m_nWeaponToUse
                // ktory wyslemy klientom
                if ( WeaponToUse != null )
                    m_nWeaponToUse = WeaponToUse.GetNetId();
                else
                    m_nWeaponToUse = -1;
            }
            else
            {
                
                /* remuje, bo przypadek przejscia z ChangeWeaponState do ChangeWeaponState
                //bedzie obsluzony w samym ChangeWeaponState.OnEnter
                if (sCurrentState.compareTo("ChangeWeaponState") == 0)
                {
                    LogD(" canceled, sCurrentStare == "+sCurrentState+"\n");
                    return;
                }*/
                        
                // jezeli nie jestemy wlascicielem, to znaczy ze to 
                // jakis klient wykonal ta akcje, trzeba ja zweryfikowac
                
                // sprawdzmy co to za bron on chce teraz miec w rece,
                // klient przyslal nam jej sieciowy identyfikator
                if ( m_nWeaponToUse != -1 )
                {
                    // znajdujemy ta bron
                    WeaponToUse = GetWeaponByNetId(m_nWeaponToUse);
                
                    //LogR(" WEAPON CHANGE IN REQ "+WeaponToUse+"\n");
                    
                    // i sprawdzmy, czy istnieje cos takiego
                    if ( WeaponToUse == null )
                    {
                        LogD(" Bron o id "+m_nWeaponToUse+" nie istnieje, akcja odrzucona!\n");
                        return;
                    }
                    
                    // sprawdzmy, czy to nie jest aktualna bron
                    /*if ( WeaponToUse == ActiveWeapon )
                    {
                        LogD(" Bron "+WeaponToUse+" o id "+m_nWeaponToUse+
                             " jest juz jako aktualna, akcja odrzucona!\n");
                        WeaponToUse = null;
                        return;
                    }*/
                    
                    // sprawdzic, czy bron jest w inwentory gracz, jezeli nie to wypad...
                    if ( IsObjectInInventory(WeaponToUse) == false )
                    {
                        LogD(" Bron o id "+m_nWeaponToUse+" nie jest w inwentory, akcja odrzucona!\n");
                        WeaponToUse = null;
                        return;
                    }
                }
                else
                {
                    WeaponToUse = null;
                }        
            }
                        
            //LogR(" WEAPON CHANGE IN REQ "+WeaponToUse+" OK, sending to clients...\n");
            
            // wysylamy klientom info o akcji
            MsgSendClientAction( EPlayerAction.WEAPON_CHANGE, m_nWeaponToUse, ++m_nChangeWeaponOutCnt );
            // i sami wykonujemy akcje
            super.ActionChangeWeaponStateDo();
        }
        else
        {
            // jestesmy klientami
            // wyslij requesta do serwera
            //LogR(" WEAPON CHANGE REQ "+WeaponToUse+"\n");
            if ( WeaponToUse != null )
                MsgSendServerActionRequest( EPlayerAction.WEAPON_CHANGE, WeaponToUse.GetNetId(), ++m_nChangeWeaponOutCnt );
            /*else
                MsgSendServerActionRequest( EPlayerAction.WEAPON_CHANGE );*/
        }
        
    }
    
    /** CLIENT wykonanie zmiany broni na kliencie
     * Pierw przygotowanie (znalezienie obiektow) pozniej prawdziwa akcja
     */
    void ActionChangeWeaponStateDo()
    {
        if ( m_nWeaponToUse == -1 )
        {
            WeaponToUse = null;
        }
        else
        {
            Weapon weapon = GetWeaponByNetId( m_nWeaponToUse );
            
            if ( (weapon != null) && (weapon.Owner == this))
                WeaponToUse = weapon;
            else
            {
                CallMethodIn( "ActionChangeWeaponStateDo", 0.1f );
                return;
            }
        }
        
        DisableCallMethod( "ActionChangeWeaponStateDo" );
        
        
        super.ActionChangeWeaponStateDo();
    }

    /**
     * Zmiana broni przez ChangeWeapon (a nie ActionChangeWeaponState)
     * jest troszke niebezpieczna (moze sie roznie wykonac na kazdym
     * z kompow) zatem warto aby serwer po zakonczonej akcji wyslal
     * stan broni trzymanej w rece na klientow. Wtedy mamy pewnosc
     * ze gra sie nie rozjedzie.
     */
    void ChangeWeapon(Weapon cWeapon)
    {
        super.ChangeWeapon( cWeapon );
        
        if ( Role == ERole._AUTHORITY && cWeapon != null )
            cWeapon.SetSendClientStateOnPlayerGotInHands();
    }
    
    
    boolean bActionAiming = false;
    
    float m_fAimingStartTime = 0.0f;
    /** Akcja przycelowania (rozpoczecie)
     */
    void ActionAimingStart()
    {
        super.ActionAimingStart();
        bAiming = motion.bAiming;
    }
    
    float m_fAimingStopTime = 0.0f;
    /** Akcja przycelowania (rozpoczecie)
     */
    void ActionAimingStop()
    {
        super.ActionAimingStop();
        bAiming = motion.bAiming;
    }
    
    /** Akcja przeladowania broni
     */
    void ActionReloadingStart()
    {
        if ( 
             ActiveWeapon       != null                     &&
             ActiveWeapon.nAmmo != ActiveWeapon.nCapacity   &&
            ( sCurrentState.equals("FreehandState") ||
              sCurrentState.equals("AimState") )
           )
        {
            if (Role == ERole._AUTHORITY)
            {
                MsgSendClientAction( EPlayerAction.RELOAD, 1 );
                            
                super.ActionReloadingStartDo();
            }
            else
            {
                MsgSendServerActionRequest( EPlayerAction.RELOAD, 1 );
            }
        }
    }
    
    
    void StartUsingBinocularsDo()
    {
        if ( m_cBinocularsToUse == null )
        {
            GameObject cObj = GetObjectByNetId( m_nBinocularsToUse );
            
            if ( cObj instanceof Binoculars )
                m_cBinocularsToUse = (Binoculars)cObj;
        }
        if ( m_cBinocularsToUse == null || m_cBinocularsToUse.Owner != this )
        {
            //TODO: jak binoculars jeszcze nie jest wyspawnowane w graczu 
            //to tez poczekac
            CallMethodIn("StartUsingBinocularsDo",0.1f);
            return;             
        }
        
        UseBinoculars( (Binoculars)m_cBinocularsToUse );
    }
    
    
    
    void StopUsingBinocularsDo()
    {
        if ( cBinoculars != null )
            cBinoculars.EndUse();
    }
    
    void UseBinoculars(Binoculars cNewBinoculars)
    {
        super.UseBinoculars( cNewBinoculars );
        m_nState = _STATE_BINOCULARS;
        SetTargetActorNull();
    }
        
    void RestoreViewAfterBinoculars()
    {
        super.RestoreViewAfterBinoculars();
        m_nState = _STATE_SPAWNED;
    }

    void InitViewForAiming()
    {
        super.InitViewForAiming();
        m_nState = _STATE_AIMING;
       
        if ( ActiveWeapon                     != null &&
             ActiveWeapon.cZoomer             != null &&
             ActiveWeapon.cZoomer.eAimingType == EWeaponAimingType._SNIPER )
        {
            SetTargetActorNull();
        }
    }
    
    void RestoreViewAfterAiming()
    {
        super.RestoreViewAfterAiming();
        m_nState = _STATE_SPAWNED;
    }
    
    
    /**
     * Metoda sprawdzajaca czy mozna wykonac akcje
     */
    boolean ServerVerifyActionExecute( TriggerObject cTrigger )
    {
        if ( bDead )
            return false;
        return cTrigger.ServerVerifyActionExecute( this, 2.0f*fTriggerVisibilityRange );
    }
    
    void UseWeapon( Weapon cWeapon )
    {
        if ( (cWeapon != null) && (! IsObjectInInventory( cWeapon )) )
            CrashLog("ERROR: Obiekt "+cWeapon+" nie nalezy do inwentory gracza "+this+" "+GetName()+"\n");
        super.UseWeapon( cWeapon );
    }
    
    void ShowInventory()
    {
        ShowInventory("");
    }
    void ShowInventory(String sText)
    {
        NetLog.PlayerInventory("-------------\n");
        NetLog.PlayerInventory("Player: "+GetNetInfo()+"\n");
        NetLog.PlayerInventory("ShowInventory "+sText+", razem "+cInventory.GetInvObjSize()+" obiektow\n");
        for ( int nInvObj=0; nInvObj<cInventory.GetInvObjSize(); nInvObj++ )
        {
            InvObject cInvObj = cInventory.GetInvObject( nInvObj );
            
            if ( cInvObj == null )
                continue;
            
            NetLog.PlayerInventory( 
                          nInvObj+" "+cInvObj.GetNetInfo()+
                          " ("+cInvObj.nGrid+
                          ","+cInvObj.nCellX+
                          ","+cInvObj.nCellY+")\n");
        }
        NetLog.PlayerInventory("-------------\n");
    }
    
    
    void CheatInventory()
    {
        for ( int nInvObj=0; nInvObj<cInventory.GetInvObjSize(); nInvObj++ )
        {
            InvObject cInvObj = cInventory.GetInvObject( nInvObj );
        
            cInvObj.Acquire( GetModule(), null );
            cInvObj.Acquire( GetModule(), this );
        }
    }
}
