public class PlayerNetBaseMover extends PlayerNetBaseInventory
{
    public boolean bResimulationAllowed = true;
    public boolean bStatesStoreAllowed = true;
    
    //czas co jak jest updateowany kierunek oraz schylenie gracza
    float m_fRotateAndErectusUpdateTime = 0.1f;
        
    boolean m_bSendServerMoveAfterODEUpdate = false;
    
    static int      sm_nControlWhileJumping     = 0;
    static boolean  sm_bCantAdjustPositionOnAir = false;
    
    static float    sm_fStateToAdjustMaxDelay = 2.0f;
    
    PuppetsVisibilityManager m_cPuppetsVisibilityManager = null; 
        
    private  boolean m_bLockedByConnectionStatusManager = false;
    void     SetLockedByConnectionStatusManager(boolean bLocked){ m_bLockedByConnectionStatusManager = bLocked; }
    boolean  IsLockedByConnectionStatusManager(){ return m_bLockedByConnectionStatusManager; }

    PlayerNetBaseMover()
    {
        super();
        
        m_bSlowDownOnEndOfJump     = true;
        
        m_bCameraBumpOnEndOfJump   = true;
        m_bDropSoundOnEndOfJump    = true;                
        _JUMP_STOP_MUL     = 1.00f;
        _JUMP_FORWARD_MUL  = 0.95f;
        
        m_bStopOnAimingAndCrawling = false;
        
        m_iCanTurnOnFlying = _CANTURNONFLYING_FROMSTANDING;
        m_bCanRunBackward = true;
            
        // Predkosci chodzenia            (still, swim, crawl, duck, walk,  run,  ladder climb)
        aMotionVelocity     = new float[] {    0,  225,   100,  250,  360,  550,     230};
        // Predkosci cofania sie     
        aMotionVelocityBack = new float[] {    0,  100,    75,  200,  300,  450,     150};
        // Predkosci strafeowania    
        aStrafeVelocity     = new float[] {    0,  125,   100,  200,  300,  500,      50};
        // Przyspieszenie            
        aMotionAcceleration = new float[] {    0,  200,   200,  600, 1800, 2000,     800};
        		
		//czas trwania zwolnienia przy postrzale
		m_fSlowDownOnRecoilTime       = 0.2f;
        //wspolczynnik zwolnienia przy postrzale
		m_fSlowDownOnRecoil           = 0.5f;
        //minimalny czas trwania zwolnienia (przy "malych" zeskokach)
		_SLOW_DOWN_ON_END_OF_JUMP_MIN = 0.3f;
        //maksymalny czas trwania zwolnienia (przy "duzych" zeskokach)
		_SLOW_DOWN_ON_END_OF_JUMP_MAX = 0.6f;
        
        if ( aMotionVelocity == null )
        {
            CrashLog("ERROR: aMotionVelocity == null");
            return;
        }
        //policzmy z jaka predkoscia moze sie minimalnie/maksymalnie poruszac gracz
        m_fInterpolateSpeedOnStop = aMotionVelocity[ 1 ];
        for ( int i=2; i<aMotionVelocity.length; i++ )
        {
            float fSpeed = aMotionVelocity[i];
            if ( m_fInterpolateSpeedOnStop < fSpeed )
                 m_fInterpolateSpeedOnStop = fSpeed;
        }
        //m_fInterpolateSpeedOnStop *= 1.5f;
        
        SetMaxInterpolateDistance( 400.0f ); 
        
        //TODO: fixit!!!! tylko do testow
        //bo ODE jeszcze nie radzi sobie z tym.
        m_bSlowDownOnEndOfJump = false;

        //m_bCanRunWithHeavyGun = true;
    }
    
    int METHOD_EnableNextJump   = 0;
    int METHOD_ForceEndOfJump   = 0;

    public void OnCreate()
    {
        METHOD_EnableNextJump   = RegisterCallMethod( "EnableNextJump" );
        METHOD_ForceEndOfJump   = RegisterCallMethod( "ForceEndOfJump" );
        
        PROFILE_CheckReceivedClientMoves = ProfileAdd("net_sim", "CheckReceivedClientMoves");
        PROFILE_TryToApplyClientMove = ProfileAdd("net_sim", "TryToApplyClientMove");
        PROFILE_ApplyClientMoveListAdd = ProfileAdd("net_sim", "T2ACM List Add");
        PROFILE_ApplyClientMoveApply = ProfileAdd("net_sim", "T2ACM Apply");

        super.OnCreate();
    
        m_cPuppetsVisibilityManager = new PuppetsVisibilityManager( this );
        
        if ( bNetIsOwner )
        {
            if (Role < ERole._AUTHORITY)
            {
                // tworzymy obiekt listy stanow
                // TODO ustalenie wielkosci listy, na podstawie wielkosci pinga
                m_cSentStatesList = new PlayerNetStateList( this, PlayerNetStateList.sm_nMaxClientSentStates );
                m_cSentStatesList.Start(); // GetTime() );
            }
	    }
        else  // SERVER i CLIENT, NIE WLASCICIEL
        {
            
            if (Role == ERole._AUTHORITY)
            {
                m_aSimulatedStates = new PlayerNetStateList( this, PlayerNetStateList.sm_nMaxServerSimulatedStates );
                m_aSimulatedStates.Start();
            }
            else
            {
                //na kliencie nie wlascicielu nie musi sie symulowac
                //fizyka w pelni okazalosci
                //Uwaga: w ODE to i tak nie bedzie dzialac
                EnablePhysicsSimplifySimulate();
            }
        }
        m_bSendMoveAllowed = true;
    }
    
    public void OnDestroy()
    {
        super.OnDestroy();
        
        if ( m_cSentStatesList != null )
        {
            m_cSentStatesList.Destroy();
            m_cSentStatesList = null;    
        }
        m_cPuppetsVisibilityManager.Destroy();
    }

    void DeactivateOnActivateDeadBody()
    {
        super.DeactivateOnActivateDeadBody();
        m_cPuppetsVisibilityManager.StopForAWhile();
    }

        
    boolean m_bRespawning = false;    
    boolean m_bSendMoveAllowed = true;    
    
    public void Respawn()
    {
        super.Respawn();

        nEnvironment = EMoveEnv.CHMOVE_GROUND;
        CleanPlayerMotion();
        //TODO: wstawic to do cleanmotion
        ForceEndOfJump();
        vOldForward = GetForwardVector();
        SetLocalSpeed( Vector.Zero );
        m_fRotateH = 0.0f;
        m_fRotateV = 0.0f;
        vCurRecoilTranslation.Set(0,0,0);
        vRecoilTranslation.Set(0,0,0);
        UpdateMotion();
        SetCorrectPosOnRender( true );
        m_bSendMoveAllowed = true;
        m_cPuppetsVisibilityManager.Reset();
    }
    
    /** Update predkosci robiony np. w UpdateMotion i po zmianie fSpeedMult (DrugSpeed)
     */
    public void UpdateSpeed()
    {
        if ( !ServerOrClientOwner() )
            return;
        
        if ( m_bOnChangeMovement && nEnvironment==EMoveEnv.CHMOVE_AIR )
            return;
        
        int iSpeed = motion.iSpeed;
        
        if( (motion.iSpeed == MotionState.SPEED_CRAWL) ^ (oldMotion.iSpeed == MotionState.SPEED_CRAWL) )
        {
			vSpeed.Set(0, 0, 0);
            SetLocalSpeed( vSpeed, false );
        }
        
        // gdy gracz sie wspina to ma inna predkosc
        if(motion.nClimbing == motion._CLIMBING_TRUE)
            iSpeed = motion.SPEED_LADDER;

        if ( !AmIFlying() || CanTurnOnFlying() )
        {
            float fSM = fSpeedMult * (bRecoiling ? m_fSlowDownOnRecoil : 1.0f );
            
            //jesli nie lecimy to mozemy policzyc na nowo vSpeed
            Vector vNewSpeed = new Vector(0,0,0);

            // tablica z ktorej bedziemy pobierali predkosc przed/tyl
            float aVelocity[] = (motion.iMoveZ > 0) ? aMotionVelocity : aMotionVelocityBack;
            
            //skladowa predkosci przod/tyl
            float fSpeedForwardBack = aVelocity[iSpeed] * fSM;
            //skladowa predkosci lewo/prawo
            float fSpeedStrafe      = aStrafeVelocity[iSpeed] * fSM;
            
            //zapamietajmy sobie maksymalna predkosc
            float fMaxSpeed = ( fSpeedForwardBack > fSpeedStrafe) ? 
                              fSpeedForwardBack                  : 
                              fSpeedStrafe;
            
            if(motion.nClimbing != motion._CLIMBING_TRUE)
                vNewSpeed.Set(fSpeedStrafe * motion.iMoveX, 0.0f, fSpeedForwardBack * motion.iMoveZ );
            else
            {
                // wspinaczka po drabinie
                float fSpeedY = fSpeedForwardBack * motion.iMoveZ;
                Vector vEnd = GetAimDir();
                fSpeedY *= (vEnd.fY > 0.f) ? 1.f : -1.f;
                
                vNewSpeed.Set(fSpeedStrafe * motion.iMoveX, fSpeedY, 0.0f);
            }

            //jesli idziemy po przekatnej, to predkosc jest 
            //srednia predkosci strafe i forward/back
            if ( (motion.iMoveX != 0) && 
                 (motion.iMoveZ != 0) ) 
            {
                vNewSpeed.Normalize();
                //vNewSpeed.Mul( ( fSpeedForwardBack + fSpeedStrafe ) * 0.5f  );
                vNewSpeed.Mul(fSpeedForwardBack);
            }
            
            if (sm_nControlWhileJumping != 0 &&
                nEnvironment == EMoveEnv.CHMOVE_AIR)
            {
                //w trakcie lotu predkosc jest modyfikowana tylko w 
                //ograniczonym zakresie, zatem bedziemy dodawali 
                //polowe aktualnie wyliczonego wektora
                vNewSpeed.Mul( 0.5f );
                //do obecnego wektora predkosci
                vNewSpeed.Add( vSpeed );
                
                //ograniczmy dlugosc wektora
                //TODO:w przypadku gey strafujemy, albo strafowalismy to
                // mozemy miec problemy z ograniczeniem predkosci, 
                //w przyszlosci to uwzglednic
                if ( vNewSpeed.Len() > fMaxSpeed )
                {
                    vNewSpeed.Normalize();
                    vNewSpeed.Mul( fMaxSpeed );
                }
            }
            
            vSpeed = vNewSpeed;
        }
        
        if (Math.abs(vSpeed.fX) < 0.001f) vSpeed.fX = 0.f;
        if (Math.abs(vSpeed.fY) < 0.001f) vSpeed.fY = 0.f;
        if (Math.abs(vSpeed.fZ) < 0.001f) vSpeed.fZ = 0.f;

        SetWalkAccel(aMotionAcceleration[iSpeed]);
        SetWalkDestSpeed(vSpeed);
    }

    // zabawa z elipsoida
    boolean m_bUpdateEllipsoidRequired = false;
    void UpdateEllipsoidAndMaxClimbAngle()
    {
        if ( m_bNetResimulate )
        {
            m_bUpdateEllipsoidRequired = true;;
            return;
        }
        
        m_bUpdateEllipsoidRequired = false;

        if (m_iSpeed != motion.iSpeed)
        {
            Vector vPos = GetLocalPosition();
            super.UpdateEllipsoidAndMaxClimbAngle();
            SetPosition(vPos);
        }
    }    

    void UpdateAnims(float fDelta)
    {
        //TODO
    }
    
    // w tej funkcji w pawn.java jest attachowanie i detachowanie - w sieci tego nie ma
    void CheckVehicle()
    {
    }
    
    void CheckSendServerMoveOnUpdate()
    {
        if ( bNetIsOwner && (Role < ERole._AUTHORITY) )
        {
            //CLIENT, WLASCICIEL - wysyla ruch gracza do serwera
            // gdy nie jest wywolanie UpdateState/UpdateMotion wtrakcie resymulacji
            // gdy nastapila zmiana kierunku patrzenia/strzelania
            // gdy nastapila zmiana ruchu
            if ( ! m_bNetResimulate && RequiredSendServerMove() )
                MsgSendServerMove();
        }
    }
        
    boolean RequiredSendServerMove()
    {
        // TODO; tymczasowo!!!
        if (m_nState == _STATE_IN_VEHICLE/* || m_nState == _STATE_ON_LIFT*/)
            return false;
            
        if (GetAimDirection().IsEqual( m_cLastSentState.vDir ) == false)
        {
            if (bDebugSendMove)
                LogD(" vDir\n");
            return true;
        }
            
        
        //if (m_cLastSentState.cMotion.IsEqual( motion ) == false)
        if ( motion.Changed( m_cLastSentState.cMotion ) )
        {
            if (bDebugSendMove)
            {
                LogD(" cMotion\n");
                m_cLastSentState.cMotion.IsEqualShow( motion );
            }
            return true;
        }
        
        if ( m_cLastSentState.bWalking != bWalking )
            return true;
        if ( m_cLastSentState.bDucking != bDucking )
            return true;
        if ( m_cLastSentState.bCrawling != bCrawling )
            return true;
        if ( m_cLastSentState.bRecoiling != bRecoiling )
            return true;
        if ( m_cLastSentState.nHitReaction != nHitReaction )
            return true;
        if ( m_cLastSentState.fSpeedMult != fSpeedMult )
            return true;
            
        return false;            
    }

    
    /** Metoda wolana na koniec kazdej ramki
     */
    void FrameFinished()
    {
        super.FrameFinished();

        // TODO; tymczasowo!!!
        if (m_nState == _STATE_IN_VEHICLE)
            return;
        
        if ( Role == ERole._AUTHORITY )
        {
            if ( ! bNetIsOwner )
            {
                //sprawdzmy czy nie mamy jakis ruchow od klienta do obsluzenia
                //CheckReceivedClientMoves();
            
                //update kamery do oceny relewantnosci
                //UpdateCurrentCamera();
            }
        }
        else //CLIENT (Role < ERole._AUTHORITY)
        {
            if ( bNetIsOwner )
            {
                //CLIENT, WLASCICIEL
                CheckSendServerMoveOnFrameFinished();
            }    
            else
            {
                //CLIENT, NIE WLASCICIEL
                //MotionStateFromPhysics();
            }        
        }
        
        //ShowPhysicsState("FF");
        //LogD(" "+cNetPlayerInfo.sNick+" NetId:"+GetNetId()+"\n");
    }
    
    public void OnReceivedDataOnServer()
    {
        super.OnReceivedDataOnServer();
        if (/*Role == ERole._AUTHORITY &&*/ !bNetIsOwner)
        {
            //sprawdzmy czy nie mamy jakis ruchow od klienta do obsluzenia
            CheckReceivedClientMoves();
            
            //update kamery do oceny relewantnosci
            UpdateCurrentCamera();
        }
    }
    
    
    public final static float _RAD2BYTE = (float)(127.f / Math.PI);
    public final static float _BYTE2RAD = (float)(Math.PI / 127.f);
    
    static Vector sm_DirToSet = new Vector();
    ControlObject m_cLastReceivedDataParent = null;
    public void OnReceivedDataOnClient()
    {
        super.OnReceivedDataOnClient();
        if (!bNetIsOwner)
        {
            if (m_nState == _STATE_IN_VEHICLE)
                m_fLastPosForSpeedCalcTime = -1f;
            else
            {
                float fAngleH = (float)byAngleH * _BYTE2RAD;
                sm_DirToSet.fX = (float)Math.sin(fAngleH);
                sm_DirToSet.fY = 0;
                sm_DirToSet.fZ = (float)Math.cos(fAngleH);
                SetDir(sm_DirToSet);
                fAimAngleY = (float)byAngleV * _BYTE2RAD;
    //            LogR("fAimAngleY = " + fAimAngleY + "\n");

                /** Jesli sie zmienil parent, to pozycja lokalna ulega drastycznej zmianie
                 *  trzeba wtedy ustawic, wyliczona predkosc jest wtedy niepoprawna
                 */
                ControlObject parent = GetParent();
                if (parent != m_cLastReceivedDataParent) 
                {
                    m_cLastReceivedDataParent = parent;
                    m_fLastPosForSpeedCalcTime = -1; // ustaw znacznik, ze pozycja invalid
                }
                else
                {
                    // uzyj teraz sm_DirToSet jako storeage'a na pozycje lokalna...
                    GetLocalPosition(sm_DirToSet);
                    // policz predkosc na podstawie zmiany pozycji
                    CalcSpeedFromPosChange(sm_DirToSet, GetLastIncomingReplicationTime(sm_nRepSetClientNotOwnerStatePacked));
                    // ustaw motion state na podstawie predkosci
                    MotionStateFromPhysics();
                }
            }
            m_cPuppetsVisibilityManager.Check( GetLastIncomingReplicationTime(sm_nRepSetClientNotOwnerStatePacked) );
        }
    }
    
    
    public void PrepareDataForReplication()
    {
        super.PrepareDataForReplication();
        Vector vDir = GetForwardVectorVolatile();
        
        float fAngleH = (float)Math.atan2(vDir.fX, vDir.fZ);
        if (fAngleH < -Math.PI)
            byAngleH = -127;
        else if (fAngleH > Math.PI)
            byAngleH = 127;
        else
            byAngleH = (byte)(fAngleH * _RAD2BYTE);
        
        if (fAimAngleY < -Math.PI)
            byAngleV = -127;
        else if (fAimAngleY > Math.PI)
            byAngleV = 127;
        else
            byAngleV = (byte)(fAimAngleY * _RAD2BYTE);
    }
    
    
    
    static boolean sm_bOnFrameFinished = false;
    
    void CheckSendServerMoveOnFrameFinished()
    {
        if ( bNetIsOwner && (Role < ERole._AUTHORITY) )
        {
            float fNow = GetTime();
            
            //CLIENT, WLASCICIEL
            sm_bOnFrameFinished = true;            
            // wysyla ruch gracza do serwera
            // gdy nastapila zmiana parenta
            // gdy nastapila zmiana kierunku patrzenia/strzelania
            // gdy czas od ostatniego wyslania jest dostatecznie odlegly
            if ( 
                ( m_cLastSentState.cParent != GetParent())           
                ||  
                (!m_cLastSentState.vDir.IsEqual( GetAimDirection() ) )
                ||
                m_cLastSentState.TimeOut( fNow ) 
                ) 
            {
                //LogR("Sending client move timeOut="+m_cLastSentState.TimeOut( fNow )+" fNow="+fNow+" m_cLastSentState.fTime="+m_cLastSentState.fTime+"\n");
                
                //TODO: tu mozna wyslac skrocony stan
                MsgSendServerMove();
            }
            sm_bOnFrameFinished = false;            
        }
    }
            

        boolean m_bNextJumpEnabled = true;
    
    boolean CanProcessJumpKey()
    {
        return super.CanProcessJumpKey() && m_bNextJumpEnabled;
    }
    
    boolean CanPlayerJump()
    {
        return (super.CanPlayerJump() && (GetMass() > 0.0f));
    }
    
    void PlayerJump()
    {
        if ( Role == ERole._AUTHORITY )
        {
            MsgSendClientActionMode( EPlayerAction.JUMP, -1, -1, EMsgSendMode.NOTOWNER );
        }
        
        // zabezpieczenie zebysmy czasem nie skakali bez masy!!!
        if ( GetMass() <= 0.0f )
        {
            SetMass( fMass );
//            LogR("SetMass(" + fMass + ") w PlayerJump\n");
        }
        
        super.PlayerJump();
        m_bNextJumpEnabled = true; //false;
        CallMethodIn( METHOD_ForceEndOfJump, 5.0f );
    }
    
    void EndOfJump()
    {
        super.EndOfJump();
        // CallMethodIn( METHOD_EnableNextJump, 0.1f );
        DisableCallMethod( METHOD_ForceEndOfJump );
    }
    
    float m_fAutoNextJump = -1.0f;
    void EnableNextJump()
    {
        m_bNextJumpEnabled = true;
        //TODO: tylko do testow
        if ( bNetIsOwner && m_fAutoNextJump >= 0.0f )
            CallMethodIn("ForceJump",m_fAutoNextJump);
    }


    /** SERVER 
     *  Ruchy playera z klienta, ktore przyszly na serwer
     * i nie zostaly jeszcze obsluzone
     */    
    protected java.util.Vector m_aReceivedClientMoves = new java.util.Vector( 0 );
    
    /** SERVER 
     *  Stan playera na serwerze ktory ostatnio zostal przesymulowany
     */
    PlayerNetState m_cLastResimulatedState = null;
    
    /**
     * Lista ostatnio symulowanych stanow na serwerze
     */
    protected PlayerNetStateList m_aSimulatedStates = null;
    /**
     * Czas ostatnio symulowanego stanu na serwerze
     */
//    float m_fLastSimulatedStatesTime = -1;
    
    /** SERVER 
     *  Ostatni czas kiedy wyslany byl adjust pozycji do klienta
     */
    float m_fLastSentAdjustTime = 0.0f;
    
    /** SERVER 
     *  Czas, po ktorym server wysle informacje korygujace polozenie gracza
     */
    final static float MIN_ADJUST_POSITION_TIME = 1.0f;
    
    /** SERVER 
     * Maksymalna wielkosc roznicy pozycji gracza u clienta i servera, gdy roznica
     * wieksza niz ta wartosc to jest wysylane ClientAdjustPosition.
     * Kwadrat odleglosci dla oszczednosci
     * Chwilowo nie jest to wykorzystywane
     */
    final static float MAX_CLIENT_MOVE_DEVIATION2 = 0.1f;

    // czas, po ktorym wymuszonye jest wyslanie adjusta do klienta
    // sprawdzany jest DEVIATION2_EPSILON, aby nie adjustowac niepotrzebnie
    final static float MAX_NOTADJUST_POSITION_TIME = 3.f;
    final static float DEVIATION2_EPSILON = 0.001f;
    
        /**SERVER Obsluga ruchu przeslanego z clienta na server.
     * Wolane w odpowiedzi na odebrany message.
     */
    void MsgRecvServerMove()
    {
        // ODCZYT DANYCH
        PlayerNetReceivedMove cReceivedMove = new PlayerNetReceivedMove();
        
        
/* TODO: upakowac te dane!
        // odczytujemy dane o ruchu
        cReceivedMove.cState.nId                    = MessageUnPackInt();
        cReceivedMove.cState.fTimeStamp             = MessageUnPackFloat();
        cReceivedMove.cState.nODEDoneUpdatesCount   = MessageUnPackByte();
        cReceivedMove.cState.cMotion.iMoveX         = MessageUnPackByte();
        cReceivedMove.cState.cMotion.iMoveZ         = MessageUnPackByte();
        cReceivedMove.cState.cMotion.iSpeed         = MessageUnPackByte();
//        cReceivedMove.cState.cMotion.iTurn          = MessageUnPackByte();
        cReceivedMove.cState.cMotion.nJumping       = MessageUnPackByte();
        cReceivedMove.cState.nHitReaction           = MessageUnPackByte();
        cReceivedMove.cState.fSpeedMult             = MessageUnPackFloat();
        cReceivedMove.cState.vJavaSpeed             = MessageUnPackVector();
//        cReceivedMove.cState.vSpeed                 = MessageUnPackVector();
        cReceivedMove.cState.vLocalSpeed            = MessageUnPackVector();
        cReceivedMove.cState.vDestSpeed             = MessageUnPackVector();
        cReceivedMove.cState.vDir                   = MessageUnPackVector();
        cReceivedMove.vPos                          = MessageUnPackVector();
        cReceivedMove.cState.nParentId              = MessageUnPackInt();
        
        byte nFlags                                 = MessageUnPackByte();
        cReceivedMove.cState.cMotion.bAiming        = UnpackBooleanFromByte( nFlags, 0 );
        cReceivedMove.cState.bAmIAiming             = UnpackBooleanFromByte( nFlags, 1 );
        cReceivedMove.cState.bWalking               = UnpackBooleanFromByte( nFlags, 2 );
        cReceivedMove.cState.bDucking               = UnpackBooleanFromByte( nFlags, 3 );
        cReceivedMove.cState.bCrawling              = UnpackBooleanFromByte( nFlags, 4 );
        cReceivedMove.cState.bRecoiling             = UnpackBooleanFromByte( nFlags, 5 );
*/
        // odczytujemy dane o ruchu
        cReceivedMove.cState.nId                    = MessageUnPackInt();
        cReceivedMove.cState.fTimeStamp             = MessageUnPackFloat();
        cReceivedMove.cState.nODEDoneUpdatesCount   = MessageUnPackByte();
        cReceivedMove.cState.cMotion.iMoveX         = MessageUnPackByte();
        cReceivedMove.cState.cMotion.iMoveZ         = MessageUnPackByte();
        cReceivedMove.cState.cMotion.iSpeed         = MessageUnPackByte();
        cReceivedMove.cState.cMotion.nJumping       = MessageUnPackByte();
        cReceivedMove.cState.nHitReaction           = MessageUnPackByte();
//        cReceivedMove.cState.fGravity               = MessageUnPackByte();

        cReceivedMove.cState.fSpeedMult             = MessageUnPackFloat();

        sm_vLocalSpeed.Set(0,0,0);
        sm_vWalkDestSpeed.Set(0,0,0);
        
        byte nFlags = MessageUnPackByte();
        
        if (IsBitSet(nFlags, _BITPOS_LOCAL_SPEED_X))
            sm_vLocalSpeed.fX = MessageUnPackFloat();
        if (IsBitSet(nFlags, _BITPOS_LOCAL_SPEED_Y))
            sm_vLocalSpeed.fY = MessageUnPackFloat();
        if (IsBitSet(nFlags, _BITPOS_LOCAL_SPEED_Z))
            sm_vLocalSpeed.fZ = MessageUnPackFloat();
        
        if (IsBitSet(nFlags, _BITPOS_DEST_SPEED_X))
            sm_vWalkDestSpeed.fX = MessageUnPackFloat();
        if (IsBitSet(nFlags, _BITPOS_DEST_SPEED_Y))
            sm_vWalkDestSpeed.fY = MessageUnPackFloat();
        if (IsBitSet(nFlags, _BITPOS_DEST_SPEED_Z))
            sm_vWalkDestSpeed.fZ = MessageUnPackFloat();

        if (IsBitSet(nFlags, _BITPOS_PARENT))
            cReceivedMove.cState.nParentId = MessageUnPackInt();
        else
            cReceivedMove.cState.nParentId = -1;
        
        cReceivedMove.cState.vJavaSpeed.Set(sm_vWalkDestSpeed);
        cReceivedMove.cState.vDestSpeed.Set(sm_vWalkDestSpeed);
        cReceivedMove.cState.vLocalSpeed.Set(sm_vLocalSpeed);
        cReceivedMove.cState.vDir = MessageUnPackVector();
        cReceivedMove.vPos = MessageUnPackVector();
        
        nFlags = MessageUnPackByte();
        cReceivedMove.cState.cMotion.bAiming        = UnpackBooleanFromByte( nFlags, 0 );
        cReceivedMove.cState.bAmIAiming             = UnpackBooleanFromByte( nFlags, 1 );
        cReceivedMove.cState.bWalking               = UnpackBooleanFromByte( nFlags, 2 );
        cReceivedMove.cState.bDucking               = UnpackBooleanFromByte( nFlags, 3 );
        cReceivedMove.cState.bCrawling              = UnpackBooleanFromByte( nFlags, 4 );
        cReceivedMove.cState.bRecoiling             = UnpackBooleanFromByte( nFlags, 5 );
        
        MessageEnd();

        //LogR("Received move from client\n");
        
        // ustalamy kto jest ewentualnym parentem
        if ( cReceivedMove.cState.nParentId != - 1 )
        {
            GameObject cParent = GetObjectByNetId( cReceivedMove.cState.nParentId );
            if ( cParent instanceof ControlObject )
                cReceivedMove.cState.cParent = (ControlObject) cParent ;
        }
        else
            cReceivedMove.cState.cParent = null;
        
        // dla pewnosci sprawdzenie, ze to sie dzieje na serwerze
        if (Role < ERole._AUTHORITY ) 
            return;
                
        if (Math.abs(cReceivedMove.cState.vDestSpeed.fX) < 0.001f)
            cReceivedMove.cState.vDestSpeed.fX = 0.f;
        if (Math.abs(cReceivedMove.cState.vDestSpeed.fY) < 0.001f)
            cReceivedMove.cState.vDestSpeed.fY = 0.f;
        if (Math.abs(cReceivedMove.cState.vDestSpeed.fZ) < 0.001f)
            cReceivedMove.cState.vDestSpeed.fZ = 0.f;
                     
        // proba zastosowania odebranego ruchu
        TryToApplyClientMove( cReceivedMove );
        
//@@        NetLog.PlayerMover("Server odebral ruch gracza - Time: " + cReceivedMove.cState.fTimeStamp + " ODEUpdates: " + cReceivedMove.cState.nODEDoneUpdatesCount + 
//             " Speed: " + cReceivedMove.cState.vLocalSpeed + " WalkDestSpeed: " + cReceivedMove.cState.vDestSpeed + "\n");
    }

    void ClearODE()
    {
        SetODEGWLinVel(Vector.Zero);
        SetODEGWForce(Vector.Zero);
        SetODEGWStateBParam1(false);
        SetODEGWStateBParam2(false);
        SetODEGWStateFParam1(0);
        SetODEGWStateFParam2(0);
    }

    // maxymalne opoznienie ruchu, ktory bedzie jeszcze obslugiwany
    public float fMaxLagTime = 0.5f;   
    
    void TryToApplyClientMove(PlayerNetReceivedMove cReceivedMove)
    {
        ProfileBegin(PROFILE_TryToApplyClientMove);
        
        //jak nie zyjemy, albo jezdzimy pojazdami to nie bedziemy
        //akceptowali jakis zablakanych ruchow z klienta
        if ( bDead || (m_nState == _STATE_IN_VEHICLE) )
        {
            ProfileEnd(PROFILE_TryToApplyClientMove);
            return;
        }
        
        if ( m_cLastResimulatedState != null )
        {
            float fPhysicsLastUpdateTime = GetPhysicsLastUpdateTime();
            if (cReceivedMove.cState.fTimeStamp < fPhysicsLastUpdateTime - fMaxLagTime ) 
            {
                NetLog.PlayerMover(
                       " otrzymany ruch jest za 'stary' aby go symulowac!!!!"+
                       " received: "+cReceivedMove.cState.fTimeStamp+
                       " "+cReceivedMove.cState.cMotion.toString()+
                       " now: "+fPhysicsLastUpdateTime+
                       "\n");
                // TODO: zastanowic sie co z tym fantem zrobic!
                // na razie go zwyczajnie ignorujemy
                ProfileEnd(PROFILE_TryToApplyClientMove);

                // czyscimy stan ODE
                //?? ClearODE();
                
                return;
            }
            
            if ( cReceivedMove.cState.nId < m_cLastResimulatedState.nId )
            {
                NetLog.PlayerMover(
                       " otrzymany ruch ma starszy id niz juz symulowany"+
                       " received: "+cReceivedMove.cState.fTimeStamp+
                       " ("+cReceivedMove.cState.nId+")"+
                       " "+cReceivedMove.cState.cMotion.toString()+
                       " last:"+m_cLastResimulatedState.fTimeStamp+
                       " ("+m_cLastResimulatedState.nId+")"+
                       " "+m_cLastResimulatedState.cMotion.toString()+" "+
                       "\n");
                // TODO: zastanowic sie co z tym fantem zrobic!
                // na razie go zwyczajnie ignorujemy
                ProfileEnd(PROFILE_TryToApplyClientMove);
                return;
            }
        }
            
        ProfileBegin(PROFILE_ApplyClientMoveListAdd);
            
        //dopisujemy na liste, obsluzymy w odpowiednim momencie
        int i = m_aReceivedClientMoves.size();
        PlayerNetReceivedMove cMove = null;
        while ( i > 0 )
        {
            i--;
            cMove = ((PlayerNetReceivedMove) m_aReceivedClientMoves.elementAt(i));
             
            //sprawdzmy w ktorym miejscu wstawic do listy - porownujemy identyfikatory
            if ( cReceivedMove.cState.nId > cMove.cState.nId )
            {
                // wstawiamy w tym miejscu
                i++;
                break;
            }
        }
            
        m_aReceivedClientMoves.insertElementAt( cReceivedMove, i );
            
        ProfileEnd(PROFILE_ApplyClientMoveListAdd);
        
        ProfileEnd(PROFILE_TryToApplyClientMove);
    }
    
    int PROFILE_CheckReceivedClientMoves = 0;
    int PROFILE_TryToApplyClientMove = 0;
    
    int PROFILE_ApplyClientMoveApply = 0;
    int PROFILE_ApplyClientMoveListAdd = 0;
    
    // Ruchy clienta sa wstawiane do vectora - teraz je obslugujemy
    void CheckReceivedClientMoves()
    {
        if (m_aReceivedClientMoves.size() == 0)
            return;
        
        ProfileBegin( PROFILE_CheckReceivedClientMoves );
        
        float fPhysicsLastUpdateTime = GetPhysicsLastUpdateTime();
        
        // po kolei zastosowujmy ruchu od najstarszych do najmlodszych
        // po zastosowaniu ostatniego
        while (m_aReceivedClientMoves.size() > 0)
		{
            // pobieramy najstarszy ruch
			PlayerNetReceivedMove cMoveFrom = (PlayerNetReceivedMove)m_aReceivedClientMoves.elementAt(0);
            
            //sprawdzamy czas ruchu
            if ( cMoveFrom.cState.fTimeStamp >= fPhysicsLastUpdateTime )
            {
                // najstarszy z ruchow na liscie jest jeszcze za 'mlody' dla serwera
                ProfileEnd( PROFILE_CheckReceivedClientMoves );
                return;
            }
            
            PlayerNetReceivedMove cMoveTo = null;
            if (m_aReceivedClientMoves.size() > 1)
                cMoveTo = (PlayerNetReceivedMove)m_aReceivedClientMoves.elementAt(1);
            
            if ((cMoveTo != null) && (cMoveTo.cState.fTimeStamp > fPhysicsLastUpdateTime))
                cMoveTo = null;

            // bedziemy oblugiwac najstarszy ruch - wypiszmy go z listy oczekujacych
            m_aReceivedClientMoves.removeElement(cMoveFrom);
            
            // czy nie jest to przypadkiem za stary ruch? - jak nie to go stosujemy
            if (cMoveFrom.cState.fTimeStamp < fPhysicsLastUpdateTime - fMaxLagTime)
            {
                NetLog.PlayerMover("Ruch z kolejki ruchow klienta jest za stary!  Lag = " + 
                                   (fPhysicsLastUpdateTime - cMoveFrom.cState.fTimeStamp) + "\n");                
                ProfileEnd( PROFILE_CheckReceivedClientMoves );
                return;
            }
            
            if (m_nState != _STATE_IN_VEHICLE)
                ApplyClientMove(cMoveFrom, cMoveTo, fPhysicsLastUpdateTime);
        }
        
        ProfileEnd( PROFILE_CheckReceivedClientMoves );
    }
    
    // Wcielamy w zycie ruch przeslany od gracza
    // Symulujemy do cMoveTo (bez cMoveTo), albo do teraz (gdy cMoveTo == null)
    void ApplyClientMove(PlayerNetReceivedMove cMoveFrom, PlayerNetReceivedMove cMoveTo, float fPhysicsLastUpdate)
    {
        boolean bAdjust = (cMoveTo == null);
        float fTimeStamp = cMoveFrom.cState.fTimeStamp;
        float fEndTime = (cMoveTo != null) ? cMoveTo.cState.fTimeStamp : fPhysicsLastUpdate;
        
        PlayerNetState cLastSimulatedState = m_aSimulatedStates.GetState( cMoveFrom.cState.fTimeStamp,
                                                                              cMoveFrom.cState.nODEDoneUpdatesCount );
        if (cLastSimulatedState == null)
        {
            NetLog.PlayerMover("Stan z czasu: " + fTimeStamp + 
                               " i ramki ODE: " + cMoveFrom.cState.nODEDoneUpdatesCount + 
                               " nie znaleziony!!!------------------------------------------------\n");
            return;
        }

        // zapamietujemy sobie naszego parenta
        ControlObject cParent = GetParent();
        
        // ustawienie gracza w tryb resymulacji
        m_bNetResimulate = true;
        
        // ustawmy poprzednio symulowany stan
        MotionState cOld = null;
        if (cLastSimulatedState != null)
        {
            cLastSimulatedState.RestorePhysicsAndPosAndDir( this );
            cLastSimulatedState.RestorePortalSystemActiveFlag( this );
            
            // odtwarzamy OldMotion na podstawie Motion z poprzedniego stanu
            cOld = cLastSimulatedState.cMotion;
        }    
        else
        {
            // to jest pierwszy doslany stan, zatem zakladam, ze:
            // poprzedni stan = aktualny stan
            cOld = cMoveFrom.cState.cMotion;
        }
        cMoveFrom.cState.cOldMotion = new MotionState( cOld );
        
        Vector vLastDirection = GetAimDirection();
        float  fLastSpeedMult = fSpeedMult;
        boolean bLastRecoiling = bRecoiling;
        int nLastClimbing = motion.nClimbing;
        
//        if (cMoveFrom.cState.nODEDoneUpdatesCount != 4)
//            int qqq=0;

        // ustawienie graczowi ruchu ktory wlasnie odebralismy
        cMoveFrom.cState.ApplyMotionAndDirAndLocalSpeed( this );
        
        // koniec resymulacji, pozwalamy by zmiany weszly w zycie
        m_bNetResimulate = false;
        
        // bierzemy pod uwage nowe ruchy
        if ( motion.Changed( oldMotion ) )
        {
            if ( (motion.IsJumping() && (motion.IsClimbing() || GetMass() <= 0.0f)) /*||
                 (!motion.IsClimbing() && (nLastClimbing > motion._CLIMBING_FALSE))*/ )
                ClimbLeave();
            UpdateMotion();
            UpdateState();
        } 
        else if ( fLastSpeedMult != fSpeedMult )
        {
            UpdateSpeed();
        }
        else if ( bLastRecoiling != cMoveFrom.cState.bRecoiling )
        {
            UpdateSpeed();
        }
        
        // TODO: czy tu nie powinno byc else?
        if ( !vLastDirection.IsEqual( GetAimDirection() ) )
        {
            // jezeli zmianie ulegl tylko kierunek to wystarczy 
            // zupdateowac wektor predkosci
            UpdateSpeed();
        }
        
        // teraz mozemy przelaczyc elipsoide
        // TODO: to tak nie zostanie, to przelaczanie eilpsoidy bedzie
        // zaimplementowane w odtwarzanie stanu
        if ( m_bUpdateEllipsoidRequired )
            UpdateEllipsoidAndMaxClimbAngle();
        
        //ustawiamy parenta takiego z jakim otrzymalismy ruch
        SwitchParentTo( cMoveFrom.cState.cParent );
                
        // zapamietujemy stan jako poprzedni
        m_cLastResimulatedState = new PlayerNetState( this, fTimeStamp );
        m_cLastResimulatedState.nODEDoneUpdatesCount = cMoveFrom.cState.nODEDoneUpdatesCount;
        m_cLastResimulatedState.nId = cMoveFrom.cState.nId;
        m_cLastResimulatedState.StorePortalSystemActiveFlag( this );
            
        if (bStatesStoreAllowed)
        {
            m_aSimulatedStates.Store( m_cLastResimulatedState );
        }

        if (bAdjust && (fEndTime - m_fLastSentAdjustTime > MIN_ADJUST_POSITION_TIME))
        {
            // ADJUST klienta
            
            // liczymy odchylenie pozycji na cliencie od serwera
            float fDeviation2 = cMoveFrom.vPos.Distance2( GetLocalPosition() );
            if ( (fDeviation2 > MAX_CLIENT_MOVE_DEVIATION2) ||
                 ((fEndTime - m_fLastSentAdjustTime > MAX_NOTADJUST_POSITION_TIME) && (fDeviation2 > DEVIATION2_EPSILON)) )
            {
                if ( ! (nEnvironment == EMoveEnv.CHMOVE_AIR &&
                        sm_bCantAdjustPositionOnAir) )
                {
                    NetLog.PlayerMover( "OUT: Adjust Deviation = "+cMoveFrom.vPos.Sub2(GetLocalPosition()) + 
                                        " Time= "+fTimeStamp+ 
                                        " ODEUpdates: "+m_cLastResimulatedState.nODEDoneUpdatesCount + 
                                        "\n");
                    MsgSendClientAdjustState( m_cLastResimulatedState );
                    m_fLastSentAdjustTime = fEndTime;
                }
            }
        }

        //przywracamy naszego parenta
        SwitchParentTo( cParent );
        
        float fRemainingDeltaTime = fEndTime - fTimeStamp;
        
        if ( fRemainingDeltaTime > 0.f )
        {
            if (bResimulationAllowed)
            {
                if ((cMoveTo == null) || (cMoveTo.cState.nODEDoneUpdatesCount == 4))
                {
                    float fLastPhysicsUpdate = cMoveFrom.cState.fTimeStamp;
                    SetPhysicsLastUpdateTime(fLastPhysicsUpdate);

//@@                    // tylko do testow!!!        
//                    LogR("Resymulacja od " + fLastPhysicsUpdate + "[" + cMoveFrom.cState.nODEDoneUpdatesCount + "]    do ");
//                    if (cMoveTo != null)
//                        LogR(fEndTime + "[" + cMoveTo.cState.nODEDoneUpdatesCount + "]");
//                    else
//                        LogR(fEndTime + " ");
//                    LogR(" przez: " + fRemainingDeltaTime + "\n");
                  
                    StepUpdatePhysicsWithODE(fRemainingDeltaTime, true, m_cLastResimulatedState.nODEDoneUpdatesCount);
                }
                else
                {
                    float fLastPhysicsUpdate = cMoveFrom.cState.fTimeStamp;
                    SetPhysicsLastUpdateTime(fLastPhysicsUpdate);
                    if (cMoveTo.cState.fTimeStamp != fPhysicsLastUpdate) 
                        fRemainingDeltaTime -= sm_fPhysicsGranularity;

//@@                    // tylko do testow!!!        
//                    LogR("Resymulacja od " + fLastPhysicsUpdate + "[" + cMoveFrom.cState.nODEDoneUpdatesCount + "]    do ");
//                    if (cMoveTo != null)
//                        LogR(fEndTime + "[" + cMoveTo.cState.nODEDoneUpdatesCount + "]");
//                    else
//                        LogR(fEndTime + " ");
//                    LogR(" przez: " + fRemainingDeltaTime);
//                    LogR(" i dosymulowanie " + cMoveTo.cState.nODEDoneUpdatesCount + " update'ow ODE\n");

                    StepUpdatePhysicsWithODE(fRemainingDeltaTime, true, m_cLastResimulatedState.nODEDoneUpdatesCount);
                    float fODEStep = ODE_GetStepSize();
                    UpdatePhysicsOnlyGW(sm_fPhysicsGranularity);
                    UpdatePhysicsOnlyODE((float)cMoveTo.cState.nODEDoneUpdatesCount * fODEStep);
                }
            }
        }
    }

    Vector GetAimDirLadderClimb()
    {
        if (bNetIsOwner)
            return new Vector(vDelayedAimDir);
        else
            return GetAimDir();
    }
    
    void OnPhysicsUpdate(float fAbsoulteTime, float fSimInterval)
    {
        //EnableODEPhysics(1);
        super.OnPhysicsUpdate(fAbsoulteTime, fSimInterval);
        float fTimeStamp = GetPhysicsLastUpdateTime(); // + sm_fPhysicsGranularity;

        if ( (Role == ERole._AUTHORITY) &&
             !m_bNetResimulate && 
             !(bNetIsOwner || IsLocalAutoControl()) )
        {
            if (bStatesStoreAllowed)
                m_aSimulatedStates.StoreWithPortalSystemActiveFlag( fTimeStamp );
        }
    }
    
    
    float fMouseRefreshRate = 4;
    void OnODEPostUpdate()
    {
        super.OnODEPostUpdate();

        if ( (Role == ERole._AUTHORITY) &&
             !m_bNetResimulate && 
             !(bNetIsOwner || IsLocalAutoControl()) )
        {
            //przyszedl nowy czas, dopisujemy stan do listy
            if (bStatesStoreAllowed)
                m_aSimulatedStates.StoreWithPortalSystemActiveFlag(GetPhysicsLastUpdateTime());
        }
        
        // z czestotliwoscia 1/8 sek
        if (GetODEGWDoneUpdates() == 4)
        {
            float fTimeStamp = RoundToPhysicsGranularity(GetPhysicsLastUpdateTime());
            if (java.lang.Math.ceil(fTimeStamp * fMouseRefreshRate) == (fTimeStamp * fMouseRefreshRate))
            {
                if (bNetIsOwner)
                {
                    DelayedRotate();
                    CheckSendServerMoveOnUpdate();
                }
                
                HomoErectus();

            }

        }

    }
    
    void StepUpdatePhysics(float fDelta, float fGranularity)
    {
        StepUpdatePhysics(fDelta, fGranularity, true, 4);
    }

    void StepUpdatePhysics(float fDelta)
    {
        StepUpdatePhysics( fDelta, sm_fPhysicsGranularity, true, 4);
    }
    
    void StepUpdatePhysics(float fDelta, boolean bCheckClimbing)
    {
        StepUpdatePhysics(fDelta, sm_fPhysicsGranularity, bCheckClimbing, 4);
    }
    
    void StepUpdatePhysicsWithODE(float fDelta, int nODEDoneUpdatesCount)
    {
        StepUpdatePhysics( fDelta, sm_fPhysicsGranularity, true, nODEDoneUpdatesCount);
    }

    void StepUpdatePhysicsWithODE(float fDelta, boolean bCheckClimbing, int nODEDoneUpdatesCount)
    {
        StepUpdatePhysics(fDelta, sm_fPhysicsGranularity, bCheckClimbing, nODEDoneUpdatesCount);
    }
    
    void StepUpdatePhysics(float fDelta, float fGranularity, boolean bCheckClimbing, int nODEDoneUpdatesCount)
    {
        // najpierw zalegle updaty ODE
        float fODEStep = ODE_GetStepSize();
        int nODEUpdatesPerPhysicsUpdates = (int) (fGranularity / fODEStep);
        int nODEUpdatesToDo = nODEUpdatesPerPhysicsUpdates - nODEDoneUpdatesCount;
        if (nODEUpdatesToDo > 0)
        {
            SetODEGWDoneUpdates(nODEDoneUpdatesCount);
            UpdatePhysicsOnlyODE((float)nODEUpdatesToDo * fODEStep);
            // fDelta -= fGranularity;     
        }
        
        while ( fDelta >= fGranularity )
        {
            float fD = fDelta;
                
            if (fD > fGranularity)
                fD = fGranularity;
            
            if ( bDebug )
                LogD(" "+fDelta+" "+fD+"\n");
                
            if ( bCheckClimbing )
            {
                if (motion.IsClimbing() && (GetMass() == 0))
                    CheckClimbLeave();
                else
	                CheckClimbEnter();    
            }
            
            UpdatePhysics( fD );
            fDelta -= fD;
        }
                
        if ( fDelta > 0.0f )
            Log(" ERROR: fDelta "+fDelta+" not updated!\n");
    }
    
    /**SERVER Wyslanie do clienta informacji o korekcji pozycji
     */
    void MsgSendClientAdjustState(PlayerNetState cState)
    {
        //MessageNew( MSG_CLIENT_ADJUST_STATE );
        MessageNewUnreliable( MSG_CLIENT_ADJUST_STATE );
        cState.MessagePackAdjustState( this, this );
        MessageSend( EMsgSendMode.OWNER );
    }
    
    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////
    // Obsluga gracza na kliencie wlascicielu  // GNKW
    ////////////////////////////////////////////////////////////////////////// 
    ///////////////////////////////////////////////////////////////////////////
        
    
    /**CLIENT lista stanow clienta
     */
    PlayerNetStateList m_cSentStatesList = null;
    
    /**CLIENT Czesc informacji z ostatnio (poprzednio) wykonanego ruchu, 
     * konieczne do stwierdzania czy doslac serverowi nowy ruch
     */
    PlayerNetLastSentState   m_cLastSentState     = new PlayerNetLastSentState();
    //licznik wyslanych ruchow
    int             m_nCntSentServerMove = 0;
    
    /**CLIENT czas, po ktorym client wysle informacje o wykonywanym ruchu
     * bez wzgledu na to czy nastapily w nim jakies zmiany - wyslanie wymuszone
     */
    static float _MAX_RESEND_MOVE_TIME = 1.2f;

    private static Vector sm_vLocalSpeed    = new Vector();
    private static Vector sm_vWalkDestSpeed = new Vector();

    protected final static int _BITPOS_LOCAL_SPEED_X = 0;
    protected final static int _BITPOS_LOCAL_SPEED_Y = 1;
    protected final static int _BITPOS_LOCAL_SPEED_Z = 2;
    protected final static int _BITPOS_DEST_SPEED_X  = 3;
    protected final static int _BITPOS_DEST_SPEED_Y  = 4;
    protected final static int _BITPOS_DEST_SPEED_Z  = 5;
    protected final static int _BITPOS_PARENT        = 6;
    
    public final static boolean IsBitSet(int nValue, int nBitPos)
    {
        return (nValue & (1 << nBitPos)) != 0;
    }
    
    boolean bIgnoreMove = false;
    
    int nSentServerMoveOnDebug = 0;
    /**CLIENT Wyslanie do serwera informacji o ruchu klienta
     */
    void MsgSendServerMove()
    {
        if ( bIgnoreMove )
            return;
        
        if ( bDebug )
        {
            nSentServerMoveOnDebug++;
        }
       
        //TODO: upakowac te dane!
        //MessageNew( MSG_SERVER_MOVE );
        MessageNewUnreliable( MSG_SERVER_MOVE );
/*        
        MessagePackInt( m_nCntSentServerMove++ );
        MessagePackFloat( GetPhysicsLastUpdateTime() ); //TODO: pack na byte
        MessagePackByte( (byte)GetODEGWDoneUpdates() ); //TODO: pack na 3bity
        MessagePackByte( motion.iMoveX );//-1,0,1 -> 2 bity
        MessagePackByte( motion.iMoveZ );//-1,0,1 -> 2 bity
        MessagePackByte( motion.iSpeed );//0..5   -> 3 bity
//        MessagePackByte( motion.iTurn );//chyba nie uzywane
        MessagePackByte( motion.nJumping );//0,1,2 -> 2 bity
        MessagePackByte( nHitReaction );//TODO: pack 1bit
        MessagePackFloat( fSpeedMult );
        MessagePackVector( vSpeed );
//        MessagePackVector( GetSpeed() );
        MessagePackVector( GetLocalSpeed() );//TODO: pack...
        MessagePackVector( GetWalkDestSpeed() );//TODO: pack...
        MessagePackVector( GetAimDirection() );//TODO: pack...
        MessagePackVector( GetLocalPosition() );
        MessagePackInt( (GetParent() != null) ? GetParent().GetNetId() : -1  );//TODO: pack
        
        byte nFlags = 0;
        nFlags = PackBooleanToByte( nFlags, 0, motion.bAiming );
        nFlags = PackBooleanToByte( nFlags, 1, AmIAiming() );
        nFlags = PackBooleanToByte( nFlags, 2, bWalking );
        nFlags = PackBooleanToByte( nFlags, 3, bDucking );
        nFlags = PackBooleanToByte( nFlags, 4, bCrawling );
        nFlags = PackBooleanToByte( nFlags, 5, bRecoiling );
        
        MessagePackByte( nFlags );
*/

        MessagePackInt( m_nCntSentServerMove++ );
        MessagePackFloat( GetPhysicsLastUpdateTime() ); //TODO: pack na byte
        MessagePackByte( (byte)GetODEGWDoneUpdates() ); //TODO: pack na 3bity
        MessagePackByte( motion.iMoveX );//-1,0,1 -> 2 bity
        MessagePackByte( motion.iMoveZ );//-1,0,1 -> 2 bity
        MessagePackByte( motion.iSpeed );//0..5   -> 3 bity
        MessagePackByte( motion.nJumping );//0,1,2 -> 2 bity
        MessagePackByte( nHitReaction );//TODO: pack 1bit
//        MessagePackByte( (byte)GetMass() );

        MessagePackFloat( fSpeedMult );

/*DEL        LogR("Pack: vSpeed = " + vSpeed + ", local = " + GetLocalSpeed() + 
             ", dest = " + GetWalkDestSpeed() + ", aim = " + GetAimDirection() + 
             ", pos = " + GetLocalPosition() + "\n");
*/        
/*DEL
        if (vSpeed.Distance(GetWalkDestSpeed()) > 0.001f)
            LogR("Pack: vSpeed = " + vSpeed + 
                 ", dest = " + GetWalkDestSpeed() + 
                 ", local = " + GetLocalSpeed() + 
                 ", aim = " + GetAimDirection() + 
                 ", pos = " + GetLocalPosition() + "\n");
*/      
        GetLocalSpeed(sm_vLocalSpeed);
        GetWalkDestSpeed(sm_vWalkDestSpeed);
        byte nFlags = 0;
        nFlags = PackBooleanToByte(nFlags, _BITPOS_LOCAL_SPEED_X, sm_vLocalSpeed.fX != 0.f);
        nFlags = PackBooleanToByte(nFlags, _BITPOS_LOCAL_SPEED_Y, sm_vLocalSpeed.fY != 0.f);
        nFlags = PackBooleanToByte(nFlags, _BITPOS_LOCAL_SPEED_Z, sm_vLocalSpeed.fZ != 0.f);
        nFlags = PackBooleanToByte(nFlags, _BITPOS_DEST_SPEED_X, sm_vWalkDestSpeed.fX != 0.f);
        nFlags = PackBooleanToByte(nFlags, _BITPOS_DEST_SPEED_Y, sm_vWalkDestSpeed.fY != 0.f);
        nFlags = PackBooleanToByte(nFlags, _BITPOS_DEST_SPEED_Z, sm_vWalkDestSpeed.fZ != 0.f);
        nFlags = PackBooleanToByte(nFlags, _BITPOS_PARENT, GetParent() != null);

        MessagePackByte(nFlags);
        if (IsBitSet(nFlags, _BITPOS_LOCAL_SPEED_X))
            MessagePackFloat(sm_vLocalSpeed.fX);
        if (IsBitSet(nFlags, _BITPOS_LOCAL_SPEED_Y))
            MessagePackFloat(sm_vLocalSpeed.fY);
        if (IsBitSet(nFlags, _BITPOS_LOCAL_SPEED_Z))
            MessagePackFloat(sm_vLocalSpeed.fZ);

        if (IsBitSet(nFlags, _BITPOS_DEST_SPEED_X))
            MessagePackFloat(sm_vWalkDestSpeed.fX);
        if (IsBitSet(nFlags, _BITPOS_DEST_SPEED_Y))
            MessagePackFloat(sm_vWalkDestSpeed.fY);
        if (IsBitSet(nFlags, _BITPOS_DEST_SPEED_Z))
            MessagePackFloat(sm_vWalkDestSpeed.fZ);

        if (IsBitSet(nFlags, _BITPOS_PARENT))
            MessagePackInt(GetParent().GetNetId());

        MessagePackVector( GetAimDirection() );//TODO: pack...
        MessagePackVector( GetLocalPosition() );
        
        nFlags = 0;
        nFlags = PackBooleanToByte( nFlags, 0, motion.bAiming );
        nFlags = PackBooleanToByte( nFlags, 1, AmIAiming() );
        nFlags = PackBooleanToByte( nFlags, 2, bWalking );
        nFlags = PackBooleanToByte( nFlags, 3, bDucking );
        nFlags = PackBooleanToByte( nFlags, 4, bCrawling );
        nFlags = PackBooleanToByte( nFlags, 5, bRecoiling );
        
        MessagePackByte( nFlags );
        
        MessageSend();
//@@        
//        LogR("Client wyslal ruch - Time: " + GetPhysicsLastUpdateTime() + " ODEUpdates: " + GetODEGWDoneUpdates() + 
//             " Speed: " + GetSpeed() + " WalkDestSpeed: " + GetWalkDestSpeed() + "\n");
        
        StoreCurrentState();
    }
    
    /**CLIENT zapamietuje i odklada na stos ostatni ruch gracza
     */
    void StoreCurrentState()
    {
        float fTime = GetPhysicsLastUpdateTime();
        // zapamietajmy to jako ostatni swoj ruch
        m_cLastSentState    = new PlayerNetLastSentState( this, fTime );
        
        if (m_cSentStatesList == null)
            return;
        
        m_cSentStatesList.Store( fTime );
    }

    /**
     * CLIENT OWNER
     * Tu bedzie zapamietany ostatnio obsluzony adjust
     * Bedziemy mogli porownywac czas tego adjusta z
     * adjustami przychodzacymy z sieci, zeby obslugiwac tylko 
     * ten ostatni
     */
    PlayerNetAdjustState m_cLastRecvAdjustState = null;

    
    /**CLIENT Sygnal korekcji pozycji po ruchu otrzymywany od servera
     */
    void MsgRecvClientAdjustState()
    {
        PlayerNetAdjustState cAdjustState = new PlayerNetAdjustState();
        cAdjustState.MessageUnPackAdjustState( this );
        MessageEnd();
        
        //jak to przyjdzie czasem na serwerze to robimy wypad
        if (Role == ERole._AUTHORITY) 
            return;
                
        //jesli akurat jestesmy w locie a w tym stanie nie przyjmujemy adjustow
        //to tez robimy wypad
        if ( nEnvironment == EMoveEnv.CHMOVE_AIR && sm_bCantAdjustPositionOnAir )
            return;
        
        //no i obslugujemy tylko najnowszego adjusta, jesli 
        //przyjdzie jakis starszy to ... tez robimy wypad.
        if ( cAdjustState.CompareTime( m_cLastRecvAdjustState ) <= 0 )
        {
            //LogR("Received old adjust\n");
            return;
        }

        if ( m_cLastSentState.fTime > cAdjustState.fTimeStamp + sm_fStateToAdjustMaxDelay )
        {
            //LogR("Adjust too late! m_cLastSentState.fTime="+m_cLastSentState.fTime+" cAdjustState.fTimeStamp="+cAdjustState.fTimeStamp+"\n");
            return;
        }
        
        //jesli wszystko jest ok, to zapamietujemy sobie ten stan jako
        //ostatnio odebrany
        m_cLastRecvAdjustState = cAdjustState;
            
        //i przystepujemy do resymulacji
        try
        {
            if ( m_cSentStatesList != null )
            {
                //LogD(" "+this+" "+bNetIsOwner+"\n");
                // przesymulowujemy z adjustem pozycji
                m_cSentStatesList.ResimulateOnAdjust( cAdjustState, GetPhysicsLastUpdateTime() );
            }
        }
        catch(Throwable e)
        {
            CrashLog( "Wypadl wyjatek w ResimulateOnAdjust: "+ e.getClass().getName() +"\n" );
        }
    }
    
    /////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////
    // Obsluga gracza na kliencie nie wlascicielu  // GNKNW
    //////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////
    
    /** CLIENT NOT OWNER 
	 *  Poskladanie motion state'a na podstawie aktualnej predkosci i kierunku
	 */
	static float sm_fMinValueSpeedAxis = 0.3f;
    
    
    Vector m_vLastPosForSpeedCalc    = new Vector();
    Vector m_vLastSpeedForAccelCalc  = new Vector();
    float m_fLastPosForSpeedCalcTime = -1;
    Vector m_vSpeedFromPos           = new Vector();
    Vector m_vAccelFromSpeed         = new Vector();
    static Vector sm_CSFPC_vPos      = new Vector();

    public Vector CalcSpeedFromPosChange(Vector vPos, float fTime)
    {
        float fDeltaTime = fTime - m_fLastPosForSpeedCalcTime;
        sm_CSFPC_vPos.Set(vPos);
        if (m_fLastPosForSpeedCalcTime < 0) // jesli < 0 - niezainicjowana - poczatek
        {
            m_vSpeedFromPos.Set(0,0,0); 
            m_vAccelFromSpeed.Set(0,0,0);
        }
        else if (fDeltaTime > 0.001f) // jesli uplynal za maly czas - zignoruj zmiane predkosci
        {
            float fOODeltaTime = 1.f / fDeltaTime;
            m_vSpeedFromPos.Set(sm_CSFPC_vPos);
            m_vSpeedFromPos.Sub(m_vLastPosForSpeedCalc);
            m_vSpeedFromPos.Mul(fOODeltaTime);
            
            m_vAccelFromSpeed.Set(m_vSpeedFromPos);
            m_vAccelFromSpeed.Sub(m_vLastSpeedForAccelCalc);
            m_vAccelFromSpeed.Mul(fOODeltaTime);
            
//            LogR(GetName() + ": fDist = " + sm_CSFPC_vPos.Distance(m_vLastPosForSpeedCalc) + " fDeltaTime = " + fDeltaTime + 
//                 " speed = " + m_vSpeedFromPos + "\n");
        }
        m_vLastPosForSpeedCalc.Set(sm_CSFPC_vPos);
        m_vLastSpeedForAccelCalc.Set(m_vSpeedFromPos);
        m_fLastPosForSpeedCalcTime = fTime;

        return m_vSpeedFromPos;
    }
    
    
	public void MotionStateFromPhysics()
	{
        Vector vS;
        float fSpeedVal;
        
        if (bIsDestSpeedReplicated)
        {
            vS = GetWalkDestSpeed();
            fSpeedVal = vS.Len2(); // tu moze byc kwadrat - potrzebna wartosc orientacyjna
        }
        else
        {
            vS = VectorWorldToLocal(m_vSpeedFromPos);
            if (vS == null)
            {
                CrashLog("Error: Just another impossible situation: player " + GetName() + " was removed from engine before MotionStateFromPhysics call!!!\n");
                return;
            }
            vS.fY = 0;
            fSpeedVal = (float)Math.sqrt(vS.fX * vS.fX + vS.fZ * vS.fZ);
            if (fSpeedVal > 0.1f)
                vS.Mul(1.f / fSpeedVal);
        }
        
        //zwykle predkosc docelowa bedziemy traktowali jaka aktualna
        //jednak podczas lotu, predkosc jako tako sie nie zmienia
        //zatem do odtworzenie motion statea bedziemy uzywali "tej poprzedniej"
        if ( !AmIFlying() || CanTurnOnFlying() )
            vSpeed = vS;
        else
        {
            vS = vSpeed;
        }

        
        if ( fSpeedVal > 10f ) //testowo
		{
            
            //prawo/lewo
            if ( vS.fX > sm_fMinValueSpeedAxis )
				motion.iMoveX = 1;
		    else if ( vS.fX < -sm_fMinValueSpeedAxis )
				motion.iMoveX = -1;
			else
				motion.iMoveX = 0;

            //przed/tyl
			if ( vS.fZ > sm_fMinValueSpeedAxis )
				motion.iMoveZ = 1;
			else if ( vS.fZ < -sm_fMinValueSpeedAxis )
				motion.iMoveZ = -1;
			else
            {
			    motion.iMoveZ = 0;
                
                // drabina
                if ( vS.fY > sm_fMinValueSpeedAxis )
			    	motion.iMoveZ = 1;
			    else if ( vS.fY < -sm_fMinValueSpeedAxis )
			    	motion.iMoveZ = -1;
            }
		}
        else
        {
			// TODO: moveY tez, co bedzie z drabina w sieci to ja nie wiem
			motion.iMoveX = 
            motion.iMoveZ = 
            motion.iMoveY = 0;
		}
				
        motion.bAiming = bAiming;
        if ( bLastCrawling && !bCrawling )
        {
            boolean bStop = false;
            bStop = true;
        }
        if ( ! motion.IsEqual( oldMotion ) )
        {
            //LogD(" "+GetTime()+"\n");
            UpdateMotion();
        }
        else
		if ( bLastCrawling    != bCrawling     || 
             bLastDucking     != bDucking      || 
             bLastWalking     != bWalking      ||
             bLastRecoiling   != bRecoiling    ||
             nLastHitReaction != nHitReaction  ||
             fLastSpeedMult   != fSpeedMult )
		{
            bLastCrawling    = bCrawling;
            bLastDucking     = bDucking;
            bLastWalking     = bWalking;
            bLastRecoiling   = bRecoiling;
            nLastHitReaction = nHitReaction;
            fLastSpeedMult   = fSpeedMult;
            
			UpdateMotion();
		}
        
        if ( fLastAimAngleY != fAimAngleY )
        {
            SetAimDirection( GetAimDirection() );
        }
	}

    /**
     * Z jakis przyczyn w niektorych sytuacjach
     * gracz sieciowy nie obraca sie tak jak powinien.
     * Jest to najprawdopodobnie jakis blad w metodzie 
     * Player.BodyDeformAimAtH()
     * 
     */
    boolean BodyDeformAimAtH()
    {
        boolean bRequiredCorrecton = super.BodyDeformAimAtH();
        //jesli potrzebna korekta, to wolamy to jeszcze raz
        if ( bRequiredCorrecton )
        {
            //oczywiscie ustawmy sobie flage zeby to sie odbylo
            bBodyDeformAimAtH = true;
            //i wolamy funkcje
            super.BodyDeformAimAtH();
        }
        
        //tu juz zwracana wartosc wcale nie jest nam potrzebna
        return true;
    }

    boolean bLastCrawling    = false;
    boolean bLastDucking     = false;
    boolean bLastWalking     = false;
    boolean bLastRecoiling   = false;
    byte    nLastHitReaction = 0;
    float   fLastSpeedMult   = 1.0f;
    
    
    float fLastAimAngleY = fAimAngleY;
    
    void SetAimDirection(Vector v)
    {
        super.SetAimDirection(v);
        fLastAimAngleY = v.fY;
        
        //LogD(" fLastAimAngleY "+fLastAimAngleY+"\n");
    }

    ///////////////////////////////////////////////////////////////////////////
    // KONIEC: Obsluga gracza na kliencie nie wlascicielu  // KOGNKNW
    //////////////////////////////////////////////////////////////////////////
        
    
    void ForceJump()
    {
        if ( CanProcessJumpKey() )
        {
            motion.nJumping = MotionState._JUMPING_TRUE;
            UpdateMotion();
        }
    }
    
    
    public void CleanPlayerMotion()
    {
        // CLIENT, WLASCICIEL lub SERVER
        if ( (bNetIsOwner && (Role < ERole._AUTHORITY)) || (Role == ERole._AUTHORITY) )
        {
            // zerujemu co sie da
            m_cLastSentState      = new PlayerNetLastSentState();
            m_nCntSentServerMove  = 0;
            
            m_aReceivedClientMoves.removeAllElements(); 
        
            m_cLastResimulatedState      = null;
            if ( m_aSimulatedStates != null )
                 m_aSimulatedStates.Clean(); // -1.0f );
//            m_fLastSimulatedStatesTime = -1;
            
            m_fLastSentAdjustTime  = 0.0f;
            m_cLastRecvAdjustState = null;
                         
            if (m_cSentStatesList != null)
                m_cSentStatesList.Clean(); // GetTime() );
        }   
        
        oldMotion.Reset();
        motion.Reset();
        m_cMotionMoveToApply = null;
        nFiring      = 
        nFiringState = Weapon._NO_FIRING;
        bWalking = false;
        bDucking = false;
        bCrawling = false;
        bRecoiling = false;
        nHitReaction = 0;
        DisableCallMethod("StopSlowDownOnRecoil");
        bAiming = false;
        m_bIsThrowingGrenade = false;
        fSpeedMult = 1.0f;
        m_bNextJumpEnabled = true;
        BodyDeformAimAtHReset();
        BodyDeformAimAtVReset();
    }
    
    
    
    
    // pozycja lokalna na jakiej ostatnio sie gracz renderowal
    Vector m_vRenderLocalPos = new Vector();
    
    // metoda zapisuje do podanego wektora pozycje gracza do 
    //renderowania w ukladzie lokalnym!!!!
    public void GetLocalRenderingPosition(Vector vTarget)
    {
        if ( vTarget != null ) 
            vTarget.Set( m_vRenderLocalPos );
    }

    //TODO: przeniesc to klas bazowych
    float m_fMinRelevantToCorrectPosOnRender = 0f; //TEST
    boolean m_bAdditionalSimulateOnRenderPuppet = true;
    boolean m_bAdditionalSimulateOnRenderOwner = true;
    
    void OnRender()
    {
        if ( ! m_bCorrectPosOnRender || fNetRelevantLevel < m_fMinRelevantToCorrectPosOnRender )
            return;
        
        /**
         * Bedziemy wyliczali specjalnie na potrzeby
         * renderingu pozycje i kierunek gracza
         */
        
        /**najpierw biezemy sie za pozycje */
                
        //pobieramy faktyczna pozycje
        GetPosition( m_vActuallyPosition );
        //zapamietujemy ja
        sm_vPos.Set( m_vActuallyPosition );
        //i przekazujemy do zmodyfikowania na potrzeby renderu
        //dosymulowujemy fizyke

        if ((m_bAdditionalSimulateOnRenderOwner && bNetIsOwner) ||
            (m_bAdditionalSimulateOnRenderPuppet && !bNetIsOwner))
            AdditionalSimulateOnRender( sm_vPos );

        //interpolujemy z poprzednia pozycje (jesli trzeba)
        if ( m_bInterpolateRenderPos )
            InterpolateRenderPos( sm_vPos );
        //teraz sobie zapamietujemy wyliczona pozycje do renderu
        m_vRenderPosition.Set( sm_vPos );
        // i ustawiamy goscia w ta pozycje
        SetPositionWorld( m_vRenderPosition );
        // zapamietujemy sobie dodatkowo jaka to jest pozycja w ukladzie lokalnym
        GetLocalPosition( m_vRenderLocalPos );
        // i zapamietujemy fakt ze gracz jest przestawiony na potrzeby renderingu
        m_bOnRenderPosition = true;
        
        /**teraz czas na kierunek */
        
        // swojego nie ruszamy
        if ( m_bInterpolateRenderDir && !bNetIsOwner )
        {
            //pobieramy faktyczny kierunek
            GetForwardVector( m_vActuallyDir );
            //i przekazujemy do wylicznie kierunku na potrzeby renderu
            InterpolateRenderDir( m_vRenderDir, m_vActuallyDir, sm_vDir );
            //teraz sobie zapamietujemy wyliczony dir do renderu
            m_vRenderDir.Set( sm_vDir );
            // i ustawiamy goscia w ten kierunek
            SetDir( m_vRenderDir );
            // i zapamietujemy fakt ze gracz jest obrocony na potrzeby renderingu
            m_bOnRenderDir = true;
        }
        
        //zapamietujemy czas renderingu
        SetRenderTime( GetTime() );
        
        
        PlaceGun();
    }
    
    
    
    /**
     * 2 metody do pobranie pozycji w ktorej 
     * gosciu jest renderowany
     */
    Vector GetRenderPosition()
    {
        GetRenderPosition( sm_vPos );
        return new Vector( sm_vPos );
    }
    
    void GetRenderPosition(Vector vPos)
    {
        //jezeli ktos sie akurat pyta o pozycje
        //podczas renderowania
        if ( m_bOnRenderPosition )
        {
            //to mamy ja "za darmo"
            vPos.Set( m_vRenderPosition );
        }
        else
        {
            //jesli nie, to trzeba ja przeliczyc
            GetPosition( vPos );
            AdditionalSimulateOnRender( vPos );
            InterpolateRenderPos( vPos );
        }
    }
    
    boolean bUseAccelInAdditionalSimulate = true;
    boolean bIsDestSpeedReplicated = true;
    /**
     * Metoda wyliczajaca pozycje do renderowania 
     * a konkretnie dosymulowuje fizyke
     */   
    void AdditionalSimulateOnRender(Vector vPos)
    {
        //jaka jest roznica czasu pomiedzy czasem aktualnym
        //a czasem symulacji fizyki?
        float fDeltaTime = GetTime() - GetPhysicsLastUpdateTime();
        //jesli sa jakies rozbieznosci, to zrobimy korekte pozycji
        if ( fDeltaTime != 0.0f && Math.abs( fDeltaTime ) < 1.0f )
        {
            //jaka bedzie predkosc przy najblizszej ramce symulacji
            //TODO: jesli fDeltaTime < 0.0f to nie uzyskamy faktycznej predkosci
            
            //jesli to bedzie problem to dopasowac GetSpeedNextFrame do fDeltaTime
            if (bNetIsOwner || Role == ERole._AUTHORITY || bIsDestSpeedReplicated)
                GetSpeedNextFrame( sm_vSpeed );
            else
            {
                if (bUseAccelInAdditionalSimulate)
                {
//                    LogR("speed = " + m_vSpeedFromPos + ", accel = " + m_vAccelFromSpeed + "\n");
                    sm_vSpeed.Set(m_vAccelFromSpeed);
                    sm_vSpeed.Mul(fDeltaTime);
                    sm_vSpeed.Add(m_vSpeedFromPos);
                }
                else
                    sm_vSpeed.Set(m_vSpeedFromPos);
            }
            
            //policzmy o jaki wektor gracz poruszy sie w tym czasie
            sm_vSpeed.Mul( fDeltaTime );
            
            //sprawdzamy czy da sie przesunac o wyliczony wektor
            if (GetPhysicsType() != EPhysics._ODE_GRAVITYWALK)
                MoveByEllipsoidPure( sm_vSpeed );

            //i o tyle ile sie dalo modyfikujemy pozycje
            vPos.Add( sm_vSpeed );
        }
    } 
    
    /**
     * Predkosc z jaka bedziemy interpolowac gracza
     */
    float GetInterpolateSpeed()
    {
        if (bNetIsOwner || Role == ERole._AUTHORITY || bIsDestSpeedReplicated)
        {
            Vector vS           = GetSpeedVectorVolatile();
            Vector vFallSpeed   = GetFallSpeed();
            if (vFallSpeed != null)
            {
                if (GetPhysicsType() != EPhysics._ODE_GRAVITYWALK)
                    vS.Add( vFallSpeed );
                else
                    vS.fY += vFallSpeed.fY;
            }
            
            return vS.Len();
        }
        else
            return m_vSpeedFromPos.Len();
    }    
    
    public void ActivateOnModule()
    {
        //zeby nie bylo interpolacji pozycji przy renderowaniu
        ResetInterpolatePosAndDir();
        super.ActivateOnModule();
    }
    
    float m_fRotateH = 0.0f;
    float m_fRotateV = 0.0f;
    Vector vDelayedAimDir = new Vector(Vector.Forward);
    
    void RotateH(float fTurn)
    {
        //jak jestesmy nie zywi, to kamera ma sie nie ruszac...
        if ( bDead )
            return;
        m_fRotateH += fTurn;
        //RotateHDo( fTurn );
    }
    void RotateV(float fTurn)
    {
        //jak jestesmy nie zywi, to kamera ma sie nie ruszac...
        if ( bDead )
            return;
        m_fRotateV += fTurn;
        RotateVCameraOnly( fTurn );
        //RotateVDo( fTurn );
    }

    /**
     * Pokryta metoda z playera, jest dlatego pusta, 
     * zeby co ramke nie bylo prob wywalania HomoErectusa.
     * W sieci HomoErectus jest wolany na scisle okreslonym
     * ziarnie (wraz z DelayedRotate() lub samo)
     */
    void CheckHomoErectus()
    {
    }
        
    /**
     * Metoda ustawia flagi aby na ramce odbylo sie 
     * body deform (zarowno BodyDeformAimAtH jak i BodyDeformAimAtV )
     */
    void CleanBodyDeform()
    {
        bBodyDeformAimAtH = true;
        bBodyDeformAimAtV = true;
        
    }
    
    
    /**
     * Wolane co jakis czas uaktualnienie kierunku 
     * chodzenia gracza
     */
    void DelayedRotate()
    {
        if ( m_fRotateH != 0.0f )
            RotateHDo( m_fRotateH );
        if ( m_fRotateV != 0.0f )
            RotateVDo( m_fRotateV );
       vDelayedAimDir.Set(GetAimDir());
//@@        LogR("halleluja!!!\n");
        
        m_fRotateH = 0.0f;
        m_fRotateV = 0.0f;
    }
    
    
    Vector sm_vForwardVector = new Vector();
    
    void GetCameraForwardVector(Vector vForward)
    {
        super.GetCameraForwardVector( vForward );
        
        //zapamietujemy kierunek oryginalny
        sm_vForwardVector.Set( vForward );
        
        //dokonujemy obrotu                
        RotateHDo( m_fRotateH, false );
        //w osi V nie potrzeba bo tam sie kamera dobrze ustawia
        //zwracamy wyliczony kierunek
        GetForwardVector( vForward );
        
        //przywracamy oryginalny kierunek
        SetDir( sm_vForwardVector );
    }
    
    Vector GetCameraForwardVector()
    {
        //TODO zrobic analogicznie do powyzszej
        return super.GetCameraForwardVector();
        
    }
    
    /**
     * Stan portali dla gracza, zapamietany jest 
     * - na serwerze notownerze przy kazdym wykonanym kroku gracza
     * - na kliencie wlascicielu po odebraniu adjusta i podczas
     *  resymulacji, po zakonczeniu resymulacji na podstawie
     *  tej flagi ustawiana jest aktywnosc systemu portali w levelu
     */
    private boolean m_bPortalSystemActiveFlag = false;
    
    /**
     * Reczne ustawienie flagi, np po spawnie gracza.
     * oraz po zawolaniu restore z PlayerNetState
     */
    void SetPortalSystemActiveFlag(boolean bActive)
    {
        m_bPortalSystemActiveFlag = bActive;
    }
     
    /**
     * Obliczenie flagi na podstawie pozycji gracza,
     * zapamietania ewentualnych zmian oraz zwrocenie aktualnej 
     * wartosci (do zapamietania w liscie stanow)
     * Wolane podczas "odkladania" stanow gracza na serwerze
     * oraz posczas resymulacji (adjust) na kliencie
     */
    boolean GetPortalSystemActiveFlag()
    {
        //pobieram pozycje gracza
        Vector vPos = GetPositionVectorVolatile();
        //podnosze troszke zeby lapal sie w extentach budynkow
        vPos.fY    += 100.0f;
        //sprawdzam stan
        int nState = GetModuleNet().CheckPortalSystemActive( vPos );
        if ( nState >= 0 )
        {
            if ( NetLog.IsEnabled( NetLog._TYPE_PLAYER_MOVER ) )
            {
                if ( m_bPortalSystemActiveFlag != (nState == 1))
                {
                    NetLog.PlayerMover("PortalSystemChangeFlag "+(nState == 1),this);
                }
            }
            //cos wykryto, zapamietajmy to
            m_bPortalSystemActiveFlag = (nState == 1);
        }
        //zwracamy aktualny stan
        return m_bPortalSystemActiveFlag;
    }
    
    
    /**
     * Zastosowanie systemu portali zgodnie z tym co 
     * wskazuje flaga m_bPortalSystemActiveFlag
     */
    public void ApplyPortalSystemActiveFlag()
    {
        NetLog.PlayerMover("ApplyPortalSystemActive "+m_bPortalSystemActiveFlag,this);
        GetModuleNet().SetPortalSystemActive( m_bPortalSystemActiveFlag );
    }

        

    
    
    void CleanPlayer()
    {
        super.CleanPlayer();
    }
    
    /** Nadpisane z playera, zeby podczas aktywnej konsoli
     *  nie bylo obslugi klawiszy gracza
     */
    void CheckMotionKeys()
    {
        if ( GetGameInfo()             != null &&
             GetGameInfo().GetHUDNet() != null &&
             GetGameInfo().GetHUDNet().IsActive( HUDNetManager._OUTGOING_MESSAGE ) )
        {
            //konsola aktywne, zapominamy o obsludze klawiszy
            return;
        }
        
        super.CheckMotionKeys();
    }
}
