/* Gracz sieciowy
 * SERVER przed komentarzem oznacza, ze dalsza czesc kodu dotyczy tylko servera
 * CLIENT przed komentarzem oznacza, ze dalsza czesc kodu dotyczy tylko klienta
 * brak jednego z powyzych oznacza, ze dalsza czesc kodu dotyczy i clienta i servera
 * Pod pojeciem dalsza czesc kodu rozumiane jest: definicja metody, atrybutu, wywolanie metody itp.
 */
public class PlayerNet extends PlayerNetBaseDriver
{
    PlayerNet thisPlayerNet = this;
    
    
    PlayerNet()
    {
        super();
        
        m_bAllowCircularSetLastOtherState = false;
        bIsActiveTarget = true;
        
        sm_bImmortal = false;
    }
    
    int METHOD_ServerRespawn = 0;
    
    
    String PROFILE_TAB = "net_sim";
    
    int PROFILE_OnMessage = 0;
    int PROFILE_OnMessageMove = 0;
    int PROFILE_OnMessageOther = 0;

    
    
    public void OnCreate()
    {
        METHOD_ServerRespawn  = RegisterCallMethod( "ServerRespawn" );
        
        super.OnCreate();

        PROFILE_OnMessage = ProfileAdd(PROFILE_TAB, "OnMessage");
        PROFILE_OnMessageMove = ProfileAdd(PROFILE_TAB, "OnMsgMove");
        PROFILE_OnMessageOther = ProfileAdd(PROFILE_TAB, "OnMsgOther");

        
        LogD(" "+(bNetIsOwner?"OWNER":"NOTOWNER")+
             " Role= "+(Role==ERole._AUTHORITY?"SERVER":"CLIENT") +"("+Role+")\n");
    
        // po stworzeniu tr zeba nadac jakas pierwotna pozycje, (default spawnpoint)
        NetSpawnPoint cJoinPoint = GetModuleNet().GetJoinPoint();
		if (cJoinPoint != null)
		{
            SetPosition( cJoinPoint.GetPosition() );
            SetAimDirection( cJoinPoint.GetForwardVector() );
            bSpawnPointInside = cJoinPoint.IsInside();
		}
        else
            CrashLog("joinPoint: not found\n");
        
        if ( bNetIsOwner )
        {                
            // podpinamy klawisze
            RegisterKeyRequest();
		    RegisterMouseAxisRequest();
            RegisterMouseButtonRequest();
            
            //kamera gracza (na poczatku TPP, po respawnie bedziemy mieli FPP)
            Camera = (CameraPlayer)CreateObject("CameraPlayer");
            Camera.Target = this;
            Camera.SetMode( CameraPlayer.CMODE_TPP );
            
            GetModuleNet().SetView( Camera, bSpawnPointInside );
	    }
        else  // SERVER i CLIENT, NIE WLASCICIEL
        {
            //tryb TPP
            CameraModeChanged( CameraPlayer.CMODE_TPP );
            
            // nie wlasciciel nie ma kamery, wiec nie moze detektowac trigerow
            bDisableTriggerDetection = true;
        }
        
        InitHUD();
        InitImplants();
        
        if (Role == ERole._AUTHORITY) // SERVER
        {
            // stwozmy obiekt trupka
            //m_cDeadBody =(DeadBody)CreateObjectNoInit("DeadBody");
            //m_cDeadBody.ServerInit( this );
                        
            // kamera, do liczenia widocznosci
            if ( bNetIsOwner )
            {
                // w sumie na serwerze kamera jego wlasnego gracza bedzie
                // nieistotna bo na serwerze beda wszystkie obiekty musialby
                // byc relewantne
                cCurrentCamera = Camera;
            }
            else
            {
                cCurrentCamera = (CameraPlayer)CreateObject("CameraPlayer");
                cCurrentCamera.Target = this;
                cCurrentCamera.SetMode(CameraPlayer.CMODE_TPP);    
                
                //Camera = (CameraPlayer)CreateObject("CameraPlayer");
                //Camera.Target = this;
                //Camera.SetMode( CameraPlayer.CMODE_TPP );
            }
            
            if ( ! GetGameInfo().IsPlayerOnServer() )
            {
                // trzeba stworzyc jakas kamere dla serwera
                //GetModuleNet().SetView( cCurrentCamera, bSpawnPointInside );
            }
        }

        // gracz zainicjowany ale martwy
        SetState("DieState");
        DeactivateOnModuleAlways();
    }
    
    public void OnDestroy()
    {
        thisPlayerNet = null;
        DeleteAttachedFXes();
                
        if (Role == ERole._AUTHORITY) // SERVER
        {
            if (Camera                       != null                              && 
                GetModuleNet()               != null                              &&   
                Camera                       == GetModuleNet().GetActiveCamera()  &&
                GetModuleNet().GetFreeCam()  != null )
            {
                GetModuleNet().SetView( GetModuleNet().GetFreeCam(), bSpawnPointInside );
            }
        }
        
        FinishImplants();
        UnregisterKeyRequest();
        UnregisterMouseAxisRequest();
        UnregisterMouseButtonRequest();
        
        super.OnDestroy();
    }
    
    
    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////
    // Obsluga gracza (ogolnie i na kliencie i serwerze)  // GNKIS
    ////////////////////////////////////////////////////////////////////////// 
    ///////////////////////////////////////////////////////////////////////////

    /**Player.UpdateState()
     */
    void UpdateState()
    {
        super.UpdateState();
       
        // zeby przed wyspalnowaniem nic nie bylo wysylane
        if ( bDead )
            return;
        
        CheckSendServerMoveOnUpdate();
    }  
    
    /**Player.UpdateMotion()
     */
    void UpdateMotion()
    {
        //jezeli wlasnie gra jest zamykana to nic nie rob
        if ( ! ModuleNet.IsGameGoing() )
            return;
        
        //zapamietajmy sobie na potrzeby serwera, czy wlasnie
        //bedzie odgrywana animacja oberwania
        if ( nHitReaction != 0 )
            m_bHitReactionOnServer = true;
        
        // nie robimy update motion gdy nie jestesmy jeszcze dobrze wyspawnowani
//        if (GetPhysicsLastUpdateTime() < fSpawnTime)
//            return;
        
        if ( bNetIsOwner )
        {
            //jesli lecimy a podczas lotu nie sterujemy to koniec
            //TODO: upewnic sie czy czasem nie bedzie czasem
            //potrzebne obsluzenie UpdateMotion podczas lotu!!!
            if ( AmIFlying() && !CanTurnOnFlying() )
            {
                UpdateSpeed();
                return;
            }
        }
        
        super.UpdateMotion();

        if (!(m_bOnChangeMovement && (nEnvironment == EMoveEnv.CHMOVE_AIR)) && !m_bRespawning && m_bSendMoveAllowed)
            CheckSendServerMoveOnUpdate();
                
        super.PostUpdateMotion();
    }    
    
    /** W playerze sieciowym pokrywamy ta metode, natomiast
     * super.PostUpdateMotion() zawolane dopiero po obsluzeniu 
     * ewentualnego wyslanie motion statea
     */
    void PostUpdateMotion()
    {
    }
    
    
        
    /**
     */
    public void CleanPlayer()
    {
        super.CleanPlayer();
        
        nLeaning = -1;
        if (Camera != null)
            Camera.ForceStopLeaning();

        m_fLastDivingTime = GetTime();
        SetUnderWater(false);
        
        if (HUD != null)
        {
            HUD.DeactivateCurMenu();
            HUD.GetHUDPlayer().ClearWarnings();
        }

        CleanPlayerMotion();
        CleanAnims();
        SetLocalSpeed( Vector.Zero );
        ActiveWeapon = null;
        PreviousActiveWeapon = null;
        UseWeapon( (Weapon)null );
        UpdateMotion();
        
        // czyscimy inventory
        if ( Role == ERole._AUTHORITY )
            CleanInventory();
        CleanImplants();
        StopDrugs();    
    }
        
    void CleanAnims()
    {
        if ( CharacterAnims != null )
            CharacterAnims.StopAll();
        if ( HandsAnims != null )
            HandsAnims.StopAll();
        for ( int i = 0; i < aWeaponHands.length; ++i )
        {
            BaseAnimations cAnim = aWeaponHands[ i ];
            if ( cAnim != null )
            {
                cAnim.Unlock();
                cAnim.StopAll();
            }
        }
    }
    
    void CleanImplants()
    {
        LogD("\n");
        if ( GetImplantSystem() != null )
             GetImplantSystem().Clean();
    }
    
    
    void OnSwitchImplantSpeed( boolean bActive )
    {
        if ( bNetIsOwner )
        {
            if ( bActive )
                fSpeedMult *= ImplantSpeed._SPEED_MULT;
            else
                fSpeedMult /= ImplantSpeed._SPEED_MULT;
            if (m_nState != _STATE_IN_VEHICLE)
		        UpdateMotion();
        }
    }
    
    /**
     */
    public void Respawn(float fTimeStamp)
    {
        fSpawnTime = fTimeStamp;
        float fMul = 1.f;
        SetPhysicsLastUpdateTime(fSpawnTime - sm_fPhysicsGranularity * fMul);
        SetODEGWDoneUpdates(0);
        Respawn();
    }
    
        
    public void Respawn()
    {
        m_bRespawning = true;
        
        super.Respawn();
        
        if (GetPhysicsType() == EPhysics._ODE_GRAVITYWALK)
            ClearODE();
        
        if ((vSpawnPointPosition != null) && (vSpawnPointForward != null))
        {
            SetPosition( vSpawnPointPosition );
            SetAimDirection( vSpawnPointForward );
            // zapamietujemy poczatkowa aktywnosc portali
            SetPortalSystemActiveFlag( bSpawnPointInside );
        }
        vOldForward      = GetForwardVector();
        vLastPosOnGround = GetPosition();
        
        fAimAngleY = 0.0f;
        ComputeAccuracy();
               
        if (Role == ERole._AUTHORITY)
        {
            // dajemy mu potrzymac
            UseWeapon( GetBestWeapon() );
            UpdateMotion();
            ComputeAccuracy();
                       
            // TODO zmien ustawienie kamery, do liczenia widzialnosci
            // Camera.SetMode(CameraPlayer.CMODE_FPP);
            // CameraModeChanged(CameraPlayer.CMODE_FPP);
            
            if ( ActiveWeapon != null )
                 ActiveWeapon.MsgSendClientState();
        }
        if (bNetIsOwner)
        {
            HideHUDNetOnRespawn();
            
            //przelaczamy kamere
            Camera.SetMode( CameraPlayer.CMODE_FPP );
            CameraModeChanged( CameraPlayer.CMODE_FPP );
            GetModuleNet().SetView( Camera, bSpawnPointInside );
            Camera.SetTake( motion, false );
            Camera.SetZoom( 1.0f );
            Camera.fAimAngleY = 0.0f;
        }
        else
        {
            GetModuleNet().RespawnFX( GetPosition(), ModuleNetBase._FX_RESPAWN_PLAYER );
        }
                
        SetState("FreehandState");
        CleanAnims();
        
        // wracamy na level
        LogD(" "+this+" bNetIsOwner:"+bNetIsOwner+"\n");
        
        ActivateOnModule();
        //EnableODEPhysics(0);
        
        DeleteAttachedFXes();
        SetCorrectPosOnRender( true );
        
        if ( ! bNetIsOwner )
            ImplantTermovision.AddToSystem( this );
        
        ShowHud();
        
        if ( Role == ERole._AUTHORITY && !bNetIsOwner )
            SetServerTestSendData();
        else if ( Role < ERole._AUTHORITY && bNetIsOwner )
            SetClientTestSendData();
        
        m_bRespawning = false;
    }
    
    void RespawnCancel()
    {
        if ( bDead )
            SetInventoryMenu();
    }
            
    void ClearODE()
    {
        SetODEGWLinVel(Vector.Zero);
        SetODEGWForce(Vector.Zero);
        SetODEGWVelocityAccumulator(Vector.Zero);
        SetODEGWStateBParam1(false);
        SetODEGWStateBParam2(false);
        SetODEGWStateFParam1(0);
        SetODEGWStateFParam2(0);
        SetODEGWDoneUpdates(0);
    }
    
    //////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////
    
    
    /** Odebranie komunikatow przychodzacych z sieci
     */
    public void OnMessage()
    {
        ProfileBegin(PROFILE_OnMessage);
        
        int nMsgId = MessageGetId();
        
        if (nMsgId == MSG_SERVER_MOVE)
            ProfileBegin(PROFILE_OnMessageMove);
        else
            ProfileBegin(PROFILE_OnMessageOther);
        
        switch ( nMsgId )
        {
        case MSG_SERVER_MOVE:
            NetLog.MsgIn( "MSG_SERVER_MOVE", this );
            MsgRecvServerMove();
            break;
        
        case MSG_CLIENT_ADJUST_STATE:
            NetLog.MsgIn( "MSG_CLIENT_ADJUST_STATE", this );
            MsgRecvClientAdjustState();
            break;
            
        case MSG_SERVER_ACTION_REQ:
            NetLog.MsgIn( "MSG_SERVER_ACTION_REQ", this );
            MsgRecvServerActionRequest();
            break;
            
        case MSG_CLIENT_ACTION:
            NetLog.MsgIn( "MSG_CLIENT_ACTION", this );
            MsgRecvClientAction();
            break;
            
        case MSG_CLIENT_RESPAWN:
            NetLog.MsgIn( "MSG_CLIENT_RESPAWN", this );
            MsgRecvClientRespawn();
            break;
            
        case MSG_CLIENT_PLAYER_DIED:
            NetLog.MsgIn( "MSG_CLIENT_PLAYER_DIED", this );
            MsgRecvClientPlayerDied();
            break;
            
		case MSG_CLIENT_HEALTH:
            NetLog.MsgIn( "MSG_CLIENT_HEALTH", this );
			MsgRecvClientHealth();
			break;
            
        case MSG_CLIENT_OVERLOAD:
            NetLog.MsgIn( "MSG_CLIENT_OVERLOAD", this );
			MsgRecvClientOverload();
			break;
            
        case MSG_CLIENT_RESPAWN_REJECT:
            NetLog.MsgIn( "MSG_CLIENT_RESPAWN_REJECT", this );
            MsgRecvClientRespawnReject();
            break;
                        
        case MSG_SERVER_SWITCH_UNDER_WATER:
            NetLog.MsgIn( "MSG_SERVER_SWITCH_UNDER_WATER", this );
            MsgRecvServerSwitchUnderWater();
            break;
                    
        case MSG_CLIENT_STATE:
        case MSG_CLIENT_STATE_SHORT:
            boolean bFull = MessageGetId() == MSG_CLIENT_STATE;
            NetLog.MsgIn( bFull ? "MSG_CLIENT_STATE" : "MSG_CLIENT_STATE_SHORT", this );
            MsgRecvClientState( bFull );
            break;

        case MSG_SERVER_STATE_REQUEST:
            NetLog.MsgIn( "MSG_SERVER_STATE_REQUEST", this );
            MsgRecvServerStateRequest();
            break;
            
        case MSG_SERVER_INV_WISH_LIST:
            NetLog.MsgIn( "MSG_SERVER_INV_WISH_LIST", this );
            MsgRecvServerInvWishList();
            break;
            
        case MSG_CLIENT_INVENTORY_CONTENT:            
            NetLog.MsgIn( "MSG_CLIENT_INVENTORY_CONTENT", this );
            MsgRecvClientInventoryContent();
            break;
            
        case MSG_SERVER_TEST_DATA:
            NetLog.MsgIn( "MSG_SERVER_TEST_DATA", this );
            MsgRecvServerTestData();
            break;
            
        case MSG_CLIENT_TEST_DATA:
            NetLog.MsgIn( "MSG_CLIENT_TEST_DATA", this );
            MsgRecvClientTestData();
            break;
        
        case MSG_SERVER_VEHICLE_COLL:
            NetLog.MsgIn( "MSG_SERVER_VEHICLE_COLL", this );
            MsgRecvServerVehicleCollision();
            break;
            
        case MSG_CLIENT_VEHICLE_COLL_ANSW:
            NetLog.MsgIn( "MSG_CLIENT_VEHICLE_COLL_ANSW", this );
            MsgRecvClientVehicleCollisionAnswer();
            break;
            
        case MSG_CLIENT_NO_INV_ROOM:
            NetLog.MsgIn( "MSG_CLIENT_NO_INV_ROOM", this );
            MsgRecvClientNoInvRoom();
            break;
        
        default:
            NetLog.MsgIn( "CANCEL "+nMsgId, this );
            MessageCancel();
        }
        
        if (nMsgId == MSG_SERVER_MOVE)
            ProfileEnd(PROFILE_OnMessageMove);
        else
            ProfileEnd(PROFILE_OnMessageOther);

        ProfileEnd(PROFILE_OnMessage);
    }
        
  
    
    /** Akcja spawnowania
     */
    void ActionRespawn()
    {
        if ( bNetIsOwner )
            ShowHUDNetOnRespawnRequest();
        if (Role == ERole._AUTHORITY)
            ServerRespawn();
        else
            MsgSendServerActionRequest( EPlayerAction.RESPAWN );
    }
    
    /** Proba odwolania akcji spawnowania
     * Bedzie mialo to miejsce, jak ktos wcisnie respawn,
     * ale bedzie musial na niego czekac (bo np. jest limit)
     * i wtedy ma szanse wejsc jeszcze do inwentory.
     * Jezeli w pore zawiadomi o tym serwer (ten jeszcze go
     * nie wyspawnuje) to bedzie mogl sobie odwiedzic inwentory
     */
    void ActionRespawnCancel()
    {
        if (Role == ERole._AUTHORITY)
            ServerRespawnCancel();
        else
            MsgSendServerActionRequest( EPlayerAction.RESPAWN_CANCEL );
    }
    
    ///////////////////////////////////////////////////////////////////////////
    // KONIEC: Obsluga gracza (ogolnie i na kliencie i serwerze)  // KGNKIS
    ////////////////////////////////////////////////////////////////////////// 
    
        
    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////
    // Obsluga gracza na serwerze  // KGNS
    ////////////////////////////////////////////////////////////////////////// 
    ///////////////////////////////////////////////////////////////////////////
    


    ///////////////////////////////////////////////////////////////
    // respawn
    
    /**SERVER Proba respawnu na serwerze, jesli sie powiedzie
     * to rozsyla info do klientow
     */
    void ServerRespawn()
    {
        m_bWaitForNextRespawnTime = false;
        DisableCallMethod( METHOD_ServerRespawn );
        
        if ( !bDead )
            return;
        
        int nReason = GetReasonIfRespawnDisabled();
        if ( nReason != ERespawnRequestResults._ENABLED )
        {
            if (bNetIsOwner)
                ShowHUDNetOnRespawnReject( nReason );
            else
                MsgSendClientRespawnReject( nReason );
            
            if (nReason == ERespawnRequestResults._DISABLED_GAME_NOTSTARTED)
                CallMethodIn( METHOD_ServerRespawn, 1.0f );
            return;
        }
        
        float fTimeToRespawn = GetGameInfo().GetTimeToRespawn( this );
        if ( fTimeToRespawn > 0.0f )
        {
            CallMethodIn( METHOD_ServerRespawn, fTimeToRespawn );
            m_bWaitForNextRespawnTime = true;
            return;
        }
		
		// znajdujemy pozycje do respawna
		NetSpawnPoint cSpawnPoint = GetModuleNet().GetRandomSpawnPoint( this );
		if (cSpawnPoint != null)
		{
		    vSpawnPointPosition = cSpawnPoint.GetSpawnPosition();
		    vSpawnPointForward  = cSpawnPoint.GetSpawnDir();
            bSpawnPointInside   = cSpawnPoint.IsInside();
		}
		else
            CrashLog("ERROR: spawnPoint == null !!! default spawn point\n");

        //zliczamy ilosc respawnow
        IncRespawnCnt();
		// server popelnia (!) respawn na graczu
		float fTime = GetTime();
        Respawn( RoundToPhysicsGranularity(fTime) );
		// wysyla pozwolenie na respawn do klientow
		MsgSendClientRespawn(fTime);
        //zapamietujemy ze sie urodzil
        SetStateFromServer( _STATE_SPAWNED, fTime );
        // informujemy o tym netgameinfo
        GetGameInfo().EventPlayerSpawned( this );
        // i na chwile wlaczamy niesmiertelnosc
        ScheduleImmortalAfterRespawn();
    }
    
    /**
     * Flaga mowiaca o tym, ze juz chcielismy sie wyspawnowac
     * ale ze wzgledu na MinRespawnTimeLimit musimy czekac...
     * Bedzie to mozna wykorzystac przy zakonczonej rundzie,
     * wtedy graczy ktorzy zgineli wczesniej i juz czekaja
     * na ponowne urodzenie wyspanuje sie od reki
     */
    boolean m_bWaitForNextRespawnTime = false;
    
    void ForceDieOnGameRestart()
    {
        super.ForceDieOnGameRestart();
                
        //musimy zagwarantowac ze _wszyscy_ maja szanse sie od razu 
        //wyspawnowac (nawet Ci zabici jeszcze przed koncem rundy)
        if ( GetPlayerInfo() != null )
            GetPlayerInfo().SetNextRespawnTime( GetTime() );
        
        //jesli gosc czekal, to sie doczekal...
        if ( m_bWaitForNextRespawnTime ) 
            CallMethodIn( METHOD_ServerRespawn, 0.0f );
    }
    
    void ServerRespawnCancel()
    {
        DisableCallMethod( METHOD_ServerRespawn );
        
        //jesli juz zyje to to herbacie
        if ( !bDead )
            return;
        
        int nReason = GetReasonIfRespawnDisabled();
        if ( nReason != ERespawnRequestResults._ENABLED )
        {
            if (bNetIsOwner)
                ShowHUDNetOnRespawnReject( nReason );
            else
                MsgSendClientRespawnReject( nReason );
            
            if (nReason != ERespawnRequestResults._DISABLED_GAME_NOTSTARTED)
                return;
        }
        
        m_bWaitForNextRespawnTime = false;
        if (bNetIsOwner)
            RespawnCancel();
        else
            MsgSendClientActionMode( EPlayerAction.RESPAWN_CANCEL, 
                                     -1, -1,  EMsgSendMode.OWNER );
    }
	
    /**SERVER wyslanie do clienta informacji o respawnie
     */
    void MsgSendClientRespawn(float fTime)
    {
        MessageNew(MSG_CLIENT_RESPAWN);
		MessagePackFloat( fTime );
        MessagePackInt( GetRespawnCnt() );
        MessagePackVector( GetPosition() );
        MessagePackVector( GetAimDirection() );
        MessagePackBoolean( bSpawnPointInside );
        MessageSend();
        
        //CrashLog("send spawn pos "+GetPosition()+"\n");
    }
    
    /**SERVER wyslanie do clienta informacji o odrzuceniu respawnu
     */
    void MsgSendClientRespawnReject(int nReason)
    {
        MessageNew(MSG_CLIENT_RESPAWN_REJECT);
        MessagePackInt( nReason );
        MessageSend( EMsgSendMode.OWNER );
    }
        
    /** SERWER odebranie checi wykonania akcji
     */
    void MsgRecvServerActionRequest()
    {
        float fTimeStamp    = MessageUnPackFloat();
        int nAction         = MessageUnPackInt();
        int nParam          = MessageUnPackInt();
        int nParam2         = MessageUnPackInt();
        MessageEnd();
        
        if ( bDead && 
             ((nAction != EPlayerAction.RESPAWN)&&
              (nAction != EPlayerAction.RESPAWN_CANCEL)) )
            return;
        
        LogD(" "+nAction+" "+nParam+"\n");
        switch ( nAction )
        {
            case EPlayerAction.RESPAWN: 
                ActionRespawn();
                break;
                
            case EPlayerAction.RESPAWN_CANCEL: 
                ActionRespawnCancel();
                break;                
                
            case EPlayerAction.WEAPON_CHANGE: 
                if ( m_nChangeWeaponInCnt < nParam2 )
                {
                    m_nWeaponToUse       = nParam;
                    m_nChangeWeaponInCnt = nParam2;
                    //LogR(" WEAPON CHANGE REQ IN from client "+m_nWeaponToUse+" "+GetObjectByNetId(m_nWeaponToUse)+"\n");
                    ActionChangeWeaponState();
                }
                /*else
                    LogR(" WEAPON CHANGE REQ IN from clientr "+nParam+" "+GetObjectByNetId(nParam)+" time failed "+m_nChangeWeaponInId+" >= "+nParam2+"\n");*/
                break;
            
            case EPlayerAction.VEHICLE_GET_IN: 
                ActionGetIn( nParam,nParam2 );
                break;
            
            case EPlayerAction.VEHICLE_GET_OUT: 
                //TODO: sprawdzic czy nParam to jest aktualny pojazd
                ActionGetOut();
                break;
                
            case EPlayerAction.VEHICLE_CHANGE_SEAT: 
                //TODO: sprawdzic czy nParam to jest aktualny pojazd
                ActionChangeSeat();
                break;                
                
            
            case EPlayerAction.RELOAD: 
                if ( nParam == 1 )
                    ActionReloadingStart();
                else
                    ActionReloadingStop();
                UpdateState();
                break;
            
            case EPlayerAction.USE: 
                InvObject cInvObj = GetInvObjByNetId( nParam );
                UseInvObject( cInvObj );
                break;
            
            case EPlayerAction.USE_END: 
                cInvObj = GetInvObjByNetId( nParam );
                EndUseInvObject( cInvObj );
                break;
            
            case EPlayerAction.IMPLANT_ON: 
                ActionImplantOn( nParam );
                break;
                
            case EPlayerAction.IMPLANT_OFF:
                ActionImplantOff( nParam );
                break;
        }
    }
    
    int GetReasonIfRespawnDisabled()
	{
		if ( GetGameInfo() == null )
		{
			NetLog.Error( "GetReasonIfRespawnDisabled() "+GetNetInfo()+" m_cGameInfo == null ");
			return ERespawnRequestResults._DISABLED_NO_REASON;
		}
		
        if ( ! cGameInitInfo.cLevels.IsCurrentValid() )
            return ERespawnRequestResults._DISABLED_NO_REASON;;
        
		return GetGameInfo().GetReasonIfRespawnDisabled( this );
	}


    
    
    void ActionImplantOn( int nImplant )
    {
        if ( Role == ERole._AUTHORITY )
        {
            ImplantOn( nImplant );
            MsgSendClientAction( EPlayerAction.IMPLANT_ON, nImplant );
        }
        else
        {
            MsgSendServerActionRequest( EPlayerAction.IMPLANT_ON , nImplant );
        }
    }
    void ActionImplantOff( int nImplant )
    {
        if ( Role == ERole._AUTHORITY )
        {
            ImplantOff( nImplant );
            MsgSendClientAction( EPlayerAction.IMPLANT_OFF, nImplant );
        }
        else
        {
            MsgSendServerActionRequest( EPlayerAction.IMPLANT_OFF , nImplant );
        }
    }
    
    void ImplantOn( int nImplant )
    {
        super.ImplantOn( nImplant );
        if ( HUD != null )
            HUD.RefreshImplantsIndicators();
    }
    
    void ImplantOff( int nImplant )
    {
		super.ImplantOff( nImplant );
        if ( HUD != null )
            HUD.RefreshImplantsIndicators();
    }
    
        
    /**SERVER akcje servera rozsylane do odpowiednich klientow
     */
    
    void MsgSendClientAction(int nAction, 
                             int nParam1, int nParam2,int nParam3,
                             int nMode, 
                             float fTimeStamp )
    {
        switch(nAction)
        {
        case EPlayerAction.RESPAWN_CANCEL:            
        case EPlayerAction.JUMP:
        case EPlayerAction.WEAPON_CHANGE:
        case EPlayerAction.RELOAD:
        case EPlayerAction.VEHICLE_GET_IN:
        case EPlayerAction.VEHICLE_GET_OUT:
        case EPlayerAction.USE:
        case EPlayerAction.USE_END:
        case EPlayerAction.IMPLANT_ON:
        case EPlayerAction.IMPLANT_OFF:
            Log("SEND MSG_CLIENT_ACTION :"+nAction+" "+nMode+"\n");
            MessageNew(MSG_CLIENT_ACTION);
            MessagePackFloat(fTimeStamp);
            MessagePackInt(nAction);
            MessagePackInt(nParam1);
            MessagePackInt(nParam2);
            MessagePackInt(nParam3);
            MessageSend(nMode);
			break;
            
		default:
			LogD(" !!!! ACTION "+nAction+" NOT SUPPORTED !!!!!\n");
        }
    }
    void MsgSendClientAction( int nAction )
    {
        MsgSendClientAction( nAction, 
                             -1, -1, -1,
                             EMsgSendMode.ALL, 
                             GetTime() );
    }
    void MsgSendClientAction( int nAction, int nParam )
    {
        MsgSendClientAction( nAction, 
                             nParam, -1, -1,
                             EMsgSendMode.ALL, 
                             GetTime() );
    }
    void MsgSendClientAction( int nAction, int nParam, int nParam2 )
    {
        MsgSendClientAction( nAction, 
                             nParam, nParam2, -1,
                             EMsgSendMode.ALL, 
                             GetTime() );
    }
    void MsgSendClientAction( int nAction, int nParam, int nParam2, int nParam3 )
    {
        MsgSendClientAction( nAction, 
                             nParam, nParam2, nParam3,
                             EMsgSendMode.ALL, 
                             GetTime() );
    }
    
    void MsgSendClientActionMode(int nAction, int nParam, int nParam2, int nMode)
    {
        MsgSendClientAction( nAction, 
                             nParam, nParam2, -1,
                             nMode, 
                             GetTime() );
    }
    
    
    void MsgSendClientPlayerDied(int nMode, int nParam,int nRespawnCnt,float fTime)
    {
        Log("SEND MSG_CLIENT_PLAYER_DIED\n");
        MessageNew( MSG_CLIENT_PLAYER_DIED );
        MessagePackFloat( fTime );
        MessagePackInt( nMode );
        MessagePackInt( nParam );
        MessagePackInt( nRespawnCnt );
        MessageSend();
    }
    
    void MsgSendClientInventoryContent()
    {
        MessageNew( MSG_CLIENT_INVENTORY_CONTENT );
        PackInventoryContent();
        MessageSend( EMsgSendMode.OWNER );
    }
    
    ///////////////////////////////////////////////////////////////////////////
    // KONIEC: Obsluga gracza na serwerze  // KGNS
    //////////////////////////////////////////////////////////////////////////    
    
    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////
    // Obsluga gracza na kliencie (ogolnie i wlascicielu i nie)  // GNKO
    ////////////////////////////////////////////////////////////////////////// 
    ///////////////////////////////////////////////////////////////////////////
    
    void MsgRecvClientAction()
    {
        float fTimeStamp    = MessageUnPackFloat();
        int   nAction       = MessageUnPackInt();
        int   nParam        = MessageUnPackInt();
        int   nParam2       = MessageUnPackInt();
        int   nParam3       = MessageUnPackInt();
        MessageEnd();
        
        if ( bDead && nAction != EPlayerAction.RESPAWN_CANCEL )
            return;
        
        switch (nAction)
        {
        case EPlayerAction.JUMP:
            LogD("MSG_CLIENT_ACTION JUMP\n");
            PlayerJump();
            break;    

        case EPlayerAction.WEAPON_CHANGE:
            LogD("MSG_CLIENT_ACTION WEAPON_CHANGE\n");
            if ( m_nChangeWeaponInCnt < nParam2 )
            {  
                m_nWeaponToUse       = nParam;
                m_nChangeWeaponInCnt = nParam2;
                //LogR(" WEAPON CHANGE IN from server "+m_nWeaponToUse+" "+GetObjectByNetId(m_nWeaponToUse)+"\n");
                ActionChangeWeaponStateDo();
            }
            /*else
                LogR(" WEAPON CHANGE IN from server "+nParam+" "+GetObjectByNetId(nParam)+" time failed "+m_nChangeWeaponInId+" >= "+nParam2+"\n");*/
            break;
            
        case EPlayerAction.RELOAD:
            LogD("MSG_CLIENT_ACTION RELOAD "+nParam);
            // TODO: dorobic zaleznosci czasowe
            if ( nParam == 1 )
                ActionReloadingStartDo();                
            else
                ActionReloadingStopDo();   
            UpdateState();
            break;
       
        case EPlayerAction.VEHICLE_GET_IN:
            LogD("MSG_CLIENT_ACTION VEHICLE_GET_IN\n");
            boolean bGetInVerified     = VerifyDriverCounter( nParam3 );
            if ( bGetInVerified )
            {  
                m_nSeatVehicleToGetInOut = nParam;
                m_nSeatIndexToGetInOut   = nParam2;
                
                m_bGetInOutFromServer = true;
                ActionGetInDo();
                m_bGetInOutFromServer = false;

                //TODO:
                //sprawdzmy czy dalo sie wsiasc
                //jesli nie, to rozstrzygnac konflikt
            }
            else
            {
                Vehicle cVehicle = GetVehicleByNetId( nParam );
                NetLog.PlayerDriver("GET_IN "+((cVehicle!=null)?cVehicle.GetNetInfo():" nid "+nParam)+
                                    " by:"+GetNetInfo()+" skipped by counter\n");
            }
            break;
            
        case EPlayerAction.VEHICLE_GET_OUT:
            LogD("MSG_CLIENT_ACTION VEHICLE_GET_OUT\n");
            boolean bGetOutVerified = VerifyDriverCounter( nParam3 );
            if ( bGetOutVerified )
            {  
                m_bSendMoveAllowed = false;
                ClearODE();
                ActionGetOutDo();
                SetPhysicsLastUpdateTime( RoundToPhysicsGranularity(fTimeStamp) );
                m_bSendMoveAllowed = true;
                //LogR("Ustawiam przy wysiadaniu (Client) LUT: " + GetPhysicsLastUpdateTime() + "\n");
                
                //TODO:
                //sprawdzmy czy napewno dalo sie wsiasc
                //jesli nie, to rozstrzygnac konflikt
            }
            else
            {
                Vehicle cVehicle = GetVehicleByNetId( nParam );
                NetLog.PlayerDriver("GET_OUT "+((cVehicle!=null)?cVehicle.GetNetInfo():" nid "+nParam)+
                                    " by:"+GetNetInfo()+" skipped by counter\n");
            }
            break;
            
        case EPlayerAction.USE:
            LogD("MSG_CLIENT_ACTION USE\n");
            InvObject invObj = GetInvObjByNetId(nParam);
            if (invObj != null)
               UseInvObjectDo( invObj );
            break;
            
        case EPlayerAction.USE_END:
            LogD("MSG_CLIENT_ACTION USE_END\n");
            invObj = GetInvObjByNetId(nParam);
            if (invObj != null)
               EndUseInvObjectDo( invObj );
            break;
        
        case EPlayerAction.IMPLANT_ON:
            LogD("MSG_CLIENT_ACTION IMPLANT_ON\n");
            ImplantOn( nParam );
            break;
        
        case EPlayerAction.IMPLANT_OFF:
            LogD("MSG_CLIENT_ACTION IMPLANT_OFF\n");
            ImplantOff( nParam );
            break;
			
		case EPlayerAction.EXECUTE:
            LogD("MSG_CLIENT_ACTION EXECUTE !!!! to chyba nie dziala!!!????\n");
            TriggerObject triggerObj = GetTriggerObjByNetId(nParam);
            if (triggerObj != null)
                triggerObj.Execute( this );
            break;
        
        case EPlayerAction.RESPAWN_CANCEL:
            RespawnCancel();
            break;
            
        default:
            LogD("MSG_CLIENT_ACTION "+nAction+" NOT SUPPORTED!!!!\n");
        }
    }

    /**
     * Akcja smierci jest obslugiwane w osobnym komunikacie
     */
    void MsgRecvClientPlayerDied()
    {
        Log("RECV MSG_CLIENT_PLAYER_DIED\n");
        float fTimeStamp  = MessageUnPackFloat();
        int   nMode       = MessageUnPackInt();
        int   nParam      = MessageUnPackInt();
        int   nRespawnCnt = MessageUnPackInt();
        MessageEnd();
        
        if ( PlayerNet.sm_bIgnoreDie )
            return;
        
        if ( GetStateFromServerTime() <= fTimeStamp )
        {
            SetRespawnCnt( nRespawnCnt );
            PlayerDied( nMode, nParam );
            SetStateFromServer( _STATE_DIE, fTimeStamp );
        }
        else
        {
            LogR("Otrzymalismy stary stan (smierc) gracza "+this+" - ignore\n");
        }
    }
    
    void MsgRecvClientInventoryContent()
    {
        Log("MSG_CLIENT_INVENTORY_CONTENT\n");
        UnPackInventoryContent();
        MessageEnd();
        
        SetInventoryContentValid();
        CheckInventoryContent();
    }
    
    ///////////////////////////////////////////////////////////////////////////
    // KONIEC: Obsluga gracza na kliencie (ogolnie i wlascicielu i nie)  // KGNKO
    //////////////////////////////////////////////////////////////////////////    
    
    
    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////
    // Obsluga gracza na kliencie wlascicielu  // GNKW
    ////////////////////////////////////////////////////////////////////////// 
    ///////////////////////////////////////////////////////////////////////////
       
    
    /**CLIENT Odbior sygnalu o respawnie
     */
    void MsgRecvClientRespawn()
    {
        if (Role == ERole._AUTHORITY) 
			return;
       
        float fTimeStamp		= MessageUnPackFloat();
        int   nRespawnCnt       = MessageUnPackInt();
        vSpawnPointPosition	    = MessageUnPackVector();
        vSpawnPointForward	    = MessageUnPackVector();
        bSpawnPointInside       = MessageUnPackBoolean();
        
        MessageEnd();
    
        //CrashLog("recv spawn pos "+vSpawnPointPosition+"\n");
        
        if ( GetStateFromServerTime() <= fTimeStamp )
        {
            SetRespawnCnt( nRespawnCnt );
            Respawn( RoundToPhysicsGranularity(fTimeStamp) );
            SetStateFromServer( _STATE_SPAWNED, fTimeStamp );
        }
        else
        {
            LogR("Otrzymalismy stary stan (spawn) gracza "+this+" - ignore\n");
        }
    }
    
    /**CLIENT Odbior sygnalu o respawnie
     */
    void MsgRecvClientRespawnReject()
    {
        if (Role == ERole._AUTHORITY) 
			return;
       
        int nReason = MessageUnPackInt();
        MessageEnd();
        //
        ShowHUDNetOnRespawnReject( nReason );
    }
    
       
    
    
    /** CLIENT wyslanie do serwera checi wykonania akcji
     * 
     */
    void MsgSendServerActionRequest( int nAction )
    {
        MsgSendServerActionRequest( nAction, -1 );
    }
    void MsgSendServerActionRequest( int nAction, int nParam1 )
    {
        MsgSendServerActionRequest( nAction, nParam1, -1 );
    }
    void MsgSendServerActionRequest( int nAction, int nParam1, int nParam2 )
    {
        LogD(" "+nAction+" "+nParam1+""+nParam2+"\n");
        MessageNew( MSG_SERVER_ACTION_REQ );
        MessagePackFloat( GetTime() );
        MessagePackInt( nAction );
        MessagePackInt( nParam1 );
        MessagePackInt( nParam2 );
        MessageSend();
    }

    ///////////////////////////////////////////////////////////////////////////
    // KONIEC: Obsluga gracza na kliencie wlascicielu  // KGNKW
    ////////////////////////////////////////////////////////////////////////// 
    
    void SetIgnoreDie( boolean bIgnore ) { sm_bIgnoreDie = bIgnore; }
    static boolean sm_bIgnoreDie = false;

    
    int m_nClientTestSendData = 128;
    int m_nServerTestSendData = 128;
    
    float m_fClientTestSendDataPeriod = 0.0f;
    float m_fServerTestSendDataPeriod = 0.0f;
    
    void SetClientTestSendData( int nBytes, float fTime )
    {
        m_nClientTestSendData = nBytes%2000;
        m_fClientTestSendDataPeriod = fTime;
        SetClientTestSendData();
    }
    
    void SetClientTestSendData()
    {
        StopClientTestSendData();
        if ( m_fClientTestSendDataPeriod > 0.0f )
            CallMethodEvery("MsgSendServerTestData",m_fClientTestSendDataPeriod);
    }
    
    void StopClientTestSendData()
    {
        DisableCallMethod("MsgSendServerTestData");
    }
    
    void SetServerTestSendData( int nBytes, float fTime )
    {
        m_nServerTestSendData = nBytes%2000;
        m_fServerTestSendDataPeriod = fTime;
        SetServerTestSendData();
    }
    
    void SetServerTestSendData()
    {
        StopServerTestSendData();
        if ( m_fServerTestSendDataPeriod > 0.0f )
            CallMethodEvery("MsgSendClientTestData",m_fServerTestSendDataPeriod);
    }
    
    void StopServerTestSendData()
    {
        DisableCallMethod("MsgSendClientTestData");
    }
                           
    void MsgSendServerTestData()
    {
        //MessageNew( MSG_SERVER_TEST_DATA );
        //MsgPackTestData( m_nClientTestSendData );
        //MessageSend();
        
        int iSent = 0;
        while (iSent < m_nServerTestSendData)
        {
            MessageNew( MSG_SERVER_TEST_DATA );
            //MsgPackTestData( m_nServerTestSendData );
            int iToSendThisTime = 0;
            if (m_nServerTestSendData - iSent > 2000)
            {
                iToSendThisTime = 2000;
            }
            else
            {
                iToSendThisTime = m_nServerTestSendData - iSent;
            }
            
            MsgPackTestData( iToSendThisTime );            
            MessageSend( );
            
            iSent += iToSendThisTime;
        }
    }
    
    void MsgSendClientTestData()
    {
        int iSent = 0;
        while (iSent < m_nServerTestSendData)
        {
            MessageNew( MSG_CLIENT_TEST_DATA );
            //MsgPackTestData( m_nServerTestSendData );
            int iToSendThisTime = 0;
            if (m_nServerTestSendData - iSent > 2000)
            {
                iToSendThisTime = 2000;
            }
            else
            {
                iToSendThisTime = m_nServerTestSendData - iSent;
            }
            
            MsgPackTestData( iToSendThisTime );            
            MessageSend( EMsgSendMode.OWNER );
            
            iSent += iToSendThisTime;
        }
    }
    
    
    void MsgRecvServerTestData()
    {
        int nCnt = MsgUnPackTestData();
        MessageEnd();
        
        NetLog.Test("RECV ServerTestData nCnt "+nCnt+" bytes\n");
    }
    
    void MsgRecvClientTestData()
    {
        int nCnt = MsgUnPackTestData();
        MessageEnd();
        
        NetLog.Test("RECV ClientTestData nCnt "+nCnt+" bytes\n");
    }
    
    void MsgPackTestData( int nBytes )
    {
        MessagePackInt( nBytes );
        for ( int i=0; i<nBytes; i++ )
            MessagePackByte( (byte)RandomInt( Byte.MAX_VALUE ) );
    }
    
    int MsgUnPackTestData()
    {
        int nBytes = MessageUnPackInt();
        for ( int i=0; i<nBytes; i++ )
            MessageUnPackByte();
        return nBytes;
    }
    
    void PlayerDied( int nPar1, int nPar2 )
    {
        super.PlayerDied( nPar1, nPar2 );
        
        StopServerTestSendData();    
        StopClientTestSendData();
    }
}


