/**
 * Model krecacy sie w PlayerPrifileMenu
 */
public class PlayerProfileModel extends MeshObject
{
    //czy po przeladowaniu mesha ma sie on ustawic na wprost?
    boolean m_bSetDirOnChangeMesh = true;
    
    boolean m_bRotateAllowed      = true;
    
    /**
     * Krecenie sie mesha
     */
    
    //z jaka predkoscia mesh sie obraca? stopnie / sekundy
    float   m_fRotateSpeed  = 75.0f;
    //wg jakiej osi sie obraca?
    Vector  m_vRotate       = new Vector(0,1,0);
    //jakie jest opoznienie obracania (po zmianie mesha) w sekundach
    float   m_fRotateDelay  = 3.0f;
    
    //czy aktualnie sie kreci?
    boolean m_bRotate       = false;
    //kiedy ostatnio byl obracany?
    float   m_fLastRotateTime   = 0.0f;

    
    
    public void OnCreate()
    {
        super.OnCreate();
        
        SetPosition();
        ClearFlag( EFlags._NO_ANIMATION );
        ClearFlag( EFlags._NO_ANIMATION_REFRESH );
        SetLighting( true );
        SetPhysicsType( EPhysics._NONE );
        SetLODCoeff( 0.0f );
        ActivateOnModuleGridIndependent();
    }
    
    NetPlayerModelInfo  m_cModelInfo = null;
    
    void SetModel(NetPlayerModelInfo cModelInfo)
    {
        if ( cModelInfo == null )
            return;
        
        boolean bMeshChanged = m_cModelInfo == null ||
                               m_cModelInfo.GetMeshPathName() == null ||
                              !m_cModelInfo.GetMeshPathName().equalsIgnoreCase( cModelInfo.GetMeshPathName() );
                              
        m_cModelInfo = cModelInfo;
        
        if ( bMeshChanged )
        {
            StopAnim("");
            LoadMesh( m_cModelInfo.GetMeshPathName() );
            //TODO:moze odpalic jakas animacje
            //PlayAnim("radosc1_loop",500);
            if ( m_bSetDirOnChangeMesh )
                SetDir( new Vector(0,0,1) ) ;
        
            if ( m_bRotateAllowed && m_fRotateDelay >= 0.0f )
            {
                m_bRotate = false;
                DisableCallMethod( "RotateOn" );
                CallMethodIn( "RotateOn", m_fRotateDelay );
            }
        }
        
        m_cModelInfo.ApplyPartialSkins( this );
    }
    
    void SetPosition()
    {
        Vector vPosition = null;
        switch (GetScreenWidth())
        {
            case 640:
                vPosition = new Vector(130,-40,1190);
                break;
            case 800:
                vPosition = new Vector(120,-40,1130);
                break;
            case 1024:
                vPosition = new Vector(120,-40,1020);
                break;
            default:
                vPosition = new Vector(120,-40,910);
                break;
        }
        
        SetPosition(vPosition);
    }
    
    void RotateOn()
    {
        m_bRotate         = true;
        m_fLastRotateTime = GetTime();
    }
    
    public void OnFrame()
    {
        if ( m_bRotate )
        {
            float fTime       = GetTime();
            float fRotate     = (m_fLastRotateTime - fTime)*m_fRotateSpeed;
            m_fLastRotateTime = fTime;
            
            RotateLocal( m_vRotate, fRotate );
        }
    }

    
}
