import java.io.*;
/** Rozne statyczne metody przydatne glownie przy skladaniu 
 * komunikatow w grze sieciowej
 */
public class NetGameTools
{
    /** 
     * Metody do miksowania tekstow z parametrami (np nickami graczy)
     */
    
    /** znacznik za ktory bedziemy wstawiali stringa
     * Jezeli w danym stringu pojawia sie dwa (lub wiecej) takich
     * znacznikow, to kolejno beda zamieniane _od lewej_
     * Jesli w przetlumaczonym tekscie zmieni sie szyk zdania
     * i kolejnosc wystepowania parametrow, nalezy podac
     * prawidlowa kolejnosc za pomoca znacznikow numerowanych %1s %2s ...
     * Przyklad:
     * Gracz %s zniszczyl obiekt %s.
     * Mozemy zamienic na:
     * Obiekt %2s zostal zniszczony przez gracza %s1.
     */
    static String   sm_sNameSubstring  = "%s";
    
    /** Metoda odnajdujaca w sMain _pierwszy_ znacznik sNameSubstring
     * i w jego miejsce wstawia stringa sName
     */
    static String MixString( String sMain, String sName )
    {
        // znajdzmy wycinany znacznik, oraz jego poczatek i koniec
        //zalozmy ze bedzie to znacznik standardowy, wtedy szukamy pierwszego z lewej
        String sNameSubstring = sm_sNameSubstring;
        int nBegin = sMain.indexOf( sNameSubstring );
        //jesli nie znalazl, to szukamy "numerowanych"
        if ( nBegin < 0 )
            for ( int i=0; i<9; i++ )
            {
                //wyliczmy sobie jak powinien wygladac kolejny znacznik
                sNameSubstring = sm_sNameSubstring.substring( 0, 1 )+
                                 i +
                                 sm_sNameSubstring.substring( 1 );
                //sprawdzmy czy taki znacznik istnieje w tekscie?
                nBegin = sMain.indexOf( sNameSubstring );
                //jesli tak, to przerywamy szukanie
                if ( nBegin >= 0 )
                    break;
            }
                
        if ( nBegin < 0 )
        {
            GameObject.LogD(" substring not found in "+sMain+"\n");
            return sMain;// + " ERROR ";
        }
        
        int nEnd   = nBegin + sNameSubstring.length();
        return sMain.substring( 0, nBegin ) + sName + sMain.substring( nEnd );
    }
    
    static String MixString( String sMain, String sName1, String sName2 )
    {
        String sTmp = MixString( sMain, sName1 );
        return MixString( sTmp, sName2 );
    }
    static String MixString( String sMain, String sName1, String sName2, String sName3 )
    {
        String sTmp = MixString( sMain, sName1, sName2 );
        return MixString( sTmp, sName3 );
    }
        
    static String MixString( String sMain, int nParam1 )
    {
        return MixString( sMain, 
                          Integer.toString( nParam1 ) );
    }
    
    static String MixString( String sMain, int nParam1, int nParam2 )
    {
        return MixString( sMain, 
                          Integer.toString( nParam1 ),
                          Integer.toString( nParam2 ));
    }
    
    static String MixString( String sMain, int nParam1, int nParam2, int nParam3 )
    {
        return MixString( sMain, 
                          Integer.toString( nParam1 ),
                          Integer.toString( nParam2 ),
                          Integer.toString( nParam3 ) );
    }
    
    static String MixString( String sMain, int []aParams )
    {
        String sRet = sMain;
        
        if ( aParams != null )
        {
            for ( int i=0; i<aParams.length; i++ )
                sRet = MixString( sRet, Integer.toString( aParams[i] ) );
        }
        
        return sRet;
    }
    
    static String MixString( String sMain, String []aParams )
    {
        String sRet = sMain;
        
        if ( aParams != null )
        {
            for ( int i=0; i<aParams.length; i++ )
                sRet = MixString( sRet, aParams[i] );
        }
        
        return sRet;
    }
    
    /**
     * Sprawdza czy string nie jest null i czy ma dlugosc > 0
     */
    static boolean IsStringValid( String sText )
    {
        return (( sText != null )&&( sText.length() > 0 ));
    }    
    
    static String GetTextWithoutPrefix(String sTypedText,String sPrefix)
    {
        java.util.StringTokenizer cTokenizer = 
            new java.util.StringTokenizer( sTypedText, " ", true );
        
        if ( cTokenizer.hasMoreTokens() )
        {
            //pobieramy pierwsze slowo
            String sText = cTokenizer.nextToken();
            
            if ( (sText != null) &&  
                  sText.startsWith( sPrefix ) )
            {
                int nBegin = sText.indexOf( sPrefix );
                int nEnd   = nBegin + sPrefix.length();
                //pozbywamy sie prefixa
                sText = sText.substring( nEnd );
                if ( (sText != null) && (sText.length()>0) )
                    return sText;
            }
        }
        return null;
    }        
    
    static String RemoveWord( String sText, String sWord )
    {
        if (( sText == null )||( sWord == null ))
            return null;
        boolean bRemoveBrackets = false;
        int nBegin = GameObject.TextToUpperCase(sText).indexOf( GameObject.TextToUpperCase(sWord) );
        int nEnd   = nBegin + sWord.length();
        //wywalamy spacje na koncu slowa
        if ( sText.length() > nEnd )
            nEnd++;
        if ( (nBegin > 0) &&  sText.startsWith("\"") ) 
        {
            bRemoveBrackets = true;
            nBegin --;
        }
        
        if ( nBegin < 0 )
        {
            GameObject.LogD(" substring "+sWord+" not found in "+sText+"\n");
            return null;
        }
        return sText.substring( 0, nBegin ) + sText.substring( nEnd );    
    }
    
    static String GetFirstWord( String sText )
    {
        if ( sText == null )
            return null;
        //najpierw pozbywamy sie spacji na poczatku
        int nSafety = 100;
        do {
            int nBegin = sText.indexOf( " " );
        
            if ( nBegin != 0 || nSafety-- < 0 )
                break;
            sText = sText.substring( nBegin+1 );
        } while (true);
        
        int nEndPos = -1;
        if ( sText.startsWith("\"") )
        {
            sText   = sText.substring( 1 );
            nEndPos = sText.indexOf( "\"" );
        }
        else
        {
            nEndPos = sText.indexOf( " " );
        }
        
        if ( nEndPos > 0 )
            return sText.substring( 0, nEndPos );
        
        return sText;
    }

    
    /** Zamiana czasu w sekundach na stringa 
     * postaci [HH:]MM:SS
     */
    static String Time2String(int nTime)
    {
        int nHour = nTime/3600;
        int nMin  = (nTime%3600)/60;
        int nSec  =  nTime%60;
        String sTextTime = ((nHour>0)?( nHour+":" ):"")+
                           ((nMin>9?"":"0")+nMin)+
                           ":"+
                           ((nSec>9?"":"0")+nSec);
        return sTextTime;
    }
    
    static int NegateBits(int nBits)
    {
        return 0xFFFFFFFF - nBits;
    }
    static int Int2Bit(int nValue)
    {
        if ( nValue < 0 || nValue > 31 )
        {
            GameObject.LogD(" ERRROR: Parametr "+nValue+" poza zakresem\n");
            return 0;
        }
        
        int nBit   = 0x00000001;
        while ( nValue > 0 )
        {
            nValue--;
            nBit *= 2;
        }
        return nBit;
    }
    
    static int CntBits(int nBits)
    {
        int nBitsCnt = 0;
        for ( int i=0; i<32; i++ )
        {
            if ( (nBits % 2)  != 0 )
                nBitsCnt++; 
            nBits /= 2;
        }
        return nBitsCnt;
    }

    /**
     * Kasowanie katalogu sDir wraz z wszytkimi
     * zawartymi w nim plikami i podkatalogami
     * nMaxLevel Oznacza ile maksymalnie poziomow
     * podkatalogow nas interesuje
     */
    static boolean DeleteDir( String sDir, int nMaxLevel )
    {
        return DeleteDir( sDir, 0 , nMaxLevel );
    }
    
    private static boolean DeleteDir( String sDir, int nLevel, int nMaxLevel )
    {
        if ( nLevel > nMaxLevel )
            return true;
        
        //sprawdzamy czy istnieje katalog 
        File cDir = new File( sDir );
        
        //nie ma podanego katalogu
        if ( !cDir.exists() )
        {
            //jesli nie ma katalogu glownego z profilem to
            //zwracamy false, jesli jakiegos podkatalogu
            //to true
            return nLevel > 0 ? true : false;
        }
        
        nLevel++;
                
        String []aFileNames = cDir.list();
        for ( int i = 0; i < aFileNames.length; i++ )
        {
            String sFile = sDir + "/"+ aFileNames[ i ];
                
            File cFile = new File( sFile );
            if ( ! cFile.exists() )
                continue;
            
            if ( cFile.isDirectory() )
                DeleteDir( sFile, nLevel );
            else                
                cFile.delete();
        }
        
        cDir.delete();
        return true;
    }
    
    static String Bool2YesNo(boolean bVal)
    {
        return bVal ? "Yes" : "No";
    }
    
    static String Bool2OnOff(boolean bVal)
    {
        return bVal ? "On" : "Off";
    }
    
    
    static int IPString2Int(String sIP)
    {
        int nIP = 0;
        if (sIP != null)
        {
            StreamTokenizer st = new StreamTokenizer(new StringReader(sIP));
            st.whitespaceChars(0,255);
            st.ordinaryChars('0','9');
            st.wordChars('0','9');
            try
            {
                st.nextToken();
                while (st.ttype != st.TT_EOF)
                {
                    String s = st.sval;
                    try
                    {
                        int i = Integer.parseInt(s);
                        nIP = (nIP << 8) + i;
                    }
                    catch (NumberFormatException e)
                    {
                        nIP = 0;
                    }
                    st.nextToken();
                }
            }
            catch (IOException e){}
        }
        return nIP;
    }

    static boolean CheckIfIsIPCorrect(String sIP)
    {
        boolean bCorrect = true;
        int     nCount   = 0;
        if (sIP != null)
        {
            StreamTokenizer st = new StreamTokenizer(new StringReader(sIP));
            st.whitespaceChars(0,255);
            st.ordinaryChars('0','9');
            st.wordChars('0','9');
            try
            {
                st.nextToken();
                while (bCorrect && (st.ttype != st.TT_EOF))
                {
                    String s = st.sval;
                    try
                    {
                        int i = Integer.parseInt(s);
                        if (i<0 || i>255) 
                            return false;
                    }
                    catch (NumberFormatException e)
                    {
                        bCorrect = false;    
                    }
                    nCount++;
                    st.nextToken();
                }
            }
            catch (IOException e){}
            
            return (bCorrect && (nCount == 4));
        }
        return false;
    }
    
    static String RemoveLastSign( String sText )
    {
        if ( (sText != null) && (sText.length() > 1) ) 
            sText = sText.substring( 0, sText.length() - 1 );
        return sText;
    }
    
    static String IP2String(int nIP)
    {
        return Integer.toString((nIP>>24)& 255) + "." +					
               Integer.toString((nIP>>16)& 255) + "." +					
               Integer.toString((nIP>> 8)& 255) + "." +					
               Integer.toString((nIP>> 0)& 255);
    }
    
    static boolean IsLANAddress(String sIP)
    {
        NetLog.Test(" IsLANAddress "+sIP);
        int nIP = IPString2Int( sIP );

		int nIP1 = (nIP >> 24)& 255;					
        int nIP2 = (nIP >> 16)& 255;
        
        boolean bRet = ( 
                        // 10.x.x.x
                        (nIP1 == 10)     ||										
		                // 127.x.x.x
                        (nIP1 == 127)    ||									 
                        // 172.16.x.x  - 172.31.x.x 
		                ((nIP1 == 172) && 
                        (nIP2 >= 16 ) && 
                        (nIP2 <= 31 ))  ||	
		                // 192.168.x.x
                        ((nIP1 == 192) && 
                        (nIP2 >= 168)) ) ;
        NetLog.Test(" "+nIP1+" "+nIP2+" "+bRet);
        return bRet;
    }
}
