public class NetLog
{
    static boolean bActive = false;
    
    /**
     * Klasa za pomoca ktorej wyswietlane sa logi z 
     * gry w odpowiednim trybie. Tryb czesci logow
     * mozna zmieniac podczas debugowania poszczegolnych
     * partii kodu.
     * W zamierzeniu powinny sie tu znalesc logi obslugujace
     * gracza sieciowego (osobno dla movera, drivera, itp)
     * pojazdy, invobjecty
     * Oczywiscie mozna tu dopisywac swoje typy logow
     */
    /**
     * Tryby wyswietlania logow
     */
    public final static int _MODE_NONE         = 0;
    public final static int _MODE_LOG          = 1;
    public final static int _MODE_LOGR         = 2;
    public final static int _MODE_CRASHLOG     = 3;
    
    /**
     * Rozne typy obiektow dla ktorych mozemy okreslic
     * tryb logow w danej chwili (domyslnie wszystkie
     * logi poznizszych typow sa wylaczone)
     */
    public final static int _TYPE_TEST              =  0;
    public final static int _TYPE_PLAYER            =  1;
    public final static int _TYPE_PLAYER_MORTAL     =  2;
    public final static int _TYPE_PLAYER_MOVER      =  3;
    public final static int _TYPE_PLAYER_DRIVER     =  4;
    public final static int _TYPE_PLAYER_INVENTORY  =  5;
    public final static int _TYPE_DEAD_BODY         =  6;
    public final static int _TYPE_VEHICLE           =  7;
    public final static int _TYPE_INVENTORY_OBJECT  =  8;
    public final static int _TYPE_DESTROYABLE       =  9;
    public final static int _TYPE_ASSAULT           = 10;
    public final static int _TYPE_RESPAWN_OBJ       = 11;
    public final static int _TYPE_OUTGOING_MESSAGE  = 12;
    public final static int _TYPE_INCOMING_MESSAGE  = 13;
    public final static int _TYPE_CONSOLE_COMMAND   = 14;
    public final static int _TYPE_CHAT              = 15;
    public final static int _TYPE_PROFILE           = 16;
    public final static int _TYPE_COUNTER           = 17;
    public final static int _TYPES_CNT              = 18; 
    
    /** 
     * Tablica przechowujaca aktualne tryby logow
     * dla poszczegolnych typow obiektow
     */
    private static int[] sm_aLogTypes = new int[_TYPES_CNT];

    
    private static String[] sm_aPrefixes = new String[]
                               {
                                null,           //_TYPE_TEST
                                null,           //_TYPE_PLAYER     
                                null,           //_TYPE_PLAYER_MORTAL
                                null,           //_TYPE_PLAYER_MOVER
                                null,           //_TYPE_PLAYER_DRIVER
                                null,           //_TYPE_PLAYER_INVENTORY
                                null,           //_TYPE_DEAD_BODY
                                null,           //_TYPE_VEHICLE
                                null,           //_TYPE_INVENTORY_OBJECT
                                "DESTROYABLE",  //_TYPE_DESTROYABLE
                                "ASSAULT",      //_TYPE_ASSAULT
                                "RESPAWN OBJ",  //_TYPE_RESPAWN_OBJ 
                                "MSG_OUT",      //_TYPE_OUTGOING_MESSAGE
                                "MSG_IN",       //_TYPE_INCOMING_MESSAGE
                                "CONSOLE_CMND", //_TYPE_CONSOLE_COMMAND
                                "CHAT",         //_TYPE_CHAT       
                                "NETPROFILE",   //_TYPE_PROFILE                                              
                                "NETCOUNTER "   //_TYPE_COUNTER                                              
                               };
    
    /**
     * Blad dzialania programu, ten log bedzie pojawial sie zawsze
     */
    static void Error(String sText)
    {
        GameObject.CrashLog( "NETERROR: "+sText );
    }
    
    static void Warning(String sText)
    {
        GameObject.CrashLog( "NETWARNING: "+sText );
    }
    
    static void CommandAnswer(String sText)
    {
        GameObject.LogR( ConsoleCommand.GetResultsPrefix()+" "+sText+"\n" );
    }
        
    /**
     * Metoda wolana z ModuleNet w OnCreate
     * Tu mozna zdecydowac ktore logi chcemy udostepnic
     */
    static void Init()
    {
        DisableAllTypes();
    
        //SetMode( _TYPE_TEST,              _MODE_LOG );
        //SetMode( _TYPE_PLAYER,            _MODE_LOG );
        //SetMode( _TYPE_PLAYER_MORTAL,     _MODE_LOG );
        //SetMode( _TYPE_PLAYER_MOVER,      _MODE_LOG );
        //SetMode( _TYPE_PLAYER_DRIVER,     _MODE_LOG );
        //SetMode( _TYPE_PLAYER_INVENTORY,  _MODE_LOG );
        //SetMode( _TYPE_DEAD_BODY,         _MODE_LOG );
        //SetMode( _TYPE_VEHICLE,           _MODE_LOG );
        //SetMode( _TYPE_INVENTORY_OBJECT,  _MODE_LOG );
        //SetMode( _TYPE_DESTROYABLE,       _MODE_LOG );
        //SetMode( _TYPE_ASSAULT,           _MODE_LOG );
        //SetMode( _TYPE_RESPAWN_OBJ,       _MODE_LOG );       
        //SetMode( _TYPE_OUTGOING_MESSAGE,  _MODE_LOG );
        //SetMode( _TYPE_INCOMING_MESSAGE,  _MODE_LOG );
        //SetMode( _TYPE_CONSOLE_COMMAND,   _MODE_LOG );
        //SetMode( _TYPE_CHAT,              _MODE_LOG );
        //SetMode( _TYPE_PROFILE,           _MODE_LOG );
        //SetMode( _TYPE_COUNTER,           _MODE_LOG );
            
        //SetMode( _TYPE_TEST,              _MODE_LOGR );
        //SetMode( _TYPE_PLAYER,            _MODE_LOGR );
        //SetMode( _TYPE_PLAYER_MORTAL,     _MODE_LOGR );
        //SetMode( _TYPE_PLAYER_MOVER,      _MODE_LOGR );
        //SetMode( _TYPE_PLAYER_DRIVER,     _MODE_LOGR );
        //SetMode( _TYPE_PLAYER_INVENTORY,  _MODE_LOGR );
        //SetMode( _TYPE_DEAD_BODY,         _MODE_LOGR );
        //SetMode( _TYPE_VEHICLE,           _MODE_LOGR );
        //SetMode( _TYPE_INVENTORY_OBJECT,  _MODE_LOGR );
        //SetMode( _TYPE_DESTROYABLE,       _MODE_LOGR );
        //SetMode( _TYPE_ASSAULT,           _MODE_LOGR );      
        //SetMode( _TYPE_RESPAWN_OBJ,       _MODE_LOGR );       
        //SetMode( _TYPE_OUTGOING_MESSAGE,  _MODE_LOGR );
        //SetMode( _TYPE_INCOMING_MESSAGE,  _MODE_LOGR );
        //SetMode( _TYPE_CONSOLE_COMMAND,   _MODE_LOGR );
        //SetMode( _TYPE_CHAT,              _MODE_LOGR );
        //SetMode( _TYPE_PROFILE,           _MODE_LOGR );
        //SetMode( _TYPE_COUNTER,           _MODE_LOGR );
        
        SetMode( _TYPE_TEST,              _MODE_CRASHLOG );
        //SetMode( _TYPE_PLAYER,            _MODE_CRASHLOG );
        //SetMode( _TYPE_PLAYER_MORTAL,     _MODE_CRASHLOG );
        //SetMode( _TYPE_PLAYER_MOVER,      _MODE_CRASHLOG );
        //SetMode( _TYPE_PLAYER_DRIVER,     _MODE_CRASHLOG );
        //SetMode( _TYPE_PLAYER_INVENTORY,  _MODE_CRASHLOG );
        //SetMode( _TYPE_DEAD_BODY,         _MODE_CRASHLOG );
        //SetMode( _TYPE_VEHICLE,           _MODE_CRASHLOG );
        //SetMode( _TYPE_INVENTORY_OBJECT,  _MODE_CRASHLOG );
        //SetMode( _TYPE_DESTROYABLE,       _MODE_CRASHLOG );
        //SetMode( _TYPE_ASSAULT,           _MODE_CRASHLOG );        
        //SetMode( _TYPE_RESPAWN_OBJ,       _MODE_CRASHLOG );       
        //SetMode( _TYPE_OUTGOING_MESSAGE,  _MODE_CRASHLOG );
        //SetMode( _TYPE_INCOMING_MESSAGE,  _MODE_CRASHLOG );
        //SetMode( _TYPE_CONSOLE_COMMAND,   _MODE_CRASHLOG );
        SetMode( _TYPE_CHAT,              _MODE_CRASHLOG );
        //SetMode( _TYPE_PROFILE,           _MODE_CRASHLOG );
        //SetMode( _TYPE_COUNTER,           _MODE_CRASHLOG );
        
        if ( ! bActive )
            DisableAllTypes();
    }
    
    /**
     * Wylacza wszystkie ponizsze logi (poszczegolnych typow)
     * Nie zmienia dzialania metod Error i Warning.
     */
    static void DisableAllTypes()
    {
        if ( sm_aLogTypes != null )
            for ( int i=0; i<sm_aLogTypes.length; ++i )
                sm_aLogTypes[ i ] = _MODE_NONE;
    }
    
    
    /** Logi ogolne, wstawiane podczas testow */
    static void Test(String sText){ LogType( sText, _TYPE_TEST ); }
    static void Test(String sText,GameObject cObj){ LogType( sText, _TYPE_TEST, cObj ); }
    
    /** Logi gracza sieciowego (ogolnie) */
    static void Player(String sText){ LogType( sText, _TYPE_PLAYER ); }
    static void Player(String sText,GameObject cObj){ LogType( sText, _TYPE_PLAYER, cObj ); }
    
    /** Logi gracza sieciowego movera (PlayerNetBaseMover)*/
    static void PlayerMortal(String sText){ LogType( sText, _TYPE_PLAYER_MORTAL ); }
    static void PlayerMortal(String sText,GameObject cObj){ LogType( sText, _TYPE_PLAYER_MORTAL, cObj ); }
    
    /** Logi gracza sieciowego movera (PlayerNetBaseMover)*/
    static void PlayerMover(String sText){ LogType( sText, _TYPE_PLAYER_MOVER ); }
    static void PlayerMover(String sText,GameObject cObj){ LogType( sText, _TYPE_PLAYER_MOVER, cObj ); }
    
    /** Logi gracza sieciowego drivera (PlayerNetBaseDriver)*/
    static void PlayerDriver(String sText){ LogType( sText, _TYPE_PLAYER_DRIVER ); }
    static void PlayerDriver(String sText,GameObject cObj){ LogType( sText, _TYPE_PLAYER_DRIVER, cObj ); }
    
    /** Logi gracza sieciowego inventory (PlayerNetBaseInventory)*/
    static void PlayerInventory(String sText){ LogType( sText, _TYPE_PLAYER_INVENTORY ); }
    static void PlayerInventory(String sText,GameObject cObj){ LogType( sText, _TYPE_PLAYER_INVENTORY, cObj ); }
    
    /** Logi trupka (DeadBody) */
    static void DeadBody(String sText){ LogType( sText, _TYPE_DEAD_BODY ); }
    static void DeadBody(String sText,GameObject cObj){ LogType( sText, _TYPE_DEAD_BODY, cObj ); }
    
    /** Logi pojazdow (Vehicle) */
    static void Vehicle(String sText){ LogType( sText, _TYPE_VEHICLE ); }
    static void Vehicle(String sText,GameObject cObj){ LogType( sText, _TYPE_VEHICLE, cObj ); }
    
    /** Logi obiektow inventory */
    static void InvObj(String sText){ LogType( sText, _TYPE_INVENTORY_OBJECT ); }
    static void InvObj(String sText,GameObject cObj){ LogType( sText, _TYPE_INVENTORY_OBJECT, cObj ); }
    
    /** Logi obiektow destroyable */
    static void Destroyable(String sText){ LogType( sText, _TYPE_DESTROYABLE ); }
    static void Destroyable(String sText,GameObject cObj){ LogType( sText, _TYPE_DESTROYABLE, cObj ); }
    
    /** Logi do trybu Assault */
    static void Assault(String sText){ LogType( sText, _TYPE_ASSAULT ); }
    static void Assault(String sText,GameObject cObj){ LogType( sText, _TYPE_ASSAULT, cObj ); }
    
    /** Logi do systemu respawnow objectow */
    static void RespawnObj(String sText){ LogType( sText, _TYPE_RESPAWN_OBJ ); }
    static void RespawnObj(String sText,GameObject cObj){ LogType( sText, _TYPE_RESPAWN_OBJ, cObj ); }
        
    /** Logi messagey wychodzacych  */
    static void MsgOut(String sText){ LogType( sText, _TYPE_OUTGOING_MESSAGE ); }
    static void MsgOut(String sText,GameObject cObj){ LogType( sText, _TYPE_OUTGOING_MESSAGE, cObj ); }

    /** Logi messagey przychodzacych  */
    static void MsgIn(String sText){ LogType( sText, _TYPE_INCOMING_MESSAGE ); }
    static void MsgIn(String sText,GameObject cObj){ LogType( sText, _TYPE_INCOMING_MESSAGE, cObj ); }
    
    /** Logi dotyczace komend z konsoli  */
    static void ConsoleCommand(String sText){ LogType( sText, _TYPE_CONSOLE_COMMAND ); }
    static void ConsoleCommand(String sText,GameObject cObj){ LogType( sText, _TYPE_CONSOLE_COMMAND, cObj ); }
    
    /** Logi dotyczace chata in game  */
    static void Chat(String sText){ LogType( sText, _TYPE_CHAT ); }
    static void Chat(String sText,GameObject cObj){ LogType( sText, _TYPE_CHAT, cObj ); }
    
    /** Logi licznikow zegarowych  */
    static void Profile(String sText){ LogType( sText, _TYPE_PROFILE ); }
    static void Profile(String sText,GameObject cObj){ LogType( sText, _TYPE_PROFILE, cObj ); }
        
    /** Logi licznikow zmian stanow  */
    static void Counter(String sText){ LogType( sText, _TYPE_COUNTER ); }
    static void Counter(String sText,GameObject cObj){ LogType( sText, _TYPE_COUNTER, cObj ); }
    
    /**
     * Ustawia tryb logow dla podanego typu
     */
    static void SetMode(int nType,int nMode)
    { 
        if ( sm_aLogTypes == null )
            return;
        if ( (nType >= 0) && (nType < sm_aLogTypes.length) )
            sm_aLogTypes[ nType ] = nMode;
    }
    
    /**
     * Pobiera tryb logow dla podanego typu obiektu
     */
    static int GetMode(int nType)
    { 
        if ( sm_aLogTypes == null )
            return _MODE_NONE;
        if ( (nType >= 0) && (nType < sm_aLogTypes.length) )
            return sm_aLogTypes[ nType ];
        return _MODE_NONE;
    }

    /**
     * Pobiera prefix logow dla podanego typu obiektu
     */
    static String GetPrefix(int nType)
    { 
        if ( sm_aPrefixes == null )
            return null;
        if ( (nType >= 0) && (nType < sm_aPrefixes.length) )
            return sm_aPrefixes[ nType ];
        return null;
    }
    
    
    /**
     * Sprawdza czy dla podanego typu obiektu
     * sa aktywne logi (jakiekolwiek)
     */
    static boolean IsEnabled(int nType)
    { 
        return ( GetMode( nType ) != _MODE_NONE ); 
    }

    
    /**
     * Prywatne metody wykonawcze
     */

    /**
     * Logowanie tesktu dla podanego typu obiektu
     * wyciagany jest tryb dla podanego typu i
     * w tym trybie odbywa sie log
     */
    private static void LogType(String sText,int nType,GameObject cObj)
    {
        int nMode = GetMode( nType );
        //jesli dany typ logow nie jest aktywny to spadamy
        if ( nMode == _MODE_NONE )
            return;

        if ( sText == null )
            sText = "";
            
        //jezeli dla danego typu zdefiniowany jest prefix, to doklejamu do na przod
        String sPrefix = GetPrefix( nType );
        if ( sPrefix != null )
             sText = sPrefix + " " + sText;
        
        //jezeli podany jest obiekt, to wklejamy jego info na koncu
        if ( cObj != null )
        {
            //jezeli na koncu sText jest znaczek "\n" to wyciac
            if ( sText.endsWith("\n") )
                sText = sText.substring( 0, sText.length()-1 );
            
            sText = sText + " " + cObj.GetNetInfo();
        }
        
        //jesli mamy co wyswietlic, to bedziemy wyswietlac
        if ( sText.length() > 0 )
        {
            //jezeli nie ma na koncu "\n" to dodac
            if ( ! sText.endsWith("\n") )
                sText = sText + "\n";    
            
            LogMode( sText, nMode );
        }
    }
    private static void LogType(String sText,int nType)
    {
        LogType( sText, nType, null );
    }
    
    private static void LogMode(String sText,int nMode)
    {
        switch ( nMode )
        {
        case _MODE_LOG:
            GameObject.Log( sText );
            break;            
        case _MODE_LOGR:
            GameObject.LogR( sText );
            break;
        case _MODE_CRASHLOG:
            GameObject.CrashLog( sText );
            break;
        }
    }
    
    
    
    
}
