public class NetProfiler extends GameObject
{
    static boolean sm_bLog = false;
    void SetLog( boolean bEnable ){ sm_bLog = bEnable; }
                        
    final public static int _NO_PROFILE                            =  0;
    final public static int _SERVER_APPLY_CLIENT_MOVE              =  1;
    final public static int _SERVER_APPLY_CLIENT_MOVE_RESIMULATE   =  2;
    final public static int _SERVER_APPLY_CLIENT_MOVE_APPLY        =  3;
    final public static int _SERVER_APPLY_CLIENT_MOVE_APPLY_MOTION =  4;
    final public static int _SERVER_APPLY_CLIENT_MOVE_APPLY_STATE  =  5;
    final public static int _SERVER_APPLY_CLIENT_MOVE_ADJUST       =  6;
    final public static int _SERVER_APPLY_CLIENT_MOVE_END          =  7;
    final public static int _PLAYER_UPDATE_STATE                   =  8;
    final public static int _PLAYERNET_UPDATE_STATE                =  9;
    final public static int _AIM_STATE_SET                         = 10;
    final public static int _AIM_STATE_ON_ENTER                    = 11;
    final public static int _CNT                                   = 12;
    
    int m_nCurrent = _AIM_STATE_SET;
     
    
    static NetProfiler m_cSingleton = null;
    
    void OnCreate()
    {
        if ( m_cSingleton == null )
            m_cSingleton = this;
    }
    
    void OnDestroy()
    {
        Stop();
        if ( m_cSingleton == this )
            m_cSingleton = null;
    }
    
    void Set(int i)
    {
        if ( m_nCurrent != i )
        {
            if ( m_bBegin )
                EndDo( m_nCurrent );
            m_nCurrent   = i;
        }
    }
    
    void Stop()
    {
        Set( _NO_PROFILE );
    }
    
    
    boolean m_bBegin = false;
        
    void BeginDo(int i)
    {
        if ( m_nCurrent == i )
        {
            ProfileNetJavaBegin();
            m_bBegin = true;
        }
    }
    
    void EndDo(int i)
    {
        if ( m_nCurrent == i )
        {
            ProfileNetJavaEnd();
            m_bBegin = false;
        }
    }
    
    String SetNext()
    {
        int i = m_nCurrent + 1;
        if ( i >= _CNT || GetName( i ) == null )
            i = 0;
        Set( i );
        return GetCurrentName();
    }
    
    int GetCurrent(){ return m_nCurrent; }
    
    String GetCurrentName(){ return GetName( m_nCurrent ); }
    
    
    static void Begin(int i)
    {
        if ( m_cSingleton != null )
            m_cSingleton.BeginDo( i );
    }
    
    static void End(int i)
    {
        if ( m_cSingleton != null )
            m_cSingleton.EndDo( i );
    }
    
    static String GetName(int nVal)
    {
        return GameObject.GetFieldNameForIntValue( NetProfiler.class, 
                                                   nVal,
                                                   null );
    }
    
    static long sm_nStartTime = 0;
    static long sm_nLastTime = 0;
    
    static long sm_nStartMemory = 0;
    static long sm_nLastMemory = 0;
    
    static void Start()
    {
        Start("");
    }
    
    static int GetMemoryUsage()
    {
        if ( m_cSingleton != null )
             return (int)m_cSingleton.GetUsedMemSize();
        return -1;
    }
    
    static String GetMemory(long nMem)
    {
        if ( nMem < 1024 )
            return ""+nMem+" B";
        else if ( nMem < 1024 * 1024 )
            return ""+((float)nMem/1024)+" kB";
        return ""+((float)nMem/(1024*1024))+" MB";
    }
    
    static void Start(String sText)
    {
        sm_nStartTime =
        sm_nLastTime  = java.lang.System.currentTimeMillis();
        sm_nStartMemory =
        sm_nLastMemory  = GetMemoryUsage();
        if ( sm_bLog )
            CrashLog("NETPROFILER start "+sText+
                     " mem:"+GetMemoryUsage()+"\n");
    }
     
    static void Delta()
    {
        Delta("");
    }
    static void Delta(String sText)
    {
        long nLastTime    = sm_nLastTime;
        sm_nLastTime      = java.lang.System.currentTimeMillis();
        long nDeltaTime   = sm_nLastTime - nLastTime;
        long nLastMemory  = sm_nLastMemory;
        sm_nLastMemory    = GetMemoryUsage();
        long nDeltaMemory = sm_nLastMemory - nLastMemory;
        if ( sm_bLog )
            CrashLog("NETPROFILER delta "+sText+
                     " time:"+nDeltaTime+
                     " mem: "+GetMemory(nDeltaMemory)+"\n");
    }
    
    static void CheckTime()
    {
        CheckTime("");
    }
    static void CheckTime(String sText)
    {
        long nLastTime   = sm_nStartTime;
        sm_nLastTime     = java.lang.System.currentTimeMillis();
        long nDeltaTime  = sm_nLastTime - nLastTime;
        long nLastMemory = sm_nStartMemory;
        sm_nLastMemory   = GetMemoryUsage();
        long nDeltaMemory= sm_nLastMemory - nLastMemory;
        if ( sm_bLog )
             CrashLog("NETPROFILER check "+sText+
                      " time:"+nDeltaTime+
                      " mem: "+GetMemory(nDeltaMemory)+"\n");
    }
}
