/** Klasa przechowujaca liste obiektow
 */
public class ObjectsList
{
    /** Wektor obiektow, TODO: zmienic java.util.Vector na cos "lepszego"
     */
    private java.util.Vector m_aList = new java.util.Vector();
    
    /** Czysci liste
     */
    void Clear()
    {
        RemoveAll();
    }
    
    /** Dodaj element do listy
     */
    void Add(Object cObj)
    {
        m_aList.addElement( cObj );
    }
    
    void InsertAt(Object cObj,int nIndex)
    {
        m_aList.insertElementAt( cObj, nIndex );
    }
    
    /** Usun element do listy
     */
    void Remove(Object cObj)
    {
        m_aList.removeElement( cObj );
    }
    
    /**
     * Czysci liste obiektow z listy
     */
    void RemoveAll()
    {
        m_aList.removeAllElements();
    }
        
    /**
     * Czysci liste obiektow z listy kasujac przy okazji 
     * wszystkie GameObjecty
     */
    void Destroy()
    {
        for ( int i=0; i<m_aList.size(); i++ )
        {
            if ( m_aList.elementAt( i ) instanceof GameObject )
            {
                GameObject cObj = (GameObject)m_aList.elementAt( i );
                cObj.delete();
            }
        }
        RemoveAll();
    }
    
    /** pobranie dlugosci listy
     */
    int GetSize()
    {
        return m_aList.size();
    }
    
    /** pobranie elementu po indeksie
     */
    Object GetObjectAt(int nIndex)
    {
        if ( nIndex >= 0 && nIndex < m_aList.size() )
            return (Object)m_aList.elementAt( nIndex );
        return null;
    }
    
    Object GetObjectByIndex(int nIndex)
    {
        NetLog.Test( " GetObjectByIndex depreciated !\n");
        return GetObjectAt( nIndex );
    }
    
    /**
     * Sprawdzenie indexu (czyli de facto aktualnej pozycji) 
     */
    int IndexOf(Object cObj)
    {
        return m_aList.indexOf( cObj );
    }

    /** pobranie pierwszego elementu o podanej klasie
     */
    Object FindFirstObjectOfClass(String sClassName)
    {
        if ( sClassName != null )
            for ( int i=0; i<m_aList.size(); i++ )
            {
                if ( !(m_aList.elementAt( i ) instanceof Object) )
                    continue;
                    
                Object cObj = (Object)m_aList.elementAt( i );
                if ( sClassName.compareTo( cObj.getClass().getName() ) == 0 )
                    return cObj;
            }
        return null;
    }
        
    /** pobranie elementu po identyfikatorze sieciowych
     * Oczywiste jest, ze szuka tylko wsrod GameObjectow
     * wiec zwraca takze GameObjecta
     */
    GameObject GetObjectByNetId(int nNetId)
    {
        for ( int i=0; i<m_aList.size(); i++ )
        {
            if ( !(m_aList.elementAt( i ) instanceof GameObject) )
                continue;
            
            GameObject cObj = (GameObject)m_aList.elementAt( i );
            
            if ( cObj.GetNetId() == nNetId )
                return cObj;
        }
        
        return null;
    }
    
    /** Sprawdzenie czy obiekt znajduje sie na liscie
     */
    boolean IsOnList( Object cObj )
    { 
        return ((cObj != null) && ( m_aList.indexOf( cObj ) > -1 ));
    }
    
    /**
     * Metoda pomocnicza do testow
     */
    void LogList(String sText)
    {
        GameObject.CrashLog("-List "+getClass().getName()+" state "+sText+"\n");
        
        for (int i=0; i<m_aList.size(); i++ )
        {
            if ( m_aList.elementAt( i ) instanceof GameObject )
            {
                GameObject cObj = (GameObject)m_aList.elementAt( i );
                GameObject.CrashLog(""+i+" "+ cObj.getClass().getName()+" id:"+cObj.GetNetId()+"\n");
            }
            else if ( m_aList.elementAt( i ) instanceof Object )
            {
                Object cObj = (Object)m_aList.elementAt( i );
                GameObject.CrashLog(""+i+" "+ cObj.getClass().getName()+"\n");
            }
        }
        GameObject.CrashLog("----------\n");
    }
}
