public class NewAIAnimal extends NewAI
{
    public float fSightRange = 2000;//#NEWAIANIMAL;AI sight range in centimeters
    public float fSightRangeRecognitionMult = 0.5f;//#NEWAIANIMAL;fSightRangeRecognitionMult * fSightRange = distance of recognizing object as enemy (if it is enemy)
    public float fSightAngle = 230;//#NEWAIANIMAL;AI sight angle in degrees
    public float fMaxEnemyRecognitionTime = 3.f;//#NEWAIANIMAL;Time to recognize enemy when distance is fSightRange
    
    public float fMaxEnemyKeepingDistance = 2000;//#NEWAIANIMAL;Max dist to keep object as active enemy
    
    public float fBiteDamage = 100;
    public float fBiteAttackRange; // odleglosc od celu, z jakiej zwierzak powinien gryzc
    public float fJawSize; // 'rozmiar szczeki'
    public String sJawElementName; // nazwa elementy bedacego szczeka
    int nJawElement; // id elementu szczeki
    float fBiteAnimDelay; // opoznienie gryzienia zalezne od animacji
    
    public String sDeathSound = null; // dzwiek odpalany po smierci
    public String sHitSound = null; // ryk po postrzale (gdy odpala sie HitReaction)
    public String sStepSoundNormal = null; // dzwiek krokow przy chodzeniu
    public String sStepSoundAttack = null; // dzwiek krokow przy galopie w czasie ataku
    public String sAttackSound = null; // dzwiek ataku
    
    public float[] m_aAggressiveMotionVelocity;
    public float[] m_aAggressiveMotionAngularVelocity;
        
    public boolean bAggressive = false;

    float m_fLastHitReactionTime = AIController._INIT_TIME; // kiedy ostatnio zwierzak zareagowal na postrzal
    float _MIN_BTW_HITS_REACTION_TIME = 10; // minimalny odstep czasu pomiedzy reakcjami na postrzal
         
    boolean bIsBiting;
    float m_fStartBitingTime;
    float m_fLastBiteTime = AIController._INIT_TIME;
    float m_fTimeBtwBites = 1;
    
    boolean m_bPlayAnimDisabled = false;
    
    int METHOD_StepDone = 0;
    
    NewAIAnimal()
    {
        m_sControllerClassName = AIControllerAnimal.class.getName();
        cAIWeapon = null;
        sDefaultItems = null;
        m_fMinTurnAngleToUpdateMotion = 30;
        m_aMotionVelocityStrafeMultiplier = new float[] {1, 1, 1, 1, 1, 1};
        bUsePhysicsToDeathFall = false;
        bHitReactionAllowed = true;
        bCanTurnWhileMoving = false;
        bBlobHasFixedOrientation = false;
    }
    
    
    public void OnCreate()
    {
        super.OnCreate();
        nJawElement = GetElementID(sJawElementName);
        //SetFlag(EFlags._FXPARTICLE_COLLISION);
        METHOD_StepDone = RegisterCallMethod("StepDone");
    }
    
    /////////////////////////////////////////////////////////////////////////////////////////////////////////
    
    public float UpdateMotion()
    {
        DisableCallMethod(METHOD_CallUpdateMotion);
        float fTime = 0;
        
        if (!IsFrozen() && !IsDead() && 
            (!m_Motion.IsEqual(m_OldMotion) || !IsPlaying("")))
        {
            int nAnimToPlay = -1;
            if (m_Motion.IsMoving())
            {
                if (m_Motion.iMoveZ != 0 ||
                    m_Motion.iMoveX != 0)
                {
                    if (m_Motion.GetSpeed() == MotionState.SPEED_RUN)
                        nAnimToPlay = AIAnimationsAnimal.A_AGGRESION_RUN;
                    else
                        nAnimToPlay = bAggressive ? AIAnimationsAnimal.A_AGGRESION_WALK :
                                                    AIAnimationsAnimal.A_WALK;
                }
                else if (m_Motion.iTurn > 0)
                    nAnimToPlay = bAggressive ? AIAnimationsAnimal.A_AGGRESION_WALK_LEFT :
                                                AIAnimationsAnimal.A_WALK_LEFT;
                else if (m_Motion.iTurn < 0)
                    nAnimToPlay = bAggressive ? AIAnimationsAnimal.A_AGGRESION_WALK_RIGHT :
                                                    AIAnimationsAnimal.A_WALK_RIGHT;
            }
            else
                nAnimToPlay = bAggressive ? AIAnimationsAnimal.A_AGGRESION_IDLE :
                                            AIAnimationsAnimal.A_IDLE;

            if (nAnimToPlay >= 0)
            {
                PlayAIAnimLoop( nAnimToPlay );
                if (m_Motion.IsMoving())
                {
                    if (m_OldMotion.iMoveX != m_Motion.iMoveX ||
                        m_OldMotion.iMoveZ != m_Motion.iMoveZ ||
                        m_OldMotion.GetSpeed() != m_Motion.GetSpeed() ||
                        m_OldMotion.iTurn != m_Motion.iTurn)
                    {
                        float fAnimLength = GetAIAnimLength(nAnimToPlay);
                        if (fAnimLength > 0.1f)
                        {
                            CallMethodOnceIn(METHOD_StepDone, 0);
                            CallMethodEvery(METHOD_StepDone, fAnimLength / 2.f);
                        }
                    }
                }
                else
                    DisableCallMethod(METHOD_StepDone);
            }
            else
                CrashLog("[NewAIAnimal.UpdateMotion] nAnimToPlay == -1!!!\n");
            
            m_OldMotion = new AIMotionState(m_Motion);
            m_Controller.MotionStateChanged();
        }
        return fTime;
    }
    

    void StepDone()
    {
        if(!SoundEmitter.bListenerInsideBuilding)
        {
            if (m_Motion.GetSpeed() == MotionState.SPEED_RUN)
            {
                if (sStepSoundAttack != null)
                    PlaySound(sStepSoundAttack);
            }
            else
                if (sStepSoundNormal != null)
                    PlaySound(sStepSoundNormal);
        }
    }    

    
    /** Zmiana predkosci poruszania w zaleznosci od stanu zwierzaka
     */
    float GetSpeedValueForActualMotion()
    {
        int iSpeed = m_Motion.GetSpeed();
        if (bAggressive || iSpeed == MotionState.SPEED_RUN)
            return m_aAggressiveMotionVelocity[iSpeed];
        else            
            return m_aMotionVelocity[iSpeed];
    }
    
    float GetAngSpeedForMotion(AIMotionState motion)
    {
        int iSpeed = motion.GetSpeed();
        if (bAggressive || iSpeed == MotionState.SPEED_RUN)
            return m_aAggressiveMotionAngularVelocity[iSpeed];
        else            
            return m_aMotionAngularVelocity[iSpeed];
    }
    

    private Vector m_vUTODir = new Vector();
    protected void UpdateTrackingObject()
    {
        m_TrackedObject.GetPosition(m_vUTODir);
        m_vUTODir.Sub(GetPositionVectorVolatile());

        if (m_Motion.IsMovingLinear())
        {
            TryToVerticalize();
            SetMaxAngSpeed(GetAngSpeedForMotion(m_Motion));
            SetFacingDestDir(m_vUTODir);

        }
        else
            Turn(m_vUTODir);
    }

    /////////////////////////////////////////////////////////////////////////////////////////////////////////

    public void OnCollisionFullInfo(ControlObject Col, Vector vPoint, Vector vNormal)
    {
        super.OnCollisionFullInfo(Col, vPoint, vNormal);
        if (Col instanceof Actor)
        {
            if (m_ActualMotion.IsMovingLinear())
            {
                m_bLastGoToSuccessfull = false;
                GoToFinished();
            }
        }
    }
    
    /////////////////////////////////////////////////////////////////////////////////////////////////////////
	public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
	{
        super.OnTakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
		
        Bleed(fDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
	}
    /////////////////////////////////////////////////////////////////////////////////////////////////////////
    
    public void HitReaction(Vector vHitDir)
    {
        float fTime = GetTime();
        if (!IsFrozen() && !IsDead() && 
            !m_bPlayAnimDisabled &&
            AIController.TimePassed(m_fLastHitReactionTime, _MIN_BTW_HITS_REACTION_TIME, fTime))
        {
            m_fLastHitReactionTime = fTime;
            // jesli jeszcze nie przymrozil kontrolera
            if (!m_Controller.IsFrozen())
                m_Controller.Freeze();

            if (m_Motion.IsMoving())
                StopGoTo();

            // odswiez animacje (force - StopAnim)
            StopAIAnim(true); // true - powiadom kontroler o przerwaniu jego animacji
            CallUpdateMotion();
            // odegraj animacje postrzalu
            m_Anims.Play(AIAnimationsAnimal.A_HIT);
            
            if (sHitSound != null)
                PlaySound(sHitSound);
            
            // zawolaj dalsza czesc obslugi postrzalu
            DisableCallMethod("HitReactionEnd");
            CallMethodIn("HitReactionEnd", GetAIAnimLength(AIAnimationsAnimal.A_HIT));
        }
    }
    
    public void HitReactionEnd()
    {
        StopAIAnim(false); // bez powiadamiania kontrolera - bo nie powinien byl dodac bnowych taskow po freeze
        CallUpdateMotion();
        m_Controller.Unfreeze();
        // przegenerowanie scenariuszy
        m_Controller.RequestEvent(AIEvents._EV_PAIN, true);
    }

    /////////////////////////////////////////////////////////////////////////////////////////////////////////

    public void Die()
    {
        if (!IsDead())
        {
            super.Die();
            if (sDeathSound != null)
                PlaySound(sDeathSound);
            DisableCallMethod(METHOD_StepDone);

            SetCollType(ECollFlags.OBJCOL_TYPE_PERFACEOBJECT);

            UpdatePathMap(false);
            PlayAIAnim(AIAnimationsAnimal.A_DEATH);
            m_bPlayAnimDisabled = true;
        }
    }
    
    public void PlayAIAnim(int nID, int nTimes)
    {
        if (!m_bPlayAnimDisabled)
            super.PlayAIAnim(nID, nTimes);
    }
        
    public void PlayAIAnimLoop(int nID)
    {
        if (!m_bPlayAnimDisabled)
            super.PlayAIAnimLoop(nID);
    }
    
    public void StopAnim(String elem)
    {
        if (!m_bPlayAnimDisabled)
            super.StopAnim(elem);
    }
                         

    /////////////////////////////////////////////////////////////////////////////////////////////////////////
    
    public boolean IsActive(ControlObject Activator)
    {
        return false;
    }

    /////////////////////////////////////////////////////////////////////////////////////////////////////////
    
    public Vector GetLookFromPoint()
    {
        return GetBoneJointPos(EBones._HEAD);
    }


    public Vector GetLookDir()
    {
        return GetBonePerpVector(EBones._HEAD);
    }

    /////////////////////////////////////////////////////////////////////////////////////////////////////////

    
    /** Rozpoczecie / zakonczenie 'gryzienia' przeciwnikow
     *  bStart - znacznik czy zaczac
     *  fDelay - opoznienie rozpoczecia (dziala tylko dla bStart == true)
     */
    public void StartBitig(boolean bStart, float fDelay)
    {
        bIsBiting = bStart;
        m_fStartBitingTime = GetTime() + fDelay;
    }
    

    public void OnFrame()
    {
        super.OnFrame();
        if (bIsBiting && 
            !IsDead() && !IsFrozen() &&
            GetTime() >= m_fStartBitingTime)
        {
            TryToBiteActor();
        }
    }
    
    
    private static Vector m_vBiteMinExt = new Vector(),
        m_vBiteMaxExt = new Vector(), 
        m_vJawOrigin = new Vector();
    void TryToBiteActor()
    {
        float fTime = GetTime();
        if (AIController.TimePassed(m_fLastBiteTime, m_fTimeBtwBites, fTime))
        {
            m_fLastBiteTime = fTime;
            if (sAttackSound != null)
                PlaySound(sAttackSound);

            if (nJawElement > -1)
            {
                GetElementPos(nJawElement, m_vJawOrigin);
                m_vBiteMinExt.Set(m_vJawOrigin);
                m_vBiteMaxExt.Set(m_vJawOrigin);

                m_vBiteMinExt.fX -= fJawSize;
                m_vBiteMinExt.fY -= fJawSize;
                m_vBiteMinExt.fZ -= fJawSize;

                m_vBiteMaxExt.fX += fJawSize;
                m_vBiteMaxExt.fY += fJawSize;
                m_vBiteMaxExt.fZ += fJawSize;
                
                ControlObject[] aObjs = GetObjectsInExtents(m_vBiteMinExt, m_vBiteMaxExt);
                if (aObjs != null)
                {
                    for (int i = 0; i < aObjs.length; i++)
                    {
                        GetForwardVector(m_vBiteMinExt);
                        if (aObjs[i] != this &&
                            aObjs[i] instanceof Pawn)
                        {
                            aObjs[i].TakeDamage(fBiteDamage, fBiteDamage, 
                                                this,
                                                m_vJawOrigin, m_vBiteMinExt,
                                                EBones._NON_BONE, EnumDamageType._KNIFE);
                        }
                    }
                }
            }
        }
    }

    
    /////////////////////////////////////////////////////////////////////////////
    // DEBUG'N'TEST
    // 
    public void CM_Move(int iMoveZ, int iMoveX)
    {
        m_Motion.iMoveZ = (byte)iMoveZ;
        m_Motion.iMoveX = (byte)iMoveX;
        UpdateMotion();
    }
    
    public void CM_Rotate(int iTurn)
    {
        m_Motion.iTurn = (byte)iTurn;
        UpdateMotion();
    }
    
    public void CM_Speed(int iSpeed)
    {
        m_Motion.SetSpeed((byte)iSpeed);
        UpdateMotion();
    }
    
    public void track()
    {
        Vector vDir = ((ChromeModuleSingle)GetModule()).MainPlayer.GetPosition();
        vDir.Sub(GetPosition());
        Turn(vDir);
    }
    
    public void go()
    {
        GoToPosition(((ChromeModuleSingle)GetModule()).MainPlayer.GetPosition());
    }
    
    public void resetspeed()
    {
        SetSpeedDir(GetForwardVector());
        SetSpeedValue(0);
    }

    public void spd(float speed)
    {
        for (int i = 0; i < m_aMotionVelocity.length; i++)
        {
            m_aMotionVelocity[i] = speed;
            m_aAggressiveMotionVelocity[i] = speed;
        }
    }
    
    
    //*********************************************************
    //                      SaveGame
    //*********************************************************
    
    
    public void SGLoadChunk(FileChunk cParentFC)
    {	
        FileChunk.Log("[NewAIAnimal.SGLoadChunk]\n");
        
        FileChunk cFC = GameObject.LoadChunk(cParentFC);   
        
        if (cFC.GetID() == ESGChunksChrome._CHK_NEWAI_ANIMAL)
        {
            super.SGLoadChunk(cFC);

            bAggressive = cFC.LoadBool();
            m_fLastHitReactionTime = cFC.LoadFloat();
            bIsBiting = cFC.LoadBool();
            m_fStartBitingTime = cFC.LoadFloat();
            m_fLastBiteTime = cFC.LoadFloat();
            m_bPlayAnimDisabled = cFC.LoadBool();
        }
        
        cFC.delete();
    }
    

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[NewAIAnimal.SGSaveChunk]\n");
        
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_NEWAI_ANIMAL, cFCParent);
        
        super.SGSaveChunk(cFC);

        cFC.SaveBool(bAggressive);
        cFC.SaveFloat(m_fLastHitReactionTime);
        cFC.SaveBool(bIsBiting);
        cFC.SaveFloat(m_fStartBitingTime);
        cFC.SaveFloat(m_fLastBiteTime);
        cFC.SaveBool(m_bPlayAnimDisabled);

        cFC.delete(); 
    }				
    
    public void SGUpdate()
    {
        FileChunk.Log("[NewAIAnimal.SGUpdate]\n");
        super.SGUpdate();
    }

}
