public class AIControllerWalkerHeavy extends AIControllerWalker
{
    static float _TIME_BTW_HEAVY_WEAPON_USE = 10f;
    static float _RND_TIME_BTW_HEAVY_WEAPON_USE = 10f;
    float m_fNextHeavyUseTime = _INIT_TIME;

    /** decyzja, czy strzelac czy nie na podstawie parametrow broni i czy uzywac broni ciezkiej */
    public void UpdateShootDecision()
    {
        if (!m_bIsShooting)
        {
            float fTime = GetTime();
            
            if (fTime > m_fNextHeavyUseTime)
            {
                Scenario scenario = GetCurrScenario();
                if ( (scenario != null) &&
                     (scenario.GetID() == StandShoot_W._ID) )
                {
                    // zmieniamy bron na ciezka
                    NewAIWalkerHeavy walker = (NewAIWalkerHeavy) GetMesh();
                    walker.UseWeaponType(walker._WEAPON_SECONDARY);
                    m_fNextHeavyUseTime = fTime + _TIME_BTW_HEAVY_WEAPON_USE + RandomFloat(_RND_TIME_BTW_HEAVY_WEAPON_USE);
                }
            }
            
            if (fTime > m_fNextShootTime)
            {
                // sprawdzamy, czy widac przeciwnika
                if (m_cActiveEnemy != null 
                    && GetActiveEnemyDistance2() < m_fWeaponEffectiveRange2)
                {
                    Vector vTargetPos = m_cActiveEnemy.GetPointToLookAt(0);
                    if ( (vTargetPos != null) && SharpAngleToShoot(vTargetPos) &&
                         (ActiveEnemyVisibleFromGun()) )
                    {
                        CallMethodOnceIn(METHOD_Fire, 0); // widac wroga, mozemy strzelac
                    }
                }
            }
        }
        else
        {
            if (m_cActiveEnemy != null)
            {
                Vector vTargetPos = m_cActiveEnemy.GetPointToLookAt(0);
                if (vTargetPos != null)
                {
                    if (!SharpAngleToShoot(vTargetPos))
                        FireDone();
                    else
                    {
                        if (!m_MeshAI.CheckTraceAbsolute(m_cActiveEnemy,
                                                         m_MeshAI.GetFireOrigin(),
                                                         vTargetPos))
                            FireDone(); // nie widac wroga
                    }
                }
            }
        }
    }
    
    /** Zakonczenie strzelania, wolane po pojedynczym strzale lub po uplywie czasu */
    public void FireDone()
    {
        super.FireDone();
        
        NewAIWalkerHeavy walker = (NewAIWalkerHeavy) GetMesh(); // niestety cast...
        walker.SwitchToOtherWeaponType(walker.GetWeaponType());
        if (GetActiveWeapon() != null)
            GetActiveWeapon().StopFire();
        
        if ((GetActiveWeapon() != null) && (GetActiveWeapon().nType == EWeaponType._HEAVY))
            walker.UseWeaponType(walker._WEAPON_PRIMARY);
    }
    
    //*********************************************************
    //                     SaveGame
    //*********************************************************
    
    
    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[AIControllerWalkerHeavy.SGLoadChunk]\n");
        
        FileChunk cFC = GameObject.LoadChunk(cParentFC);   
        
        if (cFC.GetID() == ESGChunksChrome._CHK_AICONTROLLER_WALKER_HEAVY)
        {
            super.SGLoadChunk(cFC);

            m_fNextHeavyUseTime = cFC.LoadFloat();
            
        }
        
        cFC.delete();
    }
    
    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[AIControllerWalkerHeavy.SGSaveChunk]\n");
        
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_AICONTROLLER_WALKER_HEAVY, cFCParent);
        
        super.SGSaveChunk(cFC);

        cFC.SaveFloat(m_fNextHeavyUseTime);
        
        cFC.delete(); 
    }
    
    public void SGUpdate()
    {
        FileChunk.Log("[AIControllerWalkerHeavy.SGUpdate]\n");
        super.SGUpdate();
    }

}
