/** generator filtrujacy scenariusze biegu do hideouta */
public class HideoutsCheck extends Generator
{
	HideoutsCheck(AIController controller)
	{
		super(controller);

        m_GenScenarios.SetAllBits();
		m_GenScenarios.ClearBit(GotoHideoutShoot._ID);
        m_GenScenarios.ClearBit(GotoHideout._ID);
	}
	
	void UpdateScenarios()
	{
		super.UpdateScenarios();
        
        boolean bGotoHideout = (m_Controller.HideoutsNear() != null) &&
                               (m_Controller.GetDestHideoutPos() != null) &&
                               (!m_Controller.IsBehindHideout());
        
        // czy ma niskie morale
        boolean bMoraleLow = m_Controller.IsMoraleLow();
        // czy uslyszal rykoszet i nie widzi wroga
        boolean bAfterRicochet = (!m_Controller.TimePassed(m_Controller.m_fLastHeardRicochetTime, AIControllerHuman._TIME_AFTER_RICOCHET_TO_GO_TO_HIDEOUT, m_Controller.GetTime())) &&
                                 (!m_Controller.ActiveEnemyReallyVisible());
        // czy widzi przeciwnika, walczy z nim i moze zza hideouta go trafic
        boolean bHideoutFoundForFight = m_Controller.ActiveEnemyReallyVisible() &&
                                        m_Controller.CanHitActiveEnemyFromHideout();

        if (bGotoHideout &&
            (bMoraleLow || bAfterRicochet || bHideoutFoundForFight) )
		{
			m_CurrScenarios.SetAllBits();
		}
		else
        {
			m_CurrScenarios.Set(m_GenScenarios);
#if AI_DEBUG        
            DebugUtils.AddLog(m_Controller.m_MeshAI,
                              "HideoutsNear():" + m_Controller.HideoutsNear() +
                              ", GetDestHideoutPos():" + m_Controller.GetDestHideoutPos() +
                              ", IsBehindHideout():" + m_Controller.IsBehindHideout() +
                              ", bMoraleLow:" + bMoraleLow +
                              ", bHideoutFoundForFight:" + bHideoutFoundForFight +
                              ", bAfterRicochet:" + bAfterRicochet);
#endif            
        }

#if AI_DEBUG        
        DebugUtils.AddLog(m_Controller.m_MeshAI, "\n");
#endif
	}
}
