public class SilenceBroken extends Generator
{
    static float _MIN_DIST_TO_FALL_DOWN = 2500f;
    static float _MIN_DIST_TO_FALL_DOWN_EXPLOSION = 3000f;
    static float _MIN_DIST_TO_DUCK_HIDE = 1000.f;
    
    SilenceBroken(AIController controller)
    {
        super(controller);
        
        m_GenScenarios.SetAllBits();
        //		m_GenScenarios.ClearBit(FallDownToHide._ID);
        m_GenScenarios.ClearBit(DuckHide._ID);
        m_GenScenarios.ClearBit(LookAroundAlarmed._ID);				
    }
    
    void UpdateScenarios()
    {
        super.UpdateScenarios();

        if (m_Controller.GetActiveEnemy() == null)
        {
            m_CurrScenarios.SetAllBits();
            if (m_Controller.JustHeardEnemySteps() || 
                !m_Controller.TimePassed(m_Controller.m_fLastPassageEnemyNoiseTime, 
                                         m_Controller._VERY_LONG_SOUND_IMPORTANCE_TIME, 
                                         m_Controller.GetTime()))
            {
                m_CurrScenarios.ClearBit(DuckHide._ID);
            }
            else if (m_Controller.JustHeardRicochet() ||
                m_Controller.JustHeardExplosion() ||
                m_Controller.JustHeardEnemyShot() ||
                m_Controller.JustHeardScream())
            {
                m_CurrScenarios.SetAllBits();
                
                if (m_Controller.JustHeardRicochet())
                {
                    float fDist = m_Controller.GetLastRicochetMakerDist();
                    if (fDist <= _MIN_DIST_TO_DUCK_HIDE)
                        m_CurrScenarios.ClearBit(DuckHide._ID);
                }
                if (m_Controller.JustHeardEnemyShot())
                {
                    float fDist = m_Controller.GetLastEnemyShotMakerDist();
                    if (fDist <= _MIN_DIST_TO_DUCK_HIDE)
                        m_CurrScenarios.ClearBit(DuckHide._ID);
                }
                if (m_Controller.JustHeardScream())
                {
                    m_CurrScenarios.ClearBit(DuckHide._ID);
                }
            }
            else
                m_CurrScenarios.Set(m_GenScenarios);
        }
        else
            m_CurrScenarios.Set(m_GenScenarios);


#if AI_DEBUG
            DebugUtils.AddLog(m_Controller.m_MeshAI,
                              "JustHeardRicochet():" + m_Controller.JustHeardRicochet()+
                              ", JustHeardExplosion():" + m_Controller.JustHeardExplosion() +
                              ", JustHeardEnemyShot():" + m_Controller.JustHeardEnemyShot() +
                              ", JustHeardScream():" + m_Controller.JustHeardScream());		
            DebugUtils.AddLog(m_Controller.m_MeshAI, "\n");
#endif
    }
}
