public class EditorDTypeFight extends Scenario
{
    static int _ID = _NUM_OF_SCENARIOS++;
    static int init = _EDITOR_SCENARIOS.SetBit(_ID);

    void PrepareScenario(AIController ai)
    {
        FightPoint fightPoint = ai.m_CurrFightPoint;
        bhv_DTypeFight fightData = (bhv_DTypeFight)ai.GetCurrActivity();
        
        boolean bStopFight = false;
        
        if (fightData.cEndCondition == null ||
            fightData.cEndCondition.Evaluate())
        {
            bStopFight = true;
        } 
        else if (fightPoint != null)
        {
            ChromeActor cEnemy = ai.GetActiveEnemy();
            boolean bHideoutOK = (fightPoint.cHideout != null &&
                                  fightPoint.cHideout.IsActiveOnModule());
            // jesli to nie jest kryjowka albo jest poprawna - czekaj
            boolean bWait = (fightPoint.cHideout == null || bHideoutOK);

            if (fightPoint.bCanFire && cEnemy != null)
            {
                ai.AddTask(new TaskTrackingStart(cEnemy));
                ai.AddTask(new TaskStartFire());
            }
            
            if (ai.GetMesh().GetDistance2To(fightPoint) < fightPoint.fRadius *
                                                          fightPoint.fRadius) // jestesmy w punkcie
            {
                float fTime = ai.GetTime();
                if (ai.m_fFightPointLeaveTime < 0) // dopiero tam wszedl

                {
                    ai.m_fFightPointLeaveTime = fTime + ai.RandomFloat(fightPoint.fOverallTimeMin,
                                                                       fightPoint.fOverallTimeMax);
                }
                else if (fTime > ai.m_fFightPointLeaveTime || !bWait) // uplynal czas przebywania w fightpoincie albo nie ma czekac
                {
                    // zaznacz, ze czas jest 'dirty'
                    ai.m_fFightPointLeaveTime = -1; 
                    // znajdz nastepny punkt
                    if (fightPoint.aNeighbours != null && 
                        fightPoint.aNeighbours.length > 0)
                    {
                        ai.m_CurrFightPoint = fightPoint.aNeighbours[GameObject.RandomInt(fightPoint.aNeighbours.length)];
                    }
                }
                else // ma walczyc w fightpoincie
                {
                    FightInPoint(ai);
                }
            }
            else
            {
                ai.AddTask(new TaskMotionStateChange(MotionState.SPEED_RUN));
                ai.AddTask(new TaskGoToObject(fightPoint, -1, fightPoint.fRadius));
            }

            if (fightPoint.bCanFire && cEnemy != null)
            {
                ai.AddCleaningTask(new TaskTrackingStop());
                ai.AddCleaningTask(new TaskStopFire());
            }
        }
        
        if (bStopFight ||
            fightData.cEndCondition == null ||
            fightData.cEndCondition.Evaluate())
            ai.AddCleaningTask(new TaskEditorActivityEnd());
        
        super.PrepareScenario(ai);        
    }


    protected void TryToReload(AIController ai)
    {
        if ( (ai.GetActiveWeapon() != null) &&
             (ai.GetActiveWeaponAmmo() == 0) &&
             (ai.GetMesh().m_nAmmoForActiveWeapon > 0) )
        {
            ai.AddTask(new TaskReload());
        }
    }
    
    
    protected void FightInPoint(AIController ai)
    {
        FightPoint fightPoint = ai.m_CurrFightPoint;
        ChromeActor cEnemy = ai.GetActiveEnemy();
        
        boolean bHideoutOK = (fightPoint.cHideout != null &&
                              fightPoint.cHideout.IsActiveOnModule());

        if (bHideoutOK)
        {
            ai.AddTask(new TaskStopFire());
            ai.AddTask(new TaskMotionStateChange(MotionState.SPEED_DUCK));
            if (fightPoint.bCanFire && cEnemy != null)
                ai.AddTask(new TaskStartFire());
        }
        
        TryToReload(ai);
        
        if (bHideoutOK)
            ai.AddTask(new TaskWait(ai.RandomFloat(fightPoint.fHideTimeMin,
                                                   fightPoint.fHideTimeMax),
                                    TaskWait._STOP_CND_RELOAD));
        
        TryToReload(ai);

        ai.AddTask(new TaskStopFire());
        ai.AddTask(new TaskMotionStateChange(MotionState.SPEED_RUN));
        if (fightPoint.bCanFire && cEnemy != null)
            ai.AddTask(new TaskStartFire());

        TryToReload(ai);
        boolean bWasHitLately = ai.GetTime() - ai.m_fLastGotShotTime < 3;
        
        ai.AddTask(new TaskWait(GameObject.RandomFloat(fightPoint.fShootTimeMin,
                                                       fightPoint.fShootTimeMax),
                                TaskWait._STOP_CND_RELOAD | TaskWait._STOP_CND_TAKE_DAMAGE));
        if (bWasHitLately)
            ai.AddTask(new TaskWait(fightPoint.fShootTimeMin));
        TryToReload(ai);
    }
    
    public String toString()
    {
        return "EDTF";
    }
    
    int GetID()
    {
        return _ID;   
    }    
}
