public class EditorLookAt extends Scenario
{
    static int _ID = _NUM_OF_SCENARIOS++;

    static int init = _EDITOR_SCENARIOS.SetBit(_ID);
    
    final static float _CHECK_COND_INTERVAL = 0.5f;
    
	void PrepareScenario(AIController ai)
	{
        bhv_LookAt lookAtData = (bhv_LookAt)(ai.GetCurrBehavior());
        
        if (lookAtData.cEndCondition != null &&
            !lookAtData.cEndCondition.Evaluate())
        {
            ai.AddTask(new TaskStopFire());
            ai.AddTask(new TaskTrackingStart(lookAtData.cTarget, true, lookAtData.bLookCanTurn));
            ai.AddTask(new TaskWait(_CHECK_COND_INTERVAL));
        }
        else
        {
            ai.AddCleaningTask(new TaskTrackingStop());
            ai.AddCleaningTask(new TaskEditorActivityEnd());
        }

        super.PrepareScenario(ai);        
    }

    public String toString()
    {
        return "ELA";
    }
    
    int GetID()
    {
        return _ID;   
    }    
}
