public class EditorPlayAnim extends Scenario
{
    static int _ID = _NUM_OF_SCENARIOS++;

    static int init = _EDITOR_SCENARIOS.SetBit(_ID);

	void PrepareScenario(AIController ai)
	{
		if (ai.GetCurrBehavior() == null)
			ai.CrashLog("EditorPlayAnim: ai.GetCurrBehavior() == null !!!\n"); 
        bhv_PlayAnimation playAnimationData = (bhv_PlayAnimation)(ai.GetCurrBehavior());
        
        ai.AddTask(new TaskTrackingStop());
        ai.AddTask(new TaskStopFire());
		
		int iPlayCount = playAnimationData.nCount;
		if (iPlayCount < 0)
			iPlayCount = Integer.MAX_VALUE;
        if (playAnimationData.cAnimFromSet != null)
            ai.AddTask(new TaskPlayAnim(playAnimationData.cAnimFromSet.GetSelectedAnimID(),
                                        iPlayCount));
        else            
            ai.AddTask(new TaskPlayAnim(playAnimationData.sAnimName, 
                                        iPlayCount));
        ai.AddCleaningTask(new TaskEditorActivityEnd());

        super.PrepareScenario(ai);        
    }

    public String toString()
    {
        return "EPA";
    }
    
    int GetID()
    {
        return _ID;   
    }    
}
