public class GoAfterObjectShoot extends Scenario
{
    static int _ID = _NUM_OF_SCENARIOS++;
	
	static float _MIN_FOLLOW_TIME = 3f;
	static float _MAX_FOLLOW_TIME = 10f;
	static float _MIN_DISTANCE = 500f;
								   
	void PrepareScenario(AIController ai)
	{
		if (ai.GetObjectToFollow() == null)
		{
			GameObject.CrashLog("Scenario GoAfterObjectShoot ERROR: no object to follow");
			return;
		}
		
		ChromeActor enemy = ai.GetActiveEnemy();
		
		Vector vDestPos = ai.GetObjectToFollow().GetPosition(); 
		
		ai.AddTask(new TaskTurnAtPos(vDestPos));
        if (enemy != null)
		{
			ai.AddTask(new TaskTrackingStart(enemy)); 
			ai.AddTask(new TaskStartFire());
		}

		ai.AddTask(new TaskGoToObject(ai.GetObjectToFollow(),
									  GameObject.RandomFloat(_MIN_FOLLOW_TIME, _MAX_FOLLOW_TIME),
									  _MIN_DISTANCE));
        
        if (ai.m_nLastPreparedScenario == _ID && !ai.GetMesh().m_bLastGoToSuccessfull)
            ai.AddTask(new TaskWait(1, TaskWait._STOP_CND_TAKE_DAMAGE | TaskWait._STOP_CND_RELOAD));

        
        if (enemy != null)
		{
	        ai.AddCleaningTask(new TaskTrackingStop());
			ai.AddCleaningTask(new TaskStopFire());
		}
		
        super.PrepareScenario(ai);
	}
	
    public String toString()
    {
        return "GaOS";
    }
    
    // pt:. -------------   TESTY -----------  
    int GetID()
    {
        return _ID;   
    }        
}
