/** Scenariusz odpowiadajacy za reakcje po rozpoczeciu zauwazania przeciwnika
 */
public class ReactOnSuspectSpotted extends Scenario
{
    static int _ID = _NUM_OF_SCENARIOS++;
    
	void PrepareScenario(AIController ai)
	{    
        ChromeActor cSuspect = ai.m_cSuspectInfo.m_Reference;
        if (cSuspect != null)
        {
            ai.AddTask(new TaskTurnAtObject(cSuspect));
            ai.AddTask(new TaskTrackingStart(cSuspect, false));
            ai.AddTask(new TaskWait(ai.RandomFloat(0.5f, 1f)));
            
            float fNextScreamTime = ai.GetMesh().GetNextScreamTime(NewAI._SCREAMTYPE_STRANGER_SPOTTED);
            if (ai.GetMesh().GetLastScreamType() != NewAI._SCREAMTYPE_STRANGER_SPOTTED ||
                (fNextScreamTime >= 0 && ai.GetTime() > fNextScreamTime))
            {
                ai.AddTask(new TaskScream(NewAI._SCREAMTYPE_STRANGER_SPOTTED, false)); // 'cos widzialem'
            }
            if (MathUtils.CanHappen(30))
            {
                ai.AddTask(new TaskMotionStateChange(MotionState.SPEED_WALK));
                ai.AddTask(new TaskGoToObject(cSuspect, 5, 500, true));
            }
            else
                ai.AddTask(new TaskWait(5));
        }

        ai.AddTask(new TaskWait(ai.RandomFloat(0.1f, 1f)));
        ai.AddCleaningTask(new TaskTrackingStop());
       
        super.PrepareScenario(ai);
    }

    public String toString()
    {
        return "RoSS";
    }
    
    int GetID()
    {
        return _ID;   
    }        

}
