public class Unarmed extends Scenario
{
    static int _ID = _NUM_OF_SCENARIOS++;
    
    static int _RUN_FROM_ENEMY_CHANCE = 30;
    static float _MIN_RUN_AWAY_DIST = 200;
    static float _MAX_RUN_AWAY_DIST = 1000;
    static float _MIN_DIST_TO_ENEMY_TO_SCREAM = 1500.f;

    static int _MIN_FRIGHTENED_ANIM_TIMES_CAN_MOVE = 3;
    static int _MAX_FRIGHTENED_ANIM_TIMES_CAN_MOVE = 5;
    static int _MIN_FRIGHTENED_ANIM_TIMES_STUCK = 6;
    static int _MAX_FRIGHTENED_ANIM_TIMES_STUCK = 20;
    
    void PrepareScenario(AIController ai)
    {
        // trzeba sie zastanowic jak ustalac obiekt od ktorego ma uciekac
        ChromeActor enemy = ai.GetActiveEnemy();
        
        if (enemy != null)
        {
            ai.AddTask(new TaskMotionStateChange(MotionState.SPEED_RUN));
            if ((ai.m_nLastPreparedScenario != _ID) || // jesli pierwszy raz sie wybral - sprobuj uciekac
                (ai.GetMesh().m_bLastGoToSuccessfull && 
                 MathUtils.CanHappen(_RUN_FROM_ENEMY_CHANCE)))
            {
                float dist = ai.RandomFloat(_MIN_RUN_AWAY_DIST, _MAX_RUN_AWAY_DIST);
                Vector pos = ((AIControllerHuman)ai).GetOppositeDir(enemy); // kierunek przeciwny
                pos.Mul(dist);
                pos.Add(ai.GetMesh().GetPositionVectorVolatile());
                ai.AddTask(new TaskGotoPos(pos, 10));
            }
            else
            {
                ai.AddTask(new TaskTurnAtObject(enemy));
                if (ai.GetMesh().GetDistance2To(enemy) <= _MIN_DIST_TO_ENEMY_TO_SCREAM * _MIN_DIST_TO_ENEMY_TO_SCREAM)
                    ai.AddTask(new TaskScream(NewAI._SCREAMTYPE_ENEMY_SPOTTED, false)); // tu dla cywili jest 'don't hurt me' i podobne
                int nTimes;
                if (ai.GetMesh().m_bLastGoToSuccessfull)
                    nTimes = ai.RandomInt(_MIN_FRIGHTENED_ANIM_TIMES_CAN_MOVE, _MAX_FRIGHTENED_ANIM_TIMES_CAN_MOVE);
                else
                    nTimes = ai.RandomInt(_MIN_FRIGHTENED_ANIM_TIMES_STUCK, _MAX_FRIGHTENED_ANIM_TIMES_STUCK);
                        
                ai.AddTask(new TaskPlayAnim(AIAnimationsHuman.A_FRIGHTENED, nTimes));
            }
        }
        
        super.PrepareScenario(ai);
    }            
    
    public String toString()
    {
        return "UA";
    }
    // pt:. -------------   TESTY -----------  
    int GetID()
    {
        return _ID;   
    }        
}
