public class LookAroundIdle_W extends Scenario
{
    static int _ID = _NUM_OF_SCENARIOS++;

	static int _MAX_LOOKS = 5;
    static float _MIN_DELAY = 0.5f;
    static float _MAX_DELAY = 2.f;                             
	
	void PrepareScenario(AIController ai)
	{
        NewAIWalker walker = (NewAIWalker)ai.GetMesh();
        float fMaxH = walker.m_fMaxHorizHeadAngle,
            fMinV = walker.m_fMinVertHeadAngle,
            fMaxV = walker.m_fMaxVertHeadAngle;
        
        int nLooks = ai.RandomInt(_MAX_LOOKS) + 1;
        for (int i = 0; i < nLooks; i++)
        {
            ai.AddTask(new TaskRotateHead_W(ai.RandomFloat(-fMaxH, fMaxH),
                                            ai.RandomFloat(fMinV, fMaxV),
                                            2));
            ai.AddTask(new TaskWait(ai.RandomFloat(_MIN_DELAY, _MAX_DELAY)));
        }
		ai.AddCleaningTask(new TaskRotateHead_W(0, 0, 1));
        super.PrepareScenario(ai);
	}
	
    public String toString()
    {
        return "LAIW";
    }
    // pt:. -------------   TESTY -----------  
    int GetID()
    {
        return _ID;   
    }        
}
