public class Sense extends GameObject implements IFreezable
{
    /** kontroler, ktorego nalezy powiadamiac o zmianach */
    AIController m_Controller = null;
    
    boolean m_bIsFrozen = false;
    boolean m_bIsDead = false;
    
    public void Init(AIController controller)
    {
        m_Controller = controller;
    }
    
    public void Freeze()
    {
        m_bIsFrozen = true;
    }
    
    public void Unfreeze()
    {
        m_bIsFrozen = false;
    }

    public boolean IsFrozen()
    {
        return m_bIsFrozen;
    }
    
    public void Die()
    {
        m_bIsDead = true;
    }
    
    public void Respawn()
    {
        m_bIsDead = false;
    }
    
    public boolean IsDead()
    {
        return m_bIsDead;
    }
    
    //*********************************************************
    //                   SaveGame
    //*********************************************************
    
    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[Sense.SGLoadChunk]\n");
        
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        
        if (cFC.GetID() == ESGChunksChrome._CHK_SENSE)
        {
            super.SGLoadChunk(cFC);
            
            m_bIsFrozen = cFC.LoadBool();
            m_bIsDead = cFC.LoadBool();
        }
        
        cFC.delete();
    }    

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[Sense.SGSaveChunk]\n");
        
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_SENSE, cFCParent);
        
        super.SGSaveChunk(cFC);
        
        cFC.SaveBool(m_bIsFrozen);
        cFC.SaveBool(m_bIsDead);
        
        cFC.delete(); 
    }
    
    public void SGUpdate()
    {
        FileChunk.Log("[Sense.SGUpdate]\n");
        super.SGUpdate();
    }
}
