public class Task implements ISaveGame
{
    /** Kontroler, na rzecz ktorego wykonuje sie ten task */
    AIController m_cAI = null;
    
    /** czy zadanie czyszczace     */
    boolean m_bScenarioCleaning = false;
    
    /** czy zadanie ma byc update'owane */
    boolean m_bUpdating = false;
    /** co jaki czas update	 */
    float m_fUpdateTime = 0.0f;
    


    
    /** Ustawia kontroler, na rzecz ktorego wykonuje sie ten task
     */
    public void SetAIController(AIController cAI)
    {
        m_cAI = cAI;
    }
    
    void SetScenarioCleaning()
    {
        m_bScenarioCleaning = true;
    }
    
    void SetUpdating(float fTime)
    {
        m_bUpdating = true;
        m_fUpdateTime = fTime;
    }
    
    boolean IsScenarioCleaning()
    {
        return m_bScenarioCleaning;
    }
    
    /** wykonuje zadanie     */
    public void Perform()
    {
#if AI_DEBUG
        DebugUtils.CrashLog(m_cAI.m_MeshAI, " task Perform "+this+"\n");
#endif
        if(m_bUpdating)
            m_cAI.StartTaskUpdate(m_fUpdateTime);
    }
    
    /** Update zadania	 */
    void Update()
    {
    }
    
    /** konczy  zadanie     
     * bFast - szybkie zakonczenie */
    public void Cancel(boolean bFast)
    {
        OnEndTask();
    }

    /** obsluguje komunikat wyslany z AIControllera
     */
    public void ServeNotice(int nNotice)
    {
    }

    /** wolane zawsze na koncu zadania	 */
    void OnEndTask()
    {
        m_cAI.ClearTaskTime();
        m_cAI.ClearTaskUpdate();
    }
    
    //*********************************************************
    //                       SaveGame
    //*********************************************************
    
    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[Task.SGLoadChunk]\n");
        
        FileChunk cFC = GameObject.LoadChunk(cParentFC);   
        
        if (cFC.GetID() == ESGChunksChrome._CHK_TASK)
        {
            m_bScenarioCleaning = cFC.LoadBool();
            m_bUpdating = cFC.LoadBool();
            m_fUpdateTime = cFC.LoadFloat();
        }
        
        cFC.delete();
    }
    
    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[Task.SGSaveChunk]\n");
        
        FileChunk cFC = GameObject.NewChunk(ESGChunksChrome._CHK_TASK, cFCParent);
        
        cFC.SaveBool(m_bScenarioCleaning);
        cFC.SaveBool(m_bUpdating);
        cFC.SaveFloat(m_fUpdateTime);

        cFC.delete(); 
    }
    
    public void SGUpdate()
    {
        FileChunk.Log("[Task.SGUpdate]\n");
    }
}
