public class TaskGotoPos extends Task
{
	final static float _SPEED = 500;	
	/** poczatkowa pozycja	 */
	Vector m_vDestPos = null;
	/** czas trwaia zadania 	 */
	float m_fEndTime = 0.0f;
	
    public TaskGotoPos()
    {
        //SG
    }
    
    public TaskGotoPos(Vector vDestPos)
    {
        this(vDestPos, -1);
    }

        
    public TaskGotoPos(Vector vDestPos, float fEndTime)
	{
		m_vDestPos = new Vector(vDestPos);
		m_fEndTime = fEndTime;
	}
	
    /** wykonuje zadanie     */
    public void Perform()
    {
		super.Perform();
		m_cAI.GetMesh().GoToPosition(m_vDestPos);       

		float fDist = m_cAI.GetMesh().GetDistanceTo(m_vDestPos);
        if (m_fEndTime < 0)
		    m_fEndTime = (fDist / _SPEED)*1.5f;				
		
		m_cAI.StartTaskTime(m_fEndTime);
   }
    
    public void Cancel(boolean bFast)
    {
        m_cAI.GetMesh().StopGoTo();
        super.Cancel(bFast);
    }
    
    /** obsluguje komunikat wyslany z AIControllera     */
    public void ServeNotice(int nNotice)
    {
        super.ServeNotice(nNotice);
        switch(nNotice)
		{
    		case AIEvents._NOTICE_DEST_POS:			
	    		m_cAI.Notify(AIEvents._NOTICE_END_TASK);
			break;
            
		    case AIEvents._NOTICE_TASK_TIME_PASSED:
                m_cAI.GetMesh().StopGoTo();
	    		m_cAI.Notify(AIEvents._NOTICE_END_TASK);
    		break;            
		}
    }	    
	public String toString()
	{
		return 	"GotoPos("+m_fEndTime+")";
	}	
    
    //*********************************************************
    //					SaveGame
    //*********************************************************
    
    public void SGLoadChunk(FileChunk cParentFC)
    {	
        FileChunk.Log("[TaskGotoPos.SGLoadChunk]\n");
        
        FileChunk cFC = GameObject.LoadChunk(cParentFC);   
        
        if (cFC.GetID() == ESGChunksChrome._CHK_TASK_GO_TO_POS)
        {
            super.SGLoadChunk(cFC);
            m_vDestPos = cFC.LoadVector();
            m_fEndTime = cFC.LoadFloat();
        }
        
        cFC.delete();
    }
    
    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[TaskGotoPos.SGSaveChunk]\n");
        
        FileChunk cFC = GameObject.NewChunk(ESGChunksChrome._CHK_TASK_GO_TO_POS, cFCParent);
        
        super.SGSaveChunk(cFC);
	    cFC.SaveVector(m_vDestPos);
	    cFC.SaveFloat(m_fEndTime);

        cFC.delete(); 
    }				
    
    public void SGUpdate()
    {
        FileChunk.Log("[TaskGotoPos.SGUpdate]\n");
        super.SGUpdate();
        //
    }

}
