public class TaskGuard extends Task
{
    protected ControlObject m_GuardedObject = null;
    protected float m_fGuardedAreaRadius = 0;
    protected boolean m_bGuardCritical;                                       

    public TaskGuard()
    {
        //SG
    }
    
    public TaskGuard(ControlObject cObject, float fRadius, boolean bCritical)
    {
        m_GuardedObject = cObject;
        m_fGuardedAreaRadius = fRadius;
        m_bGuardCritical = bCritical;
    }
    
    public void Perform()
    {
        super.Perform();
        m_cAI.GetMesh().GuardObject(m_GuardedObject, m_fGuardedAreaRadius, m_bGuardCritical);
        m_cAI.Notify(AIEvents._NOTICE_END_TASK);
    }
    
    //*********************************************************
    //					SaveGame
    //*********************************************************
    
    public void SGLoadChunk(FileChunk cParentFC)
    {	
        FileChunk.Log("[TaskGuard.SGLoadChunk]\n");
        
        FileChunk cFC = GameObject.LoadChunk(cParentFC);   
        
        if (cFC.GetID() == ESGChunksChrome._CHK_TASK_GUARD)
        {
            super.SGLoadChunk(cFC);
            m_GuardedObject = (ControlObject)cFC.LoadObjectRef();
            m_fGuardedAreaRadius = cFC.LoadFloat();
            m_bGuardCritical = cFC.LoadBool();
        }
        
        cFC.delete();
    }
    
    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[TaskGuard.SGSaveChunk]\n");
        
        FileChunk cFC = GameObject.NewChunk(ESGChunksChrome._CHK_TASK_GUARD, cFCParent);
        
        super.SGSaveChunk(cFC);
	    cFC.SaveObjectRef(m_GuardedObject);
	    cFC.SaveFloat(m_fGuardedAreaRadius);
        cFC.SaveBool(m_bGuardCritical);

        cFC.delete(); 
    }				
    
    public void SGUpdate()
    {
        FileChunk.Log("[TaskGuard.SGUpdate]\n");
        super.SGUpdate();
        //
    }

}
