public class TaskPlayAnim extends Task
{
    protected int m_nAnimID = -1;
    protected int m_nTimes = 0;
    protected String m_sSequenceName = null;
    
    
    public TaskPlayAnim()
    {
        //SG
    }
    
    public TaskPlayAnim(int nAnimID)
    {
        this(nAnimID, 1);
    }

    
    public TaskPlayAnim(String sAnim)
    {
        this(sAnim, 1);
    }

    
    public TaskPlayAnim(int nAnimID, int nTimes)
    {
        m_nAnimID = nAnimID;
        m_nTimes = nTimes;
    }
    
    public TaskPlayAnim(String sAnim, int nTimes)
    {
        m_sSequenceName = sAnim;
        m_nTimes = nTimes;
    }
    

    /** wykonuje zadanie     */
    public void Perform()
    {
        super.Perform();
        if (m_nTimes > 0)
        {
            m_cAI.GetMesh().CallOrRemoveUpdateMotion();
            if (m_nAnimID != -1)
                m_cAI.GetMesh().PlayAIAnim(m_nAnimID, m_nTimes);
            else
                m_cAI.GetMesh().PlayAIAnim(m_sSequenceName, m_nTimes);
        }
        else
            m_cAI.Notify(AIEvents._NOTICE_END_TASK);
    }	
    
    /** Odwolanie akcji */
    public void Cancel(boolean bQuick)
    {
        super.Cancel(bQuick);
        m_cAI.GetMesh().StopAIAnim(false);
        
    }
    
    /** obsluguje komunikat wyslany z AIControllera     */
    public void ServeNotice(int nNotice)
    {
        super.ServeNotice(nNotice);
        switch(nNotice)
        {
        case AIEvents._NOTICE_ANIM_END:
            m_cAI.Notify(AIEvents._NOTICE_END_TASK);
            break;
        case AIEvents._NOTICE_ANIM_STOPPED:
            m_cAI.Notify(AIEvents._NOTICE_END_TASK);
            break;
        }
    }	    
    
    public String toString()
    {
        if (m_nAnimID != -1)
        {
            if (m_cAI != null && m_cAI.GetMesh() != null && m_cAI.GetMesh().m_Anims != null)
                return "PlayAnim(" + m_cAI.GetMesh().m_Anims.GetNameForID(m_nAnimID) +
                        "," + m_nTimes + ")";
            else
                return "PlayAnim(" + m_nAnimID + "," + m_nTimes + ")";
        }
        else
            return "PlayAnim(" + m_sSequenceName + "," + m_nTimes + ")";
    }
    
    //*********************************************************
    //                      SaveGame
    //*********************************************************
    
    public void SGLoadChunk(FileChunk cParentFC)
    {	
        FileChunk.Log("[TaskPlayAnim.SGLoadChunk]\n");
        
        FileChunk cFC = GameObject.LoadChunk(cParentFC);   
        
        if (cFC.GetID() == ESGChunksChrome._CHK_TASK_PLAY_ANIM)
        {
            super.SGLoadChunk(cFC);
            m_nAnimID = cFC.LoadInt();
            m_nTimes = cFC.LoadInt();
            m_sSequenceName = cFC.LoadString();
        }
        
        cFC.delete();
    }
    
    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[TaskPlayAnim.SGSaveChunk]\n");
        
        FileChunk cFC = GameObject.NewChunk(ESGChunksChrome._CHK_TASK_PLAY_ANIM, cFCParent);
        
        super.SGSaveChunk(cFC);
        cFC.SaveInt(m_nAnimID);
        cFC.SaveInt(m_nTimes);
        cFC.SaveString(m_sSequenceName);

        cFC.delete(); 
    }
    
    public void SGUpdate()
    {
        FileChunk.Log("[TaskPlayAnim.SGUpdate]\n");
        super.SGUpdate();
        //
    }

}
