public class TaskReload extends Task
{
    boolean m_bForce;

    public TaskReload()
    {
        this(false);
    }
    
    public TaskReload(boolean bForce)
    {
        m_bScenarioCleaning = true;// force, zeby nie dalo sie przerwac
        m_bForce = bForce;
    }

    /** wykonuje zadanie     */
    public void Perform()
    {
        super.Perform();
        if (m_bForce ||
            ( (m_cAI.GetActiveWeapon() != null) &&
              (m_cAI.GetActiveWeaponAmmo() == 0) &&
              (m_cAI.GetMesh().m_nAmmoForActiveWeapon > 0)))
        {
            m_cAI.GetMesh().CallOrRemoveUpdateMotion();
            m_cAI.GetMesh().PlayAIAnim(AIAnimationsHuman.A_WEAPON_RELOAD, 1);
        }
        else
            m_cAI.Notify(AIEvents._NOTICE_END_TASK);
    }

    /** Odwolanie akcji */
    public void Cancel(boolean bQuick)
    {
        super.Cancel(bQuick);
        m_cAI.GetMesh().StopAIAnim(false);
    }
    
    /** obsluguje komunikat wyslany z AIControllera */
    public void ServeNotice(int nNotice)
    {
        super.ServeNotice(nNotice);
        switch(nNotice)
        {
            
        case AIEvents._NOTICE_ANIM_END:
            m_cAI.ReloadWeapon();
            m_cAI.Notify(AIEvents._NOTICE_END_TASK);
            break;
        case AIEvents._NOTICE_ANIM_STOPPED:
            m_cAI.Notify(AIEvents._NOTICE_END_TASK);
            break;
        }
    }
    
    public String toString()
    {
        return 	"Reload";
    }    
    
    
    //*********************************************************
    //                   SaveGame
    //*********************************************************
    
    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[TaskReload.SGLoadChunk]\n");
        
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        
        if (cFC.GetID() == ESGChunksChrome._CHK_TASK_RELOAD)
        {
            super.SGLoadChunk(cFC);
            m_bForce = cFC.LoadBool();
        }
        
        cFC.delete();
    }
    
    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[TaskReload.SGSaveChunk]\n");
        
        FileChunk cFC = GameObject.NewChunk(ESGChunksChrome._CHK_TASK_RELOAD, cFCParent);
        
        super.SGSaveChunk(cFC);
        cFC.SaveBool(m_bForce);

        cFC.delete(); 
    }
    
    public void SGUpdate()
    {
        FileChunk.Log("[TaskReload.SGUpdate]\n");
        super.SGUpdate();
        //
    }

}
