public class TaskScream extends Task
{
    public static final int _SOURCE_VOICE = 0;
    public static final int _SOURCE_RADIO = 1;
    
    protected int m_nScreamType = 0;
    protected boolean m_bWait = false;
    protected int m_nScreamSource;
    
    public TaskScream()
    {
        //SG
    }
    
    public TaskScream(int nScreamType, int nSource)
    {
        m_nScreamType = nScreamType;
        m_bWait = false;
        m_nScreamSource = nSource;
    }

    public TaskScream(int nScreamType, boolean bWaitForEnd)
    {
        m_nScreamType = nScreamType;
        m_bWait = bWaitForEnd;
        m_nScreamSource = _SOURCE_VOICE;
    }

    public TaskScream(int nScreamType)
    {
        this(nScreamType, true);
    }
    
    public void Perform()
    {
        super.Perform();

        float fTime = 0;
        if (m_nScreamSource == _SOURCE_VOICE)
            fTime = m_cAI.GetMesh().Scream(m_nScreamType);
        else
            m_cAI.GetMesh().SendRadioMessage(m_nScreamType);
        
        m_cAI.StartTaskTime(m_bWait ? fTime : 0);
	}
	
    public void ServeNotice(int nNotice)
    {
        super.ServeNotice(nNotice);
        switch(nNotice)
		{
		    case AIEvents._NOTICE_TASK_TIME_PASSED:
	    		m_cAI.Notify(AIEvents._NOTICE_END_TASK);
    		break;            
		}
    }	 
    
    public String toString()
    {
        return "Scream(" + m_nScreamType + ", " + m_bWait + ", " + m_nScreamSource + ")";
    }
    
    
    //*********************************************************
    //					SaveGame
    //*********************************************************
    
    public void SGLoadChunk(FileChunk cParentFC)
    {	
        FileChunk.Log("[TaskScream.SGLoadChunk]\n");
        
        FileChunk cFC = GameObject.LoadChunk(cParentFC);   
        
        if (cFC.GetID() == ESGChunksChrome._CHK_TASK_SCREAM)
        {
            super.SGLoadChunk(cFC);
            m_nScreamType = cFC.LoadInt();
            m_bWait = cFC.LoadBool();
            m_nScreamSource = cFC.LoadInt();
        }
        
        cFC.delete();
    }
    
    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[TaskScream.SGSaveChunk]\n");
        
        FileChunk cFC = GameObject.NewChunk(ESGChunksChrome._CHK_TASK_SCREAM, cFCParent);
        
        super.SGSaveChunk(cFC);
        cFC.SaveInt(m_nScreamType);
        cFC.SaveBool(m_bWait);
        cFC.SaveInt(m_nScreamSource);

        cFC.delete(); 
    }				
    
    public void SGUpdate()
    {
        FileChunk.Log("[TaskScream.SGUpdate]\n");
        super.SGUpdate();
        //
    }

}
