public class TaskStrafeObject extends Task
{
	/** minimalna odleglosc stafe'owania	 */
	final static float _MIN_STRAFE_DIST = 200;
	
	/** docelowy obiekt */
	ControlObject m_Object = null;
	
	/** czas trwaia zadania */
	float m_fEndTime = 0.0f;
    /** na jaka odleglosc ma strafe'owac     */
    float m_fStrafeLengthMul = 0.0f;
	
    public TaskStrafeObject()
    {
        //SG
    }
    
    public TaskStrafeObject(ControlObject cObject, float fEndTime, float fStrafeLengthMul)
                         
    {
  		m_Object = cObject;
		m_fEndTime = fEndTime;
        m_fStrafeLengthMul = fStrafeLengthMul;
    }
    
    /** wykonuje zadanie     */
    public void Perform()
    {
		super.Perform();		
        Vector vDestPos = FixDestPos();
        if(vDestPos!=null)
        {
            m_cAI.GetMesh().GoToPosition(FixDestPos());
		    m_cAI.StartTaskTime(m_fEndTime);
        }
        else
            m_cAI.Notify(AIEvents._NOTICE_END_TASK);  // nie mogl pobrac
    }
    
    public void Cancel(boolean bFast)
    {
        m_cAI.GetMesh().StopGoTo();
        super.Cancel(bFast);
    }    
    
    /** obsluguje komunikat wyslany z AIControllera     */
    public void ServeNotice(int nNotice)
    {
        super.ServeNotice(nNotice);
        switch(nNotice)
		{
        case AIEvents._NOTICE_DEST_POS:
            m_cAI.Notify(AIEvents._NOTICE_END_TASK);
            break;
		case AIEvents._NOTICE_TASK_TIME_PASSED:
//            GameObject.LogLine(" _NOTICE_TASK_TIME_PASSED ");
			Cancel(false);
			break;            
		}
    }	    

    /** ustalenie nastepnej docelowej  pozycji  */
    Vector FixDestPos()
    {
        if(m_Object==null)
            return null;
        Vector vObjectPos = m_Object.GetPosition();
        if(vObjectPos==null)
            return null;
        else
            vObjectPos = m_cAI.GetMesh().GetInFormationPosition(vObjectPos, null);

        
        Vector vDelta = new Vector(vObjectPos);
        vDelta.Sub(m_cAI.GetMesh().GetPositionVectorVolatile());
        float fDist = vDelta.Len();
        float fStrafeLength = m_fStrafeLengthMul*fDist;        
		if(fStrafeLength < _MIN_STRAFE_DIST)
			fStrafeLength = _MIN_STRAFE_DIST;

        // ustala kat o jaki ma obrocic wektor kierunku by biegl prostopadle do obiektu
        vDelta.fY = 0.0f;
        float fCos = (fStrafeLength/2) / fDist;
        float fAngle = (float)Math.acos(fCos);
        fAngle = (180f*fAngle)/(float)Math.PI; 

        // losuje w ktora strone (cos jest symetryczna i nie wiem jaki kat zwraca + czy - )
        if(GameObject.RandomFloat(100) >50)
            fAngle *= -1;
        
        vDelta = m_cAI.RotateVector( vDelta, fAngle, Vector.Up );
        vDelta.Normalize();
        vDelta.Mul(fStrafeLength);  
        
        Vector vDestPos = m_cAI.GetMesh().GetPosition();
        vDestPos.Add(vDelta);                       
        return vDestPos;
    }

    public String toString()
	{
		return 	"GoStrafeObject("+m_Object.GetName()+","+m_fEndTime+")";
	}	
    
    //*********************************************************
    //					SaveGame
    //*********************************************************
    
    public void SGLoadChunk(FileChunk cParentFC)
    {	
        FileChunk.Log("[TaskStrafeObject.SGLoadChunk]\n");
        
        FileChunk cFC = GameObject.LoadChunk(cParentFC);   
        
        if (cFC.GetID() == ESGChunksChrome._CHK_TASK_STRAFE_OBJECT)
        {
            super.SGLoadChunk(cFC);
	        m_Object = (ControlObject)cFC.LoadObjectRef();
	        m_fEndTime = cFC.LoadFloat();
            m_fStrafeLengthMul = cFC.LoadFloat();
        }
        
        cFC.delete();
    }
    
    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[TaskStrafeObject.SGSaveChunk]\n");
        
        FileChunk cFC = GameObject.NewChunk(ESGChunksChrome._CHK_TASK_STRAFE_OBJECT, cFCParent);
        
        super.SGSaveChunk(cFC);
        cFC.SaveObjectRef(m_Object);
	    cFC.SaveFloat(m_fEndTime);
	    cFC.SaveFloat(m_fStrafeLengthMul);

        cFC.delete(); 
    }				
    
    public void SGUpdate()
    {
        FileChunk.Log("[TaskStrafeObject.SGUpdate]\n");
        super.SGUpdate();
        //
    }

}
