public class TaskTurnAtDir extends Task
{
	Vector m_vDestDir = null;

    public TaskTurnAtDir()
    {
        //SG
    }
    
    public TaskTurnAtDir(Vector vDestDir)
	{
        if (vDestDir != null)
		    m_vDestDir = new Vector(vDestDir);
	}
    
    /** wykonuje zadanie     */
    public void Perform()
    {
        super.Perform();
		m_cAI.GetMesh().Turn(m_vDestDir);
    }	
    
    public void Cancel(boolean bFast)
    {
        m_cAI.GetMesh().StopTurn();
        super.Cancel(bFast);
    }
    
    /** obsluguje komunikat wyslany z AIControllera     */
    public void ServeNotice(int nNotice)
    {
        super.ServeNotice(nNotice);
        switch(nNotice)
		{
        case AIEvents._NOTICE_ANGLE_REACHED:
			m_cAI.Notify(AIEvents._NOTICE_END_TASK);
			break;
		}
    }
    
    //*********************************************************
    //					SaveGame
    //*********************************************************
    
    public void SGLoadChunk(FileChunk cParentFC)
    {	
        FileChunk.Log("[TaskTurnAtDir.SGLoadChunk]\n");
        
        FileChunk cFC = GameObject.LoadChunk(cParentFC);   
        
        if (cFC.GetID() == ESGChunksChrome._CHK_TASK_TURN_AT_DIR)
        {
            super.SGLoadChunk(cFC);
	        m_vDestDir = cFC.LoadVector();
      }
        
        cFC.delete();
    }
    
    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[TaskTurnAtDir.SGSaveChunk]\n");
        
        FileChunk cFC = GameObject.NewChunk(ESGChunksChrome._CHK_TASK_TURN_AT_DIR, cFCParent);
        
        super.SGSaveChunk(cFC);
	    cFC.SaveVector(m_vDestDir);

        cFC.delete(); 
    }				
    
    public void SGUpdate()
    {
        FileChunk.Log("[TaskTurnAtDir.SGUpdate]\n");
        super.SGUpdate();
        //
    }

}
