public class TaskTurnAtPos extends Task
{
	Vector m_vDestPos = null;

    public TaskTurnAtPos()
    {
        //SG
    }
    
    public TaskTurnAtPos(Vector vDestPos)
	{
        if (vDestPos != null)
		    m_vDestPos = new Vector(vDestPos);
	}

    
    private Vector m_vDir = new Vector();
    /** wykonuje zadanie     */
    public void Perform()
    {
        super.Perform();
        // ustalenie kierunku
        
        if (m_vDestPos == null)
        {
			m_cAI.Notify(AIEvents._NOTICE_END_TASK);
            return;
        }
        m_vDir.Set(m_vDestPos);
        m_vDir.Sub(m_cAI.GetMesh().GetPositionVectorVolatile());
        m_vDir.Normalize();
		m_cAI.GetMesh().Turn(m_vDir);
    }	
    
    public void Cancel(boolean bFast)
    {
        m_cAI.GetMesh().StopTurn();
        super.Cancel(bFast);
    }
    
    /** obsluguje komunikat wyslany z AIControllera     */
    public void ServeNotice(int nNotice)
    {
        super.ServeNotice(nNotice);
        switch(nNotice)
		{
        case AIEvents._NOTICE_ANGLE_REACHED:
			m_cAI.Notify(AIEvents._NOTICE_END_TASK);
			break;
		}
    }	    	

    //*********************************************************
    //					SaveGame
    //*********************************************************
    
    public void SGLoadChunk(FileChunk cParentFC)
    {	
        FileChunk.Log("[TaskTurnAtPos.SGLoadChunk]\n");
        
        FileChunk cFC = GameObject.LoadChunk(cParentFC);   
        
        if (cFC.GetID() == ESGChunksChrome._CHK_TASK_TURN_AT_POS)
        {
            super.SGLoadChunk(cFC);
	        m_vDestPos = cFC.LoadVector();
      }
        
        cFC.delete();
    }
    
    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[TaskTurnAtPos.SGSaveChunk]\n");
        
        FileChunk cFC = GameObject.NewChunk(ESGChunksChrome._CHK_TASK_TURN_AT_POS, cFCParent);
        
        super.SGSaveChunk(cFC);
	    cFC.SaveVector(m_vDestPos);

        cFC.delete(); 
    }				
    
    public void SGUpdate()
    {
        FileChunk.Log("[TaskTurnAtPos.SGUpdate]\n");
        super.SGUpdate();
        //
    }

}
