import java.io.*;

public class AIWayPoint
{
	static float _IDENTITY_DIST_2 = 2f;
	
	Vector m_vPos = null;
    short m_Neighbours[] = null;
	
	AIWayPoint(Vector vPos)
	{
		m_vPos = new Vector(vPos);
        m_Neighbours = null;
	}
	
	AIWayPoint()
	{
		m_vPos = new Vector();
        m_Neighbours = null;
	}
	
	void AddNeighbour(short iWaypoint)
	{
        if (m_Neighbours == null)
        {
            m_Neighbours = new short[1];
            m_Neighbours[0] = iWaypoint;
            return;
        }
        
        for (int i = 0; i < m_Neighbours.length; i++)
            if (iWaypoint == m_Neighbours[i])
                return;
        short tab[] = new short[m_Neighbours.length + 1];
        for (int i = 0; i < m_Neighbours.length; i++)
            tab[i] = m_Neighbours[i];
        tab[m_Neighbours.length] = iWaypoint;
        m_Neighbours = tab;
        tab = null;
	}
	
	short GetNeighbour(int iNdx)
	{
		return m_Neighbours[iNdx];
	}
	
	boolean Equals(AIWayPoint pt)
	{
		if (pt == null)
			return false;
		return (m_vPos.Distance2(pt.m_vPos) < _IDENTITY_DIST_2);
	}
	
	boolean Equals(Vector vPos)
	{
		if (vPos == null)
			return false;
		return (m_vPos.Distance2(vPos) < _IDENTITY_DIST_2);
	}
	
	static boolean Equals(Vector v1, Vector v2)
	{
		if ( (v1 == null) || (v2 == null) )
			return false;
		return (v1.Distance2(v2) < _IDENTITY_DIST_2);
	}
	
	void Save(DataOutputStream output)
		throws IOException
	{
		m_vPos.WriteToDisk(output);
	}
	
	void SaveReferences(DataOutputStream output)
		throws IOException
	{
        if (m_Neighbours == null) output.writeInt(0);
        else
        {
		    output.writeInt(m_Neighbours.length);
		    for (int i = 0; i < m_Neighbours.length; i++)
		    	output.writeInt(m_Neighbours[i]);
        }
	}
	
	void Load(DataInputStream input)
	{
		m_vPos.ReadFromDisk(input);
	}
	
	void LoadReferences(DataInputStream input)
		throws IOException
	{
		int iNeighbours = input.readInt();
		for (int i = 0; i < iNeighbours; i++)
		{
			int iTableNdx = input.readInt();
			AddNeighbour((short) iTableNdx);
		}
	}
}
