public class SubObjective extends EditorObjective
{
    {sEditorComment = "Objectives group";}
    
    /** parent objective */
    public Objective cParent;//#SUBOBJECTIVE;Group objective of this one
	
	SubObjective()
	{
		// SG
		bSG = true;
	}
    
    public void OnPostCreate()
    {
        if ( (cParent == null) && (GetModule() instanceof ChromeModule) )
            CrashLog("SubObjective error: no cParent !!!\n");
    }
    
    String GetText()
    {
        return sTextID;
    }
    
    public void Enable()
    {
        if ( !(GetModule() instanceof ChromeModule) )
            return;
        
        ChromeModule module = (ChromeModule) GetModule();
        module.m_ObjectivesManager.EnableObjective(cParent.iObjectiveOrderNumber, iObjectiveOrderNumber);
    }
    
    public void Disable()
    {
        if ( !(GetModule() instanceof ChromeModule) )
            return;
        
        ChromeModule module = (ChromeModule) GetModule();
        module.m_ObjectivesManager.DisableObjective(cParent.iObjectiveOrderNumber, iObjectiveOrderNumber);
    }
    
    public boolean IsEnabled()
    {
        if ( !(GetModule() instanceof ChromeModule) )
            return false;
        
        ChromeModule module = (ChromeModule) GetModule();
        return module.m_ObjectivesManager.IsEnabledObjective(cParent.iObjectiveOrderNumber, iObjectiveOrderNumber);
    }
    
    public void Accomplish()
    {
        if ( !(GetModule() instanceof ChromeModule) )
            return;
        
        ChromeModule module = (ChromeModule) GetModule();
        module.m_ObjectivesManager.SetAccomplished(cParent.iObjectiveOrderNumber, iObjectiveOrderNumber);
    }
    
    public void Unaccomplish()
    {
        if ( !(GetModule() instanceof ChromeModule) )
            return;
        
        ChromeModule module = (ChromeModule) GetModule();
        module.m_ObjectivesManager.SetUnaccomplished(cParent.iObjectiveOrderNumber, iObjectiveOrderNumber);
    }
	
    public boolean IsAccomplished()
    {
        if ( !(GetModule() instanceof ChromeModule) )
            return false;
        
        ChromeModule module = (ChromeModule) GetModule();
		
        return module.m_ObjectivesManager.IsAccomplished(cParent.iObjectiveOrderNumber, iObjectiveOrderNumber);
    }
	
	
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {
		FileChunk.Log("[SubObjective.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);
        
        if (cFC.GetID() == ESGChunksChrome._CHK_OBJECTIVE)
        {
            super.SGLoadChunk(cFC);
            
            ChromeModule module = (ChromeModule) GetModule();
            module.m_ObjectivesManager.SetMessagesActive(false);
            
            if(cFC.LoadBool())
                Enable();
            else
                Disable();
            
            if(cFC.LoadBool())
                Accomplish();
            else
                Unaccomplish();
            
            module.m_ObjectivesManager.SetMessagesActive(true);
        }
		
		cFC.delete();
	}
	
    /** Metoda zapisujaca dane do Save gracza
     */		
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[SubObjective.SGSaveChunk]\n");
		
        FileChunk cFC = GameObject.NewChunk(ESGChunksChrome._CHK_OBJECTIVE, cFCParent);

        super.SGSaveChunk(cFC);
        
        cFC.SaveBool(IsEnabled());
        cFC.SaveBool(IsAccomplished());
        
		cFC.delete();
    }
}
