public class BaseAnimationsDual extends BaseAnimations
{
    BaseAnimations cDual = null;
    
    BaseAnimationsDual( MeshObject mesh, String sRootBone,
                    String sTorsoBone, String sUpperTorsoBone, Class ownerClass, BaseAnimations Dual )
    {
        super( mesh, sRootBone, sTorsoBone, sUpperTorsoBone, ownerClass );
        
        cDual = Dual;
    }
    
    void SetupAnims(MotionState motion, Weapon ActiveWeapon)
    {
        //GameObject.LogR("[Dual] SetupAnims motion="+motion.toString()+"\n");
        super.SetupAnims(motion, ActiveWeapon);
        if(cDual!=null) cDual.SetupAnims(motion, ActiveWeapon);
    }
    
    void Play(int nID)
    {
        //GameObject.LogR("[Dual] Play nID="+nID+"\n");
        super.Play(nID);
        if(cDual!=null) cDual.Play(nID);
    }

    //odegranie animacji bez morphingu z poprzedniej
    void PlayNoMorph(int nID)
    {
        //GameObject.LogR("[Dual] PlayNoMorph nID="+nID+"\n");
        super.PlayNoMorph(nID);
        if(cDual!=null) cDual.PlayNoMorph(nID);
    }
    
    
    void PlayLoop(int nID)
    {
        //GameObject.LogR("[Dual] PlayLoop nID="+nID+"\n");
        super.PlayLoop(nID);
        if(cDual!=null) cDual.PlayLoop(nID);
    }
    
    void Stop(String bone)
    {
        //GameObject.LogR("[Dual] Stop bone="+bone+"\n");
        super.Stop(bone);
        if(cDual!=null) cDual.Stop(bone);
    }
    
    void StopAll()
    {
        //GameObject.LogR("[Dual] Stop all\n");
        super.StopAll();
        if(cDual!=null) cDual.StopAll();
    }
    
    void Lock()
    {
        super.Lock();
        if(cDual!=null) cDual.Lock();
    }
    
    void Unlock()
    {
        super.Unlock();
        if(cDual!=null) cDual.Unlock();
    }
}
