public class ArmoredTransporter extends Jeep
{
	ArmoredTransporter()
	{
		super();

	    fBlobMapSize = 420f;
	    sBlobMaterial = "blob_pancer.mat";
		
		m_fObservedSightVAngle = 20f;
		m_fOverObservedHeight = 500f;
		m_fOverObservedBack = 800f;
		
        m_fOverCannonHeightDrive = 100f;
        m_fFromCannonBackDrive = 100f;
        
        m_fOverCannonHeightShoot = 100f;
        m_fFromCannonBackShoot = 100f;
		
		m_fAIControlledCannonHAngle = 40f;
        
		m_sSoundSlideName = null;
        
        m_aSpeeds = new float[] { 0f, 100f, 300f, 600f, 900f, 1200f };

		bActiveTrigger = true;
        
        m_iStampSize = 17;
        
        fHealth = fMaxHealth = 12000;
        fDamageThreshold = 1100;
        fFireDamage = 100;
        fRateOfFire = 400;
        
        m_sWreckMeshName = null;
        
        fBlowUpShakeStrength = 1000;
        fBlowUpShakeDistMin = 700;
        fBlowUpShakeDistMax = 4000;
        
        m_vFXDir = new Vector(Vector.Forward);
        m_vPositionModifier = new Vector(0f, 120f, 0f);
    }
	
	void OnCreate()
    {
        super.OnCreate();
        
		DeleteAllSeatsInfos();
		AddSeatInfo(new SeatInfo(this, "KlapaT", EPassengerRole._VEHICLE_DRIVER,
								 EGetInOutAnimType._UNKNOWN, new Vector(-50f, -260f, 0f)));
		AddSeatInfo(new SeatInfo(this, "KlapaT", EPassengerRole._VEHICLE_PASSENGER,
								 EGetInOutAnimType._UNKNOWN, new Vector(50f, -260f, 0f)));
		// parametry dzwiekow
		if (m_Physics != null)
		{
			m_Physics.m_Params._TIME_BETWEEN_SLIDE_SOUNDS = 0.15f;
			m_Physics.m_Params._TIME_BETWEEN_ACCEL_SOUNDS = 0.1f;
            
            m_Physics.m_Params.SetMaxSpeed(600.0f);
            m_Physics.m_Params._SLIDE_COEF = 0.0f;
            m_Physics.m_Params._SLIDE_SUPRESS = 0.0f;
			m_Physics.m_Params._ACCELERATION_COEF = 300f;
            m_Physics.m_Params._TREE_HIT_SUPR = 0.2f;
        
            m_Physics.m_Params._TURNING_SPEED = 1000.0f;
            m_Physics.m_Params._MAX_TURN_ANGLE = 70.0f;
            
			m_Physics.m_Params._WHEEL_MOVE_SPEED_COEF = 0.6f;

            //HACK: transportowiec bez tego latal wysoko....
            m_Physics.m_Params._MAX_VERT_DEV = 0f;
            m_Physics.m_Params._HORIZ_DEV_ACCEL = 10f;
		}
        
        sBlowUpFX = "FXBlowArmoredTransporter";
        sBlowUpSound = "Data/Sounds/Weapon/GrenadeExplosion";
        
        m_fAttenuation = 0.92f;
        m_fForceFactor = 100f;
        m_fAmplitudeCoeff = 0.1f;
	}
    
    public void FireStarted(byte iMode)
    {
        cCannon.SuperStartFire(iMode);
        m_bFiring = true;
    }
    
    public void FireStopped()
    {
        m_bFiring = false;
    }
    
    /*String GetTip()
    {
        return "Armored transporter [Get In]";
    }*/
    
    public Vector GetPointToLookAt(int nPoint)
    {
        Vector vReturn = GetPosition();
        vReturn.fY += 200f;
        return vReturn;
    }
    
// HACK by AI nie wisialo w powietrzu    
	public void PawnGotIn(SeatInfo info, Pawn pawn)
	{
        super.PawnGotIn(info, pawn);
        
        if (!m_bModuleNet)
        {
            ImplantTermovision.RemoveFromSystem(pawn);
            pawn.EnableRendering(false);
            if (pawn.ActiveWeapon != null) 
                pawn.ActiveWeapon.EnableRendering(false);
        
            pawn.ClearFlag(EFlags._COLLISION);
            pawn.ClearFlag(EFlags._BLOCK_TRACE);
            pawn.ClearFlag(EFlags._BLOCK_MOVE);
        }
		pawn.fDamageThreshold = 100000f;
	}
	
	/** komunikat wysylany przez pawnera informujacy, ze wysiadl on z pojazdu */
	public void PawnGotOut(SeatInfo info, Pawn pawn)
	{
        super.PawnGotOut(info, pawn);
        
        if (!m_bModuleNet)
        {
            pawn.EnableRendering(true);
            if (pawn.ActiveWeapon != null) 
                pawn.ActiveWeapon.EnableRendering(true);
            ImplantTermovision.AddToSystem(pawn);
        
            pawn.SetFlag(EFlags._COLLISION);
            pawn.SetFlag(EFlags._BLOCK_TRACE);
            pawn.SetFlag(EFlags._BLOCK_MOVE);
        }
		pawn.fDamageThreshold = 0f;
    }
    
    /*public void Die()
    {
        super.Die();
        
        DeactivateChildren();
    }*/
    
    void VehicleCrashed()
    {
        super.VehicleCrashed();
        
        DeactivateChildren();
    }
    
/*	
	public void Display()
	{
		Vector vStartPos = GetFirstFreeSeat(EPassengerRole._VEHICLE_DRIVER).GetStartPos();
		MeshObject cMesh = (MeshObject) CreateObject("MeshObject");
		cMesh.LoadMesh("data/interface/choragiewka.3da");
		GetModule().AddControlObject(cMesh);
		cMesh.ClearFlag(EFlags._COLLISION);
		cMesh.SetLighting(true);
		cMesh.EnableRendering(true);
		cMesh.SetFlag(EFlags._PORTAL_INDEPENDENT);
		cMesh.SetPositionWorld(vStartPos);
	}
*/	
/* do testowania pozycji startowej i siedzenia
MeshObject mesh = null;    
void start()
{
    if (mesh == null)
    {
        mesh = Tools.AddHelperMesh(this, Tools._HM_MESH_EXCLAMATION);
        mesh.ActivateOnModule();
    }
    mesh.SetPositionWorld( GetFirstFreeSeat(EPassengerRole._VEHICLE_ANY).GetStartPos() );
    mesh.EnableRendering(true);
}

void seat()
{
    if (mesh == null)
    {
        mesh = Tools.AddHelperMesh(this, Tools._HM_MESH_EXCLAMATION);
        mesh.ActivateOnModule();
    }
    mesh.SetPositionWorld( GetFirstFreeSeat(EPassengerRole._VEHICLE_ANY).GetSeatPos() );
    mesh.EnableRendering(true);
}
*/
}