/** Klasa jeepa wyposazonego w automatycznie sterowane dzialko
 */
public class Jeep extends VehicleAttacker
{
    Jeep()
    {
        //#DEF_BEGIN
        ScreenshotIconPath = "data/textures/icons/icon_jeep.png";
        //#DEF_END
        
		// dzwieki
        m_sSoundStartName = "Data/Sounds/Vehicles/JeepEngineStart";
        m_sSoundLoopName  = "Data/Sounds/Vehicles/JeepEngineLoop";
        m_sSoundStopName  = "Data/Sounds/Vehicles/JeepEngineStop";
        LoadSoundParams("Data/Sounds/Vehicles/Jeep.scr");
        
        m_fSoundLoopMin = 2500.f;
        m_fSoundLoopMax = 7500.f;
        
        m_sSoundAccelName = "Data/Sounds/Vehicles/VehicleAccelBrakeGravel";
		m_sSoundBrakeName = "Data/Sounds/Vehicles/VehicleAccelBrakeGravel";
        m_sSoundSlideName = "Data/Sounds/Vehicles/VehicleSlideGravel";
		
        m_fSoundVehicleStartDuration = 1.1348753f;
        
	    fBlobMapSize = 220f;
	    sBlobMaterial = "blobs_jeep.mat";
                
        MeshName = "Data/Meshes/Vehicles/Jeep.3da";
        
        fHealth = fMaxHealth = 2000.0f;
        fDamageThreshold = 40.f;
        fFireDamage = 100;
        fRateOfFire = 600;
        
		m_fOverCannonHeightShoot = 70f;
		m_fFromCannonBackShoot = 120f;
		
		m_aSpeeds = new float[] { 0f, 210f, 630f, 1050f, 1575f, 2100f };
        
		m_fCannonMaxVAngle = 20f;
        
        m_iStampSize = 11;
        
        m_sWreckMeshName = "Data/Meshes/Vehicles/JeepWreck2.3da";
        
        m_vPositionModifier = new Vector(0f, 100f, 0f);
	}

	void OnCreate()
    {
        super.OnCreate();

		DeleteAllSeatsInfos();
        SeatInfo seat = new SeatInfo(this, "Driver", EPassengerRole._VEHICLE_DRIVER,
								 EGetInOutAnimType._LEFT_SIDE);
        seat.m_fBeginPosRadius = 300.f;
		AddSeatInfo(seat);
        seat = new SeatInfo(this, "Passenger", EPassengerRole._VEHICLE_PASSENGER,
								 EGetInOutAnimType._RIGHT_SIDE);
        seat.m_fBeginPosRadius = 300.f;
		AddSeatInfo(seat);

        if (m_Physics != null)
		{
			m_Physics.m_Params._TIME_BETWEEN_SLIDE_SOUNDS = 0.15f;
			m_Physics.m_Params._TIME_BETWEEN_ACCEL_SOUNDS = 0.1f;
            
            m_Physics.m_Params._SLIDE_COEF = 1800.0f;
            m_Physics.m_Params._SLIDE_SUPRESS = 1000.0f;
			m_Physics.m_Params._ACCELERATION_COEF = 1800f;
			m_Physics.m_Params._BRAKE_COEF = 3000f;
            m_Physics.m_Params._TREE_HIT_SUPR = 0.2f;
        
            m_Physics.m_Params._TURNING_SPEED = 2000.0f;
            m_Physics.m_Params._MAX_TURN_ANGLE = 90.0f;
            
			m_Physics.m_Params._WHEEL_MOVE_SPEED_COEF = 1f;

            m_Physics.m_Params._HORIZ_DEV_ACCEL = 50f;
            
            m_Physics.sWheelSmokeFX = "SmokeJeep";
    	}
		
		// pobieramy element kierownycy, ktora ma byc podswietlana
        //nKierownicaID = GetElementID("Kierownica");	
        
		String tab[] = { "wahacz_LP", "wahacz_LT", "wahacz_PP", "wahacz_PT" };
		
		for (int i = 0; i < tab.length; i++)
		{
			int iElement = GetElementID(tab[i]);
			if (iElement > -1)
			    SetElementAnimType(iElement, EAnimType._OFF, true);
		}
        
        SetFlag(EFlags._CAST_SHADOWS);
        SetBlobMaterial(sBlobMaterial);
        SetBlobMapSize(fBlobMapSize);

        ClearFlag(EFlags._RECEIVE_SHADOWS);
        
        // by MK, 2002-03-27
        // zeby dobrze odkladaly sie tracey na jeepie
        SetTraceCollType(ECollTraceFlags._HULL);
        SetCollType(ECollFlags.OBJCOL_TYPE_PERFACEOBJECT);
        ClearFlag(EFlags._NO_ANIMATION);
        SetFlag(EFlags._CAST_SHADOWS | EFlags._BLOCK_TRACE);
        SetFlag(EFlags.USE_TERRAIN_LIGHTMAP_FOR_LIGHTING);

        m_fAIControlledCannonVMinAngle = -45f;
        // uwaga: przy wlaczaniu/wylaczaniu fizyki przelaczam sie na OBJCOL_TYPE_ELLIPSOID
        
        sBlowUpFX = "FXJeepBlow";
        
        SetEllipsoidNoExtents(260, 250, 125);

        if (cCannon != null)
            cCannon.SetShotSoundRange(500f, 1500f);
        
        CreateWreck();
    }
    
	void CreatePhysics()
	{
		m_Physics = new PhysicsJeep(this);
        m_Physics.Init();
        m_Physics.sWheelSmokeFX = "SmokeJeep";
        m_Physics.bWheelSmokeFX = true;
        m_Physics.bWheelSmokeRearOnly = false;
        m_Physics.fWheelSmokeShiftY = 15.0f; 
        m_Physics.m_Params._TIME_BTW_SMOKES = 0.1f;
	}

	void DriverIsDead()
	{
	}
	
	void PassengerIsDead()
	{
	}
	
    public Vector GetPointToLookAt(int nPoint)
    {
        Vector vReturn = GetPosition();
        vReturn.fY += 150f;
        return vReturn;
    }
    
	float _MAX_HEIGHT_TO_SHOW_WRECK = 50f;
	boolean CanShowWreck()
	{
		if (m_Physics != null)
		{
			Vector vStart = GetPosition();
			Vector vEnd = new Vector(vStart);
			vEnd.fY -= _MAX_HEIGHT_TO_SHOW_WRECK;
			m_Physics.TestTrack(vStart, vEnd);
			vEnd.Set(m_Physics.m_collInfo.vEnd);
			vEnd.Sub(vStart);
			if (vEnd.Len() < 0.99f * _MAX_HEIGHT_TO_SHOW_WRECK)
				return true;
			else
				return false;
		}
		else
			return true;
	}
	
    void VehicleCrashed()
    {
        super.VehicleCrashed();

		// sprawdzamy, czy przypadkiem pojazd nie zostal zniszczony w powietrzu
		if (CanShowWreck())
	        ShowWreck();
		
        // wlaczamy update pathmapy
        if (m_iStampSize > 0)
        {
            if (!IsUpdatingPathMap())
                UpdatePathMap(true, m_iStampSize, true);
        }
    }
        
    public class CrashedState extends Vehicle.CrashedState
    {
        public void DisableAllActivities()
        {
            EnableRendering(false);
            DeactivateOnModuleAlways();
            DisableCallMethods();
        
            StopFXSmokeUpdate();
            if ((m_Wreck != null) && (m_bWreckVisible))
                StartFXSmokeUpdate();
            
            CallMethodIn("DeleteAttachedFXes", 10f);
        }
    }
    
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[Jeep.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_VEHICLE)
        {	
			super.SGLoadChunk(cFC);
            
			if (cFC.LoadBool())
				m_Wreck = (VehicleWreck) cFC.LoadObject(m_Wreck, this);
            m_bWreckVisible = cFC.LoadBool();
        }
		
		cFC.delete();
    }
    
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[Jeep.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_VEHICLE, cFCParent);
		
		super.SGSaveChunk(cFC);

		cFC.SaveBool(m_Wreck != null);
		if (m_Wreck != null)
			cFC.SaveObject(m_Wreck);
        cFC.SaveBool(m_bWreckVisible);
        
        cFC.delete();
    }	    			
    
	public void SGUpdate()
	{
		FileChunk.Log("[Jeep.SGSaveChunk]\n");
		
		super.SGUpdate();

		if (m_bWreckVisible)
            ShowWreck();
	}
    
    boolean m_bLocalPlayerPassenger = false;
    
	public void PawnGotIn(SeatInfo info, Pawn pawn)
	{
        super.PawnGotIn( info, pawn );
        
		if (info.GetRole() == EPassengerRole._VEHICLE_PASSENGER)
        {
            Pawn cPassenger = GetFirstOccupant( EPassengerRole._VEHICLE_PASSENGER );
            
            m_bLocalPlayerPassenger = ((cPassenger != null) && 
                                       (cPassenger.bNetIsOwner));
        }
	}
	
	public void PawnGotOut(SeatInfo info, Pawn pawn)
	{
        super.PawnGotOut( info, pawn );
        
		if (info.GetRole() == EPassengerRole._VEHICLE_PASSENGER)
        {
            m_bLocalPlayerPassenger = false;
        }
	}
}
