public class PhysicsWalker extends PhysicsVehicle
{
    Walker m_cWalker = null;
    
    PhysicsWalker(Walker cWalker)
	{
		super( cWalker );
        
        m_cWalker = cWalker;
                
        //zeby odbicia po kolizjach byly mniejsze
        m_Params._TREE_HIT_SUPR = 1.0f; //15.0f
    }

    void MoveVehicle()
    {
        if ( !m_bWalkEnabled )
        {
            m_nAnim = -1;
            return;
        }
        
        super.MoveVehicle();
                
        int    nAnim = Walker.A_STAND;
        
        float fTurn = m_fTurnLeft-m_fTurnRight;
        if ( fTurn != 0.0f )
        {
            Vector vUp = new Vector(m_vVehicleRight);
			if (m_fCurrSpeed < 0.0f) 
				vUp.Negate(); // jezeli jedzie do tylu, to skreca przeciwnie
			vUp = m_vVehicleForward.Cross(vUp);
            
            m_vVehicleForward = m_Vehicle.RotateVector( m_vVehicleForward,
											            m_Params._ROTATE_SPEED * fTurn * m_fFrameTime,
											            vUp );
            nAnim = fTurn > 0.0f ? 
                    Walker.A_ROTATE_LEFT : Walker.A_ROTATE_RIGHT;
        }
        
        if (m_bPhysicsCalcOnly)
            return;
        
        if ( m_fCurrSpeed != 0.0f )
        {
            nAnim = m_fCurrSpeed > 0.0f ? 
                    Walker.A_FORWARD : Walker.A_BACKWARD;
        }
        
        if ( m_nAnim != nAnim )
        {
            m_cWalker.PlayAnimLoop( nAnim, nAnim != Walker.A_STAND ); 
            m_nAnim = nAnim;
        }
	}
    
    int m_nAnim = -1;
    
    void TurnRightHAngle(boolean bRight)
    {
    }
    
    private
    boolean m_bWalkEnabled = false;
    boolean IsWalkEnabled(){ return m_bWalkEnabled; }
    void    EnableWalk(boolean bEnable) { m_bWalkEnabled = bEnable; }
	
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[PhysicsWalker.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_PHYSICS_WALKER)
        {	
			super.SGLoadChunk(cFC);
			m_cWalker = (Walker)cFC.LoadObjectRef();
			//m_nAnim = cFC.LoadInt();
			m_bWalkEnabled = cFC.LoadBool();			
        }
		
		cFC.delete();
    }
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[PhysicsWalker.SGSaveChunk]\n");
		
        FileChunk cFC = GameObject.NewChunk(ESGChunksChrome._CHK_PHYSICS_WALKER, cFCParent);
		
		super.SGSaveChunk(cFC);
		
		cFC.SaveObjectRef(m_cWalker);
		//cFC.SaveInt(m_nAnim);
		cFC.SaveBool(m_bWalkEnabled);
				
		cFC.delete();
    }	    				
	
	public void SGUpdate() {}	
}
