public class VehiclePhysicsState
{
    Vector m_vVehicleUpState = new Vector();
    Vector m_vVehicleForwardState = new Vector();
    Vector m_vVehiclePosState = new Vector();
    
    boolean m_bUpdatingPathMap = false;
    
    float m_fFrameTime = 0f;
    float m_fNowTime = 0f;
    float m_fAccelerate = 0f;        
    float m_fBrake = 0f;
    float m_fTurnRight = 0f;
    float m_fTurnLeft = 0f;
    float m_fFlyingTime = 0f;
    float m_fCurrSpeed = 0f;        
    float m_fCurrDirAngle = 0f;
    float m_fMoveSpeed = 0f;
    float m_fCurrGravity = 0f;
    float m_fCurrVehicleVAngle = 0f;
    float m_fCurrVehicleHAngle = 0f;   
    float m_fLandingTime = 0f;
    float m_fFuel = 0f;
    
    Vector m_vVehicleNormal = new Vector();
    Vector m_vVehicleRight = new Vector();
    Vector m_vVehicleTForward = new Vector();
    Vector m_vVehicleTNormal = new Vector();
    Vector m_vTurningSlide = new Vector();
    Vector m_vVehicleForward = new Vector();
    Vector m_vSlideVector = new Vector();
    Vector m_vCollisionVector = new Vector();
    Vector m_vMoveDir = new Vector();
    Vector m_vVehiclePosition = new Vector();        
    boolean m_bEnableBack = false;
    boolean m_bIsFlyingOnFrame = false;
    boolean m_bCheckCollision = false;
    boolean m_bRecalculateMove = false;
    boolean m_bLanding = false;
    boolean m_bFlying = false;
    CollInfo m_collInfo = new CollInfo();
    
    //dla Walkera
    boolean m_bWalkEnabled = false;

    float m_fLastYPos = 0f;
    
    void SavePhysicsState(PhysicsVehicle physics)
    {
        m_bUpdatingPathMap = physics.m_Vehicle.IsUpdatingPathMap();
        
        if ( (m_bUpdatingPathMap) && (physics.m_Vehicle.m_iStampSize > 0) )
            physics.m_Vehicle.UpdatePathMap(false, physics.m_Vehicle.m_iStampSize, true);
        
        physics.m_Vehicle.GetUpVector(m_vVehicleUpState);
        physics.m_Vehicle.GetForwardVector(m_vVehicleForwardState);
        physics.m_Vehicle.GetPosition(m_vVehiclePosState);
        
        m_fFrameTime = physics.m_fFrameTime;
        m_fNowTime = physics.m_fNowTime;
        m_fAccelerate = physics.m_fAccelerate;
        m_fBrake = physics.m_fBrake;
        m_fTurnRight = physics.m_fTurnRight;
        m_fTurnLeft = physics.m_fTurnLeft;
        m_fFlyingTime = physics.m_fFlyingTime;
        m_fCurrSpeed = physics.m_fCurrSpeed;
        m_fCurrDirAngle = physics.m_fCurrDirAngle;
        m_fMoveSpeed = physics.m_fMoveSpeed;
        m_fCurrGravity = physics.m_fCurrGravity;
        m_fCurrVehicleVAngle = physics.m_fCurrVehicleVAngle;
        m_fCurrVehicleHAngle = physics.m_fCurrVehicleHAngle;   
        m_fLandingTime = physics.m_fLandingTime;
        m_fFuel = physics.m_Vehicle.fFuel;
        m_vVehicleNormal.Set(physics.m_vVehicleNormal);
        m_vVehicleRight.Set(physics.m_vVehicleRight);
        m_vVehicleTForward.Set(physics.m_vVehicleTForward);
        m_vVehicleTNormal.Set(physics.m_vVehicleTNormal);
        m_vTurningSlide.Set(physics.m_vTurningSlide);
        m_vVehicleForward.Set(physics.m_vVehicleForward);
        m_vSlideVector.Set(physics.m_vSlideVector);
        m_vCollisionVector.Set(physics.m_vCollisionVector);
        m_vMoveDir.Set(physics.m_vMoveDir);
        m_vVehiclePosition.Set(physics.m_vVehiclePosition);
        m_bEnableBack = physics.m_bEnableBack;
        m_bIsFlyingOnFrame = physics.m_bIsFlyingOnFrame;
        m_bCheckCollision = physics.m_bCheckCollision;
        m_bRecalculateMove = physics.m_bRecalculateMove;
        m_bLanding = physics.m_bLanding;
        m_bFlying = physics.m_bFlying;
        if (physics.m_collInfo != null)
            m_collInfo = new CollInfo(physics.m_collInfo);
        else
            m_collInfo = null;
        
        //lata na sejwowanie stanu fizyki walkera, nie jest
        // to zbyt elegancki sposob, ale w nocy mi nic nie przychodzi do glowy
        if ( physics instanceof PhysicsWalker )
            m_bWalkEnabled = ((PhysicsWalker)physics).IsWalkEnabled();
        
        m_fLastYPos = physics.m_fLastYPos;
    }
    
    void RestorePhysicsState(PhysicsVehicle physics)
    {
        physics.m_Vehicle.FromUpForwardPos(m_vVehicleUpState, m_vVehicleForwardState, m_vVehiclePosState);
        
        if ( (m_bUpdatingPathMap) && (physics.m_Vehicle.m_iStampSize > 0) )
            physics.m_Vehicle.UpdatePathMap(true, physics.m_Vehicle.m_iStampSize, true);
        
        physics.m_fFrameTime = m_fFrameTime;
        physics.m_fNowTime = m_fNowTime;
        physics.m_fAccelerate = m_fAccelerate;
        physics.m_fBrake = m_fBrake;
        physics.m_fTurnRight = m_fTurnRight;
        physics.m_fTurnLeft = m_fTurnLeft;
        physics.m_fFlyingTime = m_fFlyingTime;
        physics.m_fCurrSpeed = m_fCurrSpeed;
        physics.m_fCurrDirAngle = m_fCurrDirAngle;
        physics.m_fMoveSpeed = m_fMoveSpeed;
        physics.m_fCurrGravity = m_fCurrGravity;
        physics.m_fCurrVehicleVAngle = m_fCurrVehicleVAngle;
        physics.m_fCurrVehicleHAngle = m_fCurrVehicleHAngle;   
        physics.m_fLandingTime = m_fLandingTime;
        physics.m_Vehicle.fFuel = m_fFuel;
        physics.m_vVehicleNormal.Set(m_vVehicleNormal);
        physics.m_vVehicleRight.Set(m_vVehicleRight);
        physics.m_vVehicleTForward.Set(m_vVehicleTForward);
        physics.m_vVehicleTNormal.Set(m_vVehicleTNormal);
        physics.m_vTurningSlide.Set(m_vTurningSlide);
        physics.m_vVehicleForward.Set(m_vVehicleForward);
        physics.m_vSlideVector.Set(m_vSlideVector);
        physics.m_vCollisionVector.Set(m_vCollisionVector);
        physics.m_vMoveDir.Set(m_vMoveDir);
        physics.m_vVehiclePosition.Set(m_vVehiclePosition);
        physics.m_bEnableBack = m_bEnableBack;
        physics.m_bIsFlyingOnFrame = m_bIsFlyingOnFrame;
        physics.m_bCheckCollision = m_bCheckCollision;
        physics.m_bRecalculateMove = m_bRecalculateMove;
        physics.m_bLanding = m_bLanding;
        physics.m_bFlying = m_bFlying;
        if (m_collInfo != null)
            physics.m_collInfo = m_collInfo;
        else
            physics.m_collInfo = null;
        
        //lata na sejwowanie stanu fizyki walkera, nie jest
        // to zbyt elegancki sposob, ale w nocy mi nic nie przychodzi do glowy
        if ( physics instanceof PhysicsWalker )
            ((PhysicsWalker)physics).EnableWalk( m_bWalkEnabled );
        
        physics.m_fLastYPos = m_fLastYPos;
    }
}
