public class WalkerLight extends Walker
{
    WalkerLight()
    {
        super();                    
        MeshName = "Data/Meshes/Ai/Walker_k.3da";
        
        fHealth    = 
        fMaxHealth = 3000.f;
        fDamageThreshold = 80;
        
        m_fWalkSpeed        = 500.0f;
        m_fWalkSpeedBack    = 250.0f;
        m_fRotateSpeed      = 30.0f;
        //zeby za szybko nie przebieral "nozkami" to zwalniamy animacje
        m_fWalkAnimSpeedMul = 0.75f;
        
        m_sVertRotateElem  = "Walker Neck";
        m_sHorizRotateElem = "Walker Head";
        m_sMeshElementToLookAt = "Walker Cockpit";
		                
        m_aWalkerAnimsSounds = new String[] {
                                  null, //A_STAND
                                  null, //A_FORWARD
                                  null, //A_BACKWARD
                                  null, //A_ROTATE_LEFT
                                  null, //A_ROTATE_RIGHT
                                  "Data/Sounds/Walker/Walker_Standby_k", //A_NORMAL2STANDBY
                                  null, //A_STANDBY
                                  "Data/Sounds/Walker/Walker_OpenCabin_k", //A_STANDBY2STANDBY_OPEN
                                  null, //A_STANDBY_OPEN
                                  "Data/Sounds/Walker/Walker_CloseCabin_k", //A_STANDBY_OPEN2STANDBY
                                  "Data/Sounds/Walker/Walker_WakeUp_k", //A_WAKEUP
                                  "Data/Sounds/Walker/Walker_NormUp_k", //A_NORMAL2UP
                                  null, //A_UP
                                  "Data/Sounds/Walker/Walker_UpNorm_k", //A_UP2NORMAL
                                  "Data/Sounds/Walker/Walker_NormDown_k", //A_NORMAL2DOWN
                                  null, //A_DOWN
                                  "Data/Sounds/Walker/Walker_DownNorm_k"  //A_DOWN2NORMAL
                                  };

        m_sStepSound = "Data/Sounds/Walker/Walker_Walk_k";
        m_sHeadLoopSound = "Data/Sounds/Walker/Walker_HeadLoop_k2";
        
        // elementy glowy (do ukrycia po smierci)
        m_aHeadElements = new String[] { "Walker Head", "Walker Gun", "Walker Inside",
                             "Walker Cockpit", "WW_Fotel", "Walker Pane"};
        
        fBlowUpShakeStrength = 400;
        fBlowUpShakeDistMin = 200;
        fBlowUpShakeDistMax = 2000;
	}
    
    public void OnCreate()
    {
        super.OnCreate();
        
		DeleteAllSeatsInfos();
        SeatInfo seatInfo = new SeatInfo(this, "Driver", EPassengerRole._VEHICLE_DRIVER,
                                         EGetInOutAnimType._UNKNOWN, new Vector(0, 0, 50));
        seatInfo.m_fBeginPosRadius = 300f;
        AddSeatInfo(seatInfo);
    }
    
    void CreateWeapons()
    {
        CreateNewWeapon( WeaponWalker_k.class , 
                         "Barel", 
                         WeaponWalker._MODE_PRIMARY );
    }
    
    public void PawnGotIn(SeatInfo info, Pawn pawn)
	{
		super.PawnGotIn( info, pawn );
	}
}
