import java.lang.Math;

public class Player extends PawnAnimated implements ipar_Gravity, ipar_Camouflage, ipar_VisibilityFactor, ipar_FallDamage
{
    LightObject cLightWeapon = null;
    
    Player thisPlayer = this;

    /** Stan implantow playera przekazywane z mapy na mape */
	ImplantSystem cImplantSystem = null;

    //czy gracz ma uzywac bezwladnosci chodzenia?
    boolean m_bUseWalkDestSpeed = true; // not SG
    
    boolean m_bCanRunWithHeavyGun = false;
    
    // czy gracz moze skrecac(sterowac) w locie 
    // nie moze
    final static int _CANTURNONFLYING_FALSE = 0;                            
    // moze tylko podczas skokow z miejsca
    final static int _CANTURNONFLYING_FROMSTANDING = 1;                     
    // moze zawsze
    final static int _CANTURNONFLYING_ALWAYS = 2;                           
    
    int m_iCanTurnOnFlying = _CANTURNONFLYING_FROMSTANDING;
    
    //czy gra moze biegac do tylu
    boolean m_bCanRunBackward = false;

    //bron ktora gracz ma ZAWSZE po "urodzeniu" i nie moze sie jej pozbyc
    static Class GetInbornWeaponClass(){ return WeaponHands.class; }
    
    // aktualne motion.iSpeed 
    // zapamietywane przy kazdej zmianie elipsoidy (do resymulacji w sieci)
    int m_iSpeed = 0; // not SG
    
    // zamiennik motion.bFiring
    byte nFiring = Weapon._NO_FIRING;

    //do testow odczytuje inne klawisz
    boolean bTestCheckAimingKeyState = false;

    //mowi czy jestesmy w trakcie zeskoku z drabiny (wtedy nie mozemy sie do niej podlaczyc 
    //z powrotem)
    boolean m_bJumpingOffLadder = false;
    
    /**
     * Czy gracz ma automatycznie przeladowywac 
     * po skonczeniu sie amunicji?
     */
    boolean m_bAutoReload       = true;
    
    /**czy wlasnie nie zaczelismy uzywac triggera, uzycie triggera jest na callmethodin(..., 0),
     * i na ten czas (od wywolania call... do konca metody ExecugeTrigger) ta zmienna jest true
     */
    boolean m_bExecutingTrigger = false;
    
    int m_nOnFrameDelay = 0;
    
    Player()
    {
        super();

        MeshName = "Data/Meshes/Logan/logan.3da";
        //sAnimIniFile = "Data/Meshes/Logan/logan.scr";
        //sAnimIniFile = "Data/Meshes/AI/HSoldier.scr";
        
        nTeamID = -10000; //pro-player team
		
		cConflictSide = new EnumConflictSide(EnumConflictSide._PRO_PLAYER);
        
        fMaxHealth = 800.0f;
        
        bIsAITarget = true;
        
        bSG = true;
        
        fTargetImportance = 75f;
    }

    public void Appear(ControlObject cDestinationObj)
	{
        if (cDestinationObj != null && 
            cDestinationObj.IsActiveOnModule())
        {
            FromUpForwardPos(cDestinationObj.GetUpVectorVolatile(),
                             cDestinationObj.GetForwardVectorVolatile(),
                             cDestinationObj.GetPositionVectorVolatile());
            
            // dodatkowo zabezpieczamy sie na wypadek przeniesienia
            // podczas skoku
            vLastPosOnGround = GetPosition();
        }
        
        ShowPlayer(true);
	}
    public void Disappear(ControlObject cDestinationObj)
	{
        if (cDestinationObj != null && 
            cDestinationObj.IsActiveOnModule())
        {
            FromUpForwardPos(cDestinationObj.GetUpVectorVolatile(),
                             cDestinationObj.GetForwardVectorVolatile(),
                             cDestinationObj.GetPositionVectorVolatile());
        }
		
        ShowPlayer(false);
	}

    /** implementacja ipar_Gravity
     */
    public void ChangeGravity(float fGravity, float fJumpStrength)
    {
		fMass = fGravity;
		JUMP_STRENGTH = fJumpStrength;
    }
    
    
    public void ChangeConflictSide(int nNewConflictSide)
    {
        // nadpisane, zeby nie popelnic bledu przy wpisywaniu z konsoli
        if (nNewConflictSide == EnumConflictSide._COUNTER_PLAYER ||
            nNewConflictSide == EnumConflictSide._NEUTRAL ||
            nNewConflictSide == EnumConflictSide._PRO_PLAYER)
        {
            cConflictSide = new EnumConflictSide(nNewConflictSide);
        }
    }
	
///////////////////////////////////////////////////////////////////////////////
// A T R Y B U T Y
///////////////////////////////////////////////////////////////////////////////

    ///////////////////////////////////////////////////////////////////////////
    // Parametry fizyczne gracza
    ///////////////////////////////////////////////////////////////////////////

    // float fEllipsoidPos[]    = { 84.972f  , 20.0f  , 20.0f  , 65.0f  , 84.972f  , 84.972f };
    // float fEllipsoidHeight[] = { 84.972f*2, 20.0f*2, 20.0f*2, 65.0f*2, 84.972f*2, 84.972f*2 };
    // zachar - 01.08.2003 - powiekszylem ellipsoide w pionie, bo pol glowy loganowi wystawalo ponad nia i czasem zagladal przez sufit
    //                       jakby byly z czyms problemy to do mnie...
    
    // rozmiary ellipsoidy     ( still    , swim   , crawl  , duck   , walk     , run )
    float fEllipsoidPos[]    = { 86.5f    , 20.0f  , 20.0f  , 65.0f  , 86.5f    , 86.5f };
    float fEllipsoidHeight[] = { 86.5f*2  , 20.0f*2, 20.0f*2, 65.0f*2, 86.5f*2  , 86.5f*2 };
    float fEllipsoidRadius[] = { 39.7f    , 39.7f  , 39.7f  , 39.7f  , 39.7f    , 39.7f };

    //(still, swim, crawl, duck, walk, run, )
    //kat pod jaki mozemy sie wspinac
    //float fMaxClimbAngle[] = {.0f, 10.0f, 35.0f, 55.0f, 55.0f, .0f};
    float fMaxClimbAngle[] = {.0f, 0.0f, 60.0f, 30.0f, 30.0f, 30.0f};
    //float fMaxClimbAngle[] = {.0f, 0.0f, 75.0f, 65.0f, 65.0f, 65.0f};
    
    /** Pozycje rozpoczecia wyrzucania granata w trybie normalnym dla poszczegolnych wartosci iSpeeda w MotionState
     *  (powinno byc wewnatrz elipsoidy gracza, zeby zapobiec efektowi przenikania granatow przez sciany)
     */
    final static Vector[] aGrenadeThrowStartPosNormal = { 
        new Vector(0, 90,  0), /* still */
        new Vector(0, 20,  0), /* swim */
        new Vector(0, 20,  0), /* crawl */
        new Vector(0, 50,  0), /* duck */
        new Vector(0, 90,  0), /* walk */
        new Vector(0, 90,  0), /* run */
    };

    /** Pozycje zakonczenia wyrzucania granata w trybie normalnym dla poszczegolnych wartosci iSpeeda w MotionState
     */
    final static Vector[] aGrenadeThrowEndPosNormal = { 
        new Vector(-10, 165, 30), /* still */       //new Vector(-65, 185, 30), /* still */
        new Vector(-10, 40,  100), /* swim */        //new Vector(-30, 40, 100), /* swim */
        new Vector(-10, 40,  100), /* crawl */       //new Vector(-30, 40, 100), /* crawl */
        new Vector(-10, 90,  70), /* duck */        //new Vector(-50, 105, 70), /* duck */
        new Vector(-10, 165, 30), /* walk */        //new Vector(-65, 185, 30), /* walk */
        new Vector(-10, 165, 30), /* run */         //new Vector(-65, 185, 30), /* run */
    };
    
    /** Pozycje rozpoczecia wyrzucania granata w trybie alternate dla poszczegolnych wartosci iSpeeda w MotionState
     *  (powinno byc wewnatrz elipsoidy gracza, zeby zapobiec efektowi przenikania granatow przez sciany)
     */
    final static Vector[] aGrenadeThrowStartPosAlt = { 
        new Vector(0, 50,  0), /* still */
        new Vector(0, 40,  0), /* swim */
        new Vector(0, 40,  0), /* crawl */
        new Vector(0, 50,  0), /* duck */
        new Vector(0, 50,  0), /* walk */
        new Vector(0, 50,  0), /* run */
    };

    /** Pozycje zakonczenia wyrzucania granata w trybie alternate dla poszczegolnych wartosci iSpeeda w MotionState
     */
    final static Vector[] aGrenadeThrowEndPosAlt = { 
        new Vector(-10, 50, 30), /* still */     //new Vector(-65, 50, 30), /* still */     
        new Vector(-10, 40, 100), /* swim */     //new Vector(-30, 40, 100), /* swim */     
        new Vector(-10, 40, 100), /* crawl */    //new Vector(-30, 40, 100), /* crawl */    
        new Vector(-10, 50, 70), /* duck */      //new Vector(-50, 50, 70), /* duck */      
        new Vector(-10, 50, 30), /* walk */      //new Vector(-65, 50, 30), /* walk */      
        new Vector(-10, 50, 30), /* run */       //new Vector(-65, 50, 30), /* run */       
    };
    
    
    //cos kata maksymalnego obrotu ciala Logana na boki 
    // po przekroczeniu tego kata dostawia nogi
    float fCosMaxHRotation = .5f;

    /** informacje o graczu potrzebne do inicjalizacji
     * ustawiane przed zawolaniem OnCreate() */
    GameInitInfo cGameInitInfo = null;

    ///////////////////////////////////////////////////////////////////////////
    // Tryb FPP
    ///////////////////////////////////////////////////////////////////////////

    /** Animacje dla dloni FPP */
    BaseAnimations HandsAnims = null;

    /** Aktualne animacje */
    BaseAnimations Anims = null;

    ///////////////////////////////////////////////////////////////////////////
    // Parametry grywalnosciowe gracza 
    ///////////////////////////////////////////////////////////////////////////

    /** Czas potrzebny na przycelowanie */
    public static float fAimingTime = .75f; // not SG

    /** Zoom, gdy nie ma zooma... */
    public float fEyeZoomingFactor = 1.f; // not SG

    // aktualnie wyliczona celnosc strzelania - interpolowana
    public float fCurrentAccuracy = 0;
    
    // celnosc docelowa obliczona przez CalulateAccuracy
    public float fDestAccuracy = 0;

    /** Max kat rozrzutu po trafieniu pociskiem */
    public float fDamageRecoil = 0.05f;
    
    /** predkosc zmiany celnosci */
    float fAccuracyChangeSpeed = 30.0f;

    /** Maksymalne rozwarcie celnosci */
    float fAccuracyMax = 12.f;
    
    float fRunJumpAccMult        =   1.6f;
    float fWalkSnakeAccMult      =   1.25f;
    float fDuckSnakeAccMult      =   0.8f;

    //TODO ale moze nie bedzie potrzebne
    float fInjuryAccMult         =   2.0f;

    /** przemnoznik szybkosci poruszania sie 
     *  UWAGA: po zmianie nalezy zawolac UpdateSpeed() */
    public float fSpeedMult      =   1.0f; // zmieniany przez DrugSpeed
    
    
    /** Sila wybicia sie do skoku */
    static float JUMP_STRENGTH = 1690f;//1600f;

    /** Odleglosc, z ktorej mozna walic kolba */
    static float DIST_BUTT_HIT  = 100f;

    /** Odstep czasu miedzy sondowaniem */
    float fProbeInterval = .1f;

    /** Czas ostatniego sondowania */
    protected float fLastProbe = 0.0f;

    /** czy gracz nosi na sobie ubranie wroga (patrz level 09 i kombinezon pilota...) */
    public boolean bCamouflage = false;//#PLAYER;Is player wearing enemy clothes to avoid detection

    /** Zmniejszenie obrazen od blast damagea jak gracz lezy */
    public float fCrawlBlastDamageMult = 0.6f;
    
    ///////////////////////////////////////////////////////////////////////////
    // Paramtery zwiazane z kamera
    ///////////////////////////////////////////////////////////////////////////

    /** Kamera przyczepiona do gracza chodzaca za nim */
    CameraPlayer Camera = null;

    /** Zapamietany tryb pracy kamery */
    byte nOldCameraMode = CameraPlayer.CMODE_TPP;
    
    /** Tryb widoku */
    byte nCameraGameMode = Camera.CMODE_FPP;
    

    final byte REN_NONE = -1;
    final byte REN_FULL = 0;
    final byte REN_FPP  = 1;
    final byte REN_SNIPER = 2;

    /** Tryb renderowania
     * - FPP - tylko rece FPP
     * - TPP - cala postac
     */
    byte nRenderMode = REN_FULL;
    
    ///////////////////////////////////////////////////////////////////////////////
    // Poruszanie sie
    ///////////////////////////////////////////////////////////////////////////////    

    /** Predkosc katowa */
    static float TURN_SPEED = 10.0f;

    MotionState newMotion = null; //pomoc - zadany motion

    /**wektor uzywany do celowania horyzontalnego przy malych 
     * katach odchylenia */
    Vector vOldForward = new Vector();

    /** stany klawiszy modyfikujacych sposob ruchu */
    boolean bNetClientAiming = false;
    boolean bWalking = false;
    boolean bDucking = false;
    boolean bCrawling = false;
    boolean bSwimming = false;
	
    boolean bDuckingToggle = false;
    boolean bCrawlingToggle = false;	
    
    boolean bWasSwimming = false;
    boolean bLastSwimming = false;
    
    final static int    _LEANING_LEFT = 0,
                        _LEANING_RIGHT = 1;
    int nLeaning = -1;
    //odrzut (i zwolnienie) po postrzale
    boolean bRecoiling = false;
    
    // FIXIT:tymczasowo, aby nie mozna bylo zmienic broni podczas plywania
    // TODO: poprawic, aby dalo sie zmienic bron podczas plywania
    // i dobrze byly odpalane animacje
    public static boolean sm_bSwimmingCannotChangeWeapon = true;
    
    
    /** Osrodek ruchu */
    int nEnvironment = EMoveEnv.CHMOVE_GROUND;

    /**
     */
    byte nFiringState = Weapon._NO_FIRING;
    
    /** flaga, ktora jest true w czasie przechodzenia miedzy stanami 
     * uniemozliwiajacymi akcje.
     * [Akcja w tym znaczeniu to nacisniecie klawisza, ktory zmienia stan - 
     * puszczenie go nie ma znaczenia (stzelanie,
     * reload, zmiana broni, skakanie itp.)]*/
    boolean bUnableToAct = false;

    /** ograniczenie ruchow (wykorzystywane w czasie odgrywania filmow - 
     * Logan moze sie ruszac tylko troche
     */
    boolean bLimitMoves = false;
    
    /**true w czasie bycia burbotem..
     */
    boolean bBurbotMode = false;

    /** flagi zwiazane z szukaniem drabin
     * szukanie wejscia na drabine */
    boolean bCheckForLadder = false;

    /** szukanie wyjscia z drabiny */
    boolean bCheckForLadderExit = false;
    
    // identyfikatory dummiesow do ustawiania broni
    // (uzywane tylko w trybie TPP)

    /** dummies lewej reki */
    int nLeftHandID = -1;

    /** dummies prawej reki */
    int nRightHandID = -1;

    /** Identyfikator mesh elementu root bone */
    int iRootBoneElem;

    /** Kluczowe klatki animacji postaci dla kazdej
     * z metod poruszania. Potrzbene do ustawiania postaci w odpowiedniej
     * pozycji w trybie FPP, kiedy naprawde animowane sa tylko rece. */
    int aAnimFrame[];
    
    /** Animacje, dla ktorych wpisywane sa wartosci do aAnimFrame 
     *  (potrzebne, bo moga pochodzic z roznych plikow) */
    int aAnimFrameSeqenceID[];

    /////////////////////////////////
    // Liczenie skutecznosci broni
    ////////////////////////////////

    /** liczba broni */
    final static int WEAPONS_COUNT = 17;

    /** liczba zabitych z kazdej z broni */
    int aEnemyDeceased[] = new int[WEAPONS_COUNT]; //dyn

    /** nazwa najlepszej broni */
    String sBestWeapon = "Hands"; //dyn

    /** Index w tablicy aEnemyDeceased najlepszej broni */
    int nBestWeapon = 0; //dyn

    /** liczba fragow z najlepszej broni  */
    int nBestWeaponDeceased = 0; //dyn
    
    ///////////////////////////////////////////////////////////////////////////////
    // Pomocnicze
    ///////////////////////////////////////////////////////////////////////////////    

    /** Lornetka */
    Binoculars cBinoculars = null;
    
    /** Bron, ktora nalezy wyciagnac */
    protected Weapon WeaponToUse;
    
    /** */
    Zoomer cZoomer = null;

        
    /** Wektor przesuniecia wywolanego przez Recoil broni.
     * Wspolrzedne x,y zawieraja obroty gracza w poziomie i pionie.
     * Gracz jest przywracany do pozycji sprzed strzalu po zakonczeniu serii,
     * po czym wektor jest zerowany. (wektor jest zerowany takze po kazdym ruchu
     * myszki) */
    protected Vector vRecoilTranslation = new Vector();

    float fMaxRecoil = 0.25f;
    
    static float RAD2DEG = 180.f/(float)Math.PI;
    static float DEG2RAD = (float)Math.PI/180.f;
    static float PIhalf  = (float)Math.PI/2.f;
    static float PIquarter = (float)PIhalf/2.f;

    /**
     */
    int METHOD_MotionModeChanged    = 0;
    int METHOD_StartAiming          = 0;
    int METHOD_WeaponReloaded       = 0;
    int METHOD_WeaponLeft           = 0;
    int METHOD_WeaponGot            = 0;
    int METHOD_UpdateOverloadLevel  = 0;
    int METHOD_StopSlowDown         = 0;
    int METHOD_StopFire             = 0;
    int METHOD_UpdateSpeakerPos     = 0;

    static int CLASS_Ladder         = 0;
    /** Maksymalna ilosc broni jakie gracz moze miec w rekach z modelem fpp.
     * Rozmiar tablicy aWeaponHands */
    private final int nMaxFPPWeapons = 32;
    
    /** Numer ostatnio zapisanego elementu tablicy aWeaponHands */
    int nLastFPPWeapon = 0;
    
    /** Tablica animacji broni FPP */
    BaseAnimations []aWeaponHands = new BaseAnimations[nMaxFPPWeapons];
    
    ///////////////////////////////////////////////////////////////////////////
    // Paramtery potrzebne do statystyk
    ///////////////////////////////////////////////////////////////////////////
    
    /** ilosc obrazen otrzymanych podczas gry */
    float fInjuries = 0.0f;

    
    /** NET:CLIENT i SERVER flaga informujaca o trwajacej resymulacji
     * w trakcie jej trwania zabronione sa pewne operacje na liscie stanow,
     * takze mozna ominac odgrywanie pewnych dzwiekow
     */
    boolean m_bNetResimulate = false;
    
    /**Czas ostatniego zanurkowania pod wode*/
    float m_fLastDivingTime = 0;
    
    /**Czas po jakim wychylenie sie spod wody odpala dzwiek zaczerpywania powietrza*/
    float _UNDERWATER_TIME_TO_BIGBREATH = 5f;
    
    /**Czas po jakim gracz zaczyna tonac*/
    float _UNDERWATER_TIME_TO_DROWN     = 15f;
    
///////////////////////////////////////////////////////////////////////////////
// M E T O D Y
///////////////////////////////////////////////////////////////////////////////

    // metoda zapisuje do podanego wektora pozycje gracza do renderowania
    // w ukladzie lokalnym!!!!
    public void GetLocalRenderingPosition(Vector vTarget)
    {
        if ( vTarget != null ) 
            GetLocalPosition( vTarget );
    }
    
    
    void SetUnderWater(boolean bUnder)
    {
        //CrashLog("SetUnderWater - bUnder="+bUnder+" bUnderWater="+bUnderWater+"\n");
        if (bUnder)
        {
            if (!bUnderWater)
            {
                ChromeModule cMod = (ChromeModule)GetModule();
                //schodzimy pod wode
                DisableCallMethod("StartDrowning");
                CallMethodIn("StartDrowning", _UNDERWATER_TIME_TO_DROWN);
                m_fLastDivingTime = GetTime();
                nFiring = Weapon._NO_FIRING;
                
                //troche to dziwne, ale ta metoda anuluje rzut granatem
                if (ActiveWeapon instanceof WeaponGrenade)
                    ActiveWeapon.InGameMovieStart();
            }
        }
        else
        {
            //wychodzimy z wody
            if (bUnderWater)
            {
                DisableCallMethod("StartDrowning");
                if (GetTime() - m_fLastDivingTime > _UNDERWATER_TIME_TO_BIGBREATH)
                    BigBreath();
                
                if (bNetIsOwner)
                    if (((PlayerHUD)this).HUD != null && ((PlayerHUD)this).HUD.m_HitIndicators != null)
                        ((PlayerHUD)this).HUD.m_HitIndicators.HideDrowning();
                
                DisableCallMethod("Drown");
            }
        }
        bUnderWater = bUnder;
    }
    
    void StartDrowning()
    {
        LogR("I'm DROWNING !!!\n");
        if (bNetIsOwner)
            if (((PlayerHUD)this).HUD != null && ((PlayerHUD)this).HUD.m_HitIndicators != null)
                ((PlayerHUD)this).HUD.m_HitIndicators.ShowDrowning();
        CallMethodEvery("Drown", 1f);
    }
    
    void Drown()
    {
        if (!bInMovie)
            TakeDamage(50, 0, null, null, null, EBones._NON_BONE, EnumDamageType._DROWNING);
    }
    
    void BigBreath()
    {
        AttachOneShotSound("data/sounds/PLAYER/surfaceing_breath.wav");
        
    }
    
    boolean CanFire()
    {
        if (bInMovie)
            return false;
        
        if (ActiveWeapon instanceof WeaponKnife)
            return true;
        else
            return !bUnderWater;
    }
/*
    boolean bInsideBuilding = false;
    
    static Vector l_vStartCIIB = new Vector();
    static Vector l_vEndCIIB = new Vector();
    
    boolean CheckIfInsideBuilding()
    {   
        //poczatek promienia - dol ciala
        GetPosition(l_vStartCIIB);
        l_vStartCIIB.fY += 10.0f;

        //koniec promienia - z przodu
        l_vEndCIIB.Set(0, -350.0f, 0);
        l_vEndCIIB.Add(l_vStartCIIB);
        
        Collision stCollObject = TraceObjectsExclude(l_vStartCIIB, l_vEndCIIB, this);
        
        bInsideBuilding = (stCollObject != null) && (
                          (stCollObject.Obstacle instanceof DoorableObject) ||
                          (stCollObject.Obstacle instanceof Inside) ||
                          (stCollObject.Obstacle instanceof Teleport) ||
                          (stCollObject.Obstacle instanceof DoorsObject) ||
                          stCollObject.Obstacle.IsInPortalObject()
                          );
        return bInsideBuilding;
    }
*/
    
    void OnDestroy()
    {
        super.OnDestroy();
        
        if (cLightWeapon != null)
        {
            DisableCallMethod("DeactivateLight");
            cLightWeapon.delete();
            cLightWeapon = null;
        }
        
        //GrassPusher_UnRegisterPusher(GetMeshElemFromBoneID(EBones._PELVIS));
        
        // kasujemy bronie
        if( aWeaponHands != null)
        {
            for(int i=0; i<aWeaponHands.length; i++)
            {
                BaseAnimations anim = aWeaponHands[i];
                if((anim!=null) && (anim.cMesh != null))
                {
                    anim.cMesh.delete();
                    anim.cMesh = null;
                }
            }
        }
    }

    /*static int nInstances = 0;
    int nNumber = 0;
    static String sTab[] = new String[10];*/
    
    Class m_cImplantSystemClass = ImplantSystem.class;
    
    /** Tworzenie gracza z podaniem tworcy
     */
    public void OnCreate(GameObject cCreator)
    {
        cLightWeapon = (LightObject)CreateObject("LightObject");
        cLightWeapon.EnableDynLight(false);
            
        /*nNumber = nInstances;
        nInstances ++;*/
        cImplantSystem = (ImplantSystem)CreateObject( m_cImplantSystemClass.getName() );
        
        
        
        if(cCreator instanceof ChromeModule)
        {
            // przepisujemy niezbedne dane
            cGameInitInfo = ((ChromeModule)cCreator).cGameInitInfo;
            
            // szybki hack na wczytywanie levelu bez podania GameInitInfo
            if(cGameInitInfo==null)
            {
                ((ChromeModule)cCreator).cGameInitInfo = new GameInitInfoSingle("Data/LevelsSingle_T.scr");
                cGameInitInfo = ((ChromeModule)cCreator).cGameInitInfo;
            }
            
            return;
        }
        
        if(cCreator instanceof ChromeInventoryMenu)
        {
            // przepisujemy niezbedne dane
            cGameInitInfo = ((ChromeInventoryMenu)cCreator).MenuModule.cGameInitInfo;
            return;
        }
        
        /*To sa zwalniajace logi
        if(cCreator==null)
            CrashLog("[Player.OnCreate] null\n");
        CrashLog("[Player.OnCreate] Player created from strange place!\n");
        */
    }
    
    void SetupElementIDs()
    {
        // pobieramy identyfikatory rak do ustawiania broni w rekach
        nLeftHandID = GetElementID("Left_hand");
        nRightHandID = GetElementID("Right_hand");
        if ( nLeftHandID == -1 )
            nLeftHandID = GetElementID("light_hand");
        
        //identyfikator root bone        
        //iRootBoneElem = GetMeshElemFromBoneID(EBones._PELVIS);
        iRootBoneElem = GetElementID("Bip01");
    }
    
    
    
    /** Utworzenie gracza
     */
	public void OnCreate()
    {	
        CLASS_Ladder = GetClassID("Ladder");
        //
        METHOD_MotionModeChanged = RegisterCallMethod("MotionModeChanged");
        METHOD_StartAiming       = RegisterCallMethod("StartAiming");
        METHOD_WeaponReloaded    = RegisterCallMethod("WeaponReloaded");
        METHOD_WeaponLeft        = RegisterCallMethod("WeaponLeft");
        METHOD_WeaponGot         = RegisterCallMethod("WeaponGot");
        METHOD_UpdateOverloadLevel  = RegisterCallMethod("UpdateOverloadLevel");
        METHOD_StopSlowDown      = RegisterCallMethod("StopSlowDown");
        METHOD_StopFire          = RegisterCallMethod("StopFire");
        METHOD_UpdateSpeakerPos  = RegisterCallMethod("UpdateSpeakerPos");

        LogD("\n");
        super.OnCreate();

        CreateSpeaker();
        
        
        //
        //raczki FPP
        //
        //if ( bNetIsOwner )
            InitilizeFPP();
            
        //konfiguracja sposobu animacji kosci    
        SetAnimationType();
        
        SetupElementIDs();
        //
        // dane potrzebne do zmiany ramki kosci w czasie trybu FPP
        // dla podstawowego mesha logana
        //

        
        aAnimFrame = new int[MotionState.SPEED_COUNT];
        aAnimFrameSeqenceID = new int[MotionState.SPEED_COUNT];
        
        
        aAnimFrameSeqenceID[MotionState.SPEED_STILL] = GetAnimID(CharacterAnims.ROOT_BONE, "Rwns");
        aAnimFrameSeqenceID[MotionState.SPEED_SWIM] = GetAnimID(CharacterAnims.ROOT_BONE, "Rcns");
        aAnimFrameSeqenceID[MotionState.SPEED_CRAWL] = GetAnimID(CharacterAnims.ROOT_BONE, "Rcns");
        aAnimFrameSeqenceID[MotionState.SPEED_DUCK] = GetAnimID(CharacterAnims.ROOT_BONE, "Rdns");
        aAnimFrameSeqenceID[MotionState.SPEED_WALK] = GetAnimID(CharacterAnims.ROOT_BONE, "Rwns");
        aAnimFrameSeqenceID[MotionState.SPEED_RUN] = GetAnimID(CharacterAnims.ROOT_BONE, "Rrns");

        for (int i = 0; i < MotionState.SPEED_COUNT; i++)
            aAnimFrame[i] = GetFirstFrame(aAnimFrameSeqenceID[i]);
        
        //jesli aktywny jest implant TENDO AMPLITIFY'S (Implant06)
        /*
        if ( (cInventory.aImplantList != null) &&
             (cInventory.aImplantList.length > 5) &&
             (cInventory.aImplantList[5] != null) && 
             (cInventory.aImplantList[5].bActiveFlag) )
        {
            aMotionVelocity[MotionState.SPEED_RUN]*=1.25f;
            aStrafeVelocity[MotionState.SPEED_RUN]*=1.25f;
        }
        */

        UpdateEllipsoidAndMaxClimbAngle();
        /*
        //kat pod jaki mozemy sie wspinac
        SetMaxClimbAngle(fMaxClimbAngle[motion.iSpeed]);

        // magiczne ustawienia elipsoidy
        SetEllipsoid( fEllipsoidRadius[motion.iSpeed],
                      fEllipsoidHeight[motion.iSpeed],
                      fEllipsoidPos[motion.iSpeed]);
        */

        //domyslnie tryb renderowania calej postaci. wlaczone przeksztalcenia
        //ciala , rendering broni itp..

        CameraModeChanged(CameraPlayer.CMODE_ZERO);

        SetFlag(EFlags._PORTAL_INDEPENDENT);
        ClearFlag(EFlags._CAST_SHADOWS);
        SetCollFlags(ECollFlags.OBJCOL_FLAG_SLIPDOWN);
        
        // flaga, zeby player mogl chodzic tylko gdzieniegdzie
        SetCollFlags(ECollFlags.OBJCOL_FLAG_TESTTERRAINTYPE);
        
        //SetCollAction(ECollFlags.OBJCOL_ACTION_STOP);
        
        // dodawanie inicjalizacji kolejnych rzeczy powinno byc robione z 
        // rozwaga !!!!!!!!!!! tzn. czy dodawana rzecz czasem nie ma 
        // wplywu na siec i czy najbardziej bazowy player ma miec ta rzecz !
        
        // SetWalkAccel(2000);
        
        // statystyki
        for (int i=0; i<WEAPONS_COUNT; i++) aEnemyDeceased[i] = 0;
        
        /////////////////////////////////////////////////////////////////
        // Zmodyfikuj szkielet, zeby mozna bylo dobrze traceowac gracza
        //
        MoveElementBoxSide(GetMeshElemFromBoneID(EBones._SPINE), 0, -10);
        MoveElementBoxSide(GetMeshElemFromBoneID(EBones._SPINE1), 0, -10);
        //
        /////////////////////////////////////////////////////////////////
        
        InitDeathCameraEyeDummy();
        
        //GrassPusher_RegisterPusher(GetMeshElemFromBoneID(EBones._PELVIS), 200.f);
        
        Log("[Player.OnCreate] DONE \n");
    }
    
    void CreateSpeaker()
    {
        m_cPlayerSpeaker = (ControlObject)CreateObject("MeshObject");
        m_cPlayerSpeaker.SetName("SPEAKER");
        ((MeshObject)m_cPlayerSpeaker).LoadMesh("data/interface/KameraTarget.3DA");
        m_cPlayerSpeaker.ActivateOnModule();
        m_cPlayerSpeaker.AttachAsChildTo( this );
        m_cPlayerSpeaker.SetPosition( new Vector( 0.0f, 150.0f, 0.0f ) );
        m_cPlayerSpeaker.ClearFlag(EFlags._COLLISION);
        m_cPlayerSpeaker.ClearFlag(EFlags._BLOCK_TRACE);
        m_cPlayerSpeaker.ClearFlag(EFlags._BLOCK_MOVE);
        ((MeshObject) m_cPlayerSpeaker).EnableRendering(false);
    }
    
    void RemoveSpeaker()
    {
        if (m_cPlayerSpeaker != null)
        {
            m_cPlayerSpeaker.DetachFromParent();
            m_cPlayerSpeaker.delete();
            m_cPlayerSpeaker = null;
        }
    }
    
    void SetAnimationType()
    {
        SetAnimType(EBones._SPINE, (byte)(EAnimType._SEQUENCE | EAnimType._TRANSFORM), false);
        SetAnimType(EBones._SPINE1, (byte)(EAnimType._SEQUENCE | EAnimType._TRANSFORM), false);
        SetAnimType(EBones._NECK, (byte)(EAnimType._SEQUENCE | EAnimType._TRANSFORM), false);
        SetAnimType(EBones._HEAD, (byte)(EAnimType._SEQUENCE | EAnimType._TRANSFORM), false);
        SetAnimType(EBones._PELVIS, (byte)(EAnimType._SEQUENCE | EAnimType._TRANSFORM), false);
    }
    ///////////////////////////////////////////////////////////////////////////////
    // 
    ///////////////////////////////////////////////////////////////////////////////
    
    float GetSpeedMult()
    {
        if (IsImplantActive(ImplantSystem._IMPLANT_TENDO_AMPLIFY))
            return fSpeedMult * ImplantSpeed._SPEED_MULT;
        
        return fSpeedMult;
    }
    
    /** Zwraca indeks broni w tablicy broni.
     * Zwrocony indeks mozna wykorzystac do zmiany modelu FPP.
     */
    int FindWeaponByName(Class cWeaponClass)
    {
        for(int i=0; i<nMaxFPPWeapons; i++)
        {
            BaseAnimations cAnim = aWeaponHands[i];
            if( cAnim!=null && cAnim.cOwnerClass.getName().equals(cWeaponClass.getName()))
               return i;
        }
               
        // nie ma broni o takiej klasie - dodajemy nowa
        return AddWeapon(cWeaponClass.getName());
    }

    private int AddWeapon(String sWeaponClass)
    {
        Weapon cWeaponTemplate = (Weapon)GetObjectOfClass(sWeaponClass);
        if(cWeaponTemplate!=null)
        {
            FPPHands Hands = null;
            Hands = (FPPHands)CreateObject(cWeaponTemplate.sFPPHandsClass);
            Hands.SetPlayer(this);
            Hands.ActivateOnModule();
            Hands.ClearFlag(EFlags._COLLISION);

            aWeaponHands[nLastFPPWeapon] = new BaseAnimationsDual(Hands, "Root", "", "", cWeaponTemplate.getClass(), CharacterAnims);

            if(nLastFPPWeapon == 31)
            {
                CrashLog("WARNING! nLastFPPWeapon="+nLastFPPWeapon+"\n");
                return nLastFPPWeapon;
            }
            else
                return nLastFPPWeapon++;
        }
        else
            return -1;
    }
    
    /** 
     * Inicjalizacja rzeczy zwiazanych z przelaczaniem broni FPP
     */
    void InitilizeFPP()
    {
        // czyscimy tablice z bronmi
        for(int i=0; i<nMaxFPPWeapons; i++) aWeaponHands[i] = null;

        // dodajemy defaultowe rece FPP
        HandsAnims = aWeaponHands[AddWeapon("WeaponHands")];
    }

    /** 
     * Wolane przez kamere przy zmianie sposobu obserwacji gracza
     */
    void CameraModeChanged(byte eMode)
    {
        /**FIXIT ten kawal kodu jest niepotrzebny tzn.
         * przy zalozeniu, ze dotyczy nie tylko zmiany TPP->FPP
         * powoduje przeskakiwanie animacji przy przelaczaniu miedzy
         * trybami operujacymi na tym samym meshu animacyjnym
        if (Anims != null)
        {
            Anims.cMesh.EnableRendering(false);
            Anims.Play( Anims.A_NONE );
        }
        else
        {
            HandsAnims.cMesh.EnableRendering(false);
            HandsAnims.Play( Anims.A_NONE );
            CharacterAnims.cMesh.EnableRendering(false);
            CharacterAnims.Play( Anims.A_NONE );
            if (ActiveWeapon != null)
                ActiveWeapon.EnableRendering(false);
        }
        */
        LogD("camera mode changed: "+eMode+"\n");
        switch (eMode)
        {
        case CameraPlayer.CMODE_FPP :
            {
                CharacterAnims.cMesh.ClearFlag(EFlags._CAST_SHADOWS);
                HandsAnims.cMesh.ClearFlag(EFlags._CAST_SHADOWS);
                
                // wylaczamy dla pewnosci TPP
                CharacterAnims.cMesh.EnableRendering(false);
                CharacterAnims.cMesh.ClearFlag(EFlags._NO_ANIMATION);
                //CharacterAnims.StopAll();                
                //CharacterAnims.Play( Anims.A_NONE );
                
                if ( HandsAnims != null )
                {
                    Anims = HandsAnims;
                    if (!bPlayerHidden && Anims.cMesh != null)
                        Anims.cMesh.EnableRendering(true);   
                }
                else
                    LogD( " CMODE_FPP ERROR: HandsAnims == null!\n");

                if (ActiveWeapon != null)
                    ActiveWeapon.EnableRendering(false);

                //prostujemy sie
                BodyDeformAimAtVReset();
                BodyDeformAimAtHReset();
                
                //TEMP tymczasowo zaremowane
                UpdateMotion();

                nRenderMode = REN_FPP;
                nCameraGameMode = Camera.CMODE_FPP;
            }
            break;
        case CameraPlayer.CMODE_HEAVYGUN :
			{
                CharacterAnims.cMesh.SetFlag(EFlags._CAST_SHADOWS);
                HandsAnims.cMesh.ClearFlag(EFlags._CAST_SHADOWS);
                
                // wylaczamy dla pewnosci animacje TPP
                if ( HandsAnims != null )
                {
                    HandsAnims.cMesh.EnableRendering(false);
                    HandsAnims.cMesh.ClearFlag(EFlags._NO_ANIMATION);
                    //HandsAnims.Play( Anims.A_NONE );
                }
                else
                    LogD( " CMODE_TPP ERROR: HandsAnims == null!\n");
            
                Anims = CharacterAnims;
                if (!bPlayerHidden)
                {
                    Anims.cMesh.EnableRendering(true);
                    if (ActiveWeapon != null)
                        ActiveWeapon.EnableRendering(false);
                }

                //natychmiastowe dojscie do odpowiedniej klatki animacji
                vOldForward = GetForwardVector();
/*
                SetAnimMorphTime(0);
                UpdateMotion();
                SetAnimMorphTime(Anims.fAnimMorphTime);
*/
			}
			break;
        case CameraPlayer.CMODE_TPP :
            {
                CharacterAnims.cMesh.SetFlag(EFlags._CAST_SHADOWS);
                HandsAnims.cMesh.ClearFlag(EFlags._CAST_SHADOWS);
                
                // wylaczamy dla pewnosci animacje TPP
                if ( HandsAnims != null )
                {
                    HandsAnims.cMesh.EnableRendering(false);
                    HandsAnims.cMesh.ClearFlag(EFlags._NO_ANIMATION);
                    //HandsAnims.Play( Anims.A_NONE );
                }
                else
                    LogD( " CMODE_TPP ERROR: HandsAnims == null!\n");
            
                Anims = CharacterAnims;
                if (!bPlayerHidden) 
                {
                    Anims.cMesh.EnableRendering(true);
                    if (ActiveWeapon != null && cSeatInfo == null)
                        ActiveWeapon.EnableRendering(true);
                }

                //natychmiastowe dojscie do odpowiedniej klatki animacji
                vOldForward = GetForwardVector();
                SetAnimMorphTime(0);
                if ( CanUpdateMotionOnCameraModeChanged() )
                    UpdateMotion();
                SetAnimMorphTime(Anims.fAnimMorphTime);

                nRenderMode = REN_FULL;
                nCameraGameMode = Camera.CMODE_TPP;
            }
            break;
        case CameraPlayer.CMODE_SNIPER :
            {
                CharacterAnims.cMesh.ClearFlag(EFlags._CAST_SHADOWS);
                HandsAnims.cMesh.ClearFlag(EFlags._CAST_SHADOWS);
                
                // wylaczamy dla pewnosci TPP
                CharacterAnims.cMesh.EnableRendering(false);
                CharacterAnims.cMesh.ClearFlag(EFlags._NO_ANIMATION);
                //CharacterAnims.Play( Anims.A_NONE );
                
                if ( HandsAnims != null )
                {
                    Anims = HandsAnims;
                    Anims.cMesh.EnableRendering(false);
                    // HACK ! wylaczenie renderowania wylacza updejt animacji
                    // powoduje to przeskakiwanie po ponowym wlaczeniu renderowania
                    Anims.cMesh.ClearFlag(EFlags._NO_ANIMATION);
                }
                else
                    LogD( " CMODE_SNIPER ERROR: HandsAnims == null!\n");

                if (ActiveWeapon != null)
                    ActiveWeapon.EnableRendering(false);

                //prostujemy sie
                BodyDeformAimAtVReset();
                BodyDeformAimAtHReset();
                
                //TEMP tymczasowo zaremowane
                //UpdateMotion();

                nRenderMode = REN_SNIPER;
            }
            break;
        case CameraPlayer.CMODE_ZERO :
            {
                CharacterAnims.cMesh.ClearFlag(EFlags._CAST_SHADOWS);
                HandsAnims.cMesh.ClearFlag(EFlags._CAST_SHADOWS);
                
                CharacterAnims.cMesh.EnableRendering(false);
//                CharacterAnims.Play( Anims.A_NONE );
                if ( HandsAnims != null )
                {
                    HandsAnims.cMesh.EnableRendering(false);
//                    HandsAnims.Play( Anims.A_NONE );
                }
                else
                    LogD( " CMODE_VEHICLE/ZERO/WALKER: HandsAnims == null!\n");

                
                if (ActiveWeapon != null)
                    ActiveWeapon.EnableRendering(false);
                nRenderMode = REN_NONE;
            }
            break;
        case CameraPlayer.CMODE_WALKER  :                                    
        case CameraPlayer.CMODE_VEHICLE :
        case CameraPlayer.CMODE_VEHICLE_PASSENGER :
            
            CharacterAnims.cMesh.SetFlag(EFlags._CAST_SHADOWS);
            HandsAnims.cMesh.ClearFlag(EFlags._CAST_SHADOWS);
                
            CharacterAnims.cMesh.EnableRendering(true);
            if ( HandsAnims != null )
            {
                HandsAnims.cMesh.EnableRendering(false);
            }
            
            if (ActiveWeapon != null)
                ActiveWeapon.EnableRendering(false);
            nRenderMode = REN_NONE;
            break;
        }
        //jest wolane po czasie, zeby zmienil sie stan kamery i ustawila sie na nowej pozycji
        if (bNetIsOwner && Camera != null)
            CallMethodIn( METHOD_UpdateSpeakerPos, 0.0f );
    }
    
    boolean CanUpdateMotionOnCameraModeChanged(){ return true; }

    Vector l_vCamLocalPos = new Vector();
    void UpdateSpeakerPos()
    {
        if ( Camera != null )
        {
            //l_vCamLocalPos.Set(Camera.GetPositionVolatile());
            l_vCamLocalPos = PointWorldToLocal(Camera.GetPositionVolatile());
            //l_vCamLocalPos.Sub(GetPositionVectorVolatile());
            SetSpeakerPos(l_vCamLocalPos, Camera.GetForwardVector());
        }
    }
	
	void UpdateSpeakerPos(Vector vPos)
	{
        if ( Camera != null )
        {
            l_vCamLocalPos = PointWorldToLocal(vPos);
            SetSpeakerPos(l_vCamLocalPos, Camera.GetForwardVector());
        }
	}
        
    boolean bNoHandUpd1 = false;
    boolean bNoHandUpd2 = false;
    
    static Vector l_vTemp = new Vector();
    
    /**Ile wlaczono cloaking devicow, wprawdzie ich dzialanie sie nie kumuluje, ale
     * durny gracz moze sobie powlaczac ile se chce
     */
    int m_nCloakingDevicesOn = 0;
    
    void SetCloaking(boolean bOn)
    {
        if (bOn)
        {
            m_nCloakingDevicesOn ++;
            if (m_nCloakingDevicesOn == 1)
            {
                //wlaczono pierwszy
                if ( HandsAnims != null )
                {
                    ((FPPHands)HandsAnims.cMesh).SetCloaking(true);
                }
                super.SetCloaking(true);
            }
        }
        else
        {
            m_nCloakingDevicesOn --;
            if (m_nCloakingDevicesOn == 0)
            {
                //wylaczono ostatni
                if ( HandsAnims != null )
                {
                    ((FPPHands)HandsAnims.cMesh).SetCloaking(false);
                }
                ((PlayerHUD)this).RefreshAmmoLeft();
                super.SetCloaking(false);
            }
            if (m_nCloakingDevicesOn < 0)
                m_nCloakingDevicesOn = 0;
            
        }
    }
    
    void SetHandsPos(Vector vFwd, Vector vUp, Vector vPos, CameraPlayer camera, float fCamAimAngle)
    {
        if ( HandsAnims != null )
        {
            /*if (nLeaning != -1)
            {
                l_vRight.Set(GetRightVectorVolatile());
                switch (nLeaning)
                {
                case _LEANING_LEFT:
                    l_vRight.Mul(-fLeanZ);
                    //vPos.fY += fLeanY;
                    break;
                case _LEANING_RIGHT:
                    l_vRight.Mul(fLeanZ);
                    //vPos.fY += fLeanY;
                    break;
                }
                vPos.Add(l_vRight);
            }*/
            // patrzenie gracza w pionie jest robione przez obrot
            vFwd.fY = 0.0f;
            HandsAnims.cMesh.SetDirLocal(vFwd);
            HandsAnims.cMesh.RotateLocal(l_vTemp.Set(1, 0, 0), fCamAimAngle * RAD2DEG );
            
            HandsAnims.cMesh.SetPosition(vPos);            
        }
        else
            LogD( " ERROR: HandsAnims == null!\n");

    }

    boolean bPlayerHidden = false;
    boolean bPlayerHiddenSG = false;
    
    /** Pokazanie/ukrycie playera
     */
    void ShowPlayer(boolean bShow)
    {
        bPlayerHidden = !bShow;
        //LogR("ShowPlayer " + bShow);
        //Thread.dumpStack();
        if (bShow)
        {
            switch (nRenderMode)
            {
            case REN_FULL:
                CharacterAnims.cMesh.EnableRendering(true);
                if (ActiveWeapon != null && cSeatInfo == null)
                    ActiveWeapon.EnableRendering(true);
                break;
            case REN_FPP:
                if ( HandsAnims != null && cSeatInfo == null)
                {
                    Anims = HandsAnims;
                    Anims.cMesh.EnableRendering(true);   
                }
                break;
            }
        }
        else
        {
            CharacterAnims.cMesh.EnableRendering(false);
            if ( HandsAnims != null )
            {
                Anims = HandsAnims;
                Anims.cMesh.EnableRendering(false);   
            }
            if (ActiveWeapon != null)
                ActiveWeapon.EnableRendering(false);
        }
    }
    
    // zwraca aktualna celnosc broni gracza
    float GetCurrentAccuracy()
    {
        return fCurrentAccuracy;
    }

    float fAccuracyPrevTime = 0;
    
    void UpdateAccuracy()
    {
        float fNow = GetTime();
        
        if(fAccuracyPrevTime == 0) fAccuracyPrevTime = fNow;
        float fDeltaTime = fNow - fAccuracyPrevTime;
        fAccuracyPrevTime = fNow;
        
        // wolamy wyliczenie celnosci
        if(CurrentState != null)
        {
            ((PlayerState)CurrentState).ComputeAccuracy();
        }
        
        // ograniczenie na maxymalne rozwarcie
        if(fDestAccuracy > fAccuracyMax)
            fDestAccuracy = fAccuracyMax;
        
        if(fCurrentAccuracy == fDestAccuracy) return;

        float fAccuracyChangeRate = 1.f;
        // to juz tak nie dziala!!!!
        //if (IsImplantActive(GetImplantSystem()._IMPLANT_TARGETING_ASSISTANCE))
        //    fAccuracyChangeRate = ImplantAccuracy._ACCURACY_CHANGE_RATE;
        
        float fSpeed = fAccuracyChangeSpeed;
        
        if(ActiveWeapon != null)
            fSpeed = ActiveWeapon.fAccuracyChangeSpeed;
        
        // interpolacja zmiany celnosci
        if(fCurrentAccuracy < fDestAccuracy)
        {
            fCurrentAccuracy += fAccuracyChangeRate * fSpeed * fDeltaTime;
            if(fCurrentAccuracy > fDestAccuracy) fCurrentAccuracy = fDestAccuracy;
        }
        else
        {
            fCurrentAccuracy -= fAccuracyChangeRate * fSpeed * fDeltaTime;
            if(fCurrentAccuracy < fDestAccuracy) fCurrentAccuracy = fDestAccuracy;
        }
        
        if(fCurrentAccuracy > fAccuracyMax)
            fCurrentAccuracy = fAccuracyMax;
    }
    
    /** Fcja wolana przy zmianie stanu gracza implikujacej zmiane celnosci.
     */
    void ComputeAccuracy()
    {
        if (ActiveWeapon == null)
            return;
        
        float fBaseAccuracy = 0.f;

        //aiming
        if (motion.bAiming && motion.GetMotionSpeed() != MotionState.SPEED_SWIM)
            fBaseAccuracy = ActiveWeapon.fAimAcc;
        else
            fBaseAccuracy = ActiveWeapon.fBaseAcc;

        // wstepne ustalenie celnosci
        fDestAccuracy = fBaseAccuracy;
        
        boolean bImplantAccuracy = IsImplantActive(GetImplantSystem()._IMPLANT_TARGETING_ASSISTANCE);
        
        // sprawdzamy zmiane podczas ruchu, jesli aktywny implant celowania to nie zmieniamy
        if (motion.IsMoving())
        {
            // parametry ruchu biezemy tylko gdy nie ma implanta
            // i gdy nie jest wlaczony w implancie no_move_change
            if(!bImplantAccuracy || !ImplantAccuracy._ACCURACY_NO_MOVE_CHANGE)
            {
                switch (motion.GetMotionSpeed())
                {
                    case MotionState.SPEED_CRAWL : 
                    case MotionState.SPEED_DUCK : 
                    case MotionState.SPEED_WALK :
                        fDestAccuracy = fWalkSnakeAccMult * fBaseAccuracy;
                        break;
                    case MotionState.SPEED_RUN :
                    case MotionState.SPEED_SWIM : 
                        fDestAccuracy = fRunJumpAccMult * fBaseAccuracy;
                        break;
                default :;
                }
            }
        }

        // sprawdzamy zmiane podczas stania
        if(!motion.IsMoving())
        {
            switch(motion.iSpeed)
            {
                case MotionState.SPEED_CRAWL : 
                case MotionState.SPEED_DUCK : 
                    fDestAccuracy = fDuckSnakeAccMult * fBaseAccuracy;
                    break;
            }
        }
        
        // Gdy jest czolganie i przycelowanie to Logan stoi (mimo IsMoving ustawionego na true)
        // trzeba osobno ustawic 
        if(motion.iSpeed == MotionState.SPEED_CRAWL &&
           motion.bAiming)
        {
            fDestAccuracy = fBaseAccuracy * fDuckSnakeAccMult;
        }
        
        // jesli aktywny jest implant Targeting Assistance System.
        if ( bImplantAccuracy && cSeatInfo == null)
            fDestAccuracy *= ImplantAccuracy._ACCURACY_MUL;	
        
        //clamp to 0
        if (fDestAccuracy < 0.0f) fDestAccuracy = 0.0f;
    }

    /**Do zastapienia w PlayerSingle i PlayerNet
     */
    public void Respawn()
    {
        super.Respawn();

        nLeaning = -1;
        if (Camera != null)
            Camera.ForceStopLeaning();
        
        fHealth = fMaxHealth;
        bDead = false;
        motion.Reset();

        //zerowanie flag okreslacjacych stan klawiszy
        bWalking = false;
        bDucking = false;
        bCrawling = false;
        bSwimming = false;
		
        bDuckingToggle = false;
        bCrawlingToggle = false;		
		
        
        bWasSwimming = false;

        //zerowanie flag okreslacjacych stan gracza
        nEnvironment = EMoveEnv.CHMOVE_GROUND;
        SetFallSpeed(new Vector(0, 0, 0));

        bUnableToAct = false;
        bCheckForLadder = false;
        bCheckForLadderExit = false;

        ClearFlag(EFlags._NO_ANIMATION_REFRESH);

        Camera.SetMode(CameraPlayer.CMODE_TPP);
        UpdateMotion();
        //domyslna kamera to fpp
        Camera.SetMode(CameraPlayer.CMODE_FPP);
        UpdateMotion();

        vOldForward = GetForwardVector();
        bBodyDeformAimAtH = true;
        
        //TODO : naprawic ACQUIRE dla implantow zeby dzialanie implantu nie bylo w PlayerSingle tylko w klasie implantu

        SetState("FreehandState");
    }

    ///////////////////////////////////////////////////////////////////////////
    // zdarzenia zewnetrzne, ktore maja wplyw na stan gracza
    ///////////////////////////////////////////////////////////////////////////
    
    static boolean sm_bImmortal = false;
    void SetImmortal()   { sm_bImmortal = true; }
    void ClearImmortal() { sm_bImmortal = false; }
    
	// poprawione OnTakeDamage //////////////////////////////////////////////////////////////
    public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        if(((ChromeModule)GetModule()).bMovieView) 
            return;
        
        //sprawdzam czy gracz ma wlaczony implant DERMAL ARMOR i jesli tak zmniejszam damage
        //chyba ze chodzi o upadek z wysokosci
        if ( IsImplantActive(GetImplantSystem()._IMPLANT_DERMAL_ARMOR) && 
             nDamageType != EnumDamageType._FALL)
            fDamage *= ImplantArmor._DAMAGE_MULTIPLIER;
        
        if ( this instanceof PlayerSingle && nDamageType != EnumDamageType._FALL)
        {
            fDamage *= ChromeGame.GetTakeDamageDiffLevelMult();
        }
        
        if (fDamage < 1)
            return;
        
        if (!bDead)  //jesli zywy, to obrywa
        {
            // w grze sieciowej odbieramy energie tylko na serwerze
            if ( Role == ERole._AUTHORITY && (!IsImmortal()) ) 
            {
                boolean bWasDead = bDead;

                // podczas lezenia zmniejszamy blast damage
                if(bCrawling &&
                   nDamageType == EnumDamageType._BLAST ||
                   nDamageType == EnumDamageType._BLAST_SPECIAL)
                {
                    fDamage *= fCrawlBlastDamageMult;
                }
                
                fDamage *= GetDamageMultiplier( nMeshElementorBoneID );
                
//                ProfileIntervalStart();
                
                Damage(fDamage, nDamageType);
                
//                float f = ProfileIntervalEnd();
//                CrashLog("[Player.OnTakeDamage] "+f+"\n");
                        
                if (bDead && bUsePhysicsToDeathFall)
                {
                    if (!bWasDead && (nMeshElementorBoneID != EBones._NON_BONE))
                    {
                        //uderzamy sztucznie w szyje
                        //vHitLocation = GetBoneJointPos(EBones._NECK);
                    }
                    Physics.Simulate(this, vHitLocation, vSpeed, fPhSimDamage, nMeshElementorBoneID);
                }

                fInjuries+= fDamage;
            }
        }

        //ProfileIntervalStart();
        
        // przestawienie kierunku patrzenia tzw. Recoil
        if ( (!ChromeGame.bFilms) && (cSeatInfo == null) )
        {
            // dokladamy efekt przesuniecia przy postrzale
            float fShake = fDamageRecoil;
            
            //jesli implant sily jest aktywny to zmniejsza dzialanie postrzalu
            if (IsImplantActive(ImplantSystem._IMPLANT_MUSCLE_IMPROVER))
                fShake *= ImplantStrength._WEAPON_RECOIL_MULT;
            
            if(fShake > 3.1415f) fShake = 3.1415f;
            if(fShake < 0.0f) fShake = 0.0f;

            RotateV(-fShake/2.0f + RandomFloat(fShake));
            RotateH(-fShake/2.0f + RandomFloat(fShake));
            
            //drugi parametr oznacza, ze brane jest pod uwage przyspieszenie
            // zaremowane - zobaczymy czy sie przyjmie
            //SetLocalSpeed( this.vSpeed, m_bUseWalkDestSpeed );
        }

        // efekty wizualne i slyszalne trafienia
        Vector vAssassinPos = null;
        if(Assassin instanceof ControlObject)
            vAssassinPos = ((ControlObject)Assassin).GetPosition();
        
        TakeDamageSpecialEffects(fDamage, vAssassinPos, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
        
        //float a = ProfileIntervalEnd();
        //CrashLog("[Player.OnTakeDamage] rest "+a+"\n");
    }

    float fMinTakeHitSound = 1000.f;
    float fMaxTakeHitSound = 3500.f;
    
    void TakeDamageSpecialEffects(float fDamage, Vector AssassinPos, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        // bryzgniecie krwia
        if (vHitLocation != null)
        {
            // odpalamy krew
            Vector vBloodDir = new Vector();
            vBloodDir.Set(vSpeed);
            vBloodDir.Mul(-1);
            
            //TODO zrobic wiekszy FX
            if (sFXBlood != null)
            {
                ExecuteParticleSystem(sFXBlood, vHitLocation, vBloodDir);
                ExecuteFX(sFXBlood, vHitLocation, vBloodDir);
            }
        }
        
        // odpalenie dzwiekow trafienia w cialo - nie maja one nic wspolnego ze wzdychaniem AI
        String sTakeHitSound = GetHitSound(nMeshElementorBoneID, nDamageType);
        AttachOneShotSound(sTakeHitSound, fMinTakeHitSound, fMaxTakeHitSound);
            
        if (nMeshElementorBoneID != EBones._NON_BONE)
        {
            //postrzal w konkretna kosc z widoku TPP
            if ( (Camera != null) && (Camera.GetMode() == Camera.CMODE_TPP) )
            {
                if (GetHitFX() != null)
                    // odpalamy efekt trafienia - vSpeed - normalna
                    ExecuteFX(GetHitFX(), vHitLocation, vSpeed);
            }
        }
        else
        {
            // trafienie w skutek ogolnego walniecia bez kosci
            // upadek?
        }

        // flash kamery
        if (Camera != null)
        {
            // wlaczamy krew na twarzy
            Camera.Flash( CameraExtended._FLASH_BLOOD , 0.6f, 0.2f, 0.3f);
            
            // efekt trafienia
            float fMaxHitCameraShake = 100.f;
            float fShake = fMaxHitCameraShake * fDamage/fMaxHealth;
            Camera.ShakeImpulse(fShake, fShake, fShake, CameraPlayer._SHAKE_TAKE_HIT);
        }
    }
    
    /** Pokryte z Pawna
     */
    public void YouKilledMe(GameObject Victim)
    {
        if (ActiveWeapon != null)
        {
            aEnemyDeceased[ActiveWeapon.nInvIndex-1]++;

            if (nBestWeaponDeceased < aEnemyDeceased[ActiveWeapon.nInvIndex-1])
            {
                nBestWeapon = ActiveWeapon.nInvIndex-1;                
                nBestWeaponDeceased = aEnemyDeceased[nBestWeapon];
                sBestWeapon = ActiveWeapon.GetInvName();
            }
        }
    }

    
    Vector vLastPosOnGround = null;
    
    boolean m_bOnChangeMovement = false;
    void OnChangeMovement(int iEnv)
    {
        //LogR("[Player.OnChangeMovement] "+nEnvironment+"->"+iEnv+"\n");
        //CrashLog("OnChangeMovement " + EMoveEnv.GetFlagName(iEnv));
        //jesli jhestesmy w wodzie, to nie zwracamy uwagi na 
        // to, czy dotykamy dna
        if ( (nEnvironment != EMoveEnv.CHMOVE_WATER) &&
             //(bUnderWater == false) &&
             //reagujemy tylko, kiedy osrodek zmienia sie na inny
             (nEnvironment != iEnv) /*&&
             (!(motion.nClimbing > motion._CLIMBING_FALSE))*/ )
        {
            //CrashLog("nEnvironment="+nEnvironment+" iEnv=" + iEnv +" Jump:"+(iEnv==EMoveEnv.CHMOVE_AIR)+"\n");
            nEnvironment = iEnv;
            m_bOnChangeMovement = true;
            
            // podczas resymulacji na serwerze nie wywolujemy efektow ubocznych zmiany podloza (np. tupiemy itp.)
            if (!m_bNetResimulate)
            {
                switch (nEnvironment)
                {
                    case EMoveEnv.CHMOVE_AIR :
                        {
                            // zapamietujemy miejsce z ktorego wyskoczylismy
                            vLastPosOnGround = GetPosition();
                            
                            //bez tego gracz zaczyna spadac majac juz jakas predkosc poczatkowa
                            //przenosze do player jump
                            //SetMaxFallSpeed(new Vector(0, -65000, 0));
                            //SetFallSpeed(new Vector(0, 0, 0));

                            // gracz wyskoczyl wiec wylaczamy odgrywanie krokow
                            StopMakingStepNoise();

                            //if (!m_bNetResimulate)
                            //    m_bJustJumping = true;
                            
                            //bDebugSendMove = true;
                            UpdateMotion();
                            //bDebugSendMove = false;

                            break;
                        }
                    case EMoveEnv.CHMOVE_GROUND :
                        {
                            boolean bLanding = !(motion.nClimbing > motion._CLIMBING_FALSE);
                            
                            // nie ma efektu ladowania gdy gracz idzie na drabinie
                            if(bLanding)
                            {
                                Vector vFallVector = GetFallSpeed();
                                float fFallSpeed = 0;

                                if (vFallVector != null)
                                    fFallSpeed = vFallVector.fY;

                                // liczymy z jakiej wysokosci spadl gracz
                                Vector vPos = GetPosition();
                                //czasami ten wektor jest null (przy pierszym spawnie)
                                //wiec trzeba sie zabezpieczyc
                                float fFallDist = (vLastPosOnGround != null)?(vLastPosOnGround.fY - vPos.fY):10.0f;
                                float fHurtHeight = 350.0f;
                                
                                //LogR("Falling down! fFallDist="+fFallDist+" fFallSpeed="+fFallSpeed+" vFallVector="+vFallVector+"\n");
                                
                                if (m_bGetDamageFromFalling)
                                {
                                    // float fMaxFallSpeed = -800.f;
                                    // if (GetPhysicsType() == EPhysics._ODE_GRAVITYWALK)
                                    //     fMaxFallSpeed = -1100.f;
                                    
                                    if( ((fFallDist > fHurtHeight) && (fFallSpeed < 0f)) /*||
                                       (fFallSpeed < fMaxFallSpeed)*/ )
                                    {
                                        float fDamage = fFallDist / fHurtHeight;
                                        fDamage *= fMaxHealth*0.5f;
                                        //LogR("Hit ground fDamage="+fDamage+" fFallDist="+fFallDist+"\n");

                                        PlaySound("Data/Sounds/HitGroundS_01.wav");
                                        if (Role == ERole._AUTHORITY)
                                        {
                                            TakeDamage(fDamage, fDamage, this, null, null, EBones._NON_BONE, EnumDamageType._FALL);
                                        }
                                    }
                                }

                                //SetFallSpeed(new Vector(0, 0, 0));
                                
                                // zeskoczylismy na ziemie, wiec robimy tupot 
                                StepDone();
                            }
                            
                            EndOfJump();

                            //jesli klawisz przycelowania wcisniety to trzeba to obsluzyc
                            if ( (bNetIsOwner && AmIAiming()) || ((Role == ERole._AUTHORITY) && !bNetIsOwner && bNetClientAiming) )
                            {
                                ActionAimingStart();
                                UpdateState();
                            }
                            
                            UpdateMotion();

                            // sprawdzmy czy czasem nie wskoczylismy / zeskoczylismy z pojazdu
                            CheckVehicle();
                            
                            break;
                        }
                }
            }
            else
            {
                switch (nEnvironment)
                {
                    case EMoveEnv.CHMOVE_AIR :
                        {
                            break;
                        }
                    case EMoveEnv.CHMOVE_GROUND :
                        {
                            //jesli klawisz przycelowania wcisniety to trzeba to obsluzyc
                            if ( (bNetIsOwner && AmIAiming()) || ((Role == ERole._AUTHORITY) && !bNetIsOwner && bNetClientAiming) )
                            {
                                ActionAimingStart();
                                UpdateState();
                                UpdateMotion();
                            }
                            break;
                        }
                }
            }
        }
        
        m_bOnChangeMovement = false;
    }

    void Overload()
    {
        GetImplantSystem().Overload();        
    }
    
    /** Ustawienie w fizyce identyfikatora srodowiska
     * oraz zmiennej nEnvironment w playerze, potrzebne
     * do resymulacji w grze sieciowej
     */
    public void SetPhysicsEnv( int nEnv )
    {
        //Thread.dumpStack();
        
        int nCurrhysicsEnv = GetPhysicsEnv();
        if ( nCurrhysicsEnv == nEnv &&
             nEnvironment   == nEnv )
            return;
        if ( nCurrhysicsEnv != nEnvironment )
            LogD(" ERROR: GetPhysicsEnv "+nCurrhysicsEnv+" nEnvironment "+nEnvironment+"\n");
        LogD(" "+nEnvironment+"->"+nEnv+"\n");
        super.SetPhysicsEnv( nEnv );
        //TODO:a moze jakos wymusic OnChangeMovement???
        nEnvironment = nEnv;
    }
    
    void EndOfJump()
    {
        m_bJumpingOffLadder = false;
        
        //LogR("[Player.EndOfJump] false\n");
        
        m_bJustJumping = false;
        
        //koniecznie "zerowanie" m_bJustJumping powinno byc wczesniej
        //zeby w ponizszej metodzie dokonal sie update predkosci
        // na drabinie nie ma efektu ladowania
        if(!(motion.nClimbing > motion._CLIMBING_FALSE))
            SlowDownAndCameraBumpOnEndOfJump();
        
        //natomiast to powinno byc zerowane dopiero teraz zeby
        //powyzsze metoda "wiedziala" czy skakalismy czy poprostu
        //spadlismy z dachu...
        m_bJump = false;
    }
    
    void ForceEndOfJump()
    {
        m_bJumpingOffLadder = false;
        
        //LogR("[Player.ForceEndOfJump] false\n");
        m_bJustJumping = false;
        m_bJump = false;
    }

    
    public void Die()
    {
        super.Die();

        DisableCallMethod("StartDrowning");
        DisableCallMethod("Drown");
        SetState("DieState");
    }

    void CheckTriggers()
    {
    }
    
    /** Uzywany w grze sieciowej, zeby pokazac tylko info obiektu
     * w ktorego wycelowalismy, ale nie byl odswiezany trigger
     */
    void CheckTriggers(boolean bOnlyTargetInfo)
    {
        
    }

    void ExecuteTrigger()
    {
    }

///////////////////////////////////////////////////////////////////////////////
// Uzywanie itemow
///////////////////////////////////////////////////////////////////////////////
    
    boolean CanUseItem(InvObject cItem)
    {
        boolean bResult = false;

        //itemow mozna uzywac tylko w stanie freehand
        if (sCurrentState.compareTo("FreehandState") == 0)
        {
            //tutaj ewentualnie jakies dodatkowe ograniczenia na uzywalnosc..
            if (IsLeaning() && cItem.nInvIndex == InvObject._E_BINOCULARS)
                bResult = false;
            else
                bResult = true;
        }
        //lub w stanie prowadzenia pojazdu (CarDriveState, MotorDriveState itp)
        else if (sCurrentState.endsWith("DriveState") || 
                 sCurrentState.endsWith("HeavyGunState"))
        {
            //ale tylko niektore przedmioty
            if (cItem.nInvIndex == InvObject._E_DRUG_HEALTH ||
                cItem.nInvIndex == InvObject._E_DRUG_NEURALHEALTH)
                bResult = true;
        } 
        //lub podczas przycelowania
        else if (sCurrentState.compareTo("AimState") == 0 )
        {
            bResult = cItem.CanUseWhileAiming();
        }
        else if (sCurrentState.compareTo("ReloadState") == 0 )
        {
            if (cItem.nInvIndex != InvObject._E_BINOCULARS)
                bResult = true;
        }
        else if (sCurrentState.compareTo("ChangeWeaponState") == 0 )
        {
            if (cItem.nInvIndex != InvObject._E_BINOCULARS)
                bResult = true;
        }

        /*if (bResult && cItem.nInvIndex == InvObject._E_DRUG_HEALTH)
        {
            if (GetUsedHealthExCount() > 2)
            {
                return false;
            }
        }*/
        
        return bResult;
    }    

    int GetUsedHealthExCount()
    {
        int nCount = 0;
        GameObject aDrugs[] = GetObjectsFromClass("Drug");
        if (aDrugs != null) 
            for (int i = 0; i < aDrugs.length; i++)
            {
                if ( aDrugs[i] instanceof DrugHealthex )
                {
                    DrugHealthex cDrug = (DrugHealthex)aDrugs[i];
                    if (cDrug.Owner == this && 
                        cDrug.fUnitAlreadyAdded >= cDrug.fHealthUnitAdding)
                        nCount ++;
                }
            }
        return nCount;
    }
    
    void UseInvObject(InvObject Object)
    {
        UseInvObjectDo( Object );
    }

    void UseInvObjectDo(InvObject Object)
    {
        //czasem nie mozna uzyc danego przedmiotu (np. w stanach innych niz Freehand)
        if (CanUseItem(Object))
        {
            //ActionPerformed( EPlayerAction.USE, Object.GetNetId() );
            LogD("About to use item "+Object+"\n");
            Object.Use();
        }
        else
            LogD("Can't use item "+Object+"\n");
    }
    
    //////////////////////
    // obsluga klawiszy //
    //////////////////////

    /** Wolane gdy gra jest przerwana i pokazywane jest menu InGame */
    void GameDeactivatedToMenu()
    {
        UnregisterKeyRequest();
        UnregisterMouseAxisRequest();
        UnregisterMouseButtonRequest();
    }
    
    boolean bMouseUnacquired = false;
    boolean bMouseButtonUnacquired = true;
    
    /** Wolane gdy gra powraca z menu InGame */
    void GameActivatedFromMenu()
    {
        RegisterKeyRequest();
        
        // przywracamy ustawienie jakie bylo wczesniej
        SetupMouseAcquire();
        
        // sprawdzamy czy wlaczone jest przycelowanie ciagle
        if(bNetIsOwner && !AmIAiming())
        {
            ActionAimingStop();
        }
        
        nLeaning = -1;
        if (Camera != null)
            Camera.ForceStopLeaning();
        
    }

    // ustawia acquire myszy zgodnie z wlasciwym ustawieniem gracza
    void SetupMouseAcquire()
    {
        if(bMouseUnacquired)
            MouseUnacquire(bMouseButtonUnacquired);
        else
            MouseAcquire();
    }
    
    /** Wolane gdy ma byc przywrocone sterowanie graczem np. w HUDach */
    void MouseAcquire()
    {
        bMouseUnacquired = false;
        
        // uwaga, do 4.08.03 te trzy linijki byly w if'ie
        RegisterMouseAxisRequest();
        RegisterMouseButtonRequest();

        bMouseButtonUnacquired = false;
        
        if (cSeatInfo == null)
        {
            // sprawdzamy stan klawiszy
            int nKey;
            nKey = EMouse._BUTTON_1;
            CallOnInputKey(ConvertMouseButtonToKey(nKey), GetKeyState(nKey) ? 1:0, '0');
        }
        if (Camera!=null) 
            Camera.RegisterMouseAxisRequest();
    }


    void MouseAcquireCamera()
    {
        if (Camera!=null) 
            Camera.RegisterMouseAxisRequest();
    }
    
    /** Wolane gdy ma byc wylaczone sterowanie graczem np. w HUDach */
    void MouseUnacquire(boolean bButtonUnacquire)
    {
        bMouseUnacquired = true;
        
        UnregisterMouseAxisRequest();
        if(bButtonUnacquire)
        {
            UnregisterMouseButtonRequest();
            bMouseButtonUnacquired = true;
        }

        if (Camera!=null) 
            Camera.UnregisterMouseAxisRequest();
        
        // wylaczenie wszystkich klawiszy
        int nKey;
        nKey = EMouse._BUTTON_1;
        if(GetKeyState(nKey)) CallOnInputKey(ConvertMouseButtonToKey(nKey), 0, '0');
    }
    
    ///////////////////////////
    // niestandardowe widoki //
    ///////////////////////////


    /** Ustawienie kamery i zoom'a dla przycelowania
     */
    void InitViewForAiming()
    {
        if (Camera == null) 
            return;

        nOldCameraMode = Camera.GetMode();
        //LogD("old_cameramode:"+nOldCameraMode+"\n");

        LogD("initiating aiming view, oldmode="+nOldCameraMode);
        
        if (ActiveWeapon != null)
        {
            cZoomer = ActiveWeapon.cZoomer;
            
            // Ustaw kamere, gdzie trzeba
            if ((cZoomer!= null) && (cZoomer.eAimingType == EWeaponAimingType._SNIPER))
            {
                Camera.SetMode( CameraPlayer.CMODE_SNIPER );
            }
            else 
                if ((cZoomer!= null) && cZoomer.eAimingType == EWeaponAimingType._WITH_ZOOM)
                {
                    Camera.SetMode( CameraPlayer.CMODE_FPP );
                    nRenderMode = REN_FPP;
                }
                else
                {
                    if (IsImplantActive(ImplantSystem._IMPLANT_SCOPED_EYES))
                    {
                        //aktywny implant zoom
                        ImplantZoom cImplant = (ImplantZoom)GetImplantSystem().GetImplant(ImplantSystem._IMPLANT_SCOPED_EYES);
                        if ( cImplant != null )
                            cZoomer = cImplant.GetZoomer();
                    }
                }
            
            if(cZoomer != null)
            {
                // Ustaw zoom na poczatkowy
                cZoomer.Reset();
                if (cZoomer.eAimingType == EWeaponAimingType._IMPLANT_ZOOM)
                {
                    //hack, zeby processonframe nie ustawil zooma
                    fLastZoom = cZoomer.GetZoom();
                    Camera.SetZoomSmooth( cZoomer.GetZoom() );
                }
                else
                    Camera.SetZoom( cZoomer.GetZoom() );
            }
            else
                Camera.SetZoom(1.0f);
        }
    }

    void OnImplantZoomActivate(ImplantZoom cImplant)
    {
        if (ActiveWeapon != null)
        {
            // sprawdzamy czy bron nie ma swojego zooma
            if (AmIAiming() && ActiveWeapon.nType != EWeaponType._HEAVY && 
                ActiveWeapon.nType != EWeaponType._GRENADE && 
                ActiveWeapon.IsAimEnabled() &&
                sCurrentState.compareTo("AimState") == 0 && 
                (cZoomer == null || 
                 (cZoomer != null && 
                  cZoomer.eAimingType != EWeaponAimingType._SNIPER &&
                  cZoomer.eAimingType != EWeaponAimingType._WITH_ZOOM)))
            {
                cZoomer = cImplant.GetZoomer();
                cZoomer.Reset();
                //hack, zeby processonframe nie ustawil zooma
                fLastZoom = cZoomer.GetZoom();
                if (Camera != null)
                    Camera.SetZoomSmooth( cZoomer.GetZoom() );
            }
        }
    }
    
    /**Metoda wolana przez implantzoom po wylaczeniu, przywraca normalne celowanie jesli uzylismy zooma
     */
    void OnImplantZoomDeactivate()
    {
        if (Camera == null) 
            return;
        
        if (nCurrentState == EPlayerState.AIM && 
            cZoomer != null && 
            cZoomer.eAimingType == EWeaponAimingType._IMPLANT_ZOOM)
        {
            cZoomer.Reset();
            Camera.SetZoomSmooth(fEyeZoomingFactor);
        }
    }
    
    /** Przywrocenie kamery do stanu sprzed przycelowania
     */
    void RestoreViewAfterAiming()
    {   
        if (Camera == null) return;
        
        LogD("\n");
        
        // Resetuj skale
        if (cZoomer != null && 
            cZoomer.eAimingType == EWeaponAimingType._IMPLANT_ZOOM)
            Camera.SetZoomSmooth(fEyeZoomingFactor);
        else
            Camera.SetZoom(fEyeZoomingFactor);

        // Przywroc poprzedni tryb pracy kamery
        Camera.SetMode(nCameraGameMode);

        if (nOldCameraMode == CameraPlayer.CMODE_TPP)
            nRenderMode = REN_FULL;
        else 
            nRenderMode = REN_FPP;
        
        cZoomer = null;
    }

    void UseBinoculars(Binoculars cNewBinoculars)
    {
        if (cNewBinoculars == null)
        {
            Tools.CrashLogError("Player.UseBinoculars dostalo null");
        }
        
        if (Camera != null)
        {
            nOldCameraMode = Camera.GetMode();
        }
        
        this.cBinoculars = cNewBinoculars;

        float fAnimTime = Anims.GetLength( Anims.A_WEA_PUTAWAY );
        
        if (ActiveWeapon       != null && 
            ActiveWeapon.nType != EWeaponType._BINOCULARS )
        {
            //w grze sieciowej gracz bedzie posiadal specjlana bron
            //klasy WeaponHandsBinoculars, w singlu nie wiec
            //GetNextWeapon zwroci null tak jak dotychczas...
            ChangeWeapon( GetNextWeapon( EWeaponType._BINOCULARS ) );
        }        

        //poczekaj, az odegra sie animacja chowania broni
        CallMethodIn( "UseBinocularsDo",
                     fAnimTime);

        
    }
    
    void UseBinocularsDo()
    {
        cBinoculars.UnregisterKeyRequest();
		cBinoculars.SetState("BeingUsed");
        if (bNetIsOwner)     
            cBinoculars.RegisterKeyRequest();

        if (cBinoculars != null)
        {
            cZoomer = cBinoculars.cZoomer;
        
            if ( Camera != null )
            {
                nOldCameraMode = Camera.GetMode();
                Camera.SetMode(CameraPlayer.CMODE_SNIPER);
                Camera.SetZoom(cZoomer.GetZoom());
            }
        }
    }
        

    /**
     */
    void RestoreViewAfterBinoculars()
    {
        if (Camera != null) 
        {
            if (Camera.GetMode() == Camera.CMODE_SNIPER)
            {
                Camera.SetMode(nCameraGameMode);
            }
            /*else
            {
                Camera.SetMode(nOldCameraMode);
            }*/
            Camera.SetZoom(fEyeZoomingFactor);
        }
        
		if ( ! bDead && PreviousActiveWeapon != null)
		{
            if (cBinoculars != null)
            {
                ChangeWeapon( PreviousActiveWeapon );
            }
            else
            {
                // to ewntualnie bedzie po loadzie
                // ChangeWeapon(ActiveWeapon);
            }
            
		}
        
        if (Camera.GetMode() == CameraPlayer.CMODE_TPP)
            nRenderMode = REN_FULL;
        else
		{
			if (cSeatInfo == null)
				nRenderMode = REN_FPP;
		}
        
        cBinoculars = null;
        cZoomer = null;
    }

    
    void RestoreViewAfterLoad()
    {
        
    }
    
    /** 
     */
    void InitViewForZoomerAim(ZoomerAim zoomerAim)
    {
        
        if (Camera == null) return;
        
        cZoomer  = zoomerAim;
        nOldCameraMode = Camera.GetMode();
        
        if (cZoomer != null)
        {
            //Camera.SetMode(CameraPlayer.CMODE_SNIPER);
            Camera.SetZoom(cZoomer.GetZoom());
        }
        
    }
    
    /** 
     */
    void RestoreViewAfterZoomerAim()
    {
        if (Camera == null) return;

        Camera.SetMode(nCameraGameMode);
        Camera.SetZoom(fEyeZoomingFactor);

        if (nOldCameraMode == CameraPlayer.CMODE_TPP)
            nRenderMode = REN_FULL;
        else
            nRenderMode = REN_FPP;
        
        //cBinoculars = null;
        cZoomer = null;  
        
    }

//////////////////////////////////////////////////////////////////////
    
    /** Obsluga klawiszy zwiazanych z zoomowaniem
     */
    void ProcessZoomKeys(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
        if (Precache.bPrecaching ||
            ((ChromeModule)GetModule()).bInFadeState ||
            bInMovie)
            return;
        
        byte bZoomType = -1;

        if (cZoomer != null)
        {
            if (nKeyCode == EGameControl.ZOOM_IN)
                bZoomType = Zoomer._ZOOM_IN;
            else if (nKeyCode == EGameControl.ZOOM_OUT)
                bZoomType = Zoomer._ZOOM_OUT;

            if (bZoomType != -1)
            {
                if (bKeyState)
                    cZoomer.StartZoomChange(bZoomType);
                else
                    cZoomer.StopZoomChange(bZoomType);

                if (Camera != null)
                    Camera.SetZoom(cZoomer.GetZoom());
            }
        }
        else
        {
            HUDCompass cHud = ((PlayerHUD)this).HUD.GetHUDCompass();
            if (cHud != null)
            {
                if (bKeyState)
                {
                    if (nKeyCode == EGameControl.ZOOM_IN)
                        cHud.MapZoomIn();
                    else 
                        if (nKeyCode == EGameControl.ZOOM_OUT)
                            cHud.MapZoomOut();
                }
            }
            
        }
    }

    //TODO: uwzglednic przy rzucaniu granatem prawym klawiszem.
    boolean bAimToggle = false;

    /** Metoda zwraca czy gracz ma wcisniete klawisze przycelowania */
    boolean AmIAiming()
    {
        return GetKeyState(ConvertKeyToMouseButton(EGameControl.AIM)) || bAimToggle || bNetClientAiming;
    }
    
    boolean ProcessWeaponChange(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
        if (Precache.bPrecaching ||
            ((ChromeModule)GetModule()).bInFadeState ||
            IsLeaning()||
            bInMovie)
            return false;
        
        if(bKeyState && (cBinoculars == null))
        {
            if( (nKeyCode == EGameControl.WEAPON_MELEE)  ||
                (nKeyCode == EGameControl.WEAPON_PISTOL) ||
                (nKeyCode == EGameControl.WEAPON_RIFLE)  ||
                (nKeyCode == EGameControl.WEAPON_HEAVY)  ||
                (nKeyCode == EGameControl.WEAPON_GRENADE)||
                (nKeyCode == EGameControl.WEAPON_HANDS)  ||
                //(nKeyCode == EGameControl.WEAPON_BEST)   ||
                (nKeyCode == EGameControl.WEAPON_NEXT)   ||
                (nKeyCode == EGameControl.WEAPON_PREV))
            {
                byte eWeaponType = -1;

                if (nKeyCode == EGameControl.WEAPON_PISTOL) 
                    eWeaponType = (byte)EWeaponType._PISTOL; 
                else if (nKeyCode == EGameControl.WEAPON_RIFLE) 
                    eWeaponType = (byte)EWeaponType._RIFLE;
                else if (nKeyCode == EGameControl.WEAPON_HEAVY) 
                    eWeaponType = (byte)EWeaponType._HEAVY;
                else if (nKeyCode == EGameControl.WEAPON_GRENADE) 
                    eWeaponType = (byte)EWeaponType._GRENADE;
                else if (nKeyCode == EGameControl.WEAPON_MELEE)
                    eWeaponType = (byte)EWeaponType._KNIFE;
                else if (nKeyCode == EGameControl.WEAPON_HANDS)
                    eWeaponType = (byte)EWeaponType._HAND;

                //bron ktora bedziemy chciali wziasc w rece
                Weapon cReqWeapon = null;
                
                if (eWeaponType != -1)
                {
                    // poszukaj odpowiedniego rodzaju broni cyklicznie 
                    cReqWeapon = GetNextWeapon( eWeaponType );
                }
                else
                {
                    /*if (nKeyCode == EGameControl.WEAPON_BEST)
                        WeaponToUse = GetBestWeapon();*/
                    if (nKeyCode == EGameControl.WEAPON_NEXT)
                        cReqWeapon = GetNextWeapon((byte)-1);
                    if (nKeyCode == EGameControl.WEAPON_PREV)
                        cReqWeapon = GetPrevWeapon();
                }

                // jesli wybrales sobie jakas bron - uzyj jej
                if ( cReqWeapon != null )
                {
                    WeaponToUse = cReqWeapon;
                    ActionChangeWeaponState();
                }
                
                return true;
            }

            if (nKeyCode == EGameControl.WEAPON_THROW)
            {
                if (ActiveWeapon != null && !ActiveWeapon.bLocked )
                    ActiveWeapon.ActionThrowAway();

                // gdy wyrzucilismy bron w zamian pojawia sie noz
                //TODO przeniesc to na koniec ThrowAway
                if (ActiveWeapon == null)
                    ChangeWeapon( GetBestWeapon() );
                
                return true;
            }
        }
        return false;
    }
    
    boolean ProcessAimToggle(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
        if (Precache.bPrecaching ||
            ((ChromeModule)GetModule()).bInFadeState ||
            IsLeaning() ||
            bInMovie)
            return false;
        
        if(nKeyCode == EGameControl.AIM)
        {
            // jakie kolwiek nacisniecie guzika wylacza AimToggle'a
            bAimToggle = false;
        }

        //dla granatow toggle nie dziala
        if (nKeyCode == EGameControl.AIM_TOGGLE &&
            ActiveWeapon instanceof WeaponGrenade)
        {
            CallOnInputKey(EGameControl.AIM, bKeyState ? 1:0, '0');
            Camera.CallOnInputKey(EGameControl.AIM, bKeyState ? 1:0, '0');
            return false;
        }
        
        // reagujemy na puszczenie klawisza
        if(nKeyCode == EGameControl.AIM_TOGGLE && bKeyState)
        {
            // sprawdzamy stan przycelowania
            if(motion.bAiming)
            {
                bAimToggle = false;
                
                // wylaczamy przycelowanie
                CallOnInputKey(EGameControl.AIM, 0, '0');
                Camera.CallOnInputKey(EGameControl.AIM, 0, '0');
            }
            else
            {
                // wlaczamy przycelowanie
                CallOnInputKey(EGameControl.AIM, 1, '0');
                Camera.CallOnInputKey(EGameControl.AIM, 1, '0');
                
                bAimToggle = true;
            }
            
            return true;
        }
        return false;
    }

    MotionState m_cMotionMoveToApply = null;
    
    static MotionState sm_cTmpMotion = new MotionState();
    
    boolean ProcessMotionKeys(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
        if (Precache.bPrecaching ||
            IsLeaning() ||
            bInMovie)
            return false;
        
        //czy fruwamy a podczas fruwania nie mozna sterowac graczem?
        //jesli tak, to bedziemy musieli zapamietywac wciskane
        //klawisze i obsluzyc je dopiero pozniej (po "wyladowaniu")
        boolean bSuspendApplyKeys = AmIFlying() && !CanTurnOnFlying();
            
        if ( bSuspendApplyKeys )
        {
            //zapamietajmy faktyczny stan motion state'a
            sm_cTmpMotion.Set( motion );
            
            //jesli jeszcze nie przechwytywalismy klawiszy podczase
            //tego skoku gracza, to przepiszmy oryginalny motion state
            if ( m_cMotionMoveToApply == null )
                 m_cMotionMoveToApply = new MotionState( motion );
            //ustawmy motion state na aktualnie przechwytywany
            //zostanie on zmodyfikowany w ProcessMotionKeysDo
            motion.SetMove( m_cMotionMoveToApply );
        }
            
        boolean bRet = ProcessMotionKeysDo( nKeyCode, bKeyState, nKeyAscii );
        
        if ( bSuspendApplyKeys )
        {
            //"obrobiony" stan zapamietujemy do zastosowania pozniej
            m_cMotionMoveToApply.Set( motion );
            
            //i przywracamy faktyczny stan motion state'a
            motion.Set( sm_cTmpMotion );
            //oczywiscie tak jakby zaden klawisz nie "przyszedl" zwracamy false
            return false;
        }
        
        return bRet;
    }

    /**Obsluga klawiszy zwiazanych z ruchem. Zmienia motionState
     */
	boolean ProcessMotionKeysDo(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
        if (Precache.bPrecaching ||
            IsLeaning())
            return false;
        
        boolean result = false;

        /*
        bCheckForLadder = bCheckForLadderExit = false;        

        if (nKeyCode == EGameControl.FORWARD)
        {
            if (bKeyState)
                motion.IncMoveZ();
            else
                motion.DecMoveZ();

            //wejscie na drabine tylko w czasie chodzenia do prodzu
            //wyjscie tylko w czasie cofania
            if (motion.iSpeed >= MotionState.SPEED_WALK)
            {
                if (motion.iMoveZ > 0)
                    bCheckForLadder = true;
                else if (motion.iMoveZ < 0)
                    bCheckForLadderExit = true;
            }

            result = true;

        } else if (nKeyCode == EGameControl.BACKWARD)
        {
            if (bKeyState)
                motion.DecMoveZ();
            else
                motion.IncMoveZ();

            //wejscie na drabine tylko w czasie chodzenia do prodzu
            //wyjscie tylko w czasie cofania
            if (motion.iSpeed >= MotionState.SPEED_WALK)
            {
                if (motion.iMoveZ > 0)
                    bCheckForLadder = true;
                else if (motion.iMoveZ < 0)
                    bCheckForLadderExit = true;
            }

            result = true;            
        } else if (nKeyCode == EGameControl.STRAFE_RIGHT)
        {
            if (bKeyState)
                motion.DecMoveX();
            else
                motion.IncMoveX();
            result = true;
        } else if (nKeyCode == EGameControl.STRAFE_LEFT)
        {
            if (bKeyState)
                motion.IncMoveX();
            else
                motion.DecMoveX();
            result = true;
        } 
        */
        return result;
    }

    void CheckMotionKeys()
    {
        //czy fruwamy a podczas fruwania nie mozna sterowac graczem?
        //jesli tak, to bedziemy musieli zapamietywac wciskane
        //klawisze i obsluzyc je dopiero pozniej (po "wyladowaniu")
        boolean bSuspendApplyKeys = AmIFlying() && !CanTurnOnFlying();
        
       
        if(IsLeaning() || !IsRegisteredKeyRequest() || bInMovie)
            return;
        
        if ( bSuspendApplyKeys )
        {
            //zapamietajmy faktyczny stan motion state'a
            sm_cTmpMotion.Set( motion );
            
            //jesli jeszcze nie przechwytywalismy klawiszy podczase
            //tego skoku gracza, to przepiszmy oryginalny motion state
            if ( m_cMotionMoveToApply == null )
                 m_cMotionMoveToApply = new MotionState( motion );
            //ustawmy motion state na aktualnie przechwytywany
            //zostanie on zmodyfikowany w ProcessMotionKeysDo
            motion.SetMove( m_cMotionMoveToApply );
        }
        
        int nPrevMoveX = motion.iMoveX;
        int nPrevMoveZ = motion.iMoveZ;
        
        motion.iMoveZ = 0;
        
        // sprawdzamy guziki do przodu
        if(GetKeyState(EGameControl.BACKWARD)) motion.iMoveZ-=1;
        // by Czesiu
        if(GetModule() instanceof ModuleNet)
        {
            if(GetKeyState(EGameControl.FORWARD)) motion.iMoveZ+=1;
        }
        else
        {
            if(IsLeaning_() && (!IsLeaning3_()))
                if(GetKeyState(EGameControl.FORWARD)) motion.iMoveZ+=1;
        }

        bCheckForLadder = bCheckForLadderExit = false;
        
        //wejscie na drabine tylko w czasie chodzenia do prodzu
        //wyjscie tylko w czasie cofania
        if (motion.iSpeed >= MotionState.SPEED_WALK)
        {
            if (motion.iMoveZ > 0)
                bCheckForLadder = true;
            else if (motion.iMoveZ < 0)
                bCheckForLadderExit = true;
        }

        motion.iMoveX = 0;
        if(GetKeyState(EGameControl.STRAFE_LEFT)) motion.iMoveX+=1;
        if(GetKeyState(EGameControl.STRAFE_RIGHT)) motion.iMoveX-=1;

        //jesli gosc jest zablokowany to powinien stac!
        if ( IsLockedByConnectionStatusManager() )
        {
            motion.iMoveX = 0;
            motion.iMoveY = 0;
            motion.iMoveZ = 0;
        }
                
        if ( bSuspendApplyKeys )
        {
            //"obrobiony" stan zapamietujemy do zastosowania pozniej
            m_cMotionMoveToApply.Set( motion );
            
            //i przywracamy faktyczny stan motion state'a
            motion.Set( sm_cTmpMotion );
            //oczywiscie tak jakby zaden klawisz nie "przyszedl" zwracamy false
        }
        else
        {
            // updateujemy ruch tylko przy rzeczywistej zmianie
            if( motion.iMoveX != nPrevMoveX ||
                motion.iMoveZ != nPrevMoveZ)
            {
                // updejtujemy motion
                if(!bUnableToAct)
                {
                    if( sCurrentState.equals("AimState"))
                    {
                        if (motion.iSpeed >= MotionState.SPEED_CRAWL)
                            UpdateMotion();
                    }
                    else
                        UpdateMotion();
                }
            }
        }
    }
    
    static int ConvertMouseButtonToKey(int nMouseButton)
    {
        if(nMouseButton == EMouse._BUTTON_1) return EKey._MOUSE_BUTTON1;
        if(nMouseButton == EMouse._BUTTON_2) return EKey._MOUSE_BUTTON2;
        if(nMouseButton == EMouse._BUTTON_3) return EKey._MOUSE_BUTTON3;
        return nMouseButton;
    }

    static int ConvertKeyToMouseButton(int nKey)
    {
        if(nKey == EKey._MOUSE_BUTTON1) return EMouse._BUTTON_1;
        if(nKey == EKey._MOUSE_BUTTON2) return EMouse._BUTTON_2;
        if(nKey == EKey._MOUSE_BUTTON3) return EMouse._BUTTON_3;
        return nKey;
    }
    
    void ProcessMouseButtons(int nButton, int nState)
    {
        // gdy wylaczona mysz to nie dziala lewy przycisk myszy sluzacy do klikania
        if(bMouseUnacquired && (nButton == EMouse._BUTTON_1)) return;
        
        //uzyty tu jest OnInputKey, zeby nie powielac obslugi klawiatury (myszka tez
        //moze byc podpieta pod rozne akcje)
        CallOnInputKey(ConvertMouseButtonToKey(nButton), nState, '0');
    }
    
    /**
     */
    byte GetSpeedFromKeyState()
    {
        if (bSwimming) return MotionState.SPEED_SWIM; 
        else if (bCrawling) return MotionState.SPEED_CRAWL;
        else if (bDucking) return MotionState.SPEED_DUCK;
        else if (bWalking) return MotionState.SPEED_WALK;
        return MotionState.SPEED_RUN;
    }

    /** Zmienia flagi stanu klawiszy, ale nie modyfikuje iSpeed w motionState
     */
	boolean ProcessStateKeys(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
        if (Precache.bPrecaching || bInMovie)
            return false;
        
        if (nKeyCode == EGameControl.LEAN_LEFT)
        {
            if (bKeyState)
                StartLeaningLeft();
            else
                StopLeaningLeft();
            return true;
            
        }else if (nKeyCode == EGameControl.LEAN_RIGHT)
        {
            if (bKeyState)
                StartLeaningRight();
            else
                StopLeaningRight();
            return true;
        }
        
        if (IsLeaning())
            return false;
        
        if (nKeyCode == EGameControl.WALK_TOGGLE)
        {
            if (bKeyState) bWalking=!bWalking;
            return true;
        }
        
        if (nKeyCode == EGameControl.DUCK_TOGGLE)
        {
            if (bKeyState) 
            {
                bDucking = !bDucking;
				bDuckingToggle = bDucking;
                if (bDucking)
				{
                    bCrawling = false;
					bCrawlingToggle = false;
				}
            }
            return true;
        }
        
        if (nKeyCode == EGameControl.CRAWL_TOGGLE)
        {
            if (bKeyState) 
            {
                bCrawling = !bCrawling;
				bCrawlingToggle = bCrawling;
                if (bCrawling)
				{
                    bDucking = false;
					bDuckingToggle = false;
				}
            }
            return true;
        }
        
        if (nKeyCode == EGameControl.WALK)
        {
            if (bKeyState)
                /*motion.*/bWalking = true;
            else 
                /*motion.*/bWalking = false;
            return true;
            
        } else if (nKeyCode == EGameControl.DUCK)
        {
            if (bKeyState)
            {
                /*motion.*/bDucking = true;
                           bDuckingToggle = false;
                           bCrawling = false;
            }
            else
            {
                /*motion.*/bDucking = false;
            }
            return true;
            
        } else if (nKeyCode == EGameControl.CRAWL)
        {
            if (bKeyState)
            {
                /*motion.*/bCrawling = true;
                           bDucking = false;
                           bCrawlingToggle = false;
            }
            else
                /*motion.*/bCrawling = false;
            return true;
        }

            
        return false;
        
        
    }
    
    boolean CanPressLeftCtrl()
    {
        //nie mozna uzyc lewego ctrl gdy wlaczony hud implantow, tam ten klawisz ma inne znaczenie
        return (((PlayerHUD)this).HUD.GetActiveHudMenu() != HUDManager._HUD_IMPL_MENU);
    }
    
    float fLastDeltaX = 0.0f;
    float fLastDeltaY = 0.0f;
    
    float fDeltaAccelX = 2.0f;
    float fDeltaThresholdX = 2.0f;
    
    float fDeltaAccelY = 2.0f;
    float fDeltaThresholdY = 2.0f;
    
    /** Obsluga myszy
     */
    void OnInputMouseAxis(int nAxis, int nDelta)
    {
        if (Game.cSingleton.IsScreenShotMode())
            return;
        if (cSeatInfo != null)
            return; // nie obracamy sie rowniez, kiedy siedzimy
        if (IsLeaning() && nAxis == EMouse._AXIS_X)//przy wychylaniu sie nie mozemy rozgladac sie na boki
            return;
            
        float fZoomerModifier = 1.0f;

        if (cZoomer != null)
        {
            fZoomerModifier = 1.0f/cZoomer.GetZoom();
        }

        float fDelta = (float)nDelta;
        
        float fImplantModifier = 1f;
        if (IsImplantActive(ImplantSystem._IMPLANT_SLOMO))
            fImplantModifier = ImplantSlomo._PLAYER_SLOMO;
        
        switch (nAxis)
        {
        case EMouse._AXIS_X :
            {
                float fDeltaAccel = 1.0f;
            
                if( Math.abs(fDelta - fLastDeltaX) > fDeltaThresholdX)
                    fDeltaAccel = fDeltaAccelX;
            
                fLastDeltaX = fDelta;
                float fRotate = fDelta * ControlLoadSave.fMouseSensitivity * fDeltaAccel * fZoomerModifier * fImplantModifier;
                RotateH( fRotate );
                //vRecoilTranslation.fX = vRecoilTranslation.fY = 0;
            }
            break;
        case EMouse._AXIS_Y :
            {
                float fDeltaAccel = 1.0f;
            
                if( Math.abs(fDelta - fLastDeltaY) > fDeltaThresholdY)
                    fDeltaAccel = fDeltaAccelY;

                float fInvert = ControlLoadSave.Invert_Mouse ? -1.f : 1.f;
                
                fLastDeltaY = fDelta;
                float fRotate = fDelta * fInvert * ControlLoadSave.fMouseSensitivity * fDeltaAccel * fZoomerModifier * fImplantModifier;
                RotateV( fRotate );
                //vRecoilTranslation.fX = vRecoilTranslation.fY = 0;
            }
            break;
            
        case EMouse._AXIS_Z:
            {
                if (cZoomer != null)
                {
                    cZoomer.AddZoom(-nDelta);
                    if (Camera != null)
                        Camera.SetZoom(cZoomer.GetZoom());
                }
                else
                {
                    HUDManager.ProcessMouseWheel(this, nAxis, nDelta);
                }
            }
            break;
		}
        
        
    }

    void RotateH(float fTurn)
    {
        RotateHDo( fTurn );
    }
    void RotateV(float fTurn)
    {
        RotateVCameraOnly( fTurn );
        RotateVDo( fTurn );
    }

    /** Ruch w poziomie
     */
    void RotateHDo(float fTurn)
    {
        RotateHDo( fTurn, true );
    }
    void RotateHDo(float fTurn, boolean bFull )
    {
		Vector vPlayerForward	= GetForwardVectorVolatile();
        Vector vPlayerRight		= GetRightVectorVolatile();

        //dokladniejsze obliczanie obrotu - fTurn jako kat
        vPlayerForward.Mul((float)Math.cos(fTurn));
        vPlayerRight.Mul((float)Math.sin(fTurn));
        vPlayerForward.Add(vPlayerRight);

        if (bLimitMoves)
        {
            if (vPlayerForward.Dot(vOldForward) > fCosMaxHRotation)
                SetDir( vPlayerForward );
        }
        else
        {
            SetDir( vPlayerForward );            
        }

        if ( bFull )
        {
            bBodyDeformAimAtH = true;
        
            //jesli lecimy to nasz kierdunek predkosci sie nie powinien
            //zmienic po obrocie, wiec pobierzmy go
            if ( AmIFlying() && !CanTurnOnFlying() )
                GetLocalSpeed( this.vSpeed ); 
            SetLocalSpeed( this.vSpeed, m_bUseWalkDestSpeed );
        }
    }

    /** Ruch w pionie
     */
    void RotateVCameraOnly( float fTurn )
    {
        if (Camera != null)
        {
            if (Camera.fAimAngleY - fTurn <= -PIhalf + 0.05)
                Camera.fAimAngleY = -PIhalf + 0.05f;
            else
                if (Camera.fAimAngleY - fTurn >= PIhalf - 0.05)
                    Camera.fAimAngleY = PIhalf - 0.05f;
                else
                    Camera.fAimAngleY -= fTurn;
        }
    }
    
    void RotateVDo(float fTurn)
    {
        if (Camera != null)
        {
            //tu juz w kamerze mamy zapamietane fAimAngleY
            fAimAngleY =- Camera.fAimAngleY;
        }
        else
        {
            if (fAimAngleY - fTurn <= -PIhalf + 0.05)
                fAimAngleY = -PIhalf + 0.05f;
            else
                if (fAimAngleY - fTurn >= PIhalf - 0.05)
                    fAimAngleY = PIhalf - 0.05f;
                else
                    fAimAngleY -= fTurn;
            
        }
        
        bBodyDeformAimAtV = true;

        // na drabinie nalezy zupdateowac predkosc, bo moze sie zmienic kierunek ruchu gora/dol
        if (motion.nClimbing >= MotionState._CLIMBING_TRUE)
            UpdateSpeed();
    }

    Vector l_vDir = new Vector();
    /** Ustawia wektor patrzenia playera. 
     *  Uwaga: Skladowa fY jest pionowym katem patrzenia playera.
     */
    void SetAimDirection(Vector vAimVector)
    {
        l_vDir.Set(vAimVector.fX, 0, vAimVector.fZ);
        SetDir( l_vDir );
        //w normalnym playerze ignorujemy kat patrzenia gora/dol
        //w kliencie sterowanym przez serwer ustawiamy lokalny kat patrzenia
        //fAimAngleY = vAimVector.fY;
        SetAimAngleY(vAimVector.fY);

        //if (CameraTracking != null)
        //ustawienie kamery

        bBodyDeformAimAtH = true;
        bBodyDeformAimAtV = true;
    }

    /** Pobiera wektor patrzenia gracza.
     * Uwaga: Skladowa fY jest pionowym katem patrzenia playera.
     */
    Vector GetAimDirection()
    {
        Vector vFwd = GetForwardVectorVolatile();
        return new Vector(vFwd.fX, GetAimAngleY(), vFwd.fZ);
    }

    /**
     */
    float GetAimAngleY()
    {
        /*if (Camera != null)
            return -Camera.fAimAngleY;//AimAngleCameraToWeapon();
        else*/
            return fAimAngleY;
    }

    void SetAimAngleY(float fAngle)
    {
        if (Camera != null)
            Camera.fAimAngleY = -fAngle;//AimAngleWeaponToCamera(fAngle);
        else
            fAimAngleY = fAngle;
    }

    /** Metoda wolana na koniec kazdego OnFrame. Konieczne w sieci do wyslania wynikow ramki
     * w eter. Trzeba pamietac o dopisaniu tej metody wszedzie !
     */
    void FrameFinished()
    {
    }

///////////////////////////////// 
// MODYFIKACJE SZKIELETU

    boolean bMoviePlaceGunDummy = false;
    
    /** Ulozenie broni w rekach
     */
    void PlaceGun()
    {
        if ( (ActiveWeapon == null) || (nRenderMode != REN_FULL) )
            return;

        Vector vGunAxis = null, vGunAxisPerp, vGunPos = null;

        if(bInMovie)
        {
            if(bMoviePlaceGunDummy)
            {
                ActiveWeapon.FromUpForwardPos(GetElementUpVector(nRightHandID), 
                                          GetElementForwardVector(nRightHandID), 
                                          GetElementPos(nRightHandID));
            }
            else
            {
                vGunAxis = GetElementPos( nLeftHandID );
            
                vGunPos = new Vector(vGunAxis);
                vGunPos = PointWorldToLocal( nLeftHandID, vGunPos );
            
                vGunAxis.Sub( GetElementPos( nRightHandID ) );
            }
        }
        else
        if (ActiveWeapon.nType == EWeaponType._PISTOL)
        {
            vGunAxis = GetBoneDirVector( EBones._R_FOREARM );
            vGunAxisPerp = GetBonePerpVector( EBones._R_FOREARM );
            vGunAxisPerp.Mul(-1.f);
            ActiveWeapon.FromUpForwardPos(vGunAxisPerp, vGunAxis, ActiveWeapon.GetPositionVectorVolatile());
            return;
        }
        else if (ActiveWeapon.nType == EWeaponType._KNIFE)//TODO: a hands?
        {
            ActiveWeapon.FromUpForwardPos(GetElementUpVector(nRightHandID), 
                                          GetElementForwardVector(nRightHandID), 
                                          GetElementPos(nRightHandID));
        }
        else if (ActiveWeapon.nType == EWeaponType._BINOCULARS)
        {
            //TODO: jak pozycjonowac lornetke?
            vGunAxis = GetBonePerpVector( EBones._R_FOREARM );
            vGunAxis.Negate();
            
            vGunAxis.Add( m_vBinocularsRotate );
            if ( bCrawling )
                vGunAxis.fY -= 0.4f;
            else if ( bDucking )
                vGunAxis.fY -= 0.3f;
            vGunPos = m_vBinocularsMove;
        }
        else
        {
            
            ActiveWeapon.FromUpForwardPos(GetElementUpVector(nRightHandID), 
                                      GetElementForwardVector(nRightHandID), 
                                      GetElementPos(nRightHandID));
            
            
            vGunPos = null;
            vGunAxis = null;
            
            /*
            vGunAxis = GetElementPos( nLeftHandID );
            
            vGunPos = new Vector(vGunAxis);
            vGunPos = PointWorldToLocal( nLeftHandID, vGunPos );
            
            vGunAxis.Sub( GetElementPos( nRightHandID ) );
            */
        }
        if (vGunPos!=null) 
            ActiveWeapon.SetPosition( vGunPos );
        if (vGunAxis!=null)
            ActiveWeapon.SetDir( vGunAxis );
    }
    
    Vector m_vBinocularsRotate     = new Vector(  0.0f, -0.5f, 0.0f );
    Vector m_vBinocularsMove       = new Vector(  9.0f,  3.0f, 0.0f );
    
    byte bDeformStrafe = 0;

    /** Deformacja przy strafeowaniu
     */
    void BodyDeformStrafe(byte dir)
    {
        //nie deformuj ciala jesli nie widzimy z TPP lub jestesmy 
        // schyleni
        if ( (nRenderMode != REN_FULL) || 
             (motion.iSpeed < MotionState.SPEED_DUCK) ||
             (bDeformStrafe == dir) )
            return;
        else {
            //LogD("\n");
            BoneRotate(EBones._PELVIS, new Vector(1, 0, 0), dir*30);
            BoneRotate(EBones._SPINE, new Vector(1, 0, 0), -dir*15);
            BoneRotate(EBones._SPINE1, new Vector(1, 0, 0), -dir*15);
            bDeformStrafe = dir;
        }
    }
    
    /*
     * Wyprostowanie strafe'a
     */
    void BodyDeformStrafeReset()
    {
        if ( (nRenderMode != REN_FULL) ||
             (bDeformStrafe == 0) )
            return;
        else {
            //LogD("\n");                            
            BoneRotate(EBones._PELVIS, new Vector(1, 0, 0), 0);
            BoneRotate(EBones._SPINE, new Vector(1, 0, 0), 0);
            BoneRotate(EBones._SPINE1, new Vector(1, 0, 0), 0);
            bDeformStrafe = 0;
        }
    }

    /**Celowanie za kamera w pionie.
     */
    void BodyDeformAimAtV()
    {
        if ( !bBodyDeformAimAtV ||
             (nRenderMode != REN_FULL) ||
             (motion.iSpeed < MotionState.SPEED_WALK) )
            return;
        
        BodyDeformAimAtVDo();
    }
    
    void BodyDeformAimAtVDo()
    {
        // flaga wlaczania deformacji ciala        
        bBodyDeformAimAtV = false;

        float deform;
        if (Camera != null)
        {
            deform = Camera.fAimAngleY * RAD2DEG;
            //LogD(" cam, deform "+deform+"\n");
        }
        else
        {
            // TODO: tu dopisalem minusa i pomnozylem razy RAD2DEG zeby bylo
            // dobrze, ale nie wiem czy tak zostanie.
            deform = -fAimAngleY * RAD2DEG;
            //LogD(" deform "+deform+"\n");
        }

        //ograniczenie zbytniego wygiecia
        if (deform > 45) deform = 45;
        else if (deform < -45) deform = -45;
        
        //LogD(" deform "+deform+"\n");

        BoneRotate(EBones._NECK, new Vector (0, 1, 0), deform*.5f);
        BoneRotate(EBones._HEAD, new Vector (0, 1, 0), deform*.5f);
    }

    /**Wolana przy schylaniu sie.
     */
    void BodyDeformAimAtVReset()
    {
        //LogD("\n");
        BoneRotate(EBones._NECK, new Vector (0, 1, 0), 0);
        BoneRotate(EBones._HEAD, new Vector (0, 1, 0), 0);
    }

    boolean bBodyDeformAimAtH = true;
    boolean bBodyDeformAimAtV = true;
    
    /**Celowanie za kamera w poziomie
     */
    boolean BodyDeformAimAtH()
    {
        //w grze sieciowej jezeli warunek ( deform < fCosMaxHRotation ) 
        //nie jest spelniony to gracz zle sie obraca, zatem musimy
        //zwrocic informacje o tym fakcie, zeby dokonac korekty
        boolean bRequiredCorrectonInNetGame = false;
            
        if ( (nRenderMode != REN_FULL) || (!bBodyDeformAimAtH) ) 
            return bRequiredCorrectonInNetGame;
        
        // flaga wlaczania deformacji ciala        
        bBodyDeformAimAtH = false;

        if ( motion.IsMovingLinear() || (motion.iSpeed < MotionState.SPEED_WALK) )
            return bRequiredCorrectonInNetGame;

        float deform = vOldForward.Dot(GetForwardVector());

        if ( deform < fCosMaxHRotation ) //cos(60)
        {
            vOldForward = GetForwardVector();
            bRequiredCorrectonInNetGame = true;
        }

        if (deform < 0.999)
        {
            //TODO: optimize - don't use acos - just estimate....
            deform = (float)(Math.acos(deform)* RAD2DEG);
            if ( vOldForward.Dot(GetRightVector()) < 0 )
                deform = - deform;
        }
        else 
            deform = 0;

        //LogD(" deform "+deform+"\n");
        
        BoneRotate(EBones._PELVIS, new Vector(1, 0, 0), deform);
        BoneRotate(EBones._SPINE, new Vector(1, 0, 0), -deform*.5f);
        BoneRotate(EBones._SPINE1, new Vector(1, 0, 0), -deform*.5f);
        
        return bRequiredCorrectonInNetGame;
    }

    /** Wolana po tym, jak player rusza z miejsca lub schyla sie.
     */
    void BodyDeformAimAtHReset()
    {
        vOldForward = GetForwardVector();
        
        //LogD("\n");
        BoneRotate(EBones._PELVIS, new Vector(1, 0, 0), 0);
        BoneRotate(EBones._SPINE, new Vector(1, 0, 0), 0);
        BoneRotate(EBones._SPINE1, new Vector(1, 0, 0), 0);
    }

	///////////////////////////////////////////////////////////////////////////////
	// POJAZDY
	///////////////////////////////////////////////////////////////////////////////
    
    void PrepareToGetIn(SeatInfo seat)
	{
		if (seat.GetReserver() != null)
			return;
		seat.Reserve(this);
	}
    
    /** Wejscie do pojazdu */
    void GetIn(SeatInfo seatInfo)
    {
		super.GetIn(seatInfo);
        
		if (cSeatInfo == null)
			return;

		// ustawiamy poprzedni tryb kamery, by go pozniej przywrocic
        if ( Camera != null )
            nOldCameraMode = Camera.GetMode();
        
		if (cSeatInfo.GetRole() == EPassengerRole._VEHICLE_DRIVER ||
            cSeatInfo.GetRole() == EPassengerRole._VEHICLE_PASSENGER_IDLE)            
		{
			if (cSeatInfo.GetOccupiedObject() instanceof Vehicle)
			{
				Vehicle vehicle = (Vehicle) cSeatInfo.GetOccupiedObject();
				SetupAnimsAndCamerasToGetIn(vehicle);
                if (cSeatInfo.GetRole() == EPassengerRole._VEHICLE_DRIVER)
				    vehicle.SetState("DrivenState");
			}
            else
    			SitDownToDrive();
		}
		else
			SitDownToDrive();

		if (cSeatInfo.GetOccupiedObject() instanceof ISeatVehicle)
			((ISeatVehicle) cSeatInfo.GetOccupiedObject()).PawnGotIn(cSeatInfo, this);

        ClearCollFlags(ECollFlags.OBJCOL_FLAG_TESTTERRAINTYPE);
        StopMakingStepNoise();
    }
    
	
    /** Wyjscie z pojazdu */
    boolean GetOut()
    {
		// wychodzimy przed pojazd
		ISeatVehicle vehicle = (ISeatVehicle) cSeatInfo.GetOccupiedObject();
		Vector vPos = GetCheckedPosToGetOut(vehicle,cSeatInfo);
		if (vPos == null)
			return false;
        
		if (!super.GetOut())
			return false;
		
		Vector vDir = cSeatInfo.GetSeatDir();
		vDir.fY = 0f;
		vDir.Normalize();
		SetPositionWorld(vPos);
		SetDir(vDir);
		
		if (cSeatInfo.GetRole() == EPassengerRole._VEHICLE_DRIVER &&
            vehicle instanceof Vehicle)
			((Vehicle)vehicle).SetState("UncaredDriveState"); // pojazd jedzie teraz bez nas
		
		vehicle.PawnGotOut(cSeatInfo, this);
				
		cSeatInfo.Occupy(null);
		cSeatInfo = null;

        motion.Reset();
        
        UpdateMotion();
        UpdateState();

		SetupAnimsAndCamerasToGetOut();

        SetCollFlags(ECollFlags.OBJCOL_FLAG_TESTTERRAINTYPE);
        
        // dodatkowo zabezpieczamy sie na wypadek zalapania skoku
        vLastPosOnGround = GetPosition();
        
		return true;
    }
    
    Vector GetCheckedPosToGetOut(ISeatVehicle cVehicle,SeatInfo cSeat)
    {
        return cVehicle.GetCheckedPosToGetOut( cSeat );
    }
	
	void SetupAnimsAndCamerasToGetIn(Vehicle vehicle)
	{
		SitDownToDrive();
        
        if (Camera != null)
        {
            // przelaczamy widok na VEHICLE
			Camera.m_fObservedSightVAngle = vehicle.m_fObservedSightVAngle;
			Camera.m_fOverObservedHeight = vehicle.m_fOverObservedHeight;
			Camera.m_fOverObservedBack = vehicle.m_fOverObservedBack;
            
            if ( (cSeatInfo != null) && 
                 (cSeatInfo.GetRole() == EPassengerRole._VEHICLE_PASSENGER_IDLE) )
            {
                Camera.SetMode( CameraPlayer.CMODE_VEHICLE_PASSENGER );
            }
			else
                Camera.SetMode( vehicle instanceof Walker ? 
                                CameraPlayer.CMODE_WALKER : 
                                CameraPlayer.CMODE_VEHICLE );
            nRenderMode = REN_FULL;
        }
	}
	
	void SitDownToDrive()
	{
        motion.Stop();
        oldMotion.Stop();
        bDucking = false;
        bCrawling = false;
        bWalking = false;
        
        if (cSeatInfo != null)
        {
            BodyDeformAimAtVReset();
            BodyDeformAimAtHReset();
        }
            
        ResetBodyInVehicle();
	}
	
	void SetupAnimsAndCamerasToGetOut()
	{
        // przelaczamy widok na poprzedni
        if (Camera != null)
        {
            Camera.SetMode(nCameraGameMode);
            Camera.SetTake( motion, false );
            
            //TODO: to jest chyba niepotrzebne!
            if (nOldCameraMode == CameraPlayer.CMODE_TPP)
                nRenderMode = REN_FULL;
            else 
                nRenderMode = REN_FPP;
        }
	}
	
	void VehicleCrashed()
	{
        super.VehicleCrashed();
            
		ActionGetOut();
			
	    if (bNetIsOwner)
	    	Camera.Flash(CameraExtended._FLASH_BLOOD, 0.3f, 1f, 1f);
	}

///////////////////////////////////////////////////////////////////////////////
// Update Motion
///////////////////////////////////////////////////////////////////////////////
        
    static float oneOverSqrt2 = (float)( 1.0/Math.sqrt(2) );
    
    byte nHitReaction = 0;

    /**Wlacza odpowiednia animacje na podstawie parametrow opisujacych stan:
     * iSpeed, iMove, iTurn
     */
    void UpdateMotion()
    {
        if ( bNetIsOwner )
        {
            //jesli lecimy a podczas lotu nie sterujemy to koniec
            //TODO: upewnic sie czy czasem nie bedzie czasem
            //potrzebne obsluzenie UpdateMotion podczas lotu!!!
            if ( AmIFlying() && !CanTurnOnFlying() )
                return;
            
            //jesli sa jakies wcisniete klawisze (najprawdopodobniej
            //podczas skoku) to nalezy je teraz zastosowac
            if ( m_cMotionMoveToApply != null )
            {
                motion.SetMove( m_cMotionMoveToApply );
                m_cMotionMoveToApply = null;
            }
        }

        // podczas wspinania sie jestesmy na ziemi
        if(motion.nClimbing > motion._CLIMBING_FALSE &&
           nEnvironment != EMoveEnv.CHMOVE_GROUND) 
            OnChangeMovement(EMoveEnv.CHMOVE_GROUND);
        
        ////////////////////////////////////////
        //ustalenie predkosci na podstawie stanu klawiszy i innych flag
        /*if (bUnderWater)
        {
            //motion.iSpeed = MotionState.SPEED_SWIM;
            LogR("Under water\n");
        }
        
        else*/ if (nEnvironment == EMoveEnv.CHMOVE_AIR)
        {
             motion.iSpeed = MotionState.SPEED_RUN;
             //LogD("Air\n");
             //LogD(" vPos "+GetPosition()+"\n");
             //Thread.dumpStack();
        }

        else
        {
            byte iSpeed ;

            //schylic mozemy sie bez przeszkod
            //(nad wstawaniem czuwa co ramke HomoErectus)
            if ( (iSpeed = GetSpeedFromKeyState()) < motion.iSpeed )
                motion.iSpeed = iSpeed;
            
            // zmiana z chodzenia na bieganie
            if ( (motion.iSpeed >= MotionState.SPEED_WALK) && (iSpeed >= MotionState.SPEED_RUN) )
                motion.iSpeed = iSpeed;

            // nie mozemy biegac w tyl ani przycelowujac
            if ( (motion.iSpeed == MotionState.SPEED_RUN) && 
                 ( ((motion.iMoveZ == -1)&&(!m_bCanRunBackward)) || 
                   motion.bAiming        || 
                   bRecoiling            ||
                   (nHitReaction != 0)   ||
                   (!m_bCanRunWithHeavyGun && (ActiveWeapon != null) && (ActiveWeapon.nType == EWeaponType._HEAVY)) 
                 )
               )
            {
                motion.iSpeed = MotionState.SPEED_WALK;
            }

            //po drabinie chodzic mozemy tylko wyprostowani
            if (motion.nClimbing > motion._CLIMBING_FALSE)
                motion.iSpeed = MotionState.SPEED_WALK;
        }

        //zmiana rodzaju ruchu
        if (motion.iSpeed != oldMotion.iSpeed)
        {
            UpdateEllipsoidAndMaxClimbAngle();
            
            //ustalenie wysokosci kamery
            if (Camera != null)
                Camera.SetTake(motion, true);
        }

        ////////////////////////////////////
        // deformacje zwiazane z patrzeniem w kierunku kamery
        // (tylko dla TPP)
        if (nRenderMode == REN_FULL)
        {
            //czy ruszamy z miejsca?
            if ((oldMotion.iMoveZ == 0) && (motion.iMoveZ != 0))
                BodyDeformAimAtHReset();

            //czy schylamy sie?
            if ( (oldMotion.iSpeed >= MotionState.SPEED_WALK) &&
                 (motion.iSpeed < MotionState.SPEED_WALK) )
            {
                BodyDeformAimAtVReset();
                BodyDeformAimAtHReset();
                BodyDeformStrafeReset();
                vOldForward = GetForwardVector();
                LogLine("Schylamy sie");
            }
            //czy wstajemy?
            else if ( (oldMotion.iSpeed < MotionState.SPEED_WALK) &&
                      (motion.iSpeed >= MotionState.SPEED_WALK) )
            {
                BodyDeformAimAtV();
                LogLine("Wstajemy");
            }
        }
        else
        // deformacje kosci jesli jestesmy w FPP
        // (w ten sposob wrogowie beda trafiac mniej wiecej w odpowiednie czlonki)
        {
            // zaremowane, bo teraz odpala sie animacja gracza normalnie
            //SetFrame(aAnimFrameSeqenceID[motion.iSpeed], aAnimFrame[motion.iSpeed], -1);
            //LogD("frame set:"+aAnimFrame[motion.iSpeed]+" for elem:"+iRootBoneElem+"\n");
        }

        ///////////////////////////////////////////////////////////////////////
        //ustalenie predkosci
        UpdateSpeed();
        

        //LogLine("speed: "+motion.iMoveZ+", "+vSpeed);

        ///////////////////////////////////////////////////////////////////////
        //odpalenie odpowiedniej animacji
        //ustaw zestaw animacji
        Anims.SetupAnims(motion, ActiveWeapon);
        
        ///////////////////////////////////////////////////////////////////////
        // dzwiek kroku co jakis czas - zaleznie od predkosci animacji
        if (motion.IsMovingLinear() )
        {
            if(nEnvironment == EMoveEnv.CHMOVE_AIR)
            {
                StopMakingStepNoise();
            }
            else
            {
                if (!motion.IsEqualMoving(oldMotion))
                    bMakingStepNoise = false; // jesli sie zmienilo - przelicz
                StartMakingStepNoise();
            }
        }
        else
        {
            StopMakingStepNoise();
        }

        if ( nEnvironment != EMoveEnv.CHMOVE_AIR )
        {
            //czy wstajemy z czolgania?
            if ( (oldMotion.iSpeed == MotionState.SPEED_CRAWL) &&
                  (motion.iSpeed != MotionState.SPEED_CRAWL) )
            {
                //DLog("get up!");
                //LogLine("Wstajemy z czolgania");                

                //zatrzymanie i zablokowanie akcji
                bUnableToAct = true;

                //animacja przejscia miedzy odpowiednimi stanami
                int nAnim = Anims.A_CRAWL2STAND;
                if (motion.iSpeed == MotionState.SPEED_DUCK)
                    nAnim = Anims.A_CRAWL2DUCK;
                
                if ( UpdateMotionCanPlayAnim() )
                    Anims.Play( nAnim );
                CallMethodIn(METHOD_MotionModeChanged, CameraPlayer.fHeightChangeTime/*Anims.GetLength(nAnim)*/);
                
                // czy kladziemy sie do czolgania?
            } else 
            if ( (oldMotion.iSpeed != MotionState.SPEED_CRAWL) &&
                 (motion.iSpeed == MotionState.SPEED_CRAWL) )
            {
                //zatrzymanie i zablokowanie akcji
                bUnableToAct = true;
                BodyDeformStrafeReset();

                int nAnim = Anims.A_STAND2CRAWL;
                if (oldMotion.iSpeed == MotionState.SPEED_DUCK)
                    nAnim = Anims.A_DUCK2CRAWL;
                
                if ( UpdateMotionCanPlayAnim() )
                     Anims.Play( nAnim );
                CallMethodIn(METHOD_MotionModeChanged, CameraPlayer.fHeightChangeTime/*Anims.GetLength(nAnim)*/);
                
            }else 
            //czy wstajemy z plywania?
            if ( (oldMotion.iSpeed == MotionState.SPEED_SWIM) &&
                 (motion.iSpeed != MotionState.SPEED_SWIM) )
            {
                //DLog("get up!");
                LogLine("Wstajemy z plywania");                

                //zatrzymanie i zablokowanie akcji
                bUnableToAct = true;

                //animacja przejscia miedzy odpowiednimi stanami
                int nAnim = Anims.A_SWIM2STAND; 
                if (motion.iSpeed == MotionState.SPEED_DUCK)
                    nAnim = Anims.A_SWIM2DUCK;    

                if ( UpdateMotionCanPlayAnim() )
                    Anims.Play( nAnim );
                
                CallMethodIn( METHOD_MotionModeChanged, CameraPlayer.fHeightChangeTime/*Anims.GetLength( nAnim )*/ );
            } 
            else 
                // czy kladziemy sie do plywania?
            if ( (oldMotion.iSpeed != MotionState.SPEED_SWIM) &&
                 (motion.iSpeed == MotionState.SPEED_SWIM) )
            {
                LogLine("Kladziemy sie do plywania");                

                //zatrzymanie i zablokowanie akcji
                bUnableToAct = true;
                BodyDeformStrafeReset();

                int nAnim = Anims.A_STAND2SWIM; 
                if (oldMotion.iSpeed == MotionState.SPEED_DUCK)
                    nAnim = Anims.A_DUCK2SWIM;    
                
                if ( UpdateMotionCanPlayAnim() )
                    Anims.Play( nAnim );
                
                CallMethodIn( METHOD_MotionModeChanged, CameraPlayer.fHeightChangeTime/*Anims.GetLength( nAnim )*/ );
            
            }
                // czy poruszamy sie?
            else if ( motion.IsMovingLinear() )
            {
                switch (motion.iMoveZ)
                {
                case -1 : //backward
                    //LogLine("Anims.A_BACKWARD");
                    if ( UpdateMotionCanPlayAnim() )
                        Anims.PlayLoop( Anims.A_BACKWARD );
                    
                    if (motion.iSpeed >= MotionState.SPEED_WALK)
                        BodyDeformStrafe( (byte)-motion.iMoveX );
                    break;
                case 0 : //strafe
                    if (motion.iSpeed == MotionState.SPEED_RUN)
                    {
                        //LogLine("Anims.A_FORWARD");                
                        if ( UpdateMotionCanPlayAnim() )
                            Anims.PlayLoop( Anims.A_FORWARD );
                        
                        BodyDeformStrafe((byte)motion.iMoveX);
                    }
                    else {
                        //LogLine("strafe");                
                        int nAnim = (motion.iMoveX > 0)?
                                    Anims.A_STRAFE_LEFT:
                                    Anims.A_STRAFE_RIGHT;
                        if ( UpdateMotionCanPlayAnim() )
                            Anims.PlayLoop( nAnim );
                    }
                    break;
                case 1 : //forward
                    if ( UpdateMotionCanPlayAnim() )
                        Anims.PlayLoop( Anims.A_FORWARD );
                    
                    if (motion.iSpeed >= MotionState.SPEED_WALK)
                        BodyDeformStrafe( motion.iMoveX );
                    break;
                }
                // a wiec stoimy
            } else
            {
                if ( !motion.IsJumping() /*&& motion.bAiming == false*/ )
                {
                    //juz nie strafujemy
                    BodyDeformStrafeReset();

                    // gdy przeladowanie to nie mozna odpalac zwyklego stania
                    
                    if ( UpdateMotionCanPlayAnim() )
                    {
                        //CrashLog("Anims.A_STAND "+motion.toString()+" "+GetTime()+"\n");
                        Anims.PlayLoop( Anims.A_STAND );
                    }

                    //obrot
                    if ( motion.iTurn != 0 )
                        SetAngSpeed( motion.iTurn*TURN_SPEED );
                    else
                        SetAngSpeed(0);
                }
            }
        }
        else //latamy
        {
            //BodyDeformStrafeReset();

            //animacja skoku odpalana jest w czasie wybicia
            //Anims.Play(Anims.A_JUMP);
        }
        
        if ( nHitReaction != 0 )
        {
            Anims.Unlock();
            Anims.PlayNoMorph( nHitReaction );
            
            // blokoujemy animacje
            Anims.Lock();
            float fLen = Anims.GetLength(nHitReaction);
            CallMethodIn("HitReactionEndAnim", fLen);
        }

        if ( motion.nJumping == motion._JUMPING_TRUE )
        {
            if ( CanPlayerJump() ) 
            {
                //Log(" ok, CanJump \n");
                PlayerJump();
            }
            
            else
            {
                Log("CantJump!\n");
                motion.nJumping = motion._JUMPING_FALSE;
            }
        }
        
        if ( motion.nJumping == motion._JUMPING_OFF_LADDER )
        {
            if ( CanPlayerJump() ) 
            {
                //Log(" ok, CanJump \n");
                PlayerJumpOffLadder();
            }
            else
            {
                LogLine("CantJump!\n");
                motion.nJumping = motion._JUMPING_FALSE;
            }
        }
                
        oldMotion = new MotionState(motion);
        
        PostUpdateMotion();
    }

    void HitReactionEndAnim()
    {
        // odblokowujemy animacje do czasu zakoczenia postrzalu
        Anims.Unlock();
        UpdateMotion();
    }

    boolean UpdateMotionCanPlayAnim()
    {
        return (!m_bIsThrowingGrenade) || (nCameraGameMode == Camera.CMODE_TPP);
    }

            
    /** Wszystko co chcemy wykonac po skonczeniu obslugi UpdateMotion 
     * Np po skoku nalezy wylaczyc flage nJumping (jest ona tylko jednorazowa)
     * Jednak w przypadku gry sieciowej to wylaczenie bedzie musialo nastapic
     * dopiero po przeanalizowaniu motion state'a ( PlayerNet.UpdateMotion(), 
     * dlatego zamknalem to w metodzie ktora mozna bedzie pokryc na pusta 
     * (akcja nie nastapi, w tym przypadku flaga nie bedzie zerowana)
     * i pozniej po zakonczeniu analizy recznie trzeba bedzie odpalic ta metode.
     */
    void PostUpdateMotion()
    {
        motion.nJumping = MotionState._JUMPING_FALSE;
        nHitReaction = 0;
    }

    /** Fcja pomocnicza dla UpdateMotion. Przy przejsciach miedzy crawl a staniem 
     * wykonywana jest po jakims czasie.
     */
    boolean m_bStopOnAimingAndCrawling = false;
    void MotionModeChanged()
    {
        bUnableToAct = false;
        
        //przypadek, kiedy bedac w przycelowaniu i chodzac kladziemy sie nagle
        // trzeba sie wtedy zatrzymac
        if ( m_bStopOnAimingAndCrawling         &&
             (nCurrentState == EPlayerState.AIM) && 
             (bCrawling) )
        {
            motion.Push();
            motion.StopMove();
            UpdateMotion();
            motion.Pop();
        }
        else
        {
            // jesli w trybie przycelowania zaczelismy plywac,
            // to trzeba wylaczyc przycelowanie
            if ( (nCurrentState == EPlayerState.AIM) && 
                 (bSwimming) )
            {
                StopAiming();
            }
            else
            {
                // jak wychodzmy z plywania to tez trzeba sie zatrzymac
                if ( m_bStopOnAimingAndCrawling &&
                     bWasSwimming )
                {
                    bWasSwimming = false;
                    motion.Push();
                    motion.StopMove();
                    UpdateMotion();
                    motion.Pop();
                }
                
                UpdateMotion();    
            }
            
        }
        
        //jesli klawisz przycelowania wcisniety to trzeba to obsluzyc
		if ( bNetIsOwner && AmIAiming())
        {
            ActionAimingStart();
            UpdateState();
        }

        if ( nFiringState == Weapon._FIRING_SECONDARY && 
             !GetKeyState(EGameControl.AIM))
            nFiring = Weapon._NO_FIRING;
        else
            if ( nFiringState == Weapon._FIRING_PRIMARY &&
                 !GetKeyState(EGameControl.FIRE))
                nFiring = Weapon._NO_FIRING;
    }
    
    boolean CanProcessJumpKey()
    {
        return (nEnvironment != EMoveEnv.CHMOVE_AIR)
                &&
               (motion.iSpeed >= motion.SPEED_DUCK);
    }
    
    boolean CanPlayerJump()
    {
        return ( (!(motion.nClimbing > motion._CLIMBING_FALSE))
                &&
                  (nEnvironment != EMoveEnv.CHMOVE_AIR)
                &&
                  (motion.iSpeed >= motion.SPEED_DUCK));
    }
    
    void UpdateEllipsoidAndMaxClimbAngle()
    {
        m_iSpeed = motion.iSpeed;
        SetEllipsoidAndMaxClimbAngle( motion.iSpeed );
    }
            
    void SetEllipsoidAndMaxClimbAngle( int iSpeed )
    {
        m_iSpeed = iSpeed;
        
        //Vector vPos = GetPosition();
        
        SetEllipsoid( fEllipsoidRadius   [iSpeed], 
                      fEllipsoidHeight   [iSpeed],
                      fEllipsoidPos      [iSpeed] );
        
        SetMaxClimbAngle( fMaxClimbAngle [iSpeed]);
        
        //SetPosition( vPos );
    }
    
    boolean CanTurnOnFlying()
    {
        if (m_iCanTurnOnFlying == _CANTURNONFLYING_FALSE)
            return false;
        else if(m_iCanTurnOnFlying == _CANTURNONFLYING_ALWAYS)
            return true;
        else
        {
            // badamy predkosc w x i z - jezeli skok z miejsca to moze skrecac w powietrzu
            Vector vLinVel = GetODEGWLinVel();
            vLinVel.fY = 0.f;
            return (vLinVel.Len2() < 1000.f);
        }
    }   

    /** Update predkosci robiony np. w UpdateMotion i po zmianie fSpeedMult (DrugSpeed)
     */
    public void UpdateSpeed()
    {
        //podczas skoku, nic nie ruszamy predkosci
        if ( AmIFlying() && !CanTurnOnFlying() )
        {
            SetLocalSpeed( this.vSpeed, m_bUseWalkDestSpeed );
            return;
        }
        
        if( 
            // gracz nie moze sie poruszac podczas wstawania
            ((motion.iSpeed == MotionState.SPEED_CRAWL) ^
             (oldMotion.iSpeed == MotionState.SPEED_CRAWL)))/* ||
            
            // gracz nie moze sie poruszac przy czolganiu i celowaniu
            (motion.iSpeed == MotionState.SPEED_CRAWL &&
               motion.bAiming)  
           
           )*/
        {
			vSpeed = new Vector(0, 0, 0);
            //drugi parametr oznacza, ze brane jest pod uwage przyspieszenie
            SetLocalSpeed( vSpeed, true );
        }
        else
        {
            int iSpeed = motion.iSpeed;
            
            // gdy gracz sie wspina to ma inna predkosc
            if(motion.nClimbing == motion._CLIMBING_TRUE)
                iSpeed = motion.SPEED_LADDER;
            
            //LogR("[UpdateSpeed] iSpeed="+iSpeed+"\n");
            
            float vA = ((motion.iMoveZ>0) ? aMotionVelocity[iSpeed] : aMotionVelocityBack[iSpeed])
                        * GetSpeedMult(),
                  vB = aStrafeVelocity[iSpeed] * GetSpeedMult();

            //w trakcie lotu predkosc jest modyfikowana tylko w ograniczonym zakresie            
            if (nEnvironment == EMoveEnv.CHMOVE_AIR)
            {
                vA *= 0.5;
                vB *= 0.5;
            }

            Vector vNewSpeed = new Vector();
            
            //Log("motion.bClimbing="+motion.bClimbing+" nEnvironment="+nEnvironment+"\n");
            //Log("motion.iMoveX="+motion.iMoveX+" motion.iMoveZ="+motion.iMoveZ+"\n");
            if(motion.nClimbing != motion._CLIMBING_TRUE)
                vNewSpeed.Set(vB * motion.iMoveX, 
                              0.0f,
                              vA * motion.iMoveZ );
            else
            {
                float fSpeedY = vA * motion.iMoveZ;
                Vector vEnd = GetAimDirLadderClimb();
                fSpeedY *= (vEnd.fY > 0.f) ? 1.f : -1.f;
                
                vNewSpeed.Set(vB * motion.iMoveX, 
                              fSpeedY,
                              0.0f );
            }

            //jesli idziemy po przekatnej, to predkosc jest srednia predkosci
            //  strafe i forward
            // vSpeed ma dlugosc v=sqrt(a^2+b^2),
            //   wiec vSpeed *= (0.5*(a+b))/v daje szukana srednia predkosci
            if ( (motion.iMoveX != 0)&& (motion.iMoveZ != 0) ) 
            {
                // co to wogle jest!?
                vSpeed.Mul( (float)(0.5 * (vA+vB) / Math.sqrt(vA*vA + vB*vB)) );
                
                // trzeba wyrownac dlugosc predkosci
                vNewSpeed.Normalize();
                vNewSpeed.Mul(vA);
            }
  
            SetWalkAccel(aMotionAcceleration[iSpeed]);            
            
            if (nEnvironment == EMoveEnv.CHMOVE_AIR)
            {
                vNewSpeed.Add( vSpeed );
                
                //drugi parametr oznacza, ze brane jest pod uwage przyspieszenie
				SetLocalSpeed( vNewSpeed, m_bUseWalkDestSpeed );
            }
            else
            {
                //drugi parametr oznacza, ze brane jest pod uwage przyspieszenie
				SetLocalSpeed( vNewSpeed, m_bUseWalkDestSpeed );
                
				vSpeed = vNewSpeed;
            }
            
            //Log("vNewSpeed="+vNewSpeed+"\n");
            //LogD(":"+GetLocalSpeed()+"\n");
            
        }
    }

    /** Update stanu playera na podstawie MotionState
     */
    void UpdateState()
    {
        //FreehandState
        if (sCurrentState.compareTo("FreehandState") == 0)
        {
            //LogR("[UpdateState] FreehandState\n");
            
            //przycelowanie
            if (motion.bAiming && 
                motion.iSpeed != MotionState.SPEED_SWIM  &&
                ((PlayerHUD)this).HUD.GetActiveHudMenu() == -1) 
            {
                if ( (motion.iSpeed > MotionState.SPEED_STILL) &&
                    (nEnvironment != EMoveEnv.CHMOVE_AIR) )
                {
                    if (ActiveWeapon != null) 
                    {
                        if(ActiveWeapon.nType == EWeaponType._GRENADE)
                        {
                            // przycelowanie w granacie
                            //LogR("przycelowanie w granacie\n");
                            
                            //bFiring = true;
                            motion.bAiming = false;
                        }
                        else
                        {
                            if( (ActiveWeapon.nType != EWeaponType._MINIGUN) &&
                                (ActiveWeapon.IsAimEnabled())
                                )
                            {
                                if ( IsPawnInRadius(DIST_BUTT_HIT) )
                                {
                                    iHitAnim = Anims.A_BUTT_HIT;
                                    SetState("HitState");

                                    //LogD(" motion.bAiming = false; hit\n");
                                    motion.bAiming = false;
                                }
                                else
                                {
                                    NetProfiler.Begin( NetProfiler._AIM_STATE_SET );
                                    SetState("AimState");
                                    NetProfiler.End( NetProfiler._AIM_STATE_SET );
                                }
                            }
                            else
                            {
                                //LogD(" motion.bAiming = false; 2\n");
                                motion.bAiming = false;
                            }
                        }
                    }
                    else //if (!drabina && !woda)
                    {
                        iHitAnim = Anims.A_KICK;
                        motion.bAiming = false;
                        //LogD(" motion.bAiming = false; kick\n");
                        SetState("HitState");
                    }
                }
                else
                {
                    motion.bAiming = false;
                    //LogD(" motion.bAiming = false; 4 "+(motion.iSpeed > MotionState.SPEED_STILL)+"\n");
                }
            }

            //wspinaczka
            else if ( motion.nClimbing == motion._CLIMBING_TRUE)
            {
                SetState("ClimbState");
            }

            else 
            {
                if ( motion.bReloading && 
                     (ActiveWeapon != null) &&
                     (ActiveWeapon.IsReloadEnabled() )
                    )
                {
                    SetState("ReloadState");
                }
                else
                {
                    motion.bReloading = false;
                }
            }
        }
        
        //AimState
        else if (sCurrentState.compareTo("AimState") == 0)
        {
            if (!motion.bAiming || motion.iSpeed == MotionState.SPEED_SWIM)
            {
                RestoreViewAfterAiming();
                SetState("FreehandState");
            }
            
            if ( motion.bReloading && 
                 (ActiveWeapon != null) &&
                 (ActiveWeapon.IsReloadEnabled()) &&
                 nFiringState == Weapon._NO_FIRING )
            {
                motion.bAiming = false;
                //LogD(" motion.bAiming = false; reloading\n");
                RestoreViewAfterAiming();
                SetState("ReloadState");
            }
        }
       
       
        else if (sCurrentState.compareTo("ClimbState") == 0)
        {
            if (!(motion.nClimbing > motion._CLIMBING_FALSE))
                SetState("FreehandState");
        }
   }

    boolean bMakingStepNoise = false;

    /**
     */
    void StartMakingStepNoise()
    {
        //LogR("bMakingStepNoise="+bMakingStepNoise+"\n");
        //Thread.dumpStack();
        
        if(!bMakingStepNoise)
        {
            bMakingStepNoise = true;
        
            // gdy zaczynamy 
            StepDone();
            
            if(Anims != CharacterAnims)
            {
                CharacterAnims.SetupAnims(motion, ActiveWeapon);
            }
            float fStepDuration = CharacterAnims.GetLength(CharacterAnims.A_FORWARD) / 2.0f;
            if(fStepDuration < 0.001f) fStepDuration = 0.3f;
            CallMethodEvery("StepDone",  fStepDuration);
        }
    }

    /**
     */
    void StopMakingStepNoise()
    {
        //Thread.dumpStack();
        if(bMakingStepNoise)
        {
            bMakingStepNoise = false;
            DisableCallMethod("StepDone");
        }
    }

    /** Funkcja wywolywana po kazdym kroku
     */
    void StepDone()
    {
        //LogR("StepDone -> <"+GetName()+"> vPos="+GetPosition()+" nStandingOnMaterial="+nStandingOnMaterial+"\n");
        
        boolean bInWaterSound = false;
        
        // wode odpalamy gdy jestesmy w wodzie i nie jestesmy podlaczeni do niczego
        ControlObject cParent = GetParent();
        if( bInWater &&
            !bSinkingDisabled && 
            !(cParent instanceof LiftPlatformBase) )
        {
            bInWaterSound = true;
        }
        
        if(!bInWaterSound)
        {
            if(motion.nClimbing == motion._CLIMBING_TRUE)
                PlayStepSound(motion, EMaterialType._METAL);
            else
			    PlayStepSound(motion, nStandingOnMaterial);
        }
		else
        {
			PlayStepSound(motion, EMaterialType._WATER); //woda
            
            // dodatkowo odpalamy efekt kolek na wodzie
            float fWaterLevel = GetModule().GetWaterLevel();
            Vector vWaterFXPos = GetPositionVectorVolatile();
            vWaterFXPos.fY = fWaterLevel;
            
            ExecuteFX("FXWaterStep", vWaterFXPos, Vector.Up);
        }

        // wydajemy halas o okreslonym poziomie gloscnosci
        MakeNoise(aStepVirtualNoise[motion.iSpeed], Pawn._NOISE_MOTION);
    }

    void CheckHomoErectus()
    {
        //co jakis czas sprawdz czy nie jestes pod woda 
        //albo czy nie jestes schylony
        float fCurTime = GetTime();
        if ((fCurTime - fLastProbe) > fProbeInterval)
        {
            fLastProbe = fCurTime;

            /*
            //zobacz, czy jestes pod woda
            boolean bProbe = IsUnderWater();
            //boolean bUnderWater = (motion.iSpeed == MotionState.SPEED_SWIM);
            if (bProbe != (nEnvironment == EMoveEnv.CHMOVE_WATER))
            {
                nEnvironment = bProbe ? EMoveEnv.CHMOVE_WATER : nEnvironment;
                UpdateMotion();
            }
            */
            //sprobuj sie wyprostowac
            HomoErectus();
        }
    }
        
    /** Sprawdza, czy gracz powinien byc wyprostowany (tzn. czy wg. stanu
     * klawiszy powinnismy byc wyprostowani a nie jestesmy) i jesli
     * mozemy to zrobic, to 'wstaje' gracza.
     */
    void HomoErectus()
    {
        byte iSpeed;

        //jesli jestesmy schyleni a ze stanu klawiszy wynika, ze nie
        // powinnismy byc..
        if ( (motion.iSpeed < MotionState.SPEED_WALK) &&
             ((iSpeed = GetSpeedFromKeyState()) > motion.iSpeed) )
        {
            // sprobujemy wstac na ellipsoidzie
            Vector vMove = new Vector(0, fEllipsoidHeight[iSpeed] - fEllipsoidHeight[motion.iSpeed], 0);
            vMove.fY -= 5.f;
            Vector vOldMove = new Vector(vMove);
            Vector vEllipsoid = GetEllipsoid();
            Vector vPos = GetPosition();
            SetEllipsoid(vEllipsoid.fX - 4.f, vEllipsoid.fY, vEllipsoid.fZ + 5.f);
            MoveByEllipsoidPure(vMove);
            SetEllipsoid(vEllipsoid.fX, vEllipsoid.fY, vEllipsoid.fZ);
            SetPositionWorld(vPos);
            boolean bCanErectus = (Math.abs(vMove.fY - vOldMove.fY) < 0.1f);
            
            if (!bCanErectus)
            {
                //kolizja nad glowa - nie wstajemy, ale 
                //moze mozna wstac tylko troche?
                //dla kazdej posredniej pozycji, zaczynajac od najwyzszej
                //(dla logana bedzie tylko 1 - duck)
                for (int i = iSpeed - 1; i>motion.iSpeed; i--)
                {
                    //czy sie miescimy?
                    if ( (vMove.fY + vEllipsoid.fY) >= fEllipsoidHeight[i] )
                    {
                        //mozna sie wyprostowac
                        motion.iSpeed = (byte)i;
                        UpdateMotion();
                        return;
                    }
                }
            }
            else
            {
                //mozna sie wyprostowac
                motion.iSpeed = iSpeed;
                UpdateMotion();
            }
        }
    }
    
    // parametry skoku dla GravityWalk
    public float _JUMP_STOP_MUL     = 1.0f;
    public float _JUMP_FORWARD_MUL  = 1.0f;

    // parametry skoku dla ODEGravityWalk
    public float _ODE_JUMP_STOP_MUL     = 1.25f;
    public float _ODE_JUMP_FORWARD_MUL  = 1.25f;
    
    public float fJumpAngleThreshold = 0.79f;
    
    // Skakanie
    // flaga mowiaca ze aktualnie skaczemy (lecimy)
    private boolean m_bJustJumping = false;
    // flaga mowiaca ze skok (lot) spowodowany byl klawiszem JUMP
    boolean m_bJump = false;
    
    // ustawienie tej flagi powoduje sprawdzenie czy gracz jeszcze
    // leci na handlerze OnPhysicsUpdate
    boolean m_bCheckIsJumpStarted = false;

    float _CHECK_CEILING_DISTANCE = 30.f;

    void PlayerJump()
    {
        //SetMaxFallSpeed(new Vector(0, 0, 0));
        SetMaxFallSpeed(new Vector(0, -65000, 0));
        SetFallSpeed(new Vector(0, 0, 0));

        //LogD("!\n");
        
        Vector vJumpDir = new Vector(Vector.Up); 
        // pobieramy wektor normalny w miejscu skoku
        Vector vPos = GetPosition(); vPos.fY += 10.0f;
        Vector vEnd = GetPosition(); vEnd.fY -= 10000.0f;
        
        // w fizyce ODE_GRAVITYWALK zawsze skacze do gory bo na zbyt pochylym w ogole nie skoczy
        // wiec nie sprawdzamy pochylenia
        if (GetPhysicsType() != EPhysics._ODE_GRAVITYWALK)
        {
            // badamy pochylenie terenu
            Collision cColl = TraceForCollision(vPos, vEnd, null);
            if ((cColl != null) && (cColl.vNormal.Dot(Vector.Up) < fJumpAngleThreshold))
            {
                vJumpDir = new Vector( cColl.vNormal );
                vJumpDir.Normalize();
            }
        }
        
        float fJumpForwardMul;
        float fJumpStopMul;
        if (GetPhysicsType() == EPhysics._ODE_GRAVITYWALK)
        {
            fJumpForwardMul = _ODE_JUMP_FORWARD_MUL;
            fJumpStopMul = _ODE_JUMP_STOP_MUL;
        }
        else
        {
            fJumpForwardMul = _JUMP_FORWARD_MUL;
            fJumpStopMul = _JUMP_STOP_MUL;
        }
        
        // badamy jak nisko jest sufit, coby nie skoczyc za mocno i nie uderzyc sie w glowke
        // jezeli w odleglosci _CHECK_CEILING_DISTANCE znajdziemy cos to podskakujemy nizej
        Vector vMove = new Vector(0, _CHECK_CEILING_DISTANCE, 0);
        Vector vOldMove = new Vector(vMove);
        Vector vEllipsoid = GetEllipsoid();
        Vector vOldPos = GetPosition();
        SetEllipsoid(vEllipsoid.fX - 4.f, vEllipsoid.fY, vEllipsoid.fZ + 5.f);
        MoveByEllipsoidPure(vMove);
        SetEllipsoid(vEllipsoid.fX, vEllipsoid.fY, vEllipsoid.fZ);
        SetPositionWorld(vOldPos);
        float fCeilingModifier = 1.f;
        if (Math.abs(vMove.fY - vOldMove.fY) > 0.1f)
            fCeilingModifier = vMove.fY / _CHECK_CEILING_DISTANCE;
        
        if ( motion.IsMovingLinear() )
            vJumpDir.Mul( JUMP_STRENGTH * fCeilingModifier * fJumpForwardMul );
        else
            vJumpDir.Mul( JUMP_STRENGTH * fCeilingModifier * fJumpStopMul );
        
        Jump(vJumpDir);
        
        //animacja skoku tylko w TPP
        if (nRenderMode == REN_FULL)
        {
            if ( motion.IsMovingLinear() )
                Anims.Play(Anims.A_JUMP_FORWARD);
            else
                Anims.Play(Anims.A_JUMP);        
        }
        m_bJump        = 
        m_bJustJumping = true;
        
        // wlaczamy sprawdzenie ladowania na wypadek jakby
        // gracz nie oderwal sie od ziemi
        m_bCheckIsJumpStarted = true;
    }

    /**od zwyklego skoku rozni sie tym, ze skaczemy w kierunku (od drabiny)*/
    void PlayerJumpOffLadder()
    {
//        LogD("\n");
        m_bJumpingOffLadder = true;
        
        SetMaxFallSpeed(new Vector(0, 0, 0));
        SetFallSpeed(new Vector(0, 0, 0));
        
        Ladder cLadder = CheckForLadderObject();
        if (cLadder != null)
        {
            Vector vDirToLadder = GetPosition().Sub2(cLadder.GetPosition());
            vDirToLadder.Normalize();
            Vector vJump = vDirToLadder.Mul2(750);
            Jump(vJump);
            
            //animacja skoku tylko w TPP
            if (nRenderMode == REN_FULL)
            {
                if ( motion.IsMovingLinear() )
                    Anims.Play(Anims.A_JUMP_FORWARD);
                else
                    Anims.Play(Anims.A_JUMP);        
            }
        }
        m_bJump        =
        m_bJustJumping = true;        
        
        m_bCheckIsJumpStarted = true;
    }
    
    void CheckAmIReallyFlyingAfterJump()
    {
        if(GetPhysicsEnv() == EMoveEnv.CHMOVE_GROUND)
        {
            // nie udalo sie oderwac od ziemi po skoku
            // zachowujemy sie tak jakby sie skok skonczyl
            
            // zerujemy predkosc skakania
            SetFallSpeed(new Vector(0, 0, 0));
                    
            // zeskoczylismy na ziemie, wiec robimy tupot 
            StepDone();

            // jezeli dobrze nie wyskoczylismy to nie ma zwolnienia ani tupniecia
            boolean bOldCameraBump = m_bCameraBumpOnEndOfJump;
            boolean bOldSlowDown = m_bSlowDownOnEndOfJump;
            m_bCameraBumpOnEndOfJump = false;
            m_bSlowDownOnEndOfJump = false;
            
            EndOfJump();
            
            m_bCameraBumpOnEndOfJump = bOldCameraBump;
            m_bSlowDownOnEndOfJump = bOldSlowDown;
                    
            UpdateMotion();

			// sprawdzmy czy czasem nie wskoczylismy / zeskoczylismy z pojazdu
			CheckVehicle();
            
            // jezeli fizyka ODEGravityWalk to kasuj flage odpowiedzialna za sprawdzanie czasu oderwania sie od ziemi
            if (GetPhysicsType() == EPhysics._ODE_GRAVITYWALK)
                SetODEGWStateBParam1(false);
        }
    }
    
    void OnPhysicsUpdate(float fAbsoulteTime, float fSimInterval)
    {
        if(m_bCheckIsJumpStarted && (GetPhysicsType() != EPhysics._ODE_GRAVITYWALK))
        {
           CheckAmIReallyFlyingAfterJump();
           m_bCheckIsJumpStarted = false;
        }
        
        if (motion.IsClimbing() /*&& (GetMass() == 0)*/)
            CheckClimbLeave();
        else
        {
            if(sCurrentState.equals("FreehandState"))
	            CheckClimbEnter(); 
        }
    }
    
    boolean m_bDelayedCheckIsJumpStarted = false;
    
    void OnODEPostUpdate()
    {
        if(m_bCheckIsJumpStarted)
        {
           m_bDelayedCheckIsJumpStarted = true;
           
           m_bCheckIsJumpStarted = false;
        }
        else if (m_bDelayedCheckIsJumpStarted) 
        {
            CheckAmIReallyFlyingAfterJump();
            m_bDelayedCheckIsJumpStarted = false;
        }
    }
    
///////////////////////////////////////////////////////////////////////////////
// Bron
///////////////////////////////////////////////////////////////////////////////

    Vector CalcGrenadeStartPos(Bullet grenade, byte byMotionSpeed, boolean bAlternateFire)
    {
        Vector startPos   = bAlternateFire ? aGrenadeThrowStartPosAlt[byMotionSpeed] : aGrenadeThrowStartPosNormal[byMotionSpeed];
        Vector moveAndEnd = bAlternateFire ? aGrenadeThrowEndPosAlt[byMotionSpeed] : aGrenadeThrowEndPosNormal[byMotionSpeed];
        
        startPos = PointLocalToWorld(startPos);
        moveAndEnd = PointLocalToWorld(moveAndEnd); // tu bedzie zrobiona kopia
        
        if (grenade != null && !grenade.IsStarted())
        {
            moveAndEnd.Sub(startPos); // oblicz przesuniecie

            grenade.SetPositionWorld(startPos); // poczatek przesuwania granata
            grenade.MoveByEllipsoidPure(moveAndEnd); // MoveByEllipsoid zmodyfikuje moveAndEnd
            
            moveAndEnd.Add(startPos); // przesuniecie + poczatek - nowy koniec
        }
        /*else
            CrashLog("[Player.CalcGrenadeStartPos] Error: trying to move null grenade!\n");*/
        return moveAndEnd;
    };


    /** @return punkt, z ktorego strzelamy, we wspolrzednych swiata
     */
    public Vector GetFireOrigin()
    {
        if(ActiveWeapon == null)
        {
            return GetBoneJointPos(EBones._SPINE1);
        }
        else
        {
            if(ActiveWeapon.nType == EWeaponType._GRENADE)
            {
            //    return GetBoneJointPos(EBones._R_HAND);
                return CalcGrenadeStartPos(ActiveWeapon.cBullet, motion.iSpeed, ActiveWeapon.bSecondaryMode);
            }
            else
            {
                //TOTO: teraz pozycja strzalu sie rozni miedzy FPP i TPP!
                if(nRenderMode == REN_FPP)
                {
                    //FIXIT poprawic jesli konieczne (jakas bron heavy nie strzela
                    //z lufy?)
                    /*if (ActiveWeapon.nType == EWeaponType._HEAVY &&
                        ActiveWeapon.nInvIndex != InvObject._W_HEAVY_ELECTRO )
                    {
                        // biore pozycje barella
                        Vector vBarrelPos = ((FPPHands)HandsAnims.cMesh).GetBarrelWorldPos();
                        return vBarrelPos;
                    }*/
                    
                    /*
                    // ale tak na prawde jako pozycje wystrzalu biore pozycje playera
                    Vector vFireOrigin = GetPosition();
                    
                    // zeby wszystko sie zgadzalo z wygladem fpp strzelamy z wysokosci
                    // patrzenia kamery, A CO!
                    vFireOrigin.fY += Camera.fFPPHeightDef[motion.iSpeed];
                    
                    return vFireOrigin;
                    */
                    
                    return Camera.GetPosition();
                }
                else
                {
                    Vector vPos = new Vector(GetPosition());
                    vPos.fY += Camera.fFPPHeightDef[motion.iSpeed];
                    //vPos.Add(HandsAnims.GetBarrelDummyPos());
                    vPos.fY += HandsAnims.GetBarrelDummyPos().fY;

                    //LogD("fire origin:"+vPos+"mesh:"+HandsAnims.cMesh.MeshName+"\n");
                    //GameObject.printStackTrace("");
                    // pozycja z broni fpp
                    return vPos;
                    //return ((FPPHands)HandsAnims.cMesh).GetBarrelWorldPos();
                    //return GetBoneJointPos(EBones._SPINE1);
                }
            }
        }
    }
    
    Vector GetWeaponBarrelPos()
    {
        if(nRenderMode == REN_FPP)
        {
            Vector vBarrelPos = ((FPPHands)HandsAnims.cMesh).GetBarrelWorldPos();
            return vBarrelPos;
        }
        else
        {
            return ActiveWeapon.PointWorldToLocal(ActiveWeapon.vBarrelElementPos);
        }
    }

/*
    public Vector GetAimDir()
    {
        // Kat odchylenia gracza. Jesli jest kamera, to brany z niej, inaczej 
        // z kata lokalnego
        float fAngle;

        if (Camera == null)
            fAngle = fAimAngleY;
        else
            fAngle = Camera.AimAngleCameraToWeapon();

        // v - wektor od lufy do punktu w ktory strzelamy
        Vector v	     = GetForwardVector();
        Vector vPlayerUp = new Vector(Vector.Up);
        v.Mul((float)Math.cos(fAngle));
        vPlayerUp.Mul((float)Math.sin(fAngle));
        v.Add(vPlayerUp);
        return v;
    }
*/
    public Vector GetAimDir()
    {
        // Kat odchylenia gracza. Jesli jest kamera, to brany z niej, inaczej 
        // z kata lokalnego
        float fAngle;

        if (Camera == null)
            fAngle = fAimAngleY;
        else
            fAngle = Camera.AimAngleCameraToWeapon();

        
        
        // v - wektor od lufy do punktu w ktory strzelamy
        if(bDeletedInEngine)
        {
            CrashLog("Player deleted from engine\n");
        }
        
        
        Vector v	     = GetForwardVector();
        Vector vPlayerUp = new Vector(Vector.Up);
        v.Mul((float)Math.cos(fAngle));
        vPlayerUp.Mul((float)Math.sin(fAngle));
        v.Add(vPlayerUp);
        
        
        if ( (ActiveWeapon != null) &&  (Camera != null) )
        {
            if ( nRenderMode == REN_FPP &&
                 (ActiveWeapon.nType == EWeaponType._HEAVY &&
                  ActiveWeapon.nInvIndex != InvObject._W_HEAVY_ELECTRO) 
                ||
                 ActiveWeapon.nType == EWeaponType._GRENADE )
                
            {
                // biore pozycje barella
                float fAngle2 = (float)Math.acos(Camera.GetForwardVector().Negate2().Dot(v));    
                if ((float)Math.abs(fAngle2) > 0.1f)
                {
                    return Camera.GetForwardVector().Negate2();
                }
            }
        }
        
        return v;
    }
    
    
    private Vector m_vLastFireDir = new Vector();
    /**Liczy kierunek strzalu na podstawie wektora z kamery i swojego accuracy
     */
    public Vector GetFireDir()
    {
        Vector v = GetAimDir();

        // vDev powinien byc prostopadly do v, ale to nie jest chyba 
        // az tak istotne..
        Vector vDev = new Vector( (float) ((RandomFloat(2.0f)-1f) * fCurrentAccuracy/100.f),
                                  (float) ((RandomFloat(2.0f)-1f) * fCurrentAccuracy/100.f), 
                                  (float) ((RandomFloat(2.0f)-1f) * fCurrentAccuracy/100.f) );
        v.Normalize();
        v.Add(vDev);
        v.Normalize();
        m_vLastFireDir.Set(v);
        return v;
    }

    void DeactivateLight()
    {
        DisableCallMethod("DeactivateLight");
        if (cLightWeapon != null)
        {
            cLightWeapon.EnableDynLight(false);
        }
    }
    
    private Vector m_vFXBarrelPos = new Vector();
    float fShootLightTime = 0.0f;
    void ExecuteFXBarrel(String sFXName)
    {
        switch(nRenderMode)
        {
        case REN_FPP :
            {
                DisableCallMethod("DeactivateLight");
                if (cLightWeapon != null && ActiveWeapon != null)
                {
                    cLightWeapon.EnableDynLight(true);
                    Vector vScale = cLightWeapon.GetScale();

                    cLightWeapon.SetScale(ActiveWeapon.fShootLightScale/vScale.fX, 
                                          ActiveWeapon.fShootLightScale/vScale.fY, 
                                          ActiveWeapon.fShootLightScale/vScale.fZ);
                    
                    cLightWeapon.SetColor( ActiveWeapon.vShootLightColor.fX, ActiveWeapon.vShootLightColor.fY, ActiveWeapon.vShootLightColor.fZ);
                    cLightWeapon.SetPosition(((FPPHands)HandsAnims.cMesh).GetBarrelWorldPos());
                
                    ExecuteFX( HandsAnims.cMesh, HandsAnims.GetBarrelDummyName(),
                               sFXName, new Vector(0, 0, 0));
                
                    CallMethodIn("DeactivateLight", fShootLightTime);
                }
                //ActiveWeapon.ExecuteFX(ActiveWeapon, "WeaponBeam", ActiveWeapon.vBarrel);
            }
            break;
            
        case REN_SNIPER:
            {
                // odpalenie efektu wystrzalu ze snajperki
                // gdy patrzymy przez jej zooma
            }
            break;
            
        default : 
            {
                m_vFXBarrelPos.Set(Vector.Zero);
                ExecuteFX(ActiveWeapon, "Barrel", sFXName,  m_vFXBarrelPos);
                
                if (ActiveWeapon != null)
                {
                    m_vFXBarrelPos.Set(Vector.Zero);
                    ExecuteFX(ActiveWeapon, "Barrel", sFXName, m_vFXBarrelPos);
                    
                    
                    if (ActiveWeapon != null)
                    {
                        if (m_vLastFireDir.Len2() > 0f)
                            ActiveWeapon.ExecuteFX(ActiveWeapon, "WeaponBeam", ActiveWeapon.vBarrelElementPos, 
                                                   ActiveWeapon.VectorWorldToLocal(m_vLastFireDir));
                        else
                            ActiveWeapon.ExecuteFX(ActiveWeapon, "WeaponBeam", ActiveWeapon.vBarrelElementPos);
                    }
                }

            }
        }
    }

    /** Dziala jak ExecuteFXBarrel, ale wywoluje FX'a na rzecz jakiegos
     * ControlObjecta - potrzebne do dynamicznie kontrolowanych efektow,
     * np. przy strzelaniu bronia energetyczna.
     */
    void ExecuteFXBarrel(ControlObject who, String sFXName)
    {
        switch(nRenderMode)
        {
            case REN_FPP :
            {
                who.ExecuteFX( HandsAnims.cMesh, HandsAnims.GetBarrelDummyName(),
                           sFXName, new Vector(0, 0, 0));
                ActiveWeapon.ExecuteFX(ActiveWeapon, "WeaponBeam", ActiveWeapon.vBarrelElementPos);
            }
            break;
            
        case REN_SNIPER:
            {
                // odpalenie efektu wystrzalu ze snajperki
                // gdy patrzymy przez jej zooma
            }
            break;
            
        default : 
            {
                who.ExecuteFX( ActiveWeapon, sFXName,
                           ActiveWeapon.vBarrelElementPos);
                ActiveWeapon.ExecuteFX(ActiveWeapon, "WeaponBeam", ActiveWeapon.vBarrelElementPos);
            }
        }
    }
    
    /** Wiadomosci wysylane przez bron po strzale, po nieudanym strzale itp.
     * Na ich podstawie odpalamy odpowiednie efekty - animacje, dzwieki..
     */
    void MessageWeapon(int nState)
    {
        // wystrzal
        if ((nState & Weapon.STATE_SHOT) != 0)
        {
            if ( nCameraGameMode != Camera.CMODE_TPP )
            {
                //to na wypadek, gdyby poprzedni strzal jeszcze sie nie skonczyl
                Anims.Stop( Anims.TORSO_BONE );
            
                Anims.Stop( Anims.ROOT_BONE );

                //animacja nowego strzalu - musi byc szybka - bez morphingu
                if(nFiring == Weapon._FIRING_SECONDARY) 
                    Anims.PlayNoMorph( Anims.A_WEA_FIRE2 );
                else
                    Anims.PlayNoMorph( Anims.A_WEA_FIRE );
            }
            else
            {
                //noz ma byc widoczny w tpp
                //TODO: a co z raczkami i/lub binoculars, jak bedzie mozna nimi uderzac?
                if ( (ActiveWeapon!=null) && (ActiveWeapon.nType == EWeaponType._KNIFE) )
                {
                    if(nFiring == Weapon._FIRING_SECONDARY) 
                        Anims.PlayNoMorph( Anims.A_WEA_FIRE2 );
                    else
                        Anims.PlayNoMorph( Anims.A_WEA_FIRE );
                }
            }
            
            //Vector vS = GetLocalSpeed();
            
            if(!ChromeGame.bFilms)
            {
                //
                //odrzut - przesuniecie kamery
                //
                float fEffectiveRecoil = (ActiveWeapon!=null)?ActiveWeapon.fRecoilShiftChange:0.0f;
                
                if (IsImplantActive(ImplantSystem._IMPLANT_MUSCLE_IMPROVER))
                    fEffectiveRecoil *= ImplantStrength._DAMAGE_RECOIL_MULT;
                
                //przesuniecie w pionie, losowanie od 0.5 do 1.0
                float fVShift =  (RandomFloat(0.5f) + 0.5f)   * 
                                 ((ActiveWeapon!=null)?ActiveWeapon.vRecoilShift.fY : 0.f) *
                                 fEffectiveRecoil;
                
                if (vRecoilTranslation.fY + fVShift > fMaxRecoil)
                {
                    fVShift *= -1;
                    //vRecoilTranslation.fY = fMaxRecoil;
                    //fVShift = fMaxRecoil - vRecoilTranslation.fY;
                }
                if (vRecoilTranslation.fY + fVShift < -fMaxRecoil)
                {
                    fVShift *= -1;
                    //vRecoilTranslation.fY = -fMaxRecoil;
                    //fVShift = -fMaxRecoil - vRecoilTranslation.fY;
                }
                
                
                RotateV(fVShift);

                //przesuniecie w poziomie (moze byc co najwyzej takie samo jak pionowe)
                //losowanie od 0.5 do 1.0
                float fHShift =  (RandomFloat(0.5f) + 0.5f)   * 
                                 ((ActiveWeapon!=null)?ActiveWeapon.vRecoilShift.fX : 0.f ) *
                                 fEffectiveRecoil;
                
                if (fHShift > fVShift)
                    fHShift = fVShift;
                
                //losowanie czy w lewo czy w prawo
                if (RandomFloat(1f) > 0.5f)
                    fHShift *= -1;
                
                /*if (vRecoilTranslation.fX + fHShift > fMaxRecoil)
                {
                    fHShift *= -1;
                    //vRecoilTranslation.fX = fMaxRecoil;
                    //fHShift = fMaxRecoil - vRecoilTranslation.fX;
                }
                if (vRecoilTranslation.fX + fHShift < -fMaxRecoil)
                {
                    fHShift *= -1;
                    //vRecoilTranslation.fX = -fMaxRecoil;
                    //fHShift = -fMaxRecoil - vRecoilTranslation.fX;
                }*/

                
                RotateH(fHShift);

                //kumulacja wektora odrzutu
                vRecoilTranslation.Add(new Vector(fHShift, fVShift, 0));
                
                
                // dokladamy obnizenie celnosci po strzale
                if(ActiveWeapon!=null)
                    fCurrentAccuracy += ActiveWeapon.fRecoilAccChange;
            }
            
            //peh - zmienilem na ponizsze, analogicznie do innych wystapien
            //SetLocalSpeed( vS, true );
            //drugi parametr oznacza, ze brane jest pod uwage przyspieszenie
            // to powinno byc w RoatateH
            //SetLocalSpeed( vSpeed, m_bUseWalkDestSpeed );
            
            boolean bThrowingGrenade = (ActiveWeapon != null && 
                                  ActiveWeapon.nType == EWeaponType._GRENADE);
            
            StartThrowingGrenade(bThrowingGrenade);
            
            
        }

        if ((nState & Weapon.STATE_END_OF_ROUND) != 0)
        {
            //CrashLog(ActiveWeapon + " STATE_END_OF_ROUND \n");
            
            boolean bThrowingGrenade = (ActiveWeapon != null && 
                                        ActiveWeapon.nType == EWeaponType._GRENADE);
            if (bThrowingGrenade)
            {
                //animacja rzutu granatem w tpp
                
                if ( nCameraGameMode == Camera.CMODE_TPP )
                {
                    //animacja nowego rzutu - musi byc szybka - bez morphingu
                    if(nFiring == Weapon._FIRING_SECONDARY) 
                        Anims.PlayNoMorph( Anims.A_WEA_FIRE2 );
                    else
                        Anims.PlayNoMorph( Anims.A_WEA_FIRE );
                }
            }
            StopThrowingGrenade();
            
            // wyrzucenie granatu oznacza koniec strzelania
            nFiring = Weapon._NO_FIRING; 
            UpdateState();
        }
        
        //braklo amunicji
        if ((nState & Weapon.STATE_NO_AMMO) != 0)
        {
            //CrashLog(ActiveWeapon + " STATE_NO_AMMO\n");
            //animacja nieudanego strzalu?
            
            nFiring = Weapon._NO_FIRING;
            UpdateState();
        }
        
        //wszystko w porzadku, ale chcemy zupdejtowac stan gracza (np. odwolalismy rzut
        //granatem ze wzgl. na film
        if ((nState & Weapon.STATE_READY) != 0)
        {
            if (ActiveWeapon instanceof WeaponGrenade)
            {
                if ( HandsAnims != null && HandsAnims.cMesh != null )
                {
                    ((FPPHandsGrenade)HandsAnims.cMesh).ShowGrenade();
                }
            }                
            nFiring = Weapon._NO_FIRING; 
            StopThrowingGrenade();
            UpdateState();
        }
        
    } 
    
    
    //////////////////////////////////////////////////////////////////////////
    /** TODO: !!!SG!!!
     */
    Vector m_vGrenThrowCheckStart = new Vector();//
    Vector m_vGrenThrowCheckEnd   = new Vector();//
    
    float _GRENADE_TRAJECTORY_CHECK_START_PHASE = 0.5f;
    float _GRENADE_TRAJECTORY_CHECK_END_PHASE   = 0.75f;
    
    void SetGrenadeMoveFromAnim(int nAnimID)
    {
        int internalAnimID = Anims.Anims[nAnimID];
        float firstFrame, lastFrame;
        int checkStartFrame = -1,
            checkEndFrame = -1;
        
        if (internalAnimID >= 0)
        {
            firstFrame = GetFirstFrame(internalAnimID);
            lastFrame = GetLastFrame(internalAnimID);
            checkStartFrame = (int)(firstFrame + _GRENADE_TRAJECTORY_CHECK_START_PHASE * (lastFrame - firstFrame));
            checkEndFrame   = (int)(firstFrame + _GRENADE_TRAJECTORY_CHECK_END_PHASE * (lastFrame - firstFrame));
        }
        
        if (checkStartFrame >= 0)
            SetFrame(internalAnimID, checkStartFrame, -1);
        GetElementPos(nRightHandID, m_vGrenThrowCheckStart);
        m_vGrenThrowCheckStart = PointWorldToLocal(m_vGrenThrowCheckStart);

        if (checkEndFrame >= 0)
            SetFrame(internalAnimID, checkEndFrame, -1);
        GetElementPos(nRightHandID, m_vGrenThrowCheckEnd);
        m_vGrenThrowCheckEnd = PointWorldToLocal(m_vGrenThrowCheckEnd);
    }
    
    
    void CheckGrenadeThrowPos()
    {
        
    }
    
    
    MeshObject helper1, helper2;
    
    
    
    
    
    //////////////////////////////////////////////////////////////////////////
    // Modyfikacja postrzegania gracza przez AI
    //
    
    /** Wspolczynniki latwosci zauwazenia przez przeciwnika dla roznych predkosci z MotionState
     * (STILL, SWIMM, CRAWL, DUCK, WALK, RUN)
     */
    float m_aVisibilityFactors[] = { 1.f, .95f, 0.50f, 0.75f, 1f, 1f }; 
    float m_fVisibilityRangeCloaked = 100f;
    float m_fVisibilityRangeCloakedMoving = 500f;
    float m_fVisibilityRangeUnarmed = 800f;
    
    public float GetVisibilityRangeFactor(ChromeActor cObserver)
    {
        float fFactor = m_aVisibilityFactors[motion.iSpeed];
        return fFactor;
    }
    
    public float GetVisibilityRangeThreshold(ChromeActor cObserver)
    {
        if (m_bCloaking)
        {
            if (motion.IsMovingLinear())
                return m_fVisibilityRangeCloakedMoving * ChromeGame.GetCloakingDeviceDiffLevelMult();
            else
                return m_fVisibilityRangeCloaked * ChromeGame.GetCloakingDeviceDiffLevelMult();
        }
        if (bCamouflage)
        {
            if ( (ActiveWeapon == null) || (ActiveWeapon instanceof WeaponHands) )
                return (m_fVisibilityRangeUnarmed * m_aVisibilityFactors[motion.iSpeed]);
        }
            
        return super.GetVisibilityRangeThreshold(cObserver);
    }

    /** implementacja ipar_Camouflage
     */
    public void SetCamouflage(boolean bCamouflage)
    {
        this.bCamouflage = bCamouflage;
    }
    
    /** implementacja ipar_VisibilityFactor
     */
    public void SetVisibilityFactor(int iMotionState, float fValue)
    {
        if (iMotionState >= 0 && iMotionState < m_aVisibilityFactors.length)
            m_aVisibilityFactors[iMotionState] = fValue;
    }
    
    
    /** Wspolczynniki latwosci zauwazenia przez przeciwnika dla roznych predkosci z MotionState
     * (STILL, SWIMM, CRAWL, DUCK, WALK, RUN)
     */
    float m_aShootVisibilityFactors[] = { 1.f, .5f, 0f, 0.5f, 1f, 1f }; 
    
    /** Wspolczynniki istotnosci (wag) poszczegolnych elementow wplywajacych na latwosc trafienia */
    float m_fShootVisibilityMotionStateImportance = 0.5f;
    float m_fShootVisibilityVelocityImportance = 0.5f;
    float m_fShootVisibilityJumpImportance = 0.5f;
    
    private Vector m_vShootVisObsDir = new Vector();
    private Vector m_vShootVisPrep = new Vector();
    private Vector m_vShootVisSpeed = new Vector();
    
    /** Zwraca latwosc trafienia gracza przez podanego obserwatora/
     *  @return wartosc 0-1 oznaczajaca latwosc trafienia gracza
     */
    public float GetShootVisibilityFactor(ChromeActor cObserver)
    {
        // znajdz wspolczynnik widocznosci zalezny od predkosci poruszania sie
        GetSpeed(m_vShootVisSpeed);
        float fSpeedFactor = 0;
        float fSpeed = m_vShootVisSpeed.Len();
        /** Wyliczenie dlugosci skladowej prostopadlej predkosci do kierunku 
         *  cObserver -> this
         */
        if (fSpeed > 0.1f)
        {
            /** Oblicz kierunek prostopadly do kierunku obserwatora
             */
            GetPosition(m_vShootVisObsDir);
            m_vShootVisObsDir.Sub(cObserver.GetPositionVectorVolatile());
            m_vShootVisObsDir.Normalize();

            m_vShootVisObsDir.CrossStatic(Vector.Up, m_vShootVisPrep);
            m_vShootVisPrep.Normalize();
            
            m_vShootVisSpeed.Mul(1.f / fSpeed);

            float fPrepSpeedLen = Math.abs(m_vShootVisSpeed.Dot(m_vShootVisPrep) * fSpeed);
            fSpeedFactor = 1 - fPrepSpeedLen / aMotionVelocity[MotionState.SPEED_RUN];
            if (fSpeedFactor < 0)
                fSpeedFactor = 0;
            else if (fSpeedFactor > 1)
                fSpeedFactor = 1;
        }
        else
            fSpeedFactor = 1.f;

        // obliczenie sumarycznej widocznosci
        float fRet = m_fShootVisibilityMotionStateImportance * m_aShootVisibilityFactors[motion.iSpeed] +
                     m_fShootVisibilityVelocityImportance * fSpeedFactor + 
                     (AmIFlying() ? 0 : m_fShootVisibilityJumpImportance);

        // normalizacja wyniku
        fRet /= m_fShootVisibilityMotionStateImportance +
                m_fShootVisibilityVelocityImportance +
                m_fShootVisibilityJumpImportance;
        
        // obciecie do dozwolonego zakresu
        if (fRet < 0)
            fRet = 0;
        else if (fRet > 1)
            fRet = 1;
        
        return fRet;
    }

    
    /** Mnozniki prawdopodobienstwa trafienia gracza przez ai zalezne od MotionState's
     * (STILL, SWIMM, CRAWL, DUCK, WALK, RUN)
     */
    float m_aHitChanceMults[] = { 1.f, .5f, 0.33f, 0.85f, 1f, 1f }; 
    
    public float GetHitChanceMult(ChromeActor cShooter)
    {
        return m_aHitChanceMults[motion.iSpeed];
    }
    
    
    /** metoda zwraca informacje, czy player nie jest
     * czasami w trakcje rzucania granatem
     * Sluzy to nam do blokowania animacji podczas gdy granat jest "naciagniety"
     * Niestety jest to rozwiazanie tymczasowe, bowiem w TPP nie zdaje
     * ogzaminu (gracz jezdzi na lyzwach)
     * TODO: znalezc rozwiazanie dla trybu TPP
     */
    protected boolean m_bIsThrowingGrenade = false;
    
    void StartThrowingGrenade( boolean bStart )
    {
        m_bIsThrowingGrenade = bStart;
        
        if ( m_bIsThrowingGrenade )
        {
            DisableCallMethod("CheckStopThrowingGrenade");
            CallMethodIn("CheckStopThrowingGrenade",2.0f);
        }
    }
    
    void CheckStopThrowingGrenade()
    {
        if ( nFiringState != Weapon._NO_FIRING )
            CallMethodIn("CheckStopThrowingGrenade",1.0f);
        else
            StopThrowingGrenade();
    }
    
    void StopThrowingGrenade()
    {
        m_bIsThrowingGrenade = false;
    }
    
        
    
    
    /**
     */
    void ChangeWeapon(Weapon weapon)
    {
        if (sCurrentState.compareTo("AimState") == 0)
        {
            ActionAimingStop();
            RestoreViewAfterAiming();
            SetState("FreehandState");
        }
        
        LogD("\n");
        super.ChangeWeapon(weapon);
        
        WeaponToUse = weapon;
        SetState("ChangeWeaponState");
    }

    /**
     */
    void UseWeapon(Weapon weapon)
    {
        if (sCurrentState.compareTo("AimState") == 0)
        {
            RestoreViewAfterAiming();
            SetState("FreehandState");
        }
        
        super.UseWeapon( weapon );
        //SetupAnims();

        // chowamy poprzednia bron
        if (HandsAnims != null && HandsAnims.cMesh != null)
        {
            HandsAnims.cMesh.EnableRendering(false);
            HandsAnims.cMesh.SetFlag(EFlags._NO_ANIMATION);
            //do pewnosci robimy unlock, bo jak ktos zmieni bron
            //podczas Lock (postrzal) to by sie animacje nie odblokowaly
            HandsAnims.Unlock();
        }

        Class cClass = (ActiveWeapon != null) ? 
                       ActiveWeapon.getClass() : 
                       GetWeaponClassIfActiveWeaponNull();
        if ( cClass == null )
        {
            LogD(" klasa broni == null\n");
            return;
        }
        // przelaczamy odpowiedni model broni
        int nWeaponHandIndex = FindWeaponByName( cClass );
        if (nWeaponHandIndex==-1)
            CrashLog("Nie ma modelu FPP dla broni <"+cClass.getName()+">!!!\n");
        else
            HandsAnims = aWeaponHands[ nWeaponHandIndex ];
        
        // gdy aktualnie mamy podlaczona bron do fpp to trzeba ja podmienic
        if ( nRenderMode != REN_FULL )
        {
            Anims = HandsAnims;
            
            if ( HandsAnims != null && HandsAnims.cMesh != null )
            {
                ((FPPHands)HandsAnims.cMesh).SetCloaking(m_nCloakingDevicesOn > 0);
                ((FPPHands)HandsAnims.cMesh).SetTermovision(IsImplantActive(ImplantSystem._IMPLANT_TERMOVISION_SYSTEM));
                    
                HandsAnims.cMesh.EnableRendering(true);
                HandsAnims.cMesh.ClearFlag(EFlags._NO_ANIMATION);
                    
                // pokazujemy granata na wypadek wylaczenia go wczesniej
                if(HandsAnims.cMesh instanceof FPPHandsGrenade)
                    ((FPPHandsGrenade)HandsAnims.cMesh).ShowGrenade();
            
                //HandsAnims.cMesh.SetAnimMorphTime(0);
                //HandsAnims.SetLastChangeWeaponFrame();
            }
        }
        
        
        //nie renderuj guna jesli w trybie FPP
        if (ActiveWeapon != null)
            ActiveWeapon.EnableRendering(nRenderMode == REN_FULL);
    }
    
    /**
     * Jakie raczki (jakies broni) pokazac gdy ActiveWeapon == null ?
     */
    Class GetWeaponClassIfActiveWeaponNull()
    {
        return GetInbornWeaponClass();
    }

    /**Wyrzucanie broni.
     */
    void WeaponThrowAway()
    {
        Weapon cExcludeWeapon = ActiveWeapon;
        
        super.WeaponThrowAway();

        //teraz po wyrzuceniu broni dostaniemy do reki najlepsza.
        ChangeWeapon( GetBestWeapon( cExcludeWeapon ) );
        
        //SetState("FreehandState");                    
    }

    void WeaponGrenadeThrown()
    {
        // ukrywamy meshelement granatu
        if(HandsAnims.cMesh instanceof FPPHandsGrenade && !((ChromeModule)GetModule()).bMovieView)
            ((FPPHandsGrenade)HandsAnims.cMesh).HideGrenade();
    }
    
    void WeaponAnnihilate(Weapon cToAnnihilate)
    {
        if (cToAnnihilate != null)
        {
            //wyciagamy z inventory stara bron
            cInventory.RemoveInvObject( cToAnnihilate );

            if(cToAnnihilate == ActiveWeapon)
            {
                //szukamy takich samych granatow
                Weapon newWpn = (Weapon)(cInventory.GetSpecificInvObject( ActiveWeapon.nInvIndex ));
                
                //szukamy innych granatow
                if (newWpn == null)
                    newWpn = GetNextWeapon( ActiveWeapon.nType );
                
                if (newWpn == null)
                { 
                    //szukamy poprzedniej broni
                    if(PreviousActiveWeapon != null && 
                        cInventory.GetIndex(PreviousActiveWeapon) != -1)
                    {
                        newWpn = PreviousActiveWeapon;
                    }
                    else
                    {
                        newWpn = GetBestWeapon();
                    }
                }

                // przelaczamy bron
                ChangeWeapon( newWpn );
                
                //PreviousActiveWeapon = null;
            }
            
            // niszczymy stara bron (wyrzucony noz lub granat)
            cToAnnihilate.DeactivateOnModuleAlways();
            // opozniamy kasowanie
            cToAnnihilate.CallMethodIn("delete", 3.f);
        }

        UpdateMotion();
    }
///////////////////////////////////////////////////////////////////////////////
// Operacje wykonywane na kazdej ramce
///////////////////////////////////////////////////////////////////////////////

    public void OnFrame()
    {
        SuperOnFrame();
        ProcessOnFrame();
    }
    
    public void SuperOnFrame()
    {
        if(bNetIsOwner) CheckMotionKeys();
        
        super.OnFrame();
    }

    float fLastZoom = -1.f;

    boolean m_bFireChanged = false;
    
    float fRecoilReturnSpeed = 7f;
    
    Vector vCurRecoilTranslation = new Vector();
    
    void ProcessOnFrame()
    {
        if (m_nOnFrameDelay != 0)
        {
            try{
            Thread.sleep(m_nOnFrameDelay);
            }
            catch(InterruptedException e){LogR("INTERRUPTED");}
        }
        
		super.ProcessOnFrame();
	
        CheckHomoErectus();
        
        //powracanie z odrzutu recoila
        if(!ChromeGame.bFilms)
        {
            if ( (nFiring == Weapon._NO_FIRING) &&
                 (vRecoilTranslation.Len() > 0.1e-9f) )
            {
                //LogD("recoil translation > 0: "+vRecoilTranslation+"\n");
                //vRecoilTranslation.Mul(0.4f);
                float fTimeDelta = GetTime() - fAccuracyPrevTime;
                
                vCurRecoilTranslation.Set(vRecoilTranslation);
                vCurRecoilTranslation.Mul(fRecoilReturnSpeed*fTimeDelta);
                RotateH(-vCurRecoilTranslation.fX);
                RotateV(-vCurRecoilTranslation.fY);
                vRecoilTranslation.Sub(vCurRecoilTranslation);
                //vRecoilTranslation.fX = vRecoilTranslation.fY = 0;                
            }
        }

        //skrec cialo - obrot za kierunkiem patrzenia kamery
        BodyDeformAimAtH();
        BodyDeformAimAtV();

        // update zooma jesli trzeba
        if (cZoomer != null && Camera!=null)
        {
            float fZoom = cZoomer.GetZoom();
            if (fLastZoom != fZoom)
            {
                Camera.SetZoom(fZoom);
                fLastZoom = fZoom;
            }
        }
        
        CheckIfFireChanged();
        
        FrameFinished();
        
        // obliczamy celnosc broni
        UpdateAccuracy();
        
        /*  if ((bNetIsOwner && !(Role == ERole._AUTHORITY))
            || (!bNetIsOwner && (Role == ERole._AUTHORITY)))
            Tools.ShowInfoTop(GetFallSpeed().toString(), GetModule());*/
        
    } 
    
    void CheckIfFireChanged()
    {
        //sprawdzenie zmiany stanu strzelania
        
        //jak jest zablokowany to nie strzela
        //TODO: zrobic tak, zeby po odblokowaniu (przy wcisnietym klawiszu)
        //gracz automatycznie zaczal strzelac
        if ( IsLockedByConnectionStatusManager() )
            nFiring = Weapon._NO_FIRING;
                
        if (nFiringState != nFiring)
        {
            //ograniczyc mozliwosci zmian
            if ( nFiringState != Weapon._NO_FIRING && 
                 nFiring      != Weapon._NO_FIRING )
            {
                //jezeli juz wczesniej strzelalismy
                //i nadal strzelamy czyli zmienil sie
                //stan ktory nas nie interesuje
                nFiring = nFiringState;
                return;
            }
            
            m_bFireChanged = true;
            if (nFiring != Weapon._NO_FIRING)
            {
                //zaczynamy strzelac tylko z okreslonych stanow
                if ( (sCurrentState.compareTo("FreehandState") == 0) ||
                     (sCurrentState.compareTo("AimState") == 0) ||
                     (sCurrentState.compareTo("ClimbState") == 0) )
                {
                    boolean bDuringGrenadeThrow = false;
                    
                    if(ActiveWeapon != null &&
                       ActiveWeapon instanceof WeaponGrenade &&
                       m_bIsThrowingGrenade)
                        bDuringGrenadeThrow = true;
                    
                    if (ActiveWeapon != null        &&
                        ActiveWeapon.IsFireEnabled() &&
                        !bDuringGrenadeThrow)
                    {
                        if ( ActiveWeapon.IsReloadRequired() && 
                             m_bAutoReload                   && 
                             bNetIsOwner )
                        {
                            nFiring = Weapon._NO_FIRING;
                            ActionReloadingStart();
                            UpdateState();
                        }
                        else
                        {
                            //zaczynamy strzelac
                            nFiringState       = nFiring;
                            boolean bSecondary = ActiveWeapon.CanSecondaryFire() &&
                                                (nFiring == Weapon._FIRING_SECONDARY);

                            vRecoilTranslation.fX = vRecoilTranslation.fY = 0;
                            if (((ActiveWeapon.m_nFireMode & Weapon._FIREMODE_SINGLE) 
                                == Weapon._FIREMODE_SINGLE) &&
                                !m_bExecutingTrigger)
                            {
                                ActiveWeapon.StartFire( Weapon.MODE_SINGLE, bSecondary );
                                //wylaczenie strzelanie z malym opoznieniem
                                //zeby strzelanie zostalo "zauwazone" na ramce
                                CallMethodIn( METHOD_StopFire, 0.0f );
                            }
                            else
                            if (((ActiveWeapon.m_nFireMode & Weapon._FIREMODE_BURST) 
                                == Weapon._FIREMODE_BURST) &&
                                !m_bExecutingTrigger)
                            {
                                ActiveWeapon.StartFire( Weapon.MODE_AUTO, bSecondary );
                            }
                        }
                    }
                    else
                    {
                        nFiring = Weapon._NO_FIRING;
                        //iHitAnim = Anims.A_PUNCH;
                        //SetState("HitState");
                    }
                }
            }
            else
            {
                //konczymy strzelac
                nFiringState = Weapon._NO_FIRING;
                if ( ActiveWeapon != null )
                    ActiveWeapon.StopFire();
            }
        }
        else
        {
            // zabezpieczenie przed zgubieniem broni podczas strzelania 
            if (nFiringState == Weapon._NO_FIRING && ActiveWeapon == null)
                nFiringState = Weapon._NO_FIRING;
        }
    }
    
    void StopFire()
    {
        nFiring = Weapon._NO_FIRING;
    }

    // jak musi byc gleboko aby gostek
    // zaczal plywac (glebiej niz)
    static float _MIN_DEEP_TO_START_SWIMMING = 170.0f;
    // nie przestawal plywac
    static float _MIN_DEEP_TO_KEEP_SWIMMING  = 140.0f;
    
    // zaczal sie topic (glebiej niz)
    final static float _MIN_DEEP_TO_START_SINKING  = 500.0f;
    
    // ile cm pod poziomem wody ma byc w stanie plywania
    static float _DEEP_IN_SWIMMING = 15.0f;
    
    // ile cm pod poziomem wody ma byc w stanie plywania
    static float _DEEP_IN_SINKING  = 25.0f;
    

    
    
    void CheckIfSwimming()
    {
        Vector vPos = GetPositionVectorVolatile();
		float fWaterLevel = GetModule().GetWaterLevel();
        float fWaterBottom = fWaterLevel - _MIN_DEEP_TO_START_SWIMMING - 20.0f;
        float fTerrainLevel = TerrainHeight( vPos.fX, vPos.fZ );

		bInWater    = (fWaterLevel > vPos.fY) && (fWaterBottom < vPos.fY);
        
    }
        
    /** umieszcza gostka na odpowiednim poziomie wody
     */
    void SetOnWater()
    {
        // i ustawiamy go na powierzchni
        Vector vPos = GetPosition();
        
        float fWaterLevel = GetModule().GetWaterLevel();
        
        if ( bSinking ) 
            vPos.fY = fWaterLevel - _DEEP_IN_SINKING;
        else
            vPos.fY = fWaterLevel - _DEEP_IN_SWIMMING;
        
        float fTerrainLevel = TerrainHeight( vPos.fX, vPos.fZ );
        if (vPos.fY < fTerrainLevel)
            vPos.fY = fTerrainLevel;
                
        SetPosition( vPos );        
    }
    
    /** Procka dostosowujaca fizyke do aktualnych potrzeb,
     * przelaczajaca playera pomiedzy plywaniem i chodzeniem
     */
    void SwitchPhysiscBetweenSwimming()
    {
        if ( bSwimming )
        {
            // zmieniamy mu fizyke, zeby plywal po powierzchni
            SetPhysicsType( EPhysics._FLY ); 
            SetMass( 0.0f );
                
            SetOnWater();
        }
        else
        {
            // przywracamy standardowa fizyka
            SetPhysicsType( nGravityPhysics ); 
            SetMass( fMass );
        }
        
        LogR("Swimming Mode Changed: "+bSwimming+"\n");
    }
    
    void SetPhysicsODE()
    {
        nGravityPhysics = EPhysics._ODE_GRAVITYWALK;
        SwitchPhysiscBetweenSwimming();
    }
    
    void SetPhysicsNormal()
    {
        nGravityPhysics = EPhysics._GRAVITYWALK;
        SwitchPhysiscBetweenSwimming();
    }
        
    
///////////////////////////////////////////////////////////////////////////////
// STANY GRACZA
///////////////////////////////////////////////////////////////////////////////
    
///////////////////////////////////////////////////////////////////////////////
// FREEHAND STATE
///////////////////////////////////////////////////////////////////////////////

    boolean IsPawnInRadius( float fRadius )
    { 
        //return ( GetObjectsInRadiusFromClass( fRadius, "Pawn" ).length != 0 );
        return false;
    }
	
    float m_fClimbLeaveTime = 0;
    float m_fClimbEnterDelay = 0.5f;
    
	void CheckClimbEnter()
	{
        //TODO uwzglednic mozliwosc ponownego wskoczenia na drabine w locie
        if (m_bJumpingOffLadder)
            return;
        
        if ((GetTimeForLadder() - m_fClimbEnterDelay < m_fClimbLeaveTime) 
            && 
            (motion.iMoveZ >= 0))
            return;
        
        int nCheckForLadder = CheckForLadder(true);
        
        //LogR("Enter nCheckForLadder="+_CFL[nCheckForLadder]+"\n");
        
        if ( (motion.iSpeed >= MotionState.SPEED_WALK) &&
             /*(bCheckForLadder || bCheckForLadderExit) && */
             (nCheckForLadder >= _CHECK_FOR_LADDER_TRUE))
        {
            // gracz klei sie do drabiny wiec kleimy go w ziemie
            if(nEnvironment != EMoveEnv.CHMOVE_GROUND)
               OnChangeMovement(EMoveEnv.CHMOVE_GROUND);

            //Log("[CheckClimbEnter] wchodzimy do wspinania sie\n");
            motion.nClimbing = motion._CLIMBING_TRUE;
            
            // powiekszamy trace'a
            fStepCheckTraceLen = MAX_STEP_CHECK_TRACE_LEN + fLadderHeight;
            
            //ze wzgledu na siec 
            SetMass(0);
            
            // LogR("Wejscie do stanu Climb w CheckClimbEnter\n");
            UpdateState();         
        }
        else
        {
            //ze wzgledu na siec 
            SetMass(fMass);
            // LogR("SetMass(" + fMass + ") w CheckClimbEnter\n");
        }
	}
    
    float fJumpFwd = 100;
    float fJumpUp = 100;
    
    int nPrevCheckForLadder = -1;
    void CheckClimbLeave()
	{
        int nCheckForLadder = CheckForLadder(false);

        //LogR("Leave nCheckForLadder="+_CFL[nCheckForLadder]+"\n");

        if(nPrevCheckForLadder == _CHECK_FOR_LADDER_LEAVING &&
           nCheckForLadder == _CHECK_FOR_LADDER_TRUE)
        {
            //LogR("reseting speeds\n");
            SetODEGWLinVel(Vector.Zero);
            SetODEGWForce(Vector.Zero);
            SetSpeed(Vector.Zero);
        }
        
	    //sprawdzamy, czy mamy jeszcze drabine pod nogami
	    if (nCheckForLadder == _CHECK_FOR_LADDER_LEAVING)
	    {
            //LogR("_CHECK_FOR_LADDER_LEAVING\n");
            //schodzimy z drabiny na szczycie
	        if (motion.iMoveZ != 0)
            {
                //LogR("_CHECK_FOR_LADDER_LEAVING GetPosition()="+GetPosition()+" GetAimDirLadderClimb()="+GetAimDirLadderClimb()+" \n");
                
                //LogR("motion.nClimbing = motion._CLIMBING_LEAVING;\n");
                //nie wspinamy sie ale nie zmieniamy stanu
                motion.nClimbing = motion._CLIMBING_LEAVING;

                fStepCheckTraceLen = MAX_STEP_CHECK_TRACE_LEN;

                UpdateMotion();
            }
	    }
        else
        {
            if (nCheckForLadder == _CHECK_FOR_LADDER_FALSE)
            {
                //LogR("_CHECK_FOR_LADDER_FALSE GetPosition()="+GetPosition()+" GetAimDirLadderClimb()="+GetAimDirLadderClimb()+" \n");
                ClimbLeave();
            }
            else
            {
                motion.nClimbing = motion._CLIMBING_TRUE;
                //LogR("_CHECK_FOR_LADDER_TRUE GetPosition()="+GetPosition()+" GetAimDirLadderClimb()="+GetAimDirLadderClimb()+" \n");
            }
        }
        
        nPrevCheckForLadder = nCheckForLadder;
	}
    
    public class FreehandState extends PlayerState
    {
        int nFrame = 0;

        public void OnEnter()
        {
			nCurrentState = EPlayerState.FREEHAND;
            super.OnEnter();
            // czy to nie czasem powrot z ReloadState?
            if (sLastOtherState.compareTo("ReloadState") == 0)
            {
                //jesli klawisz przycelowania wcisniety to trzeba to obsluzyc
				if ( bNetIsOwner && AmIAiming())
                {
                    ActionAimingStart();
                    UpdateState();
                }
            }

            // jezeli player wykorzystuje ODEGravityWalk to wlacz mu kolizje i symulacje
   			if (GetPhysicsType() == EPhysics._ODE_GRAVITYWALK)
                ODE_EnableODEGWAfterInputImpulse();
        }

        void OnFrame()
        {
            SuperOnFrame();
            
            //BodyDeformAimAtH();

            //
			//CheckClimbEnter();
            
            ProcessOnFrame();
        }
		

        void OnPostUpdate()
        {
            nFrame++;
            
            PlaceGun();

            if (nFrame % 3 == 0)
                CheckTriggers();
        }

        void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
        {
            ProcessZoomKeys(nKeyCode, bKeyState, nKeyAscii);

            if (nKeyCode == EKey._LCONTROL && !CanPressLeftCtrl())
                return;
            
            if (ProcessMotionKeys(nKeyCode, bKeyState, nKeyAscii))
            {
                if (!bUnableToAct)
                    UpdateMotion();
                return;
            }

            if (ProcessStateKeys(nKeyCode, bKeyState, nKeyAscii))
            {
                if (!bUnableToAct)  
                    UpdateMotion();
                return;
            }

            if (bUnableToAct || IsLeaning()) return;

            if(ProcessAimToggle(nKeyCode, bKeyState, nKeyAscii)) return;
            
            if(ProcessWeaponChange(nKeyCode, bKeyState, nKeyAscii)) return;
            
            //jesli nie mamy okularkow
            if (bKeyState && (cBinoculars == null) && 
                !((ChromeModule)GetModule()).bInFadeState &&
                !bInMovie)
            {
                if (nKeyCode==EGameControl.FIRE && CanFire())
                {
                    //CrashLog("Faja !\n");
                    nFiring |= Weapon._FIRING_PRIMARY;
                }

                else if (nKeyCode==EGameControl.AIM)
                {
                    if ( ActiveWeapon != null &&
                         ActiveWeapon.CanSecondaryFire())
                    {
                        if (CanFire() && nFiring == Weapon._NO_FIRING)
                            nFiring |= Weapon._FIRING_SECONDARY;
                    }
                    else
                    {
                        ActionAimingStart();
                        UpdateState();
                    }
                }                
                
                else if (nKeyCode == EGameControl.JUMP)
                {
                    //Uwaga, wczesniej bylo to w if'ie (!bFiringState)
                    // przenioslem to tu, bo nie dalo sie skakac
                    // w czasie rzucania granatem, ciekawe czy sie nie pop....li ;-)
                    
                    //skakac mozna tylko z ziemi
                    if ( CanProcessJumpKey() )
                    {
                        motion.nJumping = MotionState._JUMPING_TRUE;
                        UpdateMotion();
                    }
                }
                else if (nFiringState == Weapon._NO_FIRING)
                {
                    if (nKeyCode==EGameControl.ACTION) 
                    {
                        // wolamy z opoznieniemy, zeby nam sie obsluga klawiszy nie klocila
                        m_bExecutingTrigger = true;
                        CallMethodIn("ExecuteTrigger", 0.0f);

                        //Log("[Player.FreehandState]: TriggerExecuted\n");
                    }

                    else if (nKeyCode==EGameControl.RELOAD)
                    {
                        if (ActiveWeapon != null)
                        {
                            if (ActiveWeapon.nAmmo != ActiveWeapon.nCapacity)
                            {
                                ActionReloadingStart();
                                UpdateState();
                            }
                        }                    
                    }
                }

            }
            else //bKeyState
            {
                if (nKeyCode==EGameControl.FIRE)
                {
                    //wylaczamy strzelanie tylko jak strzelalismy w trybie zwyklym
                    if ( nFiringState == Weapon._FIRING_PRIMARY )
                        nFiring = Weapon._NO_FIRING;
                }                
                else if (nKeyCode==EGameControl.AIM)
                {
                    if ( nFiringState == Weapon._FIRING_SECONDARY )
                        nFiring = Weapon._NO_FIRING;
                    else
                    {
                        ActionAimingStop();
                        UpdateState();
                    }
                }                
            }
        }

        public void OnInputMouseButton(int nButton, int nState)
        {
            ProcessMouseButtons(nButton, nState);
        }
  
    }

///////////////////////////////////////////////////////////////////////////////
// HIT STATE    
///////////////////////////////////////////////////////////////////////////////
    public int iHitAnim;
    
    /**Zatrzymanie sie i uderzenie. Potem powrot do poprzedniego stanu ruchu.
     */
    public class HitState extends PlayerState
    {
        boolean bStop = false;

        public void OnEnter()
        {
			nCurrentState = EPlayerState.HIT ;
            super.OnEnter();

            //zachowaj obecny stan ruchu
            motion.Push();

            //zatrzymaj sie
            motion.Stop();
            UpdateMotion();

            //i walnij
            if (iHitAnim == Anims.A_BUTT_HIT) 
                Anims.Stop( Anims.TORSO_BONE );

            Anims.Play( iHitAnim );
            CallMethodIn("HitEnd", Anims.GetLength(iHitAnim));
        }

        void HitEnd()
        {
            LogLine("hitend");
            //cios !
            //MakeDamage()

            //jesli koniec ciosow - player puscil klawisz
            if (bStop)
            {
                //odzyskaj informacje o ruchu
                motion.Pop();

                if ( ((iHitAnim != Anims.A_PUNCH) &&
                      (iHitAnim != Anims.A_KICK)) || motion.IsMoving() )
                {
                    LogLine("updating motion");
                    UpdateMotion();
                }

                SetState("FreehandState");
            }
            else //powtorka
            {
                Anims.Play( iHitAnim );
                CallMethodIn("HitEnd", Anims.GetLength(iHitAnim));                    
            }
        }

        void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
        {
            if (ProcessStateKeys(nKeyCode, bKeyState, nKeyAscii))
            {
                return;
            }

            if (ProcessMotionKeys(nKeyCode, bKeyState, nKeyAscii))
            {
                LogLine("motion keys processed");
                //jesli ruszyl
/*                if (motion.IsMoving())
                {
                    UpdateMotion();
                    SetState("FreehandState");
                }
                else
                    motion.Stop();
*/
                return;
            }

            if (!bKeyState)
            {
                if ( 
                     ( (nKeyCode == EGameControl.FIRE) &&
                       (iHitAnim == Anims.A_PUNCH) )     ||

                     ( (nKeyCode == EGameControl.AIM) &&
                       ((iHitAnim == Anims.A_KICK) || (iHitAnim == Anims.A_BUTT_HIT)) )
                   )
                {
                    bStop = true;
                    motion.bAiming = false;
                    nFiring = Weapon._NO_FIRING;
                    //LogD(" motion.bAiming = false; hitstate\n");
                }
            }
        }

        public void OnInputMouseButton(int nButton, int nState)
        {
            if (nState == 0)
            {
                ProcessMouseButtons(nButton, nState);
            }
        }        
		
		//*********************************************************
		//					SaveGame
		//*********************************************************
	
		public void SGLoad(FileChunk cParentFC)
		{	
			FileChunk.Log("[Player$HitState] : SGLoad\n");
			
			FileChunk cFC = GameObject.LoadChunk(cParentFC);   
			
		    if (cFC.GetID() == ESGChunksChrome._CHK_PLAYER_HIT_STATE)
		    {	
				super.SGLoad(cFC);
				
				bStop = cFC.LoadBool();
		    }
			
			cFC.delete();
		}
    
		public void SGSave(FileChunk cFCParent)
		{
			FileChunk.Log("[Player$HitState] : SGSave\n");
			
		    FileChunk cFC = NewChunk(ESGChunksChrome._CHK_PLAYER_HIT_STATE, cFCParent);
			
			super.SGSave(cFC);
			
			cFC.SaveBool(bStop);
		        
		    cFC.delete();
		}	    	    	
	
		public void SGUpdate()
		{
			FileChunk.Log("[Player$HitState] : SGUpdate\n");
			OnEnter();
            
            if (m_bPawnInBuilding)
                ClearCollFlags(ECollFlags.OBJCOL_FLAG_TESTTERRAINTYPE);
            else
                ClearCollFlags(ECollFlags.OBJCOL_FLAG_TESTTERRAINTYPE);
		}
    }


///////////////////////////////////////////////////////////////////////////////
// AIM STATE
///////////////////////////////////////////////////////////////////////////////

    public class AimState extends PlayerState
    {
        boolean bReady = false;
        byte nFired = Weapon._NO_FIRING;

        int nFrame = 0;

        public void OnEnter()
        {
			nCurrentState = EPlayerState.AIM ;
            super.OnEnter();
            
            // czy to nie czasem powrot z ReloadState?
            if (sLastOtherState.compareTo("ReloadState") == 0)
            {
                //jesli juz klawisz przycelowania zwolniony, to nic tu po nas
                if ( bNetIsOwner && !AmIAiming())
                {
                    ActionAimingStop();
                    return;
                }
                // wlaczamy flage przycelowania
                motion.bAiming = true;
            }
            
            // wlaczamy zooma dopiero jak skonczy sie animacja podnoszenia guna
            DisableCallMethod( METHOD_StartAiming );
            CallMethodIn( METHOD_StartAiming, Anims.fAnimMorphTime );

            //jesli sie czolgamy, to zatrzymujemy  sie w miejscu po
            // przycelowaniu
            if (m_bStopOnAimingAndCrawling &&
                motion.iSpeed <= motion.SPEED_CRAWL)
            {
                motion.Push();
                motion.StopMove();
                UpdateMotion();
                motion.Pop();
            }
            else
            {
              UpdateMotion();
            }
            
            
        }

        void StartAiming()
        {
            DisableCallMethod( METHOD_StartAiming );
            
            InitViewForAiming();
			
            Aimed();
        }
        
        void Aimed()
        {
            bReady = true;
            
            if (nFired != Weapon._NO_FIRING)
            {
                nFiring = nFired;
                UpdateState();                
            }
        }
        
        void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
        {
            ProcessZoomKeys(nKeyCode, bKeyState, nKeyAscii);

            if (ProcessMotionKeys(nKeyCode, bKeyState, nKeyAscii))
            {
                if (motion.iSpeed >= MotionState.SPEED_CRAWL)
                    UpdateMotion();
                return;
            }

            if (ProcessStateKeys(nKeyCode, bKeyState, nKeyAscii))
            {
                if (!bUnableToAct)
                {
                    //jesli przeszlismy do czolgania, to zatrzymujemy  sie w miejscu
                    if (m_bStopOnAimingAndCrawling &&
                        bCrawling)
                    {
                        LogD("we have to stop!\n");
                        motion.Push();
                        motion.StopMove();
                        UpdateMotion();
                        motion.Pop();
                    }
                    else
                    {
                        UpdateMotion();
                    }                    
                }
                return;
            }

            if (((ChromeModule)GetModule()).bInFadeState || IsLeaning())
                return;
            
            if(ProcessAimToggle(nKeyCode, bKeyState, nKeyAscii)) return;
            
            if(ProcessWeaponChange(nKeyCode, bKeyState, nKeyAscii)) return;
            
            if ( (nKeyCode==EGameControl.AIM) &&
                 (!bKeyState) )
            {
                ActionAimingStop();
            }
            
            else if (nKeyCode==EGameControl.FIRE)
            {
                if (bKeyState && CanFire()) //wcisniety
                {
                    if (bReady)
                    {
                        //CrashLog("Faja !\n");
                        nFiring |= Weapon._FIRING_PRIMARY;
                    }
                    else
                        nFired |= Weapon._FIRING_PRIMARY;
                }
                else
                {
                    //w trybie przycelowania mozemy swobodnie 
                    //wylaczyc strzelanie, bo wiemy ze jesli
                    //bylo to w trybie primary
                    nFired  = Weapon._NO_FIRING;
                    nFiring = Weapon._NO_FIRING;
                }
            }

            else if ( (nKeyCode == EGameControl.JUMP) && 
                      (bKeyState) )
            {
                //skakac mozna tylko z ziemi
                if ( CanProcessJumpKey() )
                {
                    motion.bAiming = false;                
                    //LogD(" motion.bAiming = false; jump\n");
                    //PlayerJump();
                    motion.nJumping = MotionState._JUMPING_TRUE;
                    UpdateMotion();
                    UpdateState();
                }
            }
            
            else if ( (nKeyCode==EGameControl.RELOAD) &&
                      (bKeyState) )
                {
                    if (ActiveWeapon != null && ActiveWeapon.nAmmo != ActiveWeapon.nCapacity)
                    {
                        ActionReloadingStart();
                        UpdateState();
                    }                    
                }

        }


        public void OnInputMouseButton(int nButton, int nState)
        {
            ProcessMouseButtons(nButton, nState);
        }

        public void OnFrame()
        {
            SuperOnFrame();
            ProcessOnFrame();
        }

        void OnPostUpdate()
        {
            nFrame++;
            
            if (nFrame % 3 == 0)
                CheckTriggers();
        }        
        
        public void SGUpdate()
		{
			super.SGUpdate();
            
		}
    }
            
    void StopAiming()
    {
        //to na wypadek zbyt wczesnego wyjscia ze stanu
        //(przed wykonaniem StartAiming)
        DisableCallMethod(METHOD_StartAiming);

        if ( Camera != null )
            nOldCameraMode = Camera.GetMode();

        motion.bAiming = false;
        UpdateState();
        if (!sCurrentState.equals("CarDriveState"))
            UpdateMotion();
    }

///////////////////////////////////////////////////////////////////////////////
// RELOAD STATE
///////////////////////////////////////////////////////////////////////////////

	void ClearReloadingFlag()
	{
		motion.bReloading = false;
	}
	
    // zawolanie tego powoduje zakonczenie dzialajcego przeladowania
    void BreakWeaponReload()
    {
        if(!sCurrentState.equals("ReloadState")) return;
        
        // wylaczamy inne wolania tej metody
        DisableCallMethod(METHOD_WeaponReloaded);
            
        motion.bReloading = false;

        ((PlayerState)CurrentState).SetLastOtherState();
        UpdateMotion();
    }
    
    public class ReloadState extends PlayerState
    {
        int nFrame = 0;
        
		public void _OnEnter()
		{
            if ( IsAmmoAvailable() )
            {
                AttachOneShotSound(ActiveWeapon.sSoundReload, ActiveWeapon.fMinReloadSound, ActiveWeapon.fMaxReloadSound);
                Anims.Play( Anims.A_WEA_RELOAD );
				float fAnimTime = Anims.GetLength(Anims.A_WEA_RELOAD) + Anims.fAnimMorphTime;
                CallMethodIn(METHOD_WeaponReloaded, 
                             fAnimTime);
				CallMethodIn("ClearReloadingFlag", 
                             fAnimTime * .5f );
				//
            }
            else
            {
                Log("[ReloadState.OnEnter] No ammo available!\n");
                TextMessage(Text.Get("&NO_AMMO_AVAILABLE&"));
                motion.bReloading = false;
                
                if (sLastOtherState.compareTo("AimState") == 0) 
                {
                    SetState("FreehandState");
                    ActionAimingStop();
                    RestoreViewAfterAiming();
                    bAimToggle = false;
                }
                else
                    SetLastOtherState();
            }			
		}
        
        public void OnEnter()
        {	
			nCurrentState = EPlayerState.RELOAD ;
            super.OnEnter();
			_OnEnter();						
        }
		
		public void SGUpdate()
		{
			super.SGUpdate();
			
			nCurrentState = EPlayerState.RELOAD ;
			_OnEnter();            
		}

        public void OnInputMouseButton(int nButton, int nState)
        {
            ProcessMouseButtons(nButton, nState);
        }
        
        void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
        {
            //odswiezamy stan klawiszy, ale nic nie robimy
            if (ProcessMotionKeys(nKeyCode, bKeyState, nKeyAscii))
            {
                if(!bUnableToAct)
                    UpdateMotion();
                
                return;
            }
            
            if (ProcessStateKeys(nKeyCode, bKeyState, nKeyAscii))
            {
                if(!bUnableToAct)  
                    UpdateMotion();
                
                return;
            }
            
            if (bUnableToAct || IsLeaning()) return;

            if(ProcessWeaponChange(nKeyCode, bKeyState, nKeyAscii)) return;
            
            //jesli nie mamy okularkow
            if (bKeyState && (cBinoculars == null))
            {            
                if ( (nKeyCode == EGameControl.JUMP) && 
                     (bKeyState) )
                {
                    //skakac mozna tylko z ziemi
                    if ( CanProcessJumpKey() )
                    {
                        //motion.bAiming = false;                
                        //PlayerJump();
                        motion.nJumping = MotionState._JUMPING_TRUE;
                        UpdateMotion();
                        //UpdateState();
                    }
                }
            }
        }

        void WeaponReloaded()
        {
            // wylaczamy inne wolania tej metody
            DisableCallMethod(METHOD_WeaponReloaded);
            
            motion.bReloading = false;
            
            //rzeczywisty reload dopiero po odegraniu animacji
            WeaponReload();
            WeaponUsed();
            //MK: przesunalem to na koniec bo wydaje mi sie ze ak moze byc
            //ale glowy nie daje, jak ktos wie ze jest inaczej to 
            //niech mnie uswiadomi :-)
            //UpdateMotion();
            
            SetLastOtherState();
            //wstawie to tu
            UpdateMotion();
        }

        void OnPostUpdate()
        {
            nFrame++;
            
            if (nFrame % 3 == 0)
                CheckTriggers();
        }
    }

///////////////////////////////////////////////////////////////////////////////
// CHANGE WEAPON STATE
///////////////////////////////////////////////////////////////////////////////
    
    void ForceWeaponGot()
    {
        if(!sCurrentState.equals("ChangeWeaponState")) return;
        
        DisableCallMethod(METHOD_WeaponLeft);
        
        UseWeapon( WeaponToUse );
        Anims.SetupAnims( motion, ActiveWeapon );
        
        // wlasnie zmieniana jest bron, wymuszamy przelaczenie
        ((ChangeWeaponState)CurrentState).WeaponGot();
    }
    
    public class ChangeWeaponState extends PlayerState
    {
        public void OnEnter()
        {
            if (sCurrentState.compareTo("AimState") == 0)
            {
                ActionAimingStop();
                sCurrentState = "FreehandState";
            }
            
            LogD(ActiveWeapon + " " + PreviousActiveWeapon + " \n");
            nCurrentState = EPlayerState.CHANGEWEAPON;
            super.OnEnter();
            
            if ( nFiringState != Weapon._NO_FIRING )
            {
                nFiringState = Weapon._NO_FIRING;
                
                if (ActiveWeapon instanceof WeaponGrenade)
                {
                    ActiveWeapon.InGameMovieStart();
                }
                else
                {
                    if ( ActiveWeapon != null )
                        ActiveWeapon.StopFire();
                }
            }

            if ( ActiveWeapon != WeaponToUse )
            {
                WeaponChange();
            }
            else
            {
                CrashLog("ERROR: ChangeWeaponState WeaponToUse == ActiveWeapon "+ActiveWeapon+", skipped\n");
                SetLastOtherState();
            }
        }
		
		public void SGUpdate()
		{
			// OnEnter();
		}
        
        void WeaponChange()
        {
            //odloz jesli cos masz
            if (ActiveWeapon != null)
            {
                Anims.Play( Anims.A_WEA_PUTAWAY );
                
                CallMethodIn( METHOD_WeaponLeft, 
                              GetHandsAnimLength( Anims.A_WEA_PUTAWAY ) );
            }
            else
                WeaponLeft();
        }

        // poprzednia bron odlozona - wyciaganie nowej
        void WeaponLeft()
        {
            UseWeapon( WeaponToUse );
            
            // wylaczamy morfowanie animacji
            if (nRenderMode != REN_FULL)
               Anims.cMesh.SetAnimMorphTime( 0.0f );

            //UpdateMotion();
            Anims.SetupAnims( motion, ActiveWeapon );
            
            DisableCallMethod( METHOD_WeaponGot );
            if (ActiveWeapon != null)
            {
                Anims.Play( Anims.A_WEA_GET );
                
                CallMethodIn( METHOD_WeaponGot, 
                              GetHandsAnimLength( Anims.A_WEA_GET ) );
            }
            else 
                WeaponGot();
        }

        void WeaponGot()
        {
            DisableCallMethod(METHOD_WeaponGot);
            Anims.cMesh.SetAnimMorphTime( Anims.fAnimMorphTime );
            UpdateMotion();
            SetLastOtherState();
            
            if (GetKeyState(EGameControl.FIRE) && !bMouseUnacquired)
                CallOnInputKey(EGameControl.FIRE, 1, '0');
            if (GetKeyState(EGameControl.AIM) && !bMouseUnacquired)
                CallOnInputKey(EGameControl.AIM, 1, '0');
            if (ActiveWeapon != null)
                ActiveWeapon.OnPlayerGotInHands();
        }
        
        /**
         * Aby zapewnic spojnosc gracza w sieci musimy dlugosc animacji 
         * wyciagac z HandAnims, jednak gdy gracz jest w TPP, to wtedy 
         * Anims == CharacterAnims, zatem nie mozemy zawolac poprostu 
         * Anims.GetLength
         * Ta metoda wyciagnie dlugosc animacji z raczek niezaleznie
         * od tego czy gracz jest w TPP czy FPP
         * TODO: byc moze ta metoda przyda sie tez w innym stanie, jesli
         * tak to przeniesc do gracza
         */
        float GetHandsAnimLength(int nAnim)
        {
            //pobieramy raczki
            BaseAnimations cAnimsToGetAnimLength = (HandsAnims!=null) ?
                                                   HandsAnims : Anims;
            
            if ( cAnimsToGetAnimLength != Anims )
            {
                //jesli raczki nie sa aktualnymi animacjami
                //to inicjujemy te animacje aktualnym stanem gracza
                cAnimsToGetAnimLength.SetupAnims( motion, ActiveWeapon );
            }
            //zwracamy dlugosc animacji wg raczek
            return cAnimsToGetAnimLength.GetLength( nAnim );                
        }

        public void OnInputMouseButton(int nButton, int nState)
        {
            ProcessMouseButtons(nButton, nState);
        }
        
        void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
        {
            if (ProcessMotionKeys(nKeyCode, bKeyState, nKeyAscii))
            {
                UpdateMotion();
                return;
            }

            if (ProcessStateKeys(nKeyCode, bKeyState, nKeyAscii))
            {
                UpdateMotion();
                return;
            }
            
            if (IsLeaning())
                return;
            
            if(ProcessWeaponChange(nKeyCode, bKeyState, nKeyAscii)) return;
        }

    }

///////////////////////////////////////////////////////////////////////////////
// CLIMB STATE
///////////////////////////////////////////////////////////////////////////////


    //////////////////////////////////////////////////////
    // Drabiny                                          //
    //////////////////////////////////////////////////////

    /**Zalozenia:
    * o mozna wchodzic tylko przodem
    * o po obrocie spada sie
    * o po skoku spadanie
    * o na drabinie nie mozna wykonywac akcji
    * o drabina to obiekt z 2 face'ami, trace do przodu wykrywa wejscie
    *   trace w dol wykrywa zejscie
    * o wchodzenie na drabine to oddzielny stan gracza
    * o wejsc na drabine mozna tylko bedac freehand
    */

    //zejscie na dol drabiny
    boolean LadderClimbDown()
    {
        Vector vStart = GetPosition();

        Vector vEnd = new Vector(0, -50, 0);
        vEnd.Add(vStart);

        if (TraceTerrain(vStart, vEnd) != null)
            return true;
        else
        {
            // teraz ustawiamy flage BlockTrace dla drabin
            int i;
            for (i=0; i<aLadders.length; i++)                
                ((Ladder)(aLadders[i])).SetFlag(EFlags._BLOCK_TRACE);
            
            boolean bReturned = (TraceObjectsExclude(vStart, vEnd, this) != null);

            for (i=0; i<aLadders.length; i++)                
                ((Ladder)(aLadders[i])).ClearFlag(EFlags._BLOCK_TRACE);
            
            return bReturned;
        }
    }
    
    
    // lista wszystkich drabin na poziomie na uzytek
    // przelaczania flag przy testach wchodzenia na drabine
    
    GameObject aLadders[] = null;
    

    /** Ile Logan musi byc nad drabina zeby z niej zejsc (na szczycie)*/
    static float _CHECK_FOR_LADDER_LOGAN_UP      = 30.0f;
    /** Ile minimalnie cm nad ziemia szukamy konca drabiny */
    static float _CHECK_FOR_LADDER_TERRAIN_DELTA = 5.0f;
    
    /**Odleglosc dodawana do rozmiarow elipsoidy przy szukaniu drabiny*/ 
    float fLadderThreshold = 20.0f;
    float fLadderThresholdFirst = 50.f;
    
    /**Podczas schodzenia na gorze drabiny gracz trzyma sie na takiej wysokosci
     * drabiny do czasu wyjscia z jej zasiegu.
     */
    float fLadderYThreshold = 50;

    float fLadderCollisionDist = 200.0f;
    
    final static int _CHECK_FOR_LADDER_TRUE = 1,
                     _CHECK_FOR_LADDER_FALSE = 0,
                     _CHECK_FOR_LADDER_LEAVING = 2;
    
    final static String _CFL[] = {"_CHECK_FOR_LADDER_FALSE",
                                  "_CHECK_FOR_LADDER_TRUE",
                                  "_CHECK_FOR_LADDER_LEAVING"};
    
    LaserPointer a = null;
    LaserPointer b = null;
    LaserPointer c = null;

    float fLadderHeight = 0.f;
    
    // czesc drabiny lapiaca dol
    float fLadderDownPart = 200.f;
    
    Vector GetAimDirLadderClimb()
    {
        return GetAimDir();
    }
    
    String CheckForLadderString(boolean bEntering)
    {
        switch(CheckForLadder(bEntering, true))
        {
            case _CHECK_FOR_LADDER_LEAVING:
                return "_CHECK_FOR_LADDER_LEAVING";
                    
            case _CHECK_FOR_LADDER_FALSE:
                return "_CHECK_FOR_LADDER_FALSE";
                
            case _CHECK_FOR_LADDER_TRUE:
                return "_CHECK_FOR_LADDER_FALSE";
        }
        return "";
    }
    
    int CheckForLadder(boolean bEntering)
    {
        return CheckForLadder(bEntering, false);
    }
    
    float fSubOnEdge = 20.f;
    
    //wejscie na gore drabiny
    int CheckForLadder(boolean bEntering, boolean bDebug)
    {
        if(bDebug) LogR("[Player.CheckForLadder]\n");
        //Vector vStart = GetPosition();
        
        Ladder cLadder = CheckForLadderObject(bDebug);
        if(bDebug)
            LogR("cLadder="+((cLadder==null) ? "null" : cLadder.GetName())+"\n");
        if(cLadder!=null)
        {
            Vector vLadderMin=new Vector(), vLadderMax=new Vector();
            cLadder.GetMeshExtents(vLadderMin, vLadderMax);
            
            // przeliczamy wysokosc drabiny
            fLadderHeight = vLadderMax.fY - vLadderMin.fY;
            
            Vector vPos = GetPosition();
            vPos = cLadder.PointWorldToLocal(vPos);
            float fPlayerY = vPos.fY;
            
            if(bDebug)
                LogR("fPlayerY="+fPlayerY+" vLadderMin.fY="+vLadderMin.fY+" vLadderMax.fY="+vLadderMax.fY+" fLadderYThreshold="+fLadderYThreshold+"\n");
            
            // sprawdzamy czy gracz w obrebie drabiny
            if ((fPlayerY > vLadderMin.fY-fLadderYThreshold ) && (fPlayerY < vLadderMax.fY + fLadderYThreshold))
            {
                if(bEntering)
                {
                    // sprawdzamy wejscie na gorze
                    if(fPlayerY > vLadderMax.fY - fLadderYThreshold)
                    {
                        return _CHECK_FOR_LADDER_TRUE;
                    }
                    
                    //for(int i=0; i<2; ++i)
                    //{
                        // sprawdzamy czy gracz patrzy w drabine
                        Vector vEnd = GetAimDirLadderClimb();
                        //if(i==1) vEnd.Mul(-1.f);
                        
                        //if(bDebug)
                        //    LogR("i="+i+" vEnd="+vEnd+"\n");
                        
                        Vector vStart = GetPosition();
                        vStart.fY += 30.f;
                    
                        vEnd.Mul(fLadderCollisionDist);
                        vEnd.Add(vStart);
                
                        //if(a==null) a=Tools.CreateLaserPointer(GetModule(), LaserPointer._BEAM_RED);
                        //if(b==null) b=Tools.CreateLaserPointer(GetModule(), LaserPointer._BEAM_GREEN);
                        //if(c==null) c=Tools.CreateLaserPointer(GetModule(), LaserPointer._BEAM_BLUE);
                    
                        //Vector vZero = new Vector();
                        //a.PointFromTo(vStart, vEnd);
                        //b.PointFromTo(vZero, vZero);
                        //c.PointFromTo(vZero, vZero);
                        
                        if(cStandingOnObject!=null) cStandingOnObject.ClearFlag(EFlags._BLOCK_TRACE);
                        cLadder.SetFlag(EFlags._BLOCK_TRACE);
                        Collision stColl=TraceObjectsExclude(vStart, vEnd, this);
                        cLadder.ClearFlag(EFlags._BLOCK_TRACE);
                        if(cStandingOnObject!=null) cStandingOnObject.SetFlag(EFlags._BLOCK_TRACE);

                        if(bDebug)
                            LogR("stColl="+((stColl==null) ? "null" : stColl.Obstacle.GetName())+"\n");
                    
                        if (stColl != null)
                        {
                            if(stColl.Obstacle == cLadder)
                            {
                                vEnd = GetAimDirLadderClimb();
                                /*
                                vEnd.Normalize();
                                float fDot = stColl.vNormal.Dot(vEnd);
                                if(fDot < 0.0f)
                                    LogR("Normalna ujemna! Pownina zlapac drabina\n");
                                */
                                
                                // okreslenie czy gracz jest na dole drabiny
                                boolean bDown = (fPlayerY-vLadderMin.fY < fLadderDownPart);
                                if(bDown)
                                {
                                    // sprawdzamy czy gracz patrzy w gore i nie idzie do tylu
                                    if((vEnd.fY > 0.f) && (motion.iMoveZ > 0.f)) return _CHECK_FOR_LADDER_TRUE;
                                }
                                else
                                {
                                    // sprawdzamy czy gracz patrzy w dol
                                    if(vEnd.fY < 0.f) return _CHECK_FOR_LADDER_TRUE;
                                }
                                
                                return _CHECK_FOR_LADDER_FALSE;
                            }
                        }
                    //}//for
                    return _CHECK_FOR_LADDER_FALSE;
                }
                else
                {
                    boolean bDown = (fPlayerY-vLadderMin.fY < fLadderDownPart);
                    
                    // gracz jest na dole, sprawdzamy czy sie nie powinien odlaczyc
                    if(bDown)
                    {
                        // sprawdzamy czy gracz patrzy w drabine
                        Vector vEnd = GetAimDirLadderClimb();
                        Vector vStart = GetPosition();
                        vStart.fY += 30.f;

                        vEnd.Mul(fLadderHeight * 1.4f);
                        vEnd.Add(vStart);

                        if(cStandingOnObject!=null) cStandingOnObject.ClearFlag(EFlags._BLOCK_TRACE);
                        cLadder.SetFlag(EFlags._BLOCK_TRACE);
                        Collision stColl=TraceObjectsExclude(vStart, vEnd, this);
                        cLadder.ClearFlag(EFlags._BLOCK_TRACE);
                        if(cStandingOnObject!=null) cStandingOnObject.SetFlag(EFlags._BLOCK_TRACE);
                        
                        if (stColl != null)
                        {
                            if(stColl.Obstacle == cLadder)
                            {
                                // gdy gracz cofa sie w dolnej strefie to sie odlacza
                                if(motion.iMoveZ<0)
                                    return _CHECK_FOR_LADDER_FALSE;
                                
                                // gracz patrzy w drabine wiec nie odlaczamy
                                return _CHECK_FOR_LADDER_TRUE;
                            }
                        }
                        
                        //c.PointFromTo(vStart, vEnd);
                        return _CHECK_FOR_LADDER_FALSE;
                    }
                    else
                    {
                        // sprawdzamy zejscie na gorze
                        if(fPlayerY > vLadderMax.fY)
                        {
                            for(int i=0; i<2; ++i)
                            {
                                // sprawdzamy trace'a czy nie schodzi gracz
                                Vector vEnd = GetAimDirLadderClimb();
                                Vector vStart = GetPosition();

                                vStart.fY -= fSubOnEdge;
                                
                                if(i==1)
                                {
                                    // odwracamy kierunek
                                    vEnd.fX = -vEnd.fX;
                                    vEnd.fZ = -vEnd.fZ;
                                    vEnd.Normalize();
                                    
                                    //vEnd.fY = -1.f;
                                    //vEnd.Normalize();
                                }
                                
                                vEnd.Mul(fLadderHeight * 1.4f);
                                
                                vEnd.Add(vStart);
                                
                                //if(c==null) c=Tools.CreateLaserPointer(GetModule(), LaserPointer._BEAM_BLUE);
                                //c.PointFromTo(vStart, vEnd);
                                
                                if(cStandingOnObject!=null) cStandingOnObject.ClearFlag(EFlags._BLOCK_TRACE);
                                cLadder.SetFlag(EFlags._BLOCK_TRACE);
                                Collision stColl=TraceObjectsExclude(vStart, vEnd, this);
                                cLadder.ClearFlag(EFlags._BLOCK_TRACE);
                                if(cStandingOnObject!=null) cStandingOnObject.SetFlag(EFlags._BLOCK_TRACE);
                        
                                if (stColl != null)
                                {
                                    if(stColl.Obstacle == cLadder)
                                    {
                                        if(bDebug) LogR("No collision!\n");

                                        return _CHECK_FOR_LADDER_TRUE;
                                    }
                                }
                            }
                            return _CHECK_FOR_LADDER_LEAVING;
                        }
                    }
                    
                    // badamy zejscie z drabiny
                    return _CHECK_FOR_LADDER_TRUE;
                }
            }

            if(bDebug) LogR("fPlayerY="+fPlayerY+" vLadderMax.fY="+vLadderMax.fY+" bEntering="+bEntering+"\n");
            
            // zejscie z drabiny jest tylko je badamy
            if( (fPlayerY > vLadderMax.fY) && !bEntering )
                return _CHECK_FOR_LADDER_LEAVING;

        }
        return _CHECK_FOR_LADDER_FALSE;
    }

    static Vector l_vCorner1CFLO = new Vector();
    static Vector l_vCorner2CFLO = new Vector();
    
    MeshObject cLastLadder = null;
    
    String CheckForLadderObjectString()
    {
        Ladder cLadder = CheckForLadderObject(true);
        return (cLadder == null) ? "null" : cLadder.GetName();
    }
    
    Ladder CheckForLadderObject()
    {
        return CheckForLadderObject(false);
    }
    
	Ladder CheckForLadderObject(boolean bDebug)
    {
        if(bDebug) LogR("[Player.CheckForLadderObject]\n");

        // czy juz mamy liste drabin?
        if (aLadders==null)
        {
            // nie? to trzeba ja pobrac:
            aLadders = GetObjectsOfClass("Ladder");
            
            if (aLadders==null ||
                aLadders.length == 0)
            {
                //LogR(" Ladders not found !\n");
                return null;
            }
        }
        else
        {
            if (aLadders.length == 0)
            {
                //LogR("aLadders.length == 0\n");
                return null;
            }
        }

        if(bDebug)
        {
            if(cLastLadder != null)
            {
                Vector vLadderMin=new Vector(), vLadderMax=new Vector();
                cLastLadder.GetMeshExtents(vLadderMin, vLadderMax);
                LogR("cLastLadder.vPos="+cLastLadder.GetPosition()+" vLadderMin="+vLadderMin+" vLadderMax="+vLadderMax+"\n");
            }
            else
                LogR("No last ladder\n");
        }

        //poczatek promienia - dol ciala
        GetPosition(l_vCorner1CFLO);
        GetPosition(l_vCorner2CFLO);
        
        float CHECK_RADIUS_Y = 1.f;
        
        // szukamy wokol Logana drabin
        float fEllRad = fEllipsoidRadius[motion.SPEED_WALK];
        if(!bDebug) fEllRad = fEllipsoidRadius[motion.iSpeed];
        float fCheckRadius = (3f/3f) * fEllRad + fLadderThresholdFirst;
        l_vCorner1CFLO.fX -= fCheckRadius;
        l_vCorner1CFLO.fY -= CHECK_RADIUS_Y + fLadderYThreshold;
        l_vCorner1CFLO.fZ -= fCheckRadius;
        l_vCorner2CFLO.fX += fCheckRadius; 
        l_vCorner2CFLO.fY += CHECK_RADIUS_Y + fLadderYThreshold;
        l_vCorner2CFLO.fZ += fCheckRadius;
        
        //jesli chcemy tylem zejsc po drabinie to nie mozemy jej zlapac z wyprzedzeniem
        /*
        if(!bDebug)
            if (motion.iMoveZ >= 0)
                l_vCorner2CFLO.fY -= fLadderYThreshold;
        */

        if(bDebug) LogR("l_vCorner1CFLO="+l_vCorner1CFLO+" l_vCorner2CFLO="+l_vCorner2CFLO+" fCheckRadius="+fCheckRadius+" vPlayerPos="+GetPosition()+"\n");
        
        MeshObject cLadder = (MeshObject)GetObjectInExtentsOfClass(l_vCorner1CFLO, l_vCorner2CFLO, CLASS_Ladder);
        
        if(bDebug) LogR("First check - cLadder="+((cLadder==null) ? "null" : cLadder.GetName())+"\n");
        
        if (cLadder != null)
        {
            l_vCorner1CFLO.Zero();
            l_vCorner2CFLO.Zero();
            l_vCorner1CFLO.fX -= fCheckRadius;
            
            l_vCorner2CFLO.fX += fCheckRadius;
            l_vCorner2CFLO.fZ += fLadderThreshold;
            
            l_vCorner1CFLO.Set(cLadder.PointLocalToWorld(l_vCorner1CFLO));
            l_vCorner2CFLO.Set(cLadder.PointLocalToWorld(l_vCorner2CFLO));

            l_vCorner1CFLO.fY = GetPositionVectorVolatile().fY;
            l_vCorner2CFLO.fY = l_vCorner1CFLO.fY;
            
            l_vCorner1CFLO.fY -= CHECK_RADIUS_Y + fLadderYThreshold;
            l_vCorner2CFLO.fY += CHECK_RADIUS_Y + fLadderYThreshold;
            
            /*
            if(!bDebug)
                if (motion.iMoveZ >= 0)            
                    l_vCorner2CFLO.fY  -= fLadderYThreshold;
            */
            
            if(bDebug) LogR("l_vCorner1CFLO="+l_vCorner1CFLO+" l_vCorner2CFLO="+l_vCorner2CFLO+" fCheckRadius="+fCheckRadius+" vPlayerPos="+GetPosition()+"\n");
            
            cLadder = (MeshObject)GetObjectInExtentsOfClass(l_vCorner1CFLO, l_vCorner2CFLO, CLASS_Ladder);
            
            if(bDebug) LogR("Second check - cLadder="+((cLadder==null) ? "null" : cLadder.GetName())+"\n");
        }
 
        cLastLadder = cLadder;
        
        //TODO sprawdzenie czy gracz na wysokosci windy
        
        return (Ladder)cLadder;
    }
		
    void ClimbLeave()
    {
        // LogR("ClimbLeave\n");
        
        vLastPosOnGround = GetPosition();
        
        //LogD("\n");
        bCheckForLadder = bCheckForLadderExit = false;
        //odzyskujemy mase
        SetMass(fMass);
        motion.nClimbing = motion._CLIMBING_FALSE;
        fStepCheckTraceLen = MAX_STEP_CHECK_TRACE_LEN;
        SetFacingFlag(true);
        UpdateMotion();
        UpdateState();
        m_fClimbLeaveTime = GetTimeForLadder();
        
        //TEMP sprawdzic to, bo moze byc cos dziwnego
        //vSpeed = new Vector(0, 0, 0);
        //SetLocalSpeed( vSpeed, true );
    }
    
    float GetTimeForLadder()
    {
        return GetTime();
    }
	
    public class ClimbState extends PlayerState
    {
        int nFrame = 0;
        
        public void OnEnter()
        {
            //CrashLog("[ClimbState] jump "+ motion.nJumping + "\n");
            
			nCurrentState = EPlayerState.CLIMB ;
            super.OnEnter();			
			_OnEnter();
        }
		
		public void _OnEnter()
		{			
            //to pozwoli na przezwyciezenie grawitacji
            // LogR("_OnEnter() ClimbState\n");
            SetMass(0);
            SetFallSpeed(Vector.Zero);
            
            //zaczynamy chodzic
            motion.iSpeed = MotionState.SPEED_WALK;
            Anims.SetupAnims(motion, ActiveWeapon);
            UpdateMotion();
            
            SetFacingFlag(false);			
		}
		
		public void SGUpdate()
		{
			_OnEnter();
		}

        public void OnFrame()
        {
            SuperOnFrame();
			//CheckClimbLeave();
            
            ProcessOnFrame();
        }
		
		
	    void OnPostUpdate()
        {
            nFrame++;
            
            PlaceGun();

            if (nFrame % 3 == 0)
                CheckTriggers( true );
        }	
		

        void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
        {
            if (ProcessMotionKeys(nKeyCode, bKeyState, nKeyAscii))
            {
                UpdateMotion();
                return;
            }

            if (ProcessStateKeys(nKeyCode, bKeyState, nKeyAscii))
            {
                return;
            }

            if (bUnableToAct || ((ChromeModule)GetModule()).bInFadeState || IsLeaning()) return;

            if(ProcessAimToggle(nKeyCode, bKeyState, nKeyAscii)) return;
            
            //jesli nie mamy okularkow
            if ((bKeyState)&& (cBinoculars == null))
            {
                if (nKeyCode == EGameControl.JUMP)
                {
                    LogD(" Jump\n");
                    //LogD("\n");
                    ClimbLeave();
                    // rem by MK, zawolalem tu ClimbLeave(); bo to 
                    // przeciez prawie to same (ClimbLeave(); wola dodatkowo
                    // UpdateState() a to nie powinno niczemu przeszkodzic)
                    // jak sie nie bedzie nic chrzanic, to mozna bedzie tak
                    // zostawic...
                    //bCheckForLadder = bCheckForLadderExit = false;
                    //SetMass(fMass);
                    //motion.bClimbing = false;                    
                    //UpdateMotion();
                    // end of rem
                    
   
                    //odskok
                    //TODO PeH - sam skok w gore nie wystarczy, bo zaraz po
                    //wyskoku drabina nas znowu zlapie i przytrzyma, 
                    //trzeba od niej odskoczyc
                    Ladder cLadder = CheckForLadderObject();
                    if (cLadder != null)
                    {
                        motion.nJumping = MotionState._JUMPING_OFF_LADDER;
                    }
                    else
                    {
                        motion.nJumping = MotionState._JUMPING_TRUE;
                        
                    }
                    UpdateMotion();
                    SetState("FreehandState");
                }
            
                else if(nKeyCode==EGameControl.FIRE && CanFire() && nFiring == Weapon._NO_FIRING)
                {
                    //CrashLog("Faja !\n");
                    nFiring = Weapon._FIRING_PRIMARY;
                }
            }
            else //bKeyState
            {
                if(nKeyCode==EGameControl.FIRE)
                {
                    if ( nFiringState == Weapon._FIRING_PRIMARY )
                         nFiring = Weapon._NO_FIRING;
                }                
                else if (nKeyCode==EGameControl.AIM)
                {
                    if ( nFiringState == Weapon._FIRING_SECONDARY )
                         nFiring = Weapon._NO_FIRING;
                    else
                    {
                        ActionAimingStop();
                        UpdateState();
                    }
                }                
            }            
        }

        public void OnInputMouseButton(int nButton, int nState)
        {
            ProcessMouseButtons(nButton, nState);
        }

        void OnChangeMovement(int iEnv)
        {
            //LogR("[ClimbState.OnChangeMovement]"+iEnv);
            switch (iEnv)
            {
            case EMoveEnv.CHMOVE_GROUND : 
                {
                    //OnLeave("FreehandState");
                    break;
                }
            }
        }

    }
     
///////////////////////////////////////////////////////////////////////////////
// DIE STATE
///////////////////////////////////////////////////////////////////////////////
    float fDirSpeed = 1f;
    public class DieState extends PlayerState
    {
        public void OnEnter()
        {
            if (m_cDeathCameraEyeDummy != null)
            {
                if (nEyeId == -1)
                {
                    for (int i=0; i<sm_aEyeElements.length; i++ )
                    {
                        nEyeId = GetElementID( sm_aEyeElements[i] );
                        if (nEyeId != -1)
                            break;
                    }
                }
                if (nEyeId != -1)
                {
                    m_cDeathCameraEyeDummy.SetPosition(GetElementPos(nEyeId));
                    m_cDeathCameraEyeDummy.ActivateOnModule();
                }
                    //  AttachChild( m_cDeathCameraEyeDummy, nEyeId );
                
                
                //m_cDeathCameraEyeDummy.SetDir( GetForwardVector() ); 
                //m_cDeathCameraEyeDummy.DetachFromParentAndKeepWorldPos();
            }
            
			nCurrentState = EPlayerState.DIE;
            super.OnEnter();

            if (nFiringState != Weapon._NO_FIRING)
            {
                nFiringState = Weapon._NO_FIRING;
                if ( ActiveWeapon != null )
                    ActiveWeapon.StopFire();
            }
            
            //pozbywamy sie niepotrzebnych po smierci hudow celownikow
            if (cZoomer != null)
            {
                if (cBinoculars != null)
                {
                    RestoreViewAfterBinoculars();
                }
                else
                {
                    RestoreViewAfterAiming();
                }
            }
            
            Anims.StopAll();
            SetFlag(EFlags._NO_ANIMATION_REFRESH);
            
        }
		
		public void SGUpdate()
		{
			OnEnter();
		}
 
        void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
        {
            if ( bKeyState )
            {
            }
        }
        
        Vector l_vDeathCamPos = new Vector();
        /*void OnFrame()
        {
            if (!bVer1)
                return;
            SuperOnFrame();
            
            if (m_cDeathCameraEyeDummy != null)
            {
                l_vDeathCamPos.Set(m_cDeathCameraEyeDummy.GetPositionVectorVolatile());
                float fTerrainH = TerrainHeight(l_vDeathCamPos.fX, l_vDeathCamPos.fZ);
                
                if (fTerrainH + 5 >= l_vDeathCamPos.fY)
                {
                    l_vDeathCamPos.fY = fTerrainH + 20;
                    m_cDeathCameraEyeDummy.SetPosition(PointWorldToLocal(l_vDeathCamPos));
                }
                
            }
        }*/
        
        int nEyeId = -1;
        Vector vPrevDir = new Vector();
        float fPrevTime = 0;
        
        public void OnFrame()
        {
            if (m_cDeathCameraEyeDummy != null)
            {
                    
                if (nEyeId == -1)
                {
                    for (int i=0; i<sm_aEyeElements.length; i++ )
                    {
                        nEyeId = GetElementID( sm_aEyeElements[i] );
                        if (nEyeId != -1)
                            break;
                    }
                }
                if (nEyeId > -1)
                {
                    if (fPrevTime == 0)
                    {
                        fPrevTime = GetTime();
                        vPrevDir = GetElementRightVector(nEyeId);
                        //vPrevDir = GetElementForwardVector(nEyeId).Negate2();
                        m_cDeathCameraEyeDummy.SetDir(vPrevDir);
                    }
                    
                    Vector vPos = GetElementPos(nEyeId);
                    Vector vMove = vPos.Sub2(m_cDeathCameraEyeDummy.GetPositionVectorVolatile());
                    
                    Vector vDir = m_cDeathCameraEyeDummy.GetForwardVector();
                    Vector vDirMove = (GetElementRightVector(nEyeId)).Sub2(vDir);
                    vDirMove.Mul(fDirSpeed * (GetTime() - fPrevTime));
                    vDir.Add(vDirMove);
                    m_cDeathCameraEyeDummy.SetDir( vDir );   
                    
                    m_cDeathCameraEyeDummy.MoveByEllipsoidPure(vMove);
                    
                    m_cDeathCameraEyeDummy.SetPosition(m_cDeathCameraEyeDummy.GetPositionVectorVolatile().Add2(vMove));
                    //m_cDeathCameraEyeDummy.SetWorldPosByEllipsoid(vPos);
                    //LogR("Move = " + vMove + " expected " + m_cDeathCameraEyeDummy.GetPositionVectorVolatile());
                    
                    vPrevDir.Set(vDir);
                    fPrevTime = GetTime();
                }
                
            }
        }
        
        void OnChangeMovement(int iEnv)
        {
            //LogR("[DieState.OnChangeMovement]"+iEnv);
            switch (iEnv)
            {
            case EMoveEnv.CHMOVE_GROUND : 
                {
                    break;
                }
            }
        }        
    }

	boolean ServerOrClientOwner()
	{
		return (( (Role<ERole._AUTHORITY) && (bNetIsOwner==false) ) == false);
	}
    

    // ustawianie stanow
    
    void ActionChangeWeaponState()
    {
        ActionChangeWeaponStateDo();
    }
    
    void ActionChangeWeaponStateDo()
    {
        if ( (WeaponToUse == null) || (WeaponToUse == ActiveWeapon) )
            return;
            
        ForceWeaponGot();
        BreakWeaponReload();
        
        if ( sm_bSwimmingCannotChangeWeapon && bSwimming )
            return;
        
        if (sCurrentState.compareTo("AimState") == 0)
        {
            ActionAimingStop();
            RestoreViewAfterAiming();
            SetState("FreehandState");
        }
        
        if ( (WeaponToUse == null) || (WeaponToUse == ActiveWeapon) )
            return;
        SetState("ChangeWeaponState");
    }
    
    void ActionAimingStart()
    {
        if (((PlayerHUD)this).HUD.GetActiveHudMenu() == -1) 
            ActionAimingStartDo();
    }
    
    void ActionAimingStartDo()
    {
        motion.bAiming = true;
    }
    
    void ActionAimingStop()
    {
        ActionAimingStopDo();
    }
    
    void ActionAimingStopDo()
    {
        //motion.bAiming = false;
        StopAiming();
    }
    
    void ActionReloadingStart()
    {
        ActionReloadingStartDo();
    }
    
    void ActionReloadingStartDo()
    {
        motion.bReloading = true;
    }
    
    void ActionReloadingStop()
    {
        ActionReloadingStopDo();
    }
    
    void ActionReloadingStopDo()
    {
        motion.bReloading = false;
    }
    
        
    
    
    void ActionRespawn()
    {
        Respawn();
    }
    
    boolean bException = false;
    void SetPlayerException(boolean bValue)
    {
        bException = bValue;
    }
    void PlayerException()
    {
        return;
        /*
        if ( bException )
        {
            LogLine(" Yebudu, zobaczmy skad to przyszlo...");
            ((Player) null).GetPosition();
        }*/
    }
    
    void PutWeaponInHands( Weapon weapon )
    {
        super.PutWeaponInHands( weapon );
        
        UpdateMotion();
        //Anims.SetupAnims( motion, ActiveWeapon );
    }

    ////////////////
    
    boolean bInMovie = false;
    boolean bInMoviePhysicsDeactivated = false;
    boolean bInMovieCameraLeave = false;

    public float fPushedWeaponLODCoeff = 0.0f;
    public void InGameMovieStart()
    {
        bInMovie = true;
        
        nLeaning = -1;
        if (Camera != null)
            Camera.ForceStopLeaning();
        
        if(GetPhysicsActive())
        {
            bInMoviePhysicsDeactivated = true;
            SetPhysicsActive(false);
        }
        ((InventoryPlayer)cInventory).InGameMovieStart();
        
        DisableCallMethod("StartDrowning");
        DisableCallMethod("Drown");
        
        // ustawiamy super jakosc guna logana
        if(ActiveWeapon != null)
        {
            fPushedWeaponLODCoeff = ActiveWeapon.GetLODCoeff();
            ActiveWeapon.SetLODCoeff(0.001f);
        }
    }
    
    public void InGameMovieEnd()
    {
        bInMovie = false;
        if(bInMoviePhysicsDeactivated)
            SetPhysicsActive(true);
        
        if (bUnderWater)
        {
            float fTimeUnderWater = GetTime() - m_fLastDivingTime;
            if (fTimeUnderWater >= _UNDERWATER_TIME_TO_DROWN)
                StartDrowning();
            else
                CallMethodIn("StartDrowning", _UNDERWATER_TIME_TO_DROWN - fTimeUnderWater);
                
        }
        
        bInMoviePhysicsDeactivated = false;
        ((InventoryPlayer)cInventory).InGameMovieEnd();
        
        if(ActiveWeapon != null)
            ActiveWeapon.SetLODCoeff(fPushedWeaponLODCoeff);
    }
    
    ///////////////////////////////////////////////////////////////////////////
    // cheaty
    ///////////////////////////////////////////////////////////////////////////
    
    void SGLogs(byte nLog)
    {
        FileChunk.SetActiveLog(nLog);
    }
    
    void PlayMovie(int movie)
    {
        Movie cCheatMovie = (Movie)CreateObject("Movie");
        cCheatMovie.nMovie = movie;
        cCheatMovie.fMovieFadeOut = 0.0f;
        cCheatMovie.fWorldFadeIn = 0.0f;
        cCheatMovie.Play(null, null);
    }
    
    void SetHealth(float fNewHealth)
    {
        fHealth = fNewHealth;
        fMaxHealth = fNewHealth;
    }
    
    //Nie sejwowac, cheat testowy
    boolean m_bLifeCheat = false;
    int m_nDeathCount = 0;
    
    public void Cheat()
    {
        m_bLifeCheat = true;
    }
    
    public void Damage(float fDamage)
    {
        if (!m_bLifeCheat)
            super.Damage(fDamage);
        else
        {
            if(fHealth - fDamage <= 0.0f)
            {
                m_nDeathCount ++;
                fHealth = fMaxHealth;
                PlaySound("data\\sounds\\Ai\\krzyk 03.wav");
                String sText = ("YOU HAVE BEEN KILLED. DEATH COUNT: " + m_nDeathCount);
                ((PlayerHUD)this).TextMessage(sText);
                ((PlayerHUD)this).HUD.GetHUDLogs().InputText(sText);
                ((PlayerHUD)this).RefreshHealth();
            }
            else
            {
                super.Damage(fDamage);
            }
        }
    }
    
    public void Cyborg()
    {
        GetImplantSystem().Cheat();
    }
    
    void GivePistol()
    {
        GiveWeapon("WeaponPistol");
    }

    void GivePistolHeavy()
    {
        GiveWeapon("WeaponPistolHeavy");
    }

    void GivePistolSilenced()
    {
        GiveWeapon("WeaponPistolSilenced");
    }
    
    /** dodanie granata do inventory
     */
    void Grenade()
    {
        Weapon cWeapon = (Weapon)CreateObject("WeaponGrenade");
        ((InvObject)cWeapon).nCellsHeight = 1;
        ((InvObject)cWeapon).nCellsWidth = 1;
        cWeapon.AddToInventory(this);
    }

    void GiveSniper()
    {
        GiveWeapon("WeaponRifleSniper");
    }
    
    void GiveSniperHeavy()
    {
        GiveWeapon("WeaponRifleSniperHeavy");
    }
    
    void GiveGrenade()
    {
        Grenade();
    }
    
    void GiveGrenadeCluster()
    {
        Weapon cWeapon = (Weapon)CreateObject("WeaponGrenadeCluster");
        ((InvObject)cWeapon).nCellsHeight = 1;
        ((InvObject)cWeapon).nCellsWidth = 1;
        cWeapon.AddToInventory(this);
    }
    
    void GiveGrenadeEMP()
    {
        GiveObject("WeaponGrenadeEMP");
    }
    
    void GiveCloakingDevice()
    {
        GiveObject("CloakingDevice");
    }
    
    //void GiveGrenadeEmp()
    void Emp()
    {
        GiveObject("WeaponGrenadeEMP");
        GiveObject("WeaponGrenadeEMP");
        GiveObject("WeaponGrenadeEMP");
        GiveObject("WeaponGrenadeEMP");
        GiveObject("WeaponGrenadeEMP");
        GiveObject("WeaponGrenadeEMP");
        GiveObject("WeaponGrenadeEMP");
    }
    
    void GiveRocketLauncher()
    {
        GiveWeapon("WeaponHeavyRocketLauncher");
    }
        
    void GiveRifle()
    {
        GiveWeapon("WeaponRifle");
    }
    
    void GiveHEXHeavy()
    {
        GiveWeapon("WeaponHeavyHEX");
    }
    
    void GiveRifleHeavy()
    {
        GiveWeapon("WeaponRifleHeavy");
    }
    
    void GiveElectro()
    {
        GiveWeapon("WeaponHeavyElectro");
    }
    
    void GivePistolAuto()
    {
        GiveWeapon("WeaponRifleShort");
    }
    
    void GivePistolAutoSilenced()
    {
        GiveWeapon("WeaponRifleShortSilenced");
    }
    
    void GiveBinoculars()
    {
        ((InvObject)CreateObject("Binoculars")).AddToInventory(this);
    }
    
    void GiveMachineGun()
    {
        GiveWeapon("WeaponRifleMachineGun");
    }
    
    void GiveShotgun()
    {
        GiveWeapon("WeaponRifleShotgun");
    }
/*    
    String GiveObject(String sObject)
    {
        if(GetClassID(sObject) != 0)
        {
            ((InvObject)CreateObject(sObject)).AddToInventory(this);
            return "Object of class " + sObject + " created for Player!";
        }
        else
            return "Can't create object of class " + sObject + " - no such class!";
    }
*/
    String GiveObject(String sObject)
    {
        if(GetClassID(sObject) != 0)
        {
            InvObject cObject = ((InvObject)CreateObject(sObject));
            if (cObject.AddToInventory(this))
            {
                return "Object of class " + sObject + " created for Player!";
            }
            else
            {
                cObject.ChangeInvState(this, EInvObjState._ONGROUND );
                cObject.PhysicsDrop(ComputePhysicsDropPosition(), ComputePhysicsDropSpeed());
                return "on ground";
            }
        }
        else
            return "Can't create object of class " + sObject + " - no such class!";
    }
    
    
    void GiveWeapon(String sWeapon)
    {
        if(GetClassID(sWeapon) != 0)
        {
            Weapon cWeapon = (Weapon)CreateObject(sWeapon);
            ((InvObject)cWeapon).nCellsHeight = 1;
            ((InvObject)cWeapon).nCellsWidth = 2;
            //cWeapon.nAmmo = 1000;
            cWeapon.AddToInventory(this);
        }
    }
    
    void GiveAllAmmo()
    {
        Ammo ammo = null;
        int nAmount = 1;
        /*GiveGrenadeCluster();
        GiveGrenadeEMP();
        GiveGrenade();
        */
        for (int i=0; i<nAmount; i++)
        {
            ammo = (Ammo)CreateObject("Ammo8mmLong");
            ((InvObject)ammo).nCellsHeight = 1;
            ((InvObject)ammo).nCellsWidth = 1;
            ammo.nCapacity = 1000;
            ammo.nCount = 1000;
            ammo.AddToInventory(this);
        }
            
        for (int i=0; i<nAmount; i++)
        {
            ammo = (Ammo)CreateObject("Ammo9mmShort");
            ((InvObject)ammo).nCellsHeight = 1;
            ((InvObject)ammo).nCellsWidth = 1;
            ammo.nCapacity = 1000;
            ammo.nCount = 1000;
            ammo.AddToInventory(this);
        }
            
        for (int i=0; i<nAmount; i++)
        {
            ammo = (Ammo)CreateObject("Ammo14mmLong");
            ((InvObject)ammo).nCellsHeight = 1;
            ((InvObject)ammo).nCellsWidth = 1;
            ammo.nCapacity = 1000;
            ammo.nCount = 1000;
            ammo.AddToInventory(this);
        }
            
        for (int i=0; i<nAmount; i++)
        {
            ammo = (Ammo)CreateObject("Ammo12mmShort");
            ((InvObject)ammo).nCellsHeight = 1;
            ((InvObject)ammo).nCellsWidth = 1;
            ammo.nCapacity = 1000;
            ammo.nCount = 1000;
            ammo.AddToInventory(this);
        }
        
        for (int i=0; i<nAmount; i++)
        {
            ammo = (Ammo)CreateObject("AmmoEnergyRockets");
            ((InvObject)ammo).nCellsHeight = 1;
            ((InvObject)ammo).nCellsWidth = 1;
            ammo.nCapacity = 1000;
            ammo.nCount = 1000;
            ammo.AddToInventory(this);
        }
        
        for (int i=0; i<nAmount; i++)
        {
            ammo = (Ammo)CreateObject("AmmoRockets");
            ((InvObject)ammo).nCellsHeight = 1;
            ((InvObject)ammo).nCellsWidth = 1;
            ammo.nCapacity = 1000;
            ammo.nCount = 1000;
            ammo.AddToInventory(this);
        }
        
        for (int i=0; i<nAmount; i++)
        {
            ammo = (Ammo)CreateObject("AmmoEnergy");
           ((InvObject)ammo).nCellsHeight = 1;
            ((InvObject)ammo).nCellsWidth = 1;
            ammo.nCapacity = 1000;
            ammo.nCount = 1000;
            ammo.AddToInventory(this);
        }
        
        for (int i=0; i<nAmount; i++)
        {
            ammo = (Ammo)CreateObject("AmmoShotgun");
            ((InvObject)ammo).nCellsHeight = 1;
            ((InvObject)ammo).nCellsWidth = 1;
            ammo.nCapacity = 1000;
            ammo.nCount = 1000;
            ammo.AddToInventory(this);
        }
    }
    
    void GiveAllWeapons()
    {
        GivePistol();
        GivePistolSilenced();
        GivePistolHeavy();
        GivePistolAuto();
        GivePistolAutoSilenced();
        GiveRifle();
        GiveShotgun();
        GiveSniper();
        GiveSniperHeavy();
        GiveRocketLauncher();
		GiveMachineGun();
        GiveHEXHeavy();
        GiveRifleHeavy();
        GiveElectro();
        GiveGrenade();
        GiveGrenade();
        GiveGrenade();
        GiveGrenade();
        GiveGrenade();
        GiveGrenade();
        GiveGrenade();
        GiveGrenade();
        GiveGrenadeCluster();
        GiveGrenadeCluster();
        GiveGrenadeCluster();
        GiveGrenadeCluster();
        GiveGrenadeCluster();
    }
    
    void GiveHealthEx()
    {
        ((InvObject)CreateObject("DrugHealthex")).AddToInventory(this);
    }
    
    void GiveRadio()
    {
        ((InvObject)CreateObject("Radio")).AddToInventory(this);
    }
    
    void Pos()
    {
        CrashLog("MainPlayer position="+GetPosition()+"\n");
    }
    
    void SetPos(float x, float y, float z)
    {
        CrashLog("MainPlayer position="+GetPosition()+" and set to=");
        SetPosition(new Vector(x,y,z));
        CrashLog(GetPosition()+"\n");
    }
    
    void ShowBase()
    {
        CrashLog("Player fd="+GetForwardVector()+"\n");
        CrashLog("Player up="+GetUpVector()+"\n");
        CrashLog("Player rt="+GetRightVector()+"\n");
    }
    
    void KillEnemiesInFrustum()
    {
        ControlObject[] a=GetObjectsInFrustum(Camera, -1.0f);
        for(int i=0; i<a.length; i++)
        {
            if(a[i] instanceof AIBase)
            {
                if( GetTeamRelation( ((AIBase)a[i]) )==_TEAM_RELATION_HOSTILE )
                    ((AIBase)a[i]).TakeDamage(100000.0f, 100000f, this, new Vector(), new Vector(1,0,0),
											  EBones._NON_BONE, EnumDamageType._BULLET);
            }
            
            if(a[i] instanceof NewAI)
            {
                NewAI cAI = (NewAI)a[i];
                if( !IsFriend(cAI) )
                    cAI.TakeDamage(100000.0f, 100000, this, new Vector(), new Vector(1,0,0),
											  EBones._NON_BONE, EnumDamageType._BULLET);
            }
        }
    }
    
    ///////////////////////////////////////////////////////////////////////////
    // implanty
    ///////////////////////////////////////////////////////////////////////////

	ImplantSystem GetImplantSystem()
	{
		return cImplantSystem;
	}
	
    void ActionImplantOn( int nImplant )
    {
        ImplantOn( nImplant );
    }
    
    void ActionImplantOff( int nImplant )
    {
        ImplantOff( nImplant );
    }
    
    void ImplantOn( int nImplant )
    {
        Implant cImplant = GetImplantSystem().GetImplant(nImplant);
        if ( cImplant != null )
             cImplant.Activate();
    }
    
    void ImplantOff( int nImplant )
    {
		Implant cImplant = GetImplantSystem().GetImplant(nImplant);
        if ( cImplant != null )
             cImplant.Deactivate();
    }
    
    boolean IsImplantActive( int nImplant )
    {
        Implant cImplant = GetImplantSystem() != null ?
                           GetImplantSystem().GetImplant(nImplant) : null;
        if ( cImplant != null )
             return GetImplantSystem().IsImplantActive(nImplant);
		return false;
    }
	
    boolean IsImplantDisabled( int nImplant )
    {
        Implant cImplant = GetImplantSystem().GetImplant(nImplant);
        if ( cImplant != null )
		    return GetImplantSystem().GetImplant(nImplant).IsDisabled();
        return true;
    }
    
    void SetTermovision(boolean bOn)
    {
        if ( HandsAnims != null )
        {
            ((FPPHands)HandsAnims.cMesh).SetTermovision(bOn);
            ((PlayerHUD)this).RefreshAmmoLeft();
        }
        
        if (bOn)
            ((PlayerHUD)this).HUD.TermovisionOn();
        else
            ((PlayerHUD)this).HUD.TermovisionOff();
    }
    
    void OnSwitchImplantSpeed(boolean bActive)
    {
        UpdateSpeed();
    }
    
    void ForceImplantOverload()
    {
        if(GetImplantSystem() != null)
        {
            GetImplantSystem().ConstantOverload();
            GrenadeEMP.FXs(this);
        }
    }
    
    ///////////////////////////////////////////////////////////////////////////
    // imventory room
    ///////////////////////////////////////////////////////////////////////////

	InventoryRoom GetInventoryRoom()
	{
		return null;
	}
    
    int nLadder = 0;
    void NextLadder()
    {
        SetPosition(((Ladder)aLadders[nLadder]).GetPosition());
        nLadder ++;
        if (nLadder >= aLadders.length)
            nLadder = 0;
    }
 
    void DebugShowPos()
    {
        
    }
 
    boolean bDebugSendMove = false;
    boolean bDebugJump = false;
    
    public void SetLocalSpeed(Vector v, boolean bAccel)
    {
        //maly trick, zeby przy speedmulcie (cheat) gracz nie rozpedzal sie powoli
        if (fSpeedMult > 1)
            super.SetLocalSpeed(v, false);
        else 
            super.SetLocalSpeed(v, bAccel);
    }
    
    /** Zwalnianie po postrzale i zeskoku 
     */
    //czy ma zwalniac po zeskoku
    boolean  m_bSlowDownOnEndOfJump     = true;
    //czu ma sie kamera tapnac po zeskoku
    boolean  m_bCameraBumpOnEndOfJump   = true;
    //czu ma byc odegrany dzwiek tapniecia po zeskoku
    boolean  m_bDropSoundOnEndOfJump    = false;
    
    //czas trwania zwolnienia przy postrzale
    float m_fSlowDownOnRecoilTime       = 0.2f;
    //wspolczynnik zwolnienia przy postrzale
    float m_fSlowDownOnRecoil           = 0.1f;
    //minimalny czas trwania zwolnienia (przy "malych" zeskokach)
    float _SLOW_DOWN_ON_END_OF_JUMP_MIN = 0.1f;           // 0.3f
    //maksymalny czas trwania zwolnienia (przy "duzych" zeskokach)
    float _SLOW_DOWN_ON_END_OF_JUMP_MAX = 0.4f;           // 0.6f
    
    
    //minimalna odleglosc skoku przy ktorej bedziemy zwalniali goscia
    public float _SLOW_JUMP_LEN_MIN              = 50.0f;       // 20.f
    //minimalna odleglosc skoku przy ktorej bedziemy mieli tapniecie kamera
    public float _BUMP_JUMP_LEN_MIN              = 20.0f;
    //odleglosc skoku dla maksyalnego tapniecia kamera
    public float _BUMP_JUMP_LEN_MAX              = 200.0f;
    //minimalna odleglosc skoku przy ktorej bedziemy odpalali dzwiek
    public float _SOUND_JUMP_LEN_MIN             = 40.0f;
    
    void SlowDownAndCameraBumpOnEndOfJump()
    {
        //policzmy dlugosc skoku
        Vector vPos     = GetPosition();
        //TODO: zastanowic sie jak oceniac dlugosc skoku
        //float  fLenJump = vPos.Distance( vLastPosOnGround );
        //float  fLenJump = java.lang.Math.abs(vPos.fY - vLastPosOnGround.fY);
        float  fLenJump = vLastPosOnGround != null ? 
                          vLastPosOnGround.fY - vPos.fY : 0.0f;
        
        // po to, zeby gracz zatrzymywal sie po skoku...
        if (m_bSlowDownOnEndOfJump && bNetIsOwner)
        {
            if (java.lang.Math.abs(fLenJump) >= _SLOW_JUMP_LEN_MIN) 
                StartSlowDownOnEndOfJump(_SLOW_DOWN_ON_END_OF_JUMP_MAX);
            else if (m_bJump)
                StartSlowDownOnEndOfJump(_SLOW_DOWN_ON_END_OF_JUMP_MIN);
        } 
            
        //a teraz zeby kamera tapnela
        if ( m_bCameraBumpOnEndOfJump      &&
             (Camera != null)               && 
             (fLenJump >= _BUMP_JUMP_LEN_MIN || m_bJump) )
        {
            float fBumpCoeff = (fLenJump -_BUMP_JUMP_LEN_MIN)
                               /
                               (_BUMP_JUMP_LEN_MAX - _BUMP_JUMP_LEN_MIN);

            Camera.StartCameraBump( fBumpCoeff );
        }
        
        if ( m_bDropSoundOnEndOfJump &&
             (fLenJump >= _SOUND_JUMP_LEN_MIN) )
            PlaySound( aEndOfJumpSounds[ RandomInt( aEndOfJumpSounds.length ) ]);
    }
    
    String[] aEndOfJumpSounds = {   "Data/Sounds/Player/bodydrop1",
                                    "Data/Sounds/Player/bodydrop2", 
                                    "Data/Sounds/Player/bodydrop3",
                                    "Data/Sounds/Player/bodydrop4" };
    
    /** 
     */
    void StartSlowDownOnRecoil()
    {
        StartSlowDownOnRecoil( m_fSlowDownOnRecoilTime );
    }
    
    void StartSlowDownOnRecoil(float fTime)
    {
        if ( ! bRecoiling )
        {
            bRecoiling = true;
            UpdateMotion();
        }
        DisableCallMethod( METHOD_StopSlowDown );
        CallMethodIn( METHOD_StopSlowDown , fTime );
    }
    
    void StartSlowDownOnEndOfJump(float fTime)
    {
        if ( ! bRecoiling )
        {
            bRecoiling = true;
            UpdateMotion();
        }
        DisableCallMethod( METHOD_StopSlowDown );
        CallMethodIn( METHOD_StopSlowDown, fTime );
    }
    
    void StopSlowDown()
    {
        if ( bRecoiling )
        {
            bRecoiling = false;
            UpdateMotion();
        }
    }
    
    Vector GetRenderPosition()
    {
        return GetPosition();   
    }
    
    Vector l_vRight = new Vector();
    float fLeanZ = 30;
    float fLeanY = 15;
    void GetRenderPosition(Vector vPos)
    {
        GetPosition( vPos );
    }
    
    void GetRenderPositionWithLeaning(Vector vPos, float fLeanDelta)
    {
        GetRenderPosition( vPos );
        if (fLeanDelta != 0)
        {
            l_vRight.Set(GetRightVectorVolatile());
            l_vRight.Mul(fLeanDelta);
            vPos.Add(l_vRight);
        }
    }
    
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
	byte bFiringSG = 0;
	boolean bInMovieSG = false;	
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[Player.SGLoadChunk]\n");			
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_PLAYER)
        {
			Anims.StopAll();
				
			super.SGLoadChunk(cFC);
			
			m_bJumpingOffLadder = cFC.LoadBool();
			
            // odczytujemy czy gracz skacze
            m_bJump = cFC.LoadBool();
            m_bJustJumping = cFC.LoadBool();
            
            // zapisujemy environment gracza
            nEnvironment = cFC.LoadInt();
            
			// liczba zabitych z kazdej z broni
			for (int i=0; i < WEAPONS_COUNT; i++)
				aEnemyDeceased[i] = cFC.LoadInt();

			// nazwa najlepszej broni
			sBestWeapon = cFC.LoadString();
			// Index w tablicy aEnemyDeceased najlepszej broni
			nBestWeapon = cFC.LoadInt();
			// liczba fragow z najlepszej broni
			nBestWeaponDeceased = cFC.LoadInt();
			
			// ilosc obrazen otrzymanych podczas gry
			fInjuries = cFC.LoadFloat();			
		
			// Numer ostatnio zapisanego elementu tablicy aWeaponHands
			nLastFPPWeapon = cFC.LoadInt();
			
			// Kamera przyczepiona do gracza chodzaca za nim
			//Camera = (CameraPlayer)cFC.LoadObjectRef();
			
			// Zapamietany tryb pracy kamery
			nOldCameraMode = (byte)cFC.LoadInt();
			// Tryb widoku
			nCameraGameMode = (byte)cFC.LoadInt();
            
            
			// Tryb renderowania
			nRenderMode = (byte)cFC.LoadInt();

			// Lornetka
			//cBinoculars = (Binoculars)cFC.LoadObjectRef();
		
			//cZoomer = (Zoomer)cFC.LoadObjectRef();
			
			newMotion = (MotionState)cFC.LoadObjectRef();
            
            bCamouflage = cFC.LoadBool();
			
			bInMovie = cFC.LoadBool();
            bInMoviePhysicsDeactivated = cFC.LoadBool();
            //cImplantSystem = (ImplantSystem)cFC.LoadObjectRef();
            
            fLastProbe = cFC.LoadFloat();
			
            m_fClimbLeaveTime = cFC.LoadFloat();
            
			if (Camera == null)
				CrashLog("[PlayerSingle.SGLoad] ERROR! : Loading CameraPlayer failed ! \n");
			Camera.SGLoadChunk(cFC);
			
			// Stan implantow playera przekazywane z mapy na mape
			if (cImplantSystem == null)
				CrashLog("[PlayerSingle.SGLoad] ERROR! : Loading ImplantSystem failed !\n");			
			cImplantSystem.SGLoadChunk(cFC);
			
			iHitAnim = cFC.LoadInt();
            
            for (int i = 0; i < m_aVisibilityFactors.length; i++)
                m_aVisibilityFactors[i] = cFC.LoadFloat();
        }
		
		bFiringSG = cFC.LoadByte();
		
        fCurrentAccuracy = cFC.LoadFloat();
		
		bWalking = cFC.LoadBool();
		bDucking = cFC.LoadBool();		
		bCrawling = cFC.LoadBool();
		bSwimming = cFC.LoadBool();		
		
		bDuckingToggle = cFC.LoadBool();		
		bCrawlingToggle = cFC.LoadBool();				
		
		if (!bDuckingToggle)
			bDucking = false;

		if (!bCrawlingToggle)
			bCrawling = false;

		JUMP_STRENGTH = cFC.LoadFloat();	
		
		vLastPosOnGround = cFC.LoadVector();
        
        bPlayerHidden = bPlayerHiddenSG = cFC.LoadBool();
		
		m_bCheckIsJumpStarted = cFC.LoadBool();			
		m_bDelayedCheckIsJumpStarted = cFC.LoadBool();			
		
		bRecoiling = cFC.LoadBool();
        
        m_fLastDivingTime = cFC.LoadFloat();
        
		m_bGetDamageFromFalling = cFC.LoadBool();
		
		cFC.delete();
	}
	
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[Player.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_PLAYER, cFCParent);
		
		super.SGSaveChunk(cFC);
		
		// mowi czy jestesmy w trakcie zeskoku z drabiny
		cFC.SaveBool(m_bJumpingOffLadder);
        
        // zapisujemy czy gracz skacze
        cFC.SaveBool(m_bJump);
        cFC.SaveBool(m_bJustJumping);
	
        // zapisujemy environment gracza
        cFC.SaveInt(nEnvironment);
        
		// liczba zabitych z kazdej z broni
		for (int i=0; i < WEAPONS_COUNT; i++)
			cFC.SaveInt(aEnemyDeceased[i]);

		// nazwa najlepszej broni
		cFC.SaveString(sBestWeapon);
		// Index w tablicy aEnemyDeceased najlepszej broni
		cFC.SaveInt(nBestWeapon);
		// liczba fragow z najlepszej broni
		cFC.SaveInt(nBestWeaponDeceased);
		
		// ilosc obrazen otrzymanych podczas gry
		cFC.SaveFloat(fInjuries);
			
		// Numer ostatnio zapisanego elementu tablicy aWeaponHands
		cFC.SaveInt(nLastFPPWeapon);
		
		// Paramtery zwiazane z kamera

		// Kamera przyczepiona do gracza chodzaca za nim
		// cFC.SaveObjectRef(Camera);

		// Zapamietany tryb pracy kamery
		cFC.SaveInt((int)nOldCameraMode);
		// Tryb widoku
		cFC.SaveInt((int)nCameraGameMode);
		// Tryb renderowania
		cFC.SaveInt((int)nRenderMode);
		
		// Lornetka
		//cFC.SaveObjectRef(cBinoculars);
		
		//cFC.SaveObjectRef(cZoomer);
		
		cFC.SaveObjectRef(newMotion);		
        
        cFC.SaveBool(bCamouflage);
		
		cFC.SaveBool(bInMovie);
        cFC.SaveBool(bInMoviePhysicsDeactivated);
        
        //cFC.SaveObjectRef(cImplantSystem);
        
        cFC.SaveFloat(fLastProbe);
		
        cFC.SaveFloat(m_fClimbLeaveTime);
        
		Camera.SGSaveChunk(cFC);
		
		// Stan implantow playera przekazywane z mapy na mape
		cImplantSystem.SGSaveChunk(cFC);
		
		cFC.SaveInt(iHitAnim);
        
        for (int i = 0; i < m_aVisibilityFactors.length; i++)
            cFC.SaveFloat(m_aVisibilityFactors[i]);
		
		cFC.SaveByte((byte)nFiring);
		
        cFC.SaveFloat(fCurrentAccuracy);

		cFC.SaveBool(bWalking);
		cFC.SaveBool(bDucking);		
		cFC.SaveBool(bCrawling);
		cFC.SaveBool(bSwimming);
		
		cFC.SaveBool(bDuckingToggle);		
		cFC.SaveBool(bCrawlingToggle);		
		
		cFC.SaveFloat(JUMP_STRENGTH);		
		
		cFC.SaveVector(vLastPosOnGround);
        
        cFC.SaveBool(bPlayerHidden);
		
		cFC.SaveBool(m_bCheckIsJumpStarted);			
		cFC.SaveBool(m_bDelayedCheckIsJumpStarted);	
		
		cFC.SaveBool(bRecoiling);
        
        cFC.SaveFloat(m_fLastDivingTime);
		
		cFC.SaveBool(m_bGetDamageFromFalling);
		
        cFC.delete(); 
	}
	
	public void SGUpdate()
	{
        nLeaning = -1;
        Camera.ForceStopLeaning();
        
        m_bExecutingTrigger = false;
        
		FileChunk.Log("[Player.SGUpdate]\n");		
		
		super.SGUpdate();
		
		bUnableToAct = false;
				
		Camera.SGUpdate();

        //FIXIT Chamski hack zeby dzwieki zawsze dzialaly, trzeba poprawic save'y zeby
        //sie speaker nie kasowal
        RemoveSpeaker();
        CreateSpeaker();
        
        cImplantSystem.SGUpdate();
		
        ChromeModule cModule = (ChromeModule)GetModule();
        if(cModule.bActivatePortalSystem)
            cModule.ActivatePortalSystem();
        
        cInventory.SGUpdate();
        
        if (cBinoculars != null)
		{
            cBinoculars.EndUse();
			RestoreViewAfterBinoculars();
		}
		if (cZoomer != null)
        {
			RestoreViewAfterAiming();
        }
        
        if (sCurrentState.compareTo("AimState") == 0)
            StopAiming();
        
		//WeaponToUse = ActiveWeapon;
		//ActiveWeapon = null;		
		//ActionChangeWeaponState();
		
		// CameraModeChanged(nCameraGameMode);
		
		if (bFiringSG != 0)
			nFiringState = (byte)bFiringSG;
		
        // to musi tu byc, bo nie wiadomo kiedy SGUpdate w WeaponGrenade sie nazywa
        if(ActiveWeapon instanceof WeaponGrenade)
        {
            if(nFiringState != Weapon._NO_FIRING)
                ((WeaponGrenade)ActiveWeapon).bDisableStopFireOnce = true;
        }
        else
		    StopFire();
        
        fAccuracyPrevTime = GetTime();
		
		if (cSeatInfo != null)
			CallMethodIn("SitDownToDrive",0.f);     		
		
		//$ Elvis
		// To ma rozwiazywac to gwno z autochodzeniem po save'ach, ale nie wiem 
		// co m oe to jeszcze spierdoli. W razie czego to zakomentowa!
		if (!GetKeyState( EGameControl.FORWARD ))
		{
			if (newMotion != null)
				newMotion.StopMove();				
			if (motion != null)
				motion.StopMove();				
		}
        
        CallOnFrameEnd("UpdateSGPlayerVisibility");
        
	}
    
    
    void UpdateSGPlayerVisibility()
    {
        ShowPlayer(!bPlayerHiddenSG);
    }    
    
    boolean AmIFlying(){ return m_bJustJumping; }
    void    SetIAmFlying(boolean bVal){ m_bJustJumping = bVal; } 
    
    /********************************************************
     * *** przeciazone odtwarzanie dzwiekow
     */
    
    int AttachSound(String sSoundName)
    {
        return GetSpeaker().AttachSound(sSoundName);
    }

    int AttachSound(String sSoundName, float fMin, float fMax)
    {
        return GetSpeaker().AttachSound(sSoundName, fMin, fMax);
    }
    
    void AttachOneShotSound(String sSoundName)
    {
        GetSpeaker().AttachOneShotSound(sSoundName);
    }
	
	void AttachOneShotSound(String sSoundName, float fVolume)
    {
        GetSpeaker().AttachOneShotSound(sSoundName, fVolume);
    }

   void AttachOneShotSound(String sSoundName, float fMin, float fMax)
   {
       GetSpeaker().AttachOneShotSound(sSoundName, fMin, fMax);
   }
    
   void DetachSound(int iSoundID)
   {
       GetSpeaker().DetachSound(iSoundID);
   }
   
   void DetachAllSounds()
   {
       GetSpeaker().DetachAllSounds();
   }
    
   void SetSoundVolume(int iSoundID, float fVolume)
   {
       GetSpeaker().SetSoundVolume(iSoundID, fVolume);
   }
   
   void SetSoundFreq(int iSoundID, float fFreq)
   {
       GetSpeaker().SetSoundFreq(iSoundID, fFreq);
   }
       
   void StopSound(int iSoundID)
   {
       GetSpeaker().StopSound(iSoundID);
   }
   
   void PlaySound(int iSoundID)
   {
       GetSpeaker().PlaySound(iSoundID);
   }

   
   /**[native] Metoda sprawdza czy podany dzwiek aktualnie gra.
    * @param iSoundID identyfikator dzwieku zwrocony przez AttachSound
    * @return true gdy dzwiek gra
    */
    native boolean IsSoundPlaying(int iSoundID);
   
    /**Obiekt do odtwarzania dzwiekow, ustawiany w pozycji kamery, tak by dzwieki
     * odpalaly sie "w glowie" gracza*/
    protected ControlObject m_cPlayerSpeaker = null;
        
    /**Ustawia pozycje glosnika wzgledem gracza*/
    float _fY = 0, _fZ = 30;
    /**Ustawia pozycje glosnika wzgledem gracza*/
    void SetSpeakerPos(Vector vPos, Vector vForward)
    {
        //przestawiamy kawalek do przodu, zeby miec glosnik przed soba
        if (GetSpeaker() != null)
            GetSpeaker().SetDir(vForward);
        
        Vector vFwd = VectorWorldToLocal(vForward);
        vFwd.Negate();
        vFwd.Mul(_fZ);
        vPos.Add(vFwd);
        
        if (GetSpeaker() != null)
            GetSpeaker().SetPosition( vPos );//SetPositionWorld( vPos );

        /*MeshObject cObj = Tools.GetHelperMesh(m_cPlayerSpeaker);
        if (cObj == null)
        {
            cObj = Tools.AddHelperMesh(m_cPlayerSpeaker, Tools._HM_MESH_CUBE);
            m_cPlayerSpeaker.AttachChild(cObj);
            cObj.SetPosition(new Vector());
            cObj.SetName("SPEAKER");
        }*/
    }
    
    ControlObject GetSpeaker()
    {
        return m_cPlayerSpeaker;
    }
    
    Weapon GetNextWeapon(byte eWeaponType)
    {
        Weapon cWeapon = null;
        if (eWeaponType != -1)
        {
            cWeapon = super.GetNextWeapon(eWeaponType);
            // jesli skonczyl sie cykl - poszukaj od poczatku
            if (cWeapon == null || 
                (cWeapon==ActiveWeapon) ||
                !cWeapon.CanBeUsedByPlayer())
            {
                //sprawdzmy czy cosik znalazl (czyli ActiveWeapon)
                boolean bLastFound = cWeapon != null;
                cWeapon = super.GetNextWeapon(eWeaponType);
                //jesli teraz mu sie nie udalo, ale wczesniej
                //juz cos mial, to jeszcze raz...
                if ((cWeapon == null || !cWeapon.CanBeUsedByPlayer()) && 
                    bLastFound)
                    cWeapon = super.GetNextWeapon(eWeaponType);
            }
        }
        else
        {
            //szukamy nastepnej w ogole
            byte eCurWeapon = ActiveWeapon.nType;
            
            cWeapon = super.GetNextWeapon(eCurWeapon);
            if (cWeapon == null || 
                !cWeapon.CanBeUsedByPlayer() ||
                cWeapon == ActiveWeapon)
            {
                //ustaw sie na pozycji nInvIndex wiekszej niz nWeaponInvIndex
                //i o pasujacym rodzaju broni
                cWeapon = (Weapon)cInventory.GetFirstInvObject( EInvObjType._GUN );
            
                //najpierw znajdujemy w inventory bron ktora mamy
                while (cWeapon != null && cWeapon != ActiveWeapon)
                {
                    cWeapon = (Weapon)cInventory.GetNextInvObject();
                }
            
                //potem szukamy nastepnej
                while (cWeapon != null)
                {
                    cWeapon = (Weapon)cInventory.GetNextInvObject();
                    if (cWeapon != null && cWeapon.CanBeUsedByPlayer())
                    {
                        if (ActiveWeapon.nInvIndex != cWeapon.nInvIndex ||
                            (ActiveWeapon.nInvIndex == cWeapon.nInvIndex && 
                             cWeapon != ActiveWeapon && 
                             eCurWeapon != EWeaponType._GRENADE)
                            )
                            break;
                        
                    }
                }

                if (cWeapon == null)
                {
                    //nie znalezlismy nastepnej, szukamy pierwszej
                    cWeapon = (Weapon)cInventory.GetFirstInvObject( EInvObjType._GUN );
                    if (!cWeapon.CanBeUsedByPlayer())
                        cWeapon = (Weapon)cInventory.GetNextInvObject();
                }
                
                if (cWeapon == null)
                    nWeaponInvIndex[eCurWeapon] = 0;
                else
                    nWeaponInvIndex[eCurWeapon] = cWeapon.nInvIndex;

            
            }
         
        }
        return cWeapon;
    }

    Weapon GetPrevWeapon()
    {
        
        Weapon cWeapon = (Weapon)cInventory.GetFirstInvObject( EInvObjType._GUN );
        /*LogR("GetPrevWeapon " + "\n" +
             "   first wpn  " + cWeapon + "\n" +
             "   active wpn " + ActiveWeapon + "\n");*/
        byte eCurWeapon = ActiveWeapon.nType;
        //najpierw znajdujemy w inventory bron ktora mamy
        while (cWeapon != null && 
               cWeapon != ActiveWeapon)
        {
            cWeapon = (Weapon)cInventory.GetNextInvObject();
        }
        
        //potem szukamy poprzedniej
        while (cWeapon != null)
        {
            cWeapon = (Weapon)cInventory.GetPrevInvObject();
            //LogR("   prev wpn " + cWeapon);

            if (cWeapon != null &&
                cWeapon.CanBeUsedByPlayer())
            {
                if (ActiveWeapon.nInvIndex != cWeapon.nInvIndex ||
                    (ActiveWeapon.nInvIndex == cWeapon.nInvIndex && 
                     cWeapon != ActiveWeapon && 
                     eCurWeapon != EWeaponType._GRENADE)
                    )
                    break;
                
            }
        }

        if (cWeapon == null)
        {
            //nie znalezlismy poprzedniej, szukamy ostatniej
            cWeapon = (Weapon)cInventory.GetLastInvObject( EInvObjType._GUN );
            if (!cWeapon.CanBeUsedByPlayer())
                cWeapon = (Weapon)cInventory.GetPrevInvObject();
            //LogR("   LAST " + cWeapon);
        }
        
        if (cWeapon == null)
            nWeaponInvIndex[eCurWeapon] = 0;
        else
            nWeaponInvIndex[eCurWeapon] = cWeapon.nInvIndex;

        return cWeapon;
    }
    
	public void NextLevel()
	{
		ChromeModule module = (ChromeModule)GetModule();
		if (module instanceof ChromeModuleSingle)
		{
			((ChromeModuleSingle)module).bMissionSuccessful = true;
			((ChromeModuleSingle)module).LevelEnd();
		}
	}
    
/**
    public void EnableRendering(boolean b)
    {
        super.EnableRendering(b);
    }
    
    public void SetFrame(String seqName, float frame, int elem)
    {
        super.SetFrame(seqName, frame, elem);
    }
    
    public void SetFrame(int animId, float frame, int elem)
    {
        super.SetFrame(animId, frame, elem);
    }
*/
    boolean m_bGetDamageFromFalling = true;
    
    public void GetDamageAfterFall(boolean bGetDamage)
    {
        m_bGetDamageFromFalling = bGetDamage;
    }
    
    void GetCameraForwardVector(Vector vCameraMove)
    {
        GetForwardVector( vCameraMove );
    }
    
    Vector GetCameraForwardVector()
    {
        return GetForwardVector();
    }
    
    void ResetBodyInVehicle()
    {
        // tu wazna jest kolejnosc zawolania tych metod, bo druga bazuje na pierwszej
        ResetInVehicleAnim();
        ResetInVehiclePos();
        CallMethodIn("ResetInVehiclePos", 0.1f); // a to na wszelki wypadek
    }
    
    void ResetInVehiclePos()
    {
        if (cSeatInfo == null)
            return;

        Vector vNewPos = cSeatInfo.GetSeatPos();
        
        if (vNewPos == null)
            return;
        
        Vector vNewDir = cSeatInfo.GetSeatDir();
        Vector vDiff = GetPosition();
        int iElemID = GetElementID("Bip01");
        vDiff.Sub(GetElementPos(iElemID));
        vNewPos.Add(vDiff);
            
        FromUpForwardPos(cSeatInfo.GetSeatUpDir(), 
                         vNewDir,
                         vNewPos);
    }
    
    void ResetInVehicleAnim()
    {
        if (cSeatInfo == null)
            return;
        
        if (cSeatInfo.m_ObjectToOccupy instanceof Speeder)
            SetFrame(CharacterAnims.Anims[Anims.A_DRIVE_SPEEDER], GetFirstFrame(CharacterAnims.Anims[Anims.A_DRIVE_SPEEDER]), -1);
        else
        if (cSeatInfo.m_ObjectToOccupy instanceof Walker)
            SetFrame(CharacterAnims.Anims[Anims.A_DRIVE_WALKER], GetFirstFrame(CharacterAnims.Anims[Anims.A_DRIVE_WALKER]), -1);
        else
        {
            if (cSeatInfo.GetRole() != EPassengerRole._VEHICLE_PASSENGER ||
                cSeatInfo.GetRole() != EPassengerRole._VEHICLE_PASSENGER_IDLE )
                SetFrame(CharacterAnims.Anims[Anims.A_DRIVE], GetFirstFrame(CharacterAnims.Anims[Anims.A_DRIVE]), -1);
            else
                SetFrame(CharacterAnims.Anims[Anims.A_RIDE], GetFirstFrame(CharacterAnims.Anims[Anims.A_RIDE]), -1);
        }
    }
    
    void TryPlayObjectiveChangeSound()
    {
        if (Precache.bPrecaching)
            CallMethodIn("TryPlayObjectiveChangeSound", 0.1f);
        AttachOneShotSound("ObjectiveUpdate.wav");
    }
    
    void StartLeaningLeft()
    {
        if (nLeaning == -1 && CanLean())
        {
            nLeaning = _LEANING_LEFT;
            Camera.StartLeaning(nLeaning);
        }
    }
    
    void StopLeaningLeft()
    {
        if (nLeaning == _LEANING_LEFT)
        {
            nLeaning = -1;
            Camera.StopLeaning();
            if (bDucking && !bDuckingToggle && !GetKeyState(EGameControl.DUCK))
                bDucking = false;
        }
    }
    
    void StartLeaningRight()
    {
        if (nLeaning == -1 && CanLean())
        {
            nLeaning = _LEANING_RIGHT;
            Camera.StartLeaning(nLeaning);
        }
    }
    
    
    
    void StopLeaningRight()
    {
        if (nLeaning == _LEANING_RIGHT)
        {
            nLeaning = -1;
            Camera.StopLeaning();
            if (bDucking && !bDuckingToggle && !GetKeyState(EGameControl.DUCK))
                bDucking = false;
        }
    }
    
    boolean IsImmortal(){ return sm_bImmortal; }
    
    boolean IsLeaning()
    {
        return (nLeaning != -1) || (Camera != null && Camera.IsLeaning());
    }
    
    boolean CanLean()
    {
        return sCurrentState.compareTo("FreehandState") == 0 &&
               nFiringState == Weapon._NO_FIRING &&
               nFiring == Weapon._NO_FIRING && 
               !bCrawling &&
               !motion.IsMoving();
    }
    /////////////////////////////////////////////////////////////////////////////////
    // Strzelanie do kamery gracza
    //
    
    /** Metoda do sprawdzania, czy kula nie przelatuje odpowiednio blisko kamery (kolejne iteracje trace'a)
     * @return - struktura collision symulujaca trafienie w gracza
     */
    public Collision CheckBulletTrajectory(Weapon weapon, Vector vStart, Vector vEnd)
    {
        return null;
    }
    
    public void TakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        super.TakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
    }
    
    public void TakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nDamageType)
    {
        super.TakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nDamageType);
    }

    //do nadpisania w sieci
    boolean IsLockedByConnectionStatusManager(){ return false; }
}
